program main
  use sep
  implicit none

  real, allocatable     :: infile(:,:,:),replace(:,:,:)
  real, allocatable     :: outfile(:,:,:)
  real                  :: dx, dy, dz, ox, oy, oz
  integer               :: nx, ny, nz 
  integer               :: i,j,k, n12,n123
  integer               :: ix1, iy1, iz1
  integer               :: ix2, iy2, iz2
  integer               :: ix, iy, iz 
  real                  :: x1, y1, z1 
  real                  :: x2, y2, z2 
  real                  :: x, y, z 
  logical               :: add, verb
  real                  :: pick1, pick2
  integer, allocatable  :: pick(:)
  complex, allocatable  :: picks(:)
  character(len=128)	:: picks_
  character(len=24)	:: color1,color2
  integer               :: icount, lag
  real                  :: denom, cutoff

  call initpar()

  if (exist_file("infile"))then
      call from_aux("infile","n1",nz); call from_aux("infile","d1",dz); call from_aux("infile","o1",oz)
      call from_aux("infile","n2",nx); call from_aux("infile","d2",dx); call from_aux("infile","o2",ox)
      call from_aux("infile","n3",ny); call from_aux("infile","d3",dy); call from_aux("infile","o3",oy)
      ny=max(1,ny);
      allocate(infile(nz, nx, ny)); 
      call sreed("infile", infile, 4*nz*nx*ny)
  else
       call from_history('n1',nz); call from_history('d1',dz);  call from_history('o1',oz); 
       call from_history('n2',nx); call from_history('d2',dx);  call from_history('o2',ox); 
       call from_history('n3',ny); call from_history('d3',dy);  call from_history('o3',oy); 
       allocate(infile(nz, nx, ny)); 
       call sreed("in", infile, 4*nz*nx*ny)
       allocate(picks(size(infile)),pick(size(infile)))  
  endif
  if (exist_file("replace"))then
      allocate(replace(nz, nx, ny)); 
      call sreed("replace", replace, 4*nz*nx*ny)
  else
      call seperr('Need to specify replace file')
  endif
  allocate(outfile(nz, nx, ny)); 

  call from_param("add",add,.true.)
  call from_param("verb",verb,.false.)
  call from_param("lag",lag,0)
  call from_param("cutoff",cutoff,0.)

  outfile=infile
  where (replace>cutoff)outfile=replace

  call to_history("n1", nz); call to_history("d1", dz); call to_history("o1", oz)
  call to_history("n2", nx); call to_history("d2", dx); call to_history("o2", ox)
  call to_history("n3", ny); call to_history("d3", dy); call to_history("o3", oy)
  call to_history("label1", 'z'); call to_history("label2", 'x'); call to_history("label3", 'y')
  call to_history("esize", 4); 
  call srite("out", outfile, 4*nz*nx)
end program
