module array_mod
  use global_params_mod
  use sep
  implicit none

contains
!=========================================================================================
  subroutine data_array_alloc()
    real :: memory
        memory = size(code)
        allocate(wavelet(1));     memory = memory + 8*size(wavelet);
        if(lloyd)   allocate(vel_ref(vnum,vgrid%az%n,2)); memory = memory + 4*size(vel_ref);
        allocate(vel(vgrid%ax%n, vgrid%ay%n, vgrid%az%n)); memory = memory + 4*size(vel);
        allocate(vel_slice(vgrid%ax%n, vgrid%ay%n)); memory = memory + 4*size(vel_slice);
        allocate(nref(vgrid%az%n));memory = memory + 4*size(nref);
        allocate(refl(vgrid%ax%n, vgrid%ay%n, vgrid%az%n)); memory = memory + 4*size(refl);
        allocate( data(dgrid%agx%n, dgrid%agy%n, dgrid%asx%n, dgrid%asy%n            )); memory = memory + 8*size( data);
        allocate(fdata(dgrid%agx%n, dgrid%agy%n, dgrid%asx%n, dgrid%asy%n, dgrid%aw%n)); memory = memory + 8*size(fdata);
        if(loop=='s')then
                allocate(greens(ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n, ggrid%aw%n     ,               1)) ;
        else
                allocate(greens(ggrid%ax_surf%n, ggrid%ay_surf%n, ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n)) ;
        endif
        memory = memory + 8*size(greens);
        if (wfld_d_out)allocate(wfld_out_d(vgrid%ax%n,vgrid%ay%n,ggrid%az_modl%n,dgrid%at%n,1)); memory = memory + 8*size(wfld_out_d); 
        if (allocated(vref)) deallocate(vref); allocate(vref(vnum));memory = memory + 4*size(vref);
        memory = memory / 1024 / 1024
        write(0,'(A65)')'=========================Summary memory================================='
        write(0,'(A30,2X,F9.3,A2)')"Memory allocated per node:", memory, "Mb"
        memory=memory*nodes
        write(0,'(A30,2X,F9.3,A2)')"Total memory needed      :", memory, "Mb"
        write(0,'(A65)')'===================================================================='

  end subroutine
!################################  
  subroutine green_array_alloc()
    real :: memory
        memory = 0.
        allocate(wavelet(1));     memory = memory + 8*size(wavelet);
        if(lloyd)   allocate(vel_ref(vnum,vgrid%az%n,2)); memory = memory + 4*size(vel_ref);
        allocate(vel(vgrid%ax%n, vgrid%ay%n, vgrid%az%n)); memory = memory + 4*size(vel);
        allocate(vel_slice(vgrid%ax%n, vgrid%ay%n)); memory = memory + 4*size(vel_slice);
        allocate(nref(vgrid%az%n));memory = memory + 4*size(nref);
        if(loop=='s')then
                allocate(greens(ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n, ggrid%aw%n     ,               1)) ;
        else
                allocate(greens(ggrid%ax_surf%n, ggrid%ay_surf%n, ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n)) ;
        endif
        memory = memory + 8*size(greens);
        memory = memory / 1024 / 1024
        if (wfld_d_out)allocate(wfld_out_d(vgrid%ax%n,vgrid%ay%n,ggrid%az_modl%n,dgrid%at%n,1)); memory = memory + 8*size(wfld_out_d)/1024/1024; 
        if (allocated(vref)) deallocate(vref); allocate(vref(vnum));memory = memory + 4*size(vref)/1024/1024;
        write(0,'(A65)')'=========================Summary memory=============================='
        write(0,'(A30,2X,F11.3,A2)')"Memory allocated per node:", memory, "Mb"
        memory=memory*nodes
        write(0,'(A30,2X,F11.3,A2)')"Total memory needed      :", memory, "Mb"
        write(0,'(A65)')'===================================================================='
  end subroutine

!=======================================================================================
   subroutine green_array_alloc2(greens,green,wfld_sl_d, t_wfld1_d, t_wfld2_d, taper_wfld,progrid, t_wfld1, t_wfld2, t_wfld3)
        type(pro_grid) :: progrid   
        integer :: memory
        real   , dimension(:,:      ), allocatable :: taper_wfld    
        complex, dimension(:,:      ), allocatable :: wfld_sl_d    
        complex, dimension(:,:      ), allocatable :: t_wfld1_d    
        complex, dimension(:,:      ), allocatable :: t_wfld2_d    
        complex, dimension(:,:,:    ), allocatable :: t_wfld1    
        complex, dimension(:,:,:    ), allocatable :: t_wfld2   
        complex, dimension(:,:,:    ), allocatable :: t_wfld3   
        complex, dimension(:,:,:    ), allocatable :: green
        complex, dimension(:,:,:,:,:), allocatable :: greens
        optional :: t_wfld1,t_wfld2, t_wfld3
        if(marine)then;  
                if (allocated(taper_wfld)) deallocate(taper_wfld); allocate( taper_wfld(progrid%ax%n,progrid%ay%n)); taper_wfld=0.
        endif        
        if (allocated(wfld_sl_d))  deallocate(wfld_sl_d ); allocate( wfld_sl_d (progrid%ax%n,progrid%ay%n)); wfld_sl_d=0.

        if (allocated(t_wfld1_d )) deallocate(t_wfld1_d ); allocate( t_wfld1_d (progrid%ax%n,progrid%ay%n)); t_wfld1_d=0.
        if (allocated(t_wfld2_d )) deallocate(t_wfld2_d ); allocate( t_wfld2_d (progrid%ax%n,progrid%ay%n)); t_wfld2_d=0.
        if(present(t_wfld1))then
                if (allocated(t_wfld1 )) deallocate(t_wfld1 ); allocate( t_wfld1 (progrid%ax%n,progrid%ay%n,vnum)); t_wfld1=0.
        endif
        if(present(t_wfld2))then
                if (allocated(t_wfld2 )) deallocate(t_wfld2 ); allocate( t_wfld2 (progrid%ax%n,progrid%ay%n,vnum)); t_wfld2=0.
        endif
        if(present(t_wfld3))then
                if (allocated(t_wfld3 )) deallocate(t_wfld3 ); allocate( t_wfld3 (progrid%ax%n,progrid%ay%n,vnum)); t_wfld3=0.
        endif
        
        if(loop=='s')then
                if(allocated(greens))deallocate(greens); allocate(greens(ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n, ggrid%aw%n    ,  1              )) ;
                if(allocated(green ))deallocate(green ); allocate(green (ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n                                  )) ;
        else
                if(first_green==1)then; allocate(greens(ggrid%ax_surf%n, ggrid%ay_surf%n, ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n)); first_green=first_green+1;endif
                if(allocated(green ))deallocate(green ); allocate(green (                 ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n)) ;
        endif

   end subroutine

!=======================================================================================
   subroutine green_array_alloc3(progrid, ooogrid,nodes)
        integer :: memory, nodes
        type(pro_grid) :: progrid   
        type(out_grid) :: ooogrid   
        if (allocated(tape       )) deallocate(tape       ); allocate(tape       (progrid%ax%n,progrid%ay%n                    )); tape=1.
        if (allocated(wfldslice_u)) deallocate(wfldslice_u); allocate(wfldslice_u(progrid%ax%n,progrid%ay%n,nodes              )); wfldslice_u=0.
        if (allocated(wfldslice_d)) deallocate(wfldslice_d); allocate(wfldslice_d(progrid%ax%n,progrid%ay%n,nodes              )); wfldslice_d=0.
        if (allocated(velslice   )) deallocate(velslice   ); allocate(velslice   (progrid%ax%n,progrid%ay%n,nodes              )); velslice=0.
  end subroutine
!=======================================================================================
   subroutine green_array_alloc4(green,wfld_sl_d, t_wfld1_d, t_wfld2_d, taper_wfld,progrid)
        type(pro_grid) :: progrid   
        integer :: memory
        real   , dimension(:,:      ), allocatable :: taper_wfld    
        complex, dimension(:,:      ), allocatable :: wfld_sl_d    
        complex, dimension(:,:      ), allocatable :: t_wfld1_d    
        complex, dimension(:,:      ), allocatable :: t_wfld2_d    
        complex, dimension(:,:,:    ), allocatable :: green

        if(marine)then;  
                if (allocated(taper_wfld)) deallocate(taper_wfld); allocate( taper_wfld(progrid%ax%n,progrid%ay%n)); taper_wfld=0.
        endif        
        if (allocated(wfld_sl_d))  deallocate(wfld_sl_d ); allocate( wfld_sl_d (progrid%ax%n,progrid%ay%n)); wfld_sl_d=0.
        if (allocated(t_wfld1_d )) deallocate(t_wfld1_d ); allocate( t_wfld1_d (progrid%ax%n,progrid%ay%n)); t_wfld1_d=0.
        if (allocated(t_wfld2_d )) deallocate(t_wfld2_d ); allocate( t_wfld2_d (progrid%ax%n,progrid%ay%n)); t_wfld2_d=0.
        if(allocated(green ))      deallocate(green );     allocate(green (ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n)) ;

   end subroutine

!=======================================================================================
   subroutine mig_array_alloc()
    real :: memory
        memory = 0.
        if(lloyd)   allocate(vel_ref(vnum,vgrid%az%n,2)); memory = memory + 4*size(vel_ref);
        allocate(vel(vgrid%ax%n, vgrid%ay%n, vgrid%az%n)); memory = memory + 4*size(vel);
        allocate(nref(vgrid%az%n));memory = memory + 4*size(nref);
        allocate(mig (igrid%ahx%n, igrid%ahy%n, igrid%ax%n, igrid%ay%n, igrid%az%n));    mig =0.;  memory = memory + 4*size(mig);
        if (wfld_d_out)allocate(wfld_out_d(vgrid%ax%n,vgrid%ay%n,ggrid%az_modl%n,dgrid%at%n,1)); memory = memory + 8*size(wfld_out_d); 
        if (wfld_u_out)allocate(wfld_out_d(vgrid%ax%n,vgrid%ay%n,ggrid%az_modl%n,dgrid%at%n,1)); memory = memory + 8*size(wfld_out_u); 
        if (allocated(vref)) deallocate(vref); allocate(vref(vnum));memory = memory + 4*size(vref);
        memory = memory / 1024 / 1024
        write(0,'(A65)')'=========================Summary memory=============================='
        write(0,'(A30,2X,F9.3,A2)')"Memory allocated per node:", memory, "Mb"
        memory=memory*nodes
        write(0,'(A30,2X,F9.3,A2)')"Total memory needed      :", memory, "Mb"
        write(0,'(A65)')'===================================================================='
  end subroutine
 
!=======================================================================================
   subroutine mig_array_alloc2(wfld_sl_d, wfld_sl_u, t_wfld1_d, t_wfld1_u, t_wfld2_d, t_wfld2_u, t_mig, t_mig2, progrid, ooogrid,taper_wfld)
    type(pro_grid) :: progrid   
    type(out_grid) :: ooogrid   

        integer :: memory
        real   , dimension(:,:), allocatable :: taper_wfld    
        complex, dimension(:,:), allocatable :: wfld_sl_d    
        complex, dimension(:,:), allocatable :: wfld_sl_u    
        complex, dimension(:,:), allocatable :: t_wfld1_d    
        complex, dimension(:,:), allocatable :: t_wfld1_u    
        complex, dimension(:,:), allocatable :: t_wfld2_d    
        complex, dimension(:,:), allocatable :: t_wfld2_u    
        real,    dimension(:,:,:,:,:), allocatable :: t_mig    
        real,    dimension(:,:,:,:,:), allocatable :: t_mig2    
   
        if (allocated(taper_wfld)) deallocate(taper_wfld); allocate(taper_wfld                        (progrid%ax%n,progrid%ay%n)); taper_wfld=1.
        if (allocated(wfld_sl_d))  deallocate(wfld_sl_d ); allocate(wfld_sl_d                         (progrid%ax%n,progrid%ay%n)); wfld_sl_d=0.
        if (allocated(wfld_sl_u))  deallocate(wfld_sl_u ); allocate(wfld_sl_u                         (progrid%ax%n,progrid%ay%n)); wfld_sl_u=0.
        if (allocated(t_wfld1_d )) deallocate(t_wfld1_d ); allocate( t_wfld1_d                        (progrid%ax%n,progrid%ay%n)); t_wfld1_d=0.
        if (allocated(t_wfld2_d )) deallocate(t_wfld2_d ); allocate( t_wfld2_d                        (progrid%ax%n,progrid%ay%n)); t_wfld2_d=0.
        if (allocated(t_wfld1_u )) deallocate(t_wfld1_u ); allocate( t_wfld1_u                        (progrid%ax%n,progrid%ay%n)); t_wfld1_u=0.
        if (allocated(t_wfld2_u )) deallocate(t_wfld2_u ); allocate( t_wfld2_u                        (progrid%ax%n,progrid%ay%n)); t_wfld2_u=0.
        !if (allocated(t_mig     )) deallocate(t_mig     ); allocate( t_mig    (ooogrid%ahx%n,ooogrid%ahy%n,ooogrid%ax%n,ooogrid%ay%n,ooogrid%az%n));t_mig=0.
        if (.not. allocated(t_mig )) then ; allocate(t_mig (ooogrid%ahx%n, ooogrid%ahy%n, ooogrid%ax%n, ooogrid%ay%n, ooogrid%az%n));t_mig=0. ; endif
        if (.not. allocated(t_mig2)) then ; allocate(t_mig2(ooogrid%ahx%n, ooogrid%ahy%n, ooogrid%ax%n, ooogrid%ay%n, ooogrid%az%n));t_mig2=0.; endif
   end subroutine
!=======================================================================================
   subroutine mig_array_alloc3(progrid, ooogrid,nodes)
        integer :: memory, nodes
        type(pro_grid) :: progrid   
        type(out_grid) :: ooogrid   
        
        if (allocated(wfldslice_d)) deallocate(wfldslice_d ); allocate(wfldslice_d(progrid%ax%n,progrid%ay%n,nodes)); wfldslice_d=0.
        if (allocated(wfldslice_u)) deallocate(wfldslice_u ); allocate(wfldslice_u(progrid%ax%n,progrid%ay%n,nodes)); wfldslice_d=0.
        if (allocated(tmpwfld1_d )) deallocate(tmpwfld1_d ); allocate( tmpwfld1_d   (progrid%ax%n,progrid%ay%n,nodes)); tmpwfld1_d=0.
        if (allocated(tmpwfld2_d )) deallocate(tmpwfld2_d ); allocate( tmpwfld2_d   (progrid%ax%n,progrid%ay%n,nodes)); tmpwfld2_d=0.
        if (allocated(tmpwfld1_u )) deallocate(tmpwfld1_u ); allocate( tmpwfld1_u   (progrid%ax%n,progrid%ay%n,nodes)); tmpwfld1_u=0.
        if (allocated(tmpwfld2_u )) deallocate(tmpwfld2_u ); allocate( tmpwfld2_u   (progrid%ax%n,progrid%ay%n,nodes)); tmpwfld2_u=0.
        if (.not. allocated(tmpmig )) then ; allocate(tmpmig (ooogrid%ahx%n, ooogrid%ahy%n, ooogrid%ax%n, ooogrid%ay%n, ooogrid%az%n,nodes));tmpmig=0. ; endif
        if (.not. allocated(tmpmig2)) then ; allocate(tmpmig2(ooogrid%ahx%n, ooogrid%ahy%n, ooogrid%ax%n, ooogrid%ay%n, ooogrid%az%n,nodes));tmpmig2=0. ; endif        
        if (.not. allocated(tmp_mig2)) then ; allocate(tmp_mig2(ooogrid%ahx%n, ooogrid%ahy%n, ooogrid%ax%n, ooogrid%ay%n, ooogrid%az%n));tmp_mig2=0.; endif

        if (allocated(velslice)) deallocate(velslice); allocate(velslice(progrid%ax%n,progrid%ay%n,nodes)); velslice=0.
        if (allocated(velref  )) deallocate(velref  ); allocate(velref  (vnum,nodes)); velref=0.
        memory = 8*(6*size(wfldslice_d)+2*size(tmpmig))+4*size(velref)
        memory = memory / 1024 / 1024
        write(0,*)"Memory allocated per shot: ", memory, "Mb"
  end subroutine
 
!=======================================================================================
subroutine array_dealloc()
        if(allocated(wavelet)) deallocate(wavelet)     ;       if(allocated(vel    )) deallocate(vel)
        if(allocated(refl   )) deallocate(refl)        ;       if(allocated(data   )) deallocate(data)
        if(allocated(wavelet)) deallocate(wavelet)     ;       if(allocated(greens )) deallocate(greens)
        if(allocated(wfld_out_d )) deallocate(wfld_out_d);     if(allocated(wfld_out_u )) deallocate(wfld_out_u)
   
        if (allocated(tape        )) deallocate(tape        ); 
        if (allocated(wfld_slice_d)) deallocate(wfld_slice_d); 
        if (allocated(wfld_slice_u)) deallocate(wfld_slice_u); 
        if (allocated(tmp_wfld1_d )) deallocate(tmp_wfld1_d ); 
        if (allocated(tmp_wfld2_d )) deallocate(tmp_wfld2_d ); 
        if (allocated(tmp_wfld1_u )) deallocate(tmp_wfld1_u ); 
        if (allocated(tmp_wfld2_u )) deallocate(tmp_wfld2_u ); 
        if (allocated(tmp_mig     )) deallocate(tmp_mig     ); 
        if (allocated(tmp_mig2    )) deallocate(tmp_mig2    ); 
        if (allocated(data        )) deallocate(data        ); 
        if (allocated(mig         )) deallocate(mig         ); 
        if (allocated(vel_slice   )) deallocate(vel_slice   );  if (allocated(vel_ref     )) deallocate(vel_ref     ); 
        if (allocated(nref        )) deallocate(nref        ); 
        if (allocated(code        )) deallocate(code        ); 
  end subroutine

 !###############################################
  subroutine vel_alloc(vref, vel_slice,ind_vref,progrid)
     type(pro_grid) :: progrid   
     real,    dimension(:),        allocatable :: vref
     real,    dimension(:,:),      allocatable :: vel_slice
     integer, dimension(:,:),      allocatable :: ind_vref
     if (allocated(vel_slice)) deallocate(vel_slice); allocate(vel_slice(progrid%ax%n,progrid%ay%n))
     if (allocated(ind_vref )) deallocate(ind_vref ); allocate( ind_vref(progrid%ax%n,progrid%ay%n))
     if (allocated(vref     )) deallocate(vref); allocate(vref(vnum))
     vel_slice=0
     ind_vref=0
     vref=0
  end subroutine

  end module
