module data_compute_mod
  use global_params_mod
  implicit none
  contains
!===========================================================================================================================================================================
  subroutine data_compute1(waved,spk,wd,iwd,inode)
!        complex, dimension(:,:,:,:,:)               :: waved
!        integer                                     ::  iszd,  isxd, isyd 
!        integer                                     ::  igzd,  igxd, igyd
!        integer                                     :: iiszd, iisxd, iisyd
!        integer                                     :: iigzd, iigxd, iigyd
!        integer                                     :: izd,ixd,iyd,iwd
!        real                                        :: zd, xd , yd  
!        integer                                     :: inode
!        real                                        :: sxd , syd, gxd, gyd 
!        complex                                     :: greens_mul 
!        real, dimension(1)                          :: tmp
!        complex                                     :: spk
!        real                                        :: wd    
!
!        write(0,*)'computing data frequency:  ', iwd
!        do izd=data_imin_z, data_imax_z; 
!        do iyd=data_imin_y, data_imax_y; 
!        do ixd=data_imin_x, data_imax_x;      
!                do isyd=1, dgrid%asy%n;         syd = dgrid%asy%o + (isyd-1)*dgrid%asy%d;  iisyd = 1.5 + (syd-ggrid%ay_surf%o)/ggrid%ay_surf%d
!                do isxd=1, dgrid%asx%n;         sxd = dgrid%asx%o + (isxd-1)*dgrid%asx%d;  iisxd = 1.5 + (sxd-ggrid%ax_surf%o)/ggrid%ax_surf%d
!                        do igyd=1, dgrid%agy%n; gyd = dgrid%agy%o + (igyd-1)*dgrid%agy%d;  iigyd = 1.5 + (gyd-ggrid%ay_surf%o)/ggrid%ay_surf%d
!                        do igxd=1, dgrid%agx%n; gxd = dgrid%agx%o + (igxd-1)*dgrid%agx%d;  iigxd = 1.5 + (gxd-ggrid%ax_surf%o)/ggrid%ax_surf%d
!                                fdata(igxd,igyd,isxd,isyd,iwd)=fdata(igxd,igyd,isxd,isyd,iwd)+(wd**2)*waved(iisxd,iisyd,ixd,iyd,izd)*waved(iigxd,iigyd,ixd,iyd,izd)*refl(ixd,iyd,izd)*spk; 
!                        end do; 
!                        end do; 
!                end do; 
!                end do; 
!        end do; 
!        end do;   
!        end do;   
  end subroutine

!===========================================================================================================================================================================
! compute data from all model points for one shot and one receiver
  subroutine data_compute(waved,spk,wd,iwd,nodes)
!        complex, dimension(:,:,:,:,:)               :: waved
!        complex, allocatable, dimension(:,:,:,:,:)  :: datad
!        integer                                     ::  iszd,  isxd, isyd 
!        integer                                     ::  igzd,  igxd, igyd
!        integer                                     :: iiszd, iisxd, iisyd
!        integer                                     :: iigzd, iigxd, iigyd
!        integer                                     :: izd,ixd,iyd,iwd
!        real                                        :: zd, xd, yd  
!        integer                                     :: nodes, inode
!        real                                        :: sxd , syd, gxd, gyd 
!        complex                                     :: spk
!        real                                        :: wd    
!
!        allocate(datad(dgrid%agx%n,dgrid%agy%n,dgrid%asx%n,dgrid%asy%n,nodes));datad=0.
!!$OMP parallel do private(inode, izd, iyd, ixd, & 
!!$OMP                                   isyd, syd, iisyd, & 
!!$OMP                                   isxd, sxd, iisxd, & 
!!$OMP                                   igxd, gxd, iigyd, & 
!!$OMP                                   igyd, gyd, iigxd  ) schedule(dynamic,1) 
!        do izd=data_imin_z, data_imax_z; inode=omp_get_thread_num()+1; 
!        do iyd=data_imin_y, data_imax_y; 
!        do ixd=data_imin_x, data_imax_x;   
!                do isyd=1, dgrid%asy%n;         syd = dgrid%asy%o + (isyd-1)*dgrid%asy%d;  iisyd = 1.5 + (syd-ggrid%ay_surf%o)/ggrid%ay_surf%d
!                do isxd=1, dgrid%asx%n;         sxd = dgrid%asx%o + (isxd-1)*dgrid%asx%d;  iisxd = 1.5 + (sxd-ggrid%ax_surf%o)/ggrid%ax_surf%d
!                        do igyd=1, dgrid%agy%n; gyd = dgrid%agy%o + (igyd-1)*dgrid%agy%d;  iigyd = 1.5 + (gyd-ggrid%ay_surf%o)/ggrid%ay_surf%d
!                        do igxd=1, dgrid%agx%n; gxd = dgrid%agx%o + (igxd-1)*dgrid%agx%d;  iigxd = 1.5 + (gxd-ggrid%ax_surf%o)/ggrid%ax_surf%d
!!                                datad(igxd,igyd,isxd,isyd,inode)=datad(igxd,igyd,isxd,isyd,inode)+(wd**2)*waved(iisxd,iisyd,ixd,iyd,izd)*waved(iigxd,iigyd,ixd,iyd,izd)*ref(ixd,iyd,izd)*spk; 
!                                datad(igxd,igyd,isxd,isyd,inode)=datad(igxd,igyd,isxd,isyd,inode)+waved(iisxd,iisyd,ixd,iyd,izd)*waved(iigxd,iigyd,ixd,iyd,izd)*ref(ixd,iyd,izd)*spk; 
!                        end do; 
!                        end do; 
!                end do; 
!                end do; 
!        end do;
!        end do;
!        end do;
!!$OMP end parallel do 
!        data(:,:,:,:)=sum(datad,5)
!    deallocate(datad)
  end subroutine

end module


