module data_grid
  use global_params_mod
  implicit none

contains
!!!!!!!!!!!!!!!!  ###########
!######################################################################
  subroutine green_grid()
    if (max_z==-99999.) max_z= vgrid%az%o+vgrid%az%d*(vgrid%az%n-1); imax_z=1.5+(max_z-vgrid%az%o)/vgrid%az%d;  
    if (min_z==-99999.) min_z= vgrid%az%o                          ; imin_z=1.5+(min_z-vgrid%az%o)/vgrid%az%d;      
	
    ggrid%index_mod_minx=max(1.,1.5+(ggrid%ax_modl%o-vgrid%ax%o)/vgrid%ax%d); ggrid%index_mod_maxx=min(ggrid%index_mod_maxx+(ggrid%ax_modl%n-1), vgrid%ax%n) 
    ggrid%index_mod_miny=max(1.,1.5+(ggrid%ay_modl%o-vgrid%ay%o)/vgrid%ay%d); ggrid%index_mod_maxy=min(ggrid%index_mod_maxy+(ggrid%ay_modl%n-1), vgrid%ay%n) 
    ggrid%index_mod_minz=max(1.,1.5+(ggrid%az_modl%o-vgrid%az%o)/vgrid%az%d); ggrid%index_mod_maxz=min(ggrid%index_mod_maxz+(ggrid%az_modl%n-1), vgrid%az%n) 

    write(0,'(A65)')'========================Summary greens============================'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','ggrid%ax_surf  ','|',ggrid%ax_surf  , '|' 
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','ggrid%ay_surf  ','|',ggrid%ay_surf  , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','ggrid%ax_modl  ','|',ggrid%ax_modl  , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','ggrid%ay_modl  ','|',ggrid%ay_modl  , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','ggrid%az_modl  ','|',ggrid%az_modl  , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','ggrid%aw       ','|',ggrid%aw       , '|'
    write(0,'(A65)')'------------------------------------------------------------------'
    if (wfld_d_out)then
        write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','wfld%at       ','|',dgrid%at       , '|'
    endif
    write(0,'(A65)')'------------------------------------------------------------------' 
    write(0,*) '|', 'spike ===>>',spike
    write(0,'(A65)')'====================================================================' 
  end subroutine
!######################################################################
  subroutine velocity_grid()
    call auxin(vel_); call ainaxis(vel_,vgrid%ax,1); call ainaxis(vel_,vgrid%ay,2); call ainaxis(vel_,vgrid%az,3)
    if (max_z==-99999.) max_z= vgrid%az%o+vgrid%az%d*(vgrid%az%n-1); imax_z=1.5+(max_z-vgrid%az%o)/vgrid%az%d;  
    if (min_z==-99999.) min_z= vgrid%az%o                          ; imin_z=1.5+(min_z-vgrid%az%o)/vgrid%az%d;  
    write(0,'(A65)')'=========================Summary velocity==============================='
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|', 'x             ','|',vgrid%ax, '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|', 'y             ','|',vgrid%ay, '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|', 'z             ','|',vgrid%az, '|'
    write(0,'(A65)')'===================================================================='
	call reflect_grid()
  end subroutine
!######################################################################
  subroutine data_grid_born()
    call from_param("data_min_x"  , data_min_x   ,  ggrid%ax_modl%o ); call from_param("data_max_x"  , data_max_x   ,  ggrid%ax_modl%o+(ggrid%ax_modl%n-1)*ggrid%ax_modl%d );
    call from_param("data_min_y"  , data_min_y   ,  ggrid%ay_modl%o ); call from_param("data_max_y"  , data_max_y   ,  ggrid%ay_modl%o+(ggrid%ay_modl%n-1)*ggrid%ay_modl%d );

    data_imin_z=max(1.,1.5+(data_min_z-ggrid%az_modl%o)/ggrid%az_modl%d); data_imax_z=min(ggrid%az_modl%n,nint(1.5+(data_max_z-ggrid%az_modl%o)/ggrid%az_modl%d))
    data_imin_x=max(1.,1.5+(data_min_x-ggrid%ax_modl%o)/ggrid%ax_modl%d); data_imax_x=min(ggrid%ax_modl%n,nint(1.5+(data_max_x-ggrid%ax_modl%o)/ggrid%ax_modl%d))
    data_imin_y=max(1.,1.5+(data_min_y-ggrid%ay_modl%o)/ggrid%ay_modl%d); data_imax_y=min(ggrid%ay_modl%n,nint(1.5+(data_max_y-ggrid%ay_modl%o)/ggrid%ay_modl%d))

    write(0,'(A65)')'=========================Summary data==================================='
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','dgrid%asx  ','|',dgrid%asx  , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','dgrid%asy  ','|',dgrid%asy  , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','dgrid%aw   ','|',dgrid%aw   , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','dgrid%at   ','|',dgrid%at   , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','dgrid%agx  ','|',dgrid%agx  , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','dgrid%agy  ','|',dgrid%agy  , '|'
    write(0,'(A65)')'===================================================================='
  end subroutine
!######################################################################
 subroutine reflect_grid()
        if(exist_file(ref_))then
                call auxin(ref_)
                call ainaxis(ref_, rgrid%ax,1); call ainaxis(ref_, rgrid%ay,2); call ainaxis(ref_,rgrid%az,3)
        elseif(exist_file(vel_))then
                rgrid%az=vgrid%az
                rgrid%ax=vgrid%ax
                rgrid%ay=vgrid%ay

        else
                call seperr('supply a reflectivity or velocity+density model')
        endif
        write(0,'(A65)')'=========================Summary reflect.==============================='
        write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|', 'x             ','|',rgrid%ax, '|'
        write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|', 'y             ','|',rgrid%ay, '|'
        write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|', 'z             ','|',rgrid%az, '|'
        write(0,'(A65)')'===================================================================='
        if(rgrid%az%n/=vgrid%az%n)call seperr('unequal refl. and vel. grids: nz')
        if(rgrid%ay%n/=vgrid%ay%n)call seperr('unequal refl. and vel. grids: ny')
        if(rgrid%ax%n/=vgrid%ax%n)call seperr('unequal refl. and vel. grids: nx')
  end subroutine

 end module

 subroutine table1_int()
 end subroutine
 subroutine table3_int()
 end subroutine
 subroutine table2_int()
 end subroutine

 

