!OW mig io
module data_io
  use global_params_mod
  implicit none

contains
!#####################################################
  subroutine data_io_init()
        complex, allocatable, dimension(:) :: ctmp
        integer                            :: i, nloop
        write(*,*)"Initializing the born data"
        if(lfreq)then
                allocate(ctmp(dgrid%agx%n*dgrid%agy%n*dgrid%asx%n*dgrid%asy%n))
                ctmp = (0,0)
                nloop = dgrid%aw%n
                do i=1, nloop
                        call sep_write(ctmp, data_, esize=8)
                end do
        else
                allocate(ctmp(dgrid%at%n))
                ctmp = 0
                nloop = dgrid%agx%n*dgrid%agy%n*dgrid%asx%n*dgrid%asy%n
                do i=1, nloop
                        call sep_write(ctmp, data_, esize=4)
                end do
        endif
        deallocate(ctmp)
  end subroutine
!#####################################################
  subroutine wfld_io_init(wfld_)
        complex, allocatable, dimension(:) :: ctmp
        integer                            :: i, nloop
        character(len=256)                 :: wfld_

        allocate(ctmp(vgrid%ax%n*vgrid%ay%n*dgrid%at%n))
        ctmp = (0,0)
        nloop = vgrid%az%n
        write(*,*)"Initializing the wfld_d"
        do i=1, nloop
!            call sep_write(ctmp, wfld_, esize=4)
        end do
        deallocate(ctmp)
  end subroutine

!#####################################################
subroutine data_io_w(flag, data, index_aw )
    complex, dimension(:,:,:,:  ), allocatable :: data
    character(len=4)                    :: flag
    integer                             :: index_aw
    integer, dimension(5)               :: n_cube, j_wind, n_wind, f_wind
    integer                             :: n_dim_cube, err
    character :: y

    n_dim_cube = 5
    n_cube = (/dgrid%agx%n , dgrid%agy%n   , dgrid%asx%n   ,  dgrid%asy%n,dgrid%aw%n /)
    j_wind = (/1           , 1             , 1             ,           1 ,         1 /)
    n_wind = (/dgrid%agx%n , dgrid%agy%n   , dgrid%asx%n   , dgrid%asy%n ,         1 /)
    f_wind = (/0           , 0             , 0             ,           0 , index_aw-1/)
    !write(0,*)n_cube; write(0,*)n_wind; write(0,*)j_wind; write(0,*)f_wind; 
    !write(0,*)index_aw; write(0,*)size(data,1),size(data,2),size(data,3),size(data,4)

    if (flag == "rite") then;!       write(0,*)'writing data frequency: ', index_aw
        err = srite_window(data_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,data)
    else if (flag == "reed") then; !       write(0,*)'reading data frequency: ', index_aw
        data = 0.
        err = sreed_window(data_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,data)
    else
        call seperr("you have to specify the flag for data_io_data()")
    end if
    if (err /= 0) call seperr("data_io_data: error reading data")
  end subroutine
!#####################################################
subroutine data_io_s(flag, data, index_sx, index_sy )
    complex, dimension(:,:,:,:  ), allocatable :: data
    character(len=4)                    :: flag
    integer                             :: index_sx, index_sy
    integer, dimension(5)               :: n_cube, j_wind, n_wind, f_wind
    integer                             :: n_dim_cube, err
    character :: y

    n_dim_cube = 5
    n_cube = (/dgrid%agx%n , dgrid%agy%n   , dgrid%aw%n    , dgrid%asx%n    ,  dgrid%asy%n/)
    j_wind = (/1           , 1             , 1             , 1              ,           1/)
    n_wind = (/dgrid%agx%n , dgrid%agy%n   , dgrid%aw%n    , 1              ,           1/)
    f_wind = (/0           , 0             , 0             , index_sx-1     ,  index_sy-1/)
    if (flag == "rite") then
       err = srite_window(data_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,data)
    else if (flag == "reed") then
       data = 0.
       err = sreed_window(data_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,data)
    else
       call seperr("you have to specify the flag for data_io_data()")
    end if
    if (err /= 0) call seperr("data_io_data: error reading data")
  end subroutine
!#####################################################
subroutine data_io_a(flag, fdata)
    complex, dimension(:,:,:,:,:), allocatable 	:: fdata
    character(len=4)                    	:: flag
    integer, dimension(5)               	:: n_cube, j_wind, n_wind, f_wind
    integer                             	:: n_dim_cube, err
    character :: y

    n_dim_cube = 5
    n_cube = (/dgrid%agx%n , dgrid%agy%n   , dgrid%asx%n   , dgrid%asy%n   ,dgrid%aw%n  /)
    j_wind = (/1           , 1             , 1             , 1             ,           1/)
    n_wind = (/dgrid%agx%n , dgrid%agy%n   , dgrid%asx%n   , dgrid%asy%n   ,dgrid%aw%n  /)
    f_wind = (/0           , 0             , 0             , 0             ,	       0/)

    if (flag == "rite") then
       err = srite_window(data_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,fdata)
    else if (flag == "reed") then
       data = 0.
       err = sreed_window(data_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,fdata)
    else
       call seperr("you have to specify the flag for data_io_data()")
    end if
  end subroutine
!#####################################################
subroutine data_io_tdata(flag, fdata)
    use myfft_mod
    complex, dimension(:,:,:,:,:), allocatable 	:: fdata
    complex, dimension(size(fdata,5))		:: tmp
    character(len=4)                    	:: flag
    integer, dimension(5)               	:: n_cube, j_wind, n_wind, f_wind
    integer                             	:: n_dim_cube, err
    character :: y

    n_dim_cube = 5
    n_cube = (/dgrid%agx%n , dgrid%agy%n   , dgrid%asx%n   , dgrid%asy%n   ,dgrid%at%n  /);
    j_wind = (/1           , 1             , 1             , 1             ,           1/);
    n_wind = (/dgrid%agx%n , dgrid%agy%n   , dgrid%asx%n   , dgrid%asy%n   ,dgrid%at%n  /);
    f_wind = (/0           , 0             , 0             , 0             ,	       0/);

        do isy=1, dgrid%asy%n;         
        do isx=1, dgrid%asx%n;         
                do igy=1, dgrid%agy%n; 
                do igx=1, dgrid%agx%n; 
			call FFT1DT(fdata(dgrid%agx%n, dgrid%agy%n, dgrid%asx%n, dgrid%asy%n, :), 1);
                end do; 
                end do; 
        end do; 
        end do;   

    if (flag == "rite") then
       err = srite_window(data_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,real(fdata))
    else if (flag == "reed") then
       data = 0.
       err = sreed_window(data_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,real(fdata))
    else
       call seperr("you have to specify the flag for data_io_data()")
    end if
  end subroutine
!#####################################################
  subroutine data_io_greens(greens, index_ws)
    integer                                   :: index_ws
    integer, dimension(6)                     :: n_cube, j_wind, n_wind, f_wind
    integer                                   :: n_dim_cube, err
    complex, dimension(:,:,:,:,:), allocatable:: greens

    n_dim_cube = 6
    n_cube = (/ggrid%ax_surf%n, ggrid%ay_surf%n, ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n, ggrid%aw%n /)
    j_wind = (/1              , 1              , 1              , 1              , 1              , 1          /)
    n_wind = (/ggrid%ax_surf%n, ggrid%ay_surf%n, ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n, 1          /)
    f_wind = (/0              , 0              , 0              , 0              , 0              , index_ws-1 /)
    !write(*,*) n_cube; write(*,*) n_wind; write(*,*) f_wind; write(*,*) j_wind
    greens = 0.

    !write(0,*)'reading greens frequency: ', index_ws, 'of ', int(.5+(ggrid%aw%n*jw))
    err = sreed_window(greens_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,greens)
    if (err /= 0) call seperr("data_io_greens: error readin greens")

  end subroutine
!#####################################################
  subroutine data_io_wfld(wfld_, wfld, index_z)
    integer                                :: index_z
    integer, dimension(4)                  :: n_cube, j_wind, n_wind, f_wind
    integer                                :: n_dim_cube, err
    real , dimension(:,:,:,:), allocatable :: wfld
    character(len=256)                     :: wfld_

    n_dim_cube = 4
    n_cube = (/vgrid%az%n, vgrid%ax%n, vgrid%ay%n, dgrid%at%n/wfld_out_jt /)
    j_wind = (/1         , 1         , 1         , 1                      /)
    n_wind = (/vgrid%az%n, vgrid%ax%n, vgrid%ay%n, dgrid%at%n/wfld_out_jt /)
    f_wind = (/0         , 0        ,  0         , 0                      /)

    wfld = 0.
    err = srite_window(wfld_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,wfld)
    if (err /= 0) call seperr("data_io_greens: error reading Green's function")
  end subroutine
!#####################################################
 subroutine wfld_out(wfld,wfld_)
        use myfft_mod
        complex    , dimension(:,:,:,:,:), allocatable     :: wfld
        complex    , dimension(:      ), allocatable :: tmp_wfld
        real       , dimension(:,:,:,:), allocatable :: tmp_wfld2
        real       , dimension(:,:,:,:), allocatable :: tmp_wfld3
        character (len=256) :: wfld_

        if (allocated(tmp_wfld )) deallocate (tmp_wfld ); allocate(tmp_wfld(dgrid%at%n))
        if (allocated(tmp_wfld2)) deallocate (tmp_wfld2); allocate(tmp_wfld2(vgrid%ax%n,vgrid%ay%n,vgrid%az%n,dgrid%at%n)) 
        if (allocated(tmp_wfld3)) deallocate (tmp_wfld3); allocate(tmp_wfld3(vgrid%ax%n,vgrid%ay%n,vgrid%az%n,dgrid%at%n))

        nnode =omp_get_num_procs(); thread=omp_get_thread_num(); 
        nodes=floor(nnode*.98)
        call omp_set_num_threads(nodes); write(*,*) 'using', nodes, 'of' , nnode
        !$OMP parallel do private(it,itt,ix,iz,inode,tmp_wfld) schedule(dynamic,1) ordered 
        do iz=1,vgrid%az%n
        	if (allocated(tmp_wfld )) deallocate (tmp_wfld ); allocate(tmp_wfld(dgrid%at%n))
                inode=omp_get_thread_num();  
		if(verb>1) write(*,*)'iz.:', iz ,' of ',vgrid%az%n,' @ node ', inode         
                do iy=1,vgrid%ay%n 
                do ix=1,vgrid%ax%n 
                        tmp_wfld=wfld(ix,iy,iz,:,1); call FFT1DT(tmp_wfld, -1); tmp_wfld2(ix,iy,iz,:)=tmp_wfld
                enddo
                enddo
        enddo
        !$OMP end parallel do
        itt=1; 

        call sep_write(tmp_wfld2, wfld_, esize=4)
        write(*,*)'written wavefields for one shot successfully'
        deallocate(tmp_wfld,tmp_wfld2,tmp_wfld3)
 end subroutine
!#####################################################
  subroutine data_velocity()
        use reflect_mod 
        if(exist_file(vel_))call sreed(vel_,  vel, 4*vgrid%ax%n*vgrid%ay%n*vgrid%az%n)
        if(exist_file(ref_))then
                call sreed(ref_, ref, 4*rgrid%ax%n*rgrid%ay%n*rgrid%az%n)
        else
                call reflec(vel, ref, ref_, vgrid, den)
        endif      

  end subroutine
!#####################################################
  end module
