module data_mod
  use data_history
  use data_io
  use data_array
  use data_param 
  use data_wavelet
  use data_grid
  use data_compute_mod
  implicit none

contains
!=======================================================================================
  integer function data_init() result(stat)
    call green_input_history()
    call green_params()                                     !initialize data modeling parameters 
    call green_grid()                                       !get greens grid 
    call velocity_grid()                                    !get velocity/refl grid     
    call data_wavelets()                                    !get wavelet
    call data_params()                                      !initialize data modeling parameters 
    call data_array_alloc()                                 !allocate memory
    call data_velocity()                                    !get velocity/refl models
    if (wfld_d_out) then;                                   !save down wavefield in time
        call wfld_output_history(wfld_d_); 
        call wfld_io_init(wfld_d_); 
    endif; 
    call data_grid_born();
    call data_output_history(); 
    call data_io_init(); 
    stat = 0
  end function
!=======================================================================================
  integer function data_clos() result(stat); call data_array_dealloc(); stat = 0; end function
!!=======================================================================================
  integer function data_oper() result(stat)

    do iw=1, ggrid%aw%n                                                            ! freq. count.
        w=ggrid%aw%o+(iw-1)*ggrid%aw%d;
        index_aw=1.5+(w-dgrid%aw%o)/dgrid%aw%d
        write(0,'(A10,I5,A3,F7.3,A5,2F10.4, A6,I5)')'start iw: ', iw, '|', w,'=> (',csou(index_aw),') of ',ggrid%aw%n; 
        if (cabs(csou(index_aw))==0.)cycle
        call data_io_greens(greens, iw); data=0.
        if(spike_data)then
            call data_compute(greens,(1.,0.)       ,w,index_aw,nodes)
        else
            call data_compute(greens,csou(index_aw),w,index_aw,nodes)
        endif
        call data_io_w('rite', data, index_aw );
    enddo
    stat = 0
  end function
!===========================================================================================================================================================================
end module


