module data_param
  use global_params_mod
  implicit none
contains
!  #============================  
  subroutine data_params() 

        call from_param("ngx", dgrid%agx%n,  ggrid%ax_surf%n);call from_param("dgx", dgrid%agx%d,  ggrid%ax_surf%d);call from_param("ogx", dgrid%agx%o, ggrid%ax_surf%o)
        call from_param("ngy", dgrid%agy%n,  ggrid%ay_surf%n);call from_param("dgy", dgrid%agy%d,  ggrid%ay_surf%d);call from_param("ogy", dgrid%agy%o, ggrid%ay_surf%o)

        call from_param("nsx", dgrid%asx%n,                1);call from_param("dsx", dgrid%asx%d,  dgrid%agx%d    );call from_param("osx", dgrid%asx%o, ggrid%ax_modl%o+(ggrid%ax_modl%n-1)/2*ggrid%ax_modl%d)  
        call from_param("nsy", dgrid%asy%n,                1);call from_param("dsy", dgrid%asy%d,  dgrid%agy%d    );call from_param("osy", dgrid%asy%o, ggrid%ay_modl%o+(ggrid%ay_modl%n-1)/2*ggrid%ay_modl%d)

        call from_param("lfreq"       , lfreq        ,  .true.); 
        call from_param("data_min_z"  , data_min_z   ,  vgrid%az%o); call from_param("data_max_z"  , data_max_z   ,  vgrid%az%o+(vgrid%az%n-1)*vgrid%az%d );
        call from_param("data_min_x"  , data_min_x   ,  vgrid%ax%o); call from_param("data_max_x"  , data_max_x   ,  vgrid%ax%o+(vgrid%ax%n-1)*vgrid%ax%d );
        call from_param("data_min_y"  , data_min_y   ,  vgrid%ay%o); call from_param("data_max_y"  , data_max_y   ,  vgrid%ay%o+(vgrid%ay%n-1)*vgrid%ay%d );
  end subroutine 
!  #============================  
  subroutine green_params() 
    !files 
    greens_  = "greens" ; wavelet_="wavelet";  vel_= "vel";  wfld_d_  = "wfld_d" ;  report_ = "report" ;  data_  = "data" ;    ref_ = "ref"; 
 
    !ggrid surf. params    
    call from_param("nx_surf", ggrid%ax_surf%n, ggrid%ax_surf%n); call from_param("dx_surf", ggrid%ax_surf%d, ggrid%ax_surf%d); call from_param("ox_surf", ggrid%ax_surf%o, ggrid%ax_surf%o)
    call from_param("ny_surf", ggrid%ay_surf%n, ggrid%ay_surf%n); call from_param("dy_surf", ggrid%ay_surf%d, ggrid%ay_surf%d); call from_param("oy_surf", ggrid%ay_surf%o, ggrid%ay_surf%o)

    !ggrid modl. params    
    call from_param("nx_modl", ggrid%ax_modl%n,ggrid%ax_modl%n); call from_param("dx_modl", ggrid%ax_modl%d, ggrid%ax_modl%d); call from_param("ox_modl", ggrid%ax_modl%o, ggrid%ax_modl%o)
    call from_param("ny_modl", ggrid%ay_modl%n,ggrid%ay_modl%n); call from_param("dy_modl", ggrid%ay_modl%d, ggrid%ay_modl%d); call from_param("oy_modl", ggrid%ay_modl%o, ggrid%ay_modl%o)
    call from_param("nz_modl", ggrid%az_modl%n,ggrid%az_modl%n); call from_param("dz_modl", ggrid%az_modl%d, ggrid%az_modl%d); call from_param("oz_modl", ggrid%az_modl%o, ggrid%az_modl%o)

    call from_param("sign"        , sign         , +1     )
    call from_param("marine"      , marine       , .false.)
    call from_param("radian"      , radian       , .false.)
    call from_param("spike"       , spike        , .false.)
    call from_param("spike_data"  , spike_data   , .false.)
    call from_param("jw"          , jw           , 1      )
    call from_param("wfld_d_out"  , wfld_d_out   , .false.)
    call from_param("max_z"       , max_z        , -99999.)
    call from_param("min_z"       , min_z        , -99999.)

    open(unit=10, file=report_, status='unknown');
    write(0,'(A65)')'========================Summary nodes============================='
    call from_param("nodes"       , nodes        ,  1     );    
    nnode =omp_get_num_procs(); nodes=min(nnode-1,nodes) 
    call omp_set_num_threads(nodes); write(*,*) 'using', nodes, 'or less of' , nnode
    write(0,'(A65)')'End nodes========================================================='

  end subroutine
  end module

