module encode_data_array
  use global_params_mod
  implicit none
contains
!=========================================================================================
  subroutine data_array_alloc()
    real :: memory
        memory = 0.
        allocate(wavelet(1));     memory = memory + 8*size(wavelet);
        allocate(vel (vgrid%ax%n, vgrid%ay%n, vgrid%az%n)); memory = memory + 4*size(vel);
        allocate(den (vgrid%ax%n, vgrid%ay%n, vgrid%az%n)); memory = memory + 4*size(den);
        allocate(ref (vgrid%ax%n, vgrid%ay%n, vgrid%az%n)); memory = memory + 4*size(ref);
        allocate(mod (vgrid%ax%n, vgrid%ay%n, vgrid%az%n)); memory = memory + 4*size(mod);
        allocate( dat(dgrid%agx%n,  dgrid%agy%n, dgrid%asx%n, dgrid%asy%n            )); memory = memory + 4*size( dat);
        allocate(tdat(dgrid%agx%n,  dgrid%agy%n, dgrid%asx%n, dgrid%asy%n, dgrid%at%n)); memory = memory + 4*size(tdat);
        allocate(fdata(dgrid%agx%n, dgrid%agy%n, dgrid%asx%n, dgrid%asy%n, dgrid%aw%n)); memory = memory + 8*size(fdata);
        allocate(greens(ggrid%ax_surf%n, ggrid%ay_surf%n, ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n)) ;memory = memory + 8*size(greens);
        !allocate(greens_scode(wgrid%asx%n, wgrid%asy%n,ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n)) ;memory = memory + 8*size(greens_scode);

        allocate(mod1(size(ref ))); memory = memory + 4*size(mod1); 
        allocate(dat1(size(tdat))); memory = memory + 4*size(dat1);
        allocate(norm(niter)); memory = memory + 4*size(norm);


        if (wfld_d_out)allocate(wfld_out_d(vgrid%ax%n,vgrid%ay%n,ggrid%az_modl%n,dgrid%at%n,1)); memory = memory + 8*size(wfld_out_d); 
        memory = memory / 1024 / 1024
        write(0,'(A65)')'=========================Summary memory================================='
        write(0,'(A30,2X,F9.3,A2)')"Memory allocated per node:", memory, "Mb"
        memory=memory*nodes
        write(0,'(A30,2X,F9.3,A2)')"Total memory needed      :", memory, "Mb"
        write(0,'(A65)')'===================================================================='
  end subroutine
!=======================================================================================
subroutine data_array_dealloc()
        if(allocated(wavelet)) deallocate(wavelet)     ;       
		if(allocated(vel    )) deallocate(vel)         ;
		if(allocated(den    )) deallocate(den)         ;
        if(allocated(refl   )) deallocate(refl)        ;       
        if(allocated(data   )) deallocate(data)        ;
        if(allocated(wavelet)) deallocate(wavelet)     ;
        if(allocated(greens )) deallocate(greens)      ; 
        if(allocated(wfld_out_d )) deallocate(wfld_out_d);     
        if(allocated(wfld_out_u )) deallocate(wfld_out_u)
   
        if (allocated(wfld_slice_d)) deallocate(wfld_slice_d); 
        if (allocated(wfld_slice_u)) deallocate(wfld_slice_u); 
        if (allocated(tmp_wfld1_d )) deallocate(tmp_wfld1_d ); 
        if (allocated(tmp_wfld2_d )) deallocate(tmp_wfld2_d ); 
        if (allocated(tmp_wfld1_u )) deallocate(tmp_wfld1_u ); 
        if (allocated(tmp_wfld2_u )) deallocate(tmp_wfld2_u ); 
        if (allocated(tmp_mig     )) deallocate(tmp_mig     ); 
        if (allocated(tmp_mig2    )) deallocate(tmp_mig2    ); 
        if (allocated(data        )) deallocate(data        ); 
        if (allocated(fdata       )) deallocate(fdata       ); 
        if (allocated(mig         )) deallocate(mig         ); 
        if (allocated(vel_slice   )) deallocate(vel_slice   );  
        if (allocated(vel_ref     )) deallocate(vel_ref     ); 
        if (allocated(nref        )) deallocate(nref        ); 
  end subroutine

  end module
