module encode_data_param
  use global_params_mod
  implicit none
#include "fftw3.f"

contains
!  #============================  
  subroutine fftw_init() 
    integer :: N

    !call dfftw_plan_dft_1d (plan1d_F,dgrid%aw%n,fdata(dgrid%agx%n, dgrid%agy%n, dgrid%asx%n, dgrid%asy%n,:),fdata(dgrid%agx%n,dgrid%agy%n,dgrid%asx%n,dgrid%asy%n,:),FFTW_FORWARD,FFTW_ESTIMATE); 
    !call dfftw_plan_dft_1d (plan1d_B,dgrid%aw%n,fdata(dgrid%agx%n, dgrid%agy%n, dgrid%asx%n, dgrid%asy%n,:),fdata(dgrid%agx%n,dgrid%agy%n,dgrid%asx%n,dgrid%asy%n,:),FFTW_BACKWARD,FFTW_ESTIMATE); 

 end subroutine 
!  #============================  
  subroutine data_params() 
        call from_param("ngx", dgrid%agx%n,  min(ggrid%ax_surf%n,vgrid%ax%n));call from_param("dgx", dgrid%agx%d,  ggrid%ax_surf%d);call from_param("ogx", dgrid%agx%o, max(ggrid%ax_surf%o,vgrid%ax%o))
        call from_param("ngy", dgrid%agy%n,  min(ggrid%ay_surf%n,vgrid%ay%n));call from_param("dgy", dgrid%agy%d,  ggrid%ay_surf%d);call from_param("ogy", dgrid%agy%o, max(ggrid%ay_surf%o,vgrid%ay%o))

        call from_param("nsx", dgrid%asx%n,                1);call from_param("dsx", dgrid%asx%d,  dgrid%agx%d    );call from_param("osx", dgrid%asx%o, ggrid%ax_modl%o+(ggrid%ax_modl%n-1)/2*ggrid%ax_modl%d)  
        call from_param("nsy", dgrid%asy%n,                1);call from_param("dsy", dgrid%asy%d,  dgrid%agy%d    );call from_param("osy", dgrid%asy%o, ggrid%ay_modl%o+(ggrid%ay_modl%n-1)/2*ggrid%ay_modl%d)

        call from_param("lfreq"       , lfreq        ,  .true.); 

!! encode stuff
        call from_param("encode"      , encode       ,   F    )
        call from_param("random_constant", random_constant, F ); if (.not. encode)random_constant=F
        call from_param("random_phase", random_phase ,   F    ); if (.not. encode)random_phase=F
        call from_param("linear_phase", linear_phase ,   F    ); if (.not. encode)linear_phase=F
        call from_param("tmin"        , rand_tmin    , -0.5   )
        call from_param("tmax"        , rand_tmax    ,  0.5   ); rand_tlim=rand_tmax-rand_tmin
        call from_param("code_it"     , code_it      ,   F    );
        call from_param("fine"        , fine         ,   F    );

        if(encode)then
            dgrid%asx%n=1
            dgrid%asy%n=1
        elseif(exist_file(wavelet_))then
            dgrid%asx=wgrid%asx
            dgrid%asy=wgrid%asy
        else
            wgrid%asx=dgrid%asx
            wgrid%asy=dgrid%asy
        endif

    !! invert stuff
        call from_param("inv"         , inv          ,   F    )
        call from_param("adj"         , adj          ,   F    )
        call from_param("niter"       , niter        ,   5    )
        if(inv.and.adj) call seperr ( 'Please choose between inv or adj...cannot do both')
  end subroutine 
!  #============================  
  subroutine green_params() 
    !files 
    greens_  = "greens" ; wavelet_="wavelet";  vel_= "vel";  wfld_d_  = "wfld_d" ;  report_ = "report" ;  data_  = "data" ;    ref_ = "ref"; 
 
    !ggrid surf. params    
    call from_param("nx_surf", ggrid%ax_surf%n, ggrid%ax_surf%n); call from_param("dx_surf", ggrid%ax_surf%d, ggrid%ax_surf%d); call from_param("ox_surf", ggrid%ax_surf%o, ggrid%ax_surf%o)
    call from_param("ny_surf", ggrid%ay_surf%n, ggrid%ay_surf%n); call from_param("dy_surf", ggrid%ay_surf%d, ggrid%ay_surf%d); call from_param("oy_surf", ggrid%ay_surf%o, ggrid%ay_surf%o)

    !ggrid modl. params    
    call from_param("nx_modl", ggrid%ax_modl%n,ggrid%ax_modl%n); call from_param("dx_modl", ggrid%ax_modl%d, ggrid%ax_modl%d); call from_param("ox_modl", ggrid%ax_modl%o, ggrid%ax_modl%o)
    call from_param("ny_modl", ggrid%ay_modl%n,ggrid%ay_modl%n); call from_param("dy_modl", ggrid%ay_modl%d, ggrid%ay_modl%d); call from_param("oy_modl", ggrid%ay_modl%o, ggrid%ay_modl%o)
    call from_param("nz_modl", ggrid%az_modl%n,ggrid%az_modl%n); call from_param("dz_modl", ggrid%az_modl%d, ggrid%az_modl%d); call from_param("oz_modl", ggrid%az_modl%o, ggrid%az_modl%o)

    call from_param("sign"        , sign         , +1     )
    call from_param("marine"      , marine       , .false.)
    call from_param("radian"      , radian       , .false.)
    call from_param("spike"       , spike        , .false.)
    call from_param("spike_data"  , spike_data   , .false.)
    call from_param("jw"          , jw           , 1      )
    call from_param("wfld_d_out"  , wfld_d_out   , .false.)
    call from_param("max_z"       , max_z        , -99999.)
    call from_param("min_z"       , min_z        , -99999.)
    call from_param("verb"        , verb         , 1      )

    open(unit=10, file=report_, status='unknown');
    write(0,'(A65)')'========================Summary nodes============================='
    call from_param("nodes"       , nodes        ,  1     );    
    nnode =omp_get_num_procs(); nodes=min(nnode-1,nodes) 
    call omp_set_num_threads(nodes); write(*,*) 'using', nodes, 'or less of' , nnode
    write(0,'(A65)')'End nodes========================================================='

  end subroutine

  subroutine inv_param()
    call from_param("inv"   ,inv   , F )
    call from_param("niter" ,niter , 1 )

  end subroutine 
  end module

