program main
        use sep
        use cubic_mod
        implicit none


        character*132                   :: file1_,file2_, out_, hor1_, hor2_
        character*132                   :: amp1_, amp2_, damp_
        integer                         :: n1, n2, n3, o1, o2, o3, d1, d3, d2
        integer                         :: nz, nx, ny, oz, ox, oy, dz, dx, dy
        real, allocatable               :: trace1(:), trace2(:), tmp(:,:), hor1(:,:), hor2(:,:), file1(:,:,:), file2(:,:,:)
        real, allocatable               :: amp1(:,:), amp2(:,:), damp(:,:)
        real                            :: x,y,z
        real                            :: txt(3)
        integer                         :: i1, i2, i3 
        integer                         :: iz, ix, iy
        integer		                :: stat
        real                            ::  up, dn
        integer                         :: iup,idn
        integer                         :: iiup,iidn
        integer                         :: icount, ihor2

        
        
        if (exist_file(file1_))then
                call from_aux(file1_,"n1",n1); call from_aux(file1_,"d1",d1); call from_aux(file1_,"o1",o1)
                call from_aux(file1_,"n2",n2); call from_aux(file1_,"d2",d2); call from_aux(file1_,"o2",o2) 
                call from_aux(file1_,"n3",n3); call from_aux(file1_,"d3",d3); call from_aux(file1_,"o3",o3)
                allocate(file1(nz*nx*ny)); 
                call sreed(file1_, file1, 4*nz*nx*ny)
        else
                call from_history('n1',n1); call from_history('d1',d1);  call from_history('o1',o1); 
                call from_history('n2',n2); call from_history('d2',d2);  call from_history('o2',o2); 
                call from_history('n3',n3); call from_history('d3',d3);  call from_history('o3',o3);    
                allocate(file1(nz*nx*ny)); 
                call sreed("in", file1, 4*nz*nx*ny)
        endif
        if (exist_file(file2_))then
                call from_aux(file1_,"n1",nz); call from_aux(file1_,"d1",dz); call from_aux(file1_,"o1",oz)
                call from_aux(file1_,"n2",nx); call from_aux(file1_,"d2",dx); call from_aux(file1_,"o2",ox)
                call from_aux(file1_,"n3",ny); call from_aux(file1_,"d3",dy); call from_aux(file1_,"o3",oy)
                if(n1/=nz.or.n2/=nx.or.n3/=ny.or.o1/=oz.or.o2/=ox.or.o3/=oy.or.d1/=dz.or.d2/=dx.or.d3/=dy)then
                        write(0,'(A20,3(I5,2X),6(E15.4,2X))')trim(file2_),n1, n2, n3, o1, o2, o3, d1, d3, d2
                        write(0,'(A20,3(I5,2X),6(E15.4,2X))')trim(file2_),n1, n2, n3, o1, o2, o3, d1, d3, d2
                        call seperr('axes do not match')
                endif        
                allocate(file2(nz*nx*ny)); 
                call sreed(file2_, file2, 4*nz*nx*ny)
        endif
        write(0,*)'Axes summary'
        write(0,'(A20,3(I5,2X),6(E15.4,2X))')trim(file2_),n1, n2, n3, o1, o2, o3, d1, d3, d2


        allocate(hor1(n2,n3)); if(exist_file(hor1_))then; open(unit=100,file=trim(hor1_), status='unknown'); else; call seperr('please specify hor1_'); endif

        do i1=1,n2*n3
                read(100,*,err=200,end=200)txt
                ix=max(1., min(1.5+(txt(2)-o2)/d2, 1.*nx))
                iy=max(1., min(1.5+(txt(3)-o3)/d3, 1.*ny))
                hor1(ix,iy)=txt(1)
200             cycle                        
        end do

        call from_param("up"    , up     ,  25. ); iup =   up/d1
        call from_param("down"  , dn     ,  25. ); idn = down/d1

        ihor2=0
	if(up==0..and.dn==0.)then
                allocate(hor2(n2,n3)); if(exist_file(hor2_))then; open(unit=101,file=trim(hor2_), status='unknown'); else; call seperr('please specify hor2_ or specify up and down'); endif
                ihor2=1
                do i1=1,n2*n3
                        read(101,*,err=201,end=201)txt
                        ix=max(1., min(1.5+(txt(2)-o2)/d2, 1.*nx))
                        iy=max(1., min(1.5+(txt(3)-o3)/d3, 1.*ny))
                        hor2(ix,iy)=txt(1)
201                     cycle                        
                end do
        endif          


        if(exist_file(amp1_))allocate(amp1)
        if(exist_file(amp2_))allocate(amp2)
        if(exist_file(damp_))allocate(damp)

        write(0,*) 'SNA1            SNA2            dSNA(1-2)       SPA1            SPA2            dSPA(1-2)'

! through seismic data
	icount=9
	do iy=1,ny
	        icount=icount+1
	        do ix=1,nx
! at each point pick extra four samples to allow tri-cubic interp.
	        if(ihor2.eq.0) then
	                iiup=(hor1(ix,iy)-o1)/d1 - iup - 4
	                iidn=(hor1(ix,iy)-o1)/d1 + idn + 4
	        else
	                iiup=max(1.   ,(1.5+(min(hor1(ix,iy),hor2(ix,iy)) -o1)/d1 - iup - 4))
	                iidn=min(1.*n1,(1.5+(max(hor1(ix,iy),hor2(ix,iy)) -o1)/d1 + idn + 4))
	        end if
                if(iidn-iiup+1.lt.1)cycle
                trace1(1:len)=file1(iiup:iidn,ix,iy)
                trace2(1:len)=file2(iiup:iidn,ix,iy)
                sna1=0.
	        sna2=0.
	        spa1=0.
	        spa2=0.
	        ninterp=16
	        xstep=1./ninterp
	        if(ihor2==0) then
	                x1=max(1.   ,(hor1(ix,iy)-o2)/d1 - iup) 
	                x2=min(1.*n1,(hor1(ix,iy)-o2)/d1 + idn)
	        else
	                x1=max(1.   ,(hor1(ix,iy)-o2)/d1      )
	                x2=min(1.*n1,(hor2(ix,iy)-o2)/d1      )
	        end if

	        do x=x1,x2,xstep
		        call cubic(trace1,x,tr1,n1)
		        call cubic(trace2,x,tr2,n1)
		        if(tr1.lt.0) sna1=sna1+tr1
		        if(tr1.gt.0) spa1=spa1+tr1
		        if(tr2.lt.0) sna2=sna2+tr2
		        if(tr2.gt.0) spa2=spa2+tr2
	      end do
	      sna1=sna1/ninterp
	      sna2=sna2/ninterp
	      spa1=spa1/ninterp
	      spa2=spa2/ninterp

	      write(0,1000) int(y), int(bin), sna1, sna2, sna1-sna2, spa1, spa2, spa1-spa2
1000	      format(2i8, 16g16.6)
	   end do
	end do
	close(10)
	end




