module fftw_oneway_mod
implicit none
#include "fftw3.f"
	real   , allocatable, private           ::  in(:), in2(:,:), in3(:,:,:)
	complex, allocatable, private           :: out(:),out2(:,:),out3(:,:,:)
        integer, private, save                  :: naxis1,naxis2,nf,nt
        integer	*8, private, save               :: plan1d_F,plan2d_F,plan3d_F
        integer	*8, private, save               :: plan1d_B,plan2d_B,plan3d_B
        real,private,save                       :: scaleF,scaleB
contains
!  #============================   
  subroutine fftw_init1d(nw_in)  
	integer :: nw_in
	nf =nw_in; 
        if(allocated( in))deallocate( in); 
        if(allocated(out))deallocate(out);
        allocate(in(nf),out(nf/2+1)); 
        if(modulo(nf,2)==0) call seperr('Please pad your data to odd number of frequencies: dfftw requires odd numbers');
        scaleF=1.
        scaleB=1./nf 

        call sfftw_plan_dft_r2c_1d(plan1d_F,nf,in,out,FFTW_ESTIMATE);
        call sfftw_plan_dft_c2r_1d(plan1d_B,nf,out,in,FFTW_ESTIMATE);

 end subroutine 
!  #============================  
  subroutine fftw_exec1d(dir,data)
        complex :: data(:)
        integer :: dir
        call sfftw_plan_dft_r2c_1d(plan1d_F,nf,in,out,FFTW_ESTIMATE);
        call sfftw_plan_dft_c2r_1d(plan1d_B,nf,out,in,FFTW_ESTIMATE);
        if(dir== 1)then;  in=real(data)          ; data=0.; call sfftw_execute(plan1d_F); data(1:size(out))=out*scaleF; endif
        if(dir==-1)then;  out=data(1:size(out))  ; data=0.; call sfftw_execute(plan1d_B); data             = in*scaleB; endif
 end subroutine 
!  #============================  
  subroutine fftw_dest1d();        deallocate(in ,out ); call sfftw_destroy_plan(plan1d_F);         call sfftw_destroy_plan(plan1d_B);  end subroutine 
  subroutine fftw_dest2d();        deallocate(in2,out2); call sfftw_destroy_plan(plan2d_F);         call sfftw_destroy_plan(plan2d_B);  end subroutine 
!  #============================  
  subroutine fftw_init2d(naxis1_in,naxis2_in) 
	integer	:: naxis1_in, naxis2_in
		naxis1 =naxis1_in; 
                naxis2=naxis2_in; 
        	if(modulo(naxis1,2)==0) call seperr('Please pad your data (1 axis) to odd number of samples: dfftw requires odd numbers')
	        if(modulo(naxis2,2)==0) call seperr('Please pad your data (2 axis) to odd number of samples: dfftw requires odd numbers')
                if (allocated(in2))deallocate(in2); if (allocated(out2))deallocate(out2); allocate(in2(naxis1,naxis2),out2(naxis1/2+1,naxis2/2+1));
                call sfftw_plan_dft_r2c_2d(plan1d_F,naxis1,naxis2,in2,out2,FFTW_ESTIMATE);
                call sfftw_plan_dft_c2r_2d(plan1d_B,naxis1,naxis2,out2,in2,FFTW_ESTIMATE);
 end subroutine 
!  #============================  
  subroutine fftw_exec2d(dir,data)
        integer ::i
        complex :: data(:,:)
        integer :: dir
                call sfftw_plan_dft_r2c_2d(plan1d_F,naxis1,naxis2,in2,out2,FFTW_ESTIMATE);
                call sfftw_plan_dft_c2r_2d(plan1d_B,naxis1,naxis2,out2,in2,FFTW_ESTIMATE);

write(0,*)'//////1',dir
write(0,*)data
        if(dir== 1)then;  in2=real(data)                          ; data=0.; call sfftw_execute(plan1d_F);  do i=1,naxis2/2+1; out2(:,i)=out2(:,i)*sqrt(1./naxis2);enddo; do i=1,naxis1/2+1; out2(i,:)=out2(i,:)*sqrt(1./naxis1);enddo; data(1:size(out2,1),1:size(out2,2))=out2; endif
        if(dir==-1)then; out2=data(1:size(out2,1),1:size(out2,2)) ; data=0.; call sfftw_execute(plan1d_B);  do i=1,naxis2    ;  in2(:,i)= in2(:,i)*sqrt(1./naxis2);enddo; do i=1,naxis1    ;  in2(i,:)= in2(i,:)*sqrt(1./naxis1);enddo; data=in2                                ; endif
write(0,*)'//////2',dir
write(0,*)in2
write(0,*)'//////3',dir
write(0,*)out2
write(0,*)'//////4',dir
write(0,*)data

 end subroutine 

end module