module global_params_mod
  use util_
  use type_mod
  use sep   
  implicit none

  type(dat_grid)   , save :: dgrid    ! data grid 
  type(hes_grid)   , save :: hgrid    ! hessian grid 
  type(ref_grid)   , save :: rgrid    ! reflectivity grid 
  type(vel_grid)   , save :: vgrid    ! velocity grid
  type(pro_grid)   , save :: pgrid    ! propagation grid
  type(img_grid)   , save :: igrid    ! image grid ---> full image grid
  type(out_grid)   , save :: ogrid    ! image output grid
  type(gre_grid)   , save :: ggrid    ! green's function grid
  type(wav_grid)   , save :: wgrid    ! wavlet grid

  type(block)      , save :: zblock   !depth block
  type(block)      , save :: wblock   !freq. block

  real, dimension(:,:,:,:,:  ), allocatable, save :: tdat 
  real, dimension(:,:,:,:    ), allocatable, save :: dat 
  complex, dimension(:,:,:,:    ), allocatable, target, save :: data 
  complex, dimension(:,:,:,:,:  ), allocatable, target, save :: fdata  
  complex, dimension(:,:,:,:,:  ), allocatable, save :: tdata 
  complex, dimension(:,:,:,:,:  ), allocatable, save :: greens
  complex, dimension(:,:,:      ), allocatable, save :: green
  complex, dimension(:,:,:      ), allocatable, save :: hessian

  real,    dimension(:,:,:,:,:,:), allocatable, save :: migs          !migration...unstacked 
  real,    dimension(:,:,:,:,:  ), allocatable, save :: mig           !migration...full output space 
  real,    dimension(:,:,:,:,:  ), allocatable, save :: tmp_mig       !tmp migration...propagation space 
  real,    dimension(:,:,:,:,:  ), allocatable, save :: tmp_mig2      !tmp migration...image sace 
  real,    dimension(:,:,:,:,:  ), allocatable, save :: migp          !migration...inside propagation grid 
  real,    dimension(:,:,:      ), allocatable, save :: den           !input velocity...full den model
  real,    dimension(:,:,:      ), allocatable, save :: ref           !input reflectivity...full refl model
  real,    dimension(:,:,:      ), allocatable, target, save :: vel           !input velocity...full velocity model
  real,    dimension(:,:,:      ), allocatable, save :: vel_ref       !input ref. velocity for lloyds
  integer, dimension(:          ), allocatable, save :: nref          !no. of input ref. velocity for lloyds
  real,    dimension(:,:,:      ), allocatable, save :: refl          !input reflectivity model for depth nzs
  real,    dimension(:,:,:      ), allocatable, save :: vmod          !input velocity model for depth nzs
  real,    dimension(:          ), allocatable, save :: vref          !reference velocites for depth nzs
  real,    dimension(:,:        ), allocatable, save :: vel_slice     !input velocity slice
  real,    dimension(:,:        ), allocatable, save :: vel_slice0    !input velocity slice0
  real,    dimension(:,:        ), allocatable, save :: ref_slice     !input refl slice 
  integer, dimension(:,:        ), allocatable, save :: ind_vref      !index   ref. vel  

  real,    dimension(:          ), allocatable, save :: kx2           !wavenumber kx*kx
  real,    dimension(:          ), allocatable, save :: ky2           !wavenumber ky*ky
  real                                        , save :: kz2           !wavenumber kz*kz

  real,    dimension(:,:,:,:    ), allocatable, save :: modl          !final image for depth nzs
  real,    dimension(:,:,:,:,:  ), allocatable, save :: model         !final image for depth nzs
  real,    dimension(:,:,:,:    ), allocatable, target, save :: model2        !final image for depth nzs
  real,    dimension(:,:,:,:,:  ), allocatable, save :: normd         !shot illumination
  complex, dimension(:,:        ), allocatable, save :: crec          !input receiver function (in freq domain, nws)
  complex, dimension(:,:,:      ), allocatable, save :: csous         !input source function for all positions
  complex, dimension(:          ), allocatable, save :: csou          !input source function (in freq domain, nws)
  complex, dimension(:          ), allocatable, save :: wavelet       !input source function (in freq domain, nws)
     
  real   , dimension(:,:        ), allocatable, save :: tape          !taper for wavefield in propagation grid
  complex, dimension(:,:        ), allocatable, save :: wfld_d        !downward wavefield in propagation grid
  complex, dimension(:,:        ), allocatable, save :: wfld_u        !upward wavefield in propagation grid
  complex, dimension(:,:        ), allocatable, save :: wfld          !wavefield in propagation grid
 complex , dimension(:,:        ), allocatable, save :: tmp_wfld1
 complex , dimension(:,:        ), allocatable, save :: tmp_wfld2
 complex , dimension(:,:        ), allocatable, save :: tmp_wfld1_u
 complex , dimension(:,:        ), allocatable, save :: tmp_wfld2_u
 complex , dimension(:,:        ), allocatable, save :: tmp_wfld1_d
 complex , dimension(:,:        ), allocatable, save :: tmp_wfld2_d

  complex, dimension(:,:,:,:,:  ), allocatable, target, save :: wfld_out_d    !upward wavefield for output
  complex, dimension(:,:,:,:,:  ), allocatable, target, save :: wfld_out_u    !upward wavefield for output

  complex, dimension(:,:        ), allocatable, target, save :: wfld_slice_d    !upward wavefield for output
  complex, dimension(:,:        ), allocatable, target, save :: wfld_slice_u    !upward wavefield for output



!!!!
  real,    dimension(:,:,:      ), allocatable, save :: taper_wfld
  real,    dimension(:,:,:,:,:,:), allocatable, save :: tmpmig        !tmp migration...propagation space 
  real,    dimension(:,:,:,:,:,:), allocatable, save :: tmpmig2       !tmp migration...image sace 
  complex, dimension(:,:,:      ), allocatable, target, save :: tmpwfld1
  complex, dimension(:,:,:      ), allocatable, target, save :: tmpwfld2
  complex, dimension(:,:,:      ), allocatable, target, save :: tmpwfld3
  complex, dimension(:,:,:      ), allocatable, target, save :: tmpwfld1_u
  complex, dimension(:,:,:      ), allocatable, target, save :: tmpwfld2_u
  complex, dimension(:,:,:      ), allocatable, target, save :: tmpwfld1_d
  complex, dimension(:,:,:      ), allocatable, target, save :: tmpwfld2_d
  complex, dimension(:,:,:,:    ), allocatable, target, save :: wfldfull_d  !upward wavefield for output
  complex, dimension(:,:,:      ), allocatable, target, save :: wfldslice_d  !upward wavefield for output
  complex, dimension(:,:,:      ), allocatable, target, save :: wfldslice_u  !upward wavefield for output
  real,    dimension(:,:        ), allocatable, save :: velref       !reference velocites for depth nzs
  real,    dimension(:,:,:      ), allocatable, save :: velslice     !input velocity slice
!  complex, dimension(:          ), allocatable, save :: phase_shaping
  complex            , save :: phase_shaping


!!!! Read source hearder
  complex, dimension(:,:,:      ), allocatable, save :: csou_full    !Source hearder   

!!!! Encode stuff Jan. 21 09
  real,    dimension(:,:        ), allocatable,save  :: code          !code
  real                                        ,save  :: rand_tlim     !limits of trandom
  real                                        ,save  :: rand_tmin     !lower limits of trandom
  real                                        ,save  :: rand_tmax     !upper limits of trandom
  real                                        ,save  :: linear_tmin   !lower limits of tlinear
  real                                        ,save  :: linear_tmax   !upper limits of tlinear
  real                                        ,save  :: linear_tlim   !limits of tlinear
  real                                        ,save  :: p_min         !p-min
  real                                        ,save  :: p_max         !p-max
  logical                                     ,save  :: random_constant       
  logical                                     ,save  :: random_phase
  logical                                     ,save  :: linear_phase 
  logical                                     ,save  :: code_it
  logical                                     ,save  :: encoded
  logical                                     ,save  :: fine
  complex, dimension(:,:,:,:,:,:), allocatable,save  :: greens_scode
  complex, dimension(:,:,:,:,:  ), allocatable,save  :: greens_rcode
  
  integer                                     ,save  :: encode_nsx   
  integer                                     ,save  :: encode_nsy   
  integer                                     ,save  :: isx_end,isy_end
  integer                                     ,save  :: index_sx_end,index_sy_end
  real                                        ,save  ::  sx_end, sy_end

   
!!!! inversion stuff
  real,    dimension(:,:,:      ), allocatable, save :: mod           !inversion...full refl model
  real,    dimension(:          ), allocatable, save :: mod1           !inversion...full refl model
  real,    dimension(:          ), allocatable, save :: mod2          !inversion...full refl model

  real,    dimension(:          ), allocatable, save :: dat2          !inversion...data
  real,    dimension(:          ), allocatable, save :: dat1          !inversion...data
  real,    dimension(:          ), allocatable, save :: norm 

  integer, save :: niter



  real, save :: min_sz, max_sz
  real, save :: min_rz, max_rz
  real, save :: min_x, max_x, min_hx, max_hx 
  real, save :: min_y, max_y, min_hy, max_hy 
  real, save :: min_z, max_z
  real, save :: data_min_z, data_max_z
  real, save :: data_min_y, data_max_y
  real, save :: data_min_x, data_max_x
  integer, save :: imax_x, imin_x, data_imin_x, data_imax_x
  integer, save :: imax_y, imin_y, data_imin_y, data_imax_y
  integer, save :: imax_z, imin_z, data_imin_z, data_imax_z 
  integer, save :: imin_sz, imin_rz  
  integer, save :: imax_sz, imax_rz  
  integer, save :: mig_end_x, mig_beg_x
  integer, save :: mig_end_y, mig_beg_y
  integer, save :: first_green
  
  integer, save :: esize


  logical, save :: hole                                 !hole?
  logical, save :: ghole                                !hole?
  logical, save :: shole                                !hole?
  real, save    :: hole_sx1,hole_sy1,hole_sx2,hole_sy2  !holes
  real, save    :: hole_gx1,hole_gy1,hole_gx2,hole_gy2  !holes
  integer, save :: ih_sx1,ih_sy1,ih_sx2,ih_sy2          !holes
  integer, save :: ih_gx1,ih_gy1,ih_gx2,ih_gy2          !holes 
  integer, save :: nxhole !num. holes 
  real,    save :: dxhole !d. holes 
  real,    save :: oxhole !o. holes 
  integer, save :: nyhole !num. holes 
  real,    save :: dyhole !d. holes 
  real,    save :: oyhole !o. holes 
  real, allocatable,    save :: hhole_sx1(:),hhole_sy1(:),hhole_sx2(:),hhole_sy2(:)  !holes
  real, allocatable,    save :: hhole_gx1(:),hhole_gy1(:),hhole_gx2(:),hhole_gy2(:)  !holes
  integer, allocatable, save ::   ihh_sx1(:),  ihh_sy1(:),  ihh_sx2(:),  ihh_sy2(:)  !holes
  integer, allocatable, save ::   ihh_gx1(:),  ihh_gy1(:),  ihh_gx2(:),  ihh_gy2(:)  !holes 


  integer, save :: tape0 !taper control
  logical, save :: use_greens
  logical, save :: ffd, psp
  logical, save :: up, down
  logical, save :: encode
  logical, save :: phase
  logical, save :: allfreq
  logical, save :: ldata
  logical, save :: plane
  logical, save :: true
  integer, save :: ireset
  integer, save :: verb
  logical, save :: source
  logical, save :: pratt
  logical, save :: rand         !
  logical, save :: no_green     !no green
  logical, save :: only_green   !only green
  logical, save :: marine       !marine 
  logical, save :: lflip        !flip ricker  wavelet
  logical, save :: lricker      !use ricker source wavelet
  logical, save :: spike        !spike as wavelet 
  logical, save :: spike_data   !spike as wavelet 4 data 
  logical, save :: lfreq        !output data in freq.
  logical, save :: lloyd        !use llyod's algorithm
  logical, save :: lgreen       !forward modeling--> greens only
  logical, save :: decon        !deconvolution???? 
  logical, save :: radian       !freq. in radian?
  logical, save :: offset       !offset computations??
  logical, save :: for          !forward modeling--->green's functions+data
  logical, save :: inv          !inversion using the hessian
  logical, save :: adj          !adjoint---> migration(T) or demigration (F)
  logical, save :: opr          !define what to do
  logical, save :: taper        !taper or not
  logical, save :: sou_sig      !true amplitude
  logical, save :: true_ampli   !true amplitude
  logical, save :: wfld_d_out   !output downgoing wavefield??
  logical, save :: wfld_u_out   !output up-going wavefield??
  real   , save :: taper_pct    !taper percentage
  real   , save :: eps                  
  real   , save :: maxang       
  real   , save :: dt, ot, tmax       
  real   , save :: fund
  integer, save :: nxpad,nypad,nzpad 
  integer, save :: hessian_type !hessian type....diag or full?
  integer, save :: taper_type   !type of taper 
  integer, save :: vnum         !num. of ref. velocities
  integer, save :: num_report   !num to report
  integer, save :: istep        !steps...for messgae output
  integer, save :: rstep
  integer, save :: astep
  integer, save :: nstep
  integer, save :: inode, nodes, nnode, thread
  integer, save :: jw, jt, nt,jjw
  integer, save :: sign
  integer, save :: iz,ix,iy,iw,iv,ik,ikx,iky,it,itt
  integer, save :: izd,ixd,iyd
  integer, save :: izu,ixu,iyu
  integer, save :: ihx,ihy,ihz
  integer, save :: jhx,jhy,jhz
  integer, save :: wfld_out_jt !out wafld samplijng
  integer, save :: wfld_out_pad!out wafld samplijng
  integer, save :: index_aw
  integer, save :: isz, isx, isy , iisz, iisx, iisy   
  integer, save :: igz, igx, igy , iigz, iigx, iigy  
 

  real   , save :: wfld_d_sx, wfld_d_sy
  real   , save :: wfld_u_sx, wfld_u_sy
  integer, save :: index_sz, index_sx, index_sy
  integer, save :: index_gz, index_gx, index_gy
  real   , save :: z, x, y, w  
  real   , save :: sx, sy, gx, gy
  integer, save :: icount 

  real   , save :: mcsou
  integer, save :: seed
  integer, save :: nrnd
 
  integer, save :: stackd

  real, save :: hx,hy,hz
  
  
  
  
    logical, save :: interp
  
  !command-line / params definitions of input/output files 
  character(len=256), save :: wavelet_, twavelet_                       !source, receiver, velocity, image 
  character(len=256), save :: sou_, rec_, vel_, img_ , ref_,  mig_      !source, receiver, velocity, image, refl 
  character(len=256), save :: den_                                      !density
  character(len=256), save :: dhdr_, tdhdr_                             !data 
  character(len=256), save :: data_, tdata_                             !data 
  character(len=256), save :: vel_ref_                                  !ref. vel from lloyds
  character(len=256), save :: wfld_d_, wfld_u_                          !down and upgoing wavefields 
  character(len=256), save :: hdr_sou_, hdr_rec_                        !source header, reciever header
  character(len=256), save :: hessian_, greens_, datumn_                !hessian, greens, datum 
  character(len=256), save :: report_                                   !progress report 
  character(len=256), save :: hessian_in_, hessian_out_                 !hessian_in..hessian_out
  character(len=256), save :: mig_in_, mig_out_                         !hessian, greens, datum 
  character(len=256), save :: encode_, greens_scode_, greens_rcode_            
  character(len=256), save :: modl_

  real   , parameter :: PI = 3.14159265359
  logical, parameter :: T = .true.
  logical, parameter :: F = .false.
  real, save         :: memory
  integer, external  :: srite_window, sreed_window, getch
 
  !parallel
  integer, external  :: omp_get_num_procs 
  integer, external  :: omp_get_thread_num 
  integer, save      :: unw , iww !usefil freq

  real, save         :: max_ang

!FFT plans
  integer*8, save       :: plan1d_F
  integer*8, save       :: plan1d_B
  integer*8, save       :: plan2d_F
  integer*8, save       :: plan2d_B
  integer*8, save       :: plan3d_F
  integer*8, save       :: plan3d_B

  character(len=1), save :: loop              !loop over sources or frequencies

!New modeling not requireing greens functions
    complex,pointer     :: pwfld2(:,:)
    complex,pointer     :: pwfld(:,:)
    real,pointer        :: pvel(:,:)
    real,pointer        :: pmod(:,:)
    complex,pointer     :: pdat(:,:,:)
    
    
    
!  new obc stuff 
    logical, save       :: lobc
    logical, save       :: lfixed
!!
  integer, dimension(:          ), allocatable, save :: irand_gx      !irandom_gx
  integer, dimension(:          ), allocatable, save :: irand_gy      !irandom_gy
  integer, dimension(:          ), allocatable, save :: irand_sx      !irandom_sx
  integer, dimension(:          ), allocatable, save :: irand_sy      !irandom_sy
  real,    dimension(:          ), allocatable, save :: rand_gx       !random_gx
  real,    dimension(:          ), allocatable, save :: rand_gy       !random_gy
  real,    dimension(:          ), allocatable, save :: rand_sx       !random_sx
  real,    dimension(:          ), allocatable, save :: rand_sy       !random_sy
  real,    dimension(:          ), allocatable, save :: rand1         !random_tmp
  integer, dimension(:          ), allocatable, save :: live_gx       !live_gx
  integer, dimension(:          ), allocatable, save :: live_gy       !live_gy
  integer, dimension(:          ), allocatable, save :: live_sx       !live_sx
  integer, dimension(:          ), allocatable, save :: live_sy       !live_sy
  integer                                     , save :: nlive_sx
  integer                                     , save :: nlive_sy
  integer                                     , save :: nlive_gx
  integer                                     , save :: nlive_gy

  logical, save :: nostack
  logical, save :: nostack_w
  logical, save :: nostack_s

  logical, save :: lrand_gx
  logical, save :: lrand_gy
  logical, save :: lrand_sx
  logical, save :: lrand_sy

  character(len=256), save :: randsx_, randsy_ 				!rand zero shots
  character(len=256), save :: randgx_, randgy_ 				!rand zero geoph.	
  character(len=256), save :: randw_ 					!rand freq
  !timing
  integer       ,save :: time_array_0(8), time_array_1(8), time_array_3(8), time_array_4(8), time_array_5(8), time_array_6(8)
  real          ,save :: start_time, finish_time, start_t, finish_t, start_t0, finish_t0, start_t1, finish_t1, tot_t, int_t
  end module
