!Green's function modeling
!15th March 09 trouble with srite_window (OMP) Segmentation fault if inode/=0
module green_mod
  use history_mod 
  use io_mod
  use array_mod
  use param_mod 
  use wavelet_mod
  use myfft_mod
  use map_mod 
  use grid_mod
! use vel_mod
  use ctaper_mod
  use ssf_mod
  use ctaper_mod
  use ssf_zhang_mod
!  use data_compute_mod
  use init_mod 
  use ssf_mod_ffd
  implicit none

contains
!=======================================================================================
  integer function green_init() result(stat)
    call green_param()                                      !initialize modeling parameters 
    call velocity_grid()                                    !get velocity grid     
    call data_param()                                       !initialize data modeling parameters 
!    call green_wavelet()                                   !get wavelet
    call wavelet_s()                                        !get wavelet
    call green_grid()                                       !get greens grid 
    if(ldata)then
            call data_array_alloc()                         !allocate memory
    else
            call green_array_alloc()                        !allocate memory
    endif
    call green_velocity()                                   !get velocity from llodys
    if(.not. no_green)then
            call green_output_history()                     !output the greens history
            call greens_io_init() 
    endif

    if (wfld_d_out) then;                                   !save down wavefield in time
        call wfld_output_history(wfld_d_); 
        call wfld_io_init(wfld_d_); 
    endif; 
    if (ldata) then;                                        !model data
        call data_grid_born();
        call data_output_history(); 
        call data_io_init(); 
    endif;

    stat = 0
  end function
!=======================================================================================
  integer function green_clos() result(stat); call array_dealloc(); stat = 0; end function
!!=======================================================================================
  integer function green_oper() result(stat)
        if(loop=='s') then
            write(0,*)'looping over source'
            stat= green_oper_s2() 
        elseif(loop=='w'.and.ldata) then
            write(0,*)'born data modeling: looping over freq'
            !stat= data_oper_w2() 
        elseif(loop=='w') then
             write(0,*)'looping over freq=='
            stat= green_oper_w2() 
        else
            call seperr('No option chosen')
        endif
  end function
!===========================================================================================================================================================================
!!!!!!!!!
  integer function green_oper_w2() result(stat)
        complex, dimension(:,:,:,:  ),pointer:: dat 
        real,    dimension(:,:,:    ),pointer:: mod
        complex,pointer :: pwfld(:,:)
        real,pointer    :: pvel(:,:)
        real,pointer    :: pmod(:,:)
        complex,pointer :: pdat(:,:,:)
        icount=0;   
        stat=1
!$OMP parallel do private(iw, inode, w, index_aw, igy, gy, index_gy, igx, gx, index_gx, pgrid, kx2, ky2, wfld_slice_d, tape, tape0, tmp_wfld1_d, tmp_wfld2_d, tmpwfld1, tmpwfld2, tmpwfld3, vref, vel_slice, ind_vref, iv, iz, iy, ix,green, greens,pwfld,pvel) schedule(dynamic,1) ordered
        do iw=1, ggrid%aw%n                                                            ! freq. count.
                if(allocated(tape  ))    deallocate(tape  );    allocate(tape(vgrid%ax%n, vgrid%ay%n)); call ctaper2d(tape,vgrid,nxpad,nypad,2)
                if(allocated(green ))    deallocate(green );    allocate(green (                                  ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n));
                if(allocated(greens))    deallocate(greens);    allocate(greens(ggrid%ax_surf%n, ggrid%ay_surf%n, ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n));
                inode=omp_get_thread_num(); 
                w = ggrid%aw%o + (iw-1)*ggrid%aw%d; index_aw=1.5 + (w-dgrid%aw%o)/dgrid%aw%d
                if(cabs(csou(iw))==0.)cycle
                if(verb>2)then
                        write(* ,*)'iw.:', iw , ' of ',ggrid%aw%n,' @ node ', inode  ;   
                endif
                write(10,*)'iw.:', iw , ' of ',ggrid%aw%n,' @ node ', inode  ;
                if (allocated(vref     )) deallocate(vref     ); allocate(vref    (vnum)); vref=0.; 
                do igy=1, ggrid%ay_surf%n; ! surf. shot/geoph. pos. loop
                        gy = ggrid%ay_surf%o + (igy -1) * ggrid%ay_surf%d; index_gy=1.5 + (gy-vgrid%ay%o)/vgrid%ay%d; 
                do igx=1, ggrid%ax_surf%n;
                        gx = ggrid%ax_surf%o + (igx -1) * ggrid%ax_surf%d; index_gx=1.5 + (gx-vgrid%ax%o)/vgrid%ax%d;  
                        if(verb>2)then; if(inode==0)write(0,*)'node 0==>>igx:', igx, 'of',ggrid%ax_surf%n; endif
                        call green_pro_grid(index_gx,index_gy,pgrid);
                        if (allocated(vel_slice)) deallocate(vel_slice); allocate(vel_slice(pgrid%ax%n,pgrid%ay%n)); vel_slice=0. 
                        call k2map(pgrid,kx2,ky2);
                        stat  = ssf_init2(vgrid%az%d); if(ffd) stat  = ssf_ffd_init(sign,kx2, ky2, vgrid%az%d, vgrid%ax%d, vgrid%ay%d)
                        if(interp)then
                                call green_array_alloc2(greens,green,wfld_slice_d, tmp_wfld1_d, tmp_wfld2_d, tape, pgrid, tmpwfld1, tmpwfld2, tmpwfld3); 
                        else 
                                call green_array_alloc2(greens,green,wfld_slice_d, tmp_wfld1_d, tmp_wfld2_d, tape, pgrid); 
                        endif                                
                        if(marine)call ctaper2d_marine(tape,pgrid,2)
                        call wfld_z1_init(wfld_slice_d,pgrid,green,iw)
                        if(ffd)then
                            do iz=imin_z+1,pgrid%az%n;   ! depth loop
                                pvel=>vel(pgrid%index_xmin:pgrid%index_xmax, pgrid%index_ymin:pgrid%index_ymax,iz); 
                                pwfld=>wfld_slice_d; stat = ssf_ffd_oper(T, sign, w, minval(pvel), pvel, pwfld, kx2, ky2); wfld_slice_d(:,:) =wfld_slice_d(:,:)*tape; 
                                green(:,:,iz) = wfld_slice_d(ggrid%index_modpro_minx:ggrid%index_modpro_maxx, ggrid%index_modpro_miny:ggrid%index_modpro_maxy)
                            enddo !end depth
                        elseif(interp)then !not working correctly!!!!!
                            do iz=imin_z+1,pgrid%az%n;   ! depth loop
                                tmp_wfld1_d=wfld_slice_d; wfld_slice_d=0.
                                vref(:)=vel_ref(:,iz,1);
                                pvel=>vel(pgrid%index_xmin:pgrid%index_xmax, pgrid%index_ymin:pgrid%index_ymax,iz); 
                                do iv=nref(iz),1,-1 !vel. loop   lloyds 
                                    tmpwfld1(:,:,iv)=tmp_wfld1_d; call ssf_oper3(T, sign, w, vref(iv), pvel, tmpwfld1(:,:,iv), kx2, ky2);
                                    tmpwfld1(:,:,iv)=tmpwfld1(:,:,iv)*tape
                                enddo
                                where(pvel>=vel_ref(1,iz,2)); wfld_slice_d = tmpwfld1(:,:,1)*tape;endwhere !interp
                                tmpwfld2=sqrt(real(tmpwfld1))**2+(aimag(tmpwfld1))**2
                                tmpwfld3=atan(sin(aimag(tmpwfld1))/cos(real(tmpwfld1)))
                                do iv=nref(iz),2,-1 !vel. loop   lloyds
                                    where(pvel>=vel_ref(iv,iz,2).and.pvel<vel_ref(iv-1,iz,2)); tmp_wfld1_d = tmpwfld2(:,:,iv)*abs((pvel-vel_ref(iv,iz,1))/(vel_ref(iv-1,iz,1)-vel_ref(iv,iz,1)))+tmpwfld2(:,:,iv-1)*abs((vel_ref(iv-1,iz,1)-pvel)/(vel_ref(iv-1,iz,1)-vel_ref(iv,iz,1))); endwhere
                                    where(pvel>=vel_ref(iv,iz,2).and.pvel<vel_ref(iv-1,iz,2)); tmp_wfld2_d = tmpwfld3(:,:,iv)*abs((pvel-vel_ref(iv,iz,1))/(vel_ref(iv-1,iz,1)-vel_ref(iv,iz,1)))+tmpwfld3(:,:,iv-1)*abs((vel_ref(iv-1,iz,1)-pvel)/(vel_ref(iv-1,iz,1)-vel_ref(iv,iz,1))); endwhere
                                    where(pvel>=vel_ref(iv,iz,2).and.pvel<vel_ref(iv-1,iz,2)); wfld_slice_d=tmp_wfld1_d*cmplx(cos(real(tmp_wfld2_d)),sin(real(tmp_wfld2_d))); endwhere
                                enddo
                                green(:,:,iz) = wfld_slice_d(ggrid%index_modpro_minx:ggrid%index_modpro_maxx, ggrid%index_modpro_miny:ggrid%index_modpro_maxy)
                            enddo !end depth
                        else
                            do iz=imin_z+1,pgrid%az%n;   ! depth loop
                                tmp_wfld1_d=wfld_slice_d; wfld_slice_d=0.
                                vref(:)=vel_ref(:,iz,1);
                                pvel=>vel(pgrid%index_xmin:pgrid%index_xmax, pgrid%index_ymin:pgrid%index_ymax,iz); 
                                do iv=nref(iz),1,-1 !vel. loop   lloyds 
                                    tmp_wfld2_d=tmp_wfld1_d; call ssf_oper3(T, sign, w, vref(iv), pvel, tmp_wfld2_d, kx2, ky2);
                                    where(pvel>=vel_ref(iv,iz,2)); wfld_slice_d = tmp_wfld2_d*tape;endwhere !interp
                                enddo
                                green(:,:,iz) = wfld_slice_d(ggrid%index_modpro_minx:ggrid%index_modpro_maxx, ggrid%index_modpro_miny:ggrid%index_modpro_maxy)
                            enddo !end depth
                        endif
                        !WRITE(0,*)ggrid%ax_surf%n, ggrid%ay_surf%n, ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n
                        greens(igx,igy,:,:,:) = green
                        !do iy=1,pgrid%ay%n;
                        !        write(0,'(I5,3X,25(F7.5,2x))')iy,cabs(greens(igx,igy,:,iy,2))*1e4!/maxval(cabs(greens(igx,igy,:,:,2)))
                        !enddo
                        !if(iw==3)stop
                enddo
                enddo !end geoph./shot.
                if(cabs(csou(iw))==0.)greens=0.
                !$OMP ORDERED
                call green_io_greens(greens, iw)
                !$OMP END ORDERED 
                if(wfld_d_out) wfld_out_d(ggrid%index_mod_minx:ggrid%index_mod_maxx, ggrid%index_mod_miny:ggrid%index_mod_maxy,:,iw,1) = greens(nint(ggrid%ax_surf%n/2.),nint(ggrid%ay_surf%n/2.),:,:,:)
                        !do iy=1,pgrid%ay%n;
                                !write(0,'(I5,3X,25(F7.5,2x))')iy,cabs(wfld_out_d(:,iy,2,iw,1))*1e4!/maxval(cabs(greens(igx,igy,:,:,2)))
                        !enddo
        enddo
!$OMP end parallel do
write(0,*)'Done greens...'
        if(wfld_d_out) call wfld_out(wfld_out_d,wfld_d_); 
        stat=0;
  end function 


!===========================================================================================================================================================================
!parallel over source2
  integer function green_oper_s2() result(stat)
!!!!!!!!!
        complex, dimension(:,:,:,:  ),pointer:: dat 
        real,    dimension(:,:,:    ),pointer:: mod
        complex,pointer :: pwfld(:,:)
        real,pointer    :: pvel(:,:)
        real,pointer    :: pmod(:,:)
        complex,pointer :: pdat(:,:,:)
        icount=0;   
        stat=1
        if(allocated(greens)) deallocate(greens); allocate(greens(ggrid%ax_surf%n, 1, ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n));
        do iw=1, ggrid%aw%n                                                            ! freq. count.
                if(allocated(tape  ))    deallocate(tape  );    allocate(tape(vgrid%ax%n, vgrid%ay%n)); call ctaper2d(tape,vgrid,nxpad,nypad,2)
                if(allocated(green ))    deallocate(green );    allocate(green (                                  ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n));
                if(allocated(greens))    deallocate(greens);    allocate(greens(ggrid%ax_surf%n, ggrid%ay_surf%n, ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n));
                w = ggrid%aw%o + (iw-1)*ggrid%aw%d; index_aw=1.5 + (w-dgrid%aw%o)/dgrid%aw%d
                if(cabs(csou(iw))==0.)cycle 
                !write(* ,*)'iw.:', iw , ' of ',ggrid%aw%n
                if(verb>2)then
                        write(* ,*)'iw.:', iw , ' of ',ggrid%aw%n  
                endif
                if (allocated(vref)) deallocate(vref); allocate(vref(vnum)); vref=0.;
                do igy=1, ggrid%ay_surf%n; ! surf. shot/geoph. pos. loop
                        gy = ggrid%ay_surf%o + (igy -1) * ggrid%ay_surf%d; index_gy=1.5 + (gy-vgrid%ay%o)/vgrid%ay%d; 
!$OMP parallel do private(inode, igx, gx, index_gx, pgrid, kx2, ky2, wfld_slice_d, tape0, tmp_wfld1_d, tmp_wfld2_d, vref, vel_slice, ind_vref, iv, iz, ix, pwfld, pvel, green) schedule(dynamic,1)
                do igx=1, ggrid%ax_surf%n;
                        gx = ggrid%ax_surf%o + (igx -1) * ggrid%ax_surf%d; index_gx=1.5 + (gx-vgrid%ax%o)/vgrid%ax%d;  
                        inode=omp_get_thread_num();
                        if(verb>2)then; if(inode==1)write(0,*)'node 1==>>igx:', igx, 'of',ggrid%ax_surf%n; endif
                        call green_pro_grid(index_gx,index_gy,pgrid);
                        if (allocated(vel_slice)) deallocate(vel_slice); allocate(vel_slice(pgrid%ax%n,pgrid%ay%n)); vel_slice=0. 
                        call k2map(pgrid,kx2,ky2); 
                        stat  = ssf_init2(vgrid%az%d); if(ffd) stat  = ssf_ffd_init(sign,kx2, ky2, vgrid%az%d, vgrid%ax%d, vgrid%ay%d)
                        call green_array_alloc4(green, wfld_slice_d, tmp_wfld1_d, tmp_wfld2_d, tape, pgrid);
                        if(marine)call ctaper2d_marine(tape,pgrid,2)
                        call wfld_z1_init(wfld_slice_d,pgrid,green,iw)
                        do iz=imin_z+1,pgrid%az%n;   ! depth loop
                                pvel=>vel(pgrid%index_xmin:pgrid%index_xmax, pgrid%index_ymin:pgrid%index_ymax,iz); 
                                pwfld=>wfld_slice_d; stat = ssf_ffd_oper(T, sign, w, minval(pvel), pvel, pwfld, kx2, ky2); wfld_slice_d(:,:) =wfld_slice_d(:,:)*tape; 
                                green(:,:,iz) = wfld_slice_d(ggrid%index_modpro_minx:ggrid%index_modpro_maxx, ggrid%index_modpro_miny:ggrid%index_modpro_maxy)
                                !write(0,*)ggrid%index_modpro_minx,ggrid%index_modpro_maxx, ggrid%index_modpro_miny,ggrid%index_modpro_maxy,size(green,1),size(green,2)
                        enddo !end depth
                        greens(igx,1,:,:,:) = green
                enddo
!$OMP end parallel do
                if(cabs(csou(iw))==0.)greens=0.
                call green_io_greens3(greens, index_gy, iw)
                enddo !end geoph./shot.
        if(wfld_d_out) wfld_out_d(ggrid%index_mod_minx:ggrid%index_mod_maxx, ggrid%index_mod_miny:ggrid%index_mod_maxy,:,iw,1) = greens(nint(ggrid%ax_surf%n/2.),nint(ggrid%ay_surf%n/2.),:,:,:)
        enddo
write(0,*)'Done greens...'
        if(wfld_d_out) call wfld_out(wfld_out_d,wfld_d_); 
        stat=0;
  end function
!===========================================================================================================================================================================

end module
