module helicon_mod  
! Convolution, inverse to deconvolution.
! Requires the filter be causal with an implicit "1." at the onset.
  use adj_mod
  use helix_mod
  use regrid_mod
  use createhelix_mod
  implicit none
  type( filter), private :: aa 
  contains
  subroutine helicon_init ( aa_in )
    type( filter)    :: aa_in
    aa = aa_in
  end subroutine
  function helicon_lop ( adj, add, xx, yy,opt) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: xx,yy 
    logical              :: opt
    optional             :: opt
    call adjnull (adj,add,xx,yy )
    if(present(opt))then
    call helicon_lop2(adj,add,xx,yy,opt)
    else
    call helicon_lop2(adj,add,xx,yy)
    endif
    stat=0
  end function 
  subroutine helicon_lop2(adj,add,xx,yy,opt)
    logical,intent(in) :: adj,add 
    real, dimension (:)  :: xx 
    real, dimension (:)  :: yy 
    logical              :: opt
    optional             :: opt
    integer iy, ix, ia
    if ( adj) then  !zero lag
      xx =xx + yy
    else
      yy =yy + xx
    end if

    if(present(opt))then
    endif
    do ia = 1, size( aa%lag)
        do iy = 1  + aa%lag( ia), size( yy)
                if ( associated( aa%mis)) then; if ( aa%mis( iy)) cycle; end if; 
                ix = iy - aa%lag( ia)
                if ( adj) then
                        xx(ix)=xx(ix)+yy(iy)*aa%flt(ia)
                else
                        yy(iy)=yy(iy)+xx(ix)*aa%flt(ia)
                end if
        end do
    end do
  end subroutine 
  subroutine helicon_close()
  end subroutine 
  end module
