!hessian compute
module hessian_array
  use hessian_params
 implicit none

 contains
!==========================================================================================
!=========================================================================================
  subroutine hess_array_alloc()
    real (kind=8) :: memory
    allocate(hessian0(hgrid%ahx_offd%n,hgrid%ahy_offd%n));hessian0=0.
    allocate(wavelet(1))

    if (.not. allocated(greens_s ))then; allocate(greens_s (ggrid%ax_surf%n , ggrid%ay_surf%n,ggrid%ax_modl%n,ggrid%ay_modl%n,ggrid%az_modl%n)); greens_s=0.;endif
    if (.not. allocated(greens_r ))then; allocate(greens_r (ggrid%ax_surf%n , ggrid%ay_surf%n,ggrid%ax_modl%n,ggrid%ay_modl%n,ggrid%az_modl%n)); greens_r=0.;endif 
    if (.not. allocated(hessian1))then; allocate(hessian1(hgrid%ahx_offd%n,hgrid%ahy_offd%n,hgrid%ax_offd%n,hgrid%ay_offd%n,hgrid%az_offd%n,hgrid%ahx_modl%n, hgrid%ahy_modl%n)); hessian1=0.;endif
    if (.not. allocated(hessian2))then; allocate(hessian2(hgrid%ahx_offd%n,hgrid%ahy_offd%n,hgrid%ax_offd%n,hgrid%ay_offd%n,hgrid%az_offd%n,hgrid%ahx_modl%n, hgrid%ahy_modl%n)); hessian2=0.;endif
    if (.not. allocated(hessian3))then; allocate(hessian3(hgrid%ahx_offd%n,hgrid%ax_offd%n,hgrid%az_offd%n,hgrid%ahx_modl%n,hgrid%ax_modl%n,hgrid%az_modl%n)); hessian3=0.; endif
    

    memory = 4. * (size(hessian0) + size(hessian1) +  size(hessian2) + size(hessian3)) + 8.* size(greens1) + 8.*size(greens_r) +  8.*size(greens_s) +  8.*size(wavelet)
    memory = (memory / 1024) / 1024
    write(0,*)"Memory allocated: ", memory, "Mb"

    deallocate(greens_s,greens_r,hessian1,hessian2,hessian3)

  end subroutine
!=================================================================================================
subroutine hess_array_dealloc()
  if( allocated(greens1 )) deallocate(greens1 )
  if( allocated(hessian0)) deallocate(hessian0)
  if( allocated(hessian1)) deallocate(hessian1)
  if( allocated(hessian2)) deallocate(hessian2)
  if( allocated(hessian3)) deallocate(hessian3)
  if( allocated(wavelet )) deallocate(wavelet )
  if( allocated(greens  )) deallocate(greens  )
  if( allocated(rand1   )) deallocate(rand1   ) 
  if( allocated(rand_gx )) deallocate(rand_gx ) 
  if( allocated(rand_gy )) deallocate(rand_gy ) 
  if( allocated(rand_sx )) deallocate(rand_sx ) 
  if( allocated(rand_sy )) deallocate(rand_sy ) 
  if( allocated(irand_gx)) deallocate(irand_gx) 
  if( allocated(irand_gy)) deallocate(irand_gy) 
  if( allocated(irand_sx)) deallocate(irand_sx) 
  if( allocated(irand_sy)) deallocate(irand_sy) 
end subroutine
!=================================================================================================
end module

