program main
!modified from yaxun tang's code
  use sep
  use igrad1
  use hessian_mod_conv 
  use util_
  use type_mod
  use dottest
  use adj_mod
  use solver_me
  use minres_mod

  use base_solver_mod
!  use global_defi_mod
!  use solver_reg_mod

  implicit none
  type(axis)                            :: mov,nrm 
  real, dimension(:)  , allocatable     :: modl
  real, dimension(:)  , allocatable     :: data 
  real, dimension(:)  , allocatable     :: norm 
  real, dimension(:,:), allocatable     :: rmov 
  real, dimension(:,:), allocatable     :: mmov 
  logical                               :: adj,dot,inv,verb
  character(len=256)                    :: modl_, data_, hess_, mmov_, rmov_, norm_, lump_
  integer                               :: stat, ndim, niter, jmov, mode
  integer                               :: n
  real(dp), dimension(:)  , allocatable :: modl_mres
  real(dp), dimension(:)  , allocatable :: data_mres 
  real                                  :: eps
  real                                  :: zmin
  logical                               :: lump_it,diag,psf,full
 
  logical                               :: checkA 
  integer                               :: j, itnlim, istop, itn, nprint
  real(dp)                              :: Anorm, Acond, Arnorm, rnorm, rtol, r1norm, ynorm

  !@@ dottest
  real(kind=4), allocatable :: dat1(:), mod1(:), dat2(:), mod2(:)
  real(kind=4)              :: dot1(2), dot2(2)          

  call sep_init(SOURCE); call getch_add_string("head=/dev/null"); 
  call getch_add_string("noheader=y"); call set_no_putch();  call sep_begin_prog()
  modl_ = "modl"; data_ = "data"; hess_ = "hess"; mmov_ = "mmov"; rmov_ = "rmov"; norm_ ="norm"; lump_="lump" 

  call from_param("adj", adj, .true. );         call from_param("inv", inv, .false.);
  call from_param("dot", dot, .false.);         call from_param("niter", niter, 10);
  call from_param("verb",verb,.false.);         call from_param("eps", eps, 1.);
  call from_param("zmin", zmin , 0.);           call from_param("lump_it", lump_it, .true. );       
  call from_param("diag", diag, .true.);        call from_param("full", full, .false. );      
  call from_param("diag", psf, .false.); 
 

  call from_param("mode", mode, 1);
  !mode=1 Default CG. solver
  !mode=2 2nd CG. solver
  !mode=3 Bicongugate solver
  !mode=4 Preconditioned CG solver
  !mode=5 min. residual method solver

  call from_param("jmov", jmov, max(4,int(niter/50.)))
  call auxinout(modl_); call auxinout(data_); call auxin (hess_); 
  call auxinout(mmov_); call auxinout(rmov_); call auxout (lump_)

  call hinaxis2(hess_, hgrid%ahx_offd, 1); call hinaxis2(hess_, hgrid%ahy_offd, 2);  
  call hinaxis2(hess_, hgrid%ax_offd , 3); call hinaxis2(hess_, hgrid%ay_offd , 4); call hinaxis2(hess_, hgrid%az_offd , 5); 
  call hinaxis2(hess_, hgrid%ahx_modl, 6); call hinaxis2(hess_, hgrid%ahy_modl, 7); 
  call hinaxis2(hess_, hgrid%ax_modl , 8); call hinaxis2(hess_, hgrid%ay_modl , 9); 
  
  call from_aux(hess_, "n10", hgrid%az_modl%n)  
  call from_aux(hess_, "d10", hgrid%az_modl%d) 
  call from_aux(hess_, "o10", hgrid%az_modl%o) !cant read 2 digits!!! 

  mov%n=int(niter/jmov); mov%d=jmov; mov%o=0; 
  nrm%n=niter          ; nrm%d=1   ; nrm%o=1; 

  allocate(modl(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
  allocate(data(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
  allocate(modl_mres(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
  allocate(data_mres(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
  allocate(rmov(hgrid%az_modl%n*hgrid%ax_modl%n*hgrid%ay_modl%n,nint(1.*niter/jmov)))
  allocate(mmov(hgrid%az_modl%n*hgrid%ax_modl%n*hgrid%ay_modl%n,nint(1.*niter/jmov)))
  allocate(norm(niter))

  if (adj .or. inv .or. diag .or. lump_it) then
     write(*,*)'inv..adj..diag..lump...',inv,adj,diag,lump_it
     call sep_read(data, data_) 
     call houaxis2(modl_, hgrid%az_modl, 1);call houaxis2(modl_, hgrid%ax_modl, 2); call houaxis2(modl_, hgrid%ay_modl, 3)
     call houaxis2(mmov_, hgrid%az_modl, 1);call houaxis2(mmov_, hgrid%ax_modl, 2); call houaxis2(mmov_, mov, 3)
     call houaxis2(rmov_, hgrid%az_modl, 1);call houaxis2(rmov_, hgrid%ax_modl, 2); call houaxis2(rmov_, mov, 3)
     call houaxis2(norm_, nrm          , 1)
  else
     call houaxis2(data_, hgrid%az_modl, 1);call houaxis2(data_, hgrid%ax_modl, 2); call houaxis2(data_, hgrid%ay_modl, 3)
     call sep_read(modl, modl_)
     write(*,*)'modeling......'
  end if
  if (lump_it .or. diag)then
     call houaxis2(modl_, hgrid%az_modl, 1);call houaxis2(modl_, hgrid%ax_modl, 2); call houaxis2(modl_, hgrid%ay_modl, 3)
     call houaxis2(lump_, hgrid%az_modl, 1);call houaxis2(lump_, hgrid%ax_modl, 2); call houaxis2(lump_, hgrid%ay_modl, 3)
  endif

  stat = conv_init(hgrid, hess_, zmin, lump_)
  modl_mres=modl; data_mres=data;
  if(dot)then
        allocate(dat1(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n*hgrid%ax_offd%n*hgrid%ay_offd%n*hgrid%az_offd%n), &
                mod1(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n*hgrid%ax_offd%n*hgrid%ay_offd%n*hgrid%az_offd%n))
        allocate(dat2(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n*hgrid%ax_offd%n*hgrid%ay_offd%n*hgrid%az_offd%n), &
                mod2(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n*hgrid%ax_offd%n*hgrid%ay_offd%n*hgrid%az_offd%n))
        call random_seed
        call random_number(dat1); call random_number(mod2)
        stat = conv_oper(.true. , .false., mod1,dat1*1000)   
        stat = conv_oper(.false., .false., mod2*1000,dat2)
        dot1=0
        dot1(1) = sum(mod1*mod2); dot1(2) = sum(dat1*dat2)
        write(0,*)'--------------Dottest'
        write(0,*) dot1
        deallocate(dat1,dat2,mod1,mod2)
  else
      if (inv)then
                n = hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n
                if (mode==1)then
                        write(*,*)'starting Default CG inversion..........................'
                        call solver_cg(m=modl, d=data, Fop=conv_oper, niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb)
                elseif(mode==2)then
                        write(*,*)'starting 2nd CG inversion..............................'
                        call solver_cg2(m=modl, d=data, Fop=conv_oper, niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb)
                elseif(mode==3)then
                        write(*,*)'starting Bi CG inversion...............................'
                        call solver_bicg(m=modl, d=data, Fop=conv_oper, niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb)
                elseif(mode==4)then
                        write(*,*)'starting Precond CG inversion...........................'
                        call seperr('Not working yet...')
                elseif(mode==5)then
                        write(*,*)'starting GMRES..............................Not working fine yet'
                        call MINRES( n=n, Aprod=hess_convolve3, Msolve=hess_precond, b=data_mres, shift=0.0_dp, checkA=.false., precon=.false., &
                                        x=modl_mres, itnlim=niter, nout=6, rtol= 1.0e-12_dp ,                       &
                                        istop=istop, itn=itn, Anorm=Anorm, Acond=Acond, rnorm=rnorm, Arnorm=Arnorm, ynorm=ynorm )
                                        data=data_mres; modl=modl_mres
                elseif (mode==6)then
                        write(*,*)'starting CG square inversion with gradient reg.........'
                        call solver_cg_square(m=modl, d=data, Fop=conv_oper, Aop=conv_grad_oper, niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb,eps=eps, tol= 1.0e-12_dp)
                elseif (mode==7)then
                        write(*,*)'starting CG square inversion with laplac reg...........'
                        call solver_cg_square(m=modl, d=data, Fop=conv_oper, Aop=conv_laplac_oper, niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb,eps=eps, tol= 1.0e-12_dp)
                elseif (mode==8)then
                        write(*,*)'Starting Yaxuns solver..............................'
                        call base_solver_cglpd_smp(m=modl, d=data, Fop=conv_oper, search=.true.,  niter=niter, rmov=rmov, mmov=mmov)
                        !call base_solver_cglpd_reg(m=modl, d=data, Fop=conv_oper, Aop=conv_grad_oper, eps=(0*modl)+1., search=.true.,  niter=niter, rmov=rmov, mmov=mmov)

                else
                    call seperr('You have not selected an inversion scheme...')
                endif

      elseif(adj)then
                stat = conv_oper(adj, .false., modl, data)
      elseif(diag)then
                write(0,*)'Diag.....'
                stat = conv_oper_diag(.true., .false., modl, data)
      elseif(lump_it)then
                write(0,*)'Mass lumping .....Start'
                stat = conv_oper_lump(.true., .false., modl, data)
                write(0,*)'Mass lumping .....Done'
      else
                write(0,*)'Modeling ....Start',maxval(data),maxval(modl)
                stat = conv_oper(adj , .false., modl, data)
                write(0,*)'Modeling .....Done',maxval(data),maxval(modl)
      endif
      if (adj .or. inv .or. lump_it .or. diag) then
             write(0,*)'Writing model....',maxval(modl),minval(modl),sum(modl)
             write(0,*)'Writing model....',maxval(data),minval(data),sum(data)
             call sep_write(modl, modl_)
             if (inv)then
                     call sep_write(mmov, mmov_)
                     call sep_write(rmov, rmov_)
                     call sep_write(norm, norm_)
             endif
      else
             write(0,*)'Writing data .....',maxval(data)
             call sep_write(data, data_)
      endif
  endif

  stat = conv_clos()

  deallocate(modl, data)

end program
