program main
  use sep
  use igrad1
  use hessian_mod_conv_joint
  use util_
  use type_mod 
  use dottest
  use adj_mod
  use solver_me
  use minres_mod
  use mask1
!
  use dottest
!
  use solver_H_mod
!
  use cgstep_mod
  use cg_step_mod
  use solver_smp_mod  
  use solver_reg_mod
  use solver_prc_mod
  use base_solver_mod
!  use global_defi_mod

  implicit none
  type(axis)                            :: mov,nrm 
  real, dimension(:)  , allocatable     :: modl
  real, dimension(:)  , allocatable     :: data 
  real, dimension(:)  , allocatable     :: norm 
  real, dimension(:,:), allocatable     :: rmov 
  real, dimension(:,:), allocatable     :: mmov 
  character(len=256)                    :: modl_, data_, hess_, mmov_, rmov_,norm_
  real(dp), dimension(:)  , allocatable :: modl_mres
  real(dp), dimension(:)  , allocatable :: data_mres 
  real, dimension(:)  , allocatable     :: modl1
  real, dimension(:)  , allocatable     :: data1 
  real, dimension(:)  , allocatable     :: epsi 
  real, dimension(:)  , allocatable     :: norm1 
  real, dimension(:,:), allocatable     :: rmov1 
  real, dimension(:,:), allocatable     :: mmov1 
  character(len=256)                    :: modl1_, data1_, hess1_, mmov1_, rmov1_,norm1_
  character(len=256)                    :: epsi1_
  character(len=256)                    :: weight1_
  character(len=256)                    :: mask1_
  real(dp), dimension(:)  , allocatable :: modl1_mres
  real(dp), dimension(:)  , allocatable :: data1_mres 
  real, dimension(:)  , allocatable     :: modl2
  real, dimension(:)  , allocatable     :: data2 
  real, dimension(:)  , allocatable     :: norm2 
  real, dimension(:,:), allocatable     :: rmov2 
  real, dimension(:,:), allocatable     :: mmov2 
  character(len=256)                    :: modl2_, data2_, hess2_, mmov2_, rmov2_, norm2_
  character(len=256)                    :: epsi2_
  character(len=256)                    :: weight2_
  character(len=256)                    :: mask2_
  real(dp), dimension(:)  , allocatable :: modl2_mres
  real(dp), dimension(:)  , allocatable :: data2_mres 
  integer                               :: stat, ndim, niter, jmov, mode
  logical                               :: adj,dot,inv,verb,joint,weight,mask,precon,lump,diag,psf,full
  integer                               :: n
  double precision                      :: tol
  real                                  :: eps, eps_base, eps_4d
  real                                  :: zmin, rsv_zmin
  real                                  :: zmax, rsv_zmax
  real                                  :: xmin, rsv_xmin
  real                                  :: xmax, rsv_xmax

  logical                               :: checkA, noreg 
  integer                               :: j, itnlim, istop, itn, nprint
  real(dp)                              :: Anorm, Acond, Arnorm, rnorm, rtol, r1norm, ynorm

  !@@ dottest
  real(kind=4), allocatable :: dat1(:), mod1(:), dat2(:), mod2(:)
  real(kind=4)              :: dot1(2), dot2(2)          


  call sep_init(SOURCE); call getch_add_string("head=/dev/null"); call getch_add_string("noheader=y"); call set_no_putch();  call sep_begin_prog()
  modl1_ = "modl1"; data1_ = "data1"; hess1_ = "hess1"; mmov1_ = "mmov1"; rmov1_ = "rmov1"; norm1_ ="norm1" 
  modl2_ = "modl2"; data2_ = "data2"; hess2_ = "hess2"; mmov2_ = "mmov2"; rmov2_ = "rmov2"; norm2_ ="norm2" 
  weight1_ = "wg1"; weight2_ = "wg2"; mask1_ = "mask1"; mask2_ = "mask2"; 
  epsi1_ = "epsi1"; epsi2_ = "epsi2"; 

  call from_param("adj", adj, .true. );         call from_param("inv", inv, .false.);
  call from_param("lump", lump, .false. );       call from_param("diag", diag, .false.); 
  call from_param("full", full, .false. );       call from_param("diag", psf, .false.); 
  call from_param("dot", dot, .false.);         call from_param("niter", niter, 10);
  call from_param("verb",verb,.false.);         call from_param("joint", joint, .true.) 
  call from_param("weight",weight,.false.);     call from_param("ones",ones,.false.); 
  call from_param("mask",mask,.false.);         call from_param("precon",precon,.false.); 
  call from_param("noreg",noreg,.false.); 
  call from_param("eps", eps, 1.);
  call from_param("eps_base", eps_base, 1.);
  call from_param("eps_4d  ", eps_4d, 1.);
  call from_param("    zmin",     zmin , 50.); 
  call from_param("rsv_zmin", rsv_zmin , 50.); 
  call from_param("    zmax",     zmax , zmin); 
  call from_param("rsv_zmax", rsv_zmax , zmax); 
  call from_param("rsv_xmin", rsv_xmin , 0.); 
  call from_param("rsv_xmax", rsv_xmax , 50.); 

  rtol=1.0e-10_dp 
 
  call from_param("mode", mode, 1);
  !mode=1 Default CG. solver
  !mode=2 2nd CG. solver
  !mode=3 Bicongugate solver
  !mode=4 Preconditioned CG solver
  !mode=5 min. residual method solver

  call from_param("jmov", jmov, max(4,int(niter/50.)))
  call auxinout(modl1_); call auxinout(data1_); call auxin (hess1_); call auxinout(mmov1_); call auxinout(rmov1_)
  call auxinout(modl2_); call auxinout(data2_); call auxin (hess2_); call auxinout(mmov2_); call auxinout(rmov2_)

  
  call hinaxis2(hess1_, hgrid%ahx_offd, 1); call hinaxis2(hess1_, hgrid%ahy_offd, 2);  
  call hinaxis2(hess1_, hgrid%ax_offd , 3); call hinaxis2(hess1_, hgrid%ay_offd , 4); call hinaxis2(hess1_, hgrid%az_offd , 5); 
  call hinaxis2(hess1_, hgrid%ahx_modl, 6); call hinaxis2(hess1_, hgrid%ahy_modl, 7); 
  call hinaxis2(hess1_, hgrid%ax_modl , 8); call hinaxis2(hess1_, hgrid%ay_modl , 9); 
  call from_aux(hess1_, "n10", hgrid%az_modl%n); call from_aux(hess1_, "d10", hgrid%az_modl%d); call from_aux(hess1_, "o10", hgrid%az_modl%o) !cant read 2 digits!!! 
  call hinaxis2(hess2_, hgrid%ahx_offd, 1); call hinaxis2(hess2_, hgrid%ahy_offd, 2);  
  call hinaxis2(hess2_, hgrid%ax_offd , 3); call hinaxis2(hess2_, hgrid%ay_offd , 4); call hinaxis2(hess2_, hgrid%az_offd , 5); 
  call hinaxis2(hess2_, hgrid%ahx_modl, 6); call hinaxis2(hess2_, hgrid%ahy_modl, 7); 
  call hinaxis2(hess2_, hgrid%ax_modl , 8); call hinaxis2(hess2_, hgrid%ay_modl , 9); 
  call from_aux(hess2_, "n10", hgrid%az_modl%n); call from_aux(hess2_, "d10", hgrid%az_modl%d); call from_aux(hess2_, "o10", hgrid%az_modl%o) !cant read 2 digits!!! 

  mov%n=int(niter/jmov); mov%d=jmov; mov%o=0; 
  nrm%n=niter          ; nrm%d=1   ; nrm%o=1; 

  allocate(modl2(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
  allocate(data2(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
  allocate(modl2_mres(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
  allocate(data2_mres(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
  allocate(rmov2(hgrid%az_modl%n*hgrid%ax_modl%n*hgrid%ay_modl%n,nint(1.*niter/jmov)))
  allocate(mmov2(hgrid%az_modl%n*hgrid%ax_modl%n*hgrid%ay_modl%n,nint(1.*niter/jmov)))
  allocate(norm2(niter))

  allocate(modl1(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
  allocate(data1(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
  allocate(modl1_mres(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
  allocate(data1_mres(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
  allocate(rmov1(hgrid%az_modl%n*hgrid%ax_modl%n*hgrid%ay_modl%n,nint(1.*niter/jmov)))
  allocate(mmov1(hgrid%az_modl%n*hgrid%ax_modl%n*hgrid%ay_modl%n,nint(1.*niter/jmov)))
  allocate(norm1(niter))

  allocate(modl(2*hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
  allocate(data(2*hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
  allocate(modl_mres(2*hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
  allocate(data_mres(2*hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
  allocate(rmov(2*hgrid%az_modl%n*hgrid%ax_modl%n*hgrid%ay_modl%n,nint(1.*niter/jmov)))
  allocate(mmov(2*hgrid%az_modl%n*hgrid%ax_modl%n*hgrid%ay_modl%n,nint(1.*niter/jmov)))
  allocate(norm(2*niter))

  if (adj .or. inv) then
     if (inv) write(*,*)'inversion......'
     if (adj) write(*,*)'adjoint only...'
     call houaxis2(modl1_, hgrid%az_modl, 1);call houaxis2(modl1_, hgrid%ax_modl, 2); call houaxis2(modl1_, hgrid%ay_modl, 3)
     call houaxis2(modl2_, hgrid%az_modl, 1);call houaxis2(modl2_, hgrid%ax_modl, 2); call houaxis2(modl2_, hgrid%ay_modl, 3)
     call houaxis2(mmov1_, hgrid%az_modl, 1);call houaxis2(mmov1_, hgrid%ax_modl, 2); call houaxis2(mmov1_, mov, 3)
     call houaxis2(mmov2_, hgrid%az_modl, 1);call houaxis2(mmov2_, hgrid%ax_modl, 2); call houaxis2(mmov2_, mov, 3)
     call houaxis2(rmov1_, hgrid%az_modl, 1);call houaxis2(rmov1_, hgrid%ax_modl, 2); call houaxis2(rmov1_, mov, 3)
     call houaxis2(rmov2_, hgrid%az_modl, 1);call houaxis2(rmov2_, hgrid%ax_modl, 2); call houaxis2(rmov2_, mov, 3)
     call houaxis2(norm1_, nrm          , 1);call houaxis2(norm2_, nrm         , 1)
     call sep_read(data1, data1_) ; call sep_read(data2, data2_);
     data(1:size(data1))=data1+data2; data(size(data1)+1:size(data1)*2)=data2;
  else
     call houaxis2(data1_, hgrid%az_modl, 1);call houaxis2(data1_, hgrid%ax_modl, 2); call houaxis2(data1_, hgrid%ay_modl, 3)
     call houaxis2(data2_, hgrid%az_modl, 1);call houaxis2(data2_, hgrid%ax_modl, 2); call houaxis2(data2_, hgrid%ay_modl, 3)
     write(*,*)'modeling baseline......'
     call sep_read(modl1, modl1_)
     write(*,*)'modeling 4-D......'
     call sep_read(modl2, modl2_)
     modl(1:size(modl1))=modl1; modl(size(modl1)+1:size(modl1)*2)=modl2;
  end if

  if ((weight .and. mask) .or. precon)then
        write(*,*)'Initializing Precond Weighted Masked CG inversion..........................'
        stat = conv2_init(hgrid,hess1_,hess2_,ones,zmin,rsv_zmin,zmax,rsv_zmax,rsv_xmin,rsv_xmax,eps_base,eps_4d,niter,mask1_,mask2_, weight1_, weight2_, epsi1_, epsi2_ )
  elseif (weight .or. precon )then
        write(*,*)'Initializing Precond Weighed CG inversion..........................'
        stat = conv2_init(hgrid,hess1_,hess2_,ones,zmin,rsv_zmin,zmax,rsv_zmax,rsv_xmin,rsv_xmax,eps_base,eps_4d,niter,mask1_,mask2_, weight1_, weight2_, epsi1_, epsi2_ )
  elseif (mask .or. precon )then
        write(*,*)'Initializing Precond Masked CG inversion..........................'
        stat = conv2_init(hgrid, hess1_, hess2_, ones, zmin, rsv_zmin, zmax, rsv_zmax, rsv_xmin, rsv_xmax, eps_base, eps_4d, niter,mask1_, mask2_, epsi1_, epsi2_)
  elseif (precon )then
        write(*,*)'Initializing Precond CG inversion..........................'
        stat = conv2_init(hgrid, hess1_, hess2_, ones, zmin, rsv_zmin, zmax, rsv_zmax, rsv_xmin, rsv_xmax, eps_base, eps_4d ,niter,epsi1_, epsi2_)
  else
        write(*,*)'Initializing CG inversion..........................'
        stat = conv_init (hgrid, hess1_, hess2_, ones, zmin, rsv_zmin, zmax, rsv_zmax, rsv_xmin, rsv_xmax,  eps_base, eps_4d )
  endif

  modl_mres=modl; data_mres=data;
  ndim = hgrid%ax_offd%n*hgrid%ay_offd%n*hgrid%az_offd%n
  if(dot)then
        write(*,*)'dottest'
        allocate(dat1(2*hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n), &
                 mod1(2*hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
        allocate(dat2(2*hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n), &
                 mod2(2*hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
        call random_seed
        call random_number(dat1); call random_number(mod2);
        write(0,*)'adjoint...'
        stat = conv_oper(.true. , .false., mod1     , dat1*1000);  
        write(0,*)'forward...'
        stat = conv_oper(.false., .false., mod2*1000, dat2     );

        dot1=0; dot1=0.
        dot1(1) = dot_product(mod1,mod2); dot1(2) = dot_product(dat1,dat2)
        write(0,*)'--------------Dottest'
        write(0,*) dot1
        deallocate(dat1,dat2,mod1,mod2)

        call dot_test( oper=conv_oper, n_mod=size(modl), n_dat=size(data), dot1=dot1, dot2=dot2)
        STOP
  else
      if (lump)then
                stat = conv_oper_lump(adj , .false., modl, data)
      endif
      if (inv)then
                n = hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n
                if (mode==1)then
                        if(weight .and. mask)then
                                write(*,*)'Starting Default Weighted Masked CG inversion..........................'
                                call solver_cg(m=modl, d=data, Fop=conv_oper, Jop=conv_mask_oper, niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb)
                        elseif(weight .and. (.not. mask))then
                                write(*,*)'Starting Default Weighted CG inversion..........................'
                                call solver_cg(m=modl, d=data, Fop=conv_oper, Wop=conv_weight_oper, niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb)
                        elseif((.not. weight) .and. mask)then
                                write(*,*)'Starting Default Masked CG inversion..........................'
                                call solver_cg(m=modl, d=data, Fop=conv_oper, Jop=conv_weight_oper, niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb)
                        else
                                write(*,*)'Starting Default CG inversion no weight no mask....................'
                                call solver_cg(m=modl, d=data, Fop=conv_oper, niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb)
                        endif

                elseif(mode==2)then
                        write(*,*)'Starting 2nd CG inversion..............................'
        !                call solver_cg2(m=modl, d=data, Fop=conv_oper, niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb)
                elseif(mode==3)then
                        write(*,*)'Starting Bi CG inversion...............................'
        !                call solver_bicg(m=modl, d=data, Fop=conv_oper, niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb)
                elseif(mode==4)then
                        write(*,*)'Starting Precond CG inversion...........................'
                        call seperr('Not working yet...')
                elseif(mode==5)then
                        write(*,*)'Starting GMRES..............................Not working fine yet'
        !               call MINRES( n=n, Aprod=hess_convolve3, Msolve=hess_precond, b=data_mres, shift=0.0_dp, checkA=.false., precon=.false., &
        !                                x=mod!l_mres, itnlim=niter, nout=6, rtol= 1.0e-12_dp ,                       &
        !                                istop=istop, itn=itn, Anorm=Anorm, Acond=Acond, rnorm=rnorm, Arnorm=Arnorm, ynorm=ynorm )
        !                                data=data_mres; modl=modl_mres
                elseif(mode==6)then
                        write(*,*)'Starting Precond. CG inversion..............................'
                        call solver_pre_cg(m=modl, d=data, Fop=conv_oper, Sop=conv_precon_oper , Jop=conv_mask_oper, niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb, tol=rtol)
        !                                data=data_mres; modl=modl_mres
                elseif(mode==7)then
                        !call solver_smp(m=modl, d=data, Fop=conv_oper,  stepper=cgstep, niter=niter, rmov=rmov, mmov=mmov, verb=verb)
                        call solver_reg_me(m=modl, d=data, Fop=conv_oper, Aop=conv_grad_oper2, Wop=conv_weight_oper, stepper=cg_step, niter=niter, rmov=rmov, mmov=mmov, verb=verb, eps=eps, nAop=size(modl))
                        !call solver_precond1(m=modl, d=data, Fop=conv_oper, Pop=conv_precon_oper, niter=niter, r_mov=rmov, m_mov=mmov, r_nor=norm,beta_max=1.)
                elseif(mode==8)then
                        write(*,*)'Starting Solver cg square reg..............................'
                        call solver_cg_square(m=modl, d=data, Fop=conv_oper, Aop=conv_grad_oper2, niter=niter, jmov=jmov, rmov=rmov, mmov=mmov, norm=norm, verb=verb, eps=eps, tol=rtol)
                elseif(mode==9)then
                        write(*,*)'Starting Yaxuns solver..............................'
                        if(noreg) then
                            write(*,*)'No reg..............................'
                            call base_solver_cglpd_smp(m=modl, d=data, Fop=conv_oper, search=.true.,  niter=niter, rmov=rmov, mmov=mmov)
                           ! call base_solver_cglpd_reg(m=modl, d=data, Fop=conv_oper, Aop=conv_grad_oper2, eps=(0.*modl)+1., search=.true., Wop=conv_weight_oper, niter=niter, rmov=rmov, mmov=mmov)
                        else
                            write(*,*)'Reg..............................'
                            call base_solver_cglpd_reg(m=modl, d=data, Fop=conv_oper, Aop=conv_grad_oper2, eps=(0.*modl)+1., search=.true., Wop=conv_weight_oper, niter=niter, rmov=rmov, mmov=mmov)
                        endif
                 else
                    call seperr('You have not selected an inversion scheme...')
                endif

      elseif(adj)then
                stat = conv_oper(adj , .false., modl, data)
      else
                stat = conv_oper(adj , .false., modl, data)
      endif
      if (adj .or. inv) then
             modl1=modl(1:size(modl1)); modl2=modl(size(modl1)+1:size(modl));
             call sep_write(modl1, modl1_);  call sep_write(modl2, modl2_)
             if (inv)then
                     mmov1=mmov(1:size(mmov1,1),:); mmov2=mmov(size(mmov1,1)+1:size(mmov,1),:);
                     rmov1=rmov(1:size(rmov1,1),:); rmov2=rmov(size(rmov1,1)+1:size(rmov,1),:);
                     norm1=norm; norm2=norm
                     call sep_write(mmov1, mmov1_); call sep_write(mmov2, mmov2_)
                     call sep_write(rmov1, rmov1_); call sep_write(rmov2, rmov2_)
                     call sep_write(norm1, norm1_); call sep_write(norm2, norm2_)
             endif
      else
             data1=data(1:size(modl1)); data2=data(size(modl1)+1:size(modl1)*2);
             call sep_write(data1, data1_); call sep_write(data2, data2_)
      endif
  endif

  stat = conv_clos()

  deallocate(modl , modl1, modl2 );
  deallocate(data , data1, data2 ); 
  deallocate(rmov , rmov1, rmov2 );
  deallocate(mmov , mmov1, mmov2 ); 
  deallocate(norm , norm1, norm2 );

end program
