module hessian_convolve_adjnull
 use hessian_convolve_params
 
 implicit none

 contains 
!#####################################################  
 
  subroutine hessian_conv_adjnull(adj,modl,data)
  logical            :: adj
  real, dimension(:) :: modl, data

  if (adj )then
        modl=0.
        if (nsurv > 5) then
            modl1=0; modl2=0; modl3=0; modl4=0; modl5=0 ; modl6=0 
            data1=data(0*nmod+1:1*nmod);data2=data(1*nmod+1:2*nmod);data3=data(2*nmod+1:3*nmod);data4=data(3*nmod+1:4*nmod);data5=data(4*nmod+1:5*nmod);data6=data(5*nmod+1:6*nmod)
        elseif (nsurv > 4) then
            modl1=0; modl2=0; modl3=0; modl4=0; modl5=0 ; 
            data1=data(0*nmod+1:1*nmod);data2=data(1*nmod+1:2*nmod);data3=data(2*nmod+1:3*nmod);data4=data(3*nmod+1:4*nmod);data5=data(4*nmod+1:5*nmod);
        elseif (nsurv > 3) then
            modl1=0; modl2=0; modl3=0; modl4=0; 
            data1=data(0*nmod+1:1*nmod);data2=data(1*nmod+1:2*nmod);data3=data(2*nmod+1:3*nmod);data4=data(3*nmod+1:4*nmod);
        elseif (nsurv > 2) then
            modl1=0; modl2=0; modl3=0; 
            data1=data(0*nmod+1:1*nmod);data2=data(1*nmod+1:2*nmod);data3=data(2*nmod+1:3*nmod);
        elseif (nsurv > 1) then
            modl1=0; modl2=0; 
            data1=data(0*nmod+1:1*nmod);data2=data(1*nmod+1:2*nmod);
        elseif (nsurv > 0) then
            modl1=0; 
            data1=data(0*nmod+1:1*nmod);
            return
        endif
  else
        data=0.
        if (nsurv > 5) then
            data1=0; data2=0; data3=0; data4=0; data5=0 ; data6=0 
            modl1=modl(0*nmod+1:1*nmod);modl2=modl(1*nmod+1:2*nmod);modl3=modl(2*nmod+1:3*nmod);modl4=modl(3*nmod+1:4*nmod);modl5=modl(4*nmod+1:5*nmod);modl6=modl(5*nmod+1:6*nmod)
        elseif (nsurv > 4) then
            data1=0; data2=0; data3=0; data4=0; data5=0 ; 
            modl1=modl(0*nmod+1:1*nmod);modl2=modl(1*nmod+1:2*nmod);modl3=modl(2*nmod+1:3*nmod);modl4=modl(3*nmod+1:4*nmod);modl5=modl(4*nmod+1:5*nmod);
        elseif (nsurv > 3) then
            data1=0; data2=0; data3=0; data4=0; 
            modl1=modl(0*nmod+1:1*nmod);modl2=modl(1*nmod+1:2*nmod);modl3=modl(2*nmod+1:3*nmod);modl4=modl(3*nmod+1:4*nmod);
        elseif (nsurv > 2) then
            data1=0; data2=0; data3=0; 
            modl1=modl(0*nmod+1:1*nmod);modl2=modl(1*nmod+1:2*nmod);modl3=modl(2*nmod+1:3*nmod);
        elseif (nsurv > 1) then
            data1=0; data2=0; 
            modl1=modl(0*nmod+1:1*nmod);modl2=modl(1*nmod+1:2*nmod);
        elseif (nsurv > 0) then
            data1=0; 
            modl1=modl(0*nmod+1:1*nmod);
        endif
  endif
 end subroutine
  
!#####################################################  
  subroutine hessian_conv_adjnull_link(modl,data)
  logical            :: adj
  real, dimension(:) :: modl, data
  if (method==1)then
        if (nsurv > 5) then
			modl1=modl1
			modl2=modl2+modl1
			modl3=modl3+modl2
			modl4=modl4+modl3
			modl5=modl5+modl4
			modl6=modl6+modl5
        elseif (nsurv > 4) then
			modl1=modl1
			modl2=modl2+modl1
			modl3=modl3+modl2
			modl4=modl4+modl3
			modl5=modl5+modl4
        elseif (nsurv > 3) then
			modl1=modl1
			modl2=modl2+modl1
			modl3=modl3+modl2
			modl4=modl4+modl3
        elseif (nsurv > 2) then
			modl1=modl1
			modl2=modl2+modl1
			modl3=modl3+modl2
        elseif (nsurv > 1) then
			modl1=modl1
			modl2=modl2+modl1
        elseif (nsurv > 0) then
			modl1=modl1
        endif
  else	
        if (nsurv > 5) then
			modl1=modl(0*nmod+1:1*nmod);
			modl2=modl(1*nmod+1:2*nmod)-modl(0*nmod+1:1*nmod)
			modl3=modl(2*nmod+1:3*nmod)-modl(1*nmod+1:2*nmod)
			modl4=modl(3*nmod+1:4*nmod)-modl(2*nmod+1:3*nmod)
			modl5=modl(4*nmod+1:5*nmod)-modl(3*nmod+1:4*nmod)
			modl6=modl(5*nmod+1:6*nmod)-modl(4*nmod+1:5*nmod)
        elseif (nsurv > 4) then
			modl1=modl(0*nmod+1:1*nmod);
			modl2=modl(1*nmod+1:2*nmod)-modl(0*nmod+1:1*nmod)
			modl3=modl(2*nmod+1:3*nmod)-modl(1*nmod+1:2*nmod)
			modl4=modl(3*nmod+1:4*nmod)-modl(2*nmod+1:3*nmod)
			modl5=modl(4*nmod+1:5*nmod)-modl(3*nmod+1:4*nmod)
        elseif (nsurv > 3) then
			modl1=modl(0*nmod+1:1*nmod);
			modl2=modl(1*nmod+1:2*nmod)-modl(0*nmod+1:1*nmod)
			modl3=modl(2*nmod+1:3*nmod)-modl(1*nmod+1:2*nmod)
			modl4=modl(3*nmod+1:4*nmod)-modl(2*nmod+1:3*nmod)
        elseif (nsurv > 2) then
			modl1=modl(0*nmod+1:1*nmod);
			modl2=modl(1*nmod+1:2*nmod)-modl(0*nmod+1:1*nmod)
			modl3=modl(2*nmod+1:3*nmod)-modl(1*nmod+1:2*nmod)
        elseif (nsurv > 1) then
			modl1=modl(0*nmod+1:1*nmod);
			modl2=modl(1*nmod+1:2*nmod)-modl(0*nmod+1:1*nmod)
        elseif (nsurv > 0) then
			modl1=modl(0*nmod+1:1*nmod);
        endif
endif 

end subroutine

  end module
