module hessian_convolve_array
 use hessian_convolve_params
implicit none

 contains 
!#####################################################
  subroutine hessian_conv_array_alloc()
        if (nsurv > 0) call array_alloc(modl1, data1, hesp1, HE_1, he1, hes1, hess1, epsi1, lmbd1, mask1, wght1, pick1, modl1_mres, data1_mres, rmov1, mmov1, norm1, 1    , 1)
        if (nsurv > 1) call array_alloc(modl2, data2, hesp2, HE_2, he2, hes2, hess2, epsi2, lmbd2, mask2, wght2, pick2, modl2_mres, data2_mres, rmov2, mmov2, norm2, 1    , 2)
        if (nsurv > 2) call array_alloc(modl3, data3, hesp3, HE_3, he3, hes3, hess3, epsi3, lmbd3, mask3, wght3, pick3, modl3_mres, data3_mres, rmov3, mmov3, norm3, 1    , 3)
        if (nsurv > 3) call array_alloc(modl4, data4, hesp4, HE_4, he4, hes4, hess4, epsi4, lmbd4, mask4, wght4, pick4, modl4_mres, data4_mres, rmov4, mmov4, norm4, 1    , 4) 
        if (nsurv > 4) call array_alloc(modl5, data5, hesp5, HE_5, he5, hes5, hess5, epsi5, lmbd5, mask5, wght5, pick5, modl5_mres, data5_mres, rmov5, mmov5, norm5, 1    , 5)
        if (nsurv > 5) call array_alloc(modl6, data6, hesp6, HE_6, he6, hes6, hess6, epsi6, lmbd6, mask6, wght6, pick6, modl6_mres, data6_mres, rmov6, mmov6, norm6, 1    , 6)
        if (nsurv > 0) then
                       call array_alloc(modl , data , hesp, HE_, he, hes, hess , epsi , lmbd, mask,  wght,  pick, modl_mres , data_mres , rmov , mmov , norm , nsurv, nsurv+1)
        else
                      call seperr('You have zero surveys!!!!!!! Think deep.....OK...What exactly are you trying to do???')
                      
        endif

        if(exist_file(epsA_))allocate (epsA(nsurv*nmod));memory=memory+4*size(epsA)
        if(exist_file(epsB_))allocate (epsB(nsurv*nmod));memory=memory+4*size(epsB)
        if(exist_file(epsC_))allocate (epsC(nsurv*nmod));memory=memory+4*size(epsC)
        if(exist_file(epsD_))allocate (epsD(nsurv*nmod));memory=memory+4*size(epsD)

        allocate (err(niter))
        memory = memory / 1024 / 1024
        write(0,*)"Minimum memory allocated per node:", memory      , "Mb"
        write(0,*)"  Total memory needed (all nodes):", memory*nodes, "Mb"

  end subroutine
!#####################################################  
  subroutine               array_alloc(modl_n, data_n, hesp_n, HE__n, he_n, hes_n, hess_n, epsi_n, lmbd_n, mask_n, wght_n, pick_n, modl_n_mres, data_n_mres, rmov_n, mmov_n, norm_n, surv_num, i)
        real,     dimension(:)          , allocatable      :: modl_n, data_n, hesp_n, epsi_n, lmbd_n, mask_n, wght_n, pick_n, norm_n 
        real(dp), dimension(:)          , allocatable      :: modl_n_mres  
        real(dp), dimension(:)          , allocatable      :: data_n_mres 
        real,     dimension(:,:)        , allocatable      :: rmov_n 
        real,     dimension(:,:)        , allocatable      :: mmov_n 
        real,     dimension(:,:,:)      , allocatable      :: hess_n  
        real,     dimension(:,:,:,:,:)  , allocatable      :: hes_n  
        real,     dimension(:,:,:,:,:,:), allocatable      :: he_n  
        real,     dimension(:,:,:,:,:,:), allocatable      :: HE__n  
        integer                                            :: surv_num, i
        if(mode/=5)then
                        allocate(modl_n(surv_num*nmod)); memory=memory+4*size(modl_n)
                        allocate(data_n(surv_num*nmod)); memory=memory+4*size(data_n)
                        allocate(epsi_n(surv_num*nmod)); memory=memory+4*size(epsi_n)
                        allocate(mask_n(surv_num*nmod)); memory=memory+4*size(mask_n);mask_n=1. 
                        !allocate(lmbd_n(surv_num*nmod)); memory=memory+4*size(lmbd_n)
                        !allocate(modl_n_mres(surv_num*nmod)); memory=memory+4*size(modl_n_mres)
                        !allocate(data_n_mres(surv_num*nmod)); memory=memory+4*size(data_n_mres)
                        !allocate(rmov_n(surv_num*nmod,nint(1.*niter/jmov))); memory=memory+4*size(rmov_n)
                        !allocate(mmov_n(surv_num*nmod,nint(1.*niter/jmov))); memory=memory+4*size(mmov_n)
                        if(weight ) allocate(wght_n(surv_num*nmod)); memory=memory+4*size(wght_n);wght_n=1. 
                        if(precond) allocate(hesp_n(surv_num*nmod)); memory=memory+4*size(hesp_n)
                        if(lpick  ) allocate(pick_n(surv_num*nmod)); memory=memory+4*size(pick_n)
        endif

        allocate(norm_n(surv_num*niter)); 
                if(is2d)then
                        if(small ) then
                                        if(method==1)then
                                           allocate(HE__n(h3%n,h4%n,h5%n,h8%n,h9%n,h10%n)); memory=memory+4*size(HE__n)
                                        else
                                           allocate( he_n(h3%n,h4%n,h5%n,h8%n,h9%n,h10%n)); memory=memory+4*size(he_n)
                                        endif
                        else
                            allocate(hes_n(h3%n,h4%n,h5%n,h8%n,h9%n)); memory=memory+4*size(hes_n)
                        endif
                else
                        if(small ) then
                            allocate(hes_n(h3%n,h4%n,h5%n,h8%n,h9%n)); memory=memory+4*size(hes_n); deallocate(hes_n)
                        else
                            !allocate(hess_n(h3%n,h4%n,h5%n)); memory=memory+4*size(hess_n)
                        endif
                endif


        if(i==nsurv+1)then
                write(0,*)'Surv: [','ALL', '] Memory:',memory/1024/1024
                
        else
                write(0,*)'Surv: [',i, '] Memory:',memory/1024/1024
        endif
  end subroutine
!#####################################################  
  subroutine hessian_conv_array_clos()
        if (nsurv > 0) call array_clos(modl1, data1, hesp1, HE_1, he1, hes1, hess1, epsi1, lmbd1, mask1, wght1, pick1, modl1_mres, data1_mres, rmov1, mmov1, norm1, 1    )
        if (nsurv > 1) call array_clos(modl2, data2, hesp2, HE_2, he2, hes2, hess2, epsi2, lmbd2, mask2, wght2, pick2, modl2_mres, data2_mres, rmov2, mmov2, norm2, 1    )
        if (nsurv > 2) call array_clos(modl3, data3, hesp3, HE_3, he3, hes3, hess3, epsi3, lmbd3, mask3, wght3, pick3, modl3_mres, data3_mres, rmov3, mmov3, norm3, 1    )
        if (nsurv > 3) call array_clos(modl4, data4, hesp4, HE_4, he4, hes4, hess4, epsi4, lmbd4, mask4, wght4, pick4, modl4_mres, data4_mres, rmov4, mmov4, norm4, 1    )
        if (nsurv > 4) call array_clos(modl5, data5, hesp5, HE_5, he5, hes5, hess5, epsi5, lmbd5, mask5, wght5, pick5, modl5_mres, data5_mres, rmov5, mmov5, norm5, 1    )
        if (nsurv > 5) call array_clos(modl6, data6, hesp6, HE_6, he6, hes6, hess6, epsi6, lmbd6, mask6, wght6, pick6, modl6_mres, data6_mres, rmov6, mmov6, norm6, 1    )
        if(allocated(modl)) deallocate(modl)
        if(allocated(data)) deallocate(data)
        if(allocated(epsi)) deallocate(epsi)
        if(allocated(lmbd)) deallocate(lmbd)
        if(allocated(mask)) deallocate(mask)
        if(allocated(wght)) deallocate(wght)
        if(allocated(pick)) deallocate(pick)
        if(allocated(modl_mres)) deallocate(modl_mres)
        if(allocated(data_mres)) deallocate(data_mres)
        if(allocated(rmov)) deallocate(rmov)
        if(allocated(mmov)) deallocate(mmov)
        if(allocated(norm)) deallocate(norm)
        if(allocated(hess)) deallocate(hess)
        if(allocated(hes))  deallocate(hes)
        if(allocated(he ))  deallocate(he)
        if(allocated(HE_))  deallocate(HE_)
        if(allocated(hesp)) deallocate(hesp)
        if(allocated(epsA)) deallocate(epsA)
        if(allocated(epsB)) deallocate(epsB)
        if(allocated(epsC)) deallocate(epsC)
        if(allocated(epsD)) deallocate(epsD)
        if(allocated(err)) deallocate(err)
  end subroutine
!#####################################################  
  subroutine               array_clos(modl_n, data_n, hesp_n, HE__n, he_n, hes_n, hess_n, epsi_n, lmbd_n, mask_n, wght_n, pick_n, modl_n_mres, data_n_mres, rmov_n, mmov_n, norm_n, surv_num)
        real,     dimension(:)          , allocatable          :: modl_n, data_n, epsi_n, lmbd_n, mask_n, wght_n, pick_n, norm_n, hesp_n 
        real(dp), dimension(:)          , allocatable    :: modl_n_mres  
        real(dp), dimension(:)          , allocatable    :: data_n_mres 
        real,     dimension(:,:)        , allocatable    :: rmov_n 
        real,     dimension(:,:)        , allocatable    :: mmov_n 
        real,     dimension(:,:,:)      , allocatable    :: hess_n  
        real,     dimension(:,:,:,:,:)  , allocatable    :: hes_n  
        real,     dimension(:,:,:,:,:,:), allocatable    :: he_n  
        real,     dimension(:,:,:,:,:,:), allocatable    :: HE__n  
        integer                                          :: surv_num
        if(allocated(modl_n)) deallocate(modl_n)
        if(allocated(data_n)) deallocate(data_n)
        if(allocated(epsi_n)) deallocate(epsi_n)
        if(allocated(lmbd_n)) deallocate(lmbd_n)
        if(allocated(mask_n)) deallocate(mask_n)
        if(allocated(wght_n)) deallocate(wght_n)
        if(allocated(pick_n)) deallocate(pick_n)
        if(allocated(modl_n_mres)) deallocate(modl_n_mres)
        if(allocated(data_n_mres)) deallocate(data_n_mres)
        if(allocated(rmov_n)) deallocate(rmov_n)
        if(allocated(mmov_n)) deallocate(mmov_n)
        if(allocated(norm_n)) deallocate(norm_n)
        if(allocated(hess_n)) deallocate(hess_n)
        if(allocated(hes_n))  deallocate(hes_n)
        if(allocated(he_n))   deallocate(he_n)
        if(allocated(HE__n))  deallocate(HE__n)
        if(allocated(hesp_n)) deallocate(hesp_n)
  end subroutine
  end module
