module hessian_convolve_axis
 use hessian_convolve_params
 implicit none

 contains
  !#########################################
  subroutine hessian_conv_axis_init()
        if (nsurv > 0)then
                call hinaxis2(hess1_, hgrid%ahx_offd, 1); h1=hgrid%ahx_offd 
                call hinaxis2(hess1_, hgrid%ahy_offd, 2); h2=hgrid%ahy_offd 
                call hinaxis2(hess1_, hgrid%ax_offd , 3); h3=hgrid%ax_offd
                call hinaxis2(hess1_, hgrid%ay_offd , 4); h4=hgrid%ay_offd 
                call hinaxis2(hess1_, hgrid%az_offd , 5); h5=hgrid%az_offd 
                call hinaxis2(hess1_, hgrid%ahx_modl, 6); h6=hgrid%ahx_modl
                call hinaxis2(hess1_, hgrid%ahy_modl, 7); h7=hgrid%ahy_modl
                call hinaxis2(hess1_, hgrid%ax_modl , 8); h8=hgrid%ax_modl 
                call hinaxis2(hess1_, hgrid%ay_modl , 9); h9=hgrid%ay_modl ; if(hgrid%ay_modl%n==1)is2d=T
                !cant read 2 digits yet!!! 
                call from_aux(hess1_, "n10", hgrid%az_modl%n);   
                call from_aux(hess1_, "d10", hgrid%az_modl%d); 
                call from_aux(hess1_, "o10", hgrid%az_modl%o); h10=hgrid%az_modl
                nmod=h6%n*h7%n*h8%n*h9%n*h10%n
                noff=h1%n*h2%n*h3%n*h4%n*h5%n
        endif

        write(0,*)'Surv: {',1,'} Hessian summary';
        write(0,*)h1%n,h1%d,h1%o; write(0,*)h2%n,h2%d,h2%o; write(0,*)h3%n,h3%d,h3%o; write(0,*)h4%n,h4%d,h4%o; write(0,*)h5%n,h5%d,h5%o
        write(0,*)h6%n,h6%d,h6%o; write(0,*)h7%n,h7%d,h7%o; write(0,*)h8%n,h8%d,h8%o; write(0,*)h9%n,h9%d,h9%o; write(0,*)h10%n,h10%d,h10%o

        if (inv .or. adj)then
                call hinaxis2(data1_, hz, 3); if (h10%n/=hz%n.or.h10%d/=hz%d.or.h10%o/=hz%o) then; write(0,*)'Data 1-(hz): ',hz; write(0,*)'Hessian:', h10;call seperr('hz  mismatch') ;endif
                call hinaxis2(data1_, hy, 2); if (h9%n /=hy%n.or.h9%d /=hy%d.or. h9%o/=hy%o) then; write(0,*)'Data 1-(hy): ',hx; write(0,*)'Hessian:', h9; call seperr('hy  mismatch') ;endif
                call hinaxis2(data1_, hx, 1); if (h8%n /=hx%n.or.h8%d /=hx%d.or. h8%o/=hx%o) then; write(0,*)'Data 1-(hx): ',hy; write(0,*)'Hessian:', h8; call seperr('hx  mismatch') ;endif
        else
                call hinaxis2(modl1_, hz, 3); if (h10%n/=hz%n.or.h10%d/=hz%d.or.h10%o/=hz%o) then; write(0,*)'Modl 1-(hz): ',hz; write(0,*)'Hessian:', h10;call seperr('hz  mismatch') ;endif
                call hinaxis2(modl1_, hy, 2); if (h9%n /=hy%n.or.h9%d /=hy%d.or. h9%o/=hy%o) then; write(0,*)'Modl 1-(hy): ',hx; write(0,*)'Hessian:', h9; call seperr('hy  mismatch') ;endif
                call hinaxis2(modl1_, hx, 1); if (h8%n /=hx%n.or.h8%d /=hx%d.or. h8%o/=hx%o) then; write(0,*)'Modl 1-(hx): ',hy; write(0,*)'Hessian:', h8; call seperr('hx  mismatch') ;endif
        endif

                if (nsurv > 1)then; 
                    call conv_axis_init(hess2_,2); if (adj .or. inv)then; call conv_axis_chck(data2_,2); else; call conv_axis_chck(modl2_,2); endif
                endif
                if (nsurv > 2)then; 
                    call conv_axis_init(hess3_,3); if (adj .or. inv)then; call conv_axis_chck(data3_,3); else; call conv_axis_chck(modl3_,3); endif
                endif
                if (nsurv > 3)then; 
                    call conv_axis_init(hess4_,4); if (adj .or. inv)then; call conv_axis_chck(data4_,4); else; call conv_axis_chck(modl4_,4); endif
                endif
                if (nsurv > 4)then; 
                    call conv_axis_init(hess5_,5); if (adj .or. inv)then; call conv_axis_chck(data5_,5); else; call conv_axis_chck(modl5_,5); endif
                endif
                if (nsurv > 5)then;  
                    call conv_axis_init(hess6_,6); if (adj .or. inv)then; call conv_axis_chck(data6_,6); else; call conv_axis_chck(modl6_,6); endif
                endif
                nmod=h8%n*h9%n*h10%n

        !movie and norm init
          mov1%n=nsurv; mov%d=1; mov%o=0; 
          mov%n=int(niter/jmov); mov%d=jmov; mov%o=0; 
          nrm%n=niter          ; nrm%d=1   ; nrm%o=1; 

          if (rsv_xmin < 0. .and. hgrid%ax_modl%o<0. )then
              index_rsv_xmin=max(1.              ,1.5+abs(abs(rsv_xmin)-abs(hgrid%ax_modl%o))/hgrid%ax_modl%d)
          else
              index_rsv_xmin=max(1.              ,1.5+abs(    rsv_xmin -    hgrid%ax_modl%o) /hgrid%ax_modl%d)
          endif
          if (xmin < 0. .and. hgrid%ax_modl%o<0. )then
                  index_xmin=max(1.              ,1.5+abs(abs(    xmin)-abs(hgrid%ax_modl%o))/hgrid%ax_modl%d)
          else
                  index_xmin=max(1.              ,1.5+abs(        xmin -    hgrid%ax_modl%o) /hgrid%ax_modl%d)
          endif

          zmin    =max(zmin,hgrid%az_modl%o);
          rsv_zmin=max(rsv_zmin,hgrid%az_modl%o);
          index_rsv_xmax=min(hgrid%ax_modl%n,int(1.5+abs(rsv_xmax-hgrid%ax_modl%o)/hgrid%ax_modl%d))
          index_rsv_zmin=max(1              ,int(1.5+abs(rsv_zmin-hgrid%az_modl%o)/hgrid%az_modl%d))
          index_rsv_zmax=min(hgrid%az_modl%n,int(1.5+abs(rsv_zmax-hgrid%az_modl%o)/hgrid%az_modl%d))
          index_xmax    =min(hgrid%ax_modl%n,int(1.5+abs(    xmax-hgrid%ax_modl%o)/hgrid%ax_modl%d))
          index_zmin    =max(1              ,int(1.5+abs(    zmin-hgrid%az_modl%o)/hgrid%az_modl%d))
          index_zmax    =min(hgrid%az_modl%n,int(1.5+abs(    zmax-hgrid%az_modl%o)/hgrid%az_modl%d))
  end subroutine
!#####################################################
  subroutine conv_axis_chck(chck_n,n)
  integer                           :: n
  character(len=256)                :: chck_n
      call hinaxis2(chck_n, gx, 1); 
      call hinaxis2(chck_n, gy, 2); 
      call hinaxis2(chck_n, gz, 3); 

        if (gz%n/=hz%n) then; write(0,*)'Modl:   ', gz%n; write(0,*)'Hessian:', hz%n;call seperr('hz%n  mismatch') ;endif
        if (gz%d/=hz%d) then; write(0,*)'Modl:   ', gz%d; write(0,*)'Hessian:', hz%d;call seperr('hz%d  mismatch') ;endif
        if (gz%o/=hz%o) then; write(0,*)'Modl:   ', gz%o; write(0,*)'Hessian:', hz%o;call seperr('hz%o  mismatch') ;endif
        if (gy%n/=hy%n) then; write(0,*)'Modl:   ', gy%n; write(0,*)'Hessian:', hx%n ;call seperr('hy%n  mismatch') ;endif
        if (gy%d/=hy%d) then; write(0,*)'Modl:   ', gy%d; write(0,*)'Hessian:', hx%d ;call seperr('hy%d  mismatch') ;endif
        if (gy%o/=hy%o) then; write(0,*)'Modl:   ', gy%o; write(0,*)'Hessian:', hx%o ;call seperr('hy%o  mismatch') ;endif
        if (gx%n/=hx%n) then; write(0,*)'Modl:   ', gx%n; write(0,*)'Hessian:', hy%n ;call seperr('hx%n  mismatch') ;endif
        if (gx%d/=hx%d) then; write(0,*)'Modl:   ', gx%d; write(0,*)'Hessian:', hy%d ;call seperr('hx%d  mismatch') ;endif
        if (gx%o/=hx%o) then; write(0,*)'Modl:   ', gx%o; write(0,*)'Hessian:', hy%o ;call seperr('hx%o  mismatch') ;endif
      write(0,*)'Modl: {',n,'} Hessian summary good'
  end subroutine
!#####################################################
  subroutine conv_axis_init(hess_n,n)
  integer                           :: n
  character(len=256)                :: hess_n
      call hinaxis2(hess_n, hgrid%ahx_offd, 1); 
      call hinaxis2(hess_n, hgrid%ahy_offd, 2); 
      call hinaxis2(hess_n, hgrid%ax_offd , 3); 
      call hinaxis2(hess_n, hgrid%ay_offd , 4); 
      call hinaxis2(hess_n, hgrid%az_offd , 5); 
      call hinaxis2(hess_n, hgrid%ahx_modl, 6); 
      call hinaxis2(hess_n, hgrid%ahy_modl, 7); 
      call hinaxis2(hess_n, hgrid%ax_modl , 8); 
      call hinaxis2(hess_n, hgrid%ay_modl , 9); 
      !cant read 2 digits yet!!! 
      call from_aux(hess_n, "n10", hgrid%az_modl%n);   
      call from_aux(hess_n, "d10", hgrid%az_modl%d); 
      call from_aux(hess_n, "o10", hgrid%az_modl%o); 
        !write(0,*)hgrid%ahx_offd; 
      if (h1%n/=hgrid%ahx_offd%n.or.h1%d/= hgrid%ahx_offd%d.or.h1%o/= hgrid%ahx_offd%o) then; write(0,*)'Hess ', n, ':', 'h1  mismatch.'; write(0,*)'[',hgrid%ahx_offd,']'; write(0,*)'[',h1,']' ; call seperr('h1  mismatch') ;endif
        !write(0,*)hgrid%ahy_offd;
      if (h2%n/=hgrid%ahy_offd%n.or.h2%d/= hgrid%ahy_offd%d.or.h2%o/= hgrid%ahy_offd%o) then; write(0,*)'Hess ', n, ':', 'h2  mismatch.'; write(0,*)'[',hgrid%ahy_offd,']'; write(0,*)'[',h2,']' ; call seperr('h2  mismatch') ;endif 
        !write(0,*)hgrid%ax_offd ;
      if (h3%n/=hgrid%ax_offd%n .or.h3%d/= hgrid%ax_offd%d .or.h3%o/= hgrid%ax_offd%o ) then; write(0,*)'Hess ', n, ':', 'h3  mismatch.'; write(0,*)'[',hgrid%ax_offd,' ]'; write(0,*)'[',h3,']' ; call seperr('h3  mismatch') ;endif 
        !write(0,*)hgrid%ay_offd ;
      if (h4%n/=hgrid%ay_offd%n .or.h4%d/= hgrid%ay_offd%d .or.h4%o/= hgrid%ay_offd%o ) then; write(0,*)'Hess ', n, ':', 'h4  mismatch.'; write(0,*)'[',hgrid%ay_offd,' ]'; write(0,*)'[',h4,']' ; call seperr('h4  mismatch') ;endif
        !write(0,*)hgrid%az_offd ;
      if (h5%n/=hgrid%az_offd%n .or.h5%d/= hgrid%az_offd%d .or.h5%o/= hgrid%az_offd%o ) then; write(0,*)'Hess ', n, ':', 'h5  mismatch.'; write(0,*)'[',hgrid%az_offd,' ]'; write(0,*)'[',h5,']' ; call seperr('h5  mismatch') ;endif
        !write(0,*)hgrid%ahx_modl;
      if (h6%n/=hgrid%ahx_modl%n.or.h6%d/= hgrid%ahx_modl%d.or.h6%o/= hgrid%ahx_modl%o) then; write(0,*)'Hess ', n, ':', 'h6  mismatch.'; write(0,*)'[',hgrid%ahx_modl,']'; write(0,*)'[',h6,']' ; call seperr('h6  mismatch') ;endif
        !write(0,*)hgrid%ahy_modl;
      if (h7%n/=hgrid%ahy_modl%n.or.h7%d/= hgrid%ahy_modl%d.or.h7%o/= hgrid%ahy_modl%o) then; write(0,*)'Hess ', n, ':', 'h7  mismatch.'; write(0,*)'[',hgrid%ahy_modl,']'; write(0,*)'[',h7,']' ; call seperr('h7  mismatch') ;endif
        !write(0,*)hgrid%ax_modl ;
      if (h8%n/=hgrid%ax_modl%n .or.h8%d/= hgrid%ax_modl%d .or.h8%o/= hgrid%ax_modl%o ) then; write(0,*)'Hess ', n, ':', 'h8  mismatch.'; write(0,*)'[',hgrid%ax_modl,' ]'; write(0,*)'[',h8,']' ; call seperr('h8  mismatch') ;endif
        !write(0,*)hgrid%ay_modl ;
      if (h9%n/=hgrid%ay_modl%n .or.h9%d/= hgrid%ay_modl%d .or.h9%o/= hgrid%ay_modl%o ) then; write(0,*)'Hess ', n, ':', 'h9  mismatch.'; write(0,*)'[',hgrid%ay_modl,' ]'; write(0,*)'[',h9,']' ; call seperr('h9  mismatch') ;endif
        !write(0,*)hgrid%az_modl ;
      if (h10%n/=hgrid%az_modl%n.or.h10%d/=hgrid%az_offd%d .or.h10%o/=hgrid%az_modl%o ) then; write(0,*)'Hess ', n, ':', 'h10 mismatch.'; write(0,*)'[',hgrid%az_modl,' ]'; write(0,*)'[',h10,']' ; call seperr('h10 mismatch') ;endif
      write(0,*)'Surv: {',n,'} Hessian summary good'

  end subroutine
  end module
