module hessian_convolve_init
 use hessian_convolve_param
 implicit none

 contains
  !#########################################
 subroutine hessian_conv_aux_init()
        write(0,*)'Initializing aux. inputs for [', nsurv, '] surveys'
        if (nsurv > 0)call conv_aux_init(modl1_, data1_, hesp1_, hess1_, epsi1_, lmbd1_, mask1_, wght1_, pick1_, rmov1_, mmov1_, norm1_,1 ); 
        if (nsurv > 1)call conv_aux_init(modl2_, data2_, hesp2_, hess2_, epsi2_, lmbd2_, mask2_, wght2_, pick2_, rmov2_, mmov2_, norm2_,2 ); 
        if (nsurv > 2)call conv_aux_init(modl3_, data3_, hesp3_, hess3_, epsi3_, lmbd3_, mask3_, wght3_, pick3_, rmov3_, mmov3_, norm3_,3 ); 
        if (nsurv > 3)call conv_aux_init(modl4_, data4_, hesp4_, hess4_, epsi4_, lmbd4_, mask4_, wght4_, pick4_, rmov4_, mmov4_, norm4_,4 ); 
        if (nsurv > 4)call conv_aux_init(modl5_, data5_, hesp5_, hess5_, epsi5_, lmbd5_, mask5_, wght5_, pick5_, rmov5_, mmov5_, norm5_,5 );  
        if (nsurv > 5)call conv_aux_init(modl6_, data6_, hesp6_, hess6_, epsi6_, lmbd6_, mask6_, wght6_, pick6_, rmov6_, mmov6_, norm6_,6 ); 
        if (nsurv > 6)call seperr('Why do you have more than six surveys??? your field shld be dry by now.....Talk to ur manager!!!!!!')
        write(0,*)'Done initializing ALL surveys'
        if(exist_file(epsA_))call auxin(epsA_)
        if(exist_file(epsB_))call auxin(epsB_)
        if(exist_file(epsC_))call auxin(epsC_)
        if(exist_file(epsD_))call auxin(epsD_)
  end subroutine
!#########################################
  subroutine  conv_aux_init(modl_n, data_n, hesp_n, hess_n, epsi_n, lmbd_n, mask_n, wght_n, pick_n, rmov_n, mmov_n, norm_n, i)
  character(len=256)     :: modl_n, data_n, hesp_n, hess_n, epsi_n, lmbd_n, mask_n, wght_n, pick_n, rmov_n, mmov_n, norm_n
  integer                :: i
           call auxinout(modl_n);  write(0,*)'Done modl...', i
           call auxinout(data_n);  write(0,*)'Done data...', i 
           call auxin (hess_n);    write(0,*)'Done hess...', i

           if (adj .or. inv)then
                   call auxout(mmov_n); write(0,*)'Done mmov...', i
                   call auxout(rmov_n); write(0,*)'Done rmov...', i
                   call auxout(norm_n); write(0,*)'Done norm...', i

                   if (             exist_file(mask_n  )) then; write(0,*)'Mask..:',i; call auxin (mask_n  ); write(0,*)'Done Mask...', i; endif
                   if (weight .and. exist_file(wght_n  )) then; write(0,*)'Wght..:',i; call auxin (wght_n  ); write(0,*)'Done Wght...', i; endif 
                   if (lpick  .and. exist_file(pick_n  )) then; write(0,*)'Pick..:',i; call auxin (pick_n  ); write(0,*)'Done Pick...', i; endif
                   if (             exist_file(epsi_n  )) then; write(0,*)'Epsi..:',i; call auxin (epsi_n  ); write(0,*)'Done Epsi...', i; endif
                   if (             exist_file(lmbd_n  )) then; write(0,*)'Lmbs..:',i; call auxin (lmbd_n  ); write(0,*)'Done Lmbd...', i; endif
                   if (precond.and. exist_file(hesp_n  )) then; write(0,*)'Hesp..:',i; call auxin (hesp_n  ); write(0,*)'Done Hesp...', i; endif
           endif
           write(0,*)'Done initializing surv...', i
  end subroutine
!#####################################################
  subroutine hessian_conv_inout_init()
        mask=0. ; wght=0.; epsi=1.; lmbd=1. 

        if (nsurv > 0) then
            call conv_inout_init(modl1_, data1_, hesp1_, mask1_, epsi1_, lmbd1_, wght1_, pick1_, mmov1_, rmov1_, norm1_, data1, hesp1, mask1, epsi1, lmbd1, wght1, pick1, eps1, lmb1)
            data(0*nmod+1:1*nmod)=data(0*nmod+1:1*nmod)+data1; 
                        epsi(0*nmod+1:1*nmod)=epsi1;
            if (size(lmbd)/=0)lmbd(0*nmod+1:1*nmod)=lmbd1;
            if (msk   ) mask(0*nmod+1:1*nmod)=mask1; 
            if (weight) wght(0*nmod+1:1*nmod)=wght1; 
            if (lpick ) pick(0*nmod+1:1*nmod)=pick1;
            if (precond)hesp(0*nmod+1:1*nmod)=hesp1; 
        endif
        if (nsurv > 1) then
            call conv_inout_init(modl2_, data2_, hesp2_, mask2_, epsi2_, lmbd2_, wght2_, pick2_, mmov2_, rmov2_, norm2_, data2, hesp2, mask2, epsi2, lmbd2, wght2, pick2, eps2, lmb2)
            if (method==1)then
                data(0*nmod+1:1*nmod)=data(0*nmod+1:1*nmod)+data2; 
                data(1*nmod+1:2*nmod)=data(1*nmod+1:2*nmod)+data2; 
            else
                data(1*nmod+1:2*nmod)=data(1*nmod+1:2*nmod)+data2; 
            endif
                        epsi(1*nmod+1:2*nmod)=epsi2;
            if (size(lmbd)/=0)lmbd(1*nmod+1:2*nmod)=lmbd2;
            if (msk   ) mask(1*nmod+1:2*nmod)=mask2; 
            if (weight) wght(1*nmod+1:2*nmod)=wght2; 
            if (lpick ) pick(1*nmod+1:2*nmod)=pick2;
            if (precond)hesp(1*nmod+1:2*nmod)=hesp2; 
        endif
        if (nsurv > 2) then
            call conv_inout_init(modl3_, data3_, hesp3_, mask3_, epsi3_, lmbd3_, wght3_, pick3_, mmov3_, rmov3_, norm3_, data3, hesp3, mask3, epsi3, lmbd3, wght3, pick3,  eps3, lmb3)
            if (method==1)then
                data(0*nmod+1:1*nmod)=data(0*nmod+1:1*nmod)+data3; 
                data(1*nmod+1:2*nmod)=data(1*nmod+1:2*nmod)+data3; 
                data(2*nmod+1:3*nmod)=data(2*nmod+1:3*nmod)+data3; 
            else
                data(2*nmod+1:3*nmod)=data(2*nmod+1:3*nmod)+data3; 
            endif
                        epsi(2*nmod+1:3*nmod)=epsi3;
                        lmbd(2*nmod+1:3*nmod)=lmbd3;
            if (msk   ) mask(2*nmod+1:3*nmod)=mask3; 
            if (weight) wght(2*nmod+1:3*nmod)=wght3; 
            if (lpick ) pick(2*nmod+1:3*nmod)=pick3;
            if (precond)hesp(2*nmod+1:3*nmod)=hesp3; 
        endif
        if (nsurv > 3) then
            call conv_inout_init(modl4_, data4_, hesp4_, mask4_, epsi4_, lmbd4_, wght4_, pick4_, mmov4_, rmov4_, norm4_, data4, hesp4, mask4, epsi4, lmbd4, wght4, pick4, eps4, lmb4)
            if (method==1)then
                data(0*nmod+1:1*nmod)=data(0*nmod+1:1*nmod)+data4; 
                data(1*nmod+1:2*nmod)=data(1*nmod+1:2*nmod)+data4; 
                data(2*nmod+1:3*nmod)=data(2*nmod+1:3*nmod)+data4; 
                data(3*nmod+1:4*nmod)=data(3*nmod+1:4*nmod)+data4; 
            else
                data(3*nmod+1:4*nmod)=data(3*nmod+1:4*nmod)+data4;
            endif
                        epsi(3*nmod+1:4*nmod)=epsi4;
                        lmbd(3*nmod+1:4*nmod)=lmbd4;
            if (msk   ) mask(3*nmod+1:4*nmod)=mask4; 
            if (weight) wght(3*nmod+1:4*nmod)=wght4; 
            if (lpick ) pick(3*nmod+1:4*nmod)=pick4;
            if (precond)hesp(3*nmod+1:4*nmod)=hesp4;
        endif
        if (nsurv > 4) then
            call conv_inout_init(modl5_, data5_, hesp5_, mask5_, epsi5_, lmbd5_, wght5_, pick5_, mmov5_, rmov5_, norm5_, data5, hesp5, mask5, epsi5, lmbd5, wght5, pick5, eps5, lmb5)
            if (method==1)then
                data(0*nmod+1:1*nmod)=data(0*nmod+1:1*nmod)+data5; 
                data(1*nmod+1:2*nmod)=data(1*nmod+1:2*nmod)+data5; 
                data(2*nmod+1:3*nmod)=data(2*nmod+1:3*nmod)+data5; 
                data(3*nmod+1:4*nmod)=data(3*nmod+1:4*nmod)+data5; 
                data(4*nmod+1:5*nmod)=data(4*nmod+1:5*nmod)+data5; 
            else
                data(4*nmod+1:5*nmod)=data(4*nmod+1:5*nmod)+data5; 
            endif
                        epsi(4*nmod+1:5*nmod)=epsi5;
                        lmbd(4*nmod+1:5*nmod)=lmbd5;
            if (msk   ) mask(4*nmod+1:5*nmod)=mask5; 
            if (weight) wght(4*nmod+1:5*nmod)=wght5; 
            if (lpick ) pick(4*nmod+1:5*nmod)=pick5;
            if (precond)hesp(4*nmod+1:5*nmod)=hesp5; 
        endif
        if (nsurv > 5) then
            call conv_inout_init(modl6_, data6_, hesp6_, mask6_, epsi6_, lmbd6_, wght6_, pick6_, mmov6_, rmov6_, norm6_, data6, hesp6, mask6, epsi6, lmbd6, wght6, pick6, eps6, lmb6)
            if (method==1)then
                data(0*nmod+1:1*nmod)=data(0*nmod+1:1*nmod)+data6; 
                data(1*nmod+1:2*nmod)=data(1*nmod+1:2*nmod)+data6; 
                data(2*nmod+1:3*nmod)=data(2*nmod+1:3*nmod)+data6; 
                data(3*nmod+1:4*nmod)=data(3*nmod+1:4*nmod)+data6; 
                data(4*nmod+1:5*nmod)=data(4*nmod+1:5*nmod)+data6; 
                data(5*nmod+1:6*nmod)=data(5*nmod+1:6*nmod)+data6;
            else
                data(5*nmod+1:6*nmod)=data(5*nmod+1:6*nmod)+data6;
            endif
                        epsi(5*nmod+1:6*nmod)=epsi6;
                        lmbd(5*nmod+1:6*nmod)=lmbd6;
            if (msk   ) mask(5*nmod+1:6*nmod)=mask6; 
            if (weight) wght(5*nmod+1:6*nmod)=wght6; 
            if (lpick ) pick(5*nmod+1:6*nmod)=pick6;
            if (precond)hesp(5*nmod+1:6*nmod)=hesp6; 
        endif
        if (mode==5) data_mres=data;
        if(gpow/=0.)then;write(0,*)'reserv-hesp',maxval(hesp),minval(hesp),'b4-gpow',gpow; if(precond)hesp=(hesp/max(0.000000001,minval(hesp)))**gpow; write(0,*)'reserv--hesp',maxval(hesp),minval(hesp),'af';endif
        if(wpow/=0.)then;write(0,*)'reserv-wght',maxval(wght),minval(wght),'b4-wpow',wpow; if(precond)wght=(wght/max(0.000000001,minval(wght)))**wpow; write(0,*)'reserv--wght',maxval(wght),minval(wght),'af';endif
        if (exist_file(epsA_)) then; call sep_read(epsA,epsA_); endif
        if (exist_file(epsB_)) then; call sep_read(epsB,epsB_); endif
        if (exist_file(epsC_)) then; call sep_read(epsC,epsC_); endif
        if (exist_file(epsD_)) then; call sep_read(epsD,epsD_); endif
        if (adj .or. inv)then
                if(exist_file(mmov_))then;
                        call auxout(mmov_);
                        call houaxis2(mmov_, hgrid%ax_modl, 1);call houaxis2(mmov_, hgrid%ay_modl, 2); call houaxis2(mmov_, hgrid%az_modl, 3);call houaxis2(mmov_, mov1, 4);call houaxis2(mmov_, mov, 5)
                endif        
                if(exist_file(rdov_))then;
                        call auxout(rdov_);
                        call houaxis2(rdov_, hgrid%ax_modl, 1);call houaxis2(rdov_, hgrid%ay_modl, 2); call houaxis2(rdov_, hgrid%az_modl, 3);call houaxis2(rdov_, mov1, 4);call houaxis2(rdov_, mov, 5)
                endif        
        endif

  end subroutine
!#########  
  subroutine   conv_inout_init     (modl_n_, data_n_, hesp_n_, mask_n_, epsi_n_, lmbd_n_, wght_n_, pick_n_, mmov_n_, rmov_n_, norm_n_, data_n, hesp_n, mask_n, epsi_n, lmbd_n, wght_n, pick_n, eps_n, lmb_n)
  character(len=256)                    :: modl_n_, data_n_, mask_n_, epsi_n_, lmbd_n_, wght_n_, pick_n_, mmov_n_, rmov_n_, norm_n_, hesp_n_
  real, dimension(:)                    :: data_n, hesp_n, mask_n, epsi_n, lmbd_n, wght_n, pick_n
  real                                  :: eps_n, lmb_n
        call houaxis2(modl_n_, hgrid%ax_modl, 1);call houaxis2(modl_n_, hgrid%ay_modl, 2); call houaxis2(modl_n_, hgrid%az_modl, 3)
        call houaxis2(mmov_n_, hgrid%ax_modl, 1);call houaxis2(mmov_n_, hgrid%ay_modl, 2); call houaxis2(mmov_n_, hgrid%az_modl, 3);call houaxis2(mmov_n_, mov, 4)
        call houaxis2(rmov_n_, hgrid%ax_modl, 1);call houaxis2(rmov_n_, hgrid%ay_modl, 2); call houaxis2(rmov_n_, hgrid%az_modl, 3);call houaxis2(rmov_n_, mov, 4)
        call houaxis2(norm_n_, nrm          , 1);
        call sep_read(data_n, data_n_);
        if (msk    .and. exist_file(mask_n_)) then; call sep_read(mask_n, mask_n_) ; endif
        if (weight .and. exist_file(wght_n_)) then; call sep_read(wght_n, wght_n_) ; endif
        if (lpick  .and. exist_file(pick_n_)) then; call sep_read(pick_n, pick_n_) ; elseif (lpick) then; pick_n=1    ; endif
        if (             exist_file(epsi_n_)) then; call sep_read(epsi_n, epsi_n_) ; elseif (data_eps)then; epsi_n=maxval(abs(data_n))/eps_n; else; epsi_n=eps_n; endif
        if (             exist_file(lmbd_n_)) then; call sep_read(lmbd_n, lmbd_n_) ; elseif (data_lmb)then; lmbd_n=maxval(abs(data_n))/lmb_n; else; lmbd_n=lmb_n; endif
        if (precond.and. exist_file(hesp_n_)) then; call sep_read(hesp_n, hesp_n_) ; hesp_n=1./hesp_n; endif
  end subroutine
!#####################################################  
  subroutine hessian_conv_inout_model_init()
        if(method==1)then
                if (nsurv > 0) then; call conv_out_model_init(modl1_, data1_, modl1); modl(0*nmod+1:1*nmod)=modl1      ;endif
                if (nsurv > 1) then; call conv_out_model_init(modl2_, data2_, modl2); modl(1*nmod+1:2*nmod)=modl2-modl1;endif
                if (nsurv > 2) then; call conv_out_model_init(modl3_, data3_, modl3); modl(2*nmod+1:3*nmod)=modl3-modl2;endif 
                if (nsurv > 3) then; call conv_out_model_init(modl4_, data4_, modl4); modl(3*nmod+1:4*nmod)=modl4-modl3;endif 
                if (nsurv > 4) then; call conv_out_model_init(modl5_, data5_, modl5); modl(4*nmod+1:5*nmod)=modl5-modl4;endif 
                if (nsurv > 5) then; call conv_out_model_init(modl6_, data6_, modl6); modl(5*nmod+1:6*nmod)=modl6-modl5;endif
        else
                if (nsurv > 0) then; call conv_out_model_init(modl1_, data1_, modl1); modl(0*nmod+1:1*nmod)=modl1;endif
                if (nsurv > 1) then; call conv_out_model_init(modl2_, data2_, modl2); modl(1*nmod+1:2*nmod)=modl2;endif
                if (nsurv > 2) then; call conv_out_model_init(modl3_, data3_, modl3); modl(2*nmod+1:3*nmod)=modl3;endif 
                if (nsurv > 3) then; call conv_out_model_init(modl4_, data4_, modl4); modl(3*nmod+1:4*nmod)=modl4;endif 
                if (nsurv > 4) then; call conv_out_model_init(modl5_, data5_, modl5); modl(4*nmod+1:5*nmod)=modl5;endif 
                if (nsurv > 5) then; call conv_out_model_init(modl6_, data6_, modl6); modl(5*nmod+1:6*nmod)=modl6;endif
        endif
        if (mode==5) modl_mres=modl;
  end subroutine
!#####################################################  
  subroutine           conv_out_model_init(modl_n_, data_n_, modl_n)
  character(len=256)                :: modl_n_, data_n_
  real, dimension(:)  , allocatable :: modl_n
        call houaxis2(data_n_, hgrid%ax_modl, 1); call houaxis2(data_n_, hgrid%ay_modl, 2); call houaxis2(data_n_, hgrid%az_modl, 3)
        call sep_read(modl_n, modl_n_);
        write(0,*)sum(modl_n),trim(modl_n_)
        
  end subroutine
!#####################################################  
  subroutine  hessian_conv_summary()
          if (flat)then
                  write(0,'(A45)')'**********************************************************'
                  write(0,'(A29,2I8)')'index_rsv_xmin,index_rsv_xmax:',index_rsv_xmin,index_rsv_xmax
                  write(0,'(A29,2I8)')'index_rsv_zmin,index_rsv_zmax:',index_rsv_zmin,index_rsv_zmax
                  write(0,'(A29,2I8)')'index_xmin    ,index_xmax    :',index_xmin,index_xmax
                  write(0,'(A29,2I8)')'index_zmin    ,index_zmax    :',index_zmin,index_zmax
          endif
          write(0,'(A45)')'**********************************************************'
          do i=1,nsurv
               if(size(epsi/=0))write(0,'(A14,I2,A2,2F10.4)')'min/max epsi:', i, ':', minval(epsi((i-1)*nmod+1:i*nmod)),maxval(epsi((i-1)*nmod+1:i*nmod))
               if(size(lmbd/=0))write(0,'(A14,I2,A2,2F10.4)')'min/max lamb:', i, ':', minval(lmbd((i-1)*nmod+1:i*nmod)),maxval(lmbd((i-1)*nmod+1:i*nmod))
                write(0,'(A45)')'**********************************************************'
          enddo

          if(method==1)then
                write(0,'(A45)')'**********************************************************'
                write(0,*)'!#######USING METHOD1#######'
                write(0,*)'!/ | H16 H26 H36 H46 H56 H6|'    
                write(0,*)'!/ | H26 H26 H36 H46 H56 H6|'    
                write(0,*)'!/ | H36 H36 H36 H46 H56 H6|'    
                write(0,*)'!/ | H46 H46 H46 H46 H56 H6|'    
                write(0,*)'!/ | H56 H56 H56 H56 H56 H6|'    
                write(0,*)'!/ |  H6  H6  H6  H6  H6 H6|'    
                write(0,'(A45)')'**********************************************************'
                select case(reg_4d)
                        case(1); write(0,'(A45)')'Reg. 4d: x-gradient' ;
                        case(2); write(0,'(A45)')'Reg. 4d: z-gradient' ;
                        case(3); write(0,'(A45)')'Reg. 4d: x-laplacian';
                        case(4); write(0,'(A45)')'Reg. 4d: z-laplacian';
                        case(5); write(0,'(A45)')'Reg. 4d:xz-laplacian';
                        case(6); write(0,'(A45)')'Reg. 4d:xz-gradient mag.';
                        case(7); write(0,'(A45)')'Reg. 4d:xz-gradient mag.^2';
                        case(8); write(0,'(A45)')'Reg. 4d: z-gradient (out) +  x-gradient (in)';
                        case(9); write(0,'(A45)')'Reg. 4d:xz-gradient (out) +  x-gradient (in)';
                        case(10);write(0,'(A45)')'Reg. 4d:xz-gradient (out) +  x-laplacian (in)';
                        case(11);write(0,'(A45)')'Reg. 4d:xz-gradient (out) + xz-gradient (in)';
                        case(12);write(0,'(A45)')'Reg. 4d: z-laplacian(out) +  x-gradient (in)';
                        case(13);write(0,'(A45)')'Reg. 4d:xz-laplacian(out) +  x-laplacian (in)';
                end select
                write(0,'(A45)')'**********************************************************'
                select case(reg_base)
                        case(1); write(0,'(A45)')'Reg. base: x-gradient          **' ;
                        case(2); write(0,'(A45)')'Reg. base: x-laplacian          **';
                end select
                write(0,'(A45)')'**********************************************************'
          elseif(method==2)then
                write(0,*)'!#######USING METHOD2#######'
                write(0,*)'!/ | H1                    |'    
                write(0,*)'!/ |     H2                |'    
                write(0,*)'!/ |         H3            |'    
                write(0,*)'!/ |             H4        |'    
                write(0,*)'!/ |                 H5    |'    
                write(0,*)'!/ |                     H6|'    
                write(0,'(A45)')'**********************************************************'
                select case(reg_base)
                        case(1); write(0,'(A40)')'Reg. base/moni: x-gradient' ;
                        case(2); write(0,'(A40)')'Reg. base/moni: x-laplacian';
                end select
                write(0,'(A45)')'**********************************************************'
          else
              call seperr('Not funny:::::: You have not selected any method!!!!!!!!!!!')
          endif
  end subroutine
!#####################################################  

end module
