!RJID
module hessian_convolve_module1
  use  hessian_convolve_params
  use hessian_convolve_io

  implicit none

contains
!#######
  !subroutine  hessian_convolve(adj, mod1, dat1, mod2, dat2, mod3, dat3, mod4, dat4, mod5, dat5, mod6, dat6 )
  subroutine  hessian_convolve1(adj, add)
  logical            :: adj, add
  if(small)then
        write(0,*)'small...................'
         if (nsurv > 5) then
                call hess_convolve6(adj, modl1, modl2, modl3, modl4, modl5, modl6, data1, data2, data3, data4, data5, data6 )
         elseif (nsurv > 4) then
                call hess_convolve5(adj, modl1, modl2, modl3, modl4, modl5       , data1, data2, data3, data4, data5        )
         elseif (nsurv > 3) then
                call hess_convolve4(adj, modl1, modl2, modl3, modl4              , data1, data2, data3, data4               )
         elseif (nsurv > 2) then
                call hess_convolve3(adj, modl1, modl2, modl3                     , data1, data2, data3                      )
         elseif (nsurv > 1) then
                call hess_convolve2(adj, modl1, modl2                            , data1, data2                             )
         elseif (nsurv > 0) then
                call hess_convolve1(adj, modl1                                   , data1                                    )
         endif
  else
         if (nsurv > 5) then
                call hess_convolve_6(adj, modl1, modl2, modl3, modl4, modl5, modl6, data1, data2, data3, data4, data5, data6 )
         elseif (nsurv > 4) then
                call hess_convolve_5(adj, modl1, modl2, modl3, modl4, modl5       , data1, data2, data3, data4, data5        )
         elseif (nsurv > 3) then
                call hess_convolve_4(adj, modl1, modl2, modl3, modl4              , data1, data2, data3, data4               )
         elseif (nsurv > 2) then
                call hess_convolve_3(adj, modl1, modl2, modl3                     , data1, data2, data3                      )
         elseif (nsurv > 1) then
                call hess_convolve_2(adj, modl1, modl2                            , data1, data2                             )
         elseif (nsurv > 0) then
                call hess_convolve_1(adj, modl1                                   , data1                                    )
         endif
   endif
   end subroutine

! ##############################################
!/ | HH | 
  subroutine hess_convolve1(adj, mod1, dat1)
    logical                       :: adj
    real                          :: HH
    real                 ,pointer :: d
    real                 ,pointer :: m
    real    ,dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n),target  :: mod1
    real    ,dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n),target  :: dat1
    real                  :: start_time, finish_time,h1
    integer               :: time_array_0(8), time_array_1(8),iii
iii=0
    if (timing1)then
        call date_and_time(values=time_array_0)
        start_time = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)
    endif
        
    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                call hess_io(hess, hgrid, ix_modl, iy_modl, iz_modl, hess1_, "reed")
                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
                        iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
                        iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > ceiling(hgrid%ax_offd%n/2.)) cycle
                        ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        HH=hess(ix_offd,iy_offd,iz_offd)
			if(ix_modl==200.and.iz_modl==50.and.(ix_o==200.and.iz_o==50))h1=HH
			!if(ix_modl==200.and.iz_modl==50.or.(ix_o==200.and.iz_o==50))then;&
			!	iii=iii+1
			!	write(0,'(6(I8,2x),A3,6(I8,2x),A3,I8,A3,F18.4)')iz_m,iy_m,ix_m,iz_o,iy_o,ix_o,'||',iz_modl,iy_modl,ix_modl,iz_offd,iy_offd,ix_offd,'||||',iii,'||',HH/h1
			!endif
                        if (adj) then
                            d=>dat1(iz_m,ix_m,iy_m);
                            m=>mod1(iz_o,ix_o,iy_o);
                                m = m + HH*d  
                            d=>dat1(iz_o,ix_o,iy_o); 
                            m=>mod1(iz_m,ix_m,iy_m);
                                m = m + HH*d 
                        else 
                            d=>dat1(iz_m,ix_m,iy_m);
                            m=>mod1(iz_o,ix_o,iy_o);
                                d = d + HH*m 
                            d=>dat1(iz_o,ix_o,iy_o);
                            m=>mod1(iz_m,ix_m,iy_m);
                                d = d + HH*m 
                        end if
                end do
                end do
                end do
        end do
        end do
        end do
    if (timing1)then
        call date_and_time(values=time_array_1)
        finish_time = time_array_1 (5) * 3600 + time_array_1 (6) * 60 + time_array_1 (7) + 0.001 * time_array_1 (8)
        write(0,*)'total time', finish_time - start_time
    endif
    return
  end subroutine
!#####################################
!/ | H12 H2|    
!/ | H2  H2|    
  subroutine hess_convolve2(adj, mod1, mod2, dat1, dat2)
    logical               :: adj
    real                  :: HH1, HH2
    real          ,pointer:: d1, d2
    real          ,pointer:: m1, m2
    real    ,dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) ,target:: mod1, mod2
    real    ,dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) ,target:: dat1, dat2

    if (timing1)then
        call date_and_time(values=time_array_0)
        start_time = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)
    endif
    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                call hess_io(hess1, hgrid, ix_modl, iy_modl, iz_modl, hess1_, "reed")
                call hess_io(hess2, hgrid, ix_modl, iy_modl, iz_modl, hess2_, "reed") 
                !$OMP parallel do private(inode, iz_offd, iy_offd, ix_offd, iz_o, iy_o, ix_o, z_offd, y_offd, x_offd, HH1, HH2, d1, d2, m1, m2) schedule(dynamic) 
                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
                        iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
                        iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > ceiling(hgrid%ax_offd%n/2.)) cycle
                        ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        HH1=hess1(ix_offd,iy_offd,iz_offd)+hess2(ix_offd,iy_offd,iz_offd)
                        HH2=                               hess2(ix_offd,iy_offd,iz_offd)
                        if (adj) then
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); 
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); 
                                m1 = m1 + HH1*d1 + HH2*d2 
                                m2 = m2 + HH2*d1 + HH2*d2 
                            d1=>dat1(iz_o,ix_o,iy_o); d2=>dat2(iz_o,ix_o,iy_o); 
                            m1=>mod1(iz_m,ix_m,iy_m); m2=>mod2(iz_m,ix_m,iy_m); 
                                m1 = m1 + HH1*d1 + HH2*d2 
                                m2 = m2 + HH2*d1 + HH2*d2
                        else 
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); 
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); 
                                d1 = d1 + HH1*m1 + HH2*m2 
                                d2 = d2 + HH2*m1 + HH2*m2 
                            d1=>dat1(iz_o,ix_o,iy_o); d2=>dat2(iz_o,ix_o,iy_o); 
                            m1=>mod1(iz_m,ix_m,iy_m); m2=>mod2(iz_m,ix_m,iy_m); 
                                d1 = d1 + HH1*m1 + HH2*m2 
                                d2 = d2 + HH2*m1 + HH2*m2 
                        end if
                end do
                end do
                end do
                !$OMP end parallel do
        end do
        end do
        end do
    if (timing1)then
        call date_and_time(values=time_array_1)
        finish_time = time_array_1 (5) * 3600 + time_array_1 (6) * 60 + time_array_1 (7) + 0.001 * time_array_1 (8)
        write(0,*)'total time', finish_time - start_time
   endif
    return
  end subroutine
!#####################################
!/ | H13 H23 H3|    
!/ | H23 H23 H3|    
!/ | H3  H3  H3|    
 subroutine hess_convolve3(adj, mod1, mod2, mod3, dat1, dat2, dat3)
    logical               :: adj
    real                  :: HH1, HH2, HH3
    real          ,pointer:: d1, d2, d3
    real          ,pointer:: m1, m2, m3
    real    ,dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) ,target:: mod1, mod2, mod3
    real    ,dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) ,target:: dat1, dat2, dat3

    if (timing1)then
        call date_and_time(values=time_array_0)
        start_time = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)
    endif
        
    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                call hess_io(hess1, hgrid, ix_modl, iy_modl, iz_modl, hess1_, "reed")
                call hess_io(hess2, hgrid, ix_modl, iy_modl, iz_modl, hess2_, "reed")
                call hess_io(hess3, hgrid, ix_modl, iy_modl, iz_modl, hess3_, "reed")
                !$OMP parallel do private(inode, iz_offd, iy_offd, ix_offd, iz_o, iy_o, ix_o, z_offd, y_offd, x_offd, HH1, HH2, HH3, d1, d2, d3, m1, m2, m3) 
                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
                        iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
                        iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > ceiling(hgrid%ax_offd%n/2.)) cycle
                        ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        HH1=hess1(ix_offd,iy_offd,iz_offd)+hess2(ix_offd,iy_offd,iz_offd)+hess3(ix_offd,iy_offd,iz_offd)
                        HH2=                               hess2(ix_offd,iy_offd,iz_offd)+hess3(ix_offd,iy_offd,iz_offd)
                        HH3=                                                              hess3(ix_offd,iy_offd,iz_offd)
                        if (adj) then
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); d3=>dat3(iz_m,ix_m,iy_m); 
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); m3=>mod3(iz_o,ix_o,iy_o); 
                                m1 = m1 + HH1*d1 + HH2*d2 + HH3*d3 
                                m2 = m2 + HH2*d1 + HH2*d2 + HH3*d3 
                                m3 = m3 + HH3*d1 + HH3*d2 + HH3*d3 
                            d1=>dat1(iz_o,ix_o,iy_o); d2=>dat2(iz_o,ix_o,iy_o); d3=>dat3(iz_o,ix_o,iy_o); 
                            m1=>mod1(iz_m,ix_m,iy_m); m2=>mod2(iz_m,ix_m,iy_m); m3=>mod3(iz_m,ix_m,iy_m); 
                                m1 = m1 + HH1*d1 + HH2*d2 + HH3*d3 
                                m2 = m2 + HH2*d1 + HH2*d2 + HH3*d3 
                                m3 = m3 + HH3*d1 + HH3*d2 + HH3*d3 
                        else 
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); d3=>dat3(iz_m,ix_m,iy_m); 
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); m3=>mod3(iz_o,ix_o,iy_o); 
                                d1 = d1 + HH1*m1 + HH2*m2 + HH3*m3 
                                d2 = d2 + HH2*m1 + HH2*m2 + HH3*m3 
                                d3 = d3 + HH3*m1 + HH3*m2 + HH3*m3 
                            d1=>dat1(iz_o,ix_o,iy_o); d2=>dat2(iz_o,ix_o,iy_o); d3=>dat3(iz_o,ix_o,iy_o); 
                            m1=>mod1(iz_m,ix_m,iy_m); m2=>mod2(iz_m,ix_m,iy_m); m3=>mod3(iz_m,ix_m,iy_m); 
                                d1 = d1 + HH1*m1 + HH2*m2 + HH3*m3 
                                d2 = d2 + HH2*m1 + HH2*m2 + HH3*m3 
                                d3 = d3 + HH3*m1 + HH3*m2 + HH3*m3 
                        end if
                end do
                end do
                end do
                !$OMP end parallel do
        end do
        end do
        end do
    if (timing1)then
        call date_and_time(values=time_array_1)
        finish_time = time_array_1 (5) * 3600 + time_array_1 (6) * 60 + time_array_1 (7) + 0.001 * time_array_1 (8)
        write(0,*)'total time', finish_time - start_time
   endif
    return
  end subroutine
!#####################################
!/ | H14 H24 H34 H4|    
!/ | H24 H24 H34 H4|    
!/ | H34 H34 H34 H4|    
!/ |  H4  H4  H4 H4|    
  subroutine hess_convolve4(adj, mod1, mod2, mod3, mod4, dat1, dat2, dat3, dat4)
    logical               :: adj
    real                  :: HH1, HH2, HH3, HH4
    real          ,pointer:: d1, d2, d3, d4
    real          ,pointer:: m1, m2, m3, m4
    real    ,dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) ,target:: mod1, mod2, mod3, mod4
    real    ,dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) ,target:: dat1, dat2, dat3, dat4
    integer               :: a1
    logical               :: logic


    if (timing1)then
        call date_and_time(values=time_array_0)
        start_time = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)
    endif

    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                call hess_io(hess1, hgrid, ix_modl, iy_modl, iz_modl, hess1_, "reed")
                call hess_io(hess2, hgrid, ix_modl, iy_modl, iz_modl, hess2_, "reed")
                call hess_io(hess3, hgrid, ix_modl, iy_modl, iz_modl, hess3_, "reed")
                call hess_io(hess4, hgrid, ix_modl, iy_modl, iz_modl, hess4_, "reed")
        !$OMP parallel do private(inode, iz_offd, iy_offd, ix_offd, iz_o, iy_o, ix_o, z_offd, y_offd, x_offd, HH1, HH2, HH3, HH4, d1, d2, d3, d4, m1, m2, m3, m4)  
                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d;
                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
                        iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
                        iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > ceiling(hgrid%ax_offd%n/2.)) cycle
                        ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        HH1=hess1(ix_offd,iy_offd,iz_offd)+hess2(ix_offd,iy_offd,iz_offd)+hess3(ix_offd,iy_offd,iz_offd)+hess4(ix_offd,iy_offd,iz_offd)
                        HH2=                               hess2(ix_offd,iy_offd,iz_offd)+hess3(ix_offd,iy_offd,iz_offd)+hess4(ix_offd,iy_offd,iz_offd)
                        HH3=                                                              hess3(ix_offd,iy_offd,iz_offd)+hess4(ix_offd,iy_offd,iz_offd)
                        HH4=                                                                                             hess4(ix_offd,iy_offd,iz_offd)
                        if (adj) then
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); d3=>dat3(iz_m,ix_m,iy_m); d4=>dat4(iz_m,ix_m,iy_m); 
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); m3=>mod3(iz_o,ix_o,iy_o); m4=>mod4(iz_o,ix_o,iy_o); 
                                m1 = m1 + HH1*d1 + HH2*d2 + HH3*d3 + HH4*d4 
                                m2 = m2 + HH2*d1 + HH2*d2 + HH3*d3 + HH4*d4 
                                m3 = m3 + HH3*d1 + HH3*d2 + HH3*d3 + HH4*d4 
                                m4 = m4 + HH4*d1 + HH4*d2 + HH4*d3 + HH4*d4 
                            d1=>dat1(iz_o,ix_o,iy_o); d2=>dat2(iz_o,ix_o,iy_o); d3=>dat3(iz_o,ix_o,iy_o); d4=>dat4(iz_o,ix_o,iy_o); 
                            m1=>mod1(iz_m,ix_m,iy_m); m2=>mod2(iz_m,ix_m,iy_m); m3=>mod3(iz_m,ix_m,iy_m); m4=>mod4(iz_m,ix_m,iy_m); 
                                m1 = m1 + HH1*d1 + HH2*d2 + HH3*d3 + HH4*d4 
                                m2 = m2 + HH2*d1 + HH2*d2 + HH3*d3 + HH4*d4 
                                m3 = m3 + HH3*d1 + HH3*d2 + HH3*d3 + HH4*d4 
                                m4 = m4 + HH4*d1 + HH4*d2 + HH4*d3 + HH4*d4 
                        else 
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); d3=>dat3(iz_m,ix_m,iy_m); d4=>dat4(iz_m,ix_m,iy_m); 
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); m3=>mod3(iz_o,ix_o,iy_o); m4=>mod4(iz_o,ix_o,iy_o); 
                                d1 = d1 + HH1*m1 + HH2*m2 + HH3*m3 + HH4*m4 
                                d2 = d2 + HH2*m1 + HH2*m2 + HH3*m3 + HH4*m4 
                                d3 = d3 + HH3*m1 + HH3*m2 + HH3*m3 + HH4*m4 
                                d4 = d4 + HH4*m1 + HH4*m2 + HH4*m3 + HH4*m4 
                            d1=>dat1(iz_o,ix_o,iy_o); d2=>dat2(iz_o,ix_o,iy_o); d3=>dat3(iz_o,ix_o,iy_o); d4=>dat4(iz_o,ix_o,iy_o); 
                            m1=>mod1(iz_m,ix_m,iy_m); m2=>mod2(iz_m,ix_m,iy_m); m3=>mod3(iz_m,ix_m,iy_m); m4=>mod4(iz_m,ix_m,iy_m);
                                d1 = d1 + HH1*m1 + HH2*m2 + HH3*m3 + HH4*m4 
                                d2 = d2 + HH2*m1 + HH2*m2 + HH3*m3 + HH4*m4 
                                d3 = d3 + HH3*m1 + HH3*m2 + HH3*m3 + HH4*m4 
                                d4 = d4 + HH4*m1 + HH4*m2 + HH4*m3 + HH4*m4 
                        end if
                end do
                end do
                end do
                !$OMP end parallel do
        end do
        end do
        end do
    if (timing1)then
        call date_and_time(values=time_array_1)
        finish_time = time_array_1 (5) * 3600 + time_array_1 (6) * 60 + time_array_1 (7) + 0.001 * time_array_1 (8)
        write(0,*)'total time', finish_time - start_time
    endif
    return
  end subroutine
!#####################################
!/ | H15 H25 H35 H45 H5|    
!/ | H25 H25 H35 H45 H5|    
!/ | H35 H35 H35 H45 H5|    
!/ | H45 H45 H45 H45 H5|    
!/ |  H5  H5  H5  H5 H5|    
  subroutine hess_convolve5(adj, mod1, mod2, mod3, mod4, mod5, dat1, dat2, dat3, dat4, dat5)
    logical               :: adj
    real                  :: HH5, HH4, HH3, HH2, HH1 
    real          ,pointer:: d1, d2, d3, d4, d5
    real          ,pointer:: m1, m2, m3, m4, m5
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n),target :: mod1, mod2, mod3, mod4, mod5
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n),target :: dat1, dat2, dat3, dat4, dat5

    if (timing1)then
        call date_and_time(values=time_array_0)
        start_time = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)
    endif
        
    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                call hess_io(hess1, hgrid, ix_modl, iy_modl, iz_modl, hess1_, "reed")
                call hess_io(hess2, hgrid, ix_modl, iy_modl, iz_modl, hess2_, "reed")
                call hess_io(hess3, hgrid, ix_modl, iy_modl, iz_modl, hess3_, "reed")
                call hess_io(hess4, hgrid, ix_modl, iy_modl, iz_modl, hess4_, "reed")
                call hess_io(hess5, hgrid, ix_modl, iy_modl, iz_modl, hess5_, "reed")
                !$OMP parallel do private(inode, iz_offd, iy_offd, ix_offd, iz_o, iy_o, ix_o, z_offd, y_offd, x_offd, HH1, HH2, HH3, HH4, HH5, d1, d2, d3, d4, d5, m1, m2, m3, m4, m5) 
                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
                        iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
                        iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > ceiling(hgrid%ax_offd%n/2.)) cycle
                        ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        HH1=hess1(ix_offd,iy_offd,iz_offd)+hess2(ix_offd,iy_offd,iz_offd)+hess3(ix_offd,iy_offd,iz_offd)+hess4(ix_offd,iy_offd,iz_offd)+hess5(ix_offd,iy_offd,iz_offd)
                        HH2=                               hess2(ix_offd,iy_offd,iz_offd)+hess3(ix_offd,iy_offd,iz_offd)+hess4(ix_offd,iy_offd,iz_offd)+hess5(ix_offd,iy_offd,iz_offd)
                        HH3=                                                              hess3(ix_offd,iy_offd,iz_offd)+hess4(ix_offd,iy_offd,iz_offd)+hess5(ix_offd,iy_offd,iz_offd)
                        HH4=                                                                                             hess4(ix_offd,iy_offd,iz_offd)+hess5(ix_offd,iy_offd,iz_offd)
                        HH5=                                                                                                                            hess5(ix_offd,iy_offd,iz_offd)
                        if (adj) then
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); d3=>dat3(iz_m,ix_m,iy_m); d4=>dat4(iz_m,ix_m,iy_m); d5=>dat5(iz_m,ix_m,iy_m); 
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); m3=>mod3(iz_o,ix_o,iy_o); m4=>mod4(iz_o,ix_o,iy_o); m5=>mod5(iz_o,ix_o,iy_o); 
                                m1 = m1 + HH1*d1 + HH2*d2 + HH3*d3 + HH4*d4 + HH5*d5 
                                m2 = m2 + HH2*d1 + HH2*d2 + HH3*d3 + HH4*d4 + HH5*d5 
                                m3 = m3 + HH3*d1 + HH3*d2 + HH3*d3 + HH4*d4 + HH5*d5 
                                m4 = m4 + HH4*d1 + HH4*d2 + HH4*d3 + HH4*d4 + HH5*d5 
                                m5 = m5 + HH5*d1 + HH5*d2 + HH5*d3 + HH5*d4 + HH5*d5 
                            d1=>dat1(iz_o,ix_o,iy_o); d2=>dat2(iz_o,ix_o,iy_o); d3=>dat3(iz_o,ix_o,iy_o); d4=>dat4(iz_o,ix_o,iy_o); d5=>dat5(iz_o,ix_o,iy_o); 
                            m1=>mod1(iz_m,ix_m,iy_m); m2=>mod2(iz_m,ix_m,iy_m); m3=>mod3(iz_m,ix_m,iy_m); m4=>mod4(iz_m,ix_m,iy_m); m5=>mod5(iz_m,ix_m,iy_m); 
                                m1 = m1 + HH1*d1 + HH2*d2 + HH3*d3 + HH4*d4 + HH5*d5
                                m2 = m2 + HH2*d1 + HH2*d2 + HH3*d3 + HH4*d4 + HH5*d5
                                m3 = m3 + HH3*d1 + HH3*d2 + HH3*d3 + HH4*d4 + HH5*d5
                                m4 = m4 + HH4*d1 + HH4*d2 + HH4*d3 + HH4*d4 + HH5*d5
                                m5 = m5 + HH5*d1 + HH5*d2 + HH5*d3 + HH5*d4 + HH5*d5
                        else 
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); d3=>dat3(iz_m,ix_m,iy_m); d4=>dat4(iz_m,ix_m,iy_m); d5=>dat5(iz_m,ix_m,iy_m); 
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); m3=>mod3(iz_o,ix_o,iy_o); m4=>mod4(iz_o,ix_o,iy_o); m5=>mod5(iz_o,ix_o,iy_o); 
                                d1 = d1 + HH1*m1 + HH2*m2 + HH3*m3 + HH4*m4 + HH5*m5 
                                d2 = d2 + HH2*m1 + HH2*m2 + HH3*m3 + HH4*m4 + HH5*m5 
                                d3 = d3 + HH3*m1 + HH3*m2 + HH3*m3 + HH4*m4 + HH5*m5 
                                d4 = d4 + HH4*m1 + HH4*m2 + HH4*m3 + HH4*m4 + HH5*m5 
                                d5 = d5 + HH5*m1 + HH5*m2 + HH5*m3 + HH5*m4 + HH5*m5 
                            d1=>dat1(iz_o,ix_o,iy_o); d2=>dat2(iz_o,ix_o,iy_o); d3=>dat3(iz_o,ix_o,iy_o); d4=>dat4(iz_o,ix_o,iy_o); d5=>dat5(iz_o,ix_o,iy_o); 
                            m1=>mod1(iz_m,ix_m,iy_m); m2=>mod2(iz_m,ix_m,iy_m); m3=>mod3(iz_m,ix_m,iy_m); m4=>mod4(iz_m,ix_m,iy_m); m5=>mod5(iz_m,ix_m,iy_m); 
                                d1 = d1 + HH1*m1 + HH2*m2 + HH3*m3 + HH4*m4 + HH5*m5 
                                d2 = d2 + HH2*m1 + HH2*m2 + HH3*m3 + HH4*m4 + HH5*m5 
                                d3 = d3 + HH3*m1 + HH3*m2 + HH3*m3 + HH4*m4 + HH5*m5 
                                d4 = d4 + HH4*m1 + HH4*m2 + HH4*m3 + HH4*m4 + HH5*m5 
                                d5 = d5 + HH5*m1 + HH5*m2 + HH5*m3 + HH5*m4 + HH5*m5 
                        end if
                end do
                end do
                end do
                !$OMP end parallel do
        end do
        end do
        end do
    if (timing1)then
        call date_and_time(values=time_array_1)
        finish_time = time_array_1 (5) * 3600 + time_array_1 (6) * 60 + time_array_1 (7) + 0.001 * time_array_1 (8)
        write(0,*)'total time', finish_time - start_time
    endif
    return
  end subroutine
!#####################################
!#####################################
!/ | H16 H26 H36 H46 H56 H6|    
!/ | H26 H26 H36 H46 H56 H6|    
!/ | H36 H36 H36 H46 H56 H6|    
!/ | H46 H46 H46 H46 H56 H6|    
!/ | H56 H56 H56 H56 H56 H6|    
!/ |  H6  H6  H6  H6  H6 H6|    
  subroutine hess_convolve6(adj, mod1, mod2, mod3, mod4, mod5, mod6, dat1, dat2, dat3, dat4, dat5, dat6)
    logical               :: adj
    real                  :: HH6, HH5, HH4, HH3, HH2, HH1 
    real          ,pointer:: d1, d2, d3, d4, d5, d6
    real          ,pointer:: m1, m2, m3, m4, m5, m6
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n),target :: mod1, mod2, mod3, mod4, mod5, mod6
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n),target :: dat1, dat2, dat3, dat4, dat5, dat6

    if (timing1)then
        call date_and_time(values=time_array_0)
        start_time = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)
    endif
        
    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                call hess_io(hess1, hgrid, ix_modl, iy_modl, iz_modl, hess1_, "reed")
                call hess_io(hess2, hgrid, ix_modl, iy_modl, iz_modl, hess2_, "reed")
                call hess_io(hess3, hgrid, ix_modl, iy_modl, iz_modl, hess3_, "reed")
                call hess_io(hess4, hgrid, ix_modl, iy_modl, iz_modl, hess4_, "reed")
                call hess_io(hess5, hgrid, ix_modl, iy_modl, iz_modl, hess5_, "reed")
                call hess_io(hess6, hgrid, ix_modl, iy_modl, iz_modl, hess6_, "reed")
                !$OMP parallel do private(inode, iz_offd, iy_offd, ix_offd, iz_o, iy_o, ix_o, z_offd, y_offd, x_offd, HH1, HH2, HH3, HH4, HH5, HH6, d1, d2, d3, d4, d5, d6, m1, m2, m3, m4, m5, m6) schedule(dynamic) 
                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
                        iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
                        iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > ceiling(hgrid%ax_offd%n/2.)) cycle
                        ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        HH1=hess1(ix_offd,iy_offd,iz_offd)+hess2(ix_offd,iy_offd,iz_offd)+hess3(ix_offd,iy_offd,iz_offd)+hess4(ix_offd,iy_offd,iz_offd)+hess5(ix_offd,iy_offd,iz_offd)+hess6(ix_offd,iy_offd,iz_offd)
                        HH2=                               hess2(ix_offd,iy_offd,iz_offd)+hess3(ix_offd,iy_offd,iz_offd)+hess4(ix_offd,iy_offd,iz_offd)+hess5(ix_offd,iy_offd,iz_offd)+hess6(ix_offd,iy_offd,iz_offd)
                        HH3=                                                              hess3(ix_offd,iy_offd,iz_offd)+hess4(ix_offd,iy_offd,iz_offd)+hess5(ix_offd,iy_offd,iz_offd)+hess6(ix_offd,iy_offd,iz_offd)
                        HH4=                                                                                             hess4(ix_offd,iy_offd,iz_offd)+hess5(ix_offd,iy_offd,iz_offd)+hess6(ix_offd,iy_offd,iz_offd) 
                        HH5=                                                                                                                            hess5(ix_offd,iy_offd,iz_offd)+hess6(ix_offd,iy_offd,iz_offd)
                        HH6=                                                                                                                                                           hess6(ix_offd,iy_offd,iz_offd)
                        if (adj) then
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); d3=>dat3(iz_m,ix_m,iy_m); d4=>dat4(iz_m,ix_m,iy_m); d5=>dat5(iz_m,ix_m,iy_m); d6=>dat6(iz_m,ix_m,iy_m);
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); m3=>mod3(iz_o,ix_o,iy_o); m4=>mod4(iz_o,ix_o,iy_o); m5=>mod5(iz_o,ix_o,iy_o); m6=>mod6(iz_o,ix_o,iy_o);
                                
                                m1 = m1 + HH1*d1 + HH2*d2 + HH3*d3 + HH4*d4 + HH5*d5 + HH6*d6 
                                m2 = m2 + HH2*d1 + HH2*d2 + HH3*d3 + HH4*d4 + HH5*d5 + HH6*d6 
                                m3 = m3 + HH3*d1 + HH3*d2 + HH3*d3 + HH4*d4 + HH5*d5 + HH6*d6 
                                m4 = m4 + HH4*d1 + HH4*d2 + HH4*d3 + HH4*d4 + HH5*d5 + HH6*d6 
                                m5 = m5 + HH5*d1 + HH5*d2 + HH5*d3 + HH5*d4 + HH5*d5 + HH6*d6 
                                m6 = m6 + HH6*d1 + HH6*d2 + HH6*d3 + HH6*d4 + HH6*d5 + HH6*d6 
                            d1=>dat1(iz_o,ix_o,iy_o); d2=>dat2(iz_o,ix_o,iy_o); d3=>dat3(iz_o,ix_o,iy_o); d4=>dat4(iz_o,ix_o,iy_o); d5=>dat5(iz_o,ix_o,iy_o); d6=>dat6(iz_o,ix_o,iy_o);
                            m1=>mod1(iz_m,ix_m,iy_m); m2=>mod2(iz_m,ix_m,iy_m); m3=>mod3(iz_m,ix_m,iy_m); m4=>mod4(iz_m,ix_m,iy_m); m5=>mod5(iz_m,ix_m,iy_m); m6=>mod6(iz_m,ix_m,iy_m);
                                m1 = m1 + HH1*d1 + HH2*d2 + HH3*d3 + HH4*d4 + HH5*d5 + HH6*d6 
                                m2 = m2 + HH2*d1 + HH2*d2 + HH3*d3 + HH4*d4 + HH5*d5 + HH6*d6 
                                m3 = m3 + HH3*d1 + HH3*d2 + HH3*d3 + HH4*d4 + HH5*d5 + HH6*d6 
                                m4 = m4 + HH4*d1 + HH4*d2 + HH4*d3 + HH4*d4 + HH5*d5 + HH6*d6 
                                m5 = m5 + HH5*d1 + HH5*d2 + HH5*d3 + HH5*d4 + HH5*d5 + HH6*d6 
                                m6 = m6 + HH6*d1 + HH6*d2 + HH6*d3 + HH6*d4 + HH6*d5 + HH6*d6 
                        else 
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); d3=>dat3(iz_m,ix_m,iy_m); d4=>dat4(iz_m,ix_m,iy_m); d5=>dat5(iz_m,ix_m,iy_m); d6=>dat6(iz_m,ix_m,iy_m);
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); m3=>mod3(iz_o,ix_o,iy_o); m4=>mod4(iz_o,ix_o,iy_o); m5=>mod5(iz_o,ix_o,iy_o); m6=>mod6(iz_o,ix_o,iy_o);
                                d1 = d1 + HH1*m1 + HH2*m2 + HH3*m3 + HH4*m4 + HH5*m5 + HH6*m6 
                                d2 = d2 + HH2*m1 + HH2*m2 + HH3*m3 + HH4*m4 + HH5*m5 + HH6*m6 
                                d3 = d3 + HH3*m1 + HH3*m2 + HH3*m3 + HH4*m4 + HH5*m5 + HH6*m6 
                                d4 = d4 + HH4*m1 + HH4*m2 + HH4*m3 + HH4*m4 + HH5*m5 + HH6*m6 
                                d5 = d5 + HH5*m1 + HH5*m2 + HH5*m3 + HH5*m4 + HH5*m5 + HH6*m6 
                                d6 = d6 + HH6*m1 + HH6*m2 + HH6*m3 + HH6*m4 + HH6*m5 + HH6*m6 
                            d1=>dat1(iz_o,ix_o,iy_o); d2=>dat2(iz_o,ix_o,iy_o); d3=>dat3(iz_o,ix_o,iy_o); d4=>dat4(iz_o,ix_o,iy_o); d5=>dat5(iz_o,ix_o,iy_o); d6=>dat6(iz_o,ix_o,iy_o);
                            m1=>mod1(iz_m,ix_m,iy_m); m2=>mod2(iz_m,ix_m,iy_m); m3=>mod3(iz_m,ix_m,iy_m); m4=>mod4(iz_m,ix_m,iy_m); m5=>mod5(iz_m,ix_m,iy_m); m6=>mod6(iz_m,ix_m,iy_m);
                                d1 = d1 + HH1*m1 + HH2*m2 + HH3*m3 + HH4*m4 + HH5*m5 + HH6*m6 
                                d2 = d2 + HH2*m1 + HH2*m2 + HH3*m3 + HH4*m4 + HH5*m5 + HH6*m6 
                                d3 = d3 + HH3*m1 + HH3*m2 + HH3*m3 + HH4*m4 + HH5*m5 + HH6*m6 
                                d4 = d4 + HH4*m1 + HH4*m2 + HH4*m3 + HH4*m4 + HH5*m5 + HH6*m6 
                                d5 = d5 + HH5*m1 + HH5*m2 + HH5*m3 + HH5*m4 + HH5*m5 + HH6*m6 
                                d6 = d6 + HH6*m1 + HH6*m2 + HH6*m3 + HH6*m4 + HH6*m5 + HH6*m6 
                        end if
                end do
                end do
                end do
                !$OMP end parallel do
        end do
        end do
        end do
    if (timing1)then
        call date_and_time(values=time_array_1)
        finish_time = time_array_1 (5) * 3600 + time_array_1 (6) * 60 + time_array_1 (7) + 0.001 * time_array_1 (8)
        write(0,*)'total time', finish_time - start_time
    endif
    return
  end subroutine


!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!#####################################
  subroutine hess_convolve_1(adj, mod1, dat1)
    logical                       :: adj
    real                          :: HH
    real                 ,pointer :: d
    real                 ,pointer :: m
    real    ,dimension(h3%n, h4%n, h5%n, h8%n, h9%n) :: HH_1 
    real    ,dimension(h10%n, h8%n, h9%n) ,target :: mod1 
    real    ,dimension(h10%n, h8%n, h9%n) ,target :: dat1 
    real                  :: start_time, finish_time
    integer               :: time_array_0(8), time_array_1(8)

    if (timing1)then
        call date_and_time(values=time_array_0)
        start_time = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)
    endif
        
    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
         call hess_io3(hes1, hgrid, iz_modl, hess1_, "reed")
         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
                        iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
                        iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > ceiling(hgrid%ax_offd%n/2.)) cycle
                        ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        HH=hes1(ix_offd,iy_offd,iz_offd,ix_m,iy_m)
                        if (adj) then
                            d=>dat1(iz_m,ix_m,iy_m);  
                            m=>mod1(iz_o,ix_o,iy_o);  
                                m = m + HH*d  
                            d=>dat1(iz_o,ix_o,iy_o);  
                            m=>mod1(iz_m,ix_m,iy_m);  
                                m = m + HH*d 
                        else 
                            d=>dat1(iz_m,ix_m,iy_m); 
                            m=>mod1(iz_o,ix_o,iy_o);  
                                d = d + HH*m 
                            d=>dat1(iz_o,ix_o,iy_o); 
                            m=>mod1(iz_m,ix_m,iy_m); 
                                d = d + HH*m 
                        end if
                end do
                end do
                end do
        end do
        end do
        end do
    if (timing1)then
        call date_and_time(values=time_array_1)
        finish_time = time_array_1 (5) * 3600 + time_array_1 (6) * 60 + time_array_1 (7) + 0.001 * time_array_1 (8)
        write(0,*)'total time', finish_time - start_time
    endif
    return
  end subroutine
!#####################################
!/ | H12 H2|    
!/ | H2  H2|    
  subroutine hess_convolve_2(adj, mod1, mod2, dat1, dat2)
    logical               :: adj
    real                  :: HH2,  HH1 
    real    ,dimension(h3%n, h4%n, h5%n, h8%n, h9%n) :: HH_2, HH_1 
    real          ,pointer:: d1, d2
    real          ,pointer:: m1, m2
    real    ,dimension(h10%n, h8%n, h9%n) ,target :: mod1,mod2 
    real    ,dimension(h10%n, h8%n, h9%n) ,target :: dat1,dat2 
    real                  :: Hm2, Hm1 
    real                  :: Hd2, Hd1 
    real                  :: start_time, finish_time
    integer               :: time_array_0(8), time_array_1(8)

    if (timing1)then
        call date_and_time(values=time_array_0)
        start_time = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)
    endif

    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
                call hess_io3(hes1, hgrid, iz_modl, hess1_, "reed")
                call hess_io3(hes2, hgrid, iz_modl, hess2_, "reed")
                HH_1=hes1+hes2
                HH_2=     hes2
        !$OMP parallel do private(inode, iy_modl, ix_modl, y_modl, x_modl, iy_m, ix_m, iz_offd, iy_offd, ix_offd, iz_o, iy_o, ix_o, z_offd, y_offd, x_offd, HH1, HH2, d1, d2,  m1, m2, Hm2, Hm1, Hd2, Hd1  )  
         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
                        iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
                        iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > ceiling(hgrid%ax_offd%n/2.)) cycle
                        ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        HH1=HH_1(ix_offd,iy_offd,iz_offd,ix_m,iy_m); HH2=HH_2(ix_offd,iy_offd,iz_offd,ix_m,iy_m); 
                        if (adj) then
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); 
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); 
                            Hd2=HH2*d2
                                m1 = m1 + HH1*d1 + Hd2       
                                m2 = m2 + HH2*d1 + Hd2       
                            d1=>dat1(iz_o,ix_o,iy_o); d2=>dat2(iz_o,ix_o,iy_o); 
                            m1=>mod1(iz_m,ix_m,iy_m); m2=>mod2(iz_m,ix_m,iy_m); 
                            Hd2=HH2*d2
                                m1 = m1 + HH1*d1 + Hd2       
                                m2 = m2 + HH2*d1 + Hd2       
                        else 
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); 
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); 
                            Hm2=HH2*m2
                                d1 = d1 + HH1*m1 + Hm2   
                                d2 = d2 + HH2*m1 + Hm2  
                            d1=>dat1(iz_o,ix_o,iy_o); d2=>dat2(iz_o,ix_o,iy_o); 
                            m1=>mod1(iz_m,ix_m,iy_m); m2=>mod2(iz_m,ix_m,iy_m); 
                            Hm2=HH2*m2
                                d1 = d1 + HH1*m1 + Hm2   
                                d2 = d2 + HH2*m1 + Hm2  
                        end if
                end do
                end do
                end do
        end do
        end do
        !$OMP end parallel do
        end do
    if (timing1)then
        call date_and_time(values=time_array_1)
        finish_time = time_array_1 (5) * 3600 + time_array_1 (6) * 60 + time_array_1 (7) + 0.001 * time_array_1 (8)
        write(0,*)'total time', finish_time - start_time
    endif
    return
  end subroutine
!
!#####################################
!/ | H13 H23 H3|    
!/ | H23 H23 H3|    
!/ | H3  H3  H3|    
 subroutine hess_convolve_3(adj, mod1, mod2, mod3, dat1, dat2, dat3)
    logical               :: adj
    real                  :: HH3,  HH2,  HH1 
    real    ,dimension(h3%n, h4%n, h5%n, h8%n, h9%n) :: HH_3, HH_2, HH_1 
    real          ,pointer:: d1, d2, d3
    real          ,pointer:: m1, m2, m3
    real    ,dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) ,target:: mod1, mod2, mod3
    real    ,dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) ,target:: dat1, dat2, dat3
    real                  :: Hm3, Hm2, Hm1 
    real                  :: Hd3, Hd2, Hd1 
    real                  :: start_time, finish_time
    integer               :: time_array_0(8), time_array_1(8)

    if (timing1)then
        call date_and_time(values=time_array_0)
        start_time = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)
    endif
        
    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
                call hess_io3(hes1, hgrid, iz_modl, hess1_, "reed")
                call hess_io3(hes2, hgrid, iz_modl, hess2_, "reed")
                call hess_io3(hes3, hgrid, iz_modl, hess3_, "reed")
                HH_1=hes1+hes2+hes3
                HH_2=     hes2+hes3
                HH_3=          hes3
        !$OMP parallel do private(inode, iy_modl, ix_modl, y_modl, x_modl, iy_m, ix_m, iz_offd, iy_offd, ix_offd, iz_o, iy_o, ix_o, z_offd, y_offd, x_offd, HH1, HH2, HH3, d1, d2, d3, m1, m2, m3, Hm3, Hm2, Hm1, Hd3, Hd2, Hd1  )  
         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
                        iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
                        iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > ceiling(hgrid%ax_offd%n/2.)) cycle
                        ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        HH1=HH_1(ix_offd,iy_offd,iz_offd,ix_m,iy_m); HH2=HH_2(ix_offd,iy_offd,iz_offd,ix_m,iy_m); HH3=HH_3(ix_offd,iy_offd,iz_offd,ix_m,iy_m);
                        if (adj) then
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); d3=>dat3(iz_m,ix_m,iy_m); 
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); m3=>mod3(iz_o,ix_o,iy_o); 
                            Hd3=HH3*d3; Hd2=HH2*d2
                                m1 = m1 + HH1*d1 + Hd2    + Hd3    
                                m2 = m2 + HH2*d1 + Hd2    + Hd3    
                                m3 = m3 + HH3*d1 + HH3*d2 + Hd3    
                            d1=>dat1(iz_o,ix_o,iy_o); d2=>dat2(iz_o,ix_o,iy_o); d3=>dat3(iz_o,ix_o,iy_o); 
                            m1=>mod1(iz_m,ix_m,iy_m); m2=>mod2(iz_m,ix_m,iy_m); m3=>mod3(iz_m,ix_m,iy_m); 
                            Hd3=HH3*d3; Hd2=HH2*d2
                                m1 = m1 + HH1*d1 + Hd2    + Hd3    
                                m2 = m2 + HH2*d1 + Hd2    + Hd3    
                                m3 = m3 + HH3*d1 + HH3*d2 + Hd3    
                        else 
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); d3=>dat3(iz_m,ix_m,iy_m); 
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); m3=>mod3(iz_o,ix_o,iy_o); 
                            Hm3=HH3*m3; Hm2=HH2*m2
                                d1 = d1 + HH1*m1 + Hm2    + Hm3    
                                d2 = d2 + HH2*m1 + Hm2    + Hm3    
                                d3 = d3 + HH3*m1 + HH3*m2 + Hm3        
                            d1=>dat1(iz_o,ix_o,iy_o); d2=>dat2(iz_o,ix_o,iy_o); d3=>dat3(iz_o,ix_o,iy_o); 
                            m1=>mod1(iz_m,ix_m,iy_m); m2=>mod2(iz_m,ix_m,iy_m); m3=>mod3(iz_m,ix_m,iy_m); 
                            Hm3=HH3*m3; Hm2=HH2*m2
                                d1 = d1 + HH1*m1 + Hm2    + Hm3   
                                d2 = d2 + HH2*m1 + Hm2    + Hm3   
                                d3 = d3 + HH3*m1 + HH3*m2 + Hm3   
                        end if
                end do
                end do
                end do
        end do
        end do
        !$OMP end parallel do
        end do
    if (timing1)then
        call date_and_time(values=time_array_1)
        finish_time = time_array_1 (5) * 3600 + time_array_1 (6) * 60 + time_array_1 (7) + 0.001 * time_array_1 (8)
        write(0,*)'total time', finish_time - start_time
    endif
    return
  end subroutine
!#####################################
!/ | H14 H24 H34 H4|    
!/ | H24 H24 H34 H4|    
!/ | H34 H34 H34 H4|    
!/ |  H4  H4  H4 H4|    
  subroutine hess_convolve_4(adj, mod1, mod2, mod3, mod4, dat1, dat2, dat3, dat4)
    logical               :: adj
    real                  :: HH4,  HH3,  HH2,  HH1 
    real    ,dimension(h3%n, h4%n, h5%n, h8%n, h9%n) :: HH_4, HH_3, HH_2, HH_1 
    real          ,pointer:: d1, d2, d3, d4
    real          ,pointer:: m1, m2, m3, m4
    real    ,dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) ,target:: mod1, mod2, mod3, mod4
    real    ,dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) ,target:: dat1, dat2, dat3, dat4
    real                  :: Hm4, Hm3, Hm2, Hm1 
    real                  :: Hd4, Hd3, Hd2, Hd1 
    integer               :: a1
    logical               :: logic
    real                  :: start_time, finish_time
    integer               :: time_array_0(8), time_array_1(8)

    if (timing1)then
        call date_and_time(values=time_array_0)
        start_time = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)
    endif

    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
                call hess_io3(hes1, hgrid, iz_modl, hess1_, "reed")
                call hess_io3(hes2, hgrid, iz_modl, hess2_, "reed")
                call hess_io3(hes3, hgrid, iz_modl, hess3_, "reed")
                call hess_io3(hes4, hgrid, iz_modl, hess4_, "reed")
                HH_1=hes1+hes2+hes3+hes4
                HH_2=     hes2+hes3+hes4
                HH_3=          hes3+hes4
                HH_4=               hes4
        !$OMP parallel do private(inode, iy_modl, ix_modl, y_modl, x_modl, iy_m, ix_m, iz_offd, iy_offd, ix_offd, iz_o, iy_o, ix_o, z_offd, y_offd, x_offd, HH1, HH2, HH3, HH4, d1, d2, d3, d4, m1, m2, m3, m4, Hm4, Hm3, Hm2, Hm1, Hd4, Hd3, Hd2, Hd1  )  
         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d;
                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
                        iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
                        iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > ceiling(hgrid%ax_offd%n/2.)) cycle
                        ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        HH1=HH_1(ix_offd,iy_offd,iz_offd,ix_m,iy_m); HH2=HH_2(ix_offd,iy_offd,iz_offd,ix_m,iy_m); HH3=HH_3(ix_offd,iy_offd,iz_offd,ix_m,iy_m); HH4=HH_4(ix_offd,iy_offd,iz_offd,ix_m,iy_m); 
                        if (adj) then
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); d3=>dat3(iz_m,ix_m,iy_m); d4=>dat4(iz_m,ix_m,iy_m); 
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); m3=>mod3(iz_o,ix_o,iy_o); m4=>mod4(iz_o,ix_o,iy_o); 
                            Hd4=HH4*d4; Hd3=HH3*d3; Hd2=HH2*d2
                                m1 = m1 + HH1*d1 + Hd2    + Hd3    + Hd4    
                                m2 = m2 + HH2*d1 + Hd2    + Hd3    + Hd4    
                                m3 = m3 + HH3*d1 + HH3*d2 + Hd3    + Hd4    
                                m4 = m4 + HH4*d1 + HH4*d2 + HH4*d3 + Hd4    
                            d1=>dat1(iz_o,ix_o,iy_o); d2=>dat2(iz_o,ix_o,iy_o); d3=>dat3(iz_o,ix_o,iy_o); d4=>dat4(iz_o,ix_o,iy_o); 
                            m1=>mod1(iz_m,ix_m,iy_m); m2=>mod2(iz_m,ix_m,iy_m); m3=>mod3(iz_m,ix_m,iy_m); m4=>mod4(iz_m,ix_m,iy_m); 
                            Hd4=HH4*d4; Hd3=HH3*d3; Hd2=HH2*d2
                                m1 = m1 + HH1*d1 + Hd2    + Hd3    + Hd4    
                                m2 = m2 + HH2*d1 + Hd2    + Hd3    + Hd4    
                                m3 = m3 + HH3*d1 + HH3*d2 + Hd3    + Hd4    
                                m4 = m4 + HH4*d1 + HH4*d2 + HH4*d3 + Hd4    
                        else 
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); d3=>dat3(iz_m,ix_m,iy_m); d4=>dat4(iz_m,ix_m,iy_m); 
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); m3=>mod3(iz_o,ix_o,iy_o); m4=>mod4(iz_o,ix_o,iy_o); 
                            Hm4=HH4*m4; Hm3=HH3*m3; Hm2=HH2*m2
                                d1 = d1 + HH1*m1 + Hm2    + Hm3    + Hm4    
                                d2 = d2 + HH2*m1 + Hm2    + Hm3    + Hm4    
                                d3 = d3 + HH3*m1 + HH3*m2 + Hm3    + Hm4    
                                d4 = d4 + HH4*m1 + HH4*m2 + HH4*m3 + Hm4           
                            d1=>dat1(iz_o,ix_o,iy_o); d2=>dat2(iz_o,ix_o,iy_o); d3=>dat3(iz_o,ix_o,iy_o); d4=>dat4(iz_o,ix_o,iy_o); 
                            m1=>mod1(iz_m,ix_m,iy_m); m2=>mod2(iz_m,ix_m,iy_m); m3=>mod3(iz_m,ix_m,iy_m); m4=>mod4(iz_m,ix_m,iy_m);
                            Hm4=HH4*m4; Hm3=HH3*m3; Hm2=HH2*m2
                                d1 = d1 + HH1*m1 + Hm2    + Hm3    + Hm4    
                                d2 = d2 + HH2*m1 + Hm2    + Hm3    + Hm4    
                                d3 = d3 + HH3*m1 + HH3*m2 + Hm3    + Hm4    
                                d4 = d4 + HH4*m1 + HH4*m2 + HH4*m3 + Hm4           
                        end if
                end do
                end do
                end do
        end do
        end do
        !$OMP end parallel do
        end do
    if (timing1)then
        call date_and_time(values=time_array_1)
        finish_time = time_array_1 (5) * 3600 + time_array_1 (6) * 60 + time_array_1 (7) + 0.001 * time_array_1 (8)
        write(0,*)'total time', finish_time - start_time
    endif
    return
  end subroutine

!#####################################
!/ | H15 H25 H35 H45 H5|    
!/ | H25 H25 H35 H45 H5|    
!/ | H35 H35 H35 H45 H5|    
!/ | H45 H45 H45 H45 H5|    
!/ |  H5  H5  H5  H5 H5|    
  subroutine hess_convolve_5(adj, mod1, mod2, mod3, mod4, mod5, dat1, dat2, dat3, dat4, dat5)
    logical               :: adj
    real                  :: HH5,  HH4,  HH3,  HH2,  HH1 
    real    ,dimension(h3%n, h4%n, h5%n, h8%n, h9%n) :: HH_5, HH_4, HH_3, HH_2, HH_1 
    real          ,pointer:: d1, d2, d3, d4, d5
    real          ,pointer:: m1, m2, m3, m4, m5
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n),target :: mod1, mod2, mod3, mod4, mod5
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n),target :: dat1, dat2, dat3, dat4, dat5
    real                  :: Hm5, Hm4, Hm3, Hm2, Hm1 
    real                  :: Hd5, Hd4, Hd3, Hd2, Hd1 
    real                  :: start_time, finish_time
    integer               :: time_array_0(8), time_array_1(8)

    if (timing1)then
        call date_and_time(values=time_array_0)
        start_time = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)
    endif
        
    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
                call hess_io3(hes1, hgrid, iz_modl, hess1_, "reed")
                call hess_io3(hes2, hgrid, iz_modl, hess2_, "reed")
                call hess_io3(hes3, hgrid, iz_modl, hess3_, "reed")
                call hess_io3(hes4, hgrid, iz_modl, hess4_, "reed")
                call hess_io3(hes5, hgrid, iz_modl, hess5_, "reed")
                HH_1=hes1+hes2+hes3+hes4+hes5
                HH_2=     hes2+hes3+hes4+hes5
                HH_3=          hes3+hes4+hes5
                HH_4=               hes4+hes5
                HH_5=                    hes5
        !$OMP parallel do private(inode, iy_modl, ix_modl, y_modl, x_modl, iy_m, ix_m, iz_offd, iy_offd, ix_offd, iz_o, iy_o, ix_o, z_offd, y_offd, x_offd, HH1, HH2, HH3, HH4, HH5, d1, d2, d3, d4, d5, m1, m2, m3, m4, m5, Hm5, Hm4, Hm3, Hm2, Hm1, Hd5, Hd4, Hd3, Hd2, Hd1  )  
         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
                        iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
                        iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > ceiling(hgrid%ax_offd%n/2.)) cycle
                        ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        HH1=HH_1(ix_offd,iy_offd,iz_offd,ix_m,iy_m); HH2=HH_2(ix_offd,iy_offd,iz_offd,ix_m,iy_m); HH3=HH_3(ix_offd,iy_offd,iz_offd,ix_m,iy_m); 
                        HH4=HH_4(ix_offd,iy_offd,iz_offd,ix_m,iy_m); HH5=HH_5(ix_offd,iy_offd,iz_offd,ix_m,iy_m); 
                        if (adj) then
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); d3=>dat3(iz_m,ix_m,iy_m); d4=>dat4(iz_m,ix_m,iy_m); d5=>dat5(iz_m,ix_m,iy_m); 
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); m3=>mod3(iz_o,ix_o,iy_o); m4=>mod4(iz_o,ix_o,iy_o); m5=>mod5(iz_o,ix_o,iy_o); 
                            Hd5=HH5*d5; Hd4=HH4*d4; Hd3=HH3*d3; Hd2=HH2*d2
                                m1 = m1 + HH1*d1 + Hd2    + Hd3    + Hd4    + Hd5    
                                m2 = m2 + HH2*d1 + Hd2    + Hd3    + Hd4    + Hd5    
                                m3 = m3 + HH3*d1 + HH3*d2 + Hd3    + Hd4    + Hd5    
                                m4 = m4 + HH4*d1 + HH4*d2 + HH4*d3 + Hd4    + Hd5   
                                m5 = m5 + HH5*d1 + HH5*d2 + HH5*d3 + HH5*d4 + Hd5    
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); d3=>dat3(iz_m,ix_m,iy_m); d4=>dat4(iz_m,ix_m,iy_m); d5=>dat5(iz_m,ix_m,iy_m); 
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); m3=>mod3(iz_o,ix_o,iy_o); m4=>mod4(iz_o,ix_o,iy_o); m5=>mod5(iz_o,ix_o,iy_o); 
                            Hd5=HH5*d5; Hd4=HH4*d4; Hd3=HH3*d3; Hd2=HH2*d2
                                m1 = m1 + HH1*d1 + Hd2    + Hd3    + Hd4    + Hd5    
                                m2 = m2 + HH2*d1 + Hd2    + Hd3    + Hd4    + Hd5    
                                m3 = m3 + HH3*d1 + HH3*d2 + Hd3    + Hd4    + Hd5    
                                m4 = m4 + HH4*d1 + HH4*d2 + HH4*d3 + Hd4    + Hd5   
                                m5 = m5 + HH5*d1 + HH5*d2 + HH5*d3 + HH5*d4 + Hd5    
                        else 
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); d3=>dat3(iz_m,ix_m,iy_m); d4=>dat4(iz_m,ix_m,iy_m); d5=>dat5(iz_m,ix_m,iy_m); 
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); m3=>mod3(iz_o,ix_o,iy_o); m4=>mod4(iz_o,ix_o,iy_o); m5=>mod5(iz_o,ix_o,iy_o); 
                                Hm5=HH5*m5; Hm4=HH4*m4; Hm3=HH3*m3; Hm2=HH2*m2
                                d1 = d1 + HH1*m1 + Hm2    + Hm3    + Hm4    + Hm5       
                                d2 = d2 + HH2*m1 + Hm2    + Hm3    + Hm4    + Hm5       
                                d3 = d3 + HH3*m1 + HH3*m2 + Hm3    + Hm4    + Hm5       
                                d4 = d4 + HH4*m1 + HH4*m2 + HH4*m3 + Hm4    + Hm5       
                                d5 = d5 + HH5*m1 + HH5*m2 + HH5*m3 + HH5*m4 + Hm5       
                            d1=>dat1(iz_o,ix_o,iy_o); d2=>dat2(iz_o,ix_o,iy_o); d3=>dat3(iz_o,ix_o,iy_o); d4=>dat4(iz_o,ix_o,iy_o); d5=>dat5(iz_o,ix_o,iy_o); 
                            m1=>mod1(iz_m,ix_m,iy_m); m2=>mod2(iz_m,ix_m,iy_m); m3=>mod3(iz_m,ix_m,iy_m); m4=>mod4(iz_m,ix_m,iy_m); m5=>mod5(iz_m,ix_m,iy_m); 
                                Hm5=HH5*m5; Hm4=HH4*m4; Hm3=HH3*m3; Hm2=HH2*m2
                                d1 = d1 + HH1*m1 + Hm2    + Hm3    + Hm4    + Hm5       
                                d2 = d2 + HH2*m1 + Hm2    + Hm3    + Hm4    + Hm5       
                                d3 = d3 + HH3*m1 + HH3*m2 + Hm3    + Hm4    + Hm5       
                                d4 = d4 + HH4*m1 + HH4*m2 + HH4*m3 + Hm4    + Hm5       
                                d5 = d5 + HH5*m1 + HH5*m2 + HH5*m3 + HH5*m4 + Hm5       
                        end if
                end do
                end do
                end do
        end do
        end do
       !$OMP end parallel do
        end do
    if (timing1)then
        call date_and_time(values=time_array_1)
        finish_time = time_array_1 (5) * 3600 + time_array_1 (6) * 60 + time_array_1 (7) + 0.001 * time_array_1 (8)
        write(0,*)'total time', finish_time - start_time
    endif
    return
  end subroutine
!#####################################
!/ | H16 H26 H36 H46 H56 H6|    
!/ | H26 H26 H36 H46 H56 H6|    
!/ | H36 H36 H36 H46 H56 H6|    
!/ | H46 H46 H46 H46 H56 H6|    
!/ | H56 H56 H56 H56 H56 H6|    
!/ |  H6  H6  H6  H6  H6 H6|    
  subroutine hess_convolve_6(adj, mod1, mod2, mod3, mod4, mod5, mod6, dat1, dat2, dat3, dat4, dat5, dat6)
    logical               :: adj
    real                  :: HH6, HH5, HH4, HH3, HH2, HH1 
    real    ,dimension(h3%n, h4%n, h5%n, h8%n, h9%n) :: HH_6, HH_5, HH_4, HH_3, HH_2, HH_1 
    real          ,pointer:: d1, d2, d3, d4, d5, d6
    real          ,pointer:: m1, m2, m3, m4, m5, m6
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n),target :: mod1, mod2, mod3, mod4, mod5, mod6
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n),target :: dat1, dat2, dat3, dat4, dat5, dat6
    real                  :: Hm6, Hm5, Hm4, Hm3, Hm2, Hm1 
    real                  :: Hd6, Hd5, Hd4, Hd3, Hd2, Hd1 
    real                  :: start_time, finish_time
    integer               :: time_array_0(8), time_array_1(8)

    if (timing1)then
        call date_and_time(values=time_array_0)
        start_time = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)
    endif
        
    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
                call hess_io3(hes1, hgrid, iz_modl, hess1_, "reed") 
                call hess_io3(hes2, hgrid, iz_modl, hess2_, "reed")
                call hess_io3(hes3, hgrid, iz_modl, hess3_, "reed")
                call hess_io3(hes4, hgrid, iz_modl, hess4_, "reed")
                call hess_io3(hes5, hgrid, iz_modl, hess5_, "reed")
                call hess_io3(hes6, hgrid, iz_modl, hess6_, "reed")
                HH_1=hes1+hes2+hes3+hes4+hes5+hes6
                HH_2=     hes2+hes3+hes4+hes5+hes6
                HH_3=          hes3+hes4+hes5+hes6
                HH_4=               hes4+hes5+hes6
                HH_5=                    hes5+hes6
                HH_6=                         hes6
        !$OMP parallel do private(inode, iy_modl, ix_modl, y_modl, x_modl, iy_m, ix_m, iz_offd, iy_offd, ix_offd, iz_o, iy_o, ix_o, z_offd, y_offd, x_offd, HH1, HH2, HH3, HH4, HH5, HH6, d1, d2, d3, d4, d5, d6, m1, m2, m3, m4, m5, m6, Hm6, Hm5, Hm4, Hm3, Hm2, Hm1, Hd6, Hd5, Hd4, Hd3, Hd2, Hd1  )  
         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
                        iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
                        iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > ceiling(hgrid%ax_offd%n/2.)) cycle
                        ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        HH1=HH_1(ix_offd,iy_offd,iz_offd,ix_m,iy_m); HH2=HH_2(ix_offd,iy_offd,iz_offd,ix_m,iy_m); HH3=HH_3(ix_offd,iy_offd,iz_offd,ix_m,iy_m); 
                        HH4=HH_4(ix_offd,iy_offd,iz_offd,ix_m,iy_m); HH5=HH_5(ix_offd,iy_offd,iz_offd,ix_m,iy_m); HH6=HH_6(ix_offd,iy_offd,iz_offd,ix_m,iy_m); 
                        if (adj) then
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); d3=>dat3(iz_m,ix_m,iy_m); d4=>dat4(iz_m,ix_m,iy_m); d5=>dat5(iz_m,ix_m,iy_m); d6=>dat6(iz_m,ix_m,iy_m);
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); m3=>mod3(iz_o,ix_o,iy_o); m4=>mod4(iz_o,ix_o,iy_o); m5=>mod5(iz_o,ix_o,iy_o); m6=>mod6(iz_o,ix_o,iy_o);
                                Hd6=HH6*d6; Hd5=HH5*d5; Hd4=HH4*d4; Hd3=HH3*d3; Hd2=HH2*d2
                                m1 = m1 + HH1*d1 + Hd2    + Hd3    + Hd4    + Hd5    + Hd6
                                m2 = m2 + HH2*d1 + Hd2    + Hd3    + Hd4    + Hd5    + Hd6
                                m3 = m3 + HH3*d1 + HH3*d2 + Hd3    + Hd4    + Hd5    + Hd6
                                m4 = m4 + HH4*d1 + HH4*d2 + HH4*d3 + Hd4    + Hd5    + Hd6
                                m5 = m5 + HH5*d1 + HH5*d2 + HH5*d3 + HH5*d4 + Hd5    + Hd6
                                m6 = m6 + HH6*d1 + HH6*d2 + HH6*d3 + HH6*d4 + HH6*d5 + Hd6
                            d1=>dat1(iz_o,ix_o,iy_o); d2=>dat2(iz_o,ix_o,iy_o); d3=>dat3(iz_o,ix_o,iy_o); d4=>dat4(iz_o,ix_o,iy_o); d5=>dat5(iz_o,ix_o,iy_o); d6=>dat6(iz_o,ix_o,iy_o);
                            m1=>mod1(iz_m,ix_m,iy_m); m2=>mod2(iz_m,ix_m,iy_m); m3=>mod3(iz_m,ix_m,iy_m); m4=>mod4(iz_m,ix_m,iy_m); m5=>mod5(iz_m,ix_m,iy_m); m6=>mod6(iz_m,ix_m,iy_m);
                                Hd6=HH6*d6; Hd5=HH5*d5; Hd4=HH4*d4; Hd3=HH3*d3; Hd2=HH2*d2
                                m1 = m1 + HH1*d1 + Hd2    + Hd3    + Hd4    + Hd5    + Hd6
                                m2 = m2 + HH2*d1 + Hd2    + Hd3    + Hd4    + Hd5    + Hd6
                                m3 = m3 + HH3*d1 + HH3*d2 + Hd3    + Hd4    + Hd5    + Hd6
                                m4 = m4 + HH4*d1 + HH4*d2 + HH4*d3 + Hd4    + Hd5    + Hd6
                                m5 = m5 + HH5*d1 + HH5*d2 + HH5*d3 + HH5*d4 + Hd5    + Hd6
                                m6 = m6 + HH6*d1 + HH6*d2 + HH6*d3 + HH6*d4 + HH6*d5 + Hd6
                        else 
                            d1=>dat1(iz_m,ix_m,iy_m); d2=>dat2(iz_m,ix_m,iy_m); d3=>dat3(iz_m,ix_m,iy_m); d4=>dat4(iz_m,ix_m,iy_m); d5=>dat5(iz_m,ix_m,iy_m); d6=>dat6(iz_m,ix_m,iy_m);
                            m1=>mod1(iz_o,ix_o,iy_o); m2=>mod2(iz_o,ix_o,iy_o); m3=>mod3(iz_o,ix_o,iy_o); m4=>mod4(iz_o,ix_o,iy_o); m5=>mod5(iz_o,ix_o,iy_o); m6=>mod6(iz_o,ix_o,iy_o);
                                Hm6=HH6*m6; Hm5=HH5*m5; Hm4=HH4*m4; Hm3=HH3*m3; Hm2=HH2*m2
                                d1 = d1 + HH1*m1 + Hm2    + Hm3    + Hm4    + Hm5    + Hm6    
                                d2 = d2 + HH2*m1 + Hm2    + Hm3    + Hm4    + Hm5    + Hm6    
                                d3 = d3 + HH3*m1 + HH3*m2 + Hm3    + Hm4    + Hm5    + Hm6    
                                d4 = d4 + HH4*m1 + HH4*m2 + HH4*m3 + Hm4    + Hm5    + Hm6    
                                d5 = d5 + HH5*m1 + HH5*m2 + HH5*m3 + HH5*m4 + Hm5    + Hm6    
                                d6 = d6 + HH6*m1 + HH6*m2 + HH6*m3 + HH6*m4 + HH6*m5 + Hm6    
                            d1=>dat1(iz_o,ix_o,iy_o); d2=>dat2(iz_o,ix_o,iy_o); d3=>dat3(iz_o,ix_o,iy_o); d4=>dat4(iz_o,ix_o,iy_o); d5=>dat5(iz_o,ix_o,iy_o); d6=>dat6(iz_o,ix_o,iy_o);
                            m1=>mod1(iz_m,ix_m,iy_m); m2=>mod2(iz_m,ix_m,iy_m); m3=>mod3(iz_m,ix_m,iy_m); m4=>mod4(iz_m,ix_m,iy_m); m5=>mod5(iz_m,ix_m,iy_m); m6=>mod6(iz_m,ix_m,iy_m);
                                Hm6=HH6*m6; Hm5=HH5*m5; Hm4=HH4*m4; Hm3=HH3*m3; Hm2=HH2*m2
                                d1 = d1 + HH1*m1 + Hm2    + Hm3    + Hm4    + Hm5    + Hm6    
                                d2 = d2 + HH2*m1 + Hm2    + Hm3    + Hm4    + Hm5    + Hm6    
                                d3 = d3 + HH3*m1 + HH3*m2 + Hm3    + Hm4    + Hm5    + Hm6    
                                d4 = d4 + HH4*m1 + HH4*m2 + HH4*m3 + Hm4    + Hm5    + Hm6    
                                d5 = d5 + HH5*m1 + HH5*m2 + HH5*m3 + HH5*m4 + Hm5    + Hm6    
                                d6 = d6 + HH6*m1 + HH6*m2 + HH6*m3 + HH6*m4 + HH6*m5 + Hm6    
                        end if
                end do
                end do
                end do
        end do
        end do
                !$OMP end parallel do
        end do
    if (timing1)then
        call date_and_time(values=time_array_1)
        finish_time = time_array_1 (5) * 3600 + time_array_1 (6) * 60 + time_array_1 (7) + 0.001 * time_array_1 (8)
        write(0,*)'total time', finish_time - start_time
    endif
    return
  end subroutine



end module

