!RJMI
module hessian_convolve_module2_3d
 use  hessian_convolve_params
  use hessian_convolve_io

  implicit none

contains
!#######
  !subroutine  hessian_convolve(adj, mod1, dat1, mod2, dat2, mod3, dat3, mod4, dat4, mod5, dat5, mod6, dat6 ) 
  subroutine  hessian_convolve2_3d(adj, add)
  logical            :: adj, add
         if (nsurv > 5) then
                !call hess_convolve__6_3d(adj, modl1, modl2, modl3, modl4, modl5, modl6, data1, data2, data3, data4, data5, data6 )
         elseif (nsurv > 4) then
                !call hess_convolve__5_3d(adj, modl1, modl2, modl3, modl4, modl5       , data1, data2, data3, data4, data5        )
         elseif (nsurv > 3) then
                !call hess_convolve__4_3d(adj, modl1, modl2, modl3, modl4              , data1, data2, data3, data4               )
         elseif (nsurv > 2) then
                !call hess_convolve__3_3d(adj, modl1, modl2, modl3                     , data1, data2, data3                      )
         elseif (nsurv > 1) then
                call hess_convolve__2_3d(adj, modl1, modl2                            , data1, data2                             )
         elseif (nsurv > 0) then
                call hess_convolve__1_3d(adj, modl1                                   , data1                                    )
         endif
   end subroutine

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  subroutine hess_convolve__1_3d(adj, mod1, dat1)
    logical                       :: adj
    real                          :: HH1
    real                 ,pointer :: d1
    real                 ,pointer :: m1
    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n,nodes),target :: tmod1
    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n,nodes),target :: tdat1
    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n),target :: mod1
    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n),target :: dat1
    real, dimension(hgrid%ax_offd%n,hgrid%ay_offd%n,hgrid%az_offd%n,hgrid%ax_modl%n,hgrid%ay_modl%n),target :: hess1
    real                  :: start_time, finish_time
    integer               :: time_array_0(8), time_array_1(8)
    if (timing1)then
        call date_and_time(values=time_array_0)
        start_time = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)
    endif
    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
    tdat1=0;
    tmod1=0;
    if(.not.halfhess)then
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
             call hess_io_iz(hess1, hgrid, iz_modl, hess1_, "reed")
            !$OMP parallel do private(inode,          iy_modl, ix_modl,         y_modl, x_modl,       iy_m, ix_m, & 
            !$OMP                            iz_offd, iy_offd, ix_offd, z_offd, y_offd, x_offd, iz_o, iy_o, ix_o, &
            !$OMP                                   HH1, &
            !$OMP                                    d1, &
            !$OMP                                    m1 ) schedule (static,hgrid%az_modl%n/nodes)
                 do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;  inode=omp_get_thread_num()+1;
                 do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                                if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
                                iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
                        do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                                if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
                                iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                        do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                                if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
                                ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                                HH1=hess1(ix_offd,iy_offd,iz_offd,ix_m,iy_m); 
                                if (adj) then
                                    d1=> dat1(ix_o,iy_o,iz_o      ); 
                                    m1=>tmod1(ix_m,iy_m,iz_m,inode); 
                                        m1 = m1 + HH1*d1;
                                else
                                    d1=>tdat1(ix_m,iy_m,iz_m,inode);
                                    m1=> mod1(ix_o,iy_o,iz_o      );
                                        d1 = d1 + HH1*m1; 
                                end if
                        end do
                        end do
                        end do
                end do
                end do
            !$OMP end parallel do
         end do
     else
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
             call hess_io_iz(hess1, hgrid, iz_modl, hess1_, "reed")
            !$OMP parallel do private(inode,          iy_modl, ix_modl,         y_modl, x_modl,       iy_m, ix_m, & 
            !$OMP                            iz_offd, iy_offd, ix_offd, z_offd, y_offd, x_offd, iz_o, iy_o, ix_o, &
            !$OMP                                   HH1, &
            !$OMP                                    d1, & 
            !$OMP                                    m1  ) schedule (static,hgrid%az_modl%n/nodes)
                 do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d; inode=omp_get_thread_num()+1;
                 do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                                if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle; iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d; 
                        do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                                if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle; iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                        do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                                if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle; ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                                if (iz_offd == hgrid%az_offd%n .and. ix_offd == ceiling(hgrid%ax_offd%n/2.) .and. iy_offd == ceiling(hgrid%ay_offd%n/2.))then !diagonal
                                    HH1=hess1(ix_offd,iy_offd,iz_offd,ix_m,iy_m);
                                    if (adj) then
                                        d1=> dat1(ix_o,iy_o,iz_o      );
                                        m1=>tmod1(ix_m,iy_m,iz_m,inode);
                                            m1 = m1 + HH1*d1; 
                                    else 
                                        d1=>tdat1(ix_m,iy_m,iz_m,inode);
                                        m1=> mod1(ix_o,iy_o,iz_o      );
                                            d1 = d1 + HH1*m1; 
                                    end if
                                elseif(iz_offd == hgrid%az_offd%n .and. ix_offd  > ceiling(hgrid%ax_offd%n/2.).and. iy_offd  > ceiling(hgrid%ay_offd%n/2.))then
                                        cycle
                                else
                                    HH1=hess1(ix_offd,iy_offd,iz_offd,ix_m,iy_m); 
                                    if (adj) then
                                        d1=> dat1(ix_o,iy_o,iz_o      );
                                        m1=>tmod1(ix_m,iy_m,iz_m,inode);
                                            m1 = m1 + HH1*d1; 
                                        d1=> dat1(ix_m,iy_m,iz_m      ); 
                                        m1=>tmod1(ix_o,iy_o,iz_o,inode); 
                                            m1 = m1 + HH1*d1; 
                                    else
                                        d1=>tdat1(ix_m,iy_m,iz_m,inode); 
                                        m1=> mod1(ix_o,iy_o,iz_o      ); 
                                            d1 = d1 + HH1*m1; 
                                        d1=>tdat1(ix_o,iy_o,iz_o,inode); 
                                        m1=> mod1(ix_m,iy_m,iz_m      ); 
                                            d1 = d1 + HH1*m1;
                                    end if
                                endif
                        end do
                        end do
                        end do
                end do
                end do
            !$OMP end parallel do
         end do
    endif
    if(adj)then
            mod1=mod1+sum(tmod1,4); 
    else
            dat1=dat1+sum(tdat1,4); 
    endif
    if (timing1)then
        call date_and_time(values=time_array_1)
        finish_time = time_array_1 (5) * 3600 + time_array_1 (6) * 60 + time_array_1 (7) + 0.001 * time_array_1 (8)
        write(0,*)'total time', finish_time - start_time
    endif
    return
  end subroutine
!#####################################
!/ | H1    |    
!/ |     H2|    
  subroutine hess_convolve__2_3d(adj, mod1, mod2, dat1, dat2)
    logical               :: adj
    real                  :: HH2,  HH1 
    real          ,pointer:: d1, d2
    real          ,pointer:: m1, m2
    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n,nodes),target :: tmod1, tmod2
    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n,nodes),target :: tdat1, tdat2
    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n      ),target ::  mod1,  mod2
    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n      ),target ::  dat1,  dat2
    real, dimension(hgrid%ax_offd%n,hgrid%ay_offd%n,hgrid%az_offd%n,hgrid%ax_modl%n,hgrid%ay_modl%n),target :: hess1, hess2

    real                  :: Hm2, Hm1 
    real                  :: Hd2, Hd1 
    real                  :: start_time, finish_time
    integer               :: time_array_0(8), time_array_1(8)

    if (timing1)then
        call date_and_time(values=time_array_0)
        start_time = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)
    endif
    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
!   write(0,*)sum(mod1),sum(mod2),sum(dat1),sum(dat2),'b4.....'
    write(0,*)"maxz,maxx,maxy",maxz,maxx,maxy
    tdat1=0;tdat2=0
    tmod1=0;tmod2=0
    if(.not.halfhess)then
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
             call hess_io_iz(hess1, hgrid, iz_modl, hess1_, "reed")
             call hess_io_iz(hess2, hgrid, iz_modl, hess2_, "reed")
            !$OMP parallel do private(inode,          iy_modl, ix_modl,         y_modl, x_modl,       iy_m, ix_m, & 
            !$OMP                            iz_offd, iy_offd, ix_offd, z_offd, y_offd, x_offd, iz_o, iy_o, ix_o, &
            !$OMP                                   HH1, HH2, &
            !$OMP                                    d1,  d2, & 
            !$OMP                                    m1,  m2)schedule (static,hgrid%az_modl%n/nodes)
                 do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;  inode=omp_get_thread_num()+1;
                 do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                                if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
                                iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
                        do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                                if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
                                iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                        do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                                if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
                                ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                                HH1=hess1(ix_offd,iy_offd,iz_offd,ix_m,iy_m); HH2=hess2(ix_offd,iy_offd,iz_offd,ix_m,iy_m);
                                if (adj) then
                                    d1=> dat1(ix_o,iy_o,iz_o      ); d2=> dat2(ix_o,iy_o,iz_o      ); 
                                    m1=>tmod1(ix_m,iy_m,iz_m,inode); m2=>tmod2(ix_m,iy_m,iz_m,inode);
                                        m1 = m1 + HH1*d1; m2 = m2 + HH2*d2;
                                else
                                    d1=>tdat1(ix_m,iy_m,iz_m,inode); d2=>tdat2(ix_m,iy_m,iz_m,inode); 
                                    m1=> mod1(ix_o,iy_o,iz_o      ); m2=> mod2(ix_o,iy_o,iz_o      ); 
                                        d1 = d1 + HH1*m1; d2 = d2 + HH2*m2; 
                                end if
                        end do
                        end do
                        end do
                end do
                end do
            !$OMP end parallel do
         end do
    else
        write(0,*)sum(mod1),sum(dat1),'b4....'
        write(0,*)sum(mod2),sum(dat2),'b4....'
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
             call hess_io_iz(hess1, hgrid, iz_modl, hess1_, "reed")
             call hess_io_iz(hess2, hgrid, iz_modl, hess2_, "reed")
             write(0,'(I5,12(g12.4,2x))')iz_modl,z_modl,sum(tdat1),sum(mod1),sum(tdat2),sum(mod2),sum(hess1),sum(hess2)
            !$OMP parallel do private(inode,          iy_modl, ix_modl,         y_modl, x_modl,       iy_m, ix_m, & 
            !$OMP                            iz_offd, iy_offd, ix_offd, z_offd, y_offd, x_offd, iz_o, iy_o, ix_o, &
            !$OMP                                   HH1, HH2, &
            !$OMP                                    d1,  d2, &
            !$OMP                                    m1,  m2) schedule (static,hgrid%az_modl%n/nodes)
                 do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d; inode=omp_get_thread_num()+1;
                 do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                                if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle; iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d; 
                        do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                                if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle; iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                        do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                                if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle; ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                                if (iz_offd == hgrid%az_offd%n .and. ix_offd == ceiling(hgrid%ax_offd%n/2.) .and. iy_offd == ceiling(hgrid%ay_offd%n/2.))then !diagonal
                                    HH1=hess1(ix_offd,iy_offd,iz_offd,ix_m,iy_m); HH2=hess2(ix_offd,iy_offd,iz_offd,ix_m,iy_m);
                                    if (adj) then
                                        d1=> dat1(ix_o,iy_o,iz_o      ); d2=> dat2(ix_o,iy_o,iz_o      );
                                        m1=>tmod1(ix_m,iy_m,iz_m,inode); m2=>tmod2(ix_m,iy_m,iz_m,inode);
                                            m1 = m1 + HH1*d1; m2 = m2 + HH2*d2; 
                                    else 
                                        d1=>tdat1(ix_m,iy_m,iz_m,inode); d2=>tdat2(ix_m,iy_m,iz_m,inode); 
                                        m1=> mod1(ix_o,iy_o,iz_o      ); m2=> mod2(ix_o,iy_o,iz_o      ); 
                                            d1 = d1 + HH1*m1; d2 = d2 + HH2*m2; 
                                    end if
                                elseif(iz_offd == hgrid%az_offd%n .and. (ix_offd  > ceiling(hgrid%ax_offd%n/2.).or.(ix_offd  == ceiling(hgrid%ax_offd%n/2.).and.iy_offd > ceiling(hgrid%ay_offd%n/2.))))then
                                        cycle
                                else
                                    HH1=hess1(ix_offd,iy_offd,iz_offd,ix_m,iy_m); HH2=hess2(ix_offd,iy_offd,iz_offd,ix_m,iy_m);
                                    if (adj) then
                                        d1=> dat1(ix_o,iy_o,iz_o      ); d2=> dat2(ix_o,iy_o,iz_o      ); 
                                        m1=>tmod1(ix_m,iy_m,iz_m,inode); m2=>tmod2(ix_m,iy_m,iz_m,inode);
                                            m1 = m1 + HH1*d1; m2 = m2 + HH2*d2;
                                        d1=> dat1(ix_m,iy_m,iz_m      ); d2=> dat2(ix_m,iy_m,iz_m      ); 
                                        m1=>tmod1(ix_o,iy_o,iz_o,inode); m2=>tmod2(ix_o,iy_o,iz_o,inode);
                                            m1 = m1 + HH1*d1; m2 = m2 + HH2*d2; 
                                    else
                                        d1=>tdat1(ix_m,iy_m,iz_m,inode); d2=>tdat2(ix_m,iy_m,iz_m,inode); 
                                        m1=> mod1(ix_o,iy_o,iz_o      ); m2=> mod2(ix_o,iy_o,iz_o      ); 
                                            d1 = d1 + HH1*m1; d2 = d2 + HH2*m2; 
                                        d1=>tdat1(ix_o,iy_o,iz_o,inode); d2=>tdat2(ix_o,iy_o,iz_o,inode); 
                                        m1=> mod1(ix_m,iy_m,iz_m      ); m2=> mod2(ix_m,iy_m,iz_m      ); 
                                            d1 = d1 + HH1*m1; d2 = d2 + HH2*m2;
                                    end if
                                endif
                        end do 
                        end do
                        end do
                end do
                end do
            !$OMP end parallel do
         end do
    endif
    if(adj)then
            mod1=mod1+sum(tmod1,4); mod2=mod2+sum(tmod2,4)
    else
            dat1=dat1+sum(tdat1,4); dat2=dat2+sum(tdat2,4)
    endif
        write(0,*)sum(mod1),sum(dat1),'af....'
        write(0,*)sum(mod2),sum(dat2),'af....'
    if (timing1)then
        call date_and_time(values=time_array_1)
        finish_time = time_array_1 (5) * 3600 + time_array_1 (6) * 60 + time_array_1 (7) + 0.001 * time_array_1 (8)
        write(0,*)'total time', finish_time - start_time
    endif
    return
  end subroutine
!
!!
!!#####################################
!!/ | H3        |    
!!/ |     H3    |    
!!/ |         H3|    
! subroutine hess_convolve__3_3d(adj, mod1, mod2, mod3, dat1, dat2, dat3)
!    logical               :: adj
!    real                  :: HH3,  HH2,  HH1 
!    real          ,pointer:: d1, d2, d3
!    real          ,pointer:: m1, m2, m3
!    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n),target :: mod1, mod2, mod3
!    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n),target :: dat1, dat2, dat3
!    real                  :: Hm3, Hm2, Hm1 
!    real                  :: Hd3, Hd2, Hd1 
!    real                  :: start_time, finish_time
!    integer               :: time_array_0(8), time_array_1(8)
!
!    if (timing1)then
!        call date_and_time(values=time_array_0)
!        start_time = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)
!    endif
!        
!    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
!    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
!    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
!    !$OMP parallel do private(inode, iz_modl, iy_modl, ix_modl, z_modl, y_modl, x_modl, iz_m, iy_m, ix_m, & 
!    !$OMP                            iz_offd, iy_offd, ix_offd, z_offd, y_offd, x_offd, iz_o, iy_o, ix_o, &
!    !$OMP                                   HH1, HH2, HH3,&
!    !$OMP                                    d1,  d2,  d3,& 
!    !$OMP                                    m1,  m2,  m3 )  
!         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
!         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
!         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
!                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
!                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
!                        iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
!                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
!                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
!                        iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
!                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
!                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
!                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > ceiling(hgrid%ax_offd%n/2.)) cycle
!                        ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
!                        HH1=he1(ix_offd,iy_offd,iz_offd,ix_m,iy_m,iz_m); HH2=he2(ix_offd,iy_offd,iz_offd,ix_m,iy_m,iz_m); HH3=he3(ix_offd,iy_offd,iz_offd,ix_m,iy_m,iz_m);; 
!                        if (adj) then
!                            d1=>dat1(ix_m,iy_m,iz_m); d2=>dat2(ix_m,iy_m,iz_m); d3=>dat3(ix_m,iy_m,iz_m); 
!                            m1=>mod1(ix_o,iy_o,iz_o); m2=>mod2(ix_o,iy_o,iz_o); m3=>mod3(ix_o,iy_o,iz_o); 
!                                m1 = m1 + HH1*d1; m2 = m2 + HH2*d2; m3 = m3 + HH3*d3; 
!                            d1=>dat1(ix_o,iy_o,iz_o); d2=>dat2(ix_o,iy_o,iz_o); d3=>dat3(ix_o,iy_o,iz_o); 
!                            m1=>mod1(ix_m,iy_m,iz_m); m2=>mod2(ix_m,iy_m,iz_m); m3=>mod3(ix_m,iy_m,iz_m); 
!                                m1 = m1 + HH1*d1; m2 = m2 + HH2*d2; m3 = m3 + HH3*d3
!                        else 
!                            d1=>dat1(ix_m,iy_m,iz_m); d2=>dat2(ix_m,iy_m,iz_m); d3=>dat3(ix_m,iy_m,iz_m); 
!                            m1=>mod1(ix_o,iy_o,iz_o); m2=>mod2(ix_o,iy_o,iz_o); m3=>mod3(ix_o,iy_o,iz_o); 
!                                d1 = d1 + HH1*m1; d2 = d2 + HH2*m2; d3 = d3 + HH3*m3 
!                            d1=>dat1(ix_o,iy_o,iz_o); d2=>dat2(ix_o,iy_o,iz_o); d3=>dat3(ix_o,iy_o,iz_o); 
!                            m1=>mod1(ix_m,iy_m,iz_m); m2=>mod2(ix_m,iy_m,iz_m); m3=>mod3(ix_m,iy_m,iz_m); 
!                                d1 = d1 + HH1*m1; d2 = d2 + HH2*m2; d3 = d3 + HH3*m3 
!                        end if
!                end do
!                end do
!                end do
!        end do
!        end do
!        end do
!    !$OMP end parallel do
!    if (timing1)then
!        call date_and_time(values=time_array_1)
!        finish_time = time_array_1 (5) * 3600 + time_array_1 (6) * 60 + time_array_1 (7) + 0.001 * time_array_1 (8)
!        write(0,*)'total time', finish_time - start_time
!    endif
!    return
!  end subroutine
!!#####################################
!!/ | H14 H24 H34 H4|    
!!/ | H24 H24 H34 H4|    
!!/ | H34 H34 H34 H4|    
!!/ |  H4  H4  H4 H4|    
!  subroutine hess_convolve__4_3d(adj, mod1, mod2, mod3, mod4, dat1, dat2, dat3, dat4)
!    logical               :: adj
!    real                  :: HH4,  HH3,  HH2,  HH1 
!    real          ,pointer:: d1, d2, d3, d4
!    real          ,pointer:: m1, m2, m3, m4
!    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n),target :: mod1, mod2, mod3, mod4
!    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n),target :: dat1, dat2, dat3, dat4
!    real                  :: Hm4, Hm3, Hm2, Hm1 
!    real                  :: Hd4, Hd3, Hd2, Hd1 
!    integer               :: a1
!    logical               :: logic
!    real                  :: start_time, finish_time
!    integer               :: time_array_0(8), time_array_1(8)
!    if (timing1)then
!        call date_and_time(values=time_array_0)
!        start_time = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)
!    endif
!
!    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
!    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
!    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
!    !$OMP parallel do private(inode, iz_modl, iy_modl, ix_modl, z_modl, y_modl, x_modl, iz_m, iy_m, ix_m, & 
!    !$OMP                            iz_offd, iy_offd, ix_offd, z_offd, y_offd, x_offd, iz_o, iy_o, ix_o, &
!    !$OMP                                   HH1, HH2, HH3, HH4,&
!    !$OMP                                    d1,  d2,  d3,  d4,& 
!    !$OMP                                    m1,  m2,  m3,  m4)  
!         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
!         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
!         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
!                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
!                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
!                        iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
!                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
!                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
!                        iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
!                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
!                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
!                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > ceiling(hgrid%ax_offd%n/2.)) cycle
!                        ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
!                        HH1=he1(ix_offd,iy_offd,iz_offd,ix_m,iy_m,iz_m); HH2=he2(ix_offd,iy_offd,iz_offd,ix_m,iy_m,iz_m); HH3=he3(ix_offd,iy_offd,iz_offd,ix_m,iy_m,iz_m); 
!                        HH4=he4(ix_offd,iy_offd,iz_offd,ix_m,iy_m,iz_m);
!                        if (adj) then
!                            d1=>dat1(ix_m,iy_m,iz_m); d2=>dat2(ix_m,iy_m,iz_m); d3=>dat3(ix_m,iy_m,iz_m); d4=>dat4(ix_m,iy_m,iz_m); 
!                            m1=>mod1(ix_o,iy_o,iz_o); m2=>mod2(ix_o,iy_o,iz_o); m3=>mod3(ix_o,iy_o,iz_o); m4=>mod4(ix_o,iy_o,iz_o); 
!                                m1 = m1 + HH1*d1; m2 = m2 + HH2*d2; m3 = m3 + HH3*d3; 
!				m4 = m4 + HH4*d4; 
!                            d1=>dat1(ix_o,iy_o,iz_o); d2=>dat2(ix_o,iy_o,iz_o); d3=>dat3(ix_o,iy_o,iz_o); d4=>dat4(ix_o,iy_o,iz_o); 
!                            m1=>mod1(ix_m,iy_m,iz_m); m2=>mod2(ix_m,iy_m,iz_m); m3=>mod3(ix_m,iy_m,iz_m); m4=>mod4(ix_m,iy_m,iz_m); 
!                                m1 = m1 + HH1*d1; m2 = m2 + HH2*d2; m3 = m3 + HH3*d3
!                                m4 = m4 + HH4*d4; 
!                        else 
!                            d1=>dat1(ix_m,iy_m,iz_m); d2=>dat2(ix_m,iy_m,iz_m); d3=>dat3(ix_m,iy_m,iz_m); d4=>dat4(ix_m,iy_m,iz_m); 
!                            m1=>mod1(ix_o,iy_o,iz_o); m2=>mod2(ix_o,iy_o,iz_o); m3=>mod3(ix_o,iy_o,iz_o); m4=>mod4(ix_o,iy_o,iz_o); 
!                                d1 = d1 + HH1*m1; d2 = d2 + HH2*m2; d3 = d3 + HH3*m3 
!                                d4 = d4 + HH4*m4; 
!                            d1=>dat1(ix_o,iy_o,iz_o); d2=>dat2(ix_o,iy_o,iz_o); d3=>dat3(ix_o,iy_o,iz_o); d4=>dat4(ix_o,iy_o,iz_o); 
!                            m1=>mod1(ix_m,iy_m,iz_m); m2=>mod2(ix_m,iy_m,iz_m); m3=>mod3(ix_m,iy_m,iz_m); m4=>mod4(ix_m,iy_m,iz_m); 
!                                d1 = d1 + HH1*m1; d2 = d2 + HH2*m2; d3 = d3 + HH3*m3 
!                                d4 = d4 + HH4*m4; 
!                        end if
!                end do
!                end do
!                end do
!        end do
!        end do
!        end do
!    !$OMP end parallel do
!    if (timing1)then
!        call date_and_time(values=time_array_1)
!        finish_time = time_array_1 (5) * 3600 + time_array_1 (6) * 60 + time_array_1 (7) + 0.001 * time_array_1 (8)
!        write(0,*)'total time', finish_time - start_time
!    endif
!
!    return
!  end subroutine
!
!!#####################################
!!/ | H15 H25 H35 H45 H5|    
!!/ | H25 H25 H35 H45 H5|    
!!/ | H35 H35 H35 H45 H5|    
!!/ | H45 H45 H45 H45 H5|    
!!/ |  H5  H5  H5  H5 H5|    
!  subroutine hess_convolve__5_3d(adj, mod1, mod2, mod3, mod4, mod5, dat1, dat2, dat3, dat4, dat5)
!    logical               :: adj
!    real                  :: HH5,  HH4,  HH3,  HH2,  HH1 
!    real          ,pointer:: d1, d2, d3, d4, d5
!    real          ,pointer:: m1, m2, m3, m4, m5
!    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n),target :: mod1, mod2, mod3, mod4, mod5
!    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n),target :: dat1, dat2, dat3, dat4, dat5
!    real                  :: Hm5, Hm4, Hm3, Hm2, Hm1 
!    real                  :: Hd5, Hd4, Hd3, Hd2, Hd1 
!    real                  :: start_time, finish_time
!    integer               :: time_array_0(8), time_array_1(8)
!
!    if (timing1)then
!        call date_and_time(values=time_array_0)
!        start_time = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)
!    endif
!        
!    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
!    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
!    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
!    !$OMP parallel do private(inode, iz_modl, iy_modl, ix_modl, z_modl, y_modl, x_modl, iz_m, iy_m, ix_m, & 
!    !$OMP                            iz_offd, iy_offd, ix_offd, z_offd, y_offd, x_offd, iz_o, iy_o, ix_o, &
!    !$OMP                                   HH1, HH2, HH3, HH4, HH5, &
!    !$OMP                                    d1,  d2,  d3,  d4,  d5, & 
!    !$OMP                                    m1,  m2,  m3,  m4,  m5 )  
!         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
!         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
!         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
!                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
!                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
!                        iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
!                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
!                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
!                        iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
!                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
!                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
!                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > ceiling(hgrid%ax_offd%n/2.)) cycle
!                        ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
!                        HH1=he1(ix_offd,iy_offd,iz_offd,ix_m,iy_m,iz_m); HH2=he2(ix_offd,iy_offd,iz_offd,ix_m,iy_m,iz_m); HH3=he3(ix_offd,iy_offd,iz_offd,ix_m,iy_m,iz_m);; 
!                        HH4=he4(ix_offd,iy_offd,iz_offd,ix_m,iy_m,iz_m); HH5=he5(ix_offd,iy_offd,iz_offd,ix_m,iy_m,iz_m);
!                        if (adj) then
!                            d1=>dat1(ix_m,iy_m,iz_m); d2=>dat2(ix_m,iy_m,iz_m); d3=>dat3(ix_m,iy_m,iz_m); d4=>dat4(ix_m,iy_m,iz_m); d5=>dat5(ix_m,iy_m,iz_m); 
!                            m1=>mod1(ix_o,iy_o,iz_o); m2=>mod2(ix_o,iy_o,iz_o); m3=>mod3(ix_o,iy_o,iz_o); m4=>mod4(ix_o,iy_o,iz_o); m5=>mod5(ix_o,iy_o,iz_o); 
!                                m1 = m1 + HH1*d1; m2 = m2 + HH2*d2; m3 = m3 + HH3*d3; 
!				m4 = m4 + HH4*d4; m5 = m5 + HH5*d5; 
!                            d1=>dat1(ix_o,iy_o,iz_o); d2=>dat2(ix_o,iy_o,iz_o); d3=>dat3(ix_o,iy_o,iz_o); d4=>dat4(ix_o,iy_o,iz_o); d5=>dat5(ix_o,iy_o,iz_o); 
!                            m1=>mod1(ix_m,iy_m,iz_m); m2=>mod2(ix_m,iy_m,iz_m); m3=>mod3(ix_m,iy_m,iz_m); m4=>mod4(ix_m,iy_m,iz_m); m5=>mod5(ix_m,iy_m,iz_m); 
!                                m1 = m1 + HH1*d1; m2 = m2 + HH2*d2; m3 = m3 + HH3*d3
!                                m4 = m4 + HH4*d4; m5 = m5 + HH5*d5; 
!                        else 
!                            d1=>dat1(ix_m,iy_m,iz_m); d2=>dat2(ix_m,iy_m,iz_m); d3=>dat3(ix_m,iy_m,iz_m); d4=>dat4(ix_m,iy_m,iz_m); d5=>dat5(ix_m,iy_m,iz_m); 
!                            m1=>mod1(ix_o,iy_o,iz_o); m2=>mod2(ix_o,iy_o,iz_o); m3=>mod3(ix_o,iy_o,iz_o); m4=>mod4(ix_o,iy_o,iz_o); m5=>mod5(ix_o,iy_o,iz_o); 
!                                d1 = d1 + HH1*m1; d2 = d2 + HH2*m2; d3 = d3 + HH3*m3 
!                                d4 = d4 + HH4*m4; d5 = d5 + HH5*m5; 
!                            d1=>dat1(ix_o,iy_o,iz_o); d2=>dat2(ix_o,iy_o,iz_o); d3=>dat3(ix_o,iy_o,iz_o); d4=>dat4(ix_o,iy_o,iz_o); d5=>dat5(ix_o,iy_o,iz_o); 
!                            m1=>mod1(ix_m,iy_m,iz_m); m2=>mod2(ix_m,iy_m,iz_m); m3=>mod3(ix_m,iy_m,iz_m); m4=>mod4(ix_m,iy_m,iz_m); m5=>mod5(ix_m,iy_m,iz_m); 
!                                d1 = d1 + HH1*m1; d2 = d2 + HH2*m2; d3 = d3 + HH3*m3 
!                                d4 = d4 + HH4*m4; d5 = d5 + HH5*m5; 
!                        end if
!                end do
!                end do
!                end do
!        end do
!        end do
!        end do
!    !$OMP end parallel do
!    if (timing1)then
!        call date_and_time(values=time_array_1)
!        finish_time = time_array_1 (5) * 3600 + time_array_1 (6) * 60 + time_array_1 (7) + 0.001 * time_array_1 (8)
!        write(0,*)'total time', finish_time - start_time
!    endif
!    return
!  end subroutine
!!#####################################
!!/ | H16 H26 H36 H46 H56 H6|    
!!/ | H26 H26 H36 H46 H56 H6|    
!!/ | H36 H36 H36 H46 H56 H6|    
!!/ | H46 H46 H46 H46 H56 H6|    
!!/ | H56 H56 H56 H56 H56 H6|    
!!/ |  H6  H6  H6  H6  H6 H6|    
!  subroutine hess_convolve__6_3d(adj, mod1, mod2, mod3, mod4, mod5, mod6, dat1, dat2, dat3, dat4, dat5, dat6)
!    logical               :: adj
!    real                  :: HH6, HH5, HH4, HH3, HH2, HH1 
!    real          ,pointer:: d1, d2, d3, d4, d5, d6
!    real          ,pointer:: m1, m2, m3, m4, m5, m6
!    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n),target :: mod1, mod2, mod3, mod4, mod5, mod6
!    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n),target :: dat1, dat2, dat3, dat4, dat5, dat6
!    real                  :: Hm6, Hm5, Hm4, Hm3, Hm2, Hm1 
!    real                  :: Hd6, Hd5, Hd4, Hd3, Hd2, Hd1 
!    real                  :: start_time, finish_time
!    integer               :: time_array_0(8), time_array_1(8)
!
!    if (timing1)then
!        call date_and_time(values=time_array_0)
!        start_time = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)
!    endif
!
!    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
!    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
!    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
!
!    !$OMP parallel do private(inode, iz_modl, iy_modl, ix_modl, z_modl, y_modl, x_modl, iz_m, iy_m, ix_m, & 
!    !$OMP                            iz_offd, iy_offd, ix_offd, z_offd, y_offd, x_offd, iz_o, iy_o, ix_o, &
!    !$OMP                                   HH1, HH2, HH3, HH4, HH5, HH6, &
!    !$OMP                                    d1,  d2,  d3,  d4,  d5,  d6, & 
!    !$OMP                                    m1,  m2,  m3,  m4,  m5,  m6 )  
!         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; iz_m = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
!         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; iy_m = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
!         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; ix_m = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
!                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
!                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
!                        iz_o = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
!                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
!                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
!                        iy_o = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
!                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
!                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
!                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > ceiling(hgrid%ax_offd%n/2.)) cycle
!                        ix_o = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
!                        HH1=he1(ix_offd,iy_offd,iz_offd,ix_m,iy_m,iz_m);; HH2=he2(ix_offd,iy_offd,iz_offd,ix_m,iy_m,iz_m);; HH3=he3(ix_offd,iy_offd,iz_offd,ix_m,iy_m,iz_m);; 
!                        HH4=he4(ix_offd,iy_offd,iz_offd,ix_m,iy_m,iz_m);; HH5=he5(ix_offd,iy_offd,iz_offd,ix_m,iy_m,iz_m);; HH6=he6(ix_offd,iy_offd,iz_offd,ix_m,iy_m,iz_m);; 
!                        if (adj) then
!                            d1=>dat1(ix_m,iy_m,iz_m); d2=>dat2(ix_m,iy_m,iz_m); d3=>dat3(ix_m,iy_m,iz_m); d4=>dat4(ix_m,iy_m,iz_m); d5=>dat5(ix_m,iy_m,iz_m); d6=>dat6(ix_m,iy_m,iz_m);
!                            m1=>mod1(ix_o,iy_o,iz_o); m2=>mod2(ix_o,iy_o,iz_o); m3=>mod3(ix_o,iy_o,iz_o); m4=>mod4(ix_o,iy_o,iz_o); m5=>mod5(ix_o,iy_o,iz_o); m6=>mod6(ix_o,iy_o,iz_o);
!                                m1 = m1 + HH1*d1; m2 = m2 + HH2*d2; m3 = m3 + HH3*d3; 
!				m4 = m4 + HH4*d4; m5 = m5 + HH5*d5; m6 = m6 + HH6*d6;
!                            d1=>dat1(ix_o,iy_o,iz_o); d2=>dat2(ix_o,iy_o,iz_o); d3=>dat3(ix_o,iy_o,iz_o); d4=>dat4(ix_o,iy_o,iz_o); d5=>dat5(ix_o,iy_o,iz_o); d6=>dat6(ix_o,iy_o,iz_o);
!                            m1=>mod1(ix_m,iy_m,iz_m); m2=>mod2(ix_m,iy_m,iz_m); m3=>mod3(ix_m,iy_m,iz_m); m4=>mod4(ix_m,iy_m,iz_m); m5=>mod5(ix_m,iy_m,iz_m); m6=>mod6(ix_m,iy_m,iz_m);
!                                m1 = m1 + HH1*d1; m2 = m2 + HH2*d2; m3 = m3 + HH3*d3
!                                m4 = m4 + HH4*d4; m5 = m5 + HH5*d5; m6 = m6 + HH6*d6
!                        else 
!                            d1=>dat1(ix_m,iy_m,iz_m); d2=>dat2(ix_m,iy_m,iz_m); d3=>dat3(ix_m,iy_m,iz_m); d4=>dat4(ix_m,iy_m,iz_m); d5=>dat5(ix_m,iy_m,iz_m); d6=>dat6(ix_m,iy_m,iz_m);
!                            m1=>mod1(ix_o,iy_o,iz_o); m2=>mod2(ix_o,iy_o,iz_o); m3=>mod3(ix_o,iy_o,iz_o); m4=>mod4(ix_o,iy_o,iz_o); m5=>mod5(ix_o,iy_o,iz_o); m6=>mod6(ix_o,iy_o,iz_o);
!                                d1 = d1 + HH1*m1; d2 = d2 + HH2*m2; d3 = d3 + HH3*m3 
!                                d4 = d4 + HH4*m4; d5 = d5 + HH5*m5; d6 = d6 + HH6*m6
!                            d1=>dat1(ix_o,iy_o,iz_o); d2=>dat2(ix_o,iy_o,iz_o); d3=>dat3(ix_o,iy_o,iz_o); d4=>dat4(ix_o,iy_o,iz_o); d5=>dat5(ix_o,iy_o,iz_o); d6=>dat6(ix_o,iy_o,iz_o);
!                            m1=>mod1(ix_m,iy_m,iz_m); m2=>mod2(ix_m,iy_m,iz_m); m3=>mod3(ix_m,iy_m,iz_m); m4=>mod4(ix_m,iy_m,iz_m); m5=>mod5(ix_m,iy_m,iz_m); m6=>mod6(ix_m,iy_m,iz_m);
!                                d1 = d1 + HH1*m1; d2 = d2 + HH2*m2; d3 = d3 + HH3*m3 
!                                d4 = d4 + HH4*m4; d5 = d5 + HH5*m5; d6 = d6 + HH6*m6
!                        end if
!                end do
!                end do
!                end do
!        end do
!        end do
!        end do
!    !$OMP end parallel do
!    if (timing1)then
!        call date_and_time(values=time_array_1)
!        finish_time = time_array_1 (5) * 3600 + time_array_1 (6) * 60 + time_array_1 (7) + 0.001 * time_array_1 (8)
!        write(0,*)'total time', finish_time - start_time
!    endif
!    return
!  end subroutine
!
!

end module

