module hessian_convolve_nhlx
 use chain0_mod
 use createhelix_mod
 use cartesian_mod
 use bound_mod
 use regrid_mod
 use adj_mod
 use lapfac_mod
 use npolydiv_mod
 use nhelicon_mod
 use wilson_mod
 use util_
 implicit none
        integer,         private                                ,save   :: stat        
        type( filter),   private                                ,save   :: aa 
        type( filter),   private                                ,save   :: bb
        type(nfilter)                                           ,save   :: n_filt,lapfilt 
        real,            private,  dimension (:), allocatable   ,save   :: tt 
        integer,         private                                ,save   :: nd 
        logical,         private                                ,save   :: lscale,destroy_nhlx
        real,                                     allocatable   ,save   :: scale(:)
        integer,                                  allocatable   ,save   :: ptch(:), patch(:,:,:), patch_src(:,:,:,:,:), n_nfilt(:)
        real,            private,                 allocatable   ,save   :: dips_src(:,:,:,:,:) 
        real,            private,                 allocatable   ,save   :: tdip(:)
        real   ,         private                                        :: eps_nhlx,eps_dip
        integer,         private                                ,save   :: nmod,nang,nsc
        real,            private                                ,save   :: oang,dang
        real,            private                                ,save   :: osc,dsc
        real,            private                                ,save   :: max_eps_dip,min_eps_dip, min_dip, max_dip

        real,            private                                ,save   :: dip,lapfilt0
        integer,         private                                ,save   :: idip,iang,ifilt,verb_dip,nfilt,iidip

        integer,         private                                ,save   :: n1, n2, n3, n12, n13, n123

        integer,         private                                ,save   :: nesx,nsurv
        integer,         private                                ,save   :: n1_dip,n2_dip,n3_dip
        integer                                                 ,save   :: ndip


        real,            private                                ,save   :: n_filt0
        real,            private                                ,save   :: m,p
        real,            private                                ,save   :: pi_1,pi_2
        integer, external                  ,private   :: omp_get_num_procs
        integer, external                  ,private   :: omp_get_thread_num
        
        
        real   , parameter :: PI = 3.14159265359

        logical, parameter,private :: T = .true.
        logical, parameter,private :: F = .false.
        
        logical, private::test_dot
        
        real,private            ::dsscale
        logical                 ::lsscale
        integer,private         :: niter           
        logical, private::dip_read

 contains 
 !######################################
        subroutine  ns_init( n1_in, n2_in, n3_in, nesx_in, nsurv_in, test_dot_in,eps_dip_in)
                integer                 ::i, n1_in, n2_in, n3_in, nesx_in
                real, dimension(2)      ::u,v
                real                    :: eps_dip_in
                integer                 :: i3,iesx,nsurv_in 
                integer,allocatable     :: lap(:)
                logical                 :: test_dot_in
                optional                :: test_dot_in,eps_dip_in,nsurv_in
                
                test_dot=F;
                if(present(test_dot_in))test_dot=test_dot_in
                nsurv=1
                if(present(nsurv_in))nsurv=nsurv_in
               
                if(allocated(ptch)) deallocate(ptch)
                if(allocated(n_nfilt)) deallocate(n_nfilt)
                if(allocated(tdip)) deallocate(tdip)
                call from_param('nang ',nang,       90 )
                if (nang>1)then; 
                        call from_param('dang ',dang, pi/(nang-1));
                elseif (nang==1)then; 
                        call from_param('dang ',dang,1.); 
                elseif (nang<1 )then; 
                        call from_param('dang ',dang,0.); 
                endif
                pi_1=-pi/2
                pi_2=+pi/2 ! range of angles
                
                call from_param('ndip',ndip,         1 )
                call from_param('niter',niter,         1 )
                call from_param('oang ',oang,        pi_1)
                call from_param('nfilt',nfilt,         9 )
                call from_param('verb_dip',verb_dip,  1)
                call from_param('max_eps_dip',max_eps_dip, 0.5 )
                call from_param('min_eps_dip',min_eps_dip, 0.01)
                call from_param('max_dip',max_dip, -pi/2 )
                call from_param('min_dip',min_dip, +pi/2 )
                call from_param('scale'  ,lscale,.false. )
                call from_param('destroy_nhlx',destroy_nhlx,.false.)
                call from_param('lsscale'  ,lsscale,.false. )
                call from_param('dsscale'  ,dsscale, 5. )
                if(present(eps_dip_in))then
                        eps_dip=eps_dip_in
                else
                        call from_param('eps_dip',eps_dip, 0.01 )
                endif

                n1=n1_in; n2=n2_in; n3=n3_in
                n12 =n1*n2
                n13 =n1*n3
                n123=n1*n2*n3
                nmod=n123
                nesx=nesx_in
                
                
                if(.not.allocated(ptch     ))allocate(ptch(n12))
                if(.not.allocated(n_nfilt  ))allocate(n_nfilt(nang))
                if(.not.allocated(tdip     ))allocate(tdip(n12))
                if(.not.allocated(patch    ))allocate(patch(n1,n2,n3))
                if(.not.allocated(patch_src))allocate(patch_src(n1,n2,n3,nesx,ndip))
                if(.not.allocated(dips_src ))allocate(dips_src (n1,n2,n3,nesx,ndip))
                allocate(lap(nang))
               
               
                if(test_dot)then
                        call random_number(dips_src)
                else    
                        if(dip_read)then
                        else
                        do iesx=1,nesx
                                if(verb_dip>1)write(0,*)'Reading dips for data:',iesx,'. Please wait...'
                                if(iesx==1 )call hessian_convolve_dips_read("dip1"  ,1 )
                                if(iesx==2 )call hessian_convolve_dips_read("dip2"  ,2 )
                                if(iesx==3 )call hessian_convolve_dips_read("dip3"  ,3 )
                                if(iesx==4 )call hessian_convolve_dips_read("dip4"  ,4 )
                                if(iesx==5 )call hessian_convolve_dips_read("dip5"  ,5 )
                                if(iesx==6 )call hessian_convolve_dips_read("dip6"  ,6 )
                                if(iesx==7 )call hessian_convolve_dips_read("dip7"  ,7 )
                                if(iesx==8 )call hessian_convolve_dips_read("dip8"  ,8 )
                                if(iesx==9 )call hessian_convolve_dips_read("dip9"  ,9 )
                                if(iesx==10)call hessian_convolve_dips_read("dip10",10)
                                if(verb_dip>1)write(0,*)'Done reading dips.'
                                dip_read=T
                        enddo
                        endif
                endif
                
                !dips_src=-312002409
                !tdip = atan(tdip)
!               dips_src = atan(312002409.)-atan(dips_src)
                dips_src =  atan(dips_src)
                where(dips_src> 1.570800 )dips_src=1.570800    ! minvalmin-angle :-90/90 
                where(dips_src<-1.570800 )dips_src=-1.570800 
                if(verb_dip>2)write(0,*)'dipinfo:beg',nang,dang,oang
                if(maxval(dips_src)==minval(dips_src))then
                        nang=1; dang=1; oang=minval(dips_src); if(verb_dip>2)write(0,*)'dipinfo:a',nang,dang,oang
                elseif(minval(dips_src)>oang.and.maxval(dips_src)<oang+(nang-1)*dang)then
                        oang=minval(dips_src); dang=(maxval(dips_src)-oang)/(nang-1); if(verb_dip>2)write(0,*)'dipinfo:b',nang,dang,oang
                elseif(minval(dips_src)>oang)then 
                        oang=minval(dips_src)
                        if(maxval(dips_src)<oang+(nang-1)*dang)then
                                dang=(maxval(dips_src)-oang)/(nang-1)
                        endif
                if(verb_dip>2)write(0,*)'dipinfo:c',nang,dang,oang
                endif
                if(verb_dip>2)write(0,*)'dipinfo:end',nang,dang,oang
                
                if(test_dot)then
                        dips_src=-1.570800
                        nang=10
                        oang=-1.570800 
                        dang=0.2
                endif

                do idip=1,ndip
                        do iesx=1,nesx
                                do i3=1,n3
                                        tdip=reshape(dips_src(:,:,i3,iesx,idip),(/n12/))
                                        do i=1,n12
                                                dip  = tdip(i)
                                                iidip = 1.5+(dip-oang)/dang
                                                ptch(i)=iidip
                                                if(ptch(i)>nang.or.(ptch(i)<0.))write(0,*)dip,iidip,ptch(i)
                                        end do
                                        patch_src(:,:,i3,iesx,idip)=reshape(ptch,(/n1,n2/))
                                end do
                        end do
                end do

                where (patch_src>float(nang))patch_src=nang
                where (patch_src<1.         )patch_src=1

                where (ptch>float(nang))ptch=nang
                where (ptch<1.         )ptch=1

                n_nfilt=nfilt*3
                call nallocate(n_filt,n_nfilt,ptch)
                
                do iang=1,nang
                        do ifilt=1,nfilt
                                n_filt%hlx(iang)%lag(         ifilt) = ifilt                      ! early lags (first row)
                                n_filt%hlx(iang)%lag( nfilt  +ifilt) = n1 + ifilt - nfilt         ! late lags  (second row)
                                n_filt%hlx(iang)%lag( nfilt*2+ifilt) = n1 + ifilt                 ! late late lags (second row)
                        end do
                end do

                lap=4
                call nallocate(lapfilt,lap, ptch)                ! alloc. filter
                lapfilt0 = 1. + eps_dip                          ! zero lag coeff. multiply by variance
                
                if(verb_dip>1)write(0,'(A27,1X,I3,2X,A10)')'Computing coefficients for ',nang, 'filters...'
                do iang=1,nang
                        lapfilt%hlx(iang)%lag = (/ 1, n1-1, n1, n1+1/)    ! lag(1)= 1; lag(2)=n1  # one side only
                        dip=oang+(iang-1)*dang
                        if(verb_dip>3)write(0,*)'working on angle',iang,dip,degrad(1,dip),'of', nang 
                        u(1)= cos(dip); u(2)=-sin(dip); 
        
                        m=(u(1)-u(2))/2.; 
                        p=(u(1)+u(2))/2.;
                        lapfilt%hlx(iang)%flt = 0.;
                        lapfilt%hlx(iang)%flt = (/2*m*p,-p*p,-2*m*p,-m*m/) 
        
                        call wilson_init( 10 * n1)
                        
                        call wilson_factor( 100, lapfilt0, lapfilt%hlx(iang), n_filt0, n_filt%hlx(iang))
                        call wilson_close()
                        n_filt%hlx(iang)%flt=n_filt%hlx(iang)%flt!/n_filt0
                        if(verb_dip>3)write(0,'(50F10.6)')n_filt%hlx(iang)%flt
                end do

                call npolydiv_init(n12, n_filt)
                call hessian_convolve_dips_init(1,1)

        end subroutine
 !######################################
        subroutine hessian_convolve_dips_read(dipfile_,isrc)
                character(*)            :: dipfile_
                integer                 :: isrc
                        call from_aux(dipfile_,'n1',n1_dip,1 ); call from_aux(dipfile_,'n2',n2_dip,1 ); call from_aux(dipfile_,'n3',n3_dip,1)
                        write(0,*)n1_dip,n2_dip,n3_dip
                        if(n1_dip/=n1)then; write(0,*)'n1_dip/=n1 in file:',trim(dipfile_); call seperr('Error in hessian_convolve_dips_read');endif
                        if(n2_dip/=n2)then; write(0,*)'n2_dip/=n2 in file:',trim(dipfile_); call seperr('Error in hessian_convolve_dips_read');endif
                        if(n3_dip/=n3)then; write(0,*)'n3_dip/=n3 in file:',trim(dipfile_); call seperr('Error in hessian_convolve_dips_read');endif
                        if(allocated(dips_src))then
                                call sep_read(dips_src(:,:,:,isrc,:), trim(dipfile_))
                        else
                                call seperr('dips_src not allocated')
                        endif
        end subroutine
 !######################################
        subroutine hessian_convolve_dips_init(isex,idip)
                integer                 :: isex,idip
                        if(verb_dip>2)write(0,'(A30,I3)',advance='no')'(Re)assigning Dips for data: ',isex
                        patch=patch_src(:,:,:,isex,idip)
                        !if(isex==1)call sep_write(1.*patch,'ptch1')
                        !if(isex==2)call sep_write(1.*patch,'ptch2')
                        if(verb_dip>2)write(0,*)'... Done (re)assigning.'
        end subroutine
!#####################################################  
        integer function hessian_convolve_dips_oper(adj,add,xx,yy)  result(stat)
                real, dimension (:)             :: xx,yy
                integer                         :: isurv
                logical , intent(in)            :: adj,add
                stat=1
                        call adjnull (adj,add,xx ,yy );
                        do isurv=1,nsurv; 
                                call nhlx_lop(adj,add,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));
                        enddo
                stat=0
        end function
!#####################################################  
        integer function hessian_convolve_dips_smth(adj,add,xx,yy)  result(stat) !snooth
                real, dimension (:)             :: xx,yy
                integer                         :: isurv
                logical , intent(in)            :: adj,add
                logical                         :: tmp_destroy
                stat=1
                        call adjnull (adj,add,xx ,yy );
                        tmp_destroy=destroy_nhlx
                        destroy_nhlx=F
                        do isurv=1,nsurv; 
                                call nhlx_lop(adj,add,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));
                        enddo
                        destroy_nhlx=tmp_destroy
                stat=0
        end function
!#####################################################  
        subroutine nhlx_lop(adj,add,mod,dat)
                real, dimension (n1,n2,n3)      :: mod,dat
                real, dimension (n12)           :: xx,yy
                logical , intent(in)            :: adj,add
                integer                         :: i3
                do i3=1,n3
                        n_filt%pch=reshape((patch(:,:,i3)),(/n12/))
                        xx=reshape((mod(:,:,i3)),(/n12/))
                        yy=reshape((dat(:,:,i3)),(/n12/))
                        call nhlx_transp(1,xx,yy);
                        if (destroy_nhlx)then
                                call nhelicon_init(n_filt)
                                call filt_nhelicon(adj,add,xx,yy);
                        else
                                call npolydiv_init(n12, n_filt)
                                call filt_npolydiv(adj,add,xx,yy);
                        endif
                        call nhlx_transp(-1,xx,yy);
                        mod(:,:,i3)=reshape(xx,(/n1,n2/))
                        dat(:,:,i3)=reshape(yy,(/n1,n2/))
                enddo
                        if(adj)then
                                !mod(1,:,: )=0.
                                !mod(n1,:,:)=0.
                        else
                                !dat(1,:,: )=0.
                                !dat(n1,:,:)=0.
                        endif
        end subroutine
!######################################
        subroutine filt_npolydiv( adj, add, xx, yy) 
                integer                   :: stat,stat1,stat2 
                logical,intent(in)        :: adj,add 
                real,dimension(:)         :: xx,yy 
                real, dimension(size(xx)) :: tmp
                tmp=0.
                stat=1
                if ( adj) then
                        stat= npolydiv_lop(.false.,add, yy,tmp)     ! tmp = grad y
                        stat= npolydiv_lop(.true. ,add, xx,tmp)     ! x = x + grad' tmp
                else
                        stat= npolydiv_lop(.false.,add, xx,tmp)     ! tmp = grad x
                        stat= npolydiv_lop(.true. ,add, yy,tmp)     ! y = y + grad' tmp
                endif
                stat=stat*stat2
!                        call normal(npolydiv_lop, add, xx, yy, tmp)
        end subroutine 
!######################################
        subroutine filt_nhelicon( adj, add, xx, yy) 
                integer                   :: stat,stat1,stat2 
                logical,intent(in)        :: adj,add 
                real,dimension(:)         :: xx,yy 
                real, dimension(size(xx)) :: tmp
                tmp=0.
                stat=1
                tmp=0.
                if ( adj) then
                        stat= nhelicon_lop(.false.,add, yy,tmp)     ! tmp = grad y
                        stat= nhelicon_lop(.true. ,T  , xx,tmp)     ! x = x + grad' tmp
                else
                        stat= nhelicon_lop(.false.,add, xx,tmp)     ! tmp = grad x
                        stat= nhelicon_lop(.true. ,T  , yy,tmp)     ! y = y + grad' tmp
                endif
                stat=stat*stat2
!                        call normal(nhelicon_lop, add, xx, yy, tmp)
        end subroutine 
!!#####################################################  normal
        subroutine normal (oper, add, mod, dat, tmp)
                interface
                function oper (adj, add, mod, dat) result (stat); integer :: stat; logical, intent (in) :: adj, add; real, dimension (:)  :: mod, dat; end function oper
                end interface
                logical, intent (in)  :: add
                real, dimension (:)   :: mod, dat, tmp

                integer               :: stat1, stat2

                stat2 = oper (T, F,   tmp, mod)
                stat1 = oper (F, add, tmp, dat)
        end subroutine normal

 !#####################################Scaling functions for preconditioner
  integer function filt_scale(iter,niter,adj) result(stat)
        integer, intent (in)    :: iter, niter
        real                    :: eps
        logical , intent(in)    :: adj
        stat=1
        if(iter==1.or.(lsscale.and.adj))then; 
                if (modulo(iter,int(dsscale))==1)then;
                        eps_dip=min_eps_dip+(iter-1)*(max_eps_dip-min_eps_dip)/niter; write(0,*)'[Re]Computing spatial-filters with eps_dip:',eps_dip
                        call ns_init(n1,n2,n3,nesx,nsurv,F,eps_dip); 
               else;
               endif; 
        endif

  end function
!!#####################################################  angles

real function degtan(theta)
        real theta,pi
        pi=3.14159267
        degtan=tan(pi*theta/180)
        return
end function
!!#####################################################  angles
real function degrad(fwd,theta) result(theta1)
        integer :: fwd
        real pi,theta
                pi=3.14159267
                if (fwd==-1)then
                        theta1=pi*theta/180
                else
                        theta1=theta*180/pi
                endif
        return
end function
!!#####################################################  angles
real function taperfn(start,end,value,type)
        real start,end,value,pi
        integer type
                pi=3.14159267
                taperfn=(value-start)/(end-start)
                if (type.eq.2) then
                        taperfn=sin(taperfn*pi/2)
                end if
        return
end function
!#####################################################  transp before filter and back
        subroutine nhlx_transp(fwd,xx,yy)
                integer,intent(in)      :: fwd 
                real, dimension (:)     :: xx, yy 
                real, dimension(:,:), allocatable       :: temp
                optional                        :: yy
                if (fwd==1)then
                        allocate (temp(n2,n1))
                        temp=reshape(xx,(/n2,n1 /)); xx=reshape(transpose(temp),(/ nmod /))
                        if(present(yy))then; temp=reshape(yy,(/n2,n1 /)); yy=reshape(transpose(temp),(/ nmod /)); endif
                else
                        allocate (temp(n1,n2))
                        temp=reshape(xx,(/n1,n2 /)); xx=reshape(transpose(temp),(/ nmod /))
                        if(present(yy))then; temp=reshape(yy,(/n1,n2 /)); yy=reshape(transpose(temp),(/ nmod /));endif
                endif
                stat=0
                deallocate (temp)
        end subroutine
!#####################################################  conv or deconv
        integer function nhlx_it(adj, add, xx, yy) result(stat)
                logical,intent(in)   :: adj,add 
                real, dimension (:)  :: xx, yy
                integer              :: isurv    
                        do isurv=1,nsurv; call nhlx_transp(1,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));enddo
                if (destroy_nhlx)then
                        do isurv=1,nsurv; call filt_nhelicon(adj,add,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));enddo
                else
                        do isurv=1,nsurv; call filt_npolydiv(adj,add,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));enddo
                endif
                        do isurv=1,nsurv; call nhlx_transp(-1,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));enddo
                stat=0
        end function
!!#####################################################  conv or deconv
!        integer function nhlx_it(adj, add, xx, yy) result(stat)
!                logical,intent(in)   :: adj,add 
!                real, dimension (:)  :: xx, yy
!                integer              :: isurv    
!                call joint_adjnull2 (adj,add, xx,yy)
!                        do isurv=1,nsurv; call nhlx_transp(1,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));enddo
!                if (destroy_nlhx)then
!                        do isurv=1,nsurv; call filt_nhelicon(adj,add,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));enddo
!                else
!                        do isurv=1,nsurv; call filt_npolydiv(adj,add,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));enddo
!                endif
!                        do isurv=1,nsurv; call nhlx_transp(-1,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));enddo
!                stat=0
!        end function
! !#####################################spatial int + temp-smooth ...note:int_temp_oper in prc
!        integer function nhlx_row1(adj, add, mod, dat) result(stat)
!                logical, intent (in)     :: adj, add
!                real, dimension (: )     :: mod, dat
!                stat=1; stat=row_1(nhlx_it, int_temp_oper, adj,add,mod,dat) 
!        end function
! !######################################
!        integer function nhlx_row2(adj, add, mod, dat) result(stat)
!                logical, intent (in)     :: adj, add
!                real, dimension (: )     :: mod, dat
!                stat=1; stat=row_2(nhlx_it, int_temp_oper, adj,add,mod,dat) 
!        end function
! !######################################
!        integer function nhlx_row3(adj, add, mod, dat) result(stat)
!                logical, intent (in)     :: adj, add
!                real, dimension (: )     :: mod, dat
!                stat=1; stat=row_2(nhlx_it, int_temp_oper, adj,add,mod,dat) 
!        end function
! !######################################
!        integer function nhlx_chain1(adj, add, mod, dat) result(stat)
!                logical, intent (in)            :: adj, add
!                real, dimension (: )            :: mod, dat
!                real, dimension (size(dat))     :: tmp
!                stat=1; call chain0(nhlx_it, int_temp_oper,adj,add,mod,dat,tmp); stat=0
!        end function
! !#####################################Scaling functions for nhlx
!  integer function nhlx_scale(iter,niter,adj) result(stat)
!        integer, intent (in)     :: iter, niter
!        logical,intent(in)       :: adj
!        stat=1
!        if(iter==1.or.(lsscale.and.adj))then; if (modulo(iter,int(dsscale))==1)then; 
!            eps_dip=min_eps_dip+(iter-1)*(max_eps_dip-min_eps_dip)/niter; 
!            write(0,*)'[Re]Computing spatial-filters with eps_dip:',eps_dip
!            call ns_init(dips1,eps_dip); else;            ; endif; 
!        endif
!        if(iter==1.or.(ltscale.and.adj))then; if (modulo(iter,int(dtscale))==1)then;
!            rho_t=max_rho_t-(iter-1)*(max_rho_t-min_rho_t)/niter; 
!            write(0,*)'[Re]Computing temporal-filters with rho_t :',rho_t
!                                         else; rho_t=rho_t; endif; 
!        endif
!        stat=0
!  end function
! #####################################Scaling functions for nhlx
!  integer function nhlx_scale(iter,niter,adj) result(stat)
!        integer, intent (in)     :: iter, niter
!        logical,intent(in)       :: adj
!        stat=1
!        if(lsscale.and.adj)then; if (modulo(iter,int(dsscale))==1)then;  
!            eps_dip=min_eps_dip+(iter-1)*(max_eps_dip-min_eps_dip)/niter; 
!            write(0,*)'[Re]computing spatial-filters with eps_dip:',eps_dip
!            call ns_init(dips1,eps_dip); else;            ; endif; 
!        endif
!        if(ltscale.and.adj)then; if (modulo(iter,int(dtscale))==1)then;
!            rho_t=max_rho_t-(iter-1)*(max_rho_t-min_rho_t)/niter; 
!            write(0,*)'[Re]computing temporal-filters with rho_t :',rho_t
!                                         else; rho_t=rho_t; endif; 
!        endif
!        stat=0
!  end function
  
end module
