module hessian_convolve_params
!
  use sep
  use type_mod 
  use igrad1
  use util_
  use adj_mod
  use minresDataModule
!
implicit none
  real, dimension(:)         , allocatable ,save :: modl, modl1 , modl2 , modl3 , modl4 , modl5 , modl6
  real, dimension(:)         , allocatable ,save :: data, data1 , data2 , data3 , data4 , data5 , data6 
  real, dimension(:)         , allocatable ,save :: epsi, epsi1 , epsi2 , epsi3 , epsi4 , epsi5 , epsi6, epsi4d 
  real, dimension(:)         , allocatable ,save :: epsA
  real, dimension(:)         , allocatable ,save :: epsB
  real, dimension(:)         , allocatable ,save :: epsC
  real, dimension(:)         , allocatable ,save :: epsD
  real, dimension(:)         , allocatable ,save :: lmbd, lmbd1 , lmbd2 , lmbd3 , lmbd4 , lmbd5 , lmbd6
  real, dimension(:)         , allocatable ,save :: mask, mask1 , mask2 , mask3 , mask4 , mask5 , mask6, mask4d 
  real, dimension(:)         , allocatable ,save :: wght, wght1 , wght2 , wght3 , wght4 , wght5 , wght6, wght4d 
  real, dimension(:)         , allocatable ,save :: pick, pick1 , pick2 , pick3 , pick4 , pick5 , pick6    
  real, dimension(:)         , allocatable ,save :: norm, norm1 , norm2 , norm3 , norm4 , norm5 , norm6 
  real, dimension(:)         , allocatable ,save :: hesp, hesp1 , hesp2 , hesp3 , hesp4 , hesp5 , hesp6    
  real, dimension(:,:)       , allocatable ,save :: rmov, rmov1 , rmov2 , rmov3 , rmov4 , rmov5 , rmov6  
  real, dimension(:,:)       , allocatable ,save :: mmov, mmov1 , mmov2 , mmov3 , mmov4 , mmov5 , mmov6     
  real, dimension(:,:,:)     , allocatable ,save :: hess, hess1 , hess2 , hess3 , hess4 , hess5 , hess6    
  real, dimension(:,:,:,:,:) , allocatable ,save :: hes , hes1  , hes2  , hes3  , hes4  , hes5  , hes6    
  real, dimension(:,:,:,:,:,:),allocatable ,save :: he  , he1   , he2   , he3   , he4   , he5   , he6    
  real, dimension(:,:,:,:,:,:),allocatable ,save :: HE_ , HE_1  , HE_2  , HE_3  , HE_4  , HE_5  , HE_6   !hess for small 2D 
  real, dimension(:)         , allocatable ,save :: err
  character(len=256)                       ,save :: modl_ , modl1_, modl2_, modl3_, modl4_, modl5_, modl6_
  character(len=256)                       ,save :: data_ , data1_, data2_, data3_, data4_, data5_, data6_
  character(len=256)                       ,save :: hess_ , hess1_, hess2_, hess3_, hess4_, hess5_, hess6_
  character(len=256)                       ,save :: hesp_ , hesp1_, hesp2_, hesp3_, hesp4_, hesp5_, hesp6_
  character(len=256)                       ,save :: mmov_ , mmov1_, mmov2_, mmov3_, mmov4_, mmov5_, mmov6_
  character(len=256)                       ,save :: rmov_ , rmov1_, rmov2_, rmov3_, rmov4_, rmov5_, rmov6_
  character(len=256)                       ,save :: rdov_ , rdov1_, rdov2_, rdov3_, rdov4_, rdov5_, rdov6_
  character(len=256)                       ,save :: norm_ , norm1_, norm2_, norm3_, norm4_, norm5_, norm6_
  character(len=256)                       ,save :: epsi_ , epsi1_, epsi2_, epsi3_, epsi4_, epsi5_, epsi6_
  character(len=256)                       ,save :: epsA_
  character(len=256)                       ,save :: epsB_
  character(len=256)                       ,save :: epsC_
  character(len=256)                       ,save :: epsD_
  character(len=256)                       ,save :: err_
  character(len=256)                       ,save :: mask_ , mask1_, mask2_, mask3_, mask4_, mask5_, mask6_
  character(len=256)                       ,save :: wght_ , wght1_, wght2_, wght3_, wght4_, wght5_, wght6_
  character(len=256)                       ,save :: pick_ , pick1_, pick2_, pick3_, pick4_, pick5_, pick6_
  character(len=256)                       ,save ::         lmbd1_, lmbd2_, lmbd3_, lmbd4_, lmbd5_, lmbd6_
  real                                     ,save :: eps1, eps2, eps3, eps4, eps5, eps6
  real                                     ,save :: epA1, epA2, epA3, epA4, epA5, epA6
  real                                     ,save :: epB1, epB2, epB3, epB4, epB5, epB6
  real                                     ,save :: epC1, epC2, epC3, epC4, epC5, epC6
  real                                     ,save :: epD1, epD2, epD3, epD4, epD5, epD6
  real                                     ,save :: lmb1, lmb2, lmb3, lmb4, lmb5, lmb6
  real                                     ,save :: epi1, epi2, epi3, epi4, epi5, epi6
  real                                     ,save :: lmd1, lmd2, lmd3, lmd4, lmd5, lmd6
  real                                     ,save :: prc1, prc2, prc3, prc4, prc5, prc6
  logical                                  ,save :: adj, dot, inv, verb, joint, weight, msk, precon, lump, diag, psf, full, small, precond
  logical                                  ,save ::   epsi_1,   epsi_2,   epsi_3,   epsi_4,   epsi_5,   epsi_6
  logical                                  ,save ::   mask_1,   mask_2,   mask_3,   mask_4,   mask_5,   mask_6
  logical                                  ,save ::   pick_1,   pick_2,   pick_3,   pick_4,   pick_5,   pick_6
  logical                                  ,save :: weight_1, weight_2, weight_3, weight_4, weight_5, weight_6

  real                                     ,save :: zmin, rsv_zmin, zmax, rsv_zmax
  real                                     ,save :: xmin, rsv_xmin, xmax, rsv_xmax
  integer                                  ,save :: index_rsv_zmin, index_rsv_zmax
  integer                                  ,save :: index_rsv_xmin, index_rsv_xmax
  integer                                  ,save :: index_zmin    , index_zmax    
  integer                                  ,save :: index_xmin    , index_xmax    
 
  integer                                  ,save :: stat, jmov, mode, nsurv
  integer                                  ,save :: nmod, noff
  integer                                  ,save :: niter, iter
  integer                                  ,save :: inode, nodes, nnode, thread
  real                                     ,save :: riter     
!####fact_dz 
  real                                     ,save :: dz_fact     
  logical                                  ,save :: ldz_fact     
!####use reservoir picks???
  logical				   ,save :: lpick
  real  				   ,save :: pclip1
  real  				   ,save :: pclip2
!#####type of 4d reg.
  integer				   ,save :: reg_4d
!#####type of base/moni reg.
  integer				   ,save :: reg_base
!#####horizontal reflectors (can use simple regs.)
  logical				   ,save :: flat
!#####memory usage
  real                                     ,save :: memory      
!#####axes defaults
  type(axis)                               ,save :: hx,hy,hz 
  type(axis)                               ,save :: gx,gy,gz 
  type(axis)                               ,save :: mov, mov1, nrm 
  type(axis)                               ,save :: h1,h2,h3,h4,h5,h6,h7,h8,h9,h10
  type(hes_grid)                           ,save :: hgrid 

  integer,                              external :: srite_window, sreed_window, getch
  integer,                              external :: omp_get_num_procs, omp_get_thread_num 
!minres      
  real(dp) , dimension(:)     ,allocatable ,save :: data_mres
  real(dp) , dimension(:)     ,allocatable ,save :: modl_mres 
  real(dp) , dimension(:)     ,allocatable ,save :: data1_mres, data2_mres, data3_mres, data4_mres, data5_mres, data6_mres  
  real(dp) , dimension(:)     ,allocatable ,save :: modl1_mres, modl2_mres, modl3_mres, modl4_mres, modl5_mres, modl6_mres  
  real(dp)                                 ,save :: Anorm, Acond, Arnorm, rnorm, rtol, r1norm, ynorm
  integer                                  ,save :: n, j, itnlim, istop, itn, nprint
  double precision                         ,save :: tol
  logical                                  ,save :: checkA, noreg 
 
!hess_conv
    integer                                ,save :: ix_modl, iy_modl, iz_modl
    integer                                ,save :: ix_offd, iy_offd, iz_offd
    integer                                ,save :: ix_o, iy_o, iz_o
    integer                                ,save :: ix_m, iy_m, iz_m
    real                                   ,save :: x_offd, y_offd, z_offd
    real                                   ,save :: x_modl, y_modl, z_modl
    real                                   ,save :: maxz,maxx,maxy
    real                                   ,save :: edge
    real                                   ,save :: start_time, finish_time, start_t, finish_t, start_t0, finish_t0, start_t1, finish_t1, tot_t, int_t
    integer                                ,save :: time_array_0(8), time_array_1(8), time_array_3(8), time_array_4(8), time_array_5(8), time_array_6(8)
    logical                                ,save :: timing1, timing2
    
    integer                                ,save :: method
    integer                                ,save :: rtop
!general
    logical                                ,save :: F,T
    logical                                ,save :: is2d, ismall
    integer				   ,save :: i

! eps and lmb as func of data 
    logical                                ,save :: data_eps
    logical                                ,save :: data_lmb
 !!!!!!!!!!!! hybrid
    character(12)                               ,save:: norm_d,norm_m,norm_m1,norm_m2,norm_m3,norm_m4  
    integer                                     ,save:: quant_period
    integer                                     ,save:: psiter,max_overshot
    real                                        ,save:: quant_m ,quant_d
    real                                        ,save:: quant_m1,quant_m2,quant_m3,quant_m4
    logical                                     ,save:: lhybrid
 
!impedance
    real                                       ,save :: rho
    logical                                    ,save :: limp

!impedance
    real                                       ,save :: gpow,wpow,hpow

!use only half hessian
    logical                                    ,save :: halfhess

    character(len=256)                         ,save :: report_
    
!+ve or -ve polarity or mig ....scale mig?
    integer                                    ,save :: polarity
!#####################################################  
  end module
