module hessian_convolve_regs
 use hessian_convolve_params
 use igrad2
 use igrad1
 use laplac2
 use causint_mod
 use leakint_mod

 implicit none

 contains 
!#######
  subroutine hessian_conv_temp(adj, add, modl, data) 
    logical             :: adj, add
    real, dimension(:)  :: modl, data
    integer             :: isurv         
        call adjnull(adj,add,modl,data)
!        write(0,*)sum(data),sum(modl),'temp-b4',adj,add,lmd1
        if (adj) then
                do isurv=1,nsurv-1;
                        modl(((isurv  )*nmod)+1:(isurv+1)*nmod)= modl(((isurv  )*nmod)+1:(isurv+1)*nmod)+lmd1*data(((isurv-1)*nmod)+1:(isurv  )*nmod)
                        modl(((isurv-1)*nmod)+1:(isurv  )*nmod)= modl(((isurv-1)*nmod)+1:(isurv  )*nmod)-lmd1*data(((isurv-1)*nmod)+1:(isurv  )*nmod)
                enddo
        else
                do isurv=1,nsurv-1;
                        data(((isurv-1)*nmod)+1:(isurv  )*nmod)= data(((isurv-1)*nmod)+1:(isurv  )*nmod)+lmd1*modl(((isurv  )*nmod)+1:(isurv+1)*nmod)
                        data(((isurv-1)*nmod)+1:(isurv  )*nmod)= data(((isurv-1)*nmod)+1:(isurv  )*nmod)-lmd1*modl(((isurv-1)*nmod)+1:(isurv  )*nmod)
                enddo
        end if
!        write(0,*)sum(data),sum(modl),'temp-af',adj,add
  end subroutine
!#######
  subroutine hessian_conv_temp1(adj, add, modl, data) 
    logical             :: adj, add
    real, dimension(:)  :: modl, data
    integer             :: isurv         
        call adjnull(adj,add,modl,data)
        if (adj) then
                do isurv=1,nsurv-1;
                        modl(((isurv  )*nmod)+1:(isurv+1)*nmod)= modl(((isurv  )*nmod)+1:(isurv+1)*nmod)+(hesp(((isurv-1)*nmod)+1:(isurv  )*nmod)*lmd1)*data(((isurv-1)*nmod)+1:(isurv  )*nmod)
                        modl(((isurv-1)*nmod)+1:(isurv  )*nmod)= modl(((isurv-1)*nmod)+1:(isurv  )*nmod)-(hesp(((isurv-1)*nmod)+1:(isurv  )*nmod)*lmd1)*data(((isurv-1)*nmod)+1:(isurv  )*nmod)
                enddo
        else
                do isurv=1,nsurv-1;
                        data(((isurv-1)*nmod)+1:(isurv  )*nmod)= data(((isurv-1)*nmod)+1:(isurv  )*nmod)+(hesp(((isurv-1)*nmod)+1:(isurv  )*nmod)*lmd1)*modl(((isurv  )*nmod)+1:(isurv+1)*nmod)
                        data(((isurv-1)*nmod)+1:(isurv  )*nmod)= data(((isurv-1)*nmod)+1:(isurv  )*nmod)-(hesp(((isurv-1)*nmod)+1:(isurv  )*nmod)*lmd1)*modl(((isurv-1)*nmod)+1:(isurv  )*nmod)
                enddo
        end if
  end subroutine
!#######
  subroutine hessian_conv_temp2(adj, add, modl, data) 
    logical             :: adj, add
    real, dimension(:)  :: modl, data
    integer             :: isurv         
        call adjnull(adj,add,modl,data)
        if (adj) then
                do isurv=1,nsurv-1;
                        modl(((isurv  )*nmod)+1:(isurv+1)*nmod)= modl(((isurv  )*nmod)+1:(isurv+1)*nmod)+(1/hesp(((isurv-1)*nmod)+1:(isurv  )*nmod)*lmd1)*data(((isurv-1)*nmod)+1:(isurv  )*nmod)
                        modl(((isurv-1)*nmod)+1:(isurv  )*nmod)= modl(((isurv-1)*nmod)+1:(isurv  )*nmod)-(1/hesp(((isurv-1)*nmod)+1:(isurv  )*nmod)*lmd1)*data(((isurv-1)*nmod)+1:(isurv  )*nmod)
                enddo
        else
                do isurv=1,nsurv-1;
                        data(((isurv-1)*nmod)+1:(isurv  )*nmod)= data(((isurv-1)*nmod)+1:(isurv  )*nmod)+(1/hesp(((isurv-1)*nmod)+1:(isurv  )*nmod)*lmd1)*modl(((isurv  )*nmod)+1:(isurv+1)*nmod)
                        data(((isurv-1)*nmod)+1:(isurv  )*nmod)= data(((isurv-1)*nmod)+1:(isurv  )*nmod)-(1/hesp(((isurv-1)*nmod)+1:(isurv  )*nmod)*lmd1)*modl(((isurv-1)*nmod)+1:(isurv  )*nmod)
                enddo
        end if
  end subroutine
!#######
  subroutine hessian_conv_temp3(adj, add, modl, data) 
    logical             :: adj, add
    real, dimension(:)  :: modl, data
    integer             :: isurv         
        call adjnull(adj,add,modl,data)
        if (adj) then
                do isurv=1,nsurv-1;
                        modl(((isurv  )*nmod)+1:(isurv+1)*nmod)= modl(((isurv  )*nmod)+1:(isurv+1)*nmod)+(wght(((isurv-1)*nmod)+1:(isurv  )*nmod)*lmd1)*data(((isurv-1)*nmod)+1:(isurv  )*nmod)
                        modl(((isurv-1)*nmod)+1:(isurv  )*nmod)= modl(((isurv-1)*nmod)+1:(isurv  )*nmod)-(wght(((isurv-1)*nmod)+1:(isurv  )*nmod)*lmd1)*data(((isurv-1)*nmod)+1:(isurv  )*nmod)
                enddo
        else
                do isurv=1,nsurv-1;
                        data(((isurv-1)*nmod)+1:(isurv  )*nmod)= data(((isurv-1)*nmod)+1:(isurv  )*nmod)+(wght(((isurv-1)*nmod)+1:(isurv  )*nmod)*lmd1)*modl(((isurv  )*nmod)+1:(isurv+1)*nmod)
                        data(((isurv-1)*nmod)+1:(isurv  )*nmod)= data(((isurv-1)*nmod)+1:(isurv  )*nmod)-(wght(((isurv-1)*nmod)+1:(isurv  )*nmod)*lmd1)*modl(((isurv-1)*nmod)+1:(isurv  )*nmod)
                enddo
        end if
  end subroutine
!#####################################################  
  subroutine hessian_conv_grad_temp11(adj)
  logical            :: adj
        if (adj) then
                if (nsurv > 5)then
                        modl1=modl1+data2+data3/2+data4/3+data5/4+data6/5
                        modl2=modl2-data2
                        modl3=modl3      -data3/2
                        modl4=modl4              -data4/3
                        modl5=modl5                      -data5/4
                        modl6=modl6                              -data6/5
                elseif (nsurv > 4)then
                        modl1=modl1+data2+data3/2+data4/3+data5/4
                        modl2=modl2-data2
                        modl3=modl3      -data3/2
                        modl4=modl4              -data4/3
                        modl5=modl5                      -data5/4
               elseif (nsurv > 3)then
                        modl1=modl1+data2+data3/2+data4/3
                        modl2=modl2-data2
                        modl3=modl3      -data3/2
                        modl4=modl4              -data4/3
                        write(0,*)sum(data1),sum(modl1)
               elseif (nsurv > 2)then
                        modl1=modl1+data2+data3/2
                        modl2=modl2-data2
                        modl3=modl3      -data3/2
               elseif (nsurv > 1)then
                        modl1=modl1+data2;
                        modl2=modl2-data2; 
               endif
        else
               if (nsurv > 5) then
                       data2=data2+(-modl2+modl1)
                       data3=data3+(-modl3+modl1)/2
                       data4=data4+(-modl4+modl1)/3
                       data5=data5+(-modl5+modl1)/4
                       data6=data6+(-modl6+modl1)/5
               elseif (nsurv > 4) then
                       data2=data2+(-modl2+modl1)
                       data3=data3+(-modl3+modl1)/2
                       data4=data4+(-modl4+modl1)/3
                       data5=data5+(-modl5+modl1)/4
               elseif (nsurv > 3) then
                       data2=data2+(-modl2+modl1)
                       data3=data3+(-modl3+modl1)/2
                       data4=data4+(-modl4+modl1)/3
               elseif (nsurv > 2) then
                       data2=data2+(-modl2+modl1)
                       data3=data3+(-modl3+modl1)/2
               elseif (nsurv > 1) then
                       data2=data2+(-modl2+modl1)
               endif
        end if
  end subroutine
!#####################################################  
  subroutine hessian_conv_grad_temp(adj)
  logical            :: adj
        if (adj) then
                if (nsurv > 5)then; modl5=modl5+data6; modl6=modl6-data6; endif
                if (nsurv > 4)then; modl4=modl4+data5; modl5=modl5-data5; endif
                if (nsurv > 3)then; modl3=modl3+data4; modl4=modl4-data4; endif
                if (nsurv > 2)then; modl2=modl2+data3; modl3=modl3-data3; endif
                if (nsurv > 1)then; modl1=modl1+data2; modl2=modl2-data2; endif
        else
                if (nsurv > 5)data6=data6+(-modl6+modl5)
                if (nsurv > 4)data5=data5+(-modl5+modl4)
                if (nsurv > 3)data4=data4+(-modl4+modl3)
                if (nsurv > 2)data3=data3+(-modl3+modl2)
                if (nsurv > 1)data2=data2+(-modl2+modl1)
        end if
  end subroutine
!#####################################
  subroutine hessian_conv_grad_temp00(adj)
  logical            :: adj
        if (adj) then
                if (nsurv > 5)then
                        modl1=modl1      +data2
                        modl2=modl2-data2+data3
                        modl3=modl3-data3+data4
                        modl4=modl4-data4+data5
                        modl5=modl5-data5+data6
                        modl6=modl6-data6
                elseif (nsurv > 4)then
                        modl1=modl1      +data2
                        modl2=modl2-data2+data3
                        modl3=modl3-data3+data4
                        modl4=modl4-data4+data5
                        modl5=modl5-data5
               elseif (nsurv > 3)then
                        modl1=modl1      +data2
                        modl2=modl2-data2+data3
                        modl3=modl3-data3+data4
                        modl4=modl4-data4
               elseif (nsurv > 2)then
                        modl1=modl1      +data2
                        modl2=modl2-data2+data3
                        modl3=modl3-data3
               elseif (nsurv > 1)then
                        modl1=modl1      +data2;
                        modl2=modl2-data2; 
               endif
        else
               if (nsurv > 5) then
                       data2=data2+(-modl2+modl1)
                       data3=data3+(-modl3+modl2)
                       data4=data4+(-modl4+modl3)
                       data5=data5+(-modl5+modl4)
                       data6=data6+(-modl6+modl5)
               elseif (nsurv > 4) then
                       data2=data2+(-modl2+modl1)
                       data3=data3+(-modl3+modl2)
                       data4=data4+(-modl4+modl3)
                       data5=data5+(-modl5+modl4)
               elseif (nsurv > 3) then
                       data2=data2+(-modl2+modl1)
                       data3=data3+(-modl3+modl2)
                       data4=data4+(-modl4+modl3)
               elseif (nsurv > 2) then
                       data2=data2+(-modl2+modl1)
                       data3=data3+(-modl3+modl2)
               elseif (nsurv > 1) then
                       data2=data2+(-modl2+modl1)
               endif
        end if

  end subroutine
!#####################################################  
  subroutine hessian_conv_grad_temp22(adj)
  logical            :: adj
        if (adj) then
                if (nsurv > 5)then
                        if(method==1)then; modl1=modl1+data1*0.;else;modl1=modl1-data2*lmbd2;endif
                        modl2=modl2+data2*lmbd2; 
                        modl3=modl3+data3*lmbd3; modl2=modl2-data3*lmbd3
                        modl4=modl4+data4*lmbd4; modl3=modl3-data4*lmbd4
                        modl5=modl5+data5*lmbd5; modl4=modl4-data5*lmbd5
                        modl6=modl6+data6*lmbd6; modl5=modl5-data6*lmbd6
                elseif (nsurv > 4)then
                        if(method==1)then; modl1=modl1+data1*0.;else;modl1=modl1-data2*lmbd2;endif
                        modl2=modl2+data2*lmbd2
                        modl3=modl3+data3*lmbd3; modl2=modl2-data3*lmbd3
                        modl4=modl4+data4*lmbd4; modl3=modl3-data4*lmbd4
                        modl5=modl5+data5*lmbd5; modl4=modl4-data5*lmbd5
               elseif (nsurv > 3)then
                        if(method==1)then; modl1=modl1+data1*0.;else;modl1=modl1-data2*lmbd2;endif
                        modl2=modl2+data2*lmbd2; 
                        modl3=modl3+data3*lmbd3; modl2=modl2-data3*lmbd3
                        modl4=modl4+data4*lmbd4; modl3=modl3-data4*lmbd4
               elseif (nsurv > 2)then
                        if(method==1)then; modl1=modl1+data1*0.;else;modl1=modl1-data2*lmbd2;endif
                        modl2=modl2+data2*lmbd2; 
                        modl3=modl3+data3*lmbd3; modl2=modl2-data3*lmbd3
               elseif (nsurv > 1)then
                        if(method==1)then; modl1=modl1+data1*0.;else;modl1=modl1-data2*lmbd2;endif
                        modl2=modl2+data2*lmbd2; 
               endif
        else
               if (nsurv > 5) then
                       data1=data1+( modl1      )*0.
                       if (method==1)then; data2=data2+( modl2      )*lmbd2; else; data2=data2+( modl2-modl1)*lmbd2;endif
                       data3=data3+( modl3-modl2)*lmbd3 
                       data4=data4+( modl4-modl3)*lmbd4 
                       data5=data5+( modl5-modl4)*lmbd5 
                       data6=data6+( modl6-modl5)*lmbd6
               elseif (nsurv > 4) then
                       data1=data1+( modl1      )*0.
                       if (method==1)then; data2=data2+( modl2      )*lmbd2; else; data2=data2+( modl2-modl1)*lmbd2;endif
                       data3=data3+( modl3-modl2)*lmbd3 
                       data4=data4+( modl4-modl3)*lmbd4 
                       data5=data5+( modl5-modl4)*lmbd5 
               elseif (nsurv > 3) then
                       data1=data1+( modl1      )*0.
                       if (method==1)then; data2=data2+( modl2      )*lmbd2; else; data2=data2+( modl2-modl1)*lmbd2;endif
                       data2=data2+( modl2-modl1)*lmbd2
                       data3=data3+( modl3-modl2)*lmbd3 
                       data4=data4+( modl4-modl3)*lmbd4 
               elseif (nsurv > 2) then
                       data1=data1+( modl1      )*0.
                       if (method==1)then; data2=data2+( modl2      )*lmbd2; else; data2=data2+( modl2-modl1)*lmbd2;endif
                       data2=data2+( modl2      )*lmbd2
                       data2=data2+( modl2-modl1)*lmbd2
                       data3=data3+( modl3-modl2)*lmbd3 
               elseif (nsurv > 1) then
                       data1=data1+( modl1      )*0.
                       if (method==1)then; data2=data2+( modl2      )*lmbd2; else; data2=data2+( modl2-modl1)*lmbd2;endif
               endif
        end if

  end subroutine
!#####################################
  subroutine hessian_conv_grad(adj, modl, data)
    logical                :: adj
    real, dimension(:)     :: modl, data
    integer                :: i

    do i= 1,size(data);  
        if (adj) then
                modl(i+1)=modl(i+1)+data(i  ) 
                modl(i  )=modl(i  )-data(i  ) 
        else 
                data(i  )=data(i  )+modl(i+1) 
                data(i  )=data(i  )-modl(i  ) 
        end if
    end do
    return
  end subroutine
!#####################################
  subroutine hessian_conv_grad_4d(adj, modl, data)
    logical                :: adj
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: modl
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: data
    integer                :: ix_modl, iy_modl, iz_modl

     do iy_modl= 1,hgrid%ay_modl%n ;  
     do ix_modl= 1,hgrid%ax_modl%n-1;  
     do iz_modl= index_rsv_zmin,hgrid%az_modl%n ; 
        if (adj) then
                modl(iz_modl,ix_modl+1,iy_modl)=modl(iz_modl,ix_modl+1,iy_modl)+data(iz_modl,ix_modl ,iy_modl) 
                modl(iz_modl,ix_modl  ,iy_modl)=modl(iz_modl,ix_modl  ,iy_modl)-data(iz_modl,ix_modl ,iy_modl) 
        else 
                data(iz_modl,ix_modl  ,iy_modl)=data(iz_modl,ix_modl  ,iy_modl)+(modl(iz_modl,ix_modl+1,iy_modl)-modl(iz_modl,ix_modl  ,iy_modl)) 
        end if
    end do
    end do
    end do
   return
  end subroutine
!#####################################
  subroutine hessian_conv_gradient(adj)
  logical            :: adj
  if (method==1)then
              if (nsurv > 5)then; call grad_base(adj,modl1,data1); call grad_4d_xz(adj,modl2,data2,pick2); call grad_4d_xz(adj,modl3,data3,pick2); call grad_4d_xz(adj,modl4,data4,pick2); call grad_4d_xz(adj,modl5,data5,pick2); call grad_4d_xz(adj,modl6,data6,pick2); 
          elseif (nsurv > 4)then; call grad_base(adj,modl1,data1); call grad_4d_xz(adj,modl2,data2,pick2); call grad_4d_xz(adj,modl3,data3,pick2); call grad_4d_xz(adj,modl4,data4,pick2); call grad_4d_xz(adj,modl5,data5,pick2);                            
          elseif (nsurv > 3)then; call grad_base(adj,modl1,data1); call grad_4d_xz(adj,modl2,data2,pick2); call grad_4d_xz(adj,modl3,data3,pick2); call grad_4d_xz(adj,modl4,data4,pick2);                                                             
          elseif (nsurv > 2)then; call grad_base(adj,modl1,data1); call grad_4d_xz(adj,modl2,data2,pick2); call grad_4d_xz(adj,modl3,data3,pick2);                                                                                              
          elseif (nsurv > 1)then; call grad_base(adj,modl1,data1); call grad_4d_xz(adj,modl2,data2,pick2);                                                                                                                               
          elseif (nsurv > 0)then; call grad_base(adj,modl1,data1);                                     
          else
              write(0,*)'Trouble hessian_conv_gradient : You shld not get here!!!!!!!!!!!!!!!!!!!!!'
          endif
  else
              if (nsurv > 5)then; call grad_base(adj,modl1,data1); call grad_base(adj,modl2,data2); call grad_base(adj,modl3,data3); call grad_base(adj,modl4,data4); call grad_base(adj,modl5,data5); call grad_base(adj,modl6,data6); 
          elseif (nsurv > 4)then; call grad_base(adj,modl1,data1); call grad_base(adj,modl2,data2); call grad_base(adj,modl3,data3); call grad_base(adj,modl4,data4); call grad_base(adj,modl5,data5);                            
          elseif (nsurv > 3)then; call grad_base(adj,modl1,data1); call grad_base(adj,modl2,data2); call grad_base(adj,modl3,data3); call grad_base(adj,modl4,data4);                                                             
          elseif (nsurv > 2)then; call grad_base(adj,modl1,data1); call grad_base(adj,modl2,data2); call grad_base(adj,modl3,data3);                                                                                              
          elseif (nsurv > 1)then; call grad_base(adj,modl1,data1); call grad_base(adj,modl2,data2);                                                                                                                               
          elseif (nsurv > 0)then; call grad_base(adj,modl1,data1);                                      
          else
              write(0,*)'Trouble hessian_conv_gradient : You shld not get here!!!!!!!!!!!!!!!!!!!!!'
          endif
  endif
  end subroutine
!#####################################
  subroutine hessian_conv_gradient_link(adj)
  logical            :: adj
  if (method==1)then
               if (nsurv > 5)then; call grad_base(adj,modl1,data1); call grad_base(adj,modl2,data2); call grad_base(adj,modl3,data3); call grad_base(adj,modl4,data4); call grad_base(adj,modl5,data5); call grad_base(adj,modl6,data6); 
           elseif (nsurv > 4)then; call grad_base(adj,modl1,data1); call grad_base(adj,modl2,data2); call grad_base(adj,modl3,data3); call grad_base(adj,modl4,data4); call grad_base(adj,modl5,data5);                            
           elseif (nsurv > 3)then; call grad_base(adj,modl1,data1); call grad_base(adj,modl2,data2); call grad_base(adj,modl3,data3); call grad_base(adj,modl4,data4);                                                             
           elseif (nsurv > 2)then; call grad_base(adj,modl1,data1); call grad_base(adj,modl2,data2); call grad_base(adj,modl3,data3);                                                                                              
           elseif (nsurv > 1)then; call grad_base(adj,modl1,data1); call grad_base(adj,modl2,data2);                                                                                                                               
           elseif (nsurv > 0)then; call grad_base(adj,modl1,data1);                                      
           else
               write(0,*)'Trouble hessian_conv_gradient_link : You shld not get here!!!!!!!!!!!!!!!!!!!!!'
           endif
  else
                if (nsurv > 5)then; call grad_base(adj,modl1,data1); call grad_4d_xz(adj,modl2,data2,pick2); call grad_4d_xz(adj,modl3,data3,pick3); call grad_4d_xz(adj,modl4,data4,pick4); call grad_4d_xz(adj,modl5,data5,pick5); call grad_4d_xz(adj,modl6,data6,pick6);
            elseif (nsurv > 4)then; call grad_base(adj,modl1,data1); call grad_4d_xz(adj,modl2,data2,pick2); call grad_4d_xz(adj,modl3,data3,pick3); call grad_4d_xz(adj,modl4,data4,pick4); call grad_4d_xz(adj,modl5,data5,pick5);                            
            elseif (nsurv > 3)then; call grad_base(adj,modl1,data1); call grad_4d_xz(adj,modl2,data2,pick2); call grad_4d_xz(adj,modl3,data3,pick3); call grad_4d_xz(adj,modl4,data4,pick4);                                                             
            elseif (nsurv > 2)then; call grad_base(adj,modl1,data1); call grad_4d_xz(adj,modl2,data2,pick2); call grad_4d_xz(adj,modl3,data3,pick3);                                                                                              
            elseif (nsurv > 1)then; call grad_base(adj,modl1,data1); call grad_4d_xz(adj,modl2,data2,pick2);                                                                                                                               
            elseif (nsurv > 0)then; call grad_base(adj,modl1,data1);                                 
            else; write(0,*)'Trouble hessian_conv_gradient_link : You shld not get here!!!!!!!!!!!!!!!!!!!!!'; endif
  endif
  end subroutine
!##################apply fact-dz
  subroutine hessian_fact_dz(adj)
  logical            :: adj
              if (nsurv > 5)then; call fact_dz(adj,modl1,data1); call fact_dz(adj,modl2,data2); call fact_dz(adj,modl3,data3); call fact_dz(adj,modl4,data4); call fact_dz(adj,modl5,data5); call fact_dz(adj,modl6,data6); 
          elseif (nsurv > 4)then; call fact_dz(adj,modl1,data1); call fact_dz(adj,modl2,data2); call fact_dz(adj,modl3,data3); call fact_dz(adj,modl4,data4); call fact_dz(adj,modl5,data5);                            
          elseif (nsurv > 3)then; call fact_dz(adj,modl1,data1); call fact_dz(adj,modl2,data2); call fact_dz(adj,modl3,data3); call fact_dz(adj,modl4,data4);                                                             
          elseif (nsurv > 2)then; call fact_dz(adj,modl1,data1); call fact_dz(adj,modl2,data2); call fact_dz(adj,modl3,data3);                                                                                              
          elseif (nsurv > 1)then; call fact_dz(adj,modl1,data1); call fact_dz(adj,modl2,data2);                                                                                                                               
          elseif (nsurv > 0)then; call fact_dz(adj,modl1,data1);                                     
          else
              write(0,*)'Trouble hessian_fact_dz : You shld not get here!!!!!!!!!!!!!!!!!!!!!'
          endif
  end subroutine
!##################apply fact-dz
  subroutine hessian_damping(adj)
  logical            :: adj
              if (nsurv > 5)then; call damping(adj,modl1,data1); call damping(adj,modl2,data2); call damping(adj,modl3,data3); call damping(adj,modl4,data4); call damping(adj,modl5,data5); call damping(adj,modl6,data6); 
          elseif (nsurv > 4)then; call damping(adj,modl1,data1); call damping(adj,modl2,data2); call damping(adj,modl3,data3); call damping(adj,modl4,data4); call damping(adj,modl5,data5);                            
          elseif (nsurv > 3)then; call damping(adj,modl1,data1); call damping(adj,modl2,data2); call damping(adj,modl3,data3); call damping(adj,modl4,data4);                                                             
          elseif (nsurv > 2)then; call damping(adj,modl1,data1); call damping(adj,modl2,data2); call damping(adj,modl3,data3);                                                                                              
          elseif (nsurv > 1)then; call damping(adj,modl1,data1); call damping(adj,modl2,data2);                                                                                                                               
          elseif (nsurv > 0)then; call damping(adj,modl1,data1);                                     
          else
              write(0,*)'Trouble hessian_fact_dz : You shld not get here!!!!!!!!!!!!!!!!!!!!!'
          endif
  end subroutine
!#####################################
subroutine grad_base(adj, modl, data)
    logical                :: adj
    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: modl
    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: data
    integer                :: ix_modl, iy_modl, iz_modl
 
            if(reg_base==1)then; call  grad_x(adj, modl, data);
        elseif(reg_base==2)then; call  lapl_x(adj, modl, data); endif

        if (index_zmin /=1)then; if(adj)then; modl(:,:,1:index_zmin-1)=data(:,:,1:index_zmin-1)
                                 else       ; data(:,:,1:index_zmin-1)=modl(:,:,1:index_zmin-1); endif
        endif
  return
  end subroutine
!##################4d regs
  subroutine grad_4d_xz(adj, modl, data, pick)
    use cartesian
    logical                :: adj
    real, dimension(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n) :: modl, data, pick
    real, dimension(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n) :: mod , dat , pic
    integer                :: ix_modl, iy_modl, iz_modl
    real                   :: clip1,clip2

        mod=modl
        dat=data
            if(reg_4d==1)then; call grad_4d_x  (adj, mod, dat );
        elseif(reg_4d==2)then; call grad_4d_z  (adj, mod, dat );
        elseif(reg_4d==3)then; call lapl_4d_x  (adj, mod, dat );
        elseif(reg_4d==4)then; call lapl_4d_z  (adj, mod, dat );
        elseif(reg_4d==5)then; call lapl_4d_2d (adj, mod, dat );
        elseif(reg_4d==6)then; call grad_4d_2d (adj, mod, dat );
        elseif(reg_4d==7)then; call grad_4d_2d2(adj, mod, dat );
        elseif(reg_4d==8)then; call grad_4d_z  (adj, mod, dat ); 
                               call grad_4d_x  (adj, modl,data); 
        elseif(reg_4d==9 )then;call grad_4d_2d (adj, mod, dat ); 
                               call grad_4d_x  (adj, modl,data); 
        elseif(reg_4d==10)then;call grad_4d_2d (adj, mod, dat ); 
                               call lapl_4d_x  (adj, modl,data); 
        elseif(reg_4d==11)then;call grad_4d_2d (adj, mod, dat ); 
                               call lapl_4d_2d (adj, modl,data); 
        elseif(reg_4d==12)then;call lapl_4d_2d (adj, mod, dat ); 
                               call grad_4d_x  (adj, modl,data); 
        elseif(reg_4d==13)then;call lapl_4d_2d (adj, mod, dat ); 
                               call lapl_4d_x  (adj, modl,data);  
        else
                call seperr('Select reg_4d option between 1(x-grad.), 2(z-gradient), 3(xyz-laplac.), 4(z-laplac.), 5(xyz-grad. square mag.), 6(xyz-grad. mag.), 7(xyz-laplac.)')
        endif
        if(lpick)then
                if(adj)then
                       where(pick>pclip1.and.pick<pclip2);modl=(mod*pick+modl*(1-pick));elsewhere(pick>=pclip2);modl=(mod*pick);elsewhere; modl=mod; end where
                else
                       where(pick>pclip1.and.pick<pclip2);data=(dat*pick+data*(1-pick));elsewhere(pick>=pclip2);data=(dat*pick);elsewhere; data=dat; end where
                endif
        else
                if(adj)then
                       modl=mod; 
                else
                       data=dat;
                endif
        endif
        return
  end subroutine
!!################
  subroutine lapl_x(adj, modl, data)
        logical                :: adj
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: modl
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: data
        call laplac2_init  (hgrid%ax_modl%n,1)
        do iz_modl= 1,hgrid%az_modl%n;
                stat=laplac2_lop(adj,T,modl(:,1,iz_modl),data(:,1,iz_modl))
        enddo    
  end subroutine
!!################
  subroutine lapl_z(adj, modl, data)
        logical                :: adj
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: modl
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: data
        call laplac2_init  (hgrid%ax_modl%n,1)
        do ix_modl= 1,hgrid%ax_modl%n;
                stat=laplac2_lop(adj,T,modl(ix_modl,1,:),data(ix_modl,1,:))
        enddo    
  end subroutine
!!################
  subroutine lapl_4d_x(adj, modl, data)
        logical                :: adj
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: modl
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: data
        call laplac2_init  (hgrid%ax_modl%n,1)
        do iz_modl= 1,hgrid%az_modl%n;
                stat=laplac2_lop(adj,T,modl(:,1,iz_modl),data(:,1,iz_modl))
        enddo    
  end subroutine
!!################
  subroutine lapl_4d_z(adj, modl, data)
        logical                :: adj
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: modl
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: data
        call laplac2_init  (hgrid%ax_modl%n,1)
        do ix_modl= 1,hgrid%ax_modl%n;
                stat=laplac2_lop(adj,T,modl(ix_modl,1,:),data(ix_modl,1,:))
        enddo    
  end subroutine
!!################
  subroutine lapl_4d_2d(adj, modl, data)
        logical                :: adj
        real, dimension(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n) :: modl
        real, dimension(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n) :: data
        call laplac2_init  (hgrid%ax_modl%n,hgrid%az_modl%n)
        stat=laplac2_lop(adj,T,modl,data)
  end subroutine
!!################
  subroutine grad_x(adj, modl, data)
        logical                :: adj
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: modl
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: data
        do iz_modl= 1,hgrid%az_modl%n;
                stat=igrad1_lop(adj,T,modl(:,1,iz_modl),data(:,1,iz_modl))
        enddo    
  end subroutine
!!################
  subroutine grad_z(adj, modl, data)
        logical                :: adj,add
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: modl
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: data
        do ix_modl= 1,hgrid%ax_modl%n;
                stat=igrad1_lop(adj,T,modl(ix_modl,1,:),data(ix_modl,1,:))
        enddo    
  end subroutine
!!################
  subroutine cint_z(adj, add, modl, data)
        logical                :: adj,add
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: modl
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: data
        do ix_modl= 1,hgrid%ax_modl%n;
                stat=causint_lop(adj,T,modl(ix_modl,1,:),data(ix_modl,1,:))
        enddo
  end subroutine
!!################
  subroutine leak_z(adj, add, modl, data)
        logical                :: adj,add
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: modl
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: data
        call leakint_init (rho)
        if(adj)then
                do ix_modl= 1,hgrid%ax_modl%n;
                        stat=leakint_lop(adj,T,modl(ix_modl,1,:),lmd2*data(ix_modl,1,:))
                enddo 
        else
                do ix_modl= 1,hgrid%ax_modl%n;
                        stat=leakint_lop(adj,T,lmd2*modl(ix_modl,1,:),data(ix_modl,1,:))
                enddo
        endif                
  end subroutine
!!################
  subroutine grad_4d_x(adj, modl, data)
        logical                :: adj
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: modl
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: data
        do iz_modl= 1,hgrid%az_modl%n;
                stat=igrad1_lop(adj,T,modl(:,1,iz_modl),data(:,1,iz_modl))
        enddo    
  end subroutine
!!################
  subroutine grad_4d_z(adj, modl, data)
        logical                :: adj
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: modl
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: data
        do ix_modl= 1,hgrid%ax_modl%n;
                stat=igrad1_lop(adj,T,modl(ix_modl,1,:),data(ix_modl,1,:))
        enddo    
  end subroutine
!!################
  subroutine grad_4d_2d(adj, modl, data)
        logical                :: adj
        real, dimension(nmod)  :: modl
        real, dimension(nmod)  :: data
        real, dimension(nmod*2):: data2
        call laplac2_init  (hgrid%ax_modl%n,hgrid%az_modl%n)
        if(adj)then
                data2(     1:nmod  )=data
                data2(nmod+1:nmod*2)=data
                stat=igrad2_lop(T,T,modl,data2)
        else
                stat=igrad2_lop(F,T,modl,data2)
                data=data2(1:nmod)+data2(nmod+1:nmod*2)
        endif
  end subroutine
!!################
  subroutine grad_4d_2d2(adj, modl, data)
        logical                :: adj
        real, dimension(nmod)  :: modl
        real, dimension(nmod)  :: data
        real, dimension(nmod*2):: data2
        call laplac2_init  (hgrid%ax_modl%n,hgrid%az_modl%n)
        if(adj)then
                data2(     1:nmod  )=data**2
                data2(nmod+1:nmod*2)=data**2
                stat=igrad2_lop(T,T,modl,data2)
        else
                stat=igrad2_lop(F,T,modl,data2)
                data=data2(1:nmod)**2+data2(nmod+1:nmod*2)**2
        endif
  end subroutine
!!#####################################
  subroutine fact_dz(adj, modl, data)
        logical                :: adj
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: modl
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: data
        integer                :: ix_modl, iy_modl, iz_modl
        do iz_modl= 1,hgrid%az_modl%n;
                if(adj)then
                        modl(:,:,iz_modl)=modl(:,:,iz_modl)*1/(iz_modl*dz_fact)
                else    
                        data(:,:,iz_modl)=data(:,:,iz_modl)*1/(iz_modl*dz_fact)
                endif
        enddo    
  end subroutine
!#####################################
  subroutine damping(adj, modl, data)
        logical                :: adj
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: modl
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: data
        integer                :: ix_modl, iy_modl, iz_modl

        if(adj)then
                modl=modl+data
        else    
                data=data+modl
        endif
  end subroutine

!old stuff
!#####################################
subroutine grad_base_rsv(adj, modl, data)       
        logical                :: adj
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: modl
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: data
        real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: temp
        integer                :: ix_modl, iy_modl, iz_modl

        write(0,*)index_zmin,index_zmax	
        do iy_modl= 1,hgrid%ay_modl%n ;  
        do ix_modl= 1,hgrid%ax_modl%n-1;  
                if (adj) then
                        modl(ix_modl+1,iy_modl,index_rsv_zmin:index_rsv_zmax)=modl(ix_modl+1,iy_modl,index_rsv_zmin:index_rsv_zmax) +  data(ix_modl  ,iy_modl,index_rsv_zmin:index_rsv_zmax) 
                        modl(ix_modl  ,iy_modl,index_rsv_zmin:index_rsv_zmax)=modl(ix_modl  ,iy_modl,index_rsv_zmin:index_rsv_zmax) -  data(ix_modl  ,iy_modl,index_rsv_zmin:index_rsv_zmax) 
                else
                        data(ix_modl  ,iy_modl,index_rsv_zmin:index_rsv_zmax)=data(ix_modl  ,iy_modl,index_rsv_zmin:index_rsv_zmax) + (modl(ix_modl+1,iy_modl,index_rsv_zmin:index_rsv_zmax)- & 
        														               modl(ix_modl  ,iy_modl,index_rsv_zmin:index_rsv_zmax)) 
                end if
        end do
        end do
  return
  end subroutine
!##################
  subroutine grad_4d_xz2(adj, modl, data,pick)
    logical                :: adj
    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: modl
    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: data, datz,datx
    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: tdata,tmodl,pick
    integer                :: ix_modl, iy_modl, iz_modl, izmin, izmax,  izminb, izmaxb
    real                   :: xfact,zfact,edge,clip1,clip2
    real,dimension(hgrid%az_modl%n) :: xxfact,zzfact

        datx=data
        datz=data
    
        izmin=max(1,index_rsv_zmin-rtop)
        izmax=index_zmax

        tmodl=modl;
        tdata=data;
        clip1=0.12
        clip2=0.20

        do iz_modl= 1,hgrid%az_modl%n-1;   
        do ix_modl= 1,hgrid%ax_modl%n-1;   
                if (adj) then
                        where(pick(ix_modl,:,iz_modl)<=clip1)
                               datx(ix_modl  ,:,iz_modl  )=data(ix_modl  ,:,iz_modl  )/2.
                                datz(ix_modl  ,:,iz_modl  )=data(ix_modl  ,:,iz_modl  )/2.
                                modl(ix_modl  ,:,iz_modl+1)=modl(ix_modl  ,:,iz_modl+1)+datz(ix_modl,:,iz_modl)/1.                    
                                modl(ix_modl  ,:,iz_modl  )=modl(ix_modl  ,:,iz_modl  )-datz(ix_modl,:,iz_modl)/1.                     
                                modl(ix_modl+1,:,iz_modl  )=modl(ix_modl+1,:,iz_modl  )+datx(ix_modl,:,iz_modl)/1.                    
                                modl(ix_modl  ,:,iz_modl  )=modl(ix_modl  ,:,iz_modl  )-datx(ix_modl,:,iz_modl)/1.                    
                         end where
                 else 
                         where(pick(iz_modl,ix_modl,:)<=clip1)
                                datz(ix_modl,:,iz_modl)=datz(ix_modl,:,iz_modl)+(modl(ix_modl  ,:,iz_modl+1)-modl(ix_modl,:,iz_modl))/1.
                                datx(ix_modl,:,iz_modl)=datx(ix_modl,:,iz_modl)+(modl(ix_modl+1,:,iz_modl  )-modl(ix_modl,:,iz_modl))/1.
                                data(ix_modl,:,iz_modl)=data(ix_modl,:,iz_modl)+(datx(ix_modl  ,:,iz_modl  )+datz(ix_modl,:,iz_modl))/2. 
                         end where
                end if
        enddo
        enddo     

        do ix_modl= 1,hgrid%ax_modl%n-1;  
                if (adj) then
                        where(pick(:,ix_modl,:)>=clip2)
                                tmodl(ix_modl+1,:,:)=tmodl(ix_modl+1,:,:)+tdata(ix_modl  ,:,:)                    
                                tmodl(ix_modl  ,:,:)=tmodl(ix_modl  ,:,:)-tdata(ix_modl  ,:,:) 
                        end where
                else 
                        where(pick(:,ix_modl,:)>=clip2)
                                tdata(ix_modl,:,:)=tdata(:,ix_modl,:)+tmodl(ix_modl+1,:,:)-tmodl(ix_modl,:,:) 
                        end where
                end if
        enddo     

        if(adj)then
                where(pick>=clip2);modl=tmodl*pick;end where
        else
                where(pick>=clip2);data=tdata*pick;end where
        endif
!    do ix_modl= 1,index_rsv_xmin;
!                xfact=float(index_rsv_xmin-ix_modl)/index_rsv_xmin
!                do iy_modl= 1,hgrid%ay_modl%n;  
!                do iz_modl= index_rsv_zmin,index_rsv_zmax-1 ; 
!                if (adj) then
!                        modl(iz_modl+1,ix_modl,iy_modl)=modl(iz_modl+1,ix_modl,iy_modl)+xfact*edge*data(iz_modl   ,ix_modl,iy_modl) 
!                        modl(iz_modl  ,ix_modl,iy_modl)=modl(iz_modl  ,ix_modl,iy_modl)-xfact*edge*data(iz_modl   ,ix_modl,iy_modl) 
!                else 
!                        data(iz_modl  ,ix_modl,iy_modl)=data(iz_modl  ,ix_modl,iy_modl)+xfact*edge*(modl(iz_modl+1,ix_modl,iy_modl)-modl(iz_modl ,ix_modl,iy_modl)) 
!                end if
!        end do
!        end do
!    end do
!    do ix_modl= index_rsv_xmax,hgrid%ax_modl%n ;
!                xfact=1.-float(hgrid%ax_modl%n-ix_modl)/(hgrid%ax_modl%n-index_rsv_xmax)
!                do iy_modl= 1,hgrid%ay_modl%n;  
!                do iz_modl= index_rsv_zmin,index_rsv_zmax-1 ; 
!                if (adj) then
!                        modl(iz_modl+1,ix_modl,iy_modl)=modl(iz_modl+1,ix_modl,iy_modl)+xfact*edge*data(iz_modl   ,ix_modl,iy_modl) 
!                        modl(iz_modl  ,ix_modl,iy_modl)=modl(iz_modl  ,ix_modl,iy_modl)-xfact*edge*data(iz_modl   ,ix_modl,iy_modl) 
!                else 
!                        data(iz_modl  ,ix_modl,iy_modl)=data(iz_modl  ,ix_modl,iy_modl)+xfact*edge*(modl(iz_modl+1,ix_modl,iy_modl)-modl(iz_modl ,ix_modl,iy_modl)) 
!                end if
!        end do
!        end do
!        end do

   return

  end subroutine

  end module
