!Gboyega 04/1/09
! Variable non-stationary helix filters
module hessian_convolve_vnhlx3d
 use chain0_mod
 use createhelix_mod
 use cartesian_mod
 use bound_mod
 use regrid_mod
 use adj_mod
 use lapfac_mod
 use npolydiv_mod
 use nhelicon_mod
 use wilson_mod
 use util_

 implicit none
        integer,         private                                ,save   :: stat        
        type( filter),   private                                ,save   :: aa 
        type( filter),   private                                ,save   :: bb
        type(nfilter),   private                                ,save   :: n_filt,lapfilt 
        type(vnfilter),  private                                ,save   :: vn_filt,  vn_filtx,  vn_filty
        real,            private,  dimension (:), allocatable   ,save   :: tt 
        integer,         private                                ,save   :: nd 
        logical,         private                                ,save   :: lscale,destroy_nhlx
        real,            private,                 allocatable   ,save   :: scale(:)
        integer,         private,                 allocatable   ,save   :: ptch(:), patch(:,:,:), varr(:,:,:), var2(:,:,:), patch_src(:,:,:,:,:), jvar_src(:,:,:,:,:), patch4_src(:,:,:,:,:), jvar4_src(:,:,:,:,:), n_nfilt(:)
        real,            private,                 allocatable   ,save   :: dips_dir(:,:,:,:,:), var_src(:,:,:,:,:)  
        real,            private,                 allocatable   ,save   :: dips4_src(:,:,:,:,:),var4_src(:,:,:,:,:)  !4D dips var
        real,            private,                 allocatable   ,save   :: tdip(:),tvar(:),vv(:)
        integer,         private,                 allocatable   ,save   :: jvar(:)
        real   ,         private                                ,save   :: eps_nhlx,eps_dip
        integer,         private                                ,save   :: nmod,nsc
        integer,         private                                ,save   :: nang
        real,            private                                ,save   :: oang,dang
        integer,         private                                ,save   :: nvar
        real,            private                                ,save   :: ovar,dvar
        integer,         private                                ,save   :: nang4
        real,            private                                ,save   :: oang4,dang4
        integer,         private                                ,save   :: nvar4
        real,            private                                ,save   :: ovar4,dvar4
        real,            private                                ,save   :: osc,dsc
        real,            private                                ,save   :: max_eps_dip,min_eps_dip, min_dip, max_dip

        real,            private                                ,save   :: dip,var
        real,            private                                ,save   :: lapfilt0
        integer,         private                                ,save   :: idip,iang,ifilt,verb_dip,nfilt,iidip,iivar
        integer,         private                                ,save   :: nfiltx,nfilty
        

        integer,         private                                ,save   :: n1, n2, n3, n12, n13, n123

        integer,         private                                ,save   :: ndir,nsurv
        integer,         private                                ,save   :: n1_dip,n2_dip,n3_dip
        integer,         private                                ,save   :: ndip


        real,            private                                ,save   :: n_filt0
        real,            private                                ,save   :: m,p
        real,            private                                ,save   :: pi_1,pi_2
        integer, external                  ,private   :: omp_get_num_procs
        integer, external                  ,private   :: omp_get_thread_num
        
        
        real   , parameter :: PI = 3.14159265359

        logical, parameter,private :: T = .true.
        logical, parameter,private :: F = .false.
        
        logical, private::test_dot
        logical, private::inv_var
        
        real,private            ::dsscale
        logical                 ::lsscale
        integer,private         :: niter
        integer,private         :: iv
        integer,private         :: lonevar
        
        logical, private::dip_read
        logical, private::lone_var

        logical,private         :: v3d
        logical,private         :: xline
        integer,private         :: opt
        
 contains 
!######################################
        subroutine  vns_init3d( n1_in, n2_in, n3_in, ndir_in, nsurv_in, test_dot_in, eps_dip_in)
                integer                 ::i, n1_in, n2_in, n3_in, ndir_in, ivar
                real, dimension(2)      ::u,v
                real                    :: eps_dip_in
                integer                 :: i3,idir,nsurv_in 
                integer,allocatable     :: lap(:)
                logical                 :: test_dot_in
                optional                :: test_dot_in,eps_dip_in,nsurv_in
                real                    :: var

                test_dot=F;
                if(present(test_dot_in))test_dot=test_dot_in
                nsurv=1
                if(present(nsurv_in))nsurv=nsurv_in
               
                if(allocated(ptch)) deallocate(ptch)
                if(allocated(n_nfilt)) deallocate(n_nfilt)
                if(allocated(tdip)) deallocate(tdip)
                if(allocated(tvar)) deallocate(tvar)
                if(allocated(jvar)) deallocate(jvar)

                call from_param('nang ',nang,       90 )
                if (nang>1)then; 
                        call from_param('dang ',dang, pi/(nang-1));
                elseif (nang==1)then; 
                        call from_param('dang ',dang,1.); 
                elseif (nang<1 )then; 
                        call from_param('dang ',dang,0.); 
                endif
                pi_1=-pi/2
                pi_2=+pi/2 ! range of angles
                 

                call from_param('ndip',ndip,         1 )
                call from_param('niter',niter,         1 )
                call from_param('oang ',oang,        pi_1)
                call from_param('nfilt',nfilt,         9 )
                call from_param('verb_dip',verb_dip,  1)
                call from_param('max_dip',max_dip, -pi/2 )
                call from_param('min_dip',min_dip, +pi/2 )
                call from_param('scale'  ,lscale,.false. )
                call from_param('destroy_nhlx',destroy_nhlx,.false.)
                call from_param('lsscale'  ,lsscale,.false. )
                call from_param('dsscale'  ,dsscale, 5. )
                call from_param('v3d',v3d, .false.)
                call from_param('xline',xline, .false.) !only xline
                call from_param('nfiltx',nfiltx,       5)
                call from_param('nfilty',nfilty,       5)

                if(present(eps_dip_in))then
                        eps_dip=eps_dip_in
                else
                        call from_param('eps_dip',eps_dip, 0.01 )
                endif
                n1=n1_in; n2=n2_in; n3=n3_in
                n12 =n1*n2
                n13 =n1*n3
                n123=n1*n2*n3
                nmod=n123
                ndir=ndir_in
                
                if(.not.allocated(ptch     ))allocate(ptch(n12))
                if(.not.allocated(jvar     ))allocate(jvar(n12))
                if(.not.allocated(n_nfilt  ))allocate(n_nfilt(nang))
                if(.not.allocated(tdip     ))allocate(tdip(n12))
                if(.not.allocated(tvar     ))allocate(tvar(n12))
                if(.not.allocated(patch    ))allocate(patch(n1,n2,n3))
                if(.not.allocated(varr     ))allocate( varr(n1,n2,n3))
                if(.not.allocated(var2     ))allocate( var2(n1,n2,n3))
                if(.not.allocated(patch_src))allocate(patch_src(n1,n2,n3,ndir,ndip))
                if(.not.allocated(dips_dir ))allocate(dips_dir (n1,n2,n3,ndir,ndip))
                if(.not.allocated(  var_src))allocate(  var_src(n1,n2,n3,ndir,ndip))
                if(.not.allocated(jvar_src))allocate(  jvar_src(n1,n2,n3,ndir,ndip))
                
                if(exist_file("4dip1"))then
                        if(.not.allocated(dips4_src ))allocate(dips4_src (n1,n2,n3,ndir,ndip))
                        if(.not.allocated(patch4_src))allocate(patch4_src(n1,n2,n3,ndir,ndip))
                endif
                if(exist_file("4var1"))then
                        if(.not.allocated(  var4_src))allocate(  var4_src(n1,n2,n3,ndir,ndip))
                        if(.not.allocated( jvar4_src))allocate( jvar4_src(n1,n2,n3,ndir,ndip))
                endif
                
                allocate(lap(nang))
                
                ptch=0.; jvar=0.; n_nfilt=0.; tdip=0.; tvar=0.

                if(test_dot)then
                        call random_number(dips_dir)
                        call random_number(var_src)
                else    
                        if(dip_read)then
                        else
                        do idir=1,ndir
                                if(verb_dip>1)write(0,*)'Reading dips and var for data:',idir,'. Please wait...'
                                if(idir==1 )call hessian_convolve_vdips_read3d("dip1"  ,"var1"  ,1 ,"4dip1"  ,"4var1"  )
                                if(idir==2 )call hessian_convolve_vdips_read3d("dip2"  ,"var2"  ,2 ,"4dip2"  ,"4var2"  )
                                if(idir==3 )call hessian_convolve_vdips_read3d("dip3"  ,"var3"  ,3 ,"4dip3"  ,"4var3"  )
                                if(verb_dip>1)write(0,*)'Done reading dips and var.'
                                dip_read=T
                        enddo
                        endif
                endif

                call from_param('max_eps_dip',max_eps_dip, 0.5 )
                call from_param('min_eps_dip',min_eps_dip, 0.01)
                call from_param('nvar',nvar,         1 )
                write(0,*)'*********************************************'
                write(0,*)'max_eps_dip:',max_eps_dip
                write(0,*)'min_eps_dip:',min_eps_dip
                if(maxval(var_src)==minval(var_src))nvar=1
                if (nvar>1)then;
                        call from_param('dvar ',dvar,(maxval(var_src)-minval(var_src))/(nvar-1.)); ovar=min_eps_dip
                elseif (nvar==1)then;
                        call from_param('dvar ',dvar,1.); ovar=0.
                elseif (nvar<1 )then;  
                        call from_param('dvar ',dvar,1.); ovar=0.
                        nvar=1
                endif
                call from_param('one_var',lone_var,        F )
                call from_param('lonevar',lonevar,min(1,nvar)) !for 1variance


                if(verb_dip>2)write(0,*)'*********************************************'
                if(verb_dip>2)write(0,*)'structural dips'
                if(verb_dip>2)write(0,*)'dipinfo:beg',nang,dang,oang
                dips_dir =  atan(dips_dir)
                where(dips_dir> 1.570800 )dips_dir = 1.570800    ! minvalmin-angle :-90/90 
                where(dips_dir<-1.570800 )dips_dir =-1.570800 
                if(maxval(dips_dir)==minval(dips_dir))then
                        nang=1; dang=1; oang=minval(dips_dir); if(verb_dip>2)write(0,*)'dipinfo:a  ',nang,dang,oang
                elseif(minval(dips_dir)>oang.and.maxval(dips_dir)<oang+(nang-1)*dang)then
                        oang=minval(dips_dir); dang=(maxval(dips_dir)-oang)/(nang-1); if(verb_dip>2)write(0,*)'dipinfo:b  ',nang,dang,oang
                elseif(minval(dips_dir)>oang)then 
                        oang=minval(dips_dir)
                        if(maxval(dips_dir)<oang+(nang-1)*dang)then
                                dang=(maxval(dips_dir)-oang)/(nang-1)
                        endif
                if(verb_dip>2)write(0,*)'dipinfo:c  ',nang,dang,oang
                endif
                if(verb_dip>2)write(0,*)'dipinfo:end',nang,dang,oang

                if(exist_file("4dip1"))then
                        if(verb_dip>2)write(0,*)'*********************************************'
                        if(verb_dip>2)write(0,*)'time-lapse dips'
                        if(verb_dip>2)write(0,*)'dipinfo:beg',nang4,dang4,oang4
                        where(dips4_src> 1.570800)dips4_src= 1.570800    ! minvalmin-angle :-90/90 
                        where(dips4_src<-1.570800)dips4_src=-1.570800 
                        dips4_src =  atan(dips4_src)
                        if(maxval(dips4_src)==minval(dips4_src))then
                                nang4=1; dang4=1; oang4=minval(dips4_src); if(verb_dip>2)write(0,*)'dipinfo:a  ',nang4,dang4,oang4
                        elseif(minval(dips4_src)>oang4.and.maxval(dips4_src)<oang4+(nang4-1)*dang4)then
                                oang4=minval(dips4_src); dang4=(maxval(dips4_src)-oang4)/(nang4-1); if(verb_dip>2)write(0,*)'dipinfo:b  ',nang4,dang4,oang4
                        elseif(minval(dips4_src)>oang4)then 
                                oang4=minval(dips4_src)
                                if(maxval(dips4_src)<oang4+(nang4-1)*dang4)then
                                        dang4=(maxval(dips4_src)-oang4)/(nang4-1)
                                endif
                        if(verb_dip>2)write(0,*)'dipinfo:c  ',nang4,dang4,oang4
                        endif
                        if(verb_dip>2)write(0,*)'dipinfo:end',nang4,dang4,oang4
                        if(verb_dip>2)write(0,*)'*********************************************'
                        nang=max(nang,nang4)
                        oang=max(oang,oang4)
                        dang=max(dang,dang4)
                else
                        if(verb_dip>2)write(0,*)'*********************************************'
                        if(verb_dip>2)write(0,*)'No initial 4d dips'
                endif
                if(verb_dip>2)write(0,*)'dipinfo:end',nang,dang,oang
                if(verb_dip>2)write(0,*)'*********************************************'

                if(test_dot)then; dips_dir=-1.570800; nang=10; oang=-1.570800; dang=0.2; endif

                do idip=1,ndip
                        do idir=1,ndir
!4d-structural
                                do i3=1,n3
                                        if(exist_file("4dip1"))then
                                                tdip=reshape(dips4_src(:,:,i3,idir,idip),(/n12/))
                                                do i=1,n12
                                                        dip  = tdip(i)
                                                        iidip = 1.5+(dip-oang)/dang; ptch(i)=iidip; if(ptch(i)>nang)ptch(i)=nang; if(ptch(i)<1)ptch(i)=1; if(ptch(i)>nang.or.(ptch(i)<1.).and.verb_dip>4)write(0,*)'dip',dip,iidip,ptch(i)
                                                end do
                                                patch4_src(:,:,i3,idir,idip)=reshape(ptch,(/n1,n2/))
                                        endif         
                                        if(exist_file("4var1"))then
                                                tvar=reshape( var4_src(:,:,i3,idir,idip),(/n12/))
                                                do i=1,n12
                                                        var  = tvar(i)
                                                        iivar = 1.5+(var-ovar)/dvar; jvar(i)=iivar; if(jvar(i)>nvar)jvar(i)=nvar; if(jvar(i)<1)jvar(i)=1; if(jvar(i)>nvar.or.(jvar(i)<1.).and.verb_dip>4)write(0,*)'var',var,iivar,jvar(i)
                                                end do
                                                 jvar4_src(:,:,i3,idir,idip)=reshape(jvar,(/n1,n2/))
                                        endif
                                end do
!structural
                                do i3=1,n3
                                        tdip=reshape(dips_dir(:,:,i3,idir,idip),(/n12/))
                                        tvar=reshape( var_src(:,:,i3,idir,idip),(/n12/))
                                        do i=1,n12
                                                dip  = tdip(i)
                                                var  = tvar(i)
                                                iidip = 1.5+(dip-oang)/dang; ptch(i)=iidip; if(ptch(i)>nang)ptch(i)=nang; if(ptch(i)<1)ptch(i)=1; if(ptch(i)>nang.or.(ptch(i)<1.).and.verb_dip>4)write(0,*)'dip',dip,iidip,ptch(i)
                                                iivar = 1.5+(var-ovar)/dvar; jvar(i)=iivar; if(jvar(i)>nvar)jvar(i)=nvar; if(jvar(i)<1)jvar(i)=1; if(jvar(i)>nvar.or.(jvar(i)<1.).and.verb_dip>4)write(0,*)'var',var,iivar,jvar(i)
                                        end do
                                        patch_src(:,:,i3,idir,idip)=reshape(ptch,(/n1,n2/))
                                         jvar_src(:,:,i3,idir,idip)=reshape(jvar,(/n1,n2/))
                                end do
                        end do
                end do
                
                
!                write(0,*)'structural-',maxval(jvar),minval(jvar),maxval(var_src),minval(var_src)
!                write(0,*)'time-lapse-',maxval(jvar),minval(jvar),maxval(var_src),minval(var_src)

                where (patch_src>float(nang))patch_src=nang;    where (patch_src<1. )patch_src=1
                where ( jvar_src>nvar       )patch_src=nvar;    where (jvar_src<1.  )patch_src=1
                where (     ptch>float(nang))     ptch=nang;    where (ptch<1.      )ptch=1
                where (    jvar>nvar        )     jvar=nvar;    where (jvar<1.      )jvar=1

                n_nfilt=nfilt *3; call vnallocate(vn_filt ,n_nfilt,ptch,jvar,nvar)
                n_nfilt=nfiltx*3; call vnallocate(vn_filtx,n_nfilt,ptch,jvar,nvar)
                n_nfilt=nfilty*3; call vnallocate(vn_filty,n_nfilt,ptch,jvar,nvar)

                lap=4

                call nallocate(lapfilt,lap, ptch)      ! alloc. filter
                varr= jvar_src(:,:,:,1,1)
                var2= nvar-jvar_src(:,:,:,1,1)+1
                if(verb_dip>2)write(0,*)'*********************************************'
                if(verb_dip>2)write(0,*)'varr--destroy',minval(varr),maxval(varr)
                if(verb_dip>2)write(0,*)'var2--smooth ',minval(var2),maxval(var2)
                if(verb_dip>2)write(0,*)'*********************************************'
                do iv=1,nvar
                        var=1+(ovar+(iv-1)*dvar)
7                       if(verb_dip>1)write(0,'(A25,I4,F6.2,A5,I5,A7,F5.2)',advance='no')'working on variance',iv,var,'of',nvar,'eps=>',max(1.,var)*eps_dip
                        do iang=1,nang
                                do ifilt=1,nfilt
                                        vn_filt%nhlx(iv)%hlx(iang)%lag(         ifilt) = ifilt                      ! early lags (first row)
                                        vn_filt%nhlx(iv)%hlx(iang)%lag( nfilt  +ifilt) = n1 + ifilt - nfilt         ! late lags  (second row)
                                        vn_filt%nhlx(iv)%hlx(iang)%lag( nfilt*2+ifilt) = n1 + ifilt                 ! late late lags (second row)
                                end do
                        end do
                        lapfilt0 = 1. + max(1.,var)*eps_dip        ! zero lag coeff. multiply by variance
                        call wilson_init( 10 * n1 )
                        do iang=1,nang
                                lapfilt%hlx(iang)%lag = (/ 1, n1-1, n1, n1+1/)    ! lag(1)= 1; lag(2)=n1  # one side only
                                dip=oang+(iang-1)*dang
                                if(verb_dip>5)write(0,*)'working on angle',iang,dip,degrad(1,dip),'of', nang
                                u(1)= cos(dip); u(2)=-sin(dip); 
                                m=(u(1)-u(2))/2.; 
                                p=(u(1)+u(2))/2.;
                                lapfilt%hlx(iang)%flt = 0.;
                                lapfilt%hlx(iang)%flt = (/2*m*p,-p*p,-2*m*p,-m*m/)
                                call wilson_factor( 100, lapfilt0, lapfilt%hlx(iang), n_filt0, vn_filt%nhlx(iv)%hlx(iang))
                                if(verb_dip>5)write(0,'(50F10.6)')vn_filt%nhlx(iv)%hlx(iang)%flt
                        end do
                        call wilson_close()
                        if(verb_dip>1)write(0,*)'finished variance'
                enddo
                if(destroy_nhlx)then
                        call vnhelicon_init(     vn_filt)
                else
                        call vnpolydiv_init(nmod,vn_filt)
                endif        
                call hessian_convolve_vdips_init3d(1,1)
                inv_var=F
                write(0,*)'*********************************************'
        end subroutine

 !######################################
        subroutine hessian_convolve_vdips_read3d(dipfile_,varfile_,idir,dip4file_,var4file_)
                character(*)            :: dipfile_,varfile_   !structural dips 
                character(*)            :: dip4file_,var4file_ !4d dips
                integer                 :: idir
                optional                :: dip4file_,var4file_
                        call from_aux(dipfile_,'n1',n1_dip,1 ); call from_aux(dipfile_,'n2',n2_dip,1 ); call from_aux(dipfile_,'n3',n3_dip,1)
                        write(0,*)'dipfile',n1_dip,n2_dip,n3_dip
                        if(n1_dip/=n1)then; write(0,*)'n1_dip/=n1 in file:',trim(dipfile_); call seperr('Error in hessian_convolve_dips_read');endif
                        if(n2_dip/=n2)then; write(0,*)'n2_dip/=n2 in file:',trim(dipfile_); call seperr('Error in hessian_convolve_dips_read');endif
                        if(n3_dip/=n3)then; write(0,*)'n3_dip/=n3 in file:',trim(dipfile_); call seperr('Error in hessian_convolve_dips_read');endif
                        call from_aux(varfile_,'n1',n1_dip,1 ); call from_aux(varfile_,'n2',n2_dip,1 ); call from_aux(varfile_,'n3',n3_dip,1)
                        write(0,*)'varfile',n1_dip,n2_dip,n3_dip
                        if(n1_dip/=n1)then; write(0,*)'n1_dip/=n1 in varfile:',trim(varfile_); call seperr('Error in hessian_convolve_dips_read');endif
                        if(n2_dip/=n2)then; write(0,*)'n2_dip/=n2 in varfile:',trim(varfile_); call seperr('Error in hessian_convolve_dips_read');endif
                        if(n3_dip/=n3)then; write(0,*)'n3_dip/=n3 in varfile:',trim(varfile_); call seperr('Error in hessian_convolve_dips_read');endif
                        if(allocated(dips_dir))then
                                call sep_read(dips_dir(:,:,:,idir,:), trim(dipfile_))
                        else
                                call seperr('dips_dir not allocated in hessian_convolve_vdips_read')
                        endif
                        if(allocated(var_src))then
                                call sep_read(var_src(:,:,:,idir,:), trim(varfile_))
                        else
                                call seperr('var_src not allocated in hessian_convolve_vdips_read ')
                        endif
                        if(exist_file(dip4file_))then
                                call from_aux(dip4file_,'n1',n1_dip,1 ); call from_aux(dip4file_,'n2',n2_dip,1 ); call from_aux(dip4file_,'n3',n3_dip,1)
                                write(0,*)'dip4file',n1_dip,n2_dip,n3_dip
                                if(n1_dip/=n1)then; write(0,*)'n1_dip/=n1 in 4dfile:',trim(dip4file_); call seperr('Error in hessian_convolve_dips_read');endif
                                if(n2_dip/=n2)then; write(0,*)'n2_dip/=n2 in 4dfile:',trim(dip4file_); call seperr('Error in hessian_convolve_dips_read');endif
                                if(n3_dip/=n3)then; write(0,*)'n3_dip/=n3 in 4dfile:',trim(dip4file_); call seperr('Error in hessian_convolve_dips_read');endif
                                if(allocated(dips4_src))then
                                        call sep_read(dips4_src(:,:,:,idir,:), trim(dip4file_))
                                else
                                        call seperr('dips_dir not allocated in hessian_convolve_vdips_read')
                                endif
                        endif
                        if(exist_file(var4file_))then
                                call from_aux(var4file_,'n1',n1_dip,1 ); call from_aux(var4file_,'n2',n2_dip,1 ); call from_aux(var4file_,'n3',n3_dip,1)
                                write(0,*)'var4file',n1_dip,n2_dip,n3_dip
                                if(n1_dip/=n1)then; write(0,*)'n1_dip/=n1 in 4dvarfile:',trim(var4file_); call seperr('Error in hessian_convolve_dips_read');endif
                                if(n2_dip/=n2)then; write(0,*)'n2_dip/=n2 in 4dvarfile:',trim(var4file_); call seperr('Error in hessian_convolve_dips_read');endif
                                if(n3_dip/=n3)then; write(0,*)'n3_dip/=n3 in 4dvarfile:',trim(var4file_); call seperr('Error in hessian_convolve_dips_read');endif
                                if(allocated(var4_src))then
                                        call sep_read(var4_src(:,:,:,idir,:), trim(var4file_))
                                else
                                        call seperr('var_src not allocated in hessian_convolve_vdips_read ')
                                endif
                        endif        

        end subroutine
 !######################################
        subroutine hessian_convolve_vdips_init3d(j4,idip) 
                integer                 :: j4,idip
                        if(verb_dip>3)write(0,'(A30,I3)',advance='no')'(Re)assigning Dips for data: ',j4
                        patch=patch_src(:,:,:,j4,idip)
                         varr= jvar_src(:,:,:,j4,idip)
                         var2= nvar-jvar_src(:,:,:,j4,1)+1
                         !write(0,*)'varr',minval(varr),maxval(varr)
                         !write(0,*)'var2',minval(var2),maxval(var2)
                        if(verb_dip>3)write(0,*)'... Done (re)assigning.'
        end subroutine
 !######################################
        subroutine hessian_convolve_4dvdips_init3d(j4,idip)
                integer                 :: j4,idip
                        if(verb_dip>3)write(0,'(A30,I3)',advance='no')'(Re)assigning 4D-dips for data: ',j4
                         patch=patch4_src(:,:,:,j4,idip)
                         varr = jvar4_src(:,:,:,j4,idip) 
                         var2 = nvar-jvar4_src(:,:,:,j4,1)+1
                         !write(0,*)'varr',minval(varr),maxval(varr)
                         !write(0,*)'var2',minval(var2),maxval(var2)
                        if(verb_dip>3)write(0,*)'... Done (re)assigning.'
        end subroutine
!#####################################################
        integer function hessian_convolve_vdips_oper_1var_init3d(lonvar_in)  result(stat)
                integer                         :: lonvar_in
                optional                        :: lonvar_in
                stat=1
                        if(present(lonvar_in))lonevar=lonvar_in
                stat=0
        end function
!#####################################################
        integer function hessian_convolve_vdips_oper_1var3d(adj,add,xx,yy)  result(stat)
                real, dimension (:)             :: xx,yy
                integer                         :: isurv
                logical , intent(in)            :: adj,add
                logical                         :: tmp_var
                stat=1
                        tmp_var=lone_var
                        lone_var=T
                        call adjnull (adj,add,xx ,yy );
                        do isurv=1,nsurv; 
                                call vnhlx_lop3d(adj,add,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));
                        enddo
                        lone_var=tmp_var
                stat=0
        end function
!#####################################################lone_var
        integer function hessian_convolve_vdips_oper3d(adj,add,xx,yy)  result(stat)
                real, dimension (:)             :: xx,yy
                integer                         :: isurv
                logical , intent(in)            :: adj,add
                stat=1
                        call adjnull (adj,add,xx ,yy );
                        do isurv=1,nsurv; 
                                call vnhlx_lop3d(adj,add,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));
                        enddo
                stat=0
        end function
!#####################################################  
        integer function hessian_convolve_vdips_smth3d(adj,add,xx,yy)  result(stat) !snooth
                real, dimension (:)             :: xx,yy
                integer                         :: isurv
                logical , intent(in)            :: adj,add
                logical                         :: tmp_destroy,tmp_inv_var
                stat=1
                        call adjnull (adj,add,xx ,yy );
                        tmp_destroy=destroy_nhlx
                        tmp_inv_var=inv_var
                        inv_var=T
                        destroy_nhlx=F
                        do isurv=1,nsurv; 
                                call vnhlx_lop3d(adj,add,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));
                        enddo
                        destroy_nhlx=tmp_destroy
                        inv_var=tmp_inv_var
                stat=0
        end function
!#####################################################  
        subroutine vnhlx_lop3d(adj,add,mod,dat)
                real, dimension (n1,n2,n3)      :: mod,dat
                real, dimension (n12)           :: xx,yy
                logical , intent(in)            :: adj,add
                integer                         :: i3
                do i3=1,n3
                        if(lone_var)then
                                vn_filt%var         =lonevar
                        elseif(inv_var)then
                                vn_filt%var         =reshape(( var2(:,:,i3)),(/n12/))
                        else
                                vn_filt%var         =reshape(( varr(:,:,i3)),(/n12/))
                        endif
                        do iv=1,nvar
                                vn_filt%nhlx(iv)%pch=reshape((patch(:,:,i3)),(/n12/))
                        enddo
                
                        xx=reshape((mod(:,:,i3)),(/n12/))
                        yy=reshape((dat(:,:,i3)),(/n12/))
                        call vnhlx_transp3d(1,xx,yy);
                        if (destroy_nhlx)then
                                call vnhelicon_init(vn_filt)
                                call filt_vnhelicon3d(adj,add,xx,yy);
                        else
                                call vnpolydiv_init(n12,vn_filt)
                                call filt_vnpolydiv3d(adj,add,xx,yy);
                        endif
                        call vnhlx_transp3d(-1,xx,yy);
                        mod(:,:,i3)=reshape(xx,(/n1,n2/))
                        dat(:,:,i3)=reshape(yy,(/n1,n2/))
                enddo
               !if(adj)then; mod(1,:,: )=0.; mod(n1,:,:)=0.; else; dat(1,:,: )=0.; dat(n1,:,:)=0.; endif
        end subroutine        
!#####################################################  conv or deconv
        integer function vnhlx_it3d(adj, add, xx, yy) result(stat)
                logical,intent(in)         :: adj,add 
                real, dimension (:)          :: xx, yy
                integer                        :: isurv
                call adjnull (adj,add, xx, yy)
                do isurv=1,nsurv; call vnhlx_transp3d( 1,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));enddo
                if (destroy_nhlx)then
                        do isurv=1,nsurv; call filt_vnhelicon3d(adj,add,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));enddo
                else
                        do isurv=1,nsurv; call filt_vnpolydiv3d(adj,add,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));enddo
                endif
                do isurv=1,nsurv; call vnhlx_transp3d(-1,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));enddo
                stat=0
        end function

!######################################
        subroutine filt_vnpolydiv3d( adj, add, xx, yy) 
                integer                   :: stat,stat1,stat2 
                logical,intent(in)        :: adj,add 
                real,dimension(:)         :: xx,yy 
                real, dimension(size(xx)) :: tmp
                tmp=0.
                if ( adj) then
                        stat= vnpolydiv_lop(.false.,add, yy,tmp)     ! tmp = grad y
                        stat= vnpolydiv_lop(.true. ,add, xx,tmp)     ! x = x + grad' tmp
                else
                        stat= vnpolydiv_lop(.false.,add, xx,tmp)     ! tmp = grad x
                        stat= vnpolydiv_lop(.true. ,add, yy,tmp)     ! y = y + grad' tmp
                endif
                stat=stat*stat2
        end subroutine 
!######################################
        subroutine filt_vnhelicon3d( adj, add, xx, yy) 
                integer                   :: stat,stat1,stat2 
                logical,intent(in)        :: adj,add 
                real,dimension(:)         :: xx,yy 
                real, dimension(size(xx)) :: tmp
                tmp=0.
                if ( adj) then
                        stat= vnhelicon_lop(.false.,add, yy,tmp)     ! tmp = grad y
                        stat= vnhelicon_lop(.true. ,T  , xx,tmp)     ! x = x + grad' tmp
                else
                        stat= vnhelicon_lop(.false.,add, xx,tmp)     ! tmp = grad x
                        stat= vnhelicon_lop(.true. ,T  , yy,tmp)     ! y = y + grad' tmp
                endif
                stat=stat*stat2
        end subroutine
!#####################################################  transp before filter and back
        subroutine vnhlx_transp3d(fwd,xx,yy)
                integer,intent(in)      :: fwd 
                real, dimension (:)     :: xx, yy 
                real, dimension(:,:), allocatable       :: temp
                optional                        :: yy
                if (fwd==1)then
                        allocate (temp(n2,n1))
                        temp=reshape(xx,(/n2,n1 /)); xx=reshape(transpose(temp),(/ nmod /))
                        if(present(yy))then; temp=reshape(yy,(/n2,n1 /)); yy=reshape(transpose(temp),(/ nmod /)); endif
                else
                        allocate (temp(n1,n2))
                        temp=reshape(xx,(/n1,n2 /)); xx=reshape(transpose(temp),(/ nmod /))
                        if(present(yy))then; temp=reshape(yy,(/n1,n2 /)); yy=reshape(transpose(temp),(/ nmod /));endif
                endif
                stat=0
                deallocate (temp)
        end subroutine
!!############################################################################################################# joint preconditioners
!!#####################################spatial int + temp-smooth ...note:int_temp_oper in prc
!        integer function vnhlx_row1(adj, add, mod, dat) result(stat)
!                logical, intent (in)     :: adj, add
!                real, dimension (: )     :: mod, dat
!                if(destroy)then        
!                        stat=1; stat=row_1(vnhlx_it, grad_temp_oper, adj,add,mod,dat); stat=0 
!                else
!                        stat=1; stat=row_1(vnhlx_it,  int_temp_oper, adj,add,mod,dat); stat=0 
!                endif
!        end function
!!######################################
!        integer function vnhlx_row2(adj, add, mod, dat) result(stat)
!                logical, intent (in)     :: adj, add
!                real, dimension (: )     :: mod, dat
!                if(destroy)then        
!                        stat=1; stat=row_2(vnhlx_it,grad_temp_oper, adj,add,mod,dat); stat=0 
!                else
!                        stat=1; stat=row_2(vnhlx_it, int_temp_oper, adj,add,mod,dat); stat=0 
!                endif
!        end function
!!######################################
!        integer function vnhlx_row3(adj, add, mod, dat) result(stat)
!                logical, intent (in)     :: adj, add
!                real, dimension (: )     :: mod, dat
!                if(destroy)then        
!                        stat=1; stat=row_2(vnhlx_it,grad_temp_oper, adj,add,mod,dat) ; stat=0
!                else
!                        stat=1; stat=row_2(vnhlx_it, int_temp_oper, adj,add,mod,dat); stat=0 
!                endif
!        end function
!!######################################
!        integer function vnhlx_chain1(adj, add, mod, dat) result(stat)
!                logical, intent (in)            :: adj, add
!                real, dimension (: )            :: mod, dat
!                real, dimension (size(dat))     :: tmp
!                if(destroy)then        
!                        stat=1; call chain0(vnhlx_it,grad_temp_oper,adj,add,mod,dat,tmp); stat=0
!                else
!                        stat=1; call chain0(vnhlx_it, int_temp_oper,adj,add,mod,dat,tmp); stat=0
!                endif
!        end function
!!######################################
!        integer function vnhlx_chain2(adj, add, mod, dat) result(stat)
!                logical, intent (in)            :: adj, add
!                real, dimension (: )            :: mod, dat
!                real, dimension (size(dat))     :: tmp
!                if(destroy)then        
!                        stat=chain_2(grad_temp_oper, vnhlx_it, adj,add,mod,dat); stat=0
!                else
!                        stat=chain_2(int_temp_oper , vnhlx_it, adj,add,mod,dat); stat=0
!                endif
!        end function
!!######################################
!        integer function vnhlx_chain_2(adj, add, mod, dat) result(stat)
!                logical, intent (in)            :: adj, add
!                real, dimension (: )            :: mod, dat
!                real, dimension (size(dat))     :: tmp
!                if(destroy)then        
!                        stat=chain_2(vnhlx_it, grad_temp_oper, adj,add,mod,dat); stat=0
!                else
!                        stat=chain_2(vnhlx_it, int_temp_oper , adj,add,mod,dat); stat=0
!                endif
!        end function
! ! #####################################Scaling functions for vnhlx
!  integer function vnhlx_scale(iter,niter,adj) result(stat)
!        integer, intent (in)     :: iter, niter
!        logical,intent(in)       :: adj
!        stat=1
!        if(iter==1.or.(lsscale.and.adj))then; if (modulo(iter,int(dsscale))==1)then; 
!            eps_dip=min_eps_dip+(iter-1)*(max_eps_dip-min_eps_dip)/niter; 
!            write(0,*)'[Re]Computing spatial-filters with eps_dip:',eps_dip
!            call vns_init(f1,dips1,eps_dip); else;            ; endif; 
!        endif
!        if(iter==1.or.(ltscale.and.adj))then; if (modulo(iter,int(dtscale))==1)then;
!            rho_t=max_rho_t-(iter-1)*(max_rho_t-min_rho_t)/niter; 
!            write(0,*)'[Re]Computing temporal-filters with rho_t :',rho_t
!                                         else; rho_t=rho_t; endif; 
!        endif
!        stat=0
!  end function
!  
!  
!!######################################spatiotemporal
!  integer function spatio_lop( adj, add, mod, dat) result(stat) 
!        integer                   :: stat1,stat2 
!        logical,intent(in)        :: adj,add 
!        real,dimension(:)         :: mod,dat
!                if(verb>4)write(0,*)'++++++++++++++++++',adj,add
!                if(verb>4)write(0,*)sum(mod),sum(dat(1:size(mod))),sum(dat(1+size(mod):)),size(mod),size(dat(1+size(mod):)),'b4'
!                        stat=       vnhlx_it(adj, add, mod, dat(1:size(mod) ))
!                if(verb>4)write(0,*)sum(mod),sum(dat(1:size(mod))),sum(dat(1+size(mod):)),size(mod),size(dat(1+size(mod):)),'mid'
!                        stat= grad_temp_oper(adj, add, mod, dat(1+size(mod):))
!                if(verb>4)write(0,*)sum(mod),sum(dat(1:size(mod))),sum(dat(1+size(mod):)),size(mod),size(dat(1+size(mod):)),'af'
!                if(verb>4)write(0,*)'++++++++++++++++++',adj,add
!  end function
!!#####################################################  angles
real function degtan(theta)
        real theta,pi
        pi=3.14159267
        degtan=tan(pi*theta/180)
        return
end function
!!#####################################################  angles
real function degrad(fwd,theta) result(theta1)
        integer :: fwd
        real pi,theta
                pi=3.14159267
                if (fwd==-1)then
                        theta1=pi*theta/180
                else
                        theta1=theta*180/pi
                endif
        return
end function

!!#####################################################  close
integer function vns_clos3d() result(stat); 
        stat=1
        if(allocated(ptch      ))deallocate(ptch)
        if(allocated(jvar      ))deallocate(jvar)
        if(allocated(n_nfilt   ))deallocate(n_nfilt)
        if(allocated(tdip      ))deallocate(tdip)
        if(allocated(tvar      ))deallocate(tvar)
        if(allocated(patch     ))deallocate(patch)
        if(allocated(varr      ))deallocate( varr)
        if(allocated(var2      ))deallocate( var2)
        if(allocated(patch_src ))deallocate(patch_src )
        if(allocated(dips_dir  ))deallocate( dips_dir )
        if(allocated(  var_src ))deallocate(  var_src )
        if(allocated(jvar_src  ))deallocate( jvar_src )
        if(allocated(patch4_src))deallocate(patch4_src)
        if(allocated(dips4_src ))deallocate(dips4_src )
        if(allocated(  var4_src))deallocate( var4_src )
        if(allocated(jvar4_src ))deallocate(jvar4_src )
        stat=0
end function



end module
