!hessian compute
module hessian_history
  use hessian_params
  implicit none

  contains
!========================================================================================== 
  subroutine greens_input_history()
  real :: w
  integer :: iiw
  complex, allocatable:: tmp(:)
    greens_= "greens"; 
    wavelet_="wavelet"
    source=.false.
    if (exist_file(wavelet_))source=.true.
    call from_param("jw"  , jw  , 1 ); call from_param("jjw" , jjw , 1 ); 
    call auxin(greens_)
    call hinaxis2(greens_, ggrid%ax_surf, 1); 
    call hinaxis2(greens_, ggrid%ay_surf, 2); 
    call hinaxis2(greens_, ggrid%ax_modl, 3); 
    call hinaxis2(greens_, ggrid%ay_modl, 4); 
    call hinaxis2(greens_, ggrid%az_modl, 5); 
    call hinaxis2(greens_, ggrid%aw , 6);
!   ggrid%aw%n= nint(ggrid%aw%n/jw*1.); ggrid%aw%d=(ggrid%aw%d*jw*1.) 
    ggrid%aw%n= nint(ggrid%aw%n/jw*1.); ggrid%aw%d=(ggrid%aw%d*jw*1.) 

    if (source) then; call hinaxis2(wavelet_, dgrid%aw, 3); write(6,*)'wavelet....'; else; dgrid%aw = ggrid%aw; end if
    allocate(csou(ggrid%aw%n)); allocate(tmp(dgrid%aw%n))
    if (source)then
        if (dgrid%aw%n /= ggrid%aw%n .or. dgrid%aw%d /= ggrid%aw%d .or. dgrid%aw%o /= ggrid%aw%o) then
                call sep_read(tmp, wavelet_, esize=8); 
                do iw=1,ggrid%aw%n; 
                        w   = ggrid%aw%o + (iw-1)*ggrid%aw%d;
                        iiw = 1.5 + (w-dgrid%aw%o)/dgrid%aw%d; 
                        csou(iw)=tmp(iiw); 
                enddo; 
!               dgrid%aw=ggrid%aw;
        else
                call sep_read(tmp, wavelet_, esize=8); csou(:)=tmp(:)
        endif
    else
        dgrid%aw=ggrid%aw; csou(:)=1
    endif
    call data_radians_calc; 
    call green_radians_calc; 


    write(0,*)'========================='
    write(0,*)'Summary Greens     ======'
    write(0,*)'========================='
    write(0,*)'x_surf:n_d_o  :',ggrid%ax_surf
    write(0,*)'y_surf:n_d_o  :',ggrid%ay_surf
    write(0,*)'x_modl:n_d_o  :',ggrid%ax_modl
    write(0,*)'y_modl:n_d_o  :',ggrid%ay_modl
    write(0,*)'z_modl:n_d_o  :',ggrid%az_modl
    write(0,*)'dgrid_aw:n_d_o:',dgrid%aw
    write(0,*)'ggrid_aw:n_d_o:',ggrid%aw
    write(0,*)'jw            :',jw
    write(0,*)'========================='
    deallocate(tmp)
  end subroutine  
!==========================================================================================
  subroutine hess_output_history()
    !!!!!Outputs the Hessain details into the history file...
    hessian_= "hessian"; 
    call auxinout(hessian_)
    call houaxis2(hessian_, hgrid%ahx_offd, 1); call houaxis2(hessian_, hgrid%ahy_offd, 2); call houaxis2(hessian_, hgrid%ax_offd , 3); call houaxis2(hessian_, hgrid%ay_offd , 4); call houaxis2(hessian_, hgrid%az_offd , 5); 
    call houaxis2(hessian_, hgrid%ahx_modl, 6); call houaxis2(hessian_, hgrid%ahy_modl, 7); call houaxis2(hessian_, hgrid%ax_modl , 8); call houaxis2(hessian_, hgrid%ay_modl , 9); 
    call auxputch("n10", "i", hgrid%az_modl%n, hessian_); call auxputch("d10", "r", hgrid%az_modl%d, hessian_); call auxputch("o10", "r", hgrid%az_modl%o, hessian_)
    !labels ==========================
    call auxputch("label1","s","hx_offd", hessian_); call auxputch("label2","s","hy_offd", hessian_); call auxputch("label3","s"," x_offd", hessian_); call auxputch("label4","s"," y_offd", hessian_); call auxputch("label5 ","s"," z_offd", hessian_)
    call auxputch("label6","s","hx_modl", hessian_); call auxputch("label7","s","hy_modl", hessian_); call auxputch("label8","s"," x_modl", hessian_); call auxputch("label9","s"," y_modl", hessian_); call auxputch("label10","s"," z_modl", hessian_)
    call auxputch("d11", "r", ggrid%aw%d, hessian_); call auxputch("o11", "r", ggrid%aw%o, hessian_); call auxputch("label11","s","w     ", hessian_)
    if (nostack)then 
        call auxputch("n11", "i", ggrid%aw%n,hessian_);  else; call auxputch("n11", "i", 1         ,hessian_)
    endif 
  end subroutine 
    !===================================================
  end module

