!hessian compute
module hessian_io
  use hessian_params      
  implicit none
 contains
!====================================================================================================================
!initialize the full hessian to zeros.
 subroutine hess_io_init()
    real, allocatable, dimension(:) :: ctmp
    integer                         :: i, nloop
    allocate(ctmp(hgrid%ahx_modl%n*hgrid%ahy_modl%n*hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
    ctmp = 0.
          nloop = hgrid%ahx_offd%n*hgrid%ahy_offd%n*hgrid%ax_offd%n*hgrid%ay_offd%n*hgrid%az_offd%n
          write(*,*)'Initializing Hessian.....'
        if (nostack)then
                do i=1, nloop*ggrid%aw%n; call sep_write(ctmp, hessian_, esize=4); end do
        else
                do i=1, nloop           ; call sep_write(ctmp, hessian_, esize=4); end do
        endif
    deallocate(ctmp)
  end subroutine
!====================================================================================================================
  subroutine hess_io_greens(greens, index_ws)
    integer                                   :: index_ws
    integer, dimension(6)                     :: n_cube, j_wind, n_wind, f_wind
    integer                                   :: n_dim_cube, err
    complex, dimension(:,:,:,:,:), allocatable:: greens
 
    n_dim_cube = 6 
    n_cube = (/ggrid%ax_surf%n, ggrid%ay_surf%n, ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n, int(.5+(ggrid%aw%n*jw)) /)
    j_wind = (/1              , 1              , 1              , 1              , 1              , 1                       /)
    n_wind = (/ggrid%ax_surf%n, ggrid%ay_surf%n, ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n, 1                       /)
    f_wind = (/0              , 0              , 0              , 0              , 0              , index_ws-1              /)
    !write(*,*) n_cube; write(*,*) n_wind; write(*,*) f_wind; write(*,*) j_wind
    greens = 0.

    !write(0,*)'reading greens frequency: ', index_ws, 'of ', int(.5+(ggrid%aw%n*jw))
    err = sreed_window(greens_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,greens)
    if (err /= 0) call seperr("data_io_greens: error readin greens")

  end subroutine
!===================================================
  subroutine hess_io_wavelet(wavelet, index_ws)
    complex, dimension(:), pointer :: wavelet
    integer                        :: index_ws
    integer, dimension(1)          :: n_cube, j_wind, n_wind, f_wind
    integer                        :: n_dim_cube, err

    n_dim_cube = 1; n_cube = dgrid%aw%n; j_wind = 1; n_wind = 1; f_wind = index_ws-1
    !write(*,*) n_cube; write(*,*) n_wind; write(*,*) f_wind; write(*,*) j_wind
    wavelet = 0.
    err = sreed_window(wavelet_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,wavelet)
    if (err .lt. 0) call seperr("io_wavelet: trouble reading source wavelet")
  end subroutine

!#####################################################
 subroutine                    hess_io_hess(hessian,index_aw,index_hx_modl,index_hy_modl,index_x_modl,index_y_modl,index_z_modl, flag); 
    integer                                     ::  index_aw,index_hx_modl,index_hy_modl,index_x_modl,index_y_modl,index_z_modl 
    integer, dimension(11)                      ::  n_cube, j_wind, n_wind, f_wind
    integer                                     ::  n_dim_cube, err
    real, dimension(:,:,:,:,:),      allocatable::  hessian
    character(len=4)                            ::  flag

    n_dim_cube = 11
    n_cube = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n, ggrid%aw%n/)
    j_wind = (/1               , 1               , 1              , 1              , 1              , 1               , 1               , 1              , 1              , 1              , 1         /)
    n_wind = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, 1               , 1               , 1              , 1              , 1              , 1         /)
    f_wind = (/0               , 0               , 0              , 0              , 0              , index_hx_modl-1 , index_hy_modl-1 , index_x_modl-1 , index_y_modl-1 , index_z_modl-1 , index_aw-1/)
   ! write(*,*) n_cube; write(*,*) n_wind; write(*,*) f_wind; write(*,*) j_wind,'--'

    if (flag == "rite") then
                !write(0,*)'writing hessian freq: ', index_aw, 'of ', ggrid%aw%n; 
                err = srite_window(hessian_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian)
    else if (flag == "reed") then
                !write(0,*)'reading hessian freq: ', index_aw, 'of ', ggrid%aw%n; 
                err = sreed_window(hessian_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian)
    else
       call seperr("you have to specify the flag for data_io_data()")
    end if

    if (err /= 0) call seperr("hess_io_hess: error writing hessian")
  end subroutine
!##################################################### 
 subroutine                    hess_io_hess2(hessian,index_aw,index_x_modl,index_y_modl,index_z_modl, flag); 
    integer                                     ::  index_aw,index_x_modl,index_y_modl,index_z_modl 
    integer, dimension(11)                      ::  n_cube, j_wind, n_wind, f_wind
    integer                                     ::  n_dim_cube, err
    real, dimension(:,:,:,:,:,:,:),  allocatable::  hessian
    character(len=4)                            ::  flag

    n_dim_cube = 11
    n_cube = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n, ggrid%aw%n/)
    j_wind = (/1               , 1               , 1              , 1              , 1              , 1               , 1               , 1              , 1              , 1              , 1         /)
    n_wind = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, hgrid%ahx_modl%n, hgrid%ahy_modl%n, 1              , 1              , 1              , 1         /)
    f_wind = (/0               , 0               , 0              , 0              , 0              , 0               , 0               , index_x_modl-1 , index_y_modl-1 , index_z_modl-1 , index_aw-1/)
    write(0,'(11I7)') n_cube; write(0,'(11I7)') n_wind; write(0,'(11I7)') f_wind; write(0,'(11I7)') j_wind; write(0,*)'--'
     if (flag == "rite") then
                !write(0,*)'writing hessian freq: ', index_aw, 'of ', ggrid%aw%n; 
                err = srite_window(hessian_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian)
    else if (flag == "reed") then
                !write(0,*)'reading hessian freq: ', index_aw, 'of ', ggrid%aw%n; 
                err = sreed_window(hessian_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian)
    else
       call seperr("you have to specify the flag for data_io_data()")
    end if

    if (err /= 0) call seperr("hess_io_hess: error writing hessian")
  end subroutine
!##################################################### 
 subroutine                    hess_io_hess3(hessian, flag); 
    integer                                     ::  index_aw,index_hx_modl,index_hy_modl,index_x_modl,index_y_modl,index_z_modl 
    integer, dimension(11)                      ::  n_cube, j_wind, n_wind, f_wind
    integer                                     ::  n_dim_cube, err
    real, dimension(:,:,:,:,:,:),    allocatable::  hessian
    character(len=4)                            ::  flag

    n_dim_cube = 11
    n_cube = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n, 1/)
    j_wind = (/1               , 1               , 1              , 1              , 1              , 1               , 1               , 1              , 1              , 1              , 1/)
    n_wind = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n, 1/)
    f_wind = (/0               , 0               , 0              , 0              , 0              , 0               , 0               , 0              , 0              , 0              , 0/)
 !  write(0,'(11I7)') n_cube; write(0,'(11I7)') n_wind; write(0,'(11I7)') f_wind; write(0,'(11I7)') j_wind; write(0,*)'--'
    if (flag == "rite") then
                !write(0,*)'writing hessian freq: ', index_aw, 'of ', ggrid%aw%n; 
                err = srite_window(hessian_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian)
    else if (flag == "reed") then
                !write(0,*)'reading hessian freq: ', index_aw, 'of ', ggrid%aw%n; 
                err = sreed_window(hessian_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian)
    else
       call seperr("you have to specify the flag for data_io_data()")
    end if

    if (err /= 0) call seperr("hess_io_hess: error writing hessian")
  end subroutine
  end module

