module hessian_mod_conv
! hessian matrix + adj ...mostly from yaxun
  use adj_mod
  use type_mod
  use sep

  implicit none
  type(hes_grid)    , save                                   :: hgrid 
  real              , dimension(:,:,:) ,allocatable, private :: hess
  character(len=256),                                private :: file_
  integer           ,                               external :: srite_window, sreed_window, getch
 
contains
!#######
  integer function conv_init(hgrid_in, file_in) result(stat)
    type(hes_grid)        :: hgrid_in
    character(len=256)    :: file_in
    stat = 1
    hgrid = hgrid_in
    file_ = file_in
    allocate(hess(hgrid%ax_offd%n,hgrid%ay_offd%n,hgrid%az_offd%n))
    hess = 0.
    stat = 0.
  end function
!#######
  integer function conv_clos() result(stat)
    deallocate(hess)
    stat = 0
  end function
!#######
  integer function conv_oper(adj, add, modl, data) result(stat)
    logical            :: adj, add
    real, dimension(:) :: modl, data
    stat = 1
    if (.not. add) then
       if (adj) then
          modl = 0.
       else
          data = 0.
       end if  
    end if  
    !call hess_convolve(adj, modl, data)
    call hess_convolve2(adj, modl, data)
    stat = 0
  end function
!#######
  subroutine hess_convolve(adj, modl, data)
    logical                :: adj
    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: modl
    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: data

    integer                :: ix_modl, iy_modl, iz_modl
    integer                :: ix_offd, iy_offd, iz_offd
    integer                :: index_x_offd, index_y_offd, index_z_offd
    integer                :: index_x_modl, index_y_modl, index_z_modl
    real                   :: x_offd, y_offd, z_offd
    real                   :: x_modl, y_modl, z_modl
    real                   :: minz,minx,miny 
        
    minz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    minx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    miny=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d

         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; index_z_modl = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
         write(*,*)iz_modl, ' of ',hgrid%az_modl%n
         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; index_y_modl = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; index_x_modl = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                call hess_io(hess, hgrid, ix_modl, iy_modl, iz_modl, file_, "reed")
                do  iz_offd= 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                        if (z_offd < hgrid%az_modl%o .or. z_offd > minz ) cycle
                        index_z_offd = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d; 
                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                        if (y_offd < hgrid%ay_modl%o .or. y_offd > miny ) cycle
                        index_y_offd = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                        if (x_offd < hgrid%ax_modl%o .or. x_offd > minx ) cycle
                        index_x_offd = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        if (adj) then
                                modl(index_x_offd,index_y_offd,index_z_offd) = modl(index_x_offd,index_y_offd,index_z_offd) &
                                                          + hess(ix_offd,iy_offd,iz_offd)*data(index_x_modl,index_y_modl,index_z_modl) 
                        else 
                                data(index_x_modl,index_y_modl,index_z_modl) = data(index_x_modl,index_y_modl,index_z_modl) & 
                                                          + hess(ix_offd,iy_offd,iz_offd)*modl(index_x_offd,index_y_offd,index_z_offd)
                        end if
                end do
                end do
                end do
        end do
        end do
        end do
    return
  end subroutine
!#####################################
  subroutine hess_convolve2(adj, modl, data)
    logical                :: adj
    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: modl
    real, dimension(hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n) :: data

    integer                :: ix_modl, iy_modl, iz_modl
    integer                :: ix_offd, iy_offd, iz_offd
    integer                :: index_x_offd, index_y_offd, index_z_offd
    integer                :: index_x_modl, index_y_modl, index_z_modl
    real                   :: x_offd, y_offd, z_offd
    real                   :: x_modl, y_modl, z_modl
    real                   :: minz,minx,miny 
        
    minz=hgrid%az_modl%o + (2*hgrid%az_modl%n-1)*hgrid%az_modl%d
    minx=hgrid%ax_modl%o + (2*hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    miny=hgrid%ay_modl%o + (2*hgrid%ay_modl%n-1)*hgrid%ay_modl%d

         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; index_z_modl = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
         write(*,*)iz_modl, ' of ',hgrid%az_modl%n
         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; index_y_modl = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; index_x_modl = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                call hess_io(hess, hgrid, ix_modl, iy_modl, iz_modl, file_, "reed")
                do  iz_offd = hgrid%az_offd%n+1,2*hgrid%az_offd%n-1; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                        if (z_offd < hgrid%az_modl%o .or. z_offd > minz ) cycle
                        index_z_offd = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d; 
                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                        if (y_offd < hgrid%ay_modl%o .or. y_offd > miny ) cycle
                        index_y_offd = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                        if (x_offd < hgrid%ax_modl%o .or. x_offd > minx ) cycle
                        index_x_offd = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        write(*,*)index_x_offd,index_z_offd,ix_offd,iz_offd
!                       write(*,*)index_x_modl,index_z_modl,ix_modl,iz_modl

!                        if (adj) then
!                                modl(index_x_offd,index_y_offd,index_z_offd) = modl(index_x_offd,index_y_offd,index_z_offd) &
!                                                          + hess(ix_offd,iy_offd,iz_offd)*data(index_x_modl,index_y_modl,index_z_modl) 
!                        else 
!                                data(index_x_modl,index_y_modl,index_z_modl) = data(index_x_modl,index_y_modl,index_z_modl) & 
!                                                          + hess(ix_offd,iy_offd,iz_offd)*modl(index_x_offd,index_y_offd,index_z_offd)
!                        end if
                end do
                end do
                end do
                STOP
        end do
        end do
        end do
    return
  end subroutine



!##################
  subroutine hess_io(hess, hgrid, ix_modl, iy_modl, iz_modl, file_, flag)
    real, dimension(:,:,:) :: hess
    type(hes_grid)         :: hgrid
    integer                :: ix_modl, iy_modl, iz_modl
    character(len=*)       :: file_
    character(len=4)       :: flag
    integer, dimension(10) :: n_cube, j_wind, n_wind, f_wind
    integer                :: n_dim_cube, err

    n_dim_cube = 10
    n_cube = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, &
               hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n/)
    j_wind = (/1               , 1               , 1              , 1              , 1              , & 
               1               , 1               , 1              , 1              , 1              /)
    n_wind = (/1               , 1               , hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, &
               1               , 1               , 1              , 1              , 1              /)
    f_wind = (/0               , 0               , 0              , 0              , 0              , &
               0               , 0               , ix_modl-1      , iy_modl-1      , iz_modl-1      /)

    if (flag == "rite") then
    !   err = srite_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    else if (flag == "reed") then
       hess = 0.
       err = sreed_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    end if
    return
  end subroutine

end module

