module hessian_mod_conv
! hessian matrix + adj ...mostly from yaxun
  use adj_mod
  use type_mod
  use sep
  use minresDataModule

  implicit none
  type(hes_grid)    , save                                         :: hgrid 
  real              , dimension(:,:,:)       ,allocatable, private :: hess
  real              , dimension(:,:,:,:,:,:) ,allocatable, private :: hess2
  character(len=256),                                      private :: file_
  integer           ,                                     external :: srite_window, sreed_window, getch
 
contains
!#######
  integer function conv_init(hgrid_in, file_in) result(stat)
    type(hes_grid)        :: hgrid_in
    character(len=256)    :: file_in

    stat = 1
    hgrid = hgrid_in
    file_ = file_in
!    n = hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n
    allocate(hess (hgrid%ax_offd%n,hgrid%ay_offd%n,hgrid%az_offd%n))
    allocate(hess2(hgrid%ax_offd%n,hgrid%ay_offd%n,hgrid%az_offd%n,hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n))
    hess = 0.
    stat = 0.
  end function
!#######
  integer function conv_clos() result(stat)
    deallocate(hess)
    stat = 0
  end function
!#######
  integer function conv_oper(adj, add, modl, data) result(stat)
    logical            :: adj, add
    real, dimension(:) :: modl, data
    stat = 1
    if (.not. add) then
       if (adj) then
          modl = 0.
       else
          data = 0.
       end if  
    end if  
    !call hess_convolve(adj, modl, data)
    call hess_convolve2(adj, modl, data)
!    write(*,*)size(modl), size(data)
    stat = 0
  end function
!#######
  subroutine hess_convolve(adj, modl, data)
    logical                :: adj
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: modl
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: data

    integer                :: ix_modl, iy_modl, iz_modl
    integer                :: ix_offd, iy_offd, iz_offd
    integer                :: index_x_offd, index_y_offd, index_z_offd
    integer                :: index_x_modl, index_y_modl, index_z_modl
    real                   :: x_offd, y_offd, z_offd
    real                   :: x_modl, y_modl, z_modl
    real                   :: minz,minx,miny 
        
    minz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    minx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    miny=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d

         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; index_z_modl = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
         write(*,*)iz_modl, ' of ',hgrid%az_modl%n
         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; index_y_modl = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; index_x_modl = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                call hess_io(hess, hgrid, ix_modl, iy_modl, iz_modl, file_, "reed")
                do  iz_offd= 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                        if (z_offd < hgrid%az_modl%o .or. z_offd > minz ) cycle
                        index_z_offd = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d; 
                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                        if (y_offd < hgrid%ay_modl%o .or. y_offd > miny ) cycle
                        index_y_offd = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                        if (x_offd < hgrid%ax_modl%o .or. x_offd > minx ) cycle
                        index_x_offd = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        if (adj) then
                                modl(index_z_offd,index_x_offd,index_y_offd) = modl(index_z_offd,index_x_offd,index_y_offd) &
                                                          + hess(ix_offd,iy_offd,iz_offd)*data(index_z_modl,index_x_modl,index_y_modl) 
                        else 
                                data(index_z_modl,index_x_modl,index_y_modl) = data(index_z_modl,index_x_modl,index_y_modl) & 
                                                          + hess(ix_offd,iy_offd,iz_offd)*modl(index_z_offd,index_x_offd,index_y_offd)
                        end if
                end do
                end do
                end do
        end do
        end do
        end do
    return
  end subroutine
!#####################################
  subroutine hess_convolve2(adj, modl, data)
    logical                :: adj
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: modl
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: data

    integer                :: ix_modl, iy_modl, iz_modl
    integer                :: ix_offd, iy_offd, iz_offd
    integer                :: jx_offd, jy_offd, jz_offd
    integer                :: index_x_offd, index_y_offd, index_z_offd
    integer                :: index_x_modl, index_y_modl, index_z_modl
    real                   :: x_offd, y_offd, z_offd
    real                   :: x_modl, y_modl, z_modl
    real                   :: maxz,maxx,maxy
    integer::i
        
    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d

!        call hess_io2(hess2, hgrid, file_, "reed")
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; index_z_modl = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; index_y_modl = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; index_x_modl = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                call hess_io(hess, hgrid, ix_modl, iy_modl, iz_modl, file_, "reed")
                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
                        index_z_offd = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
                        jz_offd = hgrid%az_offd%n + (z_modl-z_offd)/hgrid%az_modl%d;
                        jz_offd = hgrid%az_offd%n + index_z_modl - index_z_offd ;
                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
                        index_y_offd = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                         jy_offd = hgrid%ay_offd%n + (y_modl-y_offd)/hgrid%ay_modl%d;
                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > floor(hgrid%ax_offd%n/2.)) cycle
                        index_x_offd = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        jx_offd = nint(hgrid%ax_offd%n/2.) +(index_x_modl - index_x_offd) ;
                        if (adj) then
                                modl(index_z_offd,index_x_offd,index_y_offd) = modl(index_z_offd,index_x_offd,index_y_offd) &
                                                          + hess(ix_offd,iy_offd,iz_offd)*data(index_z_modl,index_x_modl,index_y_modl) 
                                modl(index_z_modl,index_x_modl,index_y_modl) = modl(index_z_modl,index_x_modl,index_y_modl) &
                                                          + hess(ix_offd,iy_offd,iz_offd)*data(index_z_offd,index_x_offd,index_y_offd) 
                        else 
                                data(index_z_modl,index_x_modl,index_y_modl) = data(index_z_modl,index_x_modl,index_y_modl) & 
                                                          + hess(ix_offd,iy_offd,iz_offd) *modl(index_z_offd,index_x_offd,index_y_offd)
                                data(index_z_offd,index_x_offd,index_y_offd) = data(index_z_offd,index_x_offd,index_y_offd) & 
                                                          + hess(ix_offd,iy_offd,iz_offd) *modl(index_z_modl,index_x_modl,index_y_modl)
                        end if
                end do
                end do
                end do
        end do
        end do
        end do


    return
  end subroutine


!#####################################
  subroutine hess_convolve3(n, modl_in, data_out)
    logical                :: adj
    real(dp), dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: modl
    real(dp), dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: data
    real(dp), intent(in)   :: modl_in(n)
    real(dp), intent(out)  :: data_out(n)
    integer,  intent(in)   :: n
    integer:: i,ii,j,k

    integer                :: ix_modl, iy_modl, iz_modl
    integer                :: ix_offd, iy_offd, iz_offd
    integer                :: jx_offd, jy_offd, jz_offd
    integer                :: index_x_offd, index_y_offd, index_z_offd
    integer                :: index_x_modl, index_y_modl, index_z_modl
    real                   :: x_offd, y_offd, z_offd
    real                   :: x_modl, y_modl, z_modl
    real                   :: maxz,maxx,maxy 

    ii=1
    do k=1, hgrid%ay_modl%n
        do j=1, hgrid%ax_modl%n
                do i=1, hgrid%az_modl%n
                        modl(i,j,k)= modl_in(ii); ii=ii+1
                enddo
        enddo
    enddo
!  do i=1, 25
!       write(*,*) modl(i,1,1)
!    enddo


!    write(*,*)size(modl,1), size(modl,2),size(modl_in)
!    write(*,*)size(data,1), size(data,2), size(data_out)
    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
ii=1
!        call hess_io2(hess2, hgrid, file_, "reed")
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; index_z_modl = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
!         write(*,*)iz_modl, ' of ',hgrid%az_modl%n
         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; index_y_modl = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
!         write(*,*)iy_modl, ' of ',hgrid%ay_modl%n 
         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; index_x_modl = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
        ! write(*,*)'-------------'
        ! write(*,*)ix_modl, ' of ',hgrid%ax_modl%n, '----ix_modl'
                call hess_io(hess, hgrid, ix_modl, iy_modl, iz_modl, file_, "reed")
                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
                        index_z_offd = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
                        jz_offd = hgrid%az_offd%n + (z_modl-z_offd)/hgrid%az_modl%d;
                        jz_offd = hgrid%az_offd%n + index_z_modl - index_z_offd ;
         !               write(*,*)iz_offd, ' of ',hgrid%az_offd%n,'----iz_offd'
                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
                        index_y_offd = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                         jy_offd = hgrid%ay_offd%n + (y_modl-y_offd)/hgrid%ay_modl%d;
                         !write(*,*)iy_offd, ' of ',hgrid%ay_offd%n
                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > ceiling(hgrid%ax_offd%n/2.)) cycle
                        index_x_offd = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        jx_offd = nint(hgrid%ax_offd%n/2.) +(index_x_modl - index_x_offd) ;
         !              write(*,*)ix_offd, ' of ',hgrid%ax_offd%n,'----ix_offd'

                                data(index_z_modl,index_x_modl,index_y_modl) = data(index_z_modl,index_x_modl,index_y_modl) & 
                                                          + hess(ix_offd,iy_offd,iz_offd) *modl(index_z_offd,index_x_offd,index_y_offd)
                                data(index_z_offd,index_x_offd,index_y_offd) = data(index_z_offd,index_x_offd,index_y_offd) & 
                                                          + hess(ix_offd,iy_offd,iz_offd) *modl(index_z_modl,index_x_modl,index_y_modl)
                                                          ii=ii+1
              !                                            write(*,*)'ii',ii
                end do
                end do
                end do
        end do
        end do
        end do
    
    
        ii=1
        do k=1, hgrid%ay_modl%n
                do j=1, hgrid%ax_modl%n
                        do i=1, hgrid%az_modl%n
                                data_out(ii)= data(i,j,k); ii=ii+1
                        enddo
                enddo
        enddo

    return
  end subroutine

!#####################################
  subroutine hess_precond(n, modl_in, data_out)
    logical                :: adj
    real(dp), dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: modl
    real(dp), dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: data
    real(dp), intent(in)   :: modl_in(n)
    real(dp), intent(out)  :: data_out(n)
    integer,  intent(in)   :: n
    integer:: i,j

    integer                :: ix_modl, iy_modl, iz_modl
    integer                :: ix_offd, iy_offd, iz_offd
    integer                :: jx_offd, jy_offd, jz_offd
    integer                :: index_x_offd, index_y_offd, index_z_offd
    integer                :: index_x_modl, index_y_modl, index_z_modl
    real                   :: x_offd, y_offd, z_offd
    real                   :: x_modl, y_modl, z_modl
    real                   :: maxz,maxx,maxy 
        
    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d

!        call hess_io2(hess2, hgrid, file_, "reed")
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; index_z_modl = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
!         write(*,*)iz_modl, ' of ',hgrid%az_modl%n
         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; index_y_modl = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; index_x_modl = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                call hess_io(hess, hgrid, ix_modl, iy_modl, iz_modl, file_, "reed")
                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
                        index_z_offd = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
                        jz_offd = hgrid%az_offd%n + (z_modl-z_offd)/hgrid%az_modl%d;
                        jz_offd = hgrid%az_offd%n + index_z_modl - index_z_offd ;
                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
                        index_y_offd = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                         jy_offd = hgrid%ay_offd%n + (y_modl-y_offd)/hgrid%ay_modl%d;
                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > floor(hgrid%az_offd%n/2.)) cycle
                        index_x_offd = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        jx_offd = nint(hgrid%ax_offd%n/2.) +(index_x_modl - index_x_offd) ;
                                modl(index_z_offd,index_x_offd,index_y_offd) = modl(index_z_offd,index_x_offd,index_y_offd) &
                                                          + hess(ix_offd,iy_offd,iz_offd)*data(index_z_modl,index_x_modl,index_y_modl) 
                                modl(index_z_modl,index_x_modl,index_y_modl) = modl(index_z_modl,index_x_modl,index_y_modl) &
                                                          + hess(ix_offd,iy_offd,iz_offd)*data(index_z_offd,index_x_offd,index_y_offd) 
                end do
                end do
                end do
        end do
        end do
        end do
    return
  end subroutine






!##################
  subroutine hess_io(hess, hgrid, ix_modl, iy_modl, iz_modl, file_, flag)
    real, dimension(:,:,:) :: hess
    type(hes_grid)         :: hgrid
    integer                :: ix_modl, iy_modl, iz_modl
    character(len=*)       :: file_
    character(len=4)       :: flag
    integer, dimension(10) :: n_cube, j_wind, n_wind, f_wind
    integer                :: n_dim_cube, err

    n_dim_cube = 10
    n_cube = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, &
               hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n/)
    j_wind = (/1               , 1               , 1              , 1              , 1              , & 
               1               , 1               , 1              , 1              , 1              /)
    n_wind = (/1               , 1               , hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, &
               1               , 1               , 1              , 1              , 1              /)
    f_wind = (/0               , 0               , 0              , 0              , 0              , &
               0               , 0               , ix_modl-1      , iy_modl-1      , iz_modl-1      /)
    if (flag == "rite") then
    !   err = srite_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    else if (flag == "reed") then
       hess = 0.
       err = sreed_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    end if
    return
  end subroutine
!###################  
  subroutine hess_io2(hess, hgrid, file_, flag)
    real, dimension(:,:,:,:,:,:) :: hess
    type(hes_grid)         :: hgrid
    integer                :: ix_modl, iy_modl, iz_modl
    character(len=*)       :: file_
    character(len=4)       :: flag
    integer, dimension(10) :: n_cube, j_wind, n_wind, f_wind
    integer                :: n_dim_cube, err

    n_dim_cube = 10
    n_cube = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, &
               hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n/)
    j_wind = (/1               , 1               , 1              , 1              , 1              , & 
               1               , 1               , 1              , 1              , 1              /)
    n_wind = (/1               , 1               , hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, &
               1               , 1               , hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n/)
    f_wind = (/0               , 0               , 0              , 0              , 0              , &
               0               , 0               , 0              , 0              , 0              /)

    if (flag == "rite") then
    !   err = srite_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    else if (flag == "reed") then
       hess = 0.
       err = sreed_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    end if
    return
  end subroutine


end module

