module hessian_mod_conv_joint_good
  use adj_mod
  use type_mod
!  use igrad1
!  use igrad2
  use sep
  use minresDataModule

  implicit none
  integer           , save                               , private :: index_zmin
  real              , save                               , private :: zmin
  type(hes_grid)    , save                                         :: hgrid 
  real              , dimension(:,:,:)       ,allocatable, private :: hess1
  real              , dimension(:,:,:)       ,allocatable, private :: hess2
  real              , dimension(:,:,:)       ,allocatable, private :: hess3
  real              , dimension(:,:,:)       ,allocatable, private :: hess4
  real              , dimension(:,:,:)       ,allocatable, private :: weight1
  real              , dimension(:,:,:)       ,allocatable, private :: weight2
  character(len=256),                                      private :: file1_
  character(len=256),                                      private :: file2_
  character(len=256),                                      private :: weight1_
  character(len=256),                                      private :: weight2_
  integer           ,                                     external :: srite_window, sreed_window, getch
  logical           , save                                         :: ones

contains
!#######
  integer function conv_init(hgrid_in, file1_in, file2_in, ones_in, zmin_in) result(stat)
    optional:: zmin_in
    type(hes_grid)        :: hgrid_in
    character(len=256)    :: file1_in
    character(len=256)    :: file2_in
    logical               :: ones_in
    real                  :: zmin_in

    stat = 1
    hgrid = hgrid_in
    file1_ = file1_in
    file2_ = file2_in
    ones = ones_in
    if(present(zmin_in))then 
        zmin=zmin_in
    else
        zmin=hgrid%az_modl%o
    endif
write(0,*)ones
!    n = hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n
    allocate(hess1 (hgrid%ax_offd%n,hgrid%ay_offd%n,hgrid%az_offd%n))
    allocate(hess2 (hgrid%ax_offd%n,hgrid%ay_offd%n,hgrid%az_offd%n))
    allocate(hess3 (hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n))
    allocate(hess4 (hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n))
    hess1 = 0.
    hess2= 0.
    stat = 0.
  end function
!  ##########################
  integer function conv2_init(hgrid_in, file1_in, file2_in, weight1_in, weight2_in, ones_in, zmin_in) result(stat)
    optional:: zmin_in
    type(hes_grid)        :: hgrid_in
    character(len=256)    :: file1_in
    character(len=256)    :: file2_in
    character(len=256)    :: weight1_in
    character(len=256)    :: weight2_in
    logical               :: ones_in
    real                  :: zmin_in

    stat = 1
    hgrid = hgrid_in
    file1_ = file1_in
    file2_ = file2_in
    weight1_ = weight1_in
    weight2_ = weight2_in
    ones = ones_in
    if(present(zmin_in))then 
        zmin=zmin_in
    else
        zmin=hgrid%az_modl%o
    endif
    allocate(hess1 (hgrid%ax_offd%n,hgrid%ay_offd%n,hgrid%az_offd%n))
    allocate(hess2 (hgrid%ax_offd%n,hgrid%ay_offd%n,hgrid%az_offd%n))
    allocate(hess3 (hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n))
    allocate(hess4 (hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n))
    allocate(weight1(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n))
    allocate(weight2(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n))
    hess1 = 0.
    hess2= 0.
    stat = 0.
  end function
!#######
  integer function conv_clos() result(stat)
  if(allocated(hess1))deallocate(hess1)
  if(allocated(hess2))deallocate(hess2)
!  if(allocated(hess3))deallocate(hess3)
!  if(allocated(hess4))deallocate(hess4)
    stat = 0
  end function
!#######
  integer function conv_oper(adj, add, modl, data) result(stat)
    logical            :: adj, add
    real, dimension(:):: modl, data
    real, dimension(:),allocatable :: modl1, data1
    real, dimension(:),allocatable :: modl2, data2
    allocate(modl1(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n)); allocate(modl2(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
    allocate(data1(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n)); allocate(data2(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
    stat = 1
    if (.not. add) then
       if (adj) then; modl1 = 0.; modl2=0; data1=data(1:size(data1)); data2=data(size(data1)+1:size(data))
       else         ; data1 = 0.; data2=0; modl1=modl(1:size(modl1)); modl2=modl(size(modl1)+1:size(modl))
       end if
    else
    end if  
    call hess_convolve(adj, modl1, modl2, data1, data2)
    if (adj)then;  modl(1:size(modl1))=modl1; modl(size(modl1)+1:size(modl))=modl2;
    else        ;  data(1:size(data1))=data1; data(size(data1)+1:size(data))=data2;
    endif    
    stat = 0
  end function
!#######
  integer function conv_precon_oper(adj, add, modl, data) result(stat)
    logical            :: adj, add
    real, dimension(:) :: modl, data
    real, dimension(:),allocatable :: modl1, data1
    real, dimension(:),allocatable :: modl2, data2
    allocate(modl1(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n)); allocate(modl2(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
    allocate(data1(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n)); allocate(data2(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
    stat = 1
    if (.not. add) then
       if (adj) then;   modl1 = 0.; modl2=0; data1=data(1:size(data1)); data2=data(size(data1)+1:size(data))
       else         ;   data1 = 0.; data2=0; modl1=modl(1:size(modl1)); modl2=modl(size(modl1)+1:size(modl))
       end if
    else
    end if  
    call hess_precon_diag2(adj, modl1, modl2, data1, data2)
    if (adj)then;  modl(1:size(modl1))=modl1; modl(size(modl1)+1:size(modl))=modl2;
    else        ;  data(1:size(data1))=data1; data(size(data1)+1:size(data))=data2;
    endif    
    stat = 0
  end function
!#######
  integer function conv_mask_oper(adj, add, modl, data) result(stat)
    logical            :: adj, add
    real, dimension(:) :: modl, data
    real, dimension(:),allocatable :: modl1, data1
    real, dimension(:),allocatable :: modl2, data2
    allocate(modl1(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n)); allocate(modl2(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
    allocate(data1(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n)); allocate(data2(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
    stat = 1
    if (.not. add) then
       if (adj) then;   modl1 = 0.; modl2=0; data1=data(1:size(data1)); data2=data(size(data1)+1:size(data))
       else         ;   data1 = 0.; data2=0; modl1=modl(1:size(modl1)); modl2=modl(size(modl1)+1:size(modl))
       end if
    else
    end if  
    call hess_mask(adj, modl1, modl2, data1, data2)
    if (adj)then;  modl(1:size(modl1))=modl1; modl(size(modl1)+1:size(modl))=modl2;
    else        ;  data(1:size(data1))=data1; data(size(data1)+1:size(data))=data2;
    endif    
    stat = 0
  end function
!#######
  integer function conv_weight_oper(adj, add, modl, data) result(stat)
    logical            :: adj, add
    real, dimension(:) :: modl, data
    real, dimension(:),allocatable :: modl1, data1
    real, dimension(:),allocatable :: modl2, data2
    allocate(modl1(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n)); allocate(modl2(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
    allocate(data1(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n)); allocate(data2(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
    stat = 1
    if (.not. add) then
       if (adj) then;   modl1 = 0.; modl2=0; data1=data(1:size(data1)); data2=data(size(data1)+1:size(data))
       else         ;   data1 = 0.; data2=0; modl1=modl(1:size(modl1)); modl2=modl(size(modl1)+1:size(modl))
       end if
    else
    end if  
    call hess_weight(adj, modl1, modl2, data1, data2)
    if (adj)then;  modl(1:size(modl1))=modl1; modl(size(modl1)+1:size(modl))=modl2;
    else        ;  data(1:size(data1))=data1; data(size(data1)+1:size(data))=data2;
    endif   
    stat = 0
  end function
!#######
  integer function conv_grad_oper(adj, add, modl, data) result(stat)
    logical            :: adj, add
    real, dimension(:) :: modl, data
    real, dimension(:),allocatable :: modl1, data1
    real, dimension(:),allocatable :: modl2, data2
    allocate(modl1(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n)); allocate(modl2(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
    allocate(data1(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n)); allocate(data2(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
    stat = 1
    if (.not. add) then
       if (adj) then;   modl1 = 0.; modl2=0; data1=data(1:size(data1)); data2=data(size(data1)+1:size(data))
       else         ;   data1 = 0.; data2=0; modl1=modl(1:size(modl1)); modl2=modl(size(modl1)+1:size(modl))
       end if
    else
    end if  
    call hess_grad1(adj, modl1, modl2, data1, data2)
    if (adj)then;  modl(1:size(modl1))=modl1; modl(size(modl1)+1:size(modl))=modl2;
    else        ;  data(1:size(data1))=data1; data(size(data1)+1:size(data))=data2;
    endif    
    stat = 0
  end function
!#######
  integer function conv_grad_oper2(adj, add, modl, data) result(stat)
    logical            :: adj, add
    real, dimension(:) :: modl, data
    real, dimension(:),allocatable :: modl1, data1
    real, dimension(:),allocatable :: modl2, data2
    allocate(modl1(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n)); allocate(modl2(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
    allocate(data1(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n)); allocate(data2(hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
    stat = 1
    if (.not. add) then
       if (adj) then;   modl1 = 0.; modl2=0; data1=data(1:size(data1)); data2=data(size(data1)+1:size(data))
       else         ;   data1 = 0.; data2=0; modl1=modl(1:size(modl1)); modl2=modl(size(modl1)+1:size(modl))
       end if
    else
    end if  
    call hess_grad_base(adj, modl1, data1)
    call   hess_grad_4d(adj, modl2, data2)
    if (adj)then;  modl(1:size(modl1))=modl1; modl(size(modl1)+1:size(modl))=modl2;
    else        ;  data(1:size(data1))=data1; data(size(data1)+1:size(data))=data2;
    endif    
    stat = 0
  end function
!#####################################
  subroutine hess_convolve(adj, modl1, modl2, data1, data2)
    logical                :: adj
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: modl1
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: data1
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: modl2
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: data2

    integer                :: ix_modl, iy_modl, iz_modl
    integer                :: ix_offd, iy_offd, iz_offd
    integer                :: jx_offd, jy_offd, jz_offd
    integer                :: index_x_offd, index_y_offd, index_z_offd
    integer                :: index_x_modl, index_y_modl, index_z_modl
    real                   :: x_offd, y_offd, z_offd
    real                   :: x_modl, y_modl, z_modl
    real                   :: maxz,maxx,maxy
    integer::i,j,k,ii
        
    maxz=hgrid%az_modl%o + (hgrid%az_modl%n-1)*hgrid%az_modl%d
    maxx=hgrid%ax_modl%o + (hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    maxy=hgrid%ay_modl%o + (hgrid%ay_modl%n-1)*hgrid%ay_modl%d
         do iz_modl= 1,hgrid%az_modl%n ;  z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; index_z_modl = 1.5 + (z_modl - hgrid%az_modl%o)/hgrid%az_modl%d;
         do iy_modl= 1,hgrid%ay_modl%n ;  y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; index_y_modl = 1.5 + (y_modl - hgrid%ay_modl%o)/hgrid%ay_modl%d;
         do ix_modl= 1,hgrid%ax_modl%n ;  x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; index_x_modl = 1.5 + (x_modl - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                call hess_io(hess1, hgrid, ix_modl, iy_modl, iz_modl, file1_, "reed")
                call hess_io(hess2, hgrid, ix_modl, iy_modl, iz_modl, file2_, "reed")
                do  iz_offd = 1,hgrid%az_offd%n; z_offd = z_modl + hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; 
                        if (z_offd < hgrid%az_modl%o .or. z_offd > maxz ) cycle
                        index_z_offd = 1.5 + (z_offd - hgrid%az_modl%o)/hgrid%az_modl%d;
                do  iy_offd= 1,hgrid%ay_offd%n; y_offd = y_modl + hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d;
                        if (y_offd < hgrid%ay_modl%o .or. y_offd > maxy ) cycle
                        index_y_offd = 1.5 + (y_offd - hgrid%ay_modl%o)/hgrid%ay_modl%d;
                do  ix_offd= 1,hgrid%ax_offd%n; x_offd = x_modl + hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d;
                        if (x_offd < hgrid%ax_modl%o .or. x_offd > maxx ) cycle
                        if (iz_offd == hgrid%az_offd%n .and. ix_offd > ceiling(hgrid%ax_offd%n/2.)) cycle
                        index_x_offd = 1.5 + (x_offd - hgrid%ax_modl%o)/hgrid%ax_modl%d;
                        if (adj) then
                                modl1(index_z_offd,index_x_offd,index_y_offd) = modl1(index_z_offd,index_x_offd,index_y_offd) &
              + (hess1(ix_offd,iy_offd,iz_offd)+hess2(ix_offd,iy_offd,iz_offd))*data1(index_z_modl,index_x_modl,index_y_modl) &
              + (hess1(ix_offd,iy_offd,iz_offd)                               )*data2(index_z_modl,index_x_modl,index_y_modl) 
                                modl1(index_z_modl,index_x_modl,index_y_modl) = modl1(index_z_modl,index_x_modl,index_y_modl) &
              + (hess1(ix_offd,iy_offd,iz_offd)+hess2(ix_offd,iy_offd,iz_offd))*data1(index_z_offd,index_x_offd,index_y_offd) &
              + (hess1(ix_offd,iy_offd,iz_offd)                               )*data2(index_z_offd,index_x_offd,index_y_offd) 
                                modl2(index_z_offd,index_x_offd,index_y_offd) = modl2(index_z_offd,index_x_offd,index_y_offd) &
              + (hess1(ix_offd,iy_offd,iz_offd)                               )*data1(index_z_modl,index_x_modl,index_y_modl) &
              + (hess1(ix_offd,iy_offd,iz_offd)                               )*data2(index_z_modl,index_x_modl,index_y_modl) 
                                modl2(index_z_modl,index_x_modl,index_y_modl) = modl2(index_z_modl,index_x_modl,index_y_modl) &
              + (hess1(ix_offd,iy_offd,iz_offd)                               )*data1(index_z_offd,index_x_offd,index_y_offd) & 
              + (hess1(ix_offd,iy_offd,iz_offd)                               )*data2(index_z_offd,index_x_offd,index_y_offd) 
                        else 
                                data1(index_z_modl,index_x_modl,index_y_modl) = data1(index_z_modl,index_x_modl,index_y_modl) & 
              + (hess1(ix_offd,iy_offd,iz_offd)+hess2(ix_offd,iy_offd,iz_offd))*modl1(index_z_offd,index_x_offd,index_y_offd) &
              + (hess1(ix_offd,iy_offd,iz_offd)                               )*modl2(index_z_offd,index_x_offd,index_y_offd) 
                                data1(index_z_offd,index_x_offd,index_y_offd) = data1(index_z_offd,index_x_offd,index_y_offd) & 
              + (hess1(ix_offd,iy_offd,iz_offd)+hess2(ix_offd,iy_offd,iz_offd))*modl1(index_z_modl,index_x_modl,index_y_modl) &
              + (hess1(ix_offd,iy_offd,iz_offd)                               )*modl2(index_z_modl,index_x_modl,index_y_modl)
                                data2(index_z_modl,index_x_modl,index_y_modl) = data2(index_z_modl,index_x_modl,index_y_modl) & 
              + (hess1(ix_offd,iy_offd,iz_offd)                               )*modl1(index_z_offd,index_x_offd,index_y_offd) &
              + (hess1(ix_offd,iy_offd,iz_offd)                               )*modl2(index_z_offd,index_x_offd,index_y_offd)
                                data2(index_z_offd,index_x_offd,index_y_offd) = data2(index_z_offd,index_x_offd,index_y_offd) & 
              + (hess1(ix_offd,iy_offd,iz_offd)                               )*modl1(index_z_modl,index_x_modl,index_y_modl) &
              + (hess1(ix_offd,iy_offd,iz_offd)                               )*modl2(index_z_modl,index_x_modl,index_y_modl)

                        end if
                end do
                end do
                end do
        end do
        end do
        end do
    ii=1
       ! data2(hgrid%az_modl%n*2/3:hgrid%az_modl%n,:,:)=0

    return
  end subroutine
!#####################################
  subroutine hess_precon_diag(adj, modl1, modl2, data1, data2)
    logical                :: adj
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: modl1
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: data1
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: modl2
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: data2

    integer                :: ix_modl, iy_modl, iz_modl
    integer                :: ix_offd, iy_offd, iz_offd
    integer                :: jx_offd, jy_offd, jz_offd
    integer                :: index_x_offd, index_y_offd, index_z_offd
    integer                :: index_x_modl, index_y_modl, index_z_modl
    real                   :: x_offd, y_offd, z_offd
    real                   :: x_modl, y_modl, z_modl
    real                   :: maxz,maxx,maxy
    integer::i,j,k,ii
        
    call hess_io_diag(hess3, hgrid, file1_, "reed")
    call hess_io_diag(hess4, hgrid, file2_, "reed")

         do iz_modl= 1,hgrid%az_modl%n ;  
         do iy_modl= 1,hgrid%ay_modl%n ;  
         do ix_modl= 1,hgrid%ax_modl%n ;  
                        if (adj) then
                                modl1(iz_modl,ix_modl,iy_modl) = modl1(iz_modl,ix_modl,iy_modl) &
                                      + (hess1(ix_modl,iy_modl,iz_modl)+hess2(ix_modl,iy_modl,iz_modl))*data1(iz_modl,ix_modl,iy_modl) &
                                      + (hess1(ix_modl,iy_modl,iz_modl)                               )*data2(iz_modl,ix_modl,iy_modl) 
                                                modl2(iz_modl,ix_modl,iy_modl) = modl2(iz_modl,ix_modl,iy_modl) &
                                      + (hess1(ix_modl,iy_modl,iz_modl)                               )*data1(iz_modl,ix_modl,iy_modl) &
                                      + (hess1(ix_modl,iy_modl,iz_modl)                               )*data2(iz_modl,ix_modl,iy_modl) 
                        else 
                                data1(iz_modl,ix_modl,iy_modl) = data1(iz_modl,ix_modl,iy_modl)  & 
                                      + (hess1(ix_modl,iy_modl,iz_modl)+hess2(ix_modl,iy_modl,iz_modl))*modl1(iz_modl,ix_modl,iy_modl) &
                                      + (hess1(ix_modl,iy_modl,iz_modl)                               )*modl2(iz_modl,ix_modl,iy_modl) 
                                data2(index_z_modl,index_x_modl,index_y_modl) = data2(iz_modl,ix_modl,iy_modl) & 
                                      + (hess1(ix_modl,iy_modl,iz_modl)                               )*modl1(iz_modl,ix_modl,iy_modl) &
                                      + (hess1(ix_modl,iy_modl,iz_modl)                               )*modl2(iz_modl,ix_modl,iy_modl)
                        end if
        end do
        end do
        end do
    return
  end subroutine
!#####################################
  subroutine hess_precon_diag2(adj, modl1, modl2, data1, data2)
    logical                :: adj
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: modl1
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: data1
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: modl2
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: data2

    integer                :: ix_modl, iy_modl, iz_modl
write(0,*)ones
    if (ones)then
        if (adj)then
            modl1=data1
            modl2=data2
        else
            data1=modl1
            data2=modl2
        endif
    else

         call hess_io_diag(hess3, hgrid, file1_, "reed")
         call hess_io_diag(hess4, hgrid, file2_, "reed")

         do iz_modl= 1,hgrid%az_modl%n ;  
         do iy_modl= 1,hgrid%ay_modl%n ;  
         do ix_modl= 1,hgrid%ax_modl%n ;  
         if (adj) then
               modl1(iz_modl,ix_modl,iy_modl) = modl1(iz_modl,ix_modl,iy_modl) + 1/(hess3(ix_modl,iy_modl,iz_modl)+hess4(ix_modl,iy_modl,iz_modl))*data1(iz_modl,ix_modl,iy_modl) 
               modl2(iz_modl,ix_modl,iy_modl) = modl2(iz_modl,ix_modl,iy_modl) + 1/(hess3(ix_modl,iy_modl,iz_modl)                               )*data2(iz_modl,ix_modl,iy_modl) 
         else 
               data1(iz_modl,ix_modl,iy_modl) = data1(iz_modl,ix_modl,iy_modl) + 1/(hess3(ix_modl,iy_modl,iz_modl)+hess4(ix_modl,iy_modl,iz_modl))*modl1(iz_modl,ix_modl,iy_modl) 
               data2(iz_modl,ix_modl,iy_modl) = data2(iz_modl,ix_modl,iy_modl) + 1/(hess3(ix_modl,iy_modl,iz_modl)                               )*modl2(iz_modl,ix_modl,iy_modl)
         end if
         end do
         end do
         end do
    endif
    return
  end subroutine


!#####################################
  subroutine hess_weight(adj, modl1, modl2, data1, data2)
    logical                :: adj
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: modl1
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: data1
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: modl2
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: data2

    integer                :: ix_modl, iy_modl, iz_modl

    !call weight_io(weight1, hgrid, weight1_, "reed")
    !call weight_io(weight2, hgrid, weight2_, "reed")
    call sreed("wg1", weight1  , 4*hgrid%az_modl%n*hgrid%ax_modl%n*hgrid%ay_modl%n)
    call sreed("wg2", weight2  , 4*hgrid%az_modl%n*hgrid%ax_modl%n*hgrid%ay_modl%n)
        do iz_modl= 1,hgrid%az_modl%n ;  
        do iy_modl= 1,hgrid%ay_modl%n ; 
        do ix_modl= 1,hgrid%ax_modl%n ;  
                        if (adj) then
                                modl1(iz_modl,ix_modl,iy_modl) = modl1(iz_modl,ix_modl,iy_modl) + (weight1(iz_modl,ix_modl,iy_modl) )*data1(iz_modl,ix_modl,iy_modl) 
                                modl2(iz_modl,ix_modl,iy_modl) = modl2(iz_modl,ix_modl,iy_modl) + (weight2(iz_modl,ix_modl,iy_modl) )*data2(iz_modl,ix_modl,iy_modl) 
                        else 
                                data1(iz_modl,ix_modl,iy_modl) = data1(iz_modl,ix_modl,iy_modl) + (weight1(iz_modl,ix_modl,iy_modl) )*modl1(iz_modl,ix_modl,iy_modl) 
                                data2(iz_modl,ix_modl,iy_modl) = data2(iz_modl,ix_modl,iy_modl) + (weight2(iz_modl,ix_modl,iy_modl) )*modl2(iz_modl,ix_modl,iy_modl)
                        end if
        end do
        end do
        end do
    return
  end subroutine
!#####################################
  subroutine hess_mask(adj, modl1, modl2, data1, data2)
    optional:: modl1, modl2, data1, data2
    logical                :: adj
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: modl1
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: data1
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: modl2
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: data2

    integer                :: ix_modl, iy_modl, iz_modl

    if(present(modl1).and.present(data1))then
        call sreed("mask1", weight1  , 4*hgrid%az_modl%n*hgrid%ax_modl%n*hgrid%ay_modl%n)
        do iz_modl= 1,hgrid%az_modl%n ; !write(*,*)weight2(iz_modl,1,1) 
        do iy_modl= 1,hgrid%ay_modl%n ; 
        do ix_modl= 1,hgrid%ax_modl%n ;  
                        if (adj) then
                                modl1(iz_modl,ix_modl,iy_modl) = modl1(iz_modl,ix_modl,iy_modl) + (weight1(iz_modl,ix_modl,iy_modl))*data1(iz_modl,ix_modl,iy_modl) 
                        else 
                                data1(iz_modl,ix_modl,iy_modl) = data1(iz_modl,ix_modl,iy_modl) + (weight1(iz_modl,ix_modl,iy_modl))*modl1(iz_modl,ix_modl,iy_modl) 
                        end if
        end do
        end do
        end do
    elseif(present(modl1).and.present(data1))then
        call seperr('hess_mask: Need to specify both modl1 and data1 or none!!!')
    endif
    if(present(modl2).and.present(data2))then
        call sreed("mask2", weight2  , 4*hgrid%az_modl%n*hgrid%ax_modl%n*hgrid%ay_modl%n)
        do iz_modl= 1,hgrid%az_modl%n ; !write(*,*)weight2(iz_modl,1,1) 
        do iy_modl= 1,hgrid%ay_modl%n ; 
        do ix_modl= 1,hgrid%ax_modl%n ;  
                        if (adj) then
                                modl2(iz_modl,ix_modl,iy_modl) = modl2(iz_modl,ix_modl,iy_modl) + (weight2(iz_modl,ix_modl,iy_modl))*data2(iz_modl,ix_modl,iy_modl) 
                        else 
                                data2(iz_modl,ix_modl,iy_modl) = data2(iz_modl,ix_modl,iy_modl) + (weight2(iz_modl,ix_modl,iy_modl))*modl2(iz_modl,ix_modl,iy_modl)
                        end if
        end do
        end do
        end do
    elseif(present(modl2).and.present(data2))then
        call seperr('hess_mask: Need to specify both modl2 and data2 or none!!!')
    endif

    return
  end subroutine
!#####################################
  subroutine hess_grad1(adj, modl1, modl2, data1, data2)
    logical                :: adj
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: modl1
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: data1
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: modl2
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: data2

    integer                :: ix_modl, iy_modl, iz_modl

do ix_modl= 1,hgrid%ax_modl%n-1;  
do iy_modl= 1,hgrid%ay_modl%n ;  
do iz_modl= 1,hgrid%az_modl%n ;  
        if (adj) then
                modl1(iz_modl,ix_modl+1,iy_modl)=modl1(iz_modl,ix_modl+1,iy_modl)+data1(iz_modl,ix_modl ,iy_modl) 
                modl1(iz_modl,ix_modl  ,iy_modl)=modl1(iz_modl,ix_modl  ,iy_modl)-data1(iz_modl,ix_modl ,iy_modl) 
                modl2(iz_modl,ix_modl+1,iy_modl)=modl2(iz_modl,ix_modl+1,iy_modl)+data2(iz_modl,ix_modl ,iy_modl) 
                modl2(iz_modl,ix_modl  ,iy_modl)=modl2(iz_modl,ix_modl  ,iy_modl)-data2(iz_modl,ix_modl ,iy_modl) 
        else 
                data1(iz_modl,ix_modl  ,iy_modl)=data1(iz_modl,ix_modl  ,iy_modl)+modl1(iz_modl,ix_modl+1,iy_modl)-& 
                                                                                  modl1(iz_modl,ix_modl  ,iy_modl) 
                data2(iz_modl,ix_modl  ,iy_modl)=data2(iz_modl,ix_modl  ,iy_modl)+modl2(iz_modl,ix_modl+1,iy_modl)-& 
                                                                                  modl2(iz_modl,ix_modl  ,iy_modl) 
        end if
end do
end do
end do
    return
  end subroutine

!#####################################
  subroutine hess_grad_4d(adj, modl, data)
    logical                :: adj
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: modl
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: data
    integer                :: ix_modl, iy_modl, iz_modl

do ix_modl= 1,hgrid%ax_modl%n-1;  
do iy_modl= 1,hgrid%ay_modl%n ;  
do iz_modl= 1,hgrid%az_modl%n ;  
        if (adj) then
                modl(iz_modl,ix_modl+1,iy_modl)=modl(iz_modl,ix_modl+1,iy_modl)+data(iz_modl,ix_modl ,iy_modl) 
                modl(iz_modl,ix_modl  ,iy_modl)=modl(iz_modl,ix_modl  ,iy_modl)-data(iz_modl,ix_modl ,iy_modl) 
        else 
                data(iz_modl,ix_modl  ,iy_modl)=data(iz_modl,ix_modl  ,iy_modl)+modl(iz_modl,ix_modl+1,iy_modl)-& 
                                                                                modl(iz_modl,ix_modl  ,iy_modl) 
        end if
end do
end do
end do
    return
  end subroutine
!#####################################
  subroutine hess_grad_base(adj, modl, data)
    logical                :: adj
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: modl
    real, dimension(hgrid%az_modl%n,hgrid%ax_modl%n,hgrid%ay_modl%n) :: data
    integer                :: ix_modl, iy_modl, iz_modl

    index_zmin=1.5+(zmin-hgrid%az_modl%o)/hgrid%az_modl%d
    write(0,*)index_zmin
do ix_modl= 1,hgrid%ax_modl%n-1;  
do iy_modl= 1,hgrid%ay_modl%n ;  
do iz_modl= index_zmin,hgrid%az_modl%n ;  
        if (adj) then
                modl(iz_modl,ix_modl+1,iy_modl)=modl(iz_modl,ix_modl+1,iy_modl)+data(iz_modl,ix_modl ,iy_modl) 
                modl(iz_modl,ix_modl  ,iy_modl)=modl(iz_modl,ix_modl  ,iy_modl)-data(iz_modl,ix_modl ,iy_modl) 
        else 
                data(iz_modl,ix_modl  ,iy_modl)=data(iz_modl,ix_modl  ,iy_modl)+modl(iz_modl,ix_modl+1,iy_modl)-& 
                                                                                modl(iz_modl,ix_modl  ,iy_modl) 
        end if
end do
end do
end do
if (index_zmin /=1)then
        if(adj)then
                modl(1:index_zmin-1,:,:)=data(1:index_zmin-1,:,:)
        else
                data(1:index_zmin-1,:,:)=modl(1:index_zmin-1,:,:) 
        endif
endif
return
  end subroutine

!##################
  subroutine hess_io(hess, hgrid, ix_modl, iy_modl, iz_modl, file_, flag)
    real, dimension(:,:,:) :: hess
    type(hes_grid)         :: hgrid
    integer                :: ix_modl, iy_modl, iz_modl
    character(len=*)       :: file_
    character(len=4)       :: flag
    integer, dimension(10) :: n_cube, j_wind, n_wind, f_wind
    integer                :: n_dim_cube, err

    n_dim_cube = 10
    n_cube = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, &
               hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n/)
    j_wind = (/1               , 1               , 1              , 1              , 1              , & 
               1               , 1               , 1              , 1              , 1              /)
    n_wind = (/1               , 1               , hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, &
               1               , 1               , 1              , 1              , 1              /)
    f_wind = (/0               , 0               , 0              , 0              , 0              , &
               0               , 0               , ix_modl-1      , iy_modl-1      , iz_modl-1      /)
    if (flag == "rite") then
    !   err = srite_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    else if (flag == "reed") then
       hess = 0.
       err = sreed_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    end if
    return
  end subroutine
!###################  
  subroutine hess_io2(hess, hgrid, file_, flag)
    real, dimension(:,:,:,:,:,:) :: hess
    type(hes_grid)         :: hgrid
    integer                :: ix_modl, iy_modl, iz_modl
    character(len=*)       :: file_
    character(len=4)       :: flag
    integer, dimension(10) :: n_cube, j_wind, n_wind, f_wind
    integer                :: n_dim_cube, err

    n_dim_cube = 10
    n_cube = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, &
               hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n/)
    j_wind = (/1               , 1               , 1              , 1              , 1              , & 
               1               , 1               , 1              , 1              , 1              /)
    n_wind = (/1               , 1               , hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, &
               1               , 1               , hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n/)
    f_wind = (/0               , 0               , 0              , 0              , 0              , &
               0               , 0               , 0              , 0              , 0              /)

    if (flag == "rite") then
    !   err = srite_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    else if (flag == "reed") then
       hess = 0.
       err = sreed_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    end if
    return
  end subroutine
!###################  
  subroutine hess_io_diag(hess, hgrid, file_, flag)
    real, dimension(:,:,:) :: hess
    type(hes_grid)         :: hgrid
    integer                :: ix_modl, iy_modl, iz_modl
    character(len=*)       :: file_
    character(len=4)       :: flag
    integer, dimension(10) :: n_cube, j_wind, n_wind, f_wind
    integer                :: n_dim_cube, err

    n_dim_cube = 10
    n_cube = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n  , hgrid%ay_offd%n  , hgrid%az_offd%n  , &
               hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n  , hgrid%ay_modl%n  , hgrid%az_modl%n  /)
    j_wind = (/1               , 1               , 1                , 1                , 1                , & 
               1               , 1               , 1                , 1                , 1                /)
    n_wind = (/1               , 1               , 1                , 1                , 1                , &
               1               , 1               , hgrid%ax_modl%n  , hgrid%ay_modl%n  , hgrid%az_modl%n  /)
    f_wind = (/0               , 0               , hgrid%ax_offd%n/2, hgrid%ay_offd%n/2, hgrid%az_offd%n-1, &
               0               , 0               , 0                , 0                , 0                /)

    if (flag == "rite") then
    !   err = srite_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    else if (flag == "reed") then
       hess = 0.
!      write(0,*) 'In predonditioner ==> diagonal hessian....'
       err = sreed_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    end if
    return
  end subroutine
!###################  
  subroutine weight_io(weight, hgrid, file_, flag)
    real, dimension(:,:,:) :: weight
    type(hes_grid)         :: hgrid
    integer                :: ix_modl, iy_modl, iz_modl
    character(len=*)       :: file_
    character(len=4)       :: flag
    integer, dimension(3)  :: n_cube, j_wind, n_wind, f_wind
    integer                :: n_dim_cube, err

    n_dim_cube = 3
    n_cube = (/hgrid%az_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n/)
    j_wind = (/1              , 1              , 1              /)
    n_wind = (/hgrid%az_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n/)
    f_wind = (/0              , 0              , 0              /)

    write(*,*)'--'
    write(0,*)n_cube
    write(0,*)n_wind
    write(0,*)j_wind
    write(0,*)f_wind
    if (flag == "rite") then
    !   err = srite_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,wieght)
    else if (flag == "reed") then
       weight = 0.
       write(0,*) 'Weights ==> ....'
       write(0,*)size(weight,1),size(weight,2), size(weight,3),file_
       err = sreed_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,weight)
    end if
    return
  end subroutine



end module

