!hessian compute
module hessian_mod_marine
  use hessian_params
  use hessian_history
  use hessian_array
  use hessian_io
  implicit none

contains
!=======================================================================================
  integer function hess_oper_marine() result(stat)
    real                :: sx, sy, gx, gy
    real                :: maxx, maxy, maxz
    real                :: w
    integer             :: index_aw
    integer             ::        x_modl,        y_modl,        z_modl,        hx_modl,       hy_modl,         z_offd,        y_offd,        x_offd,        hy_offd,        hx_offd
    integer             ::       ix_modl,       iy_modl,       iz_modl,       ihx_modl,      ihy_modl,        iz_offd,       iy_offd,       ix_offd,       ihy_offd,       ihx_offd
    integer             ::  index_x_modl,  index_y_modl,  index_z_modl,  index_hx_modl, index_hy_modl,   index_z_offd,  index_y_offd,  index_x_offd,  index_hy_offd,  index_hx_offd 
    integer             ::      jxd_modl,      jyd_modl,                                                                    jyd_offd,      jxd_offd 
    integer             ::      jxu_modl,      jyu_modl,                                                                    jyu_offd,      jxu_offd 
    integer             ::       jx_modl,       jy_modl,       jz_modl,       jhx_modl,      jhy_modl,        jz_offd,       jy_offd,       jx_offd,       jhy_offd,       jhx_offd
    integer             :: index_sx, index_sy                            !!.. relative index on Green's grid
    integer             :: igx, igy, index_gx, index_gy, isx,isy 
    complex             :: greens_rec, greens_so
    complex             :: greens_old, greens_new
    real		:: cw
    integer             :: ind_gx,ndgx
    integer             :: ind_gy,ndgy
    real                :: tsx1,tsx2
    integer             :: ixhole,iyhole



    ndgx=dgrid%asx%d/dgrid%agx%d
    ndgy=dgrid%asy%d/dgrid%agy%d


    write(0,*)"num. freq.:", ggrid%aw

    maxz=ggrid%az_modl%o + (ggrid%az_modl%n-1)*ggrid%az_modl%d
    maxx=ggrid%ax_modl%o + (ggrid%ax_modl%n-1)*ggrid%ax_modl%d
    maxy=ggrid%ay_modl%o + (ggrid%ay_modl%n-1)*ggrid%ay_modl%d 
    open(unit=10, file=report_, status='unknown')
    !hessian1=0.;  hessian2=0.;
    nnode =omp_get_num_procs(); thread=omp_get_thread_num(); nodes=min(nodes,nnode) 
    call omp_set_num_threads(nodes); write(*,*) 'using', nodes,'of', nnode
do iw=1, ggrid%aw%n                                                           ! freq. count.
        cw=csou(iw)*conjg(csou(iw))
        w=ggrid%aw%o+(iw-1)*ggrid%aw%d
        if(w<=0. .or. cw<=0.)then; write(0,*)'skipping freq.:',iw,w,cw;cycle;endif
        index_aw= 1.5+(w-dgrid%aw%o)/dgrid%aw%d
        if (spike) then; cw=1; csou(iw)=1;endif
        write(0,'(A18,I5,A1,I5,A3,F7.3,A5,F10.4, A6,I5,A1,I5)')'start iw/index_aw: ', iw,'/',index_aw,'|', w,'=> (',cw ,') of ',ggrid%aw%n,'/',dgrid%aw%n; 
        if (.not. allocated(greens_s ))then; allocate(greens_s (ggrid%ax_surf%n , ggrid%ay_surf%n,ggrid%ax_modl%n,ggrid%ay_modl%n,ggrid%az_modl%n)); greens_s=0.;endif
        if (.not. allocated(greens_r ))then; allocate(greens_r (ggrid%ax_surf%n , ggrid%ay_surf%n,ggrid%ax_modl%n,ggrid%ay_modl%n,ggrid%az_modl%n)); greens_r=0.;endif

        call hess_io_greens(greens_s, index_aw); greens_r=greens_s
!        call hess_io_greens(greens_r, index_aw);
        
      	if(hole)then
!                 if(ih_sx1<ih_sx2)then; if(ih_sx1>1.and.ih_sx2<ggrid%ax_surf%n) then; greens_s(ih_sx1:ih_sx2,:,:,:,:)=0.; write(0,*) 'source hole-x:',ih_sx1,ih_sx2;endif;endif
!                 if(ih_gx1<ih_gx2)then; if(ih_gx1>1.and.ih_gx2<ggrid%ax_surf%n) then; greens_r(ih_gx1:ih_gx2,:,:,:,:)=0.; write(0,*) 'reciev hole-x:',ih_gx1,ih_gx2;endif;endif
                !if(ih_sy1<ih_sy2)then; if(ih_sy1>1.and.ih_sy2<ggrid%ay_surf%n) then; greens_s(:,ih_sy1:ih_sy2,:,:,:)=0.; write(0,*) 'source hole-y:',ih_sy1,ih_sy2;endif;endif
                !if(ih_gy1<ih_gy2)then; if(ih_gy1>1.and.ih_gy2<ggrid%ay_surf%n) then; greens_r(:,ih_gy1:ih_gy2,:,:,:)=0.; write(0,*) 'reciev hole-y:',ih_gy1,ih_gy2;endif;endif
        endif
        
        
      	if(hole)then
      	        if(shole)then
                        if(ih_sx1<ih_sx2)then; if(ih_sx1>1.and.ih_sx2<ggrid%ax_surf%n) then; 
                                do ixhole=1,nxhole
                                        greens_s(ihh_sx1(ixhole):ihh_sx2(ixhole),:,:,:,:)=0.; write(0,*) 'source hole-x:',ihh_sx1(ixhole),ihh_sx2(ixhole);
                                enddo
                        endif;endif
                endif
                if(ghole)then
                        if(ih_gx1<ih_gx2)then; if(ih_gx1>1.and.ih_gx2<ggrid%ax_surf%n) then; 
                                do ixhole=1,nxhole
                                        greens_r(ihh_gx1(ixhole):ihh_gx2(ixhole),:,:,:,:)=0.; write(0,*) 'receiver hole-x:',ihh_gx1(ixhole),ihh_gx2(ixhole);
                                enddo
                        endif;endif
                endif                        
        endif
        
!       if(lrand_gx)then; do igx=1,size(rand_gx); gx = dgrid%agx%o + (rand_gx(igx)-1)*dgrid%agx%d; index_gx = 1.5 + (gx - ggrid%ax_surf%o)/ggrid%ax_surf%d; greens_r(index_gx,:,:,:,:)=0.; enddo; endif
!       if(lrand_sx)then; do isx=1,size(rand_sx); sx = dgrid%asx%o + (rand_sx(isx)-1)*dgrid%asx%d; index_sx = 1.5 + (sx - ggrid%ax_surf%o)/ggrid%ax_surf%d; greens_s(index_sx,:,:,:,:)=0.; enddo; endif
!       if(lrand_gy)then; do igy=1,size(rand_gy); gy = dgrid%agy%o + (rand_gx(igy)-1)*dgrid%agy%d; index_gy = 1.5 + (gy - ggrid%ay_surf%o)/ggrid%ay_surf%d; greens_r(:,index_gy,:,:,:)=0.; enddo; endif
!       if(lrand_sy)then; do isy=1,size(rand_sy); sy = dgrid%asy%o + (rand_sx(isy)-1)*dgrid%asy%d; index_sy = 1.5 + (sy - ggrid%ay_surf%o)/ggrid%ay_surf%d; greens_s(:,index_sy,:,:,:)=0.; enddo; endif

        if (hgrid%ay_modl%n==1)then; 
		if(.not. allocated(hessian3))then;
                        allocate(hessian3(hgrid%ahx_offd%n,hgrid%ax_offd%n,hgrid%az_offd%n,hgrid%ahx_modl%n,hgrid%ax_modl%n,hgrid%az_modl%n)); hessian3=0.; 
                endif
        endif

        call date_and_time(values=time_array_0)
        start_t0 = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)
        finish_t0 = time_array_0 (5) * 3600 + time_array_0 (6) * 60  + time_array_0 (7) + 0.001 * time_array_0 (8)

!$OMP parallel do  private(inode,      iz_modl,     iy_modl,     ix_modl,     ihy_modl,     ihx_modl,     iz_offd,     iy_offd,     ix_offd,     ihy_offd,     ihx_offd, &
!$OMP                                  z_modl,      y_modl,      x_modl,      hy_modl,      hx_modl,      z_offd,      y_offd,      x_offd,      hy_offd,      hx_offd, &
!$OMP                            index_z_modl,index_y_modl,index_x_modl,index_hy_modl,index_hx_modl,index_z_offd,index_y_offd,index_x_offd,index_hy_offd,index_hx_offd, &
!$OMP                                             jhy_modl,    jhx_modl,                                 jz_offd,     jy_offd,     jx_offd,     jhy_offd,     jhx_offd, & 
!$OMP                                             jyd_modl,    jxd_modl,                                             jyd_offd,    jxd_offd,                             &
!$OMP                                             jyu_modl,    jxu_modl,                                             jyu_offd,    jxu_offd,                             & 
!$OMP                                             isy,        isx,                                                                                                      &
!$OMP                                              sy,         sx,                                                                                                      &
!$OMP                                        index_sy,   index_sx,                                                                                                      &
!$OMP                                             igy,        igx,                                                                                                      &
!$OMP                                              gy,         gx,                                                                                                      &
!$OMP                                        index_gy,   index_gx,                                                                                                      &
!$OMP                   greens_so,&
!$OMP                   greens_rec,&
!$OMP                   greens_old,&
!$OMP                   greens_new,&
!$OMP                   ind_gy,&
!$OMP                   ind_gx,&
!$OMP                   time_array_1,&
!$OMP                   int_t,&
!$OMP                   tot_t,&
!$OMP                   finish_t0,&
!$OMP                   finish_t1,&
!$OMP                   hessian1,&
!$OMP                   hessian2) schedule(dynamic,1)  
do iz_modl= 1,hgrid%az_modl%n                                                !  z loop 
        z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; index_z_modl = 1.5 + (z_modl - ggrid%az_modl%o)/ggrid%az_modl%d
        if (.not. allocated(hessian1))then; allocate(hessian1(hgrid%ahx_offd%n,hgrid%ahy_offd%n,hgrid%ax_offd%n,hgrid%ay_offd%n,hgrid%az_offd%n,hgrid%ahx_modl%n, hgrid%ahy_modl%n)); hessian1=0.;endif
        if (.not. allocated(hessian2))then; allocate(hessian2(hgrid%ahx_offd%n,hgrid%ahy_offd%n,hgrid%ax_offd%n,hgrid%ay_offd%n,hgrid%az_offd%n,hgrid%ahx_modl%n, hgrid%ahy_modl%n)); hessian2=0.;endif
        inode=omp_get_thread_num();
       !$OMP CRITICAL
        call date_and_time(values=time_array_1)
        finish_t1 = time_array_1 (5) * 3600 + time_array_1 (6) * 60  + time_array_1 (7) + 0.001 * time_array_1 (8)
        int_t = finish_t1-finish_t0
        tot_t = finish_t1-start_t0
        finish_t0 = finish_t1
        if(verb>2)then; if(modulo(iz_modl,hgrid%az_modl%n*5/100)==0) write(0,'(A10,I5,A4,I5,A10,I5,A35,3g13.4)')'start iz: ', iz_modl, 'of ',hgrid%az_modl%n  ,' @ inode: ', inode, ' | Time: Interv | Spent | Remain:',int_t,tot_t, int_t*(hgrid%az_modl%n-iz_modl)/nodes; endif
       !$OMP END CRITICAL
do iy_modl= 1,hgrid%ay_modl%n                                                !  y loop
        y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; index_y_modl = 1.5 + (y_modl - ggrid%ay_modl%o)/ggrid%ay_modl%d;
do ix_modl= 1,hgrid%ax_modl%n                                                !  x loop
        x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; index_x_modl = 1.5 + (x_modl - ggrid%ax_modl%o)/ggrid%ax_modl%d;
        hessian1=0.
        hessian2=0.;
        do ihy_modl= 1,hgrid%ahy_modl%n                                      ! hy loop                                
                !hy_modl = hgrid%ahy_modl%o + (ihy_modl-1)*hgrid%ahy_modl%d; jhy_modl = nint(hy_modl / ggrid%ay_modl%d)
                !   jyd_modl = index_y_modl - jhy_modl;               jyu_modl = index_y_modl + jhy_modl
                !if (jyd_modl < 1 .or. jyd_modl > ggrid%ay_modl%n .or. jyu_modl < 1 .or. jyu_modl > ggrid%ay_modl%n) cycle
                jyd_modl = 1; jyu_modl=1;
        do ihx_modl= 1,hgrid%ahx_modl%n                                      ! hx loop          
                hx_modl = hgrid%ahx_modl%o + (ihx_modl-1)*hgrid%ahx_modl%d; jhx_modl = nint(hx_modl / ggrid%ax_modl%d)
               	jxd_modl = index_x_modl - jhx_modl;               jxu_modl = index_x_modl + jhx_modl               	
                if (jxd_modl < 1 .or. jxd_modl > ggrid%ax_modl%n .or. jxu_modl < 1 .or. jxu_modl > ggrid%ax_modl%n) cycle
                do iz_offd=1, hgrid%az_offd%n                                ! zo loop            
                         z_offd = hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; jz_offd = nint(z_offd / ggrid%az_modl%d)      
                        index_z_offd = index_z_modl + jz_offd        
                        if (index_z_offd < 1 .or. index_z_offd > ggrid%az_modl%n) cycle   
                do iy_offd=1, hgrid%ay_offd%n                                ! yo loop  
                        !y_offd = hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d; jy_offd = nint(y_offd / ggrid%ay_modl%d)
                        jy_offd = 1
                do ix_offd=1, hgrid%ax_offd%n                                ! xo loop 
                        x_offd = hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d; jx_offd = nint(x_offd / ggrid%ax_modl%d)
                        do ihy_offd=1, hgrid%ahy_offd%n                      !hyo loop     
                                !hy_offd  = hgrid%ahy_offd%o + (ihy_offd-1)*hgrid%ahy_offd%d; jhy_offd  = nint(hy_offd / ggrid%ay_modl%d)
                                !jyd_offd = jyd_modl + jy_offd - jhy_offd; jyu_offd = jyu_modl + jy_offd + jhy_offd     
                                !if (jyd_offd < 1 .or. jyd_offd > ggrid%ay_modl%n .or. jyu_offd < 1 .or. jyu_offd > ggrid%ay_modl%n) cycle
                                 jyd_offd = 1; jyu_offd = 1; 
                        do ihx_offd=1, hgrid%ahx_offd%n                      !hxo loop  
                                hx_offd  = hgrid%ahx_offd%o + (ihx_offd-1)*hgrid%ahx_offd%d; jhx_offd  = nint(hx_offd / ggrid%ax_modl%d)
                                jxd_offd = jxd_modl + jx_offd - jhx_offd; jxu_offd = jxu_modl + jx_offd + jhx_offd     
                                if (jxd_offd < 1 .or. jxd_offd > ggrid%ax_modl%n .or. jxu_offd < 1 .or. jxu_offd > ggrid%ax_modl%n) cycle  
                               ! if (jxu_modl < 1 .or. jxd_modl < 1 .or. jxu_offd < 1 .or. jxu_offd < 1 ) write(0,*)ihx_offd,ix_offd,iz_offd,ihx_modl,ihy_modl,ix_modl,iy_modl,iz_modl
                               ! if (jxu_offd == -4 )then; write(0,*)'****************asdddsssssssssssssssssssssssssss1'; STOP; endif
                               !     if (jxu_modl == -4 )then; write(0,*)'****************asdddsssssssssssssssssssssssssss2'; STOP; endif
                               ! cycle
                               !compute recever green for shot 1
!                write(0,*)x_offd,y_offd,z_offd,x_modl,y_modl,z_modl
!                write(0,*)index_x_modl, index_y_modl, index_z_modl
!               	write(0,*)jxu_modl, jyu_modl,index_z_modl
!               	write(0,*)jx_offd,jy_offd,jz_offd
!               	write(0,*)jxd_modl,jyd_modl,index_z_modl
!               	write(0,*)jxd_offd,jyd_offd,index_z_offd
                                greens_rec=0. 
                                do igy= 1,dgrid%agy%n
                                        gy = dgrid%asy%o + dgrid%agy%o + (igy-1)*dgrid%agy%d; index_gy = 1.5 + (gy - ggrid%ay_surf%o)/ggrid%ay_surf%d;
                                do igx= 1,dgrid%agx%n 
                                        gx = dgrid%asx%o + dgrid%agx%o + (igx-2)*dgrid%agx%d; index_gx = 1.5 + (gx - ggrid%ax_surf%o)/ggrid%ax_surf%d;
!                                        write(0,'(A5,10(g20.5,2X))')'rec',igx,gx,gy,index_gx,index_gy,greens_rec,(gx - ggrid%ax_surf%o)
                                        greens_rec = greens_rec+ greens_r(index_gx, index_gy, jxu_modl, jyu_modl,index_z_modl)*conjg(greens_r(index_gx, index_gy, jxu_offd, jyu_offd, index_z_offd))
                                enddo 
                                enddo !recv
                                greens_so=0. 
                                do isy= 1,dgrid%asy%n
                                        sy = dgrid%asy%o + (isy-1)*dgrid%asy%d; index_sy = 1.5 + (sy - ggrid%ay_surf%o)/ggrid%ay_surf%d;
                                do isx= 1,dgrid%asx%n
                                        sx = dgrid%asx%o + (isx-1)*dgrid%asx%d; index_sx = 1.5 + (sx - ggrid%ax_surf%o)/ggrid%ax_surf%d;
                                        greens_old=0.
                                        do igy= 1,ndgy
                                                gy = sy+ dgrid%agy%o + (igy-1)*dgrid%agy%d; ind_gy = 1.5 + (gy - ggrid%ay_surf%o)/ggrid%ay_surf%d;
                                        do igx= 0,ndgx-1
                                                gx = sx+ dgrid%agx%o + (igx-1)*dgrid%agx%d; ind_gx = 1.5 + (gx - ggrid%ax_surf%o)/ggrid%ax_surf%d; 
!                                                write(0,'(A5,15(g15.5,2X))')'old',igx,igy,sx,sy,gx,gy,ind_gx,index_sx,(greens_old)
                                                greens_old = greens_old + greens_r (ind_gx, ind_gy, jxu_modl, jyu_modl,index_z_modl)*conjg(greens_r(ind_gx, ind_gy, jxu_offd, jyu_offd, index_z_offd))
                                        enddo
                                        enddo !recv_old

                                        greens_new=0.
                                        do igy= dgrid%agy%n,dgrid%agy%n+ndgy-1
                                                gy = sy+ dgrid%agy%o + (igy-1)*dgrid%agy%d; ind_gy = 1.5 + (gy - ggrid%ay_surf%o)/ggrid%ay_surf%d;
                                        do igx= dgrid%agx%n,dgrid%agx%n+ndgx-1
                                                gx = sx+ dgrid%agx%o + (igx-1)*dgrid%agx%d; ind_gx = 1.5 + (gx - ggrid%ax_surf%o)/ggrid%ax_surf%d;
!                                                write(0,'(A5,15(g15.5,2X))')'new',igx,igy,sx,sy,gx,gy,ind_gx,index_sx,(greens_new)
                                                greens_new = greens_new + greens_r (ind_gx, ind_gy, jxu_modl, jyu_modl,index_z_modl)*conjg(greens_r(ind_gx, ind_gy, jxu_offd, jyu_offd, index_z_offd))
                                        enddo
                                        enddo !recv_new
                                        greens_rec = greens_rec - greens_old + greens_new
                                         
                                        greens_so = greens_s(index_sx, index_sy, jxd_modl, jyd_modl,index_z_modl)*conjg(greens_s(index_sx, index_sy, jxd_offd, jyd_offd, index_z_offd))                                        
                                        hessian1(ihx_offd,ihy_offd,ix_offd,iy_offd,iz_offd,ihx_modl,ihy_modl)=hessian1(ihx_offd,ihy_offd,ix_offd,iy_offd,iz_offd,ihx_modl,ihy_modl)+real(greens_so*greens_rec)
!                                        write(0,'(2I5,15g15.5)')index_sx,isx,sx,hole_sx1,hole_sx2,real(greens_so),real(greens_rec), real(greens_old), real(greens_new)
                                        !if(isx==4)stop
                                enddo 
                                enddo  !shot
!                                stop
                                !hessian1(ihx_offd,ihy_offd,ix_offd,iy_offd,iz_offd,ihx_modl,ihy_modl)=real(greens_so*greens_rec)
                                !hessian1(ihx_offd,ihy_offd,ix_offd,iy_offd,iz_offd,ihx_modl,ihy_modl)=real(greens_so*greens_so)
                                !write(0,'(15g15.4)')ihx_offd,ihy_offd,ix_offd,iy_offd,iz_offd,ihx_modl,ihy_modl,jxu_modl,jyu_modl,index_z_modl,hessian1(ihx_offd,ihy_offd,ix_offd,iy_offd,iz_offd,ihx_modl,ihy_modl)
                        enddo   !hxoffd
                        enddo   !hyoffd
                enddo           !xoffd
                enddo           !yoffd
                enddo           !zoffd
        enddo                   !hxmodls
        enddo                   !hymodl
        if (hgrid%ay_modl%n==1)then
                hessian3(:,:,:,:,ix_modl,iz_modl)=hessian3(:,:,:,:,ix_modl,iz_modl)+hessian1(:,1,:,1,:,:,1)*cw
                hessian1=0.
        else
                if (nostack)then
                                !$OMP CRITICAL 
                                 hessian2=         hessian1; 
                                 call hess_io_hess2(hessian2,iw,ix_modl,iy_modl,iz_modl,'rite'); 
                                !$OMP END CRITICAL
                else
                                !$OMP CRITICAL 
                                 call hess_io_hess2(hessian2,1 ,ix_modl,iy_modl,iz_modl,'reed');
                                 !if (x_modl==0 .and. z_modl==500) write(0,*)'B4',cw,sum (hessian2)
                                 hessian2=hessian2+hessian1*cw!*(2*PI*w)**4;
                                 !write(0,*)ix_modl,iz_modl,cw,sum (hessian2)
                                 call hess_io_hess2(hessian2,1 ,ix_modl,iy_modl,iz_modl,'rite');
                                 !if (x_modl==0 .and. z_modl==500) write(0,*)'AT',cw,sum (hessian2)
                                !$OMP END CRITICAL
                endif                   
        endif
enddo                           !xmodl
enddo                           !ymodl
enddo                           !zmodl
!$OMP end parallel do 
if (hgrid%ay_modl%n==1)then
        if(verb>1)write(0,'(A10,I5,A3,I5,A10,F15.4)')'done iw:', index_aw, 'of ',ggrid%aw%n , 'sum hess',sum(hessian3)
        call hess_io_hess3(hessian3,'rite');
else
        write(* ,*)' done iw: ', index_aw, 'of ',ggrid%aw%n 
endif
enddo
stat = 0
end function
!========================================================================================== 

  end module

