!hessian compute
module hessian_mod_new
  use hessian_mod_obc
  use hessian_mod_marine
  implicit none

contains
!=======================================================================================
  integer function hess_init() result(stat)
    call greens_input_history()  	!read greens history
    call param_init()             	!initialize oneway parameters 
    call hess_output_history()    	!output the oneway history
    call hess_array_alloc()       	!allocate oneway memory space for the data
    call hess_io_init()  
    
    call from_param("null_gxmin", null_gxmin, 0.) !min. geoph.
    call from_param("null_gxmax", null_gxmax, 0.) !max. geoph.21

    index_null_gxmin = 1.5 + (null_gxmin - ggrid%ax_surf%o) / ggrid%ax_surf%d
    index_null_gxmax = 1.5 + (null_gxmax - ggrid%ax_surf%o) / ggrid%ax_surf%d

    write(*,*)'========================='
    write(0,*)"num shts.", dgrid%nsh!nsh num. of shots ......ntr num. of traces
    write(0,*)"num recv.", dgrid%ntr !nsh num. of shots ......ntr num. of traces
    write(*,*)'========================='
    stat = 0
  end function
!=======================================================================================
  integer function hess_clos() result(stat)
    call hess_array_dealloc()
    close(10)
    stat = 0
  end function
!=======================================================================================
  integer function hess_oper() result(stat)
    write(0,*)'Marine: ',marine
    if(marine)then
        stat= hess_oper_marine() 
    else
        stat= hess_oper_obc()    
    endif
  end function
!========================================================================================== 

  end module

