!hessian compute
module hessian_mod_stack_w
  use type_mod
  use global_params_mod
  use sep
  use util_
  use quantile_mod

  implicit none

    real                                         :: min_w, max_w
    real,    dimension(:,:,:,:,:,:), allocatable :: hessian1
    real,    dimension(:,:,:,:,:,:), allocatable :: hessian2
contains
!=======================================================================================
  integer function hess_init() result(stat)
    call hess_input_history()   !read greens history
    call param_init()           !initialize oneway parameters 
    call hess_output_history()  !output the oneway history
    call hess_array_alloc()     !allocate memory
    call hess_io_init()  
    
    stat = 0
  end function
!=======================================================================================
  integer function hess_clos() result(stat)
    call hess_array_dealloc()
    close(10)
    stat = 0
  end function
!=======================================================================================
  integer function hess_oper() result(stat)
  real :: w,w_
  real :: rand_vec(nrnd)
  integer :: index_aw,i
  logical :: cyc
  integer :: ir 
  real    :: R
  real    :: alpha
 

  R=2000./4000
  alpha = 1/(sqrt(1+R**2))

  
    write(0,*)"freq. axis:", ggrid%aw
    write(*,*)'========================='
  
    min_w=ggrid%aw%o; max_w=ggrid%aw%o+(ggrid%aw%n-1)*ggrid%aw%d;
    hessian1=0.;
        do iw=1, ggrid%aw%n                                                            ! freq. count.
                cyc=.false.
!                write(*,*)'iw: ', iw, 'of ',nint(ggrid%aw%n/jw*1.)
                if (rand .and. iw <= nrnd .and. jw/=1) then; 
                        call random_number(w);
                        w=min_w+(max_w-min_w)*w; 
                        index_aw=1.5+(w-min_w)/ggrid%aw%d;rand_vec(iw)=index_aw;
                        do i=1,iw-1; if (index_aw==rand_vec(i))then; cyc=.true.; exit; endif; enddo
                        if (cyc) cycle;
                      !  write(*,*)w,iw,index_aw
                elseif (rand .and. iw > nrnd .and. jw/=1)then
                        exit
                elseif((.not. rand .and. jw==1) .and. (.not. pratt))then 
                        index_aw=1+(iw-1)*jw
                        write(*,*)'index_aw: ', iw, index_aw, 'of ',nint(ggrid%aw%n/jw*1.)
                elseif ( pratt)then
                        if (iw==1)then
                                w = ggrid%aw%o+ggrid%aw%d*2
                        else
                                w = w_/alpha 
                        endif
                        w_=w
                        index_aw=1.5+(w-min_w)/ggrid%aw%d;
                !        write(*,*)iw,index_aw,w,w_,alpha
                endif

                if (index_aw > ggrid%aw%n) exit
                if (allocated(hessian2)) then; deallocate(hessian2); endif
                allocate(hessian2(hgrid%ax_offd%n,hgrid%ay_offd%n,hgrid%az_offd%n,hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n)); 
                call hess_io_hess_in(hessian2,index_aw,'reed');
        
                hessian1=hessian1+hessian2
                write(*,*)maxval(hessian1)
!                write(*,*)'index_aw: ', iw, index_aw, 'of ',nint(ggrid%aw%n/jw*1.)

     enddo
                call hess_io_hess_out(hessian1,'rite');
        
    stat = 0
  end function

!=========================================================================================
  subroutine hess_array_alloc()
    integer :: memory
    allocate(hessian1(hgrid%ax_offd%n,hgrid%ay_offd%n,hgrid%az_offd%n,hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n))
    allocate(wavelet(1))

    memory = 4 * size(hessian) + 8 * (size(greens) + size(wavelet)) ! 4*size(hessian)+ 4*size(source)+4*size(rec.)+size(wavelet)...men
    memory = memory / 1024 / 1024
    write(0,*)"Memory allocated: ", memory, "Mb"

  end subroutine
!=================================================================================================
subroutine hess_array_dealloc()
  if(allocated(hessian1)) deallocate(hessian1)
  end subroutine
!==========================================================================================
  subroutine param_init()

    write(*,*)'ax_offd:n_d_o',hgrid%ax_offd
    write(*,*)'ay_offd:n_d_o',hgrid%ay_offd
    write(*,*)'az_offd:n_d_o',hgrid%az_offd
    write(*,*)'========================='
    !============================================================
    write(*,*)'ax_modl:n_d_o',hgrid%ax_modl
    write(*,*)'ay_modl:n_d_o',hgrid%ay_modl
    write(*,*)'az_modl:n_d_o',hgrid%az_modl
    write(*,*)'========================='

    !============================================================
    report_ = "report"    ; 
    call from_param("report"      , report_      ,'report')
    call from_param("jw"          , jw           , 1      )
    call from_param("seed"        , seed         , 123    )
    call from_param("nrnd"        , nrnd         , ggrid%aw%n/jw )
    call from_param("rand"        , rand         , .false.)
    call from_param("nodes     "  , nodes        , 1      )
    call from_param("pratt     "  , pratt        , .false.)

  end subroutine
!========================================================================================== 
  subroutine hess_input_history()
    !!!!!Input the Hessain details into the history file...
    hessian_in_= "hess_in"; 

    call auxin(hessian_in_)
    call hinaxis2(hessian_in_, hgrid%ahx_offd, 1); 
    call hinaxis2(hessian_in_, hgrid%ahy_offd, 2);  
    call hinaxis2(hessian_in_, hgrid%ax_offd , 3); 
    call hinaxis2(hessian_in_, hgrid%ay_offd , 4); 
    call hinaxis2(hessian_in_, hgrid%az_offd , 5); 
    call hinaxis2(hessian_in_, hgrid%ahx_modl, 6); 
    call hinaxis2(hessian_in_, hgrid%ahy_modl, 7); 
    call hinaxis2(hessian_in_, hgrid%ax_modl , 8); 
    call hinaxis2(hessian_in_, hgrid%ay_modl , 9); 
    call from_aux(hessian_in_, "n10", hgrid%az_modl%n)  
    call from_aux(hessian_in_, "d10", hgrid%az_modl%d) 
    call from_aux(hessian_in_, "o10", hgrid%az_modl%o) !cant read 2 digits!!! 
    call from_aux(hessian_in_, "n11", ggrid%aw%n)  
    call from_aux(hessian_in_, "d11", ggrid%aw%d) 
    call from_aux(hessian_in_, "o11", ggrid%aw%o) !cant read 2 digits!!! 
  end subroutine
!==========================================================================================
  subroutine hess_output_history()
    !!!!!Outputs the Hessain details into the history file...
    hessian_out_= "hess_out"; 

    call auxinout(hessian_out_)

    !sub-offset off-diagonals ==========================
    call auxputch("n1", "i", hgrid%ahx_offd%n, hessian_out_) !sub. offset off-diag num 
    call auxputch("d1", "r", hgrid%ahx_offd%d, hessian_out_) !                     samp  
    call auxputch("o1", "r", hgrid%ahx_offd%o, hessian_out_) !                     orig.
    call auxputch("label1", "s", "hx_offd", hessian_out_)

    call auxputch("n2", "i", hgrid%ahy_offd%n, hessian_out_)
    call auxputch("d2", "r", hgrid%ahy_offd%d, hessian_out_)
    call auxputch("o2", "r", hgrid%ahy_offd%o, hessian_out_)
    call auxputch("label2", "s", "hy_offd", hessian_out_)
    !===================================================
    !zero offset off-diagonals
    call auxputch("n3", "i", hgrid%ax_offd%n, hessian_out_) !off-diag num.
    call auxputch("d3", "r", hgrid%ax_offd%d, hessian_out_) !         samp.
    call auxputch("o3", "r", hgrid%ax_offd%o, hessian_out_) !         orig.
    call auxputch("label3", "s", "x_offd", hessian_out_)

    call auxputch("n4", "i", hgrid%ay_offd%n, hessian_out_)
    call auxputch("d4", "r", hgrid%ay_offd%d, hessian_out_)
    call auxputch("o4", "r", hgrid%ay_offd%o, hessian_out_)
    call auxputch("label4", "s", "y_offd", hessian_out_)

    call auxputch("n5", "i", hgrid%az_offd%n, hessian_out_)
    call auxputch("d5", "r", hgrid%az_offd%d, hessian_out_)
    call auxputch("o5", "r", hgrid%az_offd%o, hessian_out_)
    call auxputch("label5", "s", "z_offd", hessian_out_)
    !===================================================
    !sub-offset modl. points
    call auxputch("n6", "i", hgrid%ahx_modl%n, hessian_out_) !sub-offset model point num.
    call auxputch("d6", "r", hgrid%ahx_modl%d, hessian_out_) !                       samp.
    call auxputch("o6", "r", hgrid%ahx_modl%o, hessian_out_) !                       orig.
    call auxputch("label6", "s", "hx_modl", hessian_out_)

    call auxputch("n7", "i", hgrid%ahy_modl%n, hessian_out_)
    call auxputch("d7", "r", hgrid%ahy_modl%d, hessian_out_)
    call auxputch("o7", "r", hgrid%ahy_modl%o, hessian_out_)
    call auxputch("label7", "s", "hy_modl", hessian_out_)
    !===================================================
    !zero-offset modl. points...actual model points
    call auxputch("n8", "i", hgrid%ax_modl%n, hessian_out_) !model point num.
    call auxputch("d8", "r", hgrid%ax_modl%d, hessian_out_) !            samp.
    call auxputch("o8", "r", hgrid%ax_modl%o, hessian_out_) !            orig. 
    call auxputch("label8", "s", "x_modl", hessian_out_)

    call auxputch("n9", "i", hgrid%ay_modl%n, hessian_out_)
    call auxputch("d9", "r", hgrid%ay_modl%d, hessian_out_)
    call auxputch("o9", "r", hgrid%ay_modl%o, hessian_out_)
    call auxputch("label9", "s", "y_modl", hessian_out_)

    call auxputch("n10", "i", hgrid%az_modl%n, hessian_out_)
    call auxputch("d10", "r", hgrid%az_modl%d, hessian_out_)
    call auxputch("o10", "r", hgrid%az_modl%o, hessian_out_)
    call auxputch("label10", "s", "z_modl", hessian_out_)
    !===================================================
  end subroutine

!====================================================================================================================
!initialize the full hessian to zeros.
 subroutine hess_io_init()
    real, allocatable, dimension(:) :: ctmp
    integer                         :: i, nloop
    allocate(ctmp(hgrid%ahx_modl%n*hgrid%ahy_modl%n*hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
    ctmp = 0.
          nloop = hgrid%ahx_offd%n*hgrid%ahy_offd%n*hgrid%ax_offd%n*hgrid%ay_offd%n*hgrid%az_offd%n
          write(*,*)'Initializing Hessian.....stack'
    do i=1, nloop
       call sep_write(ctmp, hessian_out_, esize=4)
    end do
    deallocate(ctmp)
  end subroutine
!====================================================================================================================
 subroutine hess_io_hess_in(hessian,index_aw,flag)
    integer                                     :: index_zs, index_aw
    integer, dimension(11)                      :: n_cube, j_wind, n_wind, f_wind
    integer                                     :: n_dim_cube, err
    real, dimension(:,:,:,:,:,:),    allocatable:: hessian
    character(len=4)                            :: flag

    n_dim_cube = 11
    n_cube = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, &
               hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n, ggrid%aw%n/)
    j_wind = (/1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1/)
    n_wind = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, & 
               hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n, 1 /)
    f_wind = (/0, 0, 0, 0, 0, 0, 0, 0, 0, 0, index_aw-1/)

 
write(*,*)n_cube
write(*,*)n_wind
write(*,*)j_wind
write(*,*)f_wind


    if (flag == "rite") then
       write(0,*)'you want to destroy the hessian!!! go away!!!!!'
     !  err = srite_window(hessian_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian)
    else if (flag == "reed") then
       write(0,*)'reading hessian freq: ', index_aw, 'of ', ggrid%aw%n
       err = sreed_window(hessian_in_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian)
    else
       call seperr("you have to specify the flag for data_io_data()")
    end if

    if (err /= 0) call seperr("hess_io_hess: error writing hessian")

  end subroutine
  !#############################
 subroutine hess_io_hess_out(hessian,flag)
    integer                                     :: index_zs, index_aw
    integer, dimension(10)                      :: n_cube, j_wind, n_wind, f_wind
    integer                                     :: n_dim_cube, err
    real, dimension(:,:,:,:,:,:),    allocatable:: hessian
    character(len=4)                            :: flag

    n_dim_cube = 10
    n_cube = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, &
               hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n /)
    j_wind = (/1, 1, 1, 1, 1, 1, 1, 1, 1, 1/)
    n_wind = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, & 
               hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n /)
    f_wind = (/0, 0, 0, 0, 0, 0, 0, 0, 0, 0/)
!write(*,*)n_cube
!write(*,*)n_wind
!write(*,*)j_wind
!write(*,*)f_wind
    if (flag == "rite") then
       err = srite_window(hessian_out_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian)
    else if (flag == "reed") then
       write(0,*)'not supposed to read here@!!!!!!'
!       err = sreed_window(hessian_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian)
    else
       call seperr("you have to specify the flag for data_io_data()")
    end if

    if (err /= 0) call seperr("hess_io_hess: error writing hessian")

  end subroutine
!====================================================================================================================
!select frequencies
 subroutine hess_freq(wavelet, nfreq, fact_l, fact_u)
    complex, allocatable, dimension(:)  :: wavelet
    real, allocatable, dimension(:)     :: ctmp,w_abs, lw,rw
    real, allocatable, dimension(:)     :: quant_u, quant_l, quant
    integer, allocatable, dimension(:)  :: lww, rww
    integer                             :: i,ii, nfreq
    integer                             :: iw_max, iw, il,lu, nl, nu,length
    real                                :: w_max, w, fact_u, fact_l

    length=size(wavelet)
   
    allocate(w_abs(length))
    w_abs=cabs(wavelet);
    w_max=w_abs(1)
    do iw=1,length; 
        if (w_abs(iw)>w_max)then; 
            w_max=w_abs(iw); iw_max=iw; 
        endif; 
    enddo

    allocate(lw(iw_max), rw(length-iw_max))
    allocate(ctmp(int(nfreq)),quant_l(int(nfreq)), quant_u(int(nfreq)))

    write(*,*)'----',size(wavelet),iw_max,length
    lw=w_abs(1:iw_max);
    rw=w_abs(  iw_max+1:length);
    quant_l(1)=1; 
    do i=2,length
        quant_l(i)=(quant_l(i-1)-i*fact_l); 
        if ( quant_l(i) <= .02)then; ctmp(1:i-1)=quant_l(1:i-1); deallocate (quant_l) ; allocate (quant_l(i-1)); quant_l=ctmp(1:i-1); exit 
        else;  ctmp(i)=quant_l(i); endif
     enddo
     
     quant_u(1)=1; 
     do i=2,size(w_abs)
        quant_u(i)=quant_u(i-1)-i*fact_u; 
        if ( quant_u(i) <= .02)then; ctmp(1:i-1)=quant_u(1:i-1); deallocate (quant_u) ; allocate (quant_u(i-1)); quant_u=ctmp(1:i-1); exit 
        else;  ctmp(i)=quant_u(i); endif
     enddo
    
     write(*,*)quant_l; write(*,*)'----'; write(*,*)quant_u;
     write(*,*)'+++++++++++++', iw_max
     allocate(lww(nfreq), rww(nfreq))
     lww(1)=iw_max; ii=1;
     do i=2,size(quant_l)-1
        w=quantile(nint(quant_l(i)*iw_max),lw); 
        do iw=2,iw_max
                if ( w<w_abs(iw))then
                    ii=ii+1;
                    if (lww(ii-1)==iw) then; ii=ii-1; continue; endif;
                    lww(ii)=iw; write(*,*) iw, w; exit;
                endif
        enddo
     enddo
     write(*,*)'+++++++++++++', iw_max

     rww(1)=iw_max+1; ii=1;
     do i=2,size(quant_u)-1
        w=quantile(nint(quant_u(i+1)*size(rw)),rw);
        do iw=iw_max+1,length
                if ( w>w_abs(iw))then
                    ii=ii+1;
                    if (rww(ii-1)==iw) then; ii=ii-1; continue; endif;
                    rww(ii)=iw; write(*,*) iw, w;  exit;
                endif
        enddo
     enddo
  

     !freq=sort([rww lww]);
    !for i=1,length(freq); wwww(i)=w(freq(i));end



!    allocate(ctmp(hgrid%ahx_modl%n*hgrid%ahy_modl%n*hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
!    ctmp = 0.
!          nloop = hgrid%ahx_offd%n*hgrid%ahy_offd%n*hgrid%ax_offd%n*hgrid%ay_offd%n*hgrid%az_offd%n
!          write(*,*)'Initializing Hessian.....stack'
!    do i=1, nloop
!       call sep_write(ctmp, hessian_out_, esize=4)
!    end do
!    deallocate(ctmp)
  end subroutine
!====================================================================================================================
  subroutine hess_io_wavelet(wavelet, index_ws)
    complex, dimension(:), pointer :: wavelet
    integer                        :: index_ws
    integer, dimension(1)          :: n_cube, j_wind, n_wind, f_wind
    integer                        :: n_dim_cube, err

    n_dim_cube = 1
    n_cube = dgrid%aw%n
    j_wind = 1 
    n_wind = 1
    f_wind = index_ws-1

    wavelet = 0.
    err = sreed_window(wavelet_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,wavelet)
    if (err .lt. 0) call seperr("io_wavelet: trouble reading source wavelet")
  end subroutine
!========================================================================================== 
 subroutine wavelet_input_history()
    integer             :: iw, niw,unw
    real                :: w 
    integer             :: num_match
    character(len=1024) :: string

    wavelet_="wavelet"; 

!read the source wavelet from file    
    if ( exist_file(wavelet_)) then
        call auxin(wavelet_)
        call from_aux(wavelet_, "n3", dgrid%aw%n); call from_aux(wavelet_, "d3", dgrid%aw%d); call from_aux(wavelet_, "o3", dgrid%aw%o)
    else
        call seperr("please provide the wavelet...you....!!!!! " )
    end if
    allocate(csou(dgrid%aw%n),wavelet(1))
    do iw=1,dgrid%aw%n
            call hess_io_wavelet(wavelet, iw); csou(iw)=wavelet(1)
    end do
    mcsou=maxval(abs(csou))
!=compute the useful freq.!!!!!!!!!!!!!!!!!!!!!!!! take values >=0.2% of max value in wavelet
    iw=0.;
    do niw=1,dgrid%aw%n-1
           if (abs(csou(niw))<=mcsou*.001) then; iw=iw+1; if (iw>=floor(dgrid%aw%n*0.02)) exit; endif
           if (abs(csou(niw))<=mcsou*.002 .and. niw <= 0.1*dgrid%aw%n) iw=iw+1;
           if (abs(csou(niw))<=mcsou*.002 .and. niw >= 0.2*dgrid%aw%n) exit;
    enddo
    
    unw=niw-iw
    ggrid%aw%o=dgrid%aw%o+(iw-1)*dgrid%aw%d; ggrid%aw%d=dgrid%aw%d*jw; ggrid%aw%n=(niw-iw)/max(jw-1,1); 
    deallocate(wavelet)
    write(*,*)'---------------'
    write(*,*)'dgrid%aw & ggrid%aw '
    write(*,*)dgrid%aw
    write(*,*)ggrid%aw
    write(*,*)'useful freq/.......',iw,niw,unw,(iw-1)*dgrid%aw%d,jw
    write(*,*)'---------------'
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  end subroutine
!######################################################################
  end module

