# 1 "<stdin>"
# 1 "<built-in>"
# 1 "<command line>"
# 1 "<stdin>"
!hessian compute
module hessian_params
  use type_mod
  use global_defi_mod
  use ctaper_mod
  use util_
  use sep

    implicit none
    real , dimension(:,:) , pointer, private :: dgrid_header_rec_save
    real , private :: dgrid_gxmin_save
    real , private :: dgrid_gymin_save
    real , private :: i, ii, iskip
    integer :: index_null_gxmin, index_null_gxmax
    real :: null_gxmin, null_gxmax

    complex, dimension(:,:,:,:,: ), allocatable :: greens1
    complex, dimension(:,:,:,:,: ), allocatable :: greens_s
    complex, dimension(:,:,:,:,: ), allocatable :: greens_r
    real, dimension(:,: ), allocatable :: hessian0
    real, dimension(:,:,:,:,:,:,: ), allocatable :: hessian1
    real, dimension(:,:,:,:,:,:,: ), allocatable :: hessian2
    real, dimension(:,:,:,:,:,: ), allocatable :: hessian3
! real, dimension(:,:,:,:,:,:,:,:,:,:), allocatable :: hessian4
contains
!==========================================================================================
  subroutine param_init()
    use qsort
    real :: xmin_modl_default, xmax_modl_default
    real :: ymin_modl_default, ymax_modl_default
    real :: zmin_modl_default, zmax_modl_default
    real :: surface_xmin_default, surface_xmax_default
    real :: surface_ymin_default, surface_ymax_default
    integer :: ixn, iyn, izn

    !============================================================
    call from_param("nsx", dgrid%asx%n, ggrid%ax_surf%n); call from_param("dsx", dgrid%asx%d, ggrid%ax_surf%d); call from_param("osx", dgrid%asx%o, ggrid%ax_surf%o)
    call from_param("nsy", dgrid%asy%n, ggrid%ay_surf%n); call from_param("dsy", dgrid%asy%d, ggrid%ay_surf%d); call from_param("osy", dgrid%asy%o, ggrid%ay_surf%o)
    dgrid%nsh = dgrid%asx%n * dgrid%asy%n !num of sources..
    call from_param("ngx", dgrid%agx%n, ggrid%ax_surf%n); call from_param("dgx", dgrid%agx%d, ggrid%ax_surf%d); call from_param("ogx", dgrid%agx%o, ggrid%ax_surf%o)
    call from_param("ngy", dgrid%agy%n, ggrid%ay_surf%n); call from_param("dgy", dgrid%agy%d, ggrid%ay_surf%d); call from_param("ogy", dgrid%agy%o, ggrid%ay_surf%o)
    dgrid%ntr = dgrid%agx%n * dgrid%agy%n !num. of traces/recievers
    write(0,*)'sx:n_d_o',dgrid%asx
    write(0,*)'sy:n_d_o',dgrid%asy
    write(0,*)'gx:n_d_o',dgrid%agx
    write(0,*)'gy:n_d_o',dgrid%agy
   !============================================================
    !sub-offset off-diags
    call from_param("nhx_offd", hgrid%ahx_offd%n, 1 ); call from_param("dhx_offd", hgrid%ahx_offd%d, ggrid%ax_modl%d); call from_param("ohx_offd", hgrid%ahx_offd%o, 0.)
    call from_param("nhy_offd", hgrid%ahy_offd%n, 1 ); call from_param("dhy_offd", hgrid%ahy_offd%d, ggrid%ay_modl%d); call from_param("ohy_offd", hgrid%ahy_offd%o, 0.)
    !off-diags
    call from_param(" nx_offd", hgrid%ax_offd%n, 1 ); call from_param(" dx_offd", hgrid%ax_offd%d, ggrid%ax_modl%d); call from_param(" ox_offd", hgrid%ax_offd%o, 0.)
    call from_param(" ny_offd", hgrid%ay_offd%n, 1 ); call from_param(" dy_offd", hgrid%ay_offd%d, ggrid%ay_modl%d); call from_param(" oy_offd", hgrid%ay_offd%o, 0.)
    call from_param(" nz_offd", hgrid%az_offd%n, 1 ); call from_param(" dz_offd", hgrid%az_offd%d, ggrid%az_modl%d); call from_param(" oz_offd", hgrid%az_offd%o, 0.)
    !sub-offset
    call from_param("nhx_modl", hgrid%ahx_modl%n, 1 ); call from_param("dhx_modl", hgrid%ahx_modl%d, ggrid%ax_modl%d); call from_param("ohx_modl", hgrid%ahx_modl%o, 0.)
    call from_param("nhy_modl", hgrid%ahy_modl%n, 1 ); call from_param("dhy_modl", hgrid%ahy_modl%d, ggrid%ay_modl%d); call from_param("ohy_modl", hgrid%ahy_modl%o, 0.)
    !============================================================
    !main-model
    xmin_modl_default = ggrid%ax_modl%o; xmax_modl_default = ggrid%ax_modl%o + (ggrid%ax_modl%n-1)*ggrid%ax_modl%d
    ymin_modl_default = ggrid%ay_modl%o; ymax_modl_default = ggrid%ay_modl%o + (ggrid%ay_modl%n-1)*ggrid%ay_modl%d
    zmin_modl_default = ggrid%az_modl%o; zmax_modl_default = ggrid%az_modl%o + (ggrid%az_modl%n-1)*ggrid%az_modl%d

    izn=0; ixn=0; iyn=0;
    call from_param("xmin_modl", hgrid%xmin_modl, xmin_modl_default);call from_param("ymin_modl", hgrid%ymin_modl, ymin_modl_default); hgrid%xmax_modl=min(hgrid%xmax_modl,ggrid%ax_modl%o+(ggrid%ax_modl%n-1)*ggrid%ax_modl%d)
    call from_param("xmax_modl", hgrid%xmax_modl, xmax_modl_default);call from_param("ymax_modl", hgrid%ymax_modl, ymax_modl_default); hgrid%ymax_modl=min(hgrid%ymax_modl,ggrid%ay_modl%o+(ggrid%ay_modl%n-1)*ggrid%ay_modl%d)
    call from_param("zmin_modl", hgrid%zmin_modl, zmin_modl_default);call from_param("zmax_modl", hgrid%zmax_modl, zmax_modl_default); hgrid%zmax_modl=min(hgrid%zmax_modl,ggrid%az_modl%o+(ggrid%az_modl%n-1)*ggrid%az_modl%d)
    ixn = 1.5 + (hgrid%xmax_modl-hgrid%xmin_modl)/ggrid%ax_modl%d
    iyn = 1.5 + (hgrid%ymax_modl-hgrid%ymin_modl)/ggrid%ay_modl%d
    izn = 1.5 + (hgrid%zmax_modl-hgrid%zmin_modl)/ggrid%az_modl%d

    call from_param(" nx_modl", hgrid%ax_modl%n, ixn); call from_param(" dx_modl", hgrid%ax_modl%d, ggrid%ax_modl%d); call from_param(" ox_modl", hgrid%ax_modl%o, hgrid%xmin_modl)
    call from_param(" ny_modl", hgrid%ay_modl%n, iyn); call from_param(" dy_modl", hgrid%ay_modl%d, ggrid%ay_modl%d); call from_param(" oy_modl", hgrid%ay_modl%o, hgrid%ymin_modl)
    call from_param(" nz_modl", hgrid%az_modl%n, izn); call from_param(" dz_modl", hgrid%az_modl%d, ggrid%az_modl%d); call from_param(" oz_modl", hgrid%az_modl%o, hgrid%zmin_modl)

      !============================================================
    write(0,*)'========================='
    write(0,*)'Summary Hessian    ======'
    write(0,*)'========================='
    write(0,*)'ahx_offd:n_d_o',hgrid%ahx_offd; write(0,*)'ahy_offd:n_d_o',hgrid%ahy_offd; write(0,*)' ax_offd:n_d_o',hgrid%ax_offd; write(0,*)' ay_offd:n_d_o',hgrid%ay_offd; write(0,*)' az_offd:n_d_o',hgrid%az_offd
    write(0,*)'========================='
    write(0,*)'ahx_modl:n_d_o',hgrid%ahx_modl; write(0,*)'ahy_modl:n_d_o',hgrid%ahy_modl; write(0,*)' ax_modl:n_d_o',hgrid%ax_modl; write(0,*)' ay_modl:n_d_o',hgrid%ay_modl; write(0,*)' az_modl:n_d_o',hgrid%az_modl
    write(0,*)'========================='
    !============================================================
    report_ = "report" ;
    call from_param("jw" , jw , 1 )
    call from_param("nostack" , nostack , .false.)
    call from_param("taper" , taper , .true. )
    call from_param("taper_pct" , taper_pct , 0.1 )
    call from_param("taper_type" , taper_type , 2 )
    call from_param("nodes     " , nodes , 1 )
    call from_param("verb      " , verb , 1 )
    call from_param("spike     " , spike , .false.)
    !============================================================
    call from_param("hole" , hole , F )
    call from_param("hole_sx1" , hole_sx1 ,-999999.)
    call from_param("hole_sy1" , hole_sy1 ,-999999.)
    call from_param("hole_gx1" , hole_gx1 ,-999999.)
    call from_param("hole_gy1" , hole_gy1 ,-999999.)
    call from_param("hole_sx2" , hole_sx2 ,-999999.)
    call from_param("hole_sy2" , hole_sy2 ,-999999.)
    call from_param("hole_gx2" , hole_gx2 ,-999999.)
    call from_param("hole_gy2" , hole_gy2 ,-999999.)
    !============================================================
    call from_param("lrand_gx" , lrand_gx , F ); call from_param("randgx",randgx_,'randgx');
    call from_param("lrand_gy" , lrand_gy , F ); call from_param("randgy",randgy_,'randgy');
    call from_param("lrand_sx" , lrand_sx , F ); call from_param("randsx",randsx_,'randsx');
    call from_param("lrand_sy" , lrand_sy , F ); call from_param("randsy",randsy_,'randsy');
    write(0,*)'Summary random data======================================='
    write(0,*)"lrand_gx:",lrand_gx,"randgy:",lrand_gy
    write(0,*)"lrand_sx:",lrand_sx,"randsy:",lrand_sy
    write(0,*)'=========================================================='
    ih_sx1=1; ih_sy1=1;ih_gy1=1;ih_gy1=1
    ih_sx2=1; ih_sy2=1;ih_gy2=1;ih_gy2=1
    if(.not. hole)then
                write(0,*)'No hole in data..good..No need to worry...'
    else
                ih_sx1=1.5+(hole_sx1-dgrid%asx%o)/dgrid%asx%d; ih_sx2=1.5+(hole_sx2-dgrid%asx%o)/dgrid%asx%d;
                ih_sy1=1.5+(hole_sy1-dgrid%asy%o)/dgrid%asy%d; ih_sy2=1.5+(hole_sy2-dgrid%asy%o)/dgrid%asy%d;
                ih_gx1=1.5+(hole_gx1-dgrid%agx%o)/dgrid%agx%d; ih_gx2=1.5+(hole_gx2-dgrid%agx%o)/dgrid%agx%d;
                ih_gy1=1.5+(hole_gy1-dgrid%agy%o)/dgrid%agy%d; ih_gy2=1.5+(hole_gy2-dgrid%agy%o)/dgrid%agy%d;
        if(hole_sx1<=hole_sx2.and.ih_sx1>1.and.ih_sx2<dgrid%asx%n) write(0,*)'hole sx           : ', ih_sx1, ih_sx2
        if(hole_sy1<=hole_sy2.and.ih_sy1>1.and.ih_sx2<dgrid%asx%n) write(0,*)'hole sy           : ', ih_sy1, ih_sy2
        if(hole_gx1<=hole_gx2.and.ih_gx1>1.and.ih_gx2<dgrid%agx%n) write(0,*)'hole gx           : ', ih_gx1, ih_gx2
        if(hole_gy1<=hole_gy2.and.ih_gy1>1.and.ih_gy2<dgrid%agy%n) write(0,*)'hole gy           : ', ih_gy1, ih_gy2
    endif
    nlive_gx=dgrid%agx%n; nlive_sx=dgrid%asx%n;
    nlive_gy=dgrid%agy%n; nlive_sy=dgrid%asy%n;
    write(0,*)'=========================================================='
    write(0,*)'Summary hole=============================================='
    if(.not. hole .and. .not.(lrand_gx.or.lrand_gy.or.lrand_sx.or.lrand_sy))then
        write(0,*)'No missing data..good..No need to worry...'
        allocate(live_gx(nlive_gx)); allocate(live_sx(nlive_sx));allocate(live_gy(nlive_gy)); allocate(live_sy(nlive_sy));
    elseif(hole)then
        if(ih_gx2==ih_gx1)then;nlive_gx=nlive_gx; else; nlive_gx=nlive_gx-(ih_gx2-ih_gx1+1); endif
        if(ih_gy2==ih_gy1)then;nlive_gy=nlive_gy; else; nlive_gy=nlive_gy-(ih_gy2-ih_gy1+1); endif
        if(ih_sx2==ih_sx1)then;nlive_sx=nlive_sx; else; nlive_sx=nlive_sx-(ih_sx2-ih_sx1+1); endif
        if(ih_sy2==ih_sy1)then;nlive_sy=nlive_sy; else; nlive_sy=nlive_sy-(ih_sy2-ih_sy1+1); endif
        if(allocated(live_gx))deallocate(live_gx); allocate(live_gx(nlive_gx));
        if(allocated(live_gy))deallocate(live_gy); allocate(live_gy(nlive_gy));
        if(allocated(live_sx))deallocate(live_sx); allocate(live_sx(nlive_sx));
        if(allocated(live_sy))deallocate(live_sy); allocate(live_sy(nlive_sy));
    else
        if(lrand_gx.or.lrand_gy)then
                write(0,*)'Will not compute missing reciver locations...'
                if(lrand_gx)then
                        if(allocated(rand1))deallocate(rand1); allocate(rand1(dgrid%agx%n))
                        open (file=trim(randgx_), unit=10, status='unknown');
                        do igx=1,dgrid%agx%n;
                                read(10,*,err=11,end=11)rand1(igx);
                        enddo
11 allocate(rand_gx(igx-1));rand_gx=rand1(1:igx-1);deallocate(rand1); close(10)
                        nlive_gx=dgrid%agx%n-size(rand_gx)
                        if(allocated(live_gx))deallocate(live_gx); allocate(live_gx(nlive_gx));
                endif
                if(lrand_gy)then
                        if(allocated(rand1))deallocate(rand1); allocate(rand1(dgrid%agy%n))
                        open (file=trim(randgy_), unit=10, status='unknown');
                        do igy=1,dgrid%agy%n;
                                read(10,*,err=12,end=12)rand1(igy);
                        enddo
12 allocate(rand_gy(igy-1));rand_gy=rand1(1:igy-1);deallocate(rand1); close(10)
                        nlive_gy=dgrid%agy%n-size(rand_gy)
                        if(allocated(live_gy))deallocate(live_gy); allocate(live_gy(nlive_gy));
                else
                        if(allocated(live_gy))deallocate(live_gy); allocate(live_gy(nlive_gy));
                endif
        endif
        if(lrand_sx.or.lrand_sy)then
                write(0,*)'Will not compute missing shot locations...'
                if(lrand_sx)then
                        if(allocated(rand1))deallocate(rand1); allocate(rand1(dgrid%asx%n))
                        open (file=trim(randsx_), unit=10, status='unknown');
                        do isx=1,dgrid%asx%n;
                                read(10,*,err=13,end=13)rand1(isx);
                        enddo
13 allocate(rand_sx(isx-1));rand_sx=rand1(1:isx-1);deallocate(rand1); close(10)
                        nlive_sx=dgrid%asx%n-size(rand_sx)
                        if(allocated(live_sx))deallocate(live_sx); allocate(live_sx(nlive_sx));
                else
                        if(allocated(live_sx))deallocate(live_sx); allocate(live_sx(nlive_sx));
                endif
                if(lrand_sy)then
                        if(allocated(rand1))deallocate(rand1); allocate(rand1(dgrid%asy%n))
                        open (file=trim(randsy_), unit=10, status='unknown');
                        do isy=1,dgrid%asy%n;
                                read(10,*,err=14,end=14)rand1(isy);
                        enddo
14 allocate(rand_sy(isy-1));rand_sy=rand1(1:isy-1);deallocate(rand1); close(10)
                        nlive_sy=dgrid%asy%n-size(rand_sy)
                        if(allocated(live_sy))deallocate(live_sy); allocate(live_sy(nlive_sy));
                else
                        if(allocated(live_sy))deallocate(live_sy); allocate(live_sy(nlive_sy));
                endif
        endif
    endif
    write(0,*)'=========================================================='
    !============================================================initialize the live sources and recievers
    if(lrand_gx)then; ii=0; do igx=1,dgrid%agx%n; iskip=0; do i=1,size(rand_gx); if(igx==rand_gx(i)) then; iskip=iskip+1; cycle; endif; enddo; if(iskip>0)cycle; ii=ii+1; live_gx(ii)=igx; enddo;
        elseif(ih_gx1<ih_gx2)then; ii=0; do igx=1,dgrid%agx%n; if(igx>ih_gx2 .or. igx<ih_gx1 ) then; ii=ii+1; live_gx(ii)=igx; endif; enddo; else; do igx=1,dgrid%agx%n; live_gx(igx)=igx; enddo; endif

    if(lrand_gy)then; ii=0; do igy=1,dgrid%agy%n; iskip=0; do i=1,size(rand_gy); if(igy==rand_gy(i)) then; iskip=iskip+1; cycle; endif; enddo; if(iskip>0)cycle; ii=ii+1; live_gy(ii)=igy; enddo;
        elseif(ih_gy1<ih_gy2)then; ii=0; do igy=1,dgrid%agy%n; if(igy>ih_gy2 .or. igy<ih_gy1 ) then; ii=ii+1; live_gx(ii)=igy; endif; enddo; else; do igy=1,dgrid%agy%n; live_gy(igy)=igy; enddo; endif

    if(lrand_sx)then; ii=0; do isx=1,dgrid%asx%n; iskip=0; do i=1,size(rand_sx); if(isx==rand_sx(i)) then; iskip=iskip+1; cycle; endif; enddo; if(iskip>0)cycle; ii=ii+1; live_sx(ii)=isx; enddo;
        elseif(ih_sx1<ih_sx2)then; ii=0; do isx=1,dgrid%asx%n; if(isx>ih_sx2 .or. isx<ih_sx1 ) then; ii=ii+1; live_sx(ii)=isx; endif; enddo; else; do isx=1,dgrid%asx%n; live_sx(isx)=isx; enddo; endif

    if(lrand_sy)then; ii=0; do isy=1,dgrid%asy%n; iskip=0; do i=1,size(rand_sy); if(isy==rand_sy(i)) then; iskip=iskip+1; cycle; endif; enddo; if(iskip>0)cycle; ii=ii+1; live_sy(ii)=isy; enddo;
        elseif(ih_sy1<ih_sy2)then; ii=0; do isy=1,dgrid%asy%n; if(isy>ih_sy2 .or. isy<ih_sy1 ) then; ii=ii+1; live_sy(ii)=isy; endif; enddo; else; do isy=1,dgrid%asy%n; live_sy(isy)=isy; enddo; endif
    allocate(irand_gx(size(rand_gx))); call quick_sort(rand_gx,irand_gx); deallocate(irand_gx);
    allocate(irand_gy(size(rand_gy))); call quick_sort(rand_gy,irand_gy); deallocate(irand_gy);
    allocate(irand_sx(size(rand_sx))); call quick_sort(rand_sx,irand_sx); deallocate(irand_sx);
    allocate(irand_sy(size(rand_sy))); call quick_sort(rand_sy,irand_sy); deallocate(irand_sy);
  end subroutine
!==========================================================================================
  subroutine data_radians_calc()
        if (.not.radian) then; dgrid%aw%d = dgrid%aw%d * 2.0 * PI; dgrid%aw%o = dgrid%aw%o * 2.0 * PI; end if
  end subroutine
!==========================================================================================
  subroutine green_radians_calc()
        if (.not.radian) then; ggrid%aw%d = ggrid%aw%d * 2.0 * PI; ggrid%aw%o = ggrid%aw%o * 2.0 * PI; end if
  end subroutine
!==========================================================================================
  end module
