module joint_encode_data_array 
  use joint_encode_data_param 
  implicit none 
contains
!=========================================================================================
  subroutine data_array_alloc()
!    real :: memory
        memory = 0.
        allocate(wavelet(1));     memory = memory + 8*size(wavelet);
        allocate(vel (vgrid%ax%n, vgrid%ay%n, vgrid%az%n)); memory = memory + 4*size(vel);
        allocate(ref (vgrid%ax%n, vgrid%ay%n, vgrid%az%n)); memory = memory + 4*size(ref);
        !allocate(den (vgrid%ax%n, vgrid%ay%n, vgrid%az%n)); memory = memory + 4*size(den);
        !allocate(mod (vgrid%ax%n, vgrid%ay%n, vgrid%az%n)); memory = memory + 4*size(mod);
        !allocate(tdat(dgrid%agx%n,  dgrid%agy%n, dgrid%asx%n, dgrid%asy%n, dgrid%at%n)); memory = memory + 4*size(tdat);
        !allocate(mig (igrid%ahx%n, igrid%ahy%n, igrid%ax%n, igrid%ay%n, igrid%az%n)); memory = memory + 4*size(mig);
        if(use_greens)then
            allocate(fdata(dgrid%agx%n, dgrid%agy%n, dgrid%asx%n, dgrid%asy%n, dgrid%aw%n)); memory = memory + 8*size(fdata);
            if(encode)then
                    allocate(greens_scode(dgrid%asx%n, dgrid%asy%n,ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n, ggrid%aw%n)) ;memory = memory + 8*size(greens_scode);
            else
            endif
        else
            !allocate(fdata(dgrid%agx%n, dgrid%agy%n, dgrid%aw%n, dgrid%asx%n, dgrid%asy%n)); memory = memory + 8*size(fdata);
        endif        
        allocate(nref(vgrid%az%n));memory = memory + 4*size(nref);
        allocate(vref(vnum));memory = memory + 4*size(vref);
        allocate(vel_ref(vnum,vgrid%az%n,2)); memory = memory + 4*size(vel_ref);

        if (wfld_d_out)allocate(wfld_out_d(vgrid%ax%n,vgrid%ay%n,vgrid%az%n,dgrid%at%n,1)); memory = memory + 8*size(wfld_out_d); 
        if (wfld_u_out)allocate(wfld_out_u(vgrid%ax%n,vgrid%ay%n,vgrid%az%n,dgrid%at%n,1)); memory = memory + 8*size(wfld_out_u); 
        memory = memory / 1024 / 1024
        write(0,'(A65)')'=========================Summary memory================================='
        write(0,'(A30,2X,F9.3,A2)')"Memory allocated per node:", memory, "Mb"
        memory=memory*nodes
        write(0,'(A30,2X,F9.3,A2)')"Total memory needed      :", memory, "Mb"
        write(0,'(A65)')'===================================================================='
        memory=(memory/nodes)*1024*1024
  end subroutine
!=======================================================================================
   subroutine mig_array_alloc3(progrid, ooogrid,nodes,dwblk_in)
        integer :: memory, nodes
        type(pro_grid) :: progrid  
        type(out_grid) :: ooogrid
        integer        :: dwblk,dwblk_in
        optional       :: dwblk_in

        if(.not.adj)then;if (allocated(wfldfull_d )) deallocate(wfldfull_d ); allocate(wfldfull_d (progrid%ax%n,progrid%ay%n,progrid%az%n,nodes )); wfldfull_d=0.;endif
                         if (allocated(tape       )) deallocate(tape       ); allocate(tape       (progrid%ax%n,progrid%ay%n                    )); tape=1.
                         if (allocated(wfldslice_u)) deallocate(wfldslice_u); allocate(wfldslice_u(progrid%ax%n,progrid%ay%n,nodes              )); wfldslice_u=0.
                         if (allocated(wfldslice_d)) deallocate(wfldslice_d); allocate(wfldslice_d(progrid%ax%n,progrid%ay%n,nodes              )); wfldslice_d=0.
                         if (allocated(velslice   )) deallocate(velslice   ); allocate(velslice   (progrid%ax%n,progrid%ay%n,nodes              )); velslice=0.
        if(.not.ffd)then 
                if (allocated(tmpwfld1_u)) deallocate(tmpwfld1_u); allocate(tmpwfld1_u(progrid%ax%n,progrid%ay%n,nodes              )); wfldslice_u=0.
                if (allocated(tmpwfld1_d)) deallocate(tmpwfld1_d); allocate(tmpwfld1_d(progrid%ax%n,progrid%ay%n,nodes              )); wfldslice_d=0.
                if (allocated(tmpwfld2_u)) deallocate(tmpwfld2_u); allocate(tmpwfld2_u(progrid%ax%n,progrid%ay%n,nodes              )); wfldslice_u=0.
                if (allocated(tmpwfld2_d)) deallocate(tmpwfld2_d); allocate(tmpwfld2_d(progrid%ax%n,progrid%ay%n,nodes              )); wfldslice_d=0.
        endif
        if(lhessian)then
                dwblk=nodes
                if(present(dwblk_in))dwblk=dwblk_in
                if (allocated(greens_r)) deallocate(greens_r); allocate(greens_r (ooogrid%ax%n,ooogrid%ay%n,ooogrid%az%n,nreal_hess,dwblk));
                if (allocated(greens_s)) deallocate(greens_s); allocate(greens_s (ooogrid%ax%n,ooogrid%ay%n,ooogrid%az%n,nreal_hess,dwblk));
                !if (allocated(greens_r)) deallocate(greens_r); allocate(greens_r   (ooogrid%ax%n,ooogrid%ay%n,nreal_hess,nodes,ooogrid%az%n));
                !if (allocated(greens_s)) deallocate(greens_s); allocate(greens_s   (ooogrid%ax%n,ooogrid%ay%n,nreal_hess,nodes,ooogrid%az%n));
        endif
  end subroutine
 !=======================================================================================
   subroutine mig_array_dealloc3()
        integer :: memory, nodes
        type(pro_grid) :: progrid   
        type(out_grid) :: ooogrid   

        if (allocated(tape      ))  deallocate(tape        ); 
        if (allocated(wfldfull_d))  deallocate(wfldfull_d  ); 
        if (allocated(wfldslice_u)) deallocate(wfldslice_u ); 
        if (allocated(wfldslice_d)) deallocate(wfldslice_d ); 
        if (allocated(wfldslice_u)) deallocate(wfldslice_u ); 
        if (allocated(tmpwfld1_d )) deallocate(tmpwfld1_d );  
        if (allocated(tmpwfld2_d )) deallocate(tmpwfld2_d ); 
        if (allocated(tmpwfld1_u )) deallocate(tmpwfld1_u ); 
        if (allocated(tmpwfld2_u )) deallocate(tmpwfld2_u ); 
        if (allocated(velslice   )) deallocate(velslice   ); 
        if (allocated(modl       )) deallocate(modl       ); 
        if (allocated(tmpmig )) deallocate(tmpmig        ); 
        if (allocated(tmpmig2)) deallocate(tmpmig2       ); 
        if (allocated(velslice)) deallocate(velslice); 
        if (allocated(velref  )) deallocate(velref  ); 
        if (allocated(nref  )) deallocate(nref  ); 
        if (allocated(vref  )) deallocate(vref  );  
        if (allocated(greens_r1 )) deallocate(greens_r1 ); 
        if (allocated(greens_s1 )) deallocate(greens_s1 ); 
        if (allocated(greens_r  )) deallocate(greens_r  ); 
        if (allocated(greens_s  )) deallocate(greens_s  ); 
        if (allocated(greens_rec)) deallocate(greens_rec); 
        if (allocated(greens_so )) deallocate(greens_so ); 

  end subroutine
!=======================================================================================
subroutine data_array_dealloc()
        if(allocated(wavelet)) deallocate(wavelet)     ;       
        if(allocated(vel    )) deallocate(vel)         ;
        if(allocated(den    )) deallocate(den)         ;
        if(allocated(refl   )) deallocate(refl)        ;       
        if(allocated(data   )) deallocate(data)        ;
        if(allocated(wavelet)) deallocate(wavelet)     ;
        if(allocated(greens )) deallocate(greens)      ; 
        if(allocated(wfld_out_d )) deallocate(wfld_out_d);     
        if(allocated(wfld_out_u )) deallocate(wfld_out_u)
   
        if (allocated(wfld_slice_d)) deallocate(wfld_slice_d); 
        if (allocated(wfld_slice_u)) deallocate(wfld_slice_u); 
        if (allocated(tmp_wfld1_d )) deallocate(tmp_wfld1_d ); 
        if (allocated(tmp_wfld2_d )) deallocate(tmp_wfld2_d ); 
        if (allocated(tmp_wfld1_u )) deallocate(tmp_wfld1_u ); 
        if (allocated(tmp_wfld2_u )) deallocate(tmp_wfld2_u ); 
        if (allocated(tmp_mig     )) deallocate(tmp_mig     ); 
        if (allocated(tmp_mig2    )) deallocate(tmp_mig2    ); 
        if (allocated(data        )) deallocate(data        ); 
        if (allocated(fdata       )) deallocate(fdata       ); 
        if (allocated(mig         )) deallocate(mig         ); 
        if (allocated(vel_slice   )) deallocate(vel_slice   );  
        if (allocated(vel_ref     )) deallocate(vel_ref     ); 
        if (allocated(nref        )) deallocate(nref        ); 
  end subroutine

!#####################################################modl1, data1,epsi1, lmbd1, mask1, wght1, pick1, modl1_mres, data1_mres, rmov1, mmov1, norm1, dips1
  subroutine joint_array_alloc()
        if (nsurv > 0) then
                nsurf=dgrid%asx%n*dgrid%asy%n*dgrid%agx%n*dgrid%agy%n
                nmod=igrid%ahx%n*igrid%ahy%n*vgrid%ax%n*vgrid%ay%n*vgrid%az%n
                ndat=dgrid%asx%n*dgrid%asy%n*dgrid%agx%n*dgrid%agy%n*dgrid%aw%n
                ndat_real=dgrid%asx%n*dgrid%asy%n*dgrid%agx%n*dgrid%agy%n*(dgrid%aw%n*2-1) ! data space is twice the actual space to account for real-complex conversion
                if(encode)then; ns  = dgrid%asx%n*dgrid%asy%n;else; ns  = wgrid%asx%n*wgrid%asy%n; endif; ng = dgrid%agx%n*dgrid%agy%n

                allocate( modl0(nmod*nsurv)); memory=memory+4*size(modl0)
                allocate(  vel0(nmod*nsurv)); memory=memory+4*size( vel0)
                if(lread_data)then
                        allocate(fdata0(ndat_real*nsurv)); memory=memory+8*size(fdata0)
                endif                        
                allocate(sshft0(wgrid%asx%n,wgrid%asy%n,nsurv)); memory=memory+size(sshft0)
                if(adj.or.inv) allocate( dips0(nmod*nsurv)); memory=memory+4*size(dips0) 
                if(use_greens)then
                        allocate(gscd0(dgrid%asx%n, dgrid%asy%n,ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n, ggrid%aw%n, nsurv)); memory=memory+8*size(gscd0)
                        if(encode)then
                                if(small)then
                                        allocate(code0(wgrid%asx%n,wgrid%asy%n,nsurv)); memory=memory+8*size(code0)
                                endif 
                        endif
                else
                        if(lhessian)then
                                if(encode)then
                                        allocate(gscd0(vgrid%ax%n, vgrid%ay%n,  1, dgrid%aw%n, dgrid%asx%n, dgrid%asy%n, nreal_hess)); memory=memory+8*size(gscd0);
                                endif 
                                allocate(csou0(wgrid%asx%n,wgrid%asy%n,wgrid%aw%n,nreal_hess)); memory=memory+8*size(csou0)
                                allocate(maps0(dgrid%agx%n,dgrid%agy%n,dgrid%asx%n,dgrid%asy%n, nsurv)); maps0=0.
                        else
                                allocate(gscd0(vgrid%ax%n, vgrid%ay%n,  1, dgrid%aw%n, dgrid%asx%n, dgrid%asy%n, nsurv)); memory=memory+8*size(gscd0);
                                allocate(csou0(wgrid%asx%n,wgrid%asy%n,wgrid%aw%n,nsurv)); memory=memory+8*size(csou0)
                        endif
                        if(encode)then
                                allocate(code0(wgrid%asx%n,wgrid%asy%n,nsurv)); memory=memory+4*size(code0)
                        endif
                endif 
                if (inv .or. dot)then
                        if(eps_vec)then
                                allocate( epsi0(nmod*nsurv*2)); memory=memory+4*size(epsi0)
                        endif
                       !allocate( epsi0(nmod*nsurv)); memory=memory+4*size(epsi0)
                       !allocate( lmbd0(nmod*nsurv)); memory=memory+4*size(lmbd0)
                       !allocate( gamm0(nmod*nsurv)); memory=memory+4*size(gamm0)
                        allocate(    f0(nmod*nsurv)); memory=memory+4*size(f0   ) 
                       !allocate(    s0(nmod*nsurv)); memory=memory+4*size(s0   )
                        if(inv)then 
                                allocate(souz0(vgrid%ax%n, vgrid%ay%n, 1, dgrid%aw%n,dgrid%asx%n, dgrid%asy%n, nsurv)) ;memory=memory+8*size(souz0);
                                allocate(norm0(nsurv*niter)); 
                                allocate(tscale(niter)); 
                                allocate(sscale(niter)); 
                                if (all)then
                                        allocate(rmov0(nsurv*nmod,nint(1.*niter/jmov))); memory=memory+4*size(rmov0)
                                        allocate(mmov0(nsurv*nmod,nint(1.*niter/jmov))); memory=memory+4*size(mmov0)
                                        allocate(mask0(nsurv*nmod)); memory=memory+4*size(mask0);mask0=1. 
                                        if(weight ) allocate(wght0(nsurv*nmod)); memory=memory+4*size(wght0);wght0=1. 
                                        if(precond) allocate(hesp0(nsurv*nmod)); memory=memory+4*size(hesp0)
                                        if(lpick  ) allocate(pick0(nsurv*nmod)); memory=memory+4*size(pick0)
                                        if(is2d)then
                                                if(small) then
                                                        allocate(HE_0(h3%n,h4%n,h5%n,h8%n,h9%n,h10%n)); memory=memory+4*size(HE_0)
                                                        allocate(he0(h3%n,h4%n,h5%n,h8%n,h9%n,h10%n)); memory=memory+4*size(he0)
                                                else
                                                        allocate(hes0(h3%n,h4%n,h5%n,h8%n,h9%n)); memory=memory+4*size(hes0)
                                                endif
                                        else
                                                if(small) then
                                                        allocate(hes0(h3%n,h4%n,h5%n,h8%n,h9%n)); memory=memory+4*size(hes0)
                                                else
                                                allocate(hess0(h3%n,h4%n,h5%n)); memory=memory+4*size(hess0)
                                                endif
                                        endif
                                endif
                        endif
                endif
        else
                call seperr('You have less than one survey....Take a break...get some coffee...then come back and figure out what you did wrong.')
        endif
        
        
        !time-shifting

        if(lsft)allocate(ts0(nmod*nsurv,3)); memory=memory+4*size(ts0)
        if(lcc )allocate(cc0(nmod*nsurv,3)); memory=memory+4*size(cc0)
        write(0,*)'Surv: [','ALL', '] Memory:',memory/1024/1024
        memory = memory / 1024 / 1024
        write(0,'(A65)')'=========================Summary memory================================='
        write(0,'(A30,2X,F9.3,A2)')"Memory allocated per node:", memory, "Mb"
        memory=memory*nodes
        write(0,'(A30,2X,F9.3,A2)')"Total memory needed      :", memory, "Mb"
        write(0,'(A65)')'===================================================================='
  end subroutine
!#####################################################  
  subroutine joint_encode_array_clos()
        if(allocated(modl0)) deallocate(modl0)
        if(allocated(data0)) deallocate(data0)
        if(allocated(dips0)) deallocate(dips0)
        if(allocated(epsi0)) deallocate(epsi0)
        if(allocated(lmbd0)) deallocate(lmbd0)
        if(allocated(mask0)) deallocate(mask0)
        if(allocated(wght0)) deallocate(wght0)
        if(allocated(wght0)) deallocate(pick0)
        !if(allocated(modl_mres0)) deallocate(modl_mres0)
        !if(allocated(data_mres0)) deallocate(data_mres0)
        if(allocated(rmov0)) deallocate(rmov0)
        if(allocated(mmov0)) deallocate(mmov0)
        if(allocated(norm0)) deallocate(norm0)
        if(allocated(hess0)) deallocate(hess0)
        if(allocated(hes0))  deallocate(hes0)
        if(allocated(he0))  deallocate(he0)
        if(allocated(HE_0))  deallocate(HE_0)
        if(allocated(hesp0)) deallocate(hesp0)
        if(allocated(sshft0)) deallocate(sshft0)
        if(allocated(maps0)) deallocate(maps0)
        call ndeallocate(  n_filt)
        call vndeallocate( vn_filt)
  end subroutine

  end module
