module joint_encode_data_compute_hess_hx
  use joint_encode_utils
  use joint_encode_data_io
  use joint_encode_data_array
  use joint_encode_data_grid
  use adj_mod
  use ssf_mod_ffd
  use ctaper_mod
!  
  use joint_hessian_params !for hessian
  use joint_hessian_utils  !for hessian
  use joint_encode_rcode_init 

  implicit none
        complex, allocatable, private   :: spk(:,:,:)
        complex, allocatable, private   :: green_ws (:,:,:,:,:)
        complex, allocatable, private   :: green_w  (:,:,:,:,:,:)
        complex, allocatable, private   :: green_w_s(:,:,:,:,:,:)
        complex, allocatable, private   :: illum_src(:,:,:,:)
  contains
!===========================================================================================================================================================================
  integer function encode_compute_hess_hx(isurv) result(stat)
    real,    dimension(:,:,:,:,:,:),allocatable:: tmodl
    complex, dimension(:,:,:,:  ),pointer:: dat 
    real,    dimension(:,:,:    ),pointer:: mod
    integer                              :: iiw, iiiw, nb_nw, max_nw, isurv, i, isxd,isyd
    type(axis)                           :: tmp_gx, tmp_gy              
    integer             :: ix,iy,iz
    integer             :: ixd,iyd
    integer             :: ixu,iyu
    integer             :: ihx,ihy
    integer             :: jhx,jhy
    real                :: hx,hy 
    integer             :: ixhole
    integer             :: icycle
    integer             :: tnsx !source counter
    integer             :: jmin_z
    integer             :: nsrc

!timer stuff
    real                :: start_time(nodes), finish_time(nodes), start_t(nodes), finish_t(nodes), start_t0(nodes), finish_t0(nodes), start_t1(nodes), finish_t1(nodes), tot_t(nodes), int_t(nodes)
    integer             :: time_array_0(8,nodes), time_array_1(8,nodes), time_array_3(8,nodes), time_array_4(8,nodes), time_array_5(8,nodes), time_array_6(8,nodes)
!timer fftw stuff
    integer*8                                   :: planf,plani
    integer*8, dimension(:)       , allocatable :: plan_s1dF, plan_s1dI
    integer*8, dimension(:)       , allocatable :: plan_r1dF, plan_r1dI
    integer*8, dimension(:)       , allocatable :: plan_s2dF, plan_s2dI
    integer*8, dimension(:)       , allocatable :: plan_r2dF, plan_r2dI
    integer*8, dimension(:)       , allocatable :: plan_2dqF, plan_2dqI
    integer*8, dimension(:)       , allocatable :: plan_2dtF, plan_2dtI

!hessian stuff
    integer             ::        x_modl,        y_modl,        z_modl,        hx_modl,       hy_modl,         z_offd,        y_offd,        x_offd,        hy_offd,        hx_offd
    integer             ::       ix_modl,       iy_modl,       iz_modl,       ihx_modl,      ihy_modl,        iz_offd,       iy_offd,       ix_offd,       ihy_offd,       ihx_offd
    integer             ::  index_x_modl,  index_y_modl,  index_z_modl,  index_hx_modl, index_hy_modl,   index_z_offd,  index_y_offd,  index_x_offd,  index_hy_offd,  index_hx_offd 
    integer             ::      jxd_modl,      jyd_modl,                                                                    jyd_offd,      jxd_offd 
    integer             ::      jxu_modl,      jyu_modl,                                                                    jyu_offd,      jxu_offd 
    integer             ::       jx_modl,       jy_modl,       jz_modl,       jhx_modl,      jhy_modl,        jz_offd,       jy_offd,       jx_offd,       jhy_offd,       jhx_offd

!freq blocking
    integer             ::         nwblk, dwblk, iwblk, iwblk1, iwblk2, iwbk, jwbk
    

        call omp_set_num_threads(nodes); 
        
        if((.not. inv .or.niter<=2).and.verb>=5)then
                if(      adj)write(0,'(A20,I4,A9,I4,A7)')'Migrating survey: ',isurv,'...with',nodes,' nodes'
                if(.not. adj)write(0,'(A20,I4,A9,I4,A7)')' Modeling survey: ',isurv,'...with',nodes,' nodes'
        endif
        if(allocated(plan_s2dF))deallocate(plan_s2dF);allocate(plan_s2dF(nodes),plan_s2dI(nodes))
        if(allocated(plan_r2dF))deallocate(plan_r2dF);allocate(plan_r2dF(nodes),plan_r2dI(nodes))

        if(allocated(plan_2dtF))deallocate(plan_2dtF);allocate(plan_2dtF(nodes),plan_2dtI(nodes))
        if(allocated(plan_2dqF))deallocate(plan_2dqF);allocate(plan_2dqF(nodes),plan_2dqI(nodes))
     
        vel=reshape(vel0((isurv-1)*nmod+1:isurv*nmod),(/vgrid%ax%n,vgrid%ay%n,vgrid%az%n/));
        tmp_gx=dgrid%agx !use in case not marine
        tmp_gy=dgrid%agy
         
        icount=0;
       if (allocated(hessian3))deallocate(hessian3); allocate(hessian3(hgrid%ax_offd%n,hgrid%ay_offd%n,hgrid%az_offd%n, hgrid%ax_modl%n,hgrid%ay_modl%n,nodes)); hessian3=0.;
!        if (allocated(hessian3))deallocate(hessian3); allocate(hessian3(hgrid%ax_offd%n,hgrid%ay_offd%n, hgrid%ax_modl%n,hgrid%ay_modl%n,hgrid%az_modl%n,nodes)); hessian3=0.;
        icount=0;
        tnsx=0.
        call sreed(maps1_,maps0,4*dgrid%agx%n*dgrid%agy%n*dgrid%asx%n*dgrid%asy%n)
        if(sum(   maps0(:,:,:,:,isurv))==0.  )maps0(:,:,:,:,isurv)=1.
        where(abs(maps0(:,:,:,:,isurv))>1.e-8)maps0(:,:,:,:,isurv)=1.
               
do isy=1, dgrid%asy%n, encode_nsy;
                sy           =     wgrid%asy%o + (        isy -1) * wgrid%asy%d; 
                sy_end       = min(wgrid%asy%o + (wgrid%asy%n -1) * wgrid%asy%d, sy + (encode_nsy-1)*wgrid%asy%d)
                index_sy     =1.5 + (sy    -vgrid%ay%o)/vgrid%ay%d
                index_sy_end =1.5 + (sy_end-vgrid%ay%o)/vgrid%ay%d
                isyd         = max(1,nint((sy -dgrid%asy%o)/dgrid%asy%d)) 
        do isx=1, dgrid%asx%n, encode_nsx;    ! shot loop encode encode_nsx shots
!        do isx=1, 1, encode_nsx;    ! shot loop encode encode_nsx shots
                sx           =     wgrid%asx%o + (        isx -1) * wgrid%asx%d; 
                sx_end       = min(wgrid%asx%o + (wgrid%asx%n -1) * wgrid%asx%d, sx + (encode_nsx-1)*wgrid%asx%d)
                index_sx     =1.5 + (sx    -vgrid%ax%o)/vgrid%ax%d
                index_sx_end =1.5 + (sx_end-vgrid%ax%o)/vgrid%ax%d
                isxd         = max(1,nint((sx-dgrid%asx%o)/dgrid%asx%d)) 
                tnsx=tnsx+1

!                if (hole.and.(isx>=ih_sx1).and.(isx<=ih_sx2))then; write(0,*)'Hole: isx,index_sx,sx', isx,index_sx,sx; cycle; endif

                icycle=0.
                if(hole)then
                        do ixhole=1,nxhole
                                if (hole.and.(isx>=ihh_sx1(ixhole)).and.(isx<=ihh_sx2(ixhole)))then; write(0,*)'Hole: isx,index_sx,sx', isx,index_sx,sx; icycle=1; endif
                        enddo
                endif
                if(icycle==1)cycle
                if(offset)then
                        dgrid%agx%o=tmp_gx%o+sx
                        dgrid%agy%o=tmp_gy%o+sy
                endif
                
                dwblk=min(nodes,dgrid%aw%n)*2
                nwblk=1.5+(dgrid%aw%n-1)/dwblk*1.
                 

                call mig_pro_grid(index_sx,index_sx_end,index_sy, index_sy_end, pgrid, ogrid); call k2map(pgrid,kx2,ky2); !define grid
                call mig_array_alloc3(pgrid,ogrid,nodes, dwblk)                                                         ; !allocate arrays
                call fftw_init(plan_s2dF, plan_s2dI, tmpwfld2_d, pgrid%ax%n, pgrid%ay%n, nodes)                         ; !fft source plans
                call fftw_init(plan_r2dF, plan_r2dI, tmpwfld2_u, pgrid%ax%n, pgrid%ay%n, nodes)                         ; !fft receiver plans 
                call circular_taper(wfldslice_d(:,:,1),tape)                                                            ; !defne taper

                stat = ssf_init2(vgrid%az%d); 
                if(encode)then!ecode source
                        do ireal=1,nreal_hess
                                csou0(isx,isy,:,ireal)=csou0(isx,isy,:,1)
                        enddo
                        if(spike)csou0=1
                        call joint_rcode_init (index_sy*index_sx,maps0(:,:,isx,isy,isurv),csou0(isx,isy,:,:))    !init encode recv.+source
                        call joint_scode_init2(index_sy*index_sx,gscd0(index_sx:index_sx_end,index_sy:index_sy_end,1,:,isxd,isyd,:))    !init encode recv.+source
                else
                        do ireal=1,nreal_hess
                                csou0(isx,isy,:,ireal)=csou0(isx,isy,:,1)
                        enddo
                        if(spike)csou0=1.
                        call joint_rcode_init(index_sy*index_sx,maps0(:,:,isx,isy,isurv),csou0(isx,isy,:,:))    !init encode recv.
                        
                endif

                if(ffd)stat = ssf_ffd_init(sign,kx2, ky2, vgrid%az%d, vgrid%ax%d, vgrid%ay%d)
                if(allocated(nref))deallocate(nref);allocate(nref(vgrid%az%n));nref=0.

                if(allocated(greens_rec))deallocate(greens_rec);allocate(greens_rec(nodes))
                if(allocated(greens_so ))deallocate(greens_so );allocate(greens_so (nodes))
                do iz=1,vgrid%az%n
                        do iv=1,vnum; if(vel_ref(iv,iz,1)>1e-05)then; nref(iz)=nref(iz)+1; else; exit; endif; enddo
                enddo
                if(.not. inv)then;
                        if(verb<= 6)write(0 ,'(A7,I4,A20,I5,A1,I5,A6,I5,A1,I5,A5,I5,A9)',advance='yes')'Survey',isurv,'|Shot [isx, isy]:  (', isx ,',' ,isy, ') of (', dgrid%asx%n ,',',dgrid%asy%n,') @ ', nodes, 'nodes'
                        if(verb > 6)write(0 ,'(A7,I4,A20,I5,A1,I5,A6,I5,A1,I5,A5,I5,A9)',advance='yes')'Survey',isurv,'|Shot [isx, isy]:  (', isx ,',' ,isy, ') of (', dgrid%asx%n ,',',dgrid%asy%n,') @ ', nodes, 'nodes'
                        if(verb>6)then
                                write(0,'(2(A14,g12.4),3(A14,I10))')'|sx:',sx,'|sx_end:',sx_end,'|index_sx:',index_sx,'|index_sx_end:',index_sx_end,'|isxd:',isxd
                                write(0,'(2(A14,g12.4),3(A14,I10))')'|sy:',sy,'|sy_end:',sy_end,'|index_sy:',index_sy,'|index_sy_end:',index_sy_end,'|isyd:',isyd
                        endif
                endif
                if(wfld_d_out)wfld_out_d=0.
                if(wfld_u_out)wfld_out_u=0.
                
                do inode=1,nodes
                        call date_and_time(values=time_array_0(:,inode))
                        start_t0 (inode) = time_array_0 (5,inode) * 3600 + time_array_0 (6,inode) * 60  + time_array_0 (7,inode) + 0.001 * time_array_0 (8,inode)
                        finish_t0(inode) = time_array_0 (5,inode) * 3600 + time_array_0 (6,inode) * 60  + time_array_0 (7,inode) + 0.001 * time_array_0 (8,inode)
                enddo
                do iwbk=1, nwblk
                        iwblk1= 1.5+(iwbk-1)*(dwblk)
                        iwblk1= min(iwblk1,dgrid%aw%n)
                        iwblk2= min(iwblk1+dwblk-1,dgrid%aw%n)
                        greens_r=0
                        greens_s=0
                        if(verb>5)write(0,'(A80,8g14.2)')'Working on freq, block:dwblk,nwblk,iwbk,iwblk1,iwblk2',dwblk,nwblk,iwbk,iwblk1,iwblk2
                        
!$OMP parallel do private(iw, inode, ireal, w, index_aw, pvel, pwfld, pmod, pdat, & 
!$OMP                           iz, iy, ix,                     &
!$OMP                           ihy, ihx,                       &
!$OMP                           hx, hy,                         &
!$OMP                           iv,                             &
!$OMP                           tmp_wfld1_d, tmp_wfld1_u,       &
!$OMP                           tmp_wfld2_d, tmp_wfld2_u,       &
!$OMP                           index_gx, index_gy,             &
!$OMP                           igx, igy,                       &
!$OMP                           jhx, jhy,                       &
!$OMP                           iyd, ixd,                       &
!$OMP                           iyu, ixu,                       &
!$OMP                                 iz_modl,   z_modl , index_z_modl, jmin_z, jwbk)  schedule (dynamic,min(1,nwblk))
                        do iw=iwblk1,iwblk2
                                jwbk=iw-iwblk1+1
                                inode=omp_get_thread_num()+1;
                                w = dgrid%aw%o + (iw-1)*dgrid%aw%d; index_aw=1.5 + (w-dgrid%aw%o)/wgrid%aw%d
                                if(sum(cabs(csou_full(:,:,iw        )))==0.) cycle; 
                                do ireal=1,nreal_hess 
                                        wfldslice_d(:,:,inode)=0.; wfldslice_u(:,:,inode)=0.;
                                        if(encode)then
                                                wfldslice_d(pgrid%index_datpro_sx:pgrid%index_datpro_sx_end,pgrid%index_datpro_sy:pgrid%index_datpro_sy_end,inode)=& 
                                                      gscd0(             index_sx:index_sx_end,                          index_sy:index_sy_end,1,iw,isxd,isyd,ireal)**2.
                                        else
                                                wfldslice_d(pgrid%index_datpro_sx,pgrid%index_datpro_sy,inode)=csou0(isx,isy,iw,ireal)**2.;
                                        endif
                                        if(dgrid%agy%d/pgrid%ay%d/=1.)then
                                                do igy=1,dgrid%agy%n
                                                        index_gy=min((igy-1)*(dgrid%agy%d/pgrid%ay%d)+pgrid%index_datpro_gymin,1.*pgrid%index_datpro_gymax)
                                                do igx=1,dgrid%agx%n
                                                        index_gx=min((igx-1)*(dgrid%agx%d/pgrid%ax%d)+pgrid%index_datpro_gxmin,1.*pgrid%index_datpro_gxmax)
                                                        wfldslice_u(index_gx,index_gy,inode)=maps0(igx,igy,isx,isy,isurv)*grcd0(igx, igy, index_aw, ireal, 1, 1, 1 )*tape(index_gx,index_gy);
                                                enddo
                                                enddo
                                        else
                                                wfldslice_u(pgrid%index_datpro_gxmin:pgrid%index_datpro_gxmax,pgrid%index_datpro_gymin:pgrid%index_datpro_gymax,inode)=grcd0(:,:, index_aw, ireal, 1, 1, 1 );
                                        endif 
                                        if(wfld_d_out)wfld_out_d(pgrid%index_xmin:pgrid%index_xmax,pgrid%index_ymin:pgrid%index_ymax,imin_sz,iw,1)=wfldslice_d(:,:,inode); 
                                        if(wfld_u_out)wfld_out_u(pgrid%index_xmin:pgrid%index_xmax,pgrid%index_ymin:pgrid%index_ymax,imin_rz,iw,1)=wfldslice_u(:,:,inode);
                                        greens_r (:,:,imin_rz,ireal,jwbk)=wfldslice_u(ogrid%index_pro_xmin:ogrid%index_pro_xmax,ogrid%index_pro_ymin:ogrid%index_pro_ymax,inode);
                                        greens_s (:,:,imin_sz,ireal,jwbk)=wfldslice_d(ogrid%index_pro_xmin:ogrid%index_pro_xmax,ogrid%index_pro_ymin:ogrid%index_pro_ymax,inode);
                                        
                                        pvel=>vel(pgrid%index_xmin:pgrid%index_xmax, pgrid%index_ymin:pgrid%index_ymax,1);
                                        !!$omp ordered
                                        !if(inode>0)write(0,"(16g14.4)")iw,index_aw,inode,encode,spike,csou0(isx,isy,iw,ireal),sum(cabs(wfldslice_u(:,:,inode))),sum(cabs(wfldslice_d(:,:,inode))),sum(cabs(greens_r (:,:,:,ireal,inode))),sum(cabs(greens_s (:,:,:,ireal,inode)))
                                        !!$omp end ordered
                                        jmin_z=imin_z

                                        if(lobc)then
                                                if(imin_sz<imin_rz)then 
                                                        jmin_z=imin_rz
                                                        do iz=imin_sz+1,jmin_z;
                                                                pvel=>vel(pgrid%index_xmin:pgrid%index_xmax, pgrid%index_ymin:pgrid%index_ymax,iz-1);
                                                                tmpwfld1_d(:,:,inode)=wfldslice_d(:,:,inode); wfldslice_d(:,:,inode)=0.
                                                                do iv=nref(iz-1),1,-1 !vel. loop   lloyds
                                                                        tmpwfld2_d(:,:,inode) = tmpwfld1_d(:,:,inode); call ssf_oper_fftw(sign, w, vel_ref(iv,iz-1,1), pvel, tmpwfld2_d(:,:,inode) , kx2, ky2, plan_s2dF(inode),plan_s2dI(inode)); 
                                                                        where(pvel>=vel_ref(iv,iz-1,2)); wfldslice_d(:,:,inode) = tmpwfld2_d(:,:,inode)*tape; endwhere
                                                                enddo
                                                                if(wfld_d_out)wfld_out_d(pgrid%index_xmin:pgrid%index_xmax,pgrid%index_ymin:pgrid%index_ymax,iz,iw,1)=wfldslice_d(:,:,inode)
                                                        enddo !end depth
                                                elseif(imin_rz<imin_sz)then
                                                        jmin_z=imin_sz
                                                        do iz=imin_rz+1,jmin_z;
                                                                pvel=>vel(pgrid%index_xmin:pgrid%index_xmax, pgrid%index_ymin:pgrid%index_ymax,iz-1);
                                                                tmpwfld1_u(:,:,inode)=wfldslice_u(:,:,inode); wfldslice_u(:,:,inode)=0.
                                                                do iv=nref(iz-1),1,-1 !vel. loop   lloyds 
                                                                        tmpwfld2_u(:,:,inode) = tmpwfld1_u(:,:,inode); call ssf_oper_fftw(sign, w, vel_ref(iv,iz-1,1), pvel, tmpwfld2_u(:,:,inode) , kx2, ky2, plan_r2dF(inode),plan_r2dI(inode)); 
                                                                        where(pvel>=vel_ref(iv,iz-1,2)); wfldslice_u(:,:,inode) = tmpwfld2_u(:,:,inode)*tape; endwhere
                                                                enddo
                                                                if(wfld_u_out)wfld_out_u(pgrid%index_xmin:pgrid%index_xmax,pgrid%index_ymin:pgrid%index_ymax,iz,iw,1)=wfldslice_u(:,:,inode)
                                                        enddo !end depth
                                                else
                                                        jmin_z=imin_rz
                                                endif 
                                        endif  
                                        do iz=jmin_z+1,pgrid%az%n;   ! depth loop
                                                pvel=>vel(pgrid%index_xmin:pgrid%index_xmax, pgrid%index_ymin:pgrid%index_ymax,iz-1);
                                                tmpwfld1_d(:,:,inode)=wfldslice_d(:,:,inode); wfldslice_d(:,:,inode)=0.
                                                tmpwfld1_u(:,:,inode)=wfldslice_u(:,:,inode); wfldslice_u(:,:,inode)=0.
                                                do iv=nref(iz-1),1,-1 !vel. loop   lloyds 
                                                        tmpwfld2_u(:,:,inode) = tmpwfld1_u(:,:,inode); call ssf_oper_fftw(sign, w, vel_ref(iv,iz-1,1), pvel, tmpwfld2_u(:,:,inode) , kx2, ky2, plan_r2dF(inode),plan_r2dI(inode)); 
                                                        tmpwfld2_d(:,:,inode) = tmpwfld1_d(:,:,inode); call ssf_oper_fftw(sign, w, vel_ref(iv,iz-1,1), pvel, tmpwfld2_d(:,:,inode) , kx2, ky2, plan_s2dF(inode),plan_s2dI(inode)); 
                                                        where(pvel>=vel_ref(iv,iz-1,2)); wfldslice_d(:,:,inode) = tmpwfld2_d(:,:,inode)*tape; wfldslice_u(:,:,inode)= tmpwfld2_u(:,:,inode)*tape; endwhere
                                                enddo
                                                if(iz>=ggrid%index_pro_minz.and.iz<=ggrid%index_pro_maxz)then 
                                                        z_modl = vgrid%az%o + (iz-1)*vgrid%az%d;
                                                        index_z_modl = 1.5 + (z_modl - ogrid%az%o)/ggrid%az_modl%d;  
                                                        greens_r (:,:,index_z_modl,ireal,jwbk)=wfldslice_u(ogrid%index_pro_xmin:ogrid%index_pro_xmax,ogrid%index_pro_ymin:ogrid%index_pro_ymax,inode)
                                                        greens_s (:,:,index_z_modl,ireal,jwbk)=wfldslice_d(ogrid%index_pro_xmin:ogrid%index_pro_xmax,ogrid%index_pro_ymin:ogrid%index_pro_ymax,inode)
                                                endif
                                                if(wfld_d_out)wfld_out_d(pgrid%index_xmin:pgrid%index_xmax,pgrid%index_ymin:pgrid%index_ymax,iz,iw,1)=wfldslice_d(:,:,inode); 
                                                if(wfld_u_out)wfld_out_u(pgrid%index_xmin:pgrid%index_xmax,pgrid%index_ymin:pgrid%index_ymax,iz,iw,1)=wfldslice_u(:,:,inode);
                                        enddo!end depth
                                enddo   !end nreal
                        enddo           !end freq. inner block
!$OMP end parallel do
                        do iz_modl= 1,hgrid%az_modl%n                                   !  z loop
                                z_modl = hgrid%az_modl%o + (iz_modl-1)*hgrid%az_modl%d; index_z_modl = 1.5+(z_modl-ogrid%az%o)/ogrid%az%d;
!$OMP parallel do private(inode, iw, ireal, &
!$OMP        iy_modl,     ix_modl,     ihy_modl,     ihx_modl,     iz_offd,     iy_offd,     ix_offd,     ihy_offd,     ihx_offd, &
!$OMP         y_modl,      x_modl,      hy_modl,      hx_modl,      z_offd,      y_offd,      x_offd,      hy_offd,      hx_offd, &
!$OMP   index_y_modl,index_x_modl,index_hy_modl,index_hx_modl,index_z_offd,index_y_offd,index_x_offd,index_hy_offd,index_hx_offd, &
!$OMP        jy_modl,     jx_modl,     jhy_modl,     jhx_modl,     jz_offd,     jy_offd,     jx_offd,     jhy_offd,     jhx_offd, &
!$OMP       jyd_modl,    jxd_modl,                                             jyd_offd,    jxd_offd,                             &
!$OMP       jyu_modl,    jxu_modl,                                             jyu_offd,    jxu_offd                              , jwbk)  schedule (dynamic,min(1,hgrid%ay_modl%n)) 
                        do iw=iwblk1,iwblk2
                                jwbk=iw-iwblk1+1
                                inode=omp_get_thread_num()+1; 
                                do ireal=1,nreal_hess
                                        do iy_modl= 1,hgrid%ay_modl%n                                   !  y loop
                                                y_modl = hgrid%ay_modl%o + (iy_modl-1)*hgrid%ay_modl%d; index_y_modl = 1.5+(y_modl-ogrid%ay%o)/ogrid%ay%d;
                                        do ix_modl= 1,hgrid%ax_modl%n                                   !  x loop
                                                x_modl = hgrid%ax_modl%o + (ix_modl-1)*hgrid%ax_modl%d; index_x_modl = 1.5+(x_modl-ogrid%ax%o)/ogrid%ax%d;
                                                        do iz_offd=1, hgrid%az_offd%n                   ! zo loop
                                                                z_offd = hgrid%az_offd%o + (iz_offd-1)*hgrid%az_offd%d; jz_offd = nint(z_offd / pgrid%az%d); index_z_offd = index_z_modl + jz_offd; if (index_z_offd < 1 .or. index_z_offd > ogrid%az%n) cycle
                                                        do iy_offd=1, hgrid%ay_offd%n                   ! yo loop 
                                                                y_offd = hgrid%ay_offd%o + (iy_offd-1)*hgrid%ay_offd%d; jy_offd = nint(y_offd / pgrid%ay%d); index_y_offd = index_y_modl + jy_offd; if (index_y_offd < 1 .or. index_y_offd > ogrid%ay%n) cycle
                                                        do ix_offd=1, hgrid%ax_offd%n                   ! xo loop
                                                                x_offd = hgrid%ax_offd%o + (ix_offd-1)*hgrid%ax_offd%d; jx_offd = nint(x_offd / pgrid%ax%d); index_x_offd = index_x_modl + jx_offd; if (index_x_offd < 1 .or. index_x_offd > ogrid%ax%n) cycle
                                                                greens_rec(inode) = greens_r(index_x_modl, index_y_modl, index_z_modl, ireal, jwbk)*conjg(greens_r(index_x_offd, index_y_offd, index_z_offd, ireal, jwbk)) 
                                                                greens_so (inode) = greens_s(index_x_modl, index_y_modl, index_z_modl, ireal, jwbk)*conjg(greens_s(index_x_offd, index_y_offd, index_z_offd, ireal, jwbk))
                                                                hessian3(ix_offd,iy_offd,iz_offd,ix_modl,iy_modl,inode)=&
                                                                hessian3(ix_offd,iy_offd,iz_offd,ix_modl,iy_modl,inode)+real(greens_so(inode)*greens_rec(inode))
                                                        enddo !xoffd
                                                        enddo !yoffd
                                                                !if(inode==1.and.ix_modl==50.and.ireal==1.and.iz_modl<20)write(0,*)index_z_offd,index_z_modl,greens_r(50, 1, index_z_offd, ireal, inode),hessian3(1,1,iz_offd,ix_modl,iy_modl,inode)
                                                        enddo !zoffd
                                        enddo                 !xmodl 
                                        enddo                 !ymodl
                                enddo   !end nreal 
                        enddo           !end freq. inner block
!$OMP end parallel do
                        if(modulo(iz_modl,25)==0)write(0,*)'Writing Hessian....iw,ireal,iz_modl:',iz_modl,sum(hessian3)
                        call hess_io_hess2(sum(hessian3,6),iz_modl, 'rite'); !read...add....write
                        hessian3=0.
                        enddo                 !zmodl 

                enddo !end freq outer block
                if(verb>5)then
                else
                endif
                call mig_array_dealloc3();
                inode=1
                if(verb>6)then
                        call date_and_time(values=time_array_1(:,inode))
                        finish_t1 (inode)= time_array_1 (5,inode) * 3600 + time_array_1 (6,inode) * 60  + time_array_1 (7,inode) + 0.001 * time_array_1 (8,inode)
                        int_t(inode) = finish_t1(inode)-finish_t0(inode)
                        tot_t(inode) = finish_t1(inode)-start_t0(inode)
                        finish_t0(inode) = finish_t1(inode)
                        write(0,'(A14, 3g13.4)')'|Int|Spent|Rem:',int_t(inode)/nodes,tot_t(inode), (tot_t(inode))*(dgrid%asx%n*dgrid%asy%n-tnsx)
                endif


        enddo !end shot y
        enddo !end shot x
        if(.not. inv .and. .not. dot)then
                if(wfld_d_out) call wfd_d_out(wfld_out_d,1)
                if(wfld_u_out) call wfd_u_out(wfld_out_u,1)
        endif
        stat=0;
        if (allocated(hessian1))deallocate(hessian1); 
  end function


end module


