module joint_encode_data_compute_mig
  use joint_encode_utils
  use joint_encode_data_io
  use joint_encode_data_array
  use joint_encode_data_grid
  use adj_mod
  use ssf_mod_ffd
  use ctaper_mod

  implicit none
        complex, allocatable, private   :: spk(:,:,:)
        complex, allocatable, private   :: green_ws (:,:,:,:,:)
        complex, allocatable, private   :: green_w  (:,:,:,:,:,:)
        complex, allocatable, private   :: green_w_s(:,:,:,:,:,:)
        complex, allocatable, private   :: illum_src(:,:,:,:)
  contains
!===========================================================================================================================================================================
  integer function encode_compute2(adj, modl, data, isurv) result(stat)
    logical,intent(in)                    :: adj 
    complex, dimension(dgrid%agx%n, dgrid%agy%n,dgrid%aw%n,dgrid%asx%n,dgrid%asy%n,nodes):: data2
    complex, dimension(dgrid%agx%n, dgrid%agy%n,dgrid%aw%n,dgrid%asx%n,dgrid%asy%n):: data
    real,    dimension(vgrid%ax%n, vgrid%ay%n, vgrid%az%n                         ):: modl
    complex, dimension(:,:,:,:  ),pointer:: dat 
    real,    dimension(:,:,:    ),pointer:: mod
    integer                              :: iiw, iiiw, nb_nw, max_nw, isurv, i, isxd,isyd
    type(axis)                           :: tmp_gx, tmp_gy              


        call omp_set_num_threads(nodes); 
        
        if((.not. inv .or.niter<=2).and.verb>=5)then
                if(      adj)write(0,'(A20,I4,A4)')'Migrating survey: ',isurv,'...'
                if(.not. adj)write(0,'(A20,I4,A4)')' Modeling survey: ',isurv,'...'
        endif
    
        vel=reshape(vel0((isurv-1)*nmod+1:isurv*nmod),(/vgrid%ax%n,vgrid%ay%n,vgrid%az%n/));
        tmp_gx=dgrid%agx !use in case not marine
        tmp_gy=dgrid%agy
         
        icount=0;  
        do isy=1, dgrid%asy%n, encode_nsy;
                sy           =     wgrid%asy%o + (        isy -1) * wgrid%asy%d; 
                sy_end       = min(wgrid%asy%o + (wgrid%asy%n -1) * wgrid%asy%d, sy + (encode_nsy-1)*wgrid%asy%d)
                index_sy     =1.5 + (sy    -vgrid%ay%o)/vgrid%ay%d
                index_sy_end =1.5 + (sy_end-vgrid%ay%o)/vgrid%ay%d
                isyd         = max(1,nint((sy -dgrid%asy%o)/dgrid%asy%d)) 
        do isx=1, dgrid%asx%n, encode_nsx;    ! shot loop encode encode_nsx shots
!        do isx=1, 1, encode_nsx;    ! shot loop encode encode_nsx shots
                sx           =     wgrid%asx%o + (        isx -1) * wgrid%asx%d; 
                sx_end       = min(wgrid%asx%o + (wgrid%asx%n -1) * wgrid%asx%d, sx + (encode_nsx-1)*wgrid%asx%d)
                index_sx     =1.5 + (sx    -vgrid%ax%o)/vgrid%ax%d
                index_sx_end =1.5 + (sx_end-vgrid%ax%o)/vgrid%ax%d
                isxd         = max(1,nint((sx-dgrid%asx%o)/dgrid%asx%d)) 
                
                if (hole.and.(isx>=ih_sx1).and.(isx<=ih_sx2))then; write(0,*)'Hole: isx,index_sx,sx', isx,index_sx,sx; cycle; endif
                if(offset)then
                        dgrid%agx%o=tmp_gx%o+sx
                        dgrid%agy%o=tmp_gy%o+sy
                endif
                !write(0,*) sx,  sx_end, index_sx, index_sx_end, isxd
                !write(0,*) dgrid%agx%o,  dgrid%agy%o
                call mig_pro_grid(index_sx,index_sx_end,index_sy, index_sy_end, pgrid, ogrid); call k2map(pgrid,kx2,ky2);
                call mig_array_alloc3(pgrid,ogrid,nodes)
!                if(isx>1)stop
!                cycle

                call ctaper2d_marine(tape,pgrid,taper_type); !ctaper2d(tape,vgrid,nxpad,nypad,2)
                stat = ssf_init2(vgrid%az%d); 
                
                stat = ssf_ffd_init(sign,kx2, ky2, vgrid%az%d, vgrid%ax%d, vgrid%ay%d)
                if(.not. inv)then;
                        if(verb< 5)write(0 ,'(A7,I4,A20,I5,A1,I5,A6,I5,A1,I5,A5,I5,A9)',advance='yes')'Survey',isurv,'|Shot [isx, isy]:  (', isx ,',' ,isy, ') of (', dgrid%asx%n ,',',dgrid%asy%n,') @ ', nodes, 'nodes'
                        if(verb>=6)write(0 ,'(A7,I4,A20,I5,A1,I5,A6,I5,A1,I5,A5,I5,A9)',advance='yes')'Survey',isurv,'|Shot [isx, isy]:  (', isx ,',' ,isy, ') of (', dgrid%asx%n ,',',dgrid%asy%n,') @ ', nodes, 'nodes'
                endif
                if(adj)then;allocate(model2( vgrid%ax%n, vgrid%ay%n, vgrid%az%n, nodes)); model2=0.;else; allocate(model2( vgrid%ax%n, vgrid%ay%n, vgrid%az%n, 1)); endif
                model2=0.
                data2=0. 
!$OMP parallel do private(iw, inode, w, index_aw, iz, pvel, pwfld, pmod, pdat) schedule (static,dgrid%aw%n/nodes)
                do iw=1, dgrid%aw%n
                        inode=omp_get_thread_num()+1; 
                        w = dgrid%aw%o + (iw-1)*dgrid%aw%d; index_aw=1.5 + (w-dgrid%aw%o)/wgrid%aw%d
                        if(sum(cabs(csou_full(:,:,iw)))==0.) cycle; 
                        wfldslice_d(:,:,inode)=0.; wfldslice_u(:,:,inode)=0.; 
                        if (spike)then; 
                                wfldslice_d(pgrid%index_datpro_sx,pgrid%index_datpro_sy,inode)=1.
                                !wfldslice_d(150,pgrid%index_datpro_sy,inode)=1.
                        else; 
                                if(encode)then
                                        wfldslice_d(pgrid%index_datpro_sx:pgrid%index_datpro_sx_end,pgrid%index_datpro_sy:pgrid%index_datpro_sy_end,inode)=& 
                                              gscd0(             index_sx:index_sx_end,                          index_sy:index_sy_end,imin_z,iw,isxd,isyd,isurv) 
                                else
                                        wfldslice_d(pgrid%index_datpro_sx,pgrid%index_datpro_sy,inode)=csou0(isx,isy,iw,1);
                                endif    
                        endif
                        if (adj)then !migration
                                wfldslice_u(pgrid%index_datpro_gxmin:pgrid%index_datpro_gxmax,pgrid%index_datpro_gymin:pgrid%index_datpro_gymax,inode)=data(:,:,iw,isx,isy);
                                if(wfld_d_out)wfld_out_d(:,:,1,iw,1)=(wfldslice_d(:,:,inode)); if(wfld_u_out)wfld_out_u(:,:,1,iw,1)=(wfldslice_u(:,:,inode))
                                if(lobc)then
                                        if(imin_sz>imin_rz)then
                                                imin_z=imin_rz
                                                do iz=imin_sz+1,imin_z;
                                                        pvel=>vel(pgrid%index_xmin:pgrid%index_xmax, pgrid%index_ymin:pgrid%index_ymax,iz);nullify(pwfld,pwfld2) 
                                                        pwfld =>wfldslice_d(:,:,inode); stat = ssf_ffd_oper(T, sign, w, minval(pvel), pvel, pwfld , kx2, ky2); wfldslice_d(:,:,inode) = wfldslice_d(:,:,inode)*tape; 
                                                enddo !end depth
                                        elseif(imin_rz<imin_sz)then
                                                imin_z=imin_sz
                                                do iz=imin_rz+1,imin_z;
                                                        pvel=>vel(pgrid%index_xmin:pgrid%index_xmax, pgrid%index_ymin:pgrid%index_ymax,iz);nullify(pwfld,pwfld2) 
                                                        pwfld =>wfldslice_u(:,:,inode); stat = ssf_ffd_oper(T,-sign, w, minval(pvel), pvel, pwfld , kx2, ky2); wfldslice_u(:,:,inode) = wfldslice_u(:,:,inode)*tape; 
                                                enddo !end depth
                                        else
                                        endif
                                endif
                                do iz=imin_z+1,pgrid%az%n;   ! depth loop
                                        pvel=>vel(pgrid%index_xmin:pgrid%index_xmax, pgrid%index_ymin:pgrid%index_ymax,iz);nullify(pwfld,pwfld2) 
                                        pwfld =>wfldslice_d(:,:,inode); stat = ssf_ffd_oper(T, sign, w, minval(pvel), pvel, pwfld , kx2, ky2); wfldslice_d(:,:,inode) = wfldslice_d(:,:,inode)*tape; 
                                        pwfld =>wfldslice_u(:,:,inode); stat = ssf_ffd_oper(T,-sign, w, minval(pvel), pvel, pwfld , kx2, ky2); wfldslice_u(:,:,inode) = wfldslice_u(:,:,inode)*tape; 
!                                write(0,*)iz,sum(wfldslice_d),sum(wfldslice_u)!size(wfldslice_d,1),size(wfldslice_d,2),size(wfldslice_d,3)
!                                write(0,*)pgrid%index_datpro_sx,pgrid%index_datpro_sy
!                                write(0,*)size(wfldslice_d,1),size(wfldslice_d,2),size(wfldslice_d,3)
!                                write(0,*)size(wfldslice_u,1),size(wfldslice_u,2),size(wfldslice_u,3)
                                        !src_illums(:,:,iz,inode)=src_illums(:,:,iz,inode)+wfldslice_d(:,:,inode)*conjg(wfldslice_d(:,:,inode))
                                        model2(ogrid%index_img_xmin:ogrid%index_img_xmax,ogrid%index_img_ymin:ogrid%index_img_ymax,iz,inode)=&
                                        model2(ogrid%index_img_xmin:ogrid%index_img_xmax,ogrid%index_img_ymin:ogrid%index_img_ymax,iz,inode)+wfldslice_u(:,:,inode)*conjg(wfldslice_d(:,:,inode));
                                        if(wfld_d_out)wfld_out_d(:,:,iz,iw,1)=wfldslice_d(:,:,inode); if(wfld_u_out)wfld_out_u(:,:,iz,iw,1)=wfldslice_u(:,:,inode)
                                enddo !end depth
                                if(verb>6)write(0,'(A8,I5,2X,A13,I5,2x,A13,E15.4,2x,3F15.4,3X,(6E15.4),A2,E15.4)')'isurv',isurv,'Adding freq:', iw, 'sum modl:',sum(model2(:,:,:,inode)),w,csou0(isx,isy,iw,isurv),sum(data(:,:,iw,isx,isy)),sum(wfldslice_d(:,:,inode)), sum(wfldslice_u(:,:,inode)),'|',sum(pvel); 
                        else    !demigration
                                if(wfld_d_out)wfld_out_d(:,:,1,iw,1)=wfldslice_d(:,:,inode);
                                if(lobc)imin_z=imin_sz
                                do iz=imin_z+1,pgrid%az%n;   ! depth loop
                                        pvel=>vel(pgrid%index_xmin:pgrid%index_xmax, pgrid%index_ymin:pgrid%index_ymax,iz); 
                                        pwfld=>wfldslice_d(:,:,inode); stat = ssf_ffd_oper(T, +1, w, minval(pvel), pvel, pwfld, kx2, ky2); wfldslice_d(:,:,inode) = wfldslice_d(:,:,inode)*tape; 
                                        wfldfull_d(:,:,iz,inode)=wfldslice_d(:,:,inode);
                                        if(wfld_d_out)wfld_out_d(:,:,iz,iw,1)=wfldslice_d(:,:,inode)
                                enddo !end depth
                                wfldslice_u(pgrid%index_datpro_gxmin:pgrid%index_datpro_gxmax,pgrid%index_datpro_gymin:pgrid%index_datpro_gymax,inode)=wfldfull_d(:,:,pgrid%az%n,inode)*modl(:,:,pgrid%az%n);;
                                
                                do iz=pgrid%az%n-1,imin_z,-1;   !depth loop
                                        pvel=>vel(pgrid%index_xmin:pgrid%index_xmax, pgrid%index_ymin:pgrid%index_ymax,iz); 
                                        pwfld=>wfldslice_u(:,:,inode); stat = ssf_ffd_oper(T, +1, w, minval(pvel), pvel, pwfld, kx2, ky2); wfldslice_u(:,:,inode) = wfldslice_u(:,:,inode)*tape
                                        wfldslice_u(:,:,inode)=wfldslice_u(:,:,inode)+wfldfull_d(:,:,iz,inode)*modl(:,:,iz);
                                        if(wfld_u_out)wfld_out_u(:,:,iz,iw,1)=(wfldslice_u(:,:,inode))
                                enddo !end depth
                                if(lobc)then
                                        if(imin_rz<imin_z)then
                                                do iz=imin_z,imin_z,-1;   !depth loop
                                                        pvel=>vel(pgrid%index_xmin:pgrid%index_xmax, pgrid%index_ymin:pgrid%index_ymax,iz); 
                                                        pwfld=>wfldslice_u(:,:,inode); stat = ssf_ffd_oper(T, +1, w, minval(pvel), pvel, pwfld, kx2, ky2); wfldslice_u(:,:,inode) = wfldslice_u(:,:,inode)*tape
                                                        if(wfld_u_out)wfld_out_u(:,:,iz,iw,1)=(wfldslice_u(:,:,inode))
                                                enddo !end depth
                                        endif
                                endif
                                data2(:,:,index_aw,isx,isy,inode)=data2(:,:,index_aw,isx,isy,inode)+wfldslice_u(:,:,inode);
                                if(verb>6)write(0,'(A13,I5,2x,E12.5,2x,A13,2(E15.4,2x))')'Adding freq:', iw, cabs(csou0(isx,isy,iw,isurv)), 'sum data:',sum(data2(:,:,index_aw,isx,isy,inode)); 
                        endif
                enddo           !end freq.
!$OMP end parallel do
                if(adj)then
                        !write(0,*)size(modl,1),size(modl,2),size(modl,3)
                        modl=modl+sum(model2,4)  
                        if(inv)then
                                if(verb>5)write(*,'(A13,2I5,2x,A13,E15.4,2x,A13,E15.4)')'|Adding shot:', isx,isy, 'cumm-mig:', sum(modl), 'mig:',sum(sum(model2,4))
                                call sep_write(modl,mig_)
                        else
                                if(verb>5)then
                                        write(*,'(A13,2I5,2x,A13,E15.4,2x,A13,E15.4)')'|Adding shot:', isx,isy, 'cumm-mig:', sum(modl), 'mig:',sum(sum(model2,4)) 
                                else
                                endif
                                do  iz=1,ogrid%az%n;  
                                do  iy=1,ogrid%ay%n;  
                                do  ix=1,ogrid%ax%n;  
                                       mig(1,1,ix+ogrid%index_img_xmin-1,iy+ogrid%index_img_ymin-1,iz) = & 
                                       mig(1,1,ix+ogrid%index_img_xmin-1,iy+ogrid%index_img_ymin-1,iz) + modl(ix,iy,iz); 
                                enddo
                                enddo
                                enddo
                                call mig_io2(modl,isurv);
                        endif
                else
                        data=data+sum(data2,6)
                        if(inv)then
                                if(verb>5)write(*,'(A13,2I5,2x,A13,2(E15.4,2X))')'|Saving shot:', isx,isy, ' ===== ', sum(data)
                        else
                                !write(0,*)
                        endif
                endif
                call mig_array_dealloc3(); deallocate(model2)
        enddo !end shot y 
        enddo !end shot x 
        if(.not. inv .and. .not. dot)then
!               if(wfld_d_out) call wfld_out(wfld_out_d,wfld_d_);
!               if(wfld_u_out) call wfld_out(wfld_out_u,wfld_u_);
                if(wfld_d_out) call wfd_d_out(wfld_out_d,isurv)
                if(wfld_u_out) call wfd_u_out(wfld_out_u,isurv)
        endif
        stat=0;
  end function


end module


