module joint_encode_data_compute_mig_hx_back
  use joint_encode_utils
  use joint_encode_data_io
  use joint_encode_data_array
  use joint_encode_data_grid
  use adj_mod
  use ssf_mod_ffd
  use ctaper_mod

  implicit none
        complex, allocatable, private   :: spk(:,:,:)
        complex, allocatable, private   :: green_ws (:,:,:,:,:)
        complex, allocatable, private   :: green_w  (:,:,:,:,:,:)
        complex, allocatable, private   :: green_w_s(:,:,:,:,:,:)
        complex, allocatable, private   :: illum_src(:,:,:,:)
  contains
!===========================================================================================================================================================================
  integer function encode_compute_hx(adj, modl, isurv) result(stat)
    logical,intent(in)                         :: adj 
    complex, dimension(:,:,:,:,:,:),allocatable:: data2
    complex, dimension(dgrid%agx%n, dgrid%agy%n,dgrid%aw%n):: dat 
    complex, dimension(:,:,:,:,:,:),allocatable::tmodl 
    real,    dimension(igrid%ahx%n,igrid%ahy%n,vgrid%ax%n, vgrid%ay%n, vgrid%az%n       ):: modl
    integer                              :: iiw, iiiw, nb_nw, max_nw, isurv, i, isxd,isyd
    type(axis)                           :: tmp_gx, tmp_gy              
    integer             :: ix,iy,iz
    integer             :: ixd,iyd
    integer             :: ixu,iyu
    integer             :: jxd,jyd
    integer             :: jxu,jyu
    integer             :: ihx,ihy
    integer             :: jhx,jhy
    real                :: hx,hy
    integer             :: ixhole
    integer             :: icycle
    integer             :: jgx,jgy
    real                :: start_time(nodes), finish_time(nodes), start_t(nodes), finish_t(nodes), start_t0(nodes), finish_t0(nodes), start_t1(nodes), finish_t1(nodes), tot_t(nodes), int_t(nodes)
    integer             :: time_array_0(8,nodes), time_array_1(8,nodes), time_array_3(8,nodes), time_array_4(8,nodes), time_array_5(8,nodes), time_array_6(8,nodes)

        call omp_set_num_threads(nodes); 
        
        if((.not. inv .or.niter<=2).and.verb>=5)then
                if(      adj)write(0,'(A20,I4,A4)')'Migrating survey: ',isurv,'...'
                if(.not. adj)write(0,'(A20,I4,A4)')' Modeling survey: ',isurv,'...'
        endif
        if(allocated(tmodl))deallocate(tmodl);allocate(tmodl(igrid%ahx%n,igrid%ahy%n,vgrid%ax%n, vgrid%ay%n, vgrid%az%n, nodes))
    
        vel=reshape(vel0((isurv-1)*nmod+1:isurv*nmod),(/vgrid%ax%n,vgrid%ay%n,vgrid%az%n/));
        tmp_gx=dgrid%agx !use in case not marine
        tmp_gy=dgrid%agy
         
        icount=0;  
        do isy=1, dgrid%asy%n, encode_nsy;
                sy           =     wgrid%asy%o + (        isy -1) * wgrid%asy%d; 
                sy_end       = min(wgrid%asy%o + (wgrid%asy%n -1) * wgrid%asy%d, sy + (encode_nsy-1)*wgrid%asy%d)
                index_sy     =1.5 + (sy    -vgrid%ay%o)/vgrid%ay%d
                index_sy_end =1.5 + (sy_end-vgrid%ay%o)/vgrid%ay%d
                isyd         = max(1,nint((sy -dgrid%asy%o)/dgrid%asy%d)) 
        do isx=1, dgrid%asx%n, encode_nsx;    ! shot loop encode encode_nsx shots
!        do isx=1, 1, encode_nsx;    ! shot loop encode encode_nsx shots
                sx           =     wgrid%asx%o + (        isx -1) * wgrid%asx%d; 
                sx_end       = min(wgrid%asx%o + (wgrid%asx%n -1) * wgrid%asx%d, sx + (encode_nsx-1)*wgrid%asx%d)
                index_sx     =1.5 + (sx    -vgrid%ax%o)/vgrid%ax%d
                index_sx_end =1.5 + (sx_end-vgrid%ax%o)/vgrid%ax%d 
                isxd         = max(1,nint((sx-dgrid%asx%o)/dgrid%asx%d)) 
                
!                if (hole.and.(isx>=ih_sx1).and.(isx<=ih_sx2))then; write(0,*)'Hole: isx,index_sx,sx', isx,index_sx,sx; cycle; endif
                
                call data_read("reed", dat, isx, isy, isurv)
                icycle=0
                if(hole)then
                        do ixhole=1,nxhole
                                if (hole.and.(isx>=ihh_sx1(ixhole)).and.(isx<=ihh_sx2(ixhole)))then; write(0,*)'Hole: isx,index_sx,sx', isx,index_sx,sx; icycle=1; endif
                        enddo
                endif                   
                if(icycle==1)cycle
                if(offset)then
                        dgrid%agx%o=tmp_gx%o+sx
                        dgrid%agy%o=tmp_gy%o+sy
                endif
                !write(0,*) dgrid%agx%o,  dgrid%agy%o
                call mig_pro_grid(index_sx,index_sx_end,index_sy, index_sy_end, pgrid, ogrid); call k2map(pgrid,kx2,ky2);
                call mig_array_alloc3(pgrid,ogrid,nodes)
!                if(isx>1)stop
!                cycle

                !call ctaper2d_marine(tape,pgrid,taper_type); !ctaper2d(tape,vgrid,nxpad,nypad,2)
                call circular_taper(wfldslice_d(:,:,1),tape)
                stat = ssf_init2(vgrid%az%d); 
                if(ffd)stat = ssf_ffd_init(sign,kx2, ky2, vgrid%az%d, vgrid%ax%d, vgrid%ay%d)
                
!                write(0,*) sx,  sx_end, index_sx, index_sx_end, isxd
                if(allocated(nref))deallocate(nref);allocate(nref(vgrid%az%n));nref=0.
                do iz=1,vgrid%az%n
                        do iv=1,vnum; if(vel_ref(iv,iz,1)>1e-05)then; nref(iz)=nref(iz)+1; else; exit; endif; enddo
                enddo
                if(.not. inv)then;
                        if(verb<= 6)write(0 ,'(A7,I4,A20,I5,A1,I5,A6,I5,A1,I5,A5,I5,A9)',advance='yes')'Survey',isurv,'|Shot [isx, isy]:  (', isx ,',' ,isy, ') of (', dgrid%asx%n ,',',dgrid%asy%n,') @ ', nodes, 'nodes'
                        if(verb > 6)write(0 ,'(A7,I4,A20,I5,A1,I5,A6,I5,A1,I5,A5,I5,A9)',advance='yes')'Survey',isurv,'|Shot [isx, isy]:  (', isx ,',' ,isy, ') of (', dgrid%asx%n ,',',dgrid%asy%n,') @ ', nodes, 'nodes'
                        if(verb>6)then
                                write(0,'(2(A14,g12.4),3(A14,I10))')'|sx:',sx,'|sx_end:',sx_end,'|index_sx:',index_sx,'|index_sx_end:',index_sx_end,'|isxd:',isxd
                                write(0,'(2(A14,g12.4),3(A14,I10))')'|sy:',sy,'|sy_end:',sy_end,'|index_sy:',index_sy,'|index_sy_end:',index_sy_end,'|isyd:',isyd
                        endif
                endif
                tmodl=0.
                jgy=int(dgrid%agy%d/pgrid%ay%d)
                jgx=int(dgrid%agx%d/pgrid%ax%d)
                
                do inode=1,nodes
                        call date_and_time(values=time_array_0(:,inode))
                        start_t0 (inode) = time_array_0 (5,inode) * 3600 + time_array_0 (6,inode) * 60  + time_array_0 (7,inode) + 0.001 * time_array_0 (8,inode)
                        finish_t0(inode) = time_array_0 (5,inode) * 3600 + time_array_0 (6,inode) * 60  + time_array_0 (7,inode) + 0.001 * time_array_0 (8,inode)
                enddo

!$OMP parallel do private(iw, inode, w, index_aw, pvel, pwfld, pmod, pdat, & 
!$OMP                           iz, iy, ix,     &
!$OMP                           ihy, ihx,   &
!$OMP                           hx, hy,   &
!$OMP                           iv,   & 
!$OMP                           tmp_wfld1_d, tmp_wfld1_u,   &
!$OMP                           tmp_wfld2_d, tmp_wfld2_u,   &
!$OMP                           index_gx, index_gy,   &
!$OMP                           igx, igy,   &
!$OMP                           jhx, jhy,   &
!$OMP                           iyd, ixd,       &
!$OMP                           jyd, jxd,       &
!$OMP                           jyu, jxu,       &
!$OMP                           iyu, ixu )  schedule (dynamic,min(1,dgrid%aw%n))
                do iw=1, dgrid%aw%n, jw 
                        inode=omp_get_thread_num()+1; 
                        w = dgrid%aw%o + (iw-1)*dgrid%aw%d; index_aw=1.5 + (w-dgrid%aw%o)/wgrid%aw%d
                        if(sum(cabs(csou_full(:,:,iw  )))==0.) cycle; 
                        if(sum(cabs(      dat(:,:,iw  )))==0.) cycle;

                        wfldslice_d(:,:,inode)=0.; wfldslice_u(:,:,inode)=0.;  
                        if (spike)then; 
                                wfldslice_d(pgrid%index_datpro_sx,pgrid%index_datpro_sy,inode)=1.
                                !wfldslice_d(150,pgrid%index_datpro_sy,inode)=1.
                        else; 
                                if(encode)then
                                        wfldslice_d(pgrid%index_datpro_sx:pgrid%index_datpro_sx_end,pgrid%index_datpro_sy:pgrid%index_datpro_sy_end,inode)=& 
                                              gscd0(             index_sx:index_sx_end,                          index_sy:index_sy_end,imin_z,iw,isxd,isyd,isurv) 
                                else
                                        wfldslice_d(pgrid%index_datpro_sx,pgrid%index_datpro_sy,inode)=csou0(isx,isy,iw,1);
                                endif
                        endif
                        if (adj)then !migration
                                if(dgrid%agy%d/pgrid%ay%d/=1.)then
                                        do igy=1,dgrid%agy%n
                                                index_gy=min((igy-1)*jgy+pgrid%index_datpro_gymin,pgrid%index_datpro_gymax)
                                        do igx=1,dgrid%agx%n
                                                index_gx=min((igx-1)*jgx+pgrid%index_datpro_gxmin,pgrid%index_datpro_gxmax)
                                                wfldslice_u(index_gx,index_gy,inode)=dat(igx,igy,iw);
                                        enddo
                                        enddo
                                else
                                        wfldslice_u(pgrid%index_datpro_gxmin:pgrid%index_datpro_gxmax,pgrid%index_datpro_gymin:pgrid%index_datpro_gymax,inode)=dat(:,:,iw);
                                endif
                                if(wfld_d_out)wfld_out_d(:,:,1,iw,1)=(wfldslice_d(:,:,inode)); if(wfld_u_out)wfld_out_u(:,:,1,iw,1)=(wfldslice_u(:,:,inode))
                                pvel=>vel(pgrid%index_xmin:pgrid%index_xmax, pgrid%index_ymin:pgrid%index_ymax,1);
                                if(lobc)then
                                        if(imin_sz<imin_rz)then
                                                imin_z=imin_rz
                                                do iz=imin_sz+1,imin_z;
                                                        pvel=>vel(pgrid%index_xmin:pgrid%index_xmax, pgrid%index_ymin:pgrid%index_ymax,iz-1);
                                                        tmpwfld1_d(:,:,inode)=wfldslice_d(:,:,inode); wfldslice_d(:,:,inode)=0.
                                                        do iv=nref(iz-1),1,-1 !vel. loop   lloyds
                                                                tmpwfld2_d(:,:,inode) = tmpwfld1_d(:,:,inode); call ssf_oper3(T,sign, w, vel_ref(iv,iz-1,1), pvel, tmpwfld2_d(:,:,inode) , kx2, ky2); 
                                                                where(pvel>=vel_ref(iv,iz-1,2)); wfldslice_d(:,:,inode) = tmpwfld2_d(:,:,inode)*tape; endwhere
                                                        enddo
                                                enddo !end depth
                                        elseif(imin_rz<imin_sz)then
                                                imin_z=imin_sz
                                                do iz=imin_rz+1,imin_z;
                                                        pvel=>vel(pgrid%index_xmin:pgrid%index_xmax, pgrid%index_ymin:pgrid%index_ymax,iz-1);
                                                        tmpwfld1_u(:,:,inode)=wfldslice_u(:,:,inode); wfldslice_u(:,:,inode)=0.
                                                        do iv=nref(iz-1),1,-1 !vel. loop   lloyds 
                                                                tmpwfld2_u(:,:,inode) = tmpwfld1_u(:,:,inode); call ssf_oper3(T,-sign, w, vel_ref(iv,iz-1,1), pvel, tmpwfld2_u(:,:,inode) , kx2, ky2);
                                                                where(pvel>=vel_ref(iv,iz-1,2)); wfldslice_u(:,:,inode) = tmpwfld2_u(:,:,inode)*tape; endwhere
                                                        enddo
                                                enddo !end depth
                                        else
                                                imin_z=imin_rz
                                        endif
                                endif
                                if(ogrid%ahy%n==1.and.ogrid%ahx%n==1)then
                                        do iz=imin_z+1,pgrid%az%n;   ! depth loop
                                                pvel=>vel(pgrid%index_xmin:pgrid%index_xmax, pgrid%index_ymin:pgrid%index_ymax,iz-1);
                                                tmpwfld1_d(:,:,inode)=wfldslice_d(:,:,inode); wfldslice_d(:,:,inode)=0.
                                                tmpwfld1_u(:,:,inode)=wfldslice_u(:,:,inode); wfldslice_u(:,:,inode)=0.
                                                do iv=nref(iz-1),1,-1 !vel. loop   lloyds
                                                        tmpwfld2_u(:,:,inode) = tmpwfld1_u(:,:,inode); call ssf_oper3(T,-sign, w, vel_ref(iv,iz-1,1), pvel, tmpwfld2_u(:,:,inode) , kx2, ky2);
                                                        tmpwfld2_d(:,:,inode) = tmpwfld1_d(:,:,inode); call ssf_oper3(T, sign, w, vel_ref(iv,iz-1,1), pvel, tmpwfld2_d(:,:,inode) , kx2, ky2); 
                                                        where(pvel>=vel_ref(iv,iz-1,2)); wfldslice_d(:,:,inode) = tmpwfld2_d(:,:,inode)*tape; wfldslice_u(:,:,inode)= tmpwfld2_u(:,:,inode)*tape; endwhere
                                                enddo
!                                                tmodl(1,1,ogrid%index_img_xmin:ogrid%index_img_xmax,ogrid%index_img_ymin:ogrid%index_img_ymax,iz,inode)=&
!                                                tmodl(1,1,ogrid%index_img_xmin:ogrid%index_img_xmax,ogrid%index_img_ymin:ogrid%index_img_ymax,iz,inode)+(wfldslice_u(ogrid%index_pro_xmin:ogrid%index_pro_xmax,ogrid%index_pro_ymin:ogrid%index_pro_ymax,inode)&
!                                                                                                                                                  *conjg(wfldslice_d(ogrid%index_pro_xmin:ogrid%index_pro_xmax,ogrid%index_pro_ymin:ogrid%index_pro_ymax,inode)));
                                                do  iy=1,ogrid%ay%n;!xline
                                                                iyd = (iy + ogrid%index_pro_ymin-1);
                                                                jyd = ogrid%index_img_ymin+iy-1
                                                do  ix=1,ogrid%ax%n;!inline
                                                                ixd = (ix + ogrid%index_pro_xmin-1);
                                                                jxd = ogrid%index_img_xmin+ix-1
                                                                tmodl(1,1,jxd,jyd,iz,inode)=&
                                                                tmodl(1,1,jxd,jyd,iz,inode)+(wfldslice_u(ixd,iyd,inode)*conjg(wfldslice_d(ixd,iyd,inode)));
                                                enddo!end inline
                                                enddo!end xline
                                        enddo!end depth
                                else
                                        do iz=imin_z+1,pgrid%az%n;   ! depth loop
                                                pvel=>vel(pgrid%index_xmin:pgrid%index_xmax, pgrid%index_ymin:pgrid%index_ymax,iz-1);
                                                tmpwfld1_d(:,:,inode)=wfldslice_d(:,:,inode); wfldslice_d(:,:,inode)=0.
                                                tmpwfld1_u(:,:,inode)=wfldslice_u(:,:,inode); wfldslice_u(:,:,inode)=0.
                                                do iv=nref(iz-1),1,-1 !vel. loop   lloyds 
                                                        tmpwfld2_u(:,:,inode) = tmpwfld1_u(:,:,inode); call ssf_oper3(T,-sign, w, vel_ref(iv,iz-1,1), pvel, tmpwfld2_u(:,:,inode) , kx2, ky2);
                                                        tmpwfld2_d(:,:,inode) = tmpwfld1_d(:,:,inode); call ssf_oper3(T, sign, w, vel_ref(iv,iz-1,1), pvel, tmpwfld2_d(:,:,inode) , kx2, ky2); 
                                                        where(pvel>=vel_ref(iv,iz-1,2)); wfldslice_d(:,:,inode) = tmpwfld2_d(:,:,inode)*tape; wfldslice_u(:,:,inode)= tmpwfld2_u(:,:,inode)*tape; endwhere
                                                enddo
                                                do  iy=1,ogrid%ay%n;!xline
                                                do  ix=1,ogrid%ax%n;!inline
                                                        do ihy=1,ogrid%ahy%n;
                                                                hy=ogrid%ahy%o + (ihy-1)*ogrid%ahy%d; jhy = nint(hy/pgrid%ay%d)
                                                                iyd = (iy + ogrid%index_pro_ymin-1)-jhy; iyu = (iy + ogrid%index_pro_ymin-1)+jhy; if (iyd < 1 .or. iyd > pgrid%ay%n .or. iyu < 1 .or. iyu > pgrid%ay%n ) cycle
                                                        do ihx=1,ogrid%ahx%n;
                                                                hx=ogrid%ahx%o + (ihx-1)*ogrid%ahx%d; jhx = nint(hx/pgrid%ax%d)
                                                                ixd = (ix + ogrid%index_pro_xmin-1)-jhx; ixu = (ix + ogrid%index_pro_xmin-1)+jhx; if (ixd < 1 .or. ixd > pgrid%ax%n .or. ixu < 1 .or. ixu > pgrid%ax%n ) cycle
                                                                tmodl(ihx,ihy,ogrid%index_img_xmin+ix-1,ogrid%index_img_ymin+iy-1,iz,inode)=&
                                                                tmodl(ihx,ihy,ogrid%index_img_xmin+ix-1,ogrid%index_img_ymin+iy-1,iz,inode)+(wfldslice_u(ixu,iyu,inode)*conjg(wfldslice_d(ixd,iyd,inode)));
                                                        enddo
                                                        enddo
                                                enddo!end inline
                                                enddo!end xline
                                        enddo!end depth
                                endif
!                        if(verb>5)then; if(modulo(iw,dgrid%aw%n*5/10)==0) write(0,'(A10,I5,A4,I5,A10,I5,A35,3g13.4)')'start iw: ', iw, 'of ',dgrid%aw%n  ,' @ inode: ', inode, ' | Time: Interv | Spent | Remain:',int_t(inode),tot_t(inode), int_t(inode)*(dgrid%aw%n-iw)/nodes; endif
                                if(verb>6)then
                                        call date_and_time(values=time_array_1(:,inode))
                                        finish_t1 (inode)= time_array_1 (5,inode) * 3600 + time_array_1 (6,inode) * 60  + time_array_1 (7,inode) + 0.001 * time_array_1 (8,inode)
                                        int_t(inode) = finish_t1(inode)-finish_t0(inode)
                                        tot_t(inode) = finish_t1(inode)-start_t0(inode)
                                        finish_t0(inode) = finish_t1(inode)
                                        write(0,'(A4,I5,1X, A13,I5,F12.4,2x)',advance="no") 'isurv',isurv,'Adding freq:', iw, w
                                        write(0,'(A12,2g15.4,1x)' ,advance="no")'| sum modl:',sum(tmodl(:,:,:,:,:,:))
                                        write(0,'(A12,2g15.4,1x)' ,advance="no")'| sum dat:' ,sum(  dat(:,:,iw))
                                        write(0,'(A8, 2g15.4,1x)',advance="no")'| csou:',csou0(isx,isy,iw,isurv)
                                        write(0,'(A5, 2g15.4,1x)',advance="no")'|dwn:',sum(wfldslice_d(:,:,inode))
                                        write(0,'(A5, 2g15.4,1x)',advance="no")'|up:',sum(wfldslice_u(:,:,inode))
                                        write(0,'(A5 ,  g15.4,A4,I5)',advance="no")'|',sum(pvel),' at ',inode 
                                        write(0,'(A9,  g4.1)',advance="no")'|hx/hy==1',(ogrid%ahy%n==1.and.ogrid%ahx%n==1);
                                        write(0,'(A14, 3g13.4)')'|Int|Spent|Rem:',int_t(inode),tot_t(inode), (tot_t(inode)/iw)*(dgrid%aw%n-iw)
                                endif
                        else    !demigration !!!pspi version not implemented
                        endif
                enddo           !end freq.
!$OMP end parallel do
                if(adj)then 
                       modl=modl+sum(tmodl,6)
                        if(inv)then
                                if(verb>5)write(*,'(A13,2I5,2x,A13,E15.4,2x,A13,E15.4)')'|Adding shot:', isx,isy, 'cumm-mig:', sum(modl), 'mig:',sum(sum(tmodl,6))
                                call sep_write(modl,mig_)
                        else
                                if(verb>5)then
                                        write(*,'(A13,2I5,2x,A13,E15.4,2x,A13,E15.4)')'|Adding shot:', isx,isy, 'cumm-mig:', sum(modl), 'mig:',sum(sum(tmodl,6)) 
                                else
                                endif
                                call mig_io_hx(modl,isurv);
                        endif
                endif
                call mig_array_dealloc3();tmodl=0.
        enddo !end shot y 
        enddo !end shot x 
        if(allocated(tmodl))deallocate(tmodl)
        if(.not. inv .and. .not. dot)then
!               if(wfld_d_out) call wfld_out(wfld_out_d,wfld_d_);
!               if(wfld_u_out) call wfld_out(wfld_out_u,wfld_u_);
                if(wfld_d_out) call wfd_d_out(wfld_out_d,isurv)
                if(wfld_u_out) call wfd_u_out(wfld_out_u,isurv)
        endif
        stat=0;
  end function


end module


