module joint_encode_data_compute_mod
  use joint_encode_params
  use joint_encode_data_io
  use joint_encode_adjnull
  use myfft_mod
  use adj_mod

  implicit none
        complex, allocatable, private   :: spk(:,:,:)
        complex, allocatable, private   :: green_ws (:,:,:,:,:)
        complex, allocatable, private   :: green_w  (:,:,:,:,:,:)
        complex, allocatable, private   :: green_w_s(:,:,:,:,:,:)
  contains
!===========================================================================================================================================================================
!#######
  integer function encode_compute_init1(nodes) result(stat)
    integer :: nodes
        stat = 1
            if(allocated(green_ws     )) deallocate(green_ws ); allocate(green_ws (ggrid%ax_surf%n, ggrid%ay_surf%n, ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n))
            if(allocated(green_w      )) deallocate(green_w  ); allocate(green_w  (ggrid%ax_surf%n, ggrid%ay_surf%n, ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n, nodes))
            if(small)then
                    if(allocated(green_w_s)) deallocate(green_w_s); allocate(green_w_s(dgrid%asx%n    , dgrid%asy%n    , ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n, ggrid%aw%n))
            else
                    if(allocated(green_w_s)) deallocate(green_w_s); allocate(green_w_s(dgrid%asx%n    , dgrid%asy%n    , ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n, nodes))
            endif
            if(allocated(spk    )) deallocate(spk    ); allocate(spk(size(csou_full,1),size(csou_full,2), nodes))
        stat = 0
  end function
!#######
  integer function encode_compute_init(iwd_in,inode) result(stat)
    integer :: iwd_in
    integer :: inode
        stat = 1
            call data_io_greens(green_ws, iwd_in); 
            green_w(:,:,:,:,:,inode)=green_ws 
            spk(:,:,inode)   = csou_full(:,:,iwd_in); 
        stat = 0
  end function
!#######
  integer function encode_compute_init_s(isurv) result(stat)
    integer :: isurv
        stat = 1
        if(small)then
            if(isurv==1)green_w_s=gscd1;if(isurv==2)green_w_s=gscd2; if(isurv==3)green_w_s=gscd3; if(isurv==4)green_w_s=gscd4; if(isurv==5)green_w_s=gscd5; if(isurv==6)green_w_s=gscd6
        else
            if(isurv==1)green_w_s=gscd1;if(isurv==2)green_w_s=gscd2; if(isurv==3)green_w_s=gscd3; if(isurv==4)green_w_s=gscd4; if(isurv==5)green_w_s=gscd5; if(isurv==6)green_w_s=gscd6
        endif
       stat = 0
  end function
!#######
  integer function encode_compute_init_blk(iiw, max_nw,isurv) result(stat)
    integer :: iiw,max_nw,isurv
        stat = 1
        call data_io_greens_blk(green_w,iiw,max_nw);
        spk=0.; spk(:,:,1:max_nw-iiw+1)=csou0(:,:,iiw:max_nw,isurv);
       stat = 0
  end function
!#######
subroutine encode_compute_data(adj, modl, data, inode, iwd, iwd2, isurv)
    logical                       :: adj,  add
    real,    dimension(:, :, :   ),pointer:: modl
    complex, dimension(:, :, :, :),pointer:: data
    integer :: inode, iwd, iwd2, isurv
     call encode_compute_data_lop(adj, modl, data, inode, iwd, iwd2, isurv)
end subroutine
!#######
! compute data from all model points for all shots and receivers encoded 
  subroutine encode_compute_data_lop(adj, modl, data, inode,iwd,iwd2,isurv)
    logical                             :: adj,  add
    real, dimension(:,:,:),pointer      :: modl
    complex, dimension(:,:,:,:),pointer :: data
        integer                         ::  iszd,  isxd, isyd
        integer                         ::  igzd,  igxd, igyd
        integer                         :: iiszd, iisxd, iisyd
        integer                         :: iigzd, iigxd, iigyd
        integer                         ::  ijzd,  ijxd, ijyd
        integer                         ::   jzd,   jxd,  jyd 
        real                            ::    zd,    xd, yd  
        real                            :: sxd , syd, gxd, gyd 
        integer                         :: inode, iwd, iwd2, isurv

        if(verb>6)write(0,'(A10,3I10,8E20.5)')'b4',inode,iwd, iwd2,sum(modl), sum(data), sum(green_w_s(:,:,:,:,:,iwd2)), sum(green_w(:,:,:,:,:,iwd))
        if(adj)then
            do jzd=data_imin_z, data_imax_z;     zd = vgrid%az%o  + (jzd-1)*vgrid%az%d;     ijzd = 1.5 + ( zd-ggrid%az_modl%o)/ggrid%az_modl%d
            do jyd=data_imin_y, data_imax_y;     yd = vgrid%ay%o  + (jyd-1)*vgrid%ay%d;     ijyd = 1.5 + ( yd-ggrid%ay_modl%o)/ggrid%ay_modl%d
            do jxd=data_imin_x, data_imax_x;     xd = vgrid%ax%o  + (jxd-1)*vgrid%ax%d;     ijxd = 1.5 + ( xd-ggrid%ax_modl%o)/ggrid%ax_modl%d
                    do igyd=1, dgrid%agy%n;     gyd = dgrid%agy%o + (igyd-1)*dgrid%agy%d;  iigyd = 1.5 + (gyd-ggrid%ay_surf%o)/ggrid%ay_surf%d
                    do igxd=1, dgrid%agx%n;     gxd = dgrid%agx%o + (igxd-1)*dgrid%agx%d;  iigxd = 1.5 + (gxd-ggrid%ax_surf%o)/ggrid%ax_surf%d
                        modl( jxd,jyd,jzd )=modl( jxd, jyd,jzd)+conjg(green_w(iigxd,iigyd,ijxd,ijyd,ijzd,iwd)*green_w_s(1,1,ijxd,ijyd,ijzd,iwd2))*data(igxd,igyd, 1,1); 
                    end do;
                    end do;
            end do;  
            end do;   
            end do;   
        else
            do jzd=data_imin_z, data_imax_z;     zd = vgrid%az%o  + (jzd-1)*vgrid%az%d;     ijzd = 1.5 + ( zd-ggrid%az_modl%o)/ggrid%az_modl%d
            do jyd=data_imin_y, data_imax_y;     yd = vgrid%ay%o  + (jyd-1)*vgrid%ay%d;     ijyd = 1.5 + ( yd-ggrid%ay_modl%o)/ggrid%ay_modl%d
            do jxd=data_imin_x, data_imax_x;     xd = vgrid%ax%o  + (jxd-1)*vgrid%ax%d;     ijxd = 1.5 + ( xd-ggrid%ax_modl%o)/ggrid%ax_modl%d
                    do igyd=1, dgrid%agy%n;     gyd = dgrid%agy%o + (igyd-1)*dgrid%agy%d;  iigyd = 1.5 + (gyd-ggrid%ay_surf%o)/ggrid%ay_surf%d
                    do igxd=1, dgrid%agx%n;     gxd = dgrid%agx%o + (igxd-1)*dgrid%agx%d;  iigxd = 1.5 + (gxd-ggrid%ax_surf%o)/ggrid%ax_surf%d
!cycle
                        data(igxd,igyd,1,1)=data(igxd,igyd,1,1)+     (green_w(iigxd,iigyd,ijxd,ijyd,ijzd,iwd)*green_w_s(1,1,ijxd,ijyd,ijzd,iwd2))*modl( jxd, jyd, jzd); 
                    end do;   
                    end do; 
            end do;
            end do;  
            end do;   
        end if;
        if(verb>6)write(0,'(A10,3I10,8E20.5)')'af',inode,iwd, iwd2, sum(modl), sum(data), sum(green_w_s(:,:,:,:,:,iwd2)), sum(green_w(:,:,:,:,:,iwd))
  end subroutine
!####### 
  subroutine encode_scode_init()  
        integer                  ::   jzd,   jxd,  jyd
        integer                  ::  iszd,  isxd, isyd, iw, n , isrv
        integer                  ::  igzd,  igxd, igyd
        integer                  ::  ijzd,  ijxd, ijyd
        integer                  :: iiszd, iisxd, iisyd
        integer                  ::iiiszd,iiisxd,iiisyd
        real                     :: sxd , syd, gxd, gyd 
        real                     :: zd, xd, yd   
        complex, allocatable     :: green(:,:,:,:,:)

        if(allocated(green )) deallocate (green); allocate(green (ggrid%ax_surf%n,ggrid%ay_surf%n,ggrid%ax_modl%n,ggrid%ay_modl%n,ggrid%az_modl%n ));  green=0.
        write(0,*)'Initializing the encoded source waveform...';
        gscd0=0. !init fulll source waveform
        do iw=1,ggrid%aw%n; 
            if(sum(cabs(csou_full(:,:,iw)))<dgrid%asx%n*dgrid%asy%n*mcsou) cycle
            call data_io_greens(green, iw);  
            do isrv=1,nsurv
                !$OMP parallel do private(jzd,jyd,jxd,isyd,isxd,syd,sxd,iisyd,iisxd) schedule(dynamic,10)  
                do jzd=data_imin_z, data_imax_z;
                do jyd=data_imin_y, data_imax_y;
                do jxd=data_imin_x, data_imax_x;
                    do isyd=1, wgrid%asy%n; syd = wgrid%asy%o + (isyd-1)*wgrid%asy%d;  iisyd = 1.5 + (syd-ggrid%ay_surf%o)/ggrid%ay_surf%d
                    do isxd=1, wgrid%asx%n; sxd = wgrid%asx%o + (isxd-1)*wgrid%asx%d;  iisxd = 1.5 + (sxd-ggrid%ax_surf%o)/ggrid%ax_surf%d
                        gscd0(1,1,jxd,jyd,jzd,iw,isrv)=gscd0(1,1,jxd,jyd,jzd,iw,isrv)+(green(iisxd,iisyd,jxd,jyd,jzd))*(csou0(isxd,isyd,iw,isrv))
                    end do;
                    end do;
                end do;
                end do;    
                end do;
                !$OMP end parallel do
                if(verb>4)then;      write(0,*)'ifreq. | isurv:', iw,isrv,sum(gscd0(:,:,:,:,:,iw,isrv)); 
                elseif(verb>3)then;  write(0,*)'ifreq. | isurv:', iw,isrv;endif
            end do;
        write(0,*)'Done initializing the encoded source waveform...';
        enddo;
!endif
!dont forget this...remove comments
!        if(nsurv>0)then;gscd1=>gscd0(:, :,  :,  :,  :, :, 1);write(0,*)'sum source waveform:', 1, sum(gscd1); endif
!        if(nsurv>1)then;gscd2=>gscd0(:, :,  :,  :,  :, :, 2);write(0,*)'sum source waveform:', 2, sum(gscd2); endif
!        if(nsurv>2)then;gscd3=>gscd0(:, :,  :,  :,  :, :, 3);write(0,*)'sum source waveform:', 3, sum(gscd3); endif
!        if(nsurv>3)then;gscd4=>gscd0(:, :,  :,  :,  :, :, 4);write(0,*)'sum source waveform:', 4, sum(gscd4); endif
!        if(nsurv>4)then;gscd5=>gscd0(:, :,  :,  :,  :, :, 5);write(0,*)'sum source waveform:', 5, sum(gscd5); endif
!        if(nsurv>5)then;gscd6=>gscd0(:, :,  :,  :,  :, :, 6);write(0,*)'sum source waveform:', 6, sum(gscd6); endif     
        if(allocated(green    )) deallocate(green    ); 
  end subroutine


end module


