module joint_encode_fft
  use joint_encode_params
  use fftw_oneway_mod
  !use fft_data_mod
 
implicit none
!  type(fft_type)     :: fft_1d_id, rft_1d_id 
contains
!!=======================================================================================
  integer function encode_read2(fdat,dat_) result(stat)
	complex ::fdat(dgrid%agx%n, dgrid%agy%n, dgrid%aw%n, dgrid%asx%n, dgrid%asy%n)
	character(len=256)         :: dat_ 
        stat=1
        call sep_read(fdat, dat_) ; 
        stat=0
  end function
!!=======================================================================================
  integer function encode_read(fdat,dat_) result(stat)
	complex ::fdat(dgrid%agx%n, dgrid%agy%n, dgrid%asx%n, dgrid%asy%n, dgrid%aw%n)
	character(len=256)         :: dat_
        stat=1
        call sep_read(fdat, dat_) ; 
        stat=0
  end function
!!=======================================================================================
  integer function encode_write(fdat,dat_) result(stat)
	complex ::fdat(dgrid%agx%n, dgrid%agy%n, dgrid%asx%n, dgrid%asy%n, dgrid%aw%n)
	character(len=256)         :: dat_
        stat=1
        call sep_write(fdat, dat_) ; 
write(0,*)'Wroteeeeeeeeee data...', sum(fdat), trim(dat_)
        stat=0
  end function
!!=======================================================================================
  integer function encode_fft(dir,fdat) result(stat)
	complex ::fdat(dgrid%agx%n, dgrid%agy%n, dgrid%aw%n, dgrid%asx%n, dgrid%asy%n)
	integer :: dir
        stat=1; stat = encode_transf(dir,fdat);
  end function
!!=======================================================================================
  integer function encode_transf(dir,fdat) result(stat)
        integer :: dir
	complex :: fdat(:,:,:,:,:)
        stat=1
        if(dir==1.or.dir==-1)then
		if(use_greens)then
                        do isy=1, dgrid%asy%n;      do isx=1, dgrid%asx%n;  do igy=1, dgrid%agy%n;      do igx=1, dgrid%agx%n; 
                            call FFT1DT(fdat(igx, igy, isx, isy, :), dir);
                        end do;                     end do;                 end do;                     end do;   
                else
                        do isy=1, dgrid%asy%n;      do isx=1, dgrid%asx%n;  do igy=1, dgrid%agy%n;      do igx=1, dgrid%agx%n; 
                            call FFT1DT(fdat(igx, igy, :, isx, isy), dir);
                        end do;                     end do;                 end do;                     end do;   
                endif
        else
            call seperr('Error dir encode')
        endif
        stat=0
  end function
!!=======================================================================================
  integer function encode_fft_green_fftw(dir,fdat) result(stat)
	complex ::fdat(dgrid%agx%n, dgrid%agy%n, dgrid%asx%n, dgrid%asy%n, dgrid%aw%n*2-1)
	integer :: dir
        stat=1; stat = encode_transf_green_fftw(dir,fdat);
  end function
!!=======================================================================================
  integer function encode_transf_green_fftw(dir,fdat) result(stat)
	complex ::fdat(:,:,:,:,:)
	integer :: dir
        stat=1
        if(dir==1.or.dir==-1)then
                do isy=1, dgrid%asy%n;      do isx=1, dgrid%asx%n;  do igy=1, dgrid%agy%n;      do igx=1, dgrid%agx%n; 
                        call fftw_exec1d(dir,fdat(igx, igy, isx, isy, :)); 
                end do;                     end do;                 end do;                     end do;   
        else
            call seperr('Error dir encode')
        endif
        stat=0
  end function
!!=======================================================================================
  integer function encode_fft_fftw(dir,fdat) result(stat)
	complex ::fdat(dgrid%agx%n, dgrid%agy%n, dgrid%aw%n*2-1, dgrid%asx%n, dgrid%asy%n)
	integer :: dir
        stat=1; stat = encode_transf_fftw(dir,fdat);
  end function
!!=======================================================================================
  integer function encode_transf_fftw(dir,fdat) result(stat)
	complex ::fdat(:,:,:,:,:)
        complex :: tmp1(dgrid%aw%n*2-1),tmp2(dgrid%aw%n*2-1)
	integer :: dir,i
        if(dir==1.or.dir==-1)then
                do isy=1, dgrid%asy%n;      do isx=1, dgrid%asx%n;  do igy=1, dgrid%agy%n;      do igx=1, dgrid%agx%n; 
                tmp1=fdat(igx, igy, :, isx, isy)
                        call fftw_exec1d (-1,fdat(igx, igy, :, isx, isy)); 
                tmp2=fdat(igx, igy, :, isx, isy)
                        call fftw_exec1d (1,fdat(igx, igy, :, isx, isy)); 
                end do;                     end do;                 end do;                     end do;   
        else
            call seperr('Error dir encode')
        endif
        stat=0
  end function
!!=======================================================================================
  subroutine clean_post3dvz_guj()
!    call clean_rfft(rft_1d_id)
!    call clean_fft (fft_1d_id)
  end subroutine clean_post3dvz_guj
!!=======================================================================================
  function rft_fwd_axis1(U)
    real   , dimension(:,:)        , intent(in) :: U
    complex, dimension(size(U,1)/2,  size(U,2)) :: rft_fwd_axis1
    complex, dimension(size(U,1)/2+1)           :: all_freq
    integer                                     :: ix
    do ix = 1, size(U,2)
!       call rfft_1d_data(rft_1d_id, -1, nt, U(:,ix), all_freq)
       rft_fwd_axis1(:,ix) = all_freq(2:) ! Throw away the zero frequency
    end do
  end function rft_fwd_axis1
!!=======================================================================================
  function rft_bck_axis1(C)
    complex, dimension(:,:), intent(in)        :: C
    real   , dimension(2*size(C,1), size(C,2)) :: rft_bck_axis1
    complex, dimension(1+size(C,1))            :: all_freq
    integer                                    :: ix
        
        rft_bck_axis1(:,ix)=0

    all_freq (1)=0
    do ix = 1, size(C,2)
       all_freq(2:) = C(:,ix)
!       call rfft_1d_data(rft_1d_id, 1, nt, rft_bck_axis1(:,ix), all_freq)
    end do
  end function rft_bck_axis1
!!=======================================================================================

end module
