module joint_encode_data_grid
  use joint_encode_params
  implicit none

contains
!!!!!!!!!!!!!!!!  ###########
!######################################################################
  subroutine obc_grid()

  end subroutine

!######################################################################
  subroutine green_grid()

  end subroutine
!######################################################################
  subroutine velocity_grid()
  vel_="vel"
    call auxin(vel_); call ainaxis(vel_,vgrid%ax,1); call ainaxis(vel_,vgrid%ay,2); call ainaxis(vel_,vgrid%az,3)
    if (max_z==-99999.) max_z= vgrid%az%o+vgrid%az%d*(vgrid%az%n-1); imax_z=1.5+(max_z-vgrid%az%o)/vgrid%az%d;  
    if (min_z==-99999.) min_z= vgrid%az%o                          ; imin_z=1.5+(min_z-vgrid%az%o)/vgrid%az%d;  

    write(0,'(A65)')'=========================Summary velocity==============================='
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|', 'x             ','|',vgrid%ax, '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|', 'y             ','|',vgrid%ay, '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|', 'z             ','|',vgrid%az, '|'
    write(0,'(A65)')'===================================================================='
	call reflect_grid()
    if (max_z==-99999.) max_z= vgrid%az%o+vgrid%az%d*(vgrid%az%n-1); imax_z=1.5+(max_z-vgrid%az%o)/vgrid%az%d;  
    if (min_z==-99999.) min_z= vgrid%az%o                          ; imin_z=1.5+(min_z-vgrid%az%o)/vgrid%az%d;      
  end subroutine
!######################################################################
  subroutine data_grid_born()
        integer :: ixhole,iyhole
        call from_param("data_min_z"  , data_min_z   ,  vgrid%az%o); call from_param("data_max_z"  , data_max_z   ,  vgrid%az%o+(vgrid%az%n-1)*vgrid%az%d );
        call from_param("data_min_x"  , data_min_x   ,  vgrid%ax%o); call from_param("data_max_x"  , data_max_x   ,  vgrid%ax%o+(vgrid%ax%n-1)*vgrid%ax%d );
        call from_param("data_min_y"  , data_min_y   ,  vgrid%ay%o); call from_param("data_max_y"  , data_max_y   ,  vgrid%ay%o+(vgrid%ay%n-1)*vgrid%ay%d );

	if(use_greens)then
	        data_imin_z=max(1.,1.5+(data_min_z-ggrid%az_modl%o)/ggrid%az_modl%d); data_imax_z=min(ggrid%az_modl%n,int(1.5+(data_max_z-ggrid%az_modl%o)/ggrid%az_modl%d))
        	data_imin_x=max(1.,1.5+(data_min_x-ggrid%ax_modl%o)/ggrid%ax_modl%d); data_imax_x=min(ggrid%ax_modl%n,int(1.5+(data_max_x-ggrid%ax_modl%o)/ggrid%ax_modl%d))
	        data_imin_y=max(1.,1.5+(data_min_y-ggrid%ay_modl%o)/ggrid%ay_modl%d); data_imax_y=min(ggrid%ay_modl%n,int(1.5+(data_max_y-ggrid%ay_modl%o)/ggrid%ay_modl%d))

        	data_imin_z=min(data_imin_z,int(1.5+(data_min_z-vgrid%az%o)/vgrid%az%d)); data_imax_z=min(data_imax_z,int(1.5+(data_max_z-vgrid%az%o)/vgrid%az%d))
	        data_imin_x=min(data_imin_x,int(1.5+(data_min_x-vgrid%ax%o)/vgrid%ax%d)); data_imax_x=min(data_imax_x,int(1.5+(data_max_x-vgrid%ax%o)/vgrid%ax%d))
        	data_imin_y=min(data_imin_y,int(1.5+(data_min_y-vgrid%ay%o)/vgrid%ay%d)); data_imax_y=min(data_imax_y,int(1.5+(data_max_y-vgrid%ay%o)/vgrid%ay%d))
	else
        	data_imin_x=max(1.,1.5+(data_min_x-vgrid%ax%o)/vgrid%ax%d); data_imax_x=min(vgrid%ax%n,int(1.5+(data_max_x-vgrid%ax%o)/vgrid%ax%d))
	        data_imin_y=max(1.,1.5+(data_min_y-vgrid%ay%o)/vgrid%ay%d); data_imax_y=min(vgrid%ay%n,int(1.5+(data_max_y-vgrid%ay%o)/vgrid%ay%d))

	endif
    write(0,'(A65)')'=========================Summary data==================================='
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','dgrid%asx  ','|',dgrid%asx  , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','dgrid%asy  ','|',dgrid%asy  , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','dgrid%aw   ','|',dgrid%aw   , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','dgrid%at   ','|',dgrid%at   , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','dgrid%agx  ','|',dgrid%agx  , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','dgrid%agy  ','|',dgrid%agy  , '|'
    write(0,'(A2,A15,A2,2(I10  ,2X),A2)') '|','imin_x, imax_x','|',data_imin_x,  data_imax_x, '|'
    write(0,'(A2,A15,A2,2(I10  ,2X),A2)') '|','imin_y, imax_y','|',data_imin_y,  data_imax_y, '|'
    write(0,'(A2,A15,A2,2(F10.3,2X),A2)') '|',' min_x,  max_x','|',data_min_x,  data_max_x, '|'
    write(0,'(A2,A15,A2,2(F10.3,2X),A2)') '|',' min_y,  max_y','|',data_min_y,  data_max_y, '|'
    write(0,'(A65)')'===================================================================='
    write(0,'(A65)')'========================Summary hole ================================='
        if(.not. hole)then 
                write(0,*)'No hole in data..good..No need to worry...'
        else
                ih_sx1=1.5+(hole_sx1-dgrid%asx%o)/dgrid%asx%d;ih_sx2=1.5+(hole_sx2-dgrid%asx%o)/dgrid%asx%d
                ih_sy1=1.5+(hole_sy1-dgrid%asy%o)/dgrid%asy%d;ih_sy2=1.5+(hole_sy2-dgrid%asy%o)/dgrid%asy%d
                ih_gx1=1.5+(hole_gx1-dgrid%agx%o)/dgrid%agx%d;ih_gx2=1.5+(hole_gx2-dgrid%agx%o)/dgrid%agx%d
                ih_gy1=1.5+(hole_gy1-dgrid%agy%o)/dgrid%agy%d;ih_gy2=1.5+(hole_gy2-dgrid%agy%o)/dgrid%agy%d
                if(hole_sx1<=hole_sx2.and.ih_sx1>1.and.ih_sx2<dgrid%asx%n) write(0,*)'hole sx           : ', ih_sx1, ih_sx2
                if(hole_sy1<=hole_sy2.and.ih_sy1>1.and.ih_sx2<dgrid%asx%n) write(0,*)'hole sy           : ', ih_sy1, ih_sy2
                if(hole_gx1<=hole_gx2.and.ih_gx1>1.and.ih_gx2<dgrid%agx%n) write(0,*)'hole gx           : ', ih_gx1, ih_gx2
                if(hole_gy1<=hole_gy2.and.ih_gy1>1.and.ih_gy2<dgrid%agy%n) write(0,*)'hole gy           : ', ih_gy1, ih_gy2
                write(0,*)"nxhole,dxhole,oxhole:",nxhole,dxhole,oxhole
                write(0,*)"nyhole,dyhole,oyhole:",nyhole,dyhole,oyhole
                allocate(ihh_sx1(nxhole),ihh_sx2(nxhole),ihh_sy1(nyhole),ihh_sy2(nyhole))
                allocate(ihh_gx1(nxhole),ihh_gx2(nxhole),ihh_gy1(nyhole),ihh_gy2(nyhole))
                
                do ixhole=1,nxhole
                        ihh_sx1(ixhole)=ih_sx1+(ixhole-1)*dxhole; ihh_sx2(ixhole)=ih_sx2+(ixhole-1)*dxhole; write(0,*)'ihole, hole sx : ', ixhole,ihh_sx1(ixhole), ihh_sx2(ixhole)
!                       ihh_gx1(ixhole)=ih_gx1+(ixhole-1)*dxhole; ihh_gx2(ixhole)=ih_gx2+(ixhole-1)*dxhole; write(0,*)'ihole, hole gx : ', ixhole,ihh_gx1(ixhole), ihh_gx2(ixhole)
                end do
                do iyhole=1,nyhole
                        ihh_sy1(iyhole)=ih_sy1+(iyhole-1)*dyhole; ihh_sy2(iyhole)=ih_sy2+(iyhole-1)*dyhole; write(0,*)'ihole, hole sy : ', iyhole,ihh_sy1(iyhole), ihh_sy2(iyhole)
!                       ihh_gy1(iyhole)=ih_gy1+(iyhole-1)*dyhole; ihh_gy2(iyhole)=ih_gy2+(iyhole-1)*dyhole; write(0,*)'ihole, hole gy : ', iyhole,ihh_gy1(iyhole), ihh_gy2(iyhole)
                end do
        endif
    write(0,'(A65)')'===================================================================='
  end subroutine
!######################################################################
 subroutine reflect_grid()
        if(exist_file(ref_))then
                call auxin(ref_)
                call ainaxis(ref_, rgrid%ax,1); call ainaxis(ref_, rgrid%ay,2); call ainaxis(ref_,rgrid%az,3)
        elseif(exist_file(vel_))then
                rgrid%az=vgrid%az
                rgrid%ax=vgrid%ax
                rgrid%ay=vgrid%ay

        else
                call seperr('supply a reflectivity or velocity+density model')
        endif
        write(0,'(A65)')'=========================Summary reflect.==============================='
        write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|', 'x             ','|',rgrid%ax, '|'
        write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|', 'y             ','|',rgrid%ay, '|'
        write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|', 'z             ','|',rgrid%az, '|'
        write(0,'(A65)')'===================================================================='
        if(rgrid%az%n/=vgrid%az%n)call seperr('unequal refl. and vel. grids: nz')
        if(rgrid%ay%n/=vgrid%ay%n)call seperr('unequal refl. and vel. grids: ny')
        if(rgrid%ax%n/=vgrid%ax%n)call seperr('unequal refl. and vel. grids: nx')
  end subroutine

!######################################################################
subroutine green_pro_grid(igx,igy,progrid)
    type(pro_grid) :: progrid   
    real           :: progrid_xmin, progrid_xmax, progrid_ymin, progrid_ymax, progrid_zmin, progrid_zmax
    integer        :: igx,igy    

    progrid%ax%d  = vgrid%ax%d        ; progrid%ay%d  = vgrid%ay%d        ; progrid%az%d  = vgrid%az%d

    call from_param("nxpad_beg", progrid%nxpad_beg, 0); call from_param("nxpad_end", progrid%nxpad_end, 0); nxpad=(pgrid%nxpad_beg+pgrid%nxpad_end)/2.
    call from_param("nypad_beg", progrid%nypad_beg, 0); call from_param("nypad_end", progrid%nypad_end, 0); nypad=(pgrid%nypad_beg+pgrid%nypad_end)/2.

!    write(0,*)'prid_xmin/max', progrid_xmin,progrid_xmax; write(0,*)'prid_ymin/max', progrid_ymin,progrid_ymax;  write(0,*)'prid_zmin/max', progrid_zmin,progrid_zmax; 
!    write(0,*)'==========================================================>'
!    write(0,*)'geoph. @ ixg/iyg in vel. model:',igx,igy
    progrid_xmin = min(ggrid%ax_surf%o, ggrid%ax_modl%o); progrid_xmax = max(ggrid%ax_surf%o + (ggrid%ax_surf%n-1)*ggrid%ax_surf%d, ggrid%ax_modl%o + (ggrid%ax_modl%n-1)*ggrid%ax_modl%d)
    progrid_ymin = min(ggrid%ay_surf%o, ggrid%ay_modl%o); progrid_ymax = max(ggrid%ay_surf%o + (ggrid%ay_surf%n-1)*ggrid%ay_surf%d, ggrid%ay_modl%o + (ggrid%ay_modl%n-1)*ggrid%ay_modl%d)
    progrid_zmin = max(min_z          , vgrid%az%o                     ); progrid_zmax = min(max_z                                                ,(vgrid%az%n       -1)*vgrid%az%d)
!    write(0,*)'prid_xmin/max', progrid_xmin,progrid_xmax; write(0,*)'prid_ymin/max', progrid_ymin,progrid_ymax;  write(0,*)'prid_zmin/max', progrid_zmin,progrid_zmax; 

    !!.. add the padding on both x and y direction
    progrid_xmin = progrid_xmin - progrid%nxpad_beg*progrid%ax%d; progrid_xmax = progrid_xmax + progrid%nxpad_end*progrid%ax%d
    progrid_ymin = progrid_ymin - progrid%nypad_beg*progrid%ay%d; progrid_ymax = progrid_ymax + progrid%nypad_end*progrid%ay%d
!    write(0,*)'prid_xmin/max', progrid_xmin,progrid_xmax; write(0,*)'prid_ymin/max', progrid_ymin,progrid_ymax;  write(0,*)'prid_zmin/max', progrid_zmin,progrid_zmax; 

    !!.. make sure the propagation grid is within the velocity model 
    progrid_xmin = max(progrid_xmin, vgrid%ax%o); progrid_xmax = min(progrid_xmax, vgrid%ax%o + (vgrid%ax%n-1)*vgrid%ax%d)
    progrid_ymin = max(progrid_ymin, vgrid%ay%o); progrid_ymax = min(progrid_ymax, vgrid%ay%o + (vgrid%ay%n-1)*vgrid%ay%d)
!    write(0,*)'prid_xmin/max', progrid_xmin,progrid_xmax; write(0,*)'prid_ymin/max', progrid_ymin,progrid_ymax;  write(0,*)'prid_zmin/max', progrid_zmin,progrid_zmax; 
    !################################################
    !!.. propagation grid 
    progrid%ax%o = progrid_xmin; progrid%ax%n =     1.5 + (progrid_xmax - progrid_xmin)/progrid%ax%d
    progrid%ay%o = progrid_ymin; progrid%ay%n =     1.5 + (progrid_ymax - progrid_ymin)/progrid%ay%d
    progrid%az%o = progrid_zmin; progrid%az%n = min(1.5 + (progrid_zmax - progrid_zmin)/progrid%az%d, 1.*vgrid%az%n)
                                 progrid%az%n = min(progrid%az%n,int(1.5+(ggrid%az_modl%o+(ggrid%az_modl%n-1)*ggrid%az_modl%d - progrid%az%o)/progrid%az%d))

    !!....first and last index of propagation grid in the velocity model
    progrid%index_xmin         = 1.5 + (progrid_xmin - vgrid%ax%o )/ progrid%ax%d; progrid%index_ymin         = 1.5 + (progrid_ymin - vgrid%ay%o) / progrid%ay%d  
    progrid%index_xmax         = 1.5 + (progrid_xmax - vgrid%ax%o )/ progrid%ax%d; progrid%index_ymax         = 1.5 + (progrid_ymax - vgrid%ay%o) / progrid%ay%d  
    !!.. index of the geoph. in the propagation grid
    progrid%index_datpro_sx  = max(1,igx - progrid%index_xmin+1)  
    progrid%index_datpro_sy  = max(1,igy - progrid%index_ymin+1)
    !!....index of 1st and last point of greens grid in propagation grid
    ggrid%index_modpro_minx   = 1.5 + (ggrid%ax_modl%o-progrid_xmin)/progrid%ax%d; ggrid%index_modpro_maxx=1.5 + (ggrid%ax_modl%o+(ggrid%ax_modl%n-1)*ggrid%ax_modl%d - progrid%ax%o)/progrid%ax%d
    ggrid%index_modpro_miny   = 1.5 + (ggrid%ay_modl%o-progrid_ymin)/progrid%ay%d; ggrid%index_modpro_maxy=1.5 + (ggrid%ay_modl%o+(ggrid%ay_modl%n-1)*ggrid%ay_modl%d - progrid%ay%o)/progrid%ay%d

!    write(0,*)'----------------------------------------------------------!'
!    write(0,*)'prid%ax   ', progrid%ax        ; write(0,*)'prid%ay   ', progrid%ay; write(0,*)'prid%az   ', progrid%az
!    write(0,*)'----------------------------------------------------------'
!    write(0,*)'progrid%_x                 ',  progrid_xmin, progrid_xmax ; 
!    write(0,*)'progrid%index_x            ', progrid%index_xmin, progrid%index_xmax ; 
!    write(0,*)'progrid%index_y            ', progrid%index_ymin, progrid%index_ymax ; 
!    write(0,*)'ggrid%index_pminx/maxx     ', ggrid%index_modpro_minx, ggrid%index_modpro_maxx  
!    write(0,*)'ggrid%index_pminx/maxy     ', ggrid%index_modpro_miny, ggrid%index_modpro_maxy  
!    write(0,*)'progrid%index_sx/sy        ', progrid%index_datpro_sx, progrid%index_datpro_sy,igx,igy  
 end subroutine
!######################################################################
subroutine mig_pro_grid(isx, isx2, isy, isy2, progrid,ooogrid)
    type(pro_grid) :: progrid   
    type(out_grid) :: ooogrid   
    real           :: progrid_xmin, progrid_xmax, progrid_ymin, progrid_ymax, progrid_zmin, progrid_zmax
    integer        :: isx,isy    
    integer        :: isx2,isy2    
    progrid%ax%d  = vgrid%ax%d        ; progrid%ay%d   = vgrid%ay%d      ; progrid%az%d  = vgrid%az%d
    ooogrid%ax%d  = vgrid%ax%d        ; ooogrid%ay%d   = vgrid%ay%d      ; ooogrid%az%d  = vgrid%az%d
    ooogrid%ahx%d = igrid%ahx%d       ; ooogrid%ahy%d  = igrid%ahy%d       
    ooogrid%ahx%o = igrid%ahx%o       ; ooogrid%ahy%o  = igrid%ahy%o       
    ooogrid%ahx%n = igrid%ahx%n       ; ooogrid%ahy%n  = igrid%ahy%n       

    ! write(0,*)'==========================================================>'
    ! write(0,*)'shot. @ isx/isy in vel. model:',isx, isy
    progrid_xmin = min(dgrid%agx%o, vgrid%ax%o + (isx-1)*vgrid%ax%d); progrid_xmax = min(max(dgrid%agx%o + (dgrid%agx%n-1)*dgrid%agx%d, vgrid%ax%o + (isx2-1)*vgrid%ax%d),vgrid%ax%o+(vgrid%ax%n-1)*vgrid%ax%n)
    progrid_ymin = min(dgrid%agy%o, vgrid%ay%o + (isy-1)*vgrid%ay%d); progrid_ymax = min(max(dgrid%agy%o + (dgrid%agy%n-1)*dgrid%agy%d, vgrid%ay%o + (isy2-1)*vgrid%ay%d),vgrid%ay%o+(vgrid%ay%n-1)*vgrid%ay%n)
    if (min_z == -99999.) min_z=vgrid%az%o                            ; progrid_zmin = min_z 
    if (max_z == -99999.) max_z=vgrid%az%o + (vgrid%az%n-1)*vgrid%az%d; progrid_zmax = max_z 
    !write(0,*)'-1'
    !write(0,'(3(A10,2F10.2,2X))')'prid_xmin/max', progrid_xmin,progrid_xmax,'prid_ymin/max', progrid_ymin,progrid_ymax,'prid_zmin/max', progrid_zmin,progrid_zmax; 
    !write(0,*)'1', dgrid%agx%o,dgrid%agy%o,dgrid%agx%o + (dgrid%agx%n-1)*dgrid%agx%d, vgrid%ax%o + (isx-1)*vgrid%ax%d, isx
    !write(0,*)'11', dgrid%agx
    !write(0,*)max_z, vgrid%az%o, (vgrid%az%n-1), vgrid%az%d, progrid_zmax, vgrid%az%o + (vgrid%az%n-1)*vgrid%az%d
    if(lhessian)then
            ooogrid%ax%o=max(progrid_xmin,ggrid%xmin_modl); ooogrid%ax%n=min(1.5+(progrid_xmax-ooogrid%ax%o)/ooogrid%ax%d,1.5+(ggrid%xmax_modl-ooogrid%ax%o)/ooogrid%ax%d)
            ooogrid%ay%o=max(progrid_ymin,ggrid%ymin_modl); ooogrid%ay%n=min(1.5+(progrid_ymax-ooogrid%ay%o)/ooogrid%ay%d,1.5+(ggrid%ymax_modl-ooogrid%ay%o)/ooogrid%ay%d)
            ooogrid%az%o=max(progrid_zmin,ggrid%zmin_modl); ooogrid%az%n=min(1.5+(progrid_zmax-ooogrid%az%o)/ooogrid%az%d,1.5+(ggrid%zmax_modl-ooogrid%az%o)/ooogrid%az%d)
    else
            ooogrid%ax%o=progrid_xmin; ooogrid%ax%n=1.5+(progrid_xmax-progrid_xmin)/ooogrid%ax%d
            ooogrid%ay%o=progrid_ymin; ooogrid%ay%n=1.5+(progrid_ymax-progrid_ymin)/ooogrid%ay%d
            ooogrid%az%o=progrid_zmin; ooogrid%az%n=1.5+(progrid_zmax-progrid_zmin)/ooogrid%az%d
    endif
    !!.. add the padding on both x and y direction
    call from_param("nxpad_beg", progrid%nxpad_beg, 0); call from_param("nxpad_end", progrid%nxpad_end, 0); nxpad=(pgrid%nxpad_beg+pgrid%nxpad_end)/2.
    call from_param("nypad_beg", progrid%nypad_beg, 0); call from_param("nypad_end", progrid%nypad_end, 0); nypad=(pgrid%nypad_beg+pgrid%nypad_end)/2.
    progrid_xmin = progrid_xmin - progrid%nxpad_beg*progrid%ax%d; progrid_xmax = progrid_xmax + progrid%nxpad_end*progrid%ax%d
    progrid_ymin = progrid_ymin - progrid%nypad_beg*progrid%ay%d; progrid_ymax = progrid_ymax + progrid%nypad_end*progrid%ay%d
    !write(0,*)'-2'
    !write(0,'(3(A10,2F10.2,2X))')'prid_xmin/max', progrid_xmin,progrid_xmax,'prid_ymin/max', progrid_ymin,progrid_ymax,'prid_zmin/max', progrid_zmin,progrid_zmax; 

    !!.. make sure the propagation grid is within the velocity model 
    progrid_xmin = max(progrid_xmin, vgrid%ax%o); progrid_xmax = min(progrid_xmax, vgrid%ax%o + (vgrid%ax%n-1)*vgrid%ax%d)
    progrid_ymin = max(progrid_ymin, vgrid%ay%o); progrid_ymax = min(progrid_ymax, vgrid%ay%o + (vgrid%ay%n-1)*vgrid%ay%d)
    !write(0,*)'-3'
    !write(0,'(3(A10,2F10.2,2X))')'prid_xmin/max', progrid_xmin,progrid_xmax,'prid_ymin/max', progrid_ymin,progrid_ymax,'prid_zmin/max', progrid_zmin,progrid_zmax; 
    !################################################
    !!.. propagation grid 
    progrid%ax%o = progrid_xmin; progrid%ax%n =     1.5 + (progrid_xmax - progrid_xmin)/progrid%ax%d
    progrid%ay%o = progrid_ymin; progrid%ay%n =     1.5 + (progrid_ymax - progrid_ymin)/progrid%ay%d
    progrid%az%o = progrid_zmin; progrid%az%n = min(1.5 + (progrid_zmax - progrid_zmin)/progrid%az%d, 1.*vgrid%az%n)
    if(lhessian)then
        progrid%az%n = min(1.5 + (min(progrid_zmax,ggrid%zmax_modl) - progrid_zmin)/progrid%az%d, 1.*vgrid%az%n)
    endif

    !!....first and last index of propagation grid in the velocity model
    progrid%index_xmin         = 1.5 + (progrid_xmin - vgrid%ax%o )/ progrid%ax%d; progrid%index_ymin         = 1.5 + (progrid_ymin - vgrid%ay%o) / progrid%ay%d  
    progrid%index_xmax         = 1.5 + (progrid_xmax - vgrid%ax%o )/ progrid%ax%d; progrid%index_ymax         = 1.5 + (progrid_ymax - vgrid%ay%o) / progrid%ay%d  
    !!.. index of the source. in the propagation grid
    progrid%index_datpro_sx  = max(1,isx - progrid%index_xmin+1)  
    progrid%index_datpro_sy  = max(1,isy - progrid%index_ymin+1)
    !!.. index of the last encoded source. in the propagation grid
    progrid%index_datpro_sx_end  = max(1,isx2 - progrid%index_xmin+1)  
    progrid%index_datpro_sy_end  = max(1,isy2 - progrid%index_ymin+1)
    !!.. index of 1st and last geoph. in the velocity model
    progrid%gxmin  = max(vgrid%ax%o, dgrid%agx%o )                                                       ; progrid%index_gxmin  = 1.5 + (progrid%gxmin-vgrid%ax%o)/vgrid%ax%d  
    progrid%gymin  = max(vgrid%ay%o, dgrid%agy%o )                                                       ; progrid%index_gymin  = 1.5 + (progrid%gymin-vgrid%ay%o)/vgrid%ay%d  
    progrid%gxmax  = min(vgrid%ax%o+(vgrid%ax%n-1)*vgrid%ax%d, dgrid%agx%o + (dgrid%agx%n-1)*dgrid%agx%d); progrid%index_gxmax  = 1.5 + (progrid%gxmax-vgrid%ax%o)/vgrid%ax%d  
    progrid%gymax  = min(vgrid%ay%o+(vgrid%ay%n-1)*vgrid%ay%d, dgrid%agy%o + (dgrid%agy%n-1)*dgrid%agy%d); progrid%index_gymax  = 1.5 + (progrid%gymax-vgrid%ay%o)/vgrid%ay%d 
    !!.. index of 1st and last geoph. in the propagation grid
    progrid%index_datpro_gxmin  = max(1.,progrid%index_gxmin - progrid%index_xmin+1.);  progrid%index_datpro_gymin  = max(1.,progrid%index_gymin - progrid%index_ymin+1.)
    progrid%index_datpro_gxmax  = max(1.,progrid%index_gxmax - progrid%index_xmin+1.);  progrid%index_datpro_gymax  = max(1.,progrid%index_gymax - progrid%index_ymin+1.)
    if(lhessian)then 
            !!....index of 1st and last point of output grid in propagation grid
            ooogrid%index_pro_xmin   = 1.5 + (ooogrid%ax%o-progrid_xmin)/progrid%ax%d; ooogrid%index_pro_xmax=1.5 + (ooogrid%ax%o+(ooogrid%ax%n-1)*ooogrid%ax%d - progrid%ax%o)/progrid%ax%d
            ooogrid%index_pro_ymin   = 1.5 + (ooogrid%ay%o-progrid_ymin)/progrid%ay%d; ooogrid%index_pro_ymax=1.5 + (ooogrid%ay%o+(ooogrid%ay%n-1)*ooogrid%ay%d - progrid%ay%o)/progrid%ay%d
            ooogrid%index_pro_zmin   = 1.5 + (ooogrid%az%o-progrid_zmin)/progrid%az%d; ooogrid%index_pro_zmax=1.5 + (ooogrid%az%o+(ooogrid%az%n-1)*ooogrid%az%d - progrid%az%o)/progrid%az%d
            !!....index of 1st and last point of output grid in greens grid
            ooogrid%index_img_xmin   = 1.5 + (ooogrid%ax%o-ggrid%ax_modl%o)/ggrid%ax_modl%d; ooogrid%index_img_xmax=1.5 + (ooogrid%ax%o+(ooogrid%ax%n-1)*ooogrid%ax%d - ggrid%ax_modl%o)/ggrid%ax_modl%d
            ooogrid%index_img_ymin   = 1.5 + (ooogrid%ay%o-ggrid%ay_modl%o)/ggrid%ay_modl%d; ooogrid%index_img_ymax=1.5 + (ooogrid%ay%o+(ooogrid%ay%n-1)*ooogrid%ay%d - ggrid%ay_modl%o)/ggrid%ay_modl%d
            ooogrid%index_img_zmin   = 1.5 + (ooogrid%az%o-ggrid%az_modl%o)/ggrid%az_modl%d; ooogrid%index_img_zmax=1.5 + (ooogrid%az%o+(ooogrid%az%n-1)*ooogrid%az%d - ggrid%az_modl%o)/ggrid%az_modl%d
    else
            !!....index of 1st and last point of output grid in propagation grid
            ooogrid%index_pro_xmin   = 1.5 + (ooogrid%ax%o-progrid_xmin)/progrid%ax%d; ooogrid%index_pro_xmax=1.5 + (ooogrid%ax%o+(ooogrid%ax%n-1)*ooogrid%ax%d - progrid%ax%o)/progrid%ax%d
            ooogrid%index_pro_ymin   = 1.5 + (ooogrid%ay%o-progrid_ymin)/progrid%ay%d; ooogrid%index_pro_ymax=1.5 + (ooogrid%ay%o+(ooogrid%ay%n-1)*ooogrid%ay%d - progrid%ay%o)/progrid%ay%d
            ooogrid%index_pro_zmin   = 1.5 + (ooogrid%az%o-progrid_zmin)/progrid%az%d; ooogrid%index_pro_zmax=1.5 + (ooogrid%az%o+(ooogrid%az%n-1)*ooogrid%az%d - progrid%az%o)/progrid%az%d
            !!....index of 1st and last point of output grid in image grid
            ooogrid%index_img_xmin   = 1.5 + (ooogrid%ax%o-vgrid%ax%o)/vgrid%ax%d; ooogrid%index_img_xmax=1.5 + (ooogrid%ax%o+(ooogrid%ax%n-1)*ooogrid%ax%d - vgrid%ax%o)/vgrid%ax%d
            ooogrid%index_img_ymin   = 1.5 + (ooogrid%ay%o-vgrid%ay%o)/vgrid%ay%d; ooogrid%index_img_ymax=1.5 + (ooogrid%ay%o+(ooogrid%ay%n-1)*ooogrid%ay%d - vgrid%ay%o)/vgrid%ay%d
            ooogrid%index_img_zmin   = 1.5 + (ooogrid%az%o-vgrid%az%o)/vgrid%az%d; ooogrid%index_img_zmax=1.5 + (ooogrid%az%o+(ooogrid%az%n-1)*ooogrid%az%d - vgrid%az%o)/vgrid%az%d
    endif
    if(verb>=10)then
     write(0,*)'----------------------------------------------------------!'
     write(0,*)'prid%ax   ', progrid%ax        ; write(0,*)'prid%ay   ', progrid%ay; write(0,*)'prid%az   ', progrid%az
     write(0,*)'orid%ax   ', ooogrid%ax        ; write(0,*)'orid%ay   ', ooogrid%ay  ; write(0,*)'orid%az   ', ooogrid%az
     write(0,*)'orid%ahx  ', ooogrid%ahx       ; write(0,*)'orid%ahy  ', ooogrid%ahy  
     write(0,*)'----------------------------------------------------------'
     endif
    if(verb>=15)then
     write(0,*)'progrid%_x                 ', progrid_xmin, progrid_xmax ; 
     write(0,*)'progrid%_y                 ', progrid_ymin, progrid_ymax ; 
     write(0,*)'progrid%index_x            ', progrid%index_xmin, progrid%index_xmax ; 
     write(0,*)'progrid%index_y            ', progrid%index_ymin, progrid%index_ymax ; 
     write(0,*)'ogrid%index_pminx/maxx     ', ooogrid%index_pro_xmin, ooogrid%index_pro_xmax 
     write(0,*)'ogrid%index_pminy/maxy     ', ooogrid%index_pro_ymin, ooogrid%index_pro_ymax  
     write(0,*)'ogrid%index_iminx/maxx     ', ooogrid%index_img_xmin, ooogrid%index_img_xmax
     write(0,*)'ogrid%index_iminy/maxy     ', ooogrid%index_img_ymin, ooogrid%index_img_ymax
     write(0,*)'ogrid%index_iminz/maxz     ', ooogrid%index_img_zmin, ooogrid%index_img_zmax  
     write(0,*)'progrid%index_sx/sy        ', progrid%index_datpro_sx, progrid%index_datpro_sy
     write(0,*)'progrid%index_sx/sy-end    ', progrid%index_datpro_sx_end, progrid%index_datpro_sy_end
     write(0,*)'progrid%index_pgxmin/pgxmax', progrid%index_datpro_gxmin, progrid%index_datpro_gxmax  
     write(0,*)'progrid%index_pgymin/pgymax', progrid%index_datpro_gymin, progrid%index_datpro_gymax
     write(0,*)'progrid%index_igxmin/igxmax', progrid%index_gxmin, progrid%index_gxmax  
     write(0,*)'progrid%index_igymin/igymax', progrid%index_gymin, progrid%index_gymax  
     write(0,*)'----------------------------------------------------------'
     endif
  end subroutine

!######################################################################
 subroutine migration_grid()
    call from_param("max_hx", max_hx, -99999.);     call from_param("min_hx", min_hx, -99999.); 
    call from_param("max_hy", max_hy, -99999.);     call from_param("min_hy", min_hy, -99999.); 

    igrid%ax%o=max(min_x,vgrid%ax%o); igrid%ay%o=max(min_y,vgrid%ay%o); igrid%az%o=max(min_z,vgrid%az%o)
    igrid%ax%n=vgrid%ax%n           ; igrid%ay%n=vgrid%ay%n           ; igrid%az%n=vgrid%az%n
    igrid%ax%d=vgrid%ax%d           ; igrid%ay%d=vgrid%ay%d           ; igrid%az%d=vgrid%az%d           ;igrid%ahx%d=igrid%ax%d; igrid%ahy%d=igrid%ay%d
    if (max_hx ==-99999. .and. min_hx==-99999. ) then;  
        igrid%ahx%n=1; igrid%ahx%o=0.; 
    elseif (min_hx==-99999. .and. max_hx /= -99999.) then; 
        min_hx=-max_hx; igrid%ahx%n=1.5 + (max_hx - min_hx)/igrid%ax%d; igrid%ahx%o=min_hx;  
    elseif (min_hx/=-99999. .and. max_hx == -99999.) then; 
        max_hx=-min_hx; igrid%ahx%n=1.5 + (max_hx - min_hx)/igrid%ax%d; igrid%ahx%o=min_hx;
    else
                        igrid%ahx%n=1.5 + (max_hx - min_hx)/igrid%ax%d; igrid%ahx%o=min_hx;
    endif
    if (max_hy ==-99999. .and. min_hy==-99999. ) then;  
        igrid%ahy%n=1; igrid%ahy%o=0.; 
    elseif (min_hy==-99999. .and. max_hy /= -99999.) then; 
        min_hy=-max_hy; igrid%ahy%n=1.5 + (max_hy - min_hy)/igrid%ay%d; igrid%ahy%o=min_hy;  
    elseif (min_hy/=-99999. .and. max_hy == -99999.) then; 
        max_hy=-min_hy; igrid%ahy%n=1.5 + (max_hy - min_hy)/igrid%ay%d; igrid%ahy%o=min_hy; 
    else
                        igrid%ahy%n=1.5 + (max_hy - min_hy)/igrid%ay%d; igrid%ahy%o=min_hy;
    endif

    write(0,'(A65)')'========================Summary migration============================'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','hx  ','|',igrid%ahx  , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','hy  ','|',igrid%ahy  , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','x   ','|',igrid%ax   , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','y   ','|',igrid%ay   , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','z   ','|',igrid%az   , '|'
    write(0,'(A65)')'===================================================================='
  end subroutine
!=============================================
  subroutine migration_grid_in()
    call auxin(mig_); call ainaxis(mig_,igrid%ahx,1); call ainaxis(mig_,igrid%ahy,2); call ainaxis(mig_,igrid%ax,3); call ainaxis(mig_,igrid%ay,4); call ainaxis(mig_,igrid%az,5); 

    write(0,*)'Summary migration======================================'
    write(0,*) 'hx             : ',igrid%ahx
    write(0,*) 'hy             : ',igrid%ahy
    write(0,*) 'x              : ',igrid%ax
    write(0,*) 'y              : ',igrid%ay
    write(0,*) 'z              : ',igrid%az
    write(0,*)'======================================================='
  end subroutine


 subroutine table1_int()
 end subroutine
 subroutine table3_int()
 end subroutine
 subroutine table2_int()
 end subroutine

 

 end module
