!hessian compute
module joint_hessian_params
  use type_mod
  use joint_encode_params
  use ctaper_mod
  use util_
  use sep

    implicit none
    real   , dimension(:,:)      , pointer, private     :: dgrid_header_rec_save
    real                                  , private     :: dgrid_gxmin_save
    real                                  , private     :: dgrid_gymin_save
    real                                  , private     :: jj, ii, iskip
    integer                                             :: index_null_gxmin, index_null_gxmax
    real                                                :: null_gxmin, null_gxmax 
    integer                               , private     :: ixhole, iyhole

    complex, dimension(:,:,:,:,:          ), allocatable :: greens1
    complex, dimension(:,:,:,:,:          ), allocatable :: greens_s
    complex, dimension(:,:,:,:,:          ), allocatable :: greens_r
    complex, dimension(:,:,:,:,:          ), allocatable :: greens_s1!temp sou greens
    complex, dimension(:,:,:,:,:          ), allocatable :: greens_r1!temp rec greens
    complex, dimension(:                  ), allocatable :: greens_rec
    complex, dimension(:                  ), allocatable :: greens_so
    real,    dimension(:,:                ), allocatable :: hessian0
    real,    dimension(:,:,:,:,:,:,:      ), allocatable :: hessian1
    real,    dimension(:,:,:,:,:,:,:      ), allocatable :: hessian2
    real,    dimension(:,:,:,:,:,:        ), allocatable :: hessian3
!   real,    dimension(:,:,:,:,:,:,:,:,:,:), allocatable :: hessian4
! num realizations
    integer                                ,save         :: ireal,nreal_hess
 

contains
!==========================================================================================
  subroutine hessian_params()
    use qsort
    real    :: xmin_modl_default, xmax_modl_default
    real    :: ymin_modl_default, ymax_modl_default
    real    :: zmin_modl_default, zmax_modl_default
    real    :: surface_xmin_default, surface_xmax_default
    real    :: surface_ymin_default, surface_ymax_default
    integer :: ixn, iyn, izn

    !============================================================
    !call from_param("nsx", dgrid%asx%n, 1); call from_param("dsx", dgrid%asx%d,  1.); call from_param("osx", dgrid%asx%o,  0.) 
    !call from_param("nsy", dgrid%asy%n, 1); call from_param("dsy", dgrid%asy%d,  1.); call from_param("osy", dgrid%asy%o,  0.) 
    !call from_param("ngx", dgrid%agx%n, 1); call from_param("dgx", dgrid%agx%d,  1.); call from_param("ogx", dgrid%agx%o,  0.)
    !call from_param("ngy", dgrid%agy%n, 1); call from_param("dgy", dgrid%agy%d,  1.); call from_param("ogy", dgrid%agy%o,  0.)
    dgrid%nsh = dgrid%asx%n * dgrid%asy%n     !num  of sources..
    dgrid%ntr = dgrid%agx%n * dgrid%agy%n   !num. of traces/recievers
   !============================================================
    !sub-offset off-diags
    call from_param("nhx_offd", hgrid%ahx_offd%n, 1 ); call from_param("dhx_offd", hgrid%ahx_offd%d, vgrid%ax%d); call from_param("ohx_offd", hgrid%ahx_offd%o, 0.)
    call from_param("nhy_offd", hgrid%ahy_offd%n, 1 ); call from_param("dhy_offd", hgrid%ahy_offd%d, vgrid%ay%d); call from_param("ohy_offd", hgrid%ahy_offd%o, 0.)
    !off-diags
    call from_param(" nx_offd",  hgrid%ax_offd%n, 1 ); call from_param(" dx_offd",  hgrid%ax_offd%d, vgrid%ax%d); call from_param(" ox_offd",  hgrid%ax_offd%o, 0.)               
    call from_param(" ny_offd",  hgrid%ay_offd%n, 1 ); call from_param(" dy_offd",  hgrid%ay_offd%d, vgrid%ay%d); call from_param(" oy_offd",  hgrid%ay_offd%o, 0.)
    call from_param(" nz_offd",  hgrid%az_offd%n, 1 ); call from_param(" dz_offd",  hgrid%az_offd%d, vgrid%az%d); call from_param(" oz_offd",  hgrid%az_offd%o, 0.)
    !sub-offset
    call from_param("nhx_modl", hgrid%ahx_modl%n, 1 ); call from_param("dhx_modl", hgrid%ahx_modl%d, vgrid%ax%d); call from_param("ohx_modl", hgrid%ahx_modl%o, 0.)
    call from_param("nhy_modl", hgrid%ahy_modl%n, 1 ); call from_param("dhy_modl", hgrid%ahy_modl%d, vgrid%ay%d); call from_param("ohy_modl", hgrid%ahy_modl%o, 0.)
    !============================================================
    !main-model
    xmin_modl_default = vgrid%ax%o; xmax_modl_default = vgrid%ax%o + (vgrid%ax%n-1)*vgrid%ax%d
    ymin_modl_default = vgrid%ay%o; ymax_modl_default = vgrid%ay%o + (vgrid%ay%n-1)*vgrid%ay%d
    zmin_modl_default = vgrid%az%o; zmax_modl_default = vgrid%az%o + (vgrid%az%n-1)*vgrid%az%d

    izn=0; ixn=0; iyn=0;
    call from_param("xmin_modl", hgrid%xmin_modl, xmin_modl_default);call from_param("ymin_modl", hgrid%ymin_modl, ymin_modl_default); hgrid%xmax_modl=min(hgrid%xmax_modl,vgrid%ax%o+(vgrid%ax%n-1)*vgrid%ax%d)
    call from_param("xmax_modl", hgrid%xmax_modl, xmax_modl_default);call from_param("ymax_modl", hgrid%ymax_modl, ymax_modl_default); hgrid%ymax_modl=min(hgrid%ymax_modl,vgrid%ay%o+(vgrid%ay%n-1)*vgrid%ay%d)
    call from_param("zmin_modl", hgrid%zmin_modl, zmin_modl_default);call from_param("zmax_modl", hgrid%zmax_modl, zmax_modl_default); hgrid%zmax_modl=min(hgrid%zmax_modl,vgrid%az%o+(vgrid%az%n-1)*vgrid%az%d)
    ixn =   1.5 + (hgrid%xmax_modl-hgrid%xmin_modl)/vgrid%ax%d
    iyn =   1.5 + (hgrid%ymax_modl-hgrid%ymin_modl)/vgrid%ay%d
    izn =   1.5 + (hgrid%zmax_modl-hgrid%zmin_modl)/vgrid%az%d

    call from_param(" nx_modl",  hgrid%ax_modl%n, ixn); call from_param(" dx_modl",  hgrid%ax_modl%d, vgrid%ax%d); call from_param(" ox_modl",  hgrid%ax_modl%o, hgrid%xmin_modl)
    call from_param(" ny_modl",  hgrid%ay_modl%n, iyn); call from_param(" dy_modl",  hgrid%ay_modl%d, vgrid%ay%d); call from_param(" oy_modl",  hgrid%ay_modl%o, hgrid%ymin_modl)
    call from_param(" nz_modl",  hgrid%az_modl%n, izn); call from_param(" dz_modl",  hgrid%az_modl%d, vgrid%az%d); call from_param(" oz_modl",  hgrid%az_modl%o, hgrid%zmin_modl)
    
    hgrid%xmin_modl=hgrid%ax_modl%o; hgrid%ymin_modl=hgrid%ay_modl%o; hgrid%zmin_modl=hgrid%az_modl%o
    
    hgrid%xmax_modl=hgrid%ax_modl%o+(hgrid%ax_modl%n-1)*hgrid%ax_modl%d
    hgrid%ymax_modl=hgrid%ay_modl%o+(hgrid%ay_modl%n-1)*hgrid%ay_modl%d
    hgrid%zmax_modl=hgrid%az_modl%o+(hgrid%az_modl%n-1)*hgrid%az_modl%d

    !============================================================
    write(0,'(A65)')'================================================================'
    write(0,'(A65)')'Summary Hessian                                        ========='
    write(0,'(A65)')'================================================================'
    write(0,*      )'ahx_offd:n_d_o',hgrid%ahx_offd; write(0,*)'ahy_offd:n_d_o',hgrid%ahy_offd; write(0,*)' ax_offd:n_d_o',hgrid%ax_offd; write(0,*)' ay_offd:n_d_o',hgrid%ay_offd; write(0,*)' az_offd:n_d_o',hgrid%az_offd
    write(0,'(A65)')'================================================================'
    write(0,*      )'ahx_modl:n_d_o',hgrid%ahx_modl; write(0,*)'ahy_modl:n_d_o',hgrid%ahy_modl; write(0,*)' ax_modl:n_d_o',hgrid%ax_modl; write(0,*)' ay_modl:n_d_o',hgrid%ay_modl; write(0,*)' az_modl:n_d_o',hgrid%az_modl
    write(0,'(A65)')'================================================================'
    !============================================================
    report_ = "report"    ; 
    call from_param("marine"      , marine       , F      )
    call from_param("jw"          , jw           , 1      )
    call from_param("nostack"     , nostack      , .false.)
    call from_param("taper"       , taper        , .true. )
    call from_param("taper_pct"   , taper_pct    , 0.1    )
    call from_param("taper_type"  , taper_type   , 2      )
    call from_param("nodes     "  , nodes        , 1      )
    call from_param("verb      "  , verb         , 1      ) 
    call from_param("spike     "  , spike        , .false.)
    !============================================================
    call from_param("hole"        , hole         , F      )
    call from_param("ghole"       , ghole        , F      )
    call from_param("shole"       , shole        , F      )

    if(.not. hole) shole=F        
    if(.not. hole) ghole=F        
    if(.not.shole.and.(.not.(ghole)))hole=F
    call from_param("hole_sx1"    , hole_sx1     ,-999999.)
    call from_param("hole_sy1"    , hole_sy1     ,-999999.)
    call from_param("hole_gx1"    , hole_gx1     ,-999999.)
    call from_param("hole_gy1"    , hole_gy1     ,-999999.)
    call from_param("hole_sx2"    , hole_sx2     ,-999999.)
    call from_param("hole_sy2"    , hole_sy2     ,-999999.)
    call from_param("hole_gx2"    , hole_gx2     ,-999999.)
    call from_param("hole_gy2"    , hole_gy2     ,-999999.)
    call from_param("nxhole"      , nxhole       , 0      )
    call from_param("dxhole"      , dxhole       , 0.     )
    call from_param("oxhole"      , oxhole       , 0.     )
    call from_param("nyhole"      , nyhole       , 0      )
    call from_param("dyhole"      , dyhole       , 0.     )
    call from_param("oyhole"      , oyhole       , 0.     )
    !============================================================
    call from_param("lrand_gx"    , lrand_gx     , F      ); call from_param("randgx",randgx_,'randgx'); 
    call from_param("lrand_gy"    , lrand_gy     , F      ); call from_param("randgy",randgy_,'randgy');
    call from_param("lrand_sx"    , lrand_sx     , F      ); call from_param("randsx",randsx_,'randsx');
    call from_param("lrand_sy"    , lrand_sy     , F      ); call from_param("randsy",randsy_,'randsy');
    write(0,'(A65)')'Summary random data=============================================='
    write(0,*)"lrand_gx:",lrand_gx,"randgy:",lrand_gy
    write(0,*)"lrand_sx:",lrand_sx,"randsy:",lrand_sy
    write(0,'(A65)')'End random======================================================='
    ih_sx1=1; ih_sy1=1;ih_gy1=1;ih_gy1=1  
    ih_sx2=1; ih_sy2=1;ih_gy2=1;ih_gy2=1  
    ggrid%ax_surf%d=min(dgrid%asx%d,dgrid%agx%d)
    ggrid%ay_surf%d=min(dgrid%asy%d,dgrid%agy%d)
    if(offset)then
        ggrid%ax_surf%o=dgrid%asx%o+dgrid%agx%o
        ggrid%ay_surf%o=dgrid%asy%o+dgrid%agy%o
    else
        ggrid%ax_surf%o=min(dgrid%asx%o,dgrid%agx%o)
        ggrid%ay_surf%o=min(dgrid%asy%o,dgrid%agy%o)
    endif
    if(.not. hole)then 
                write(0,*)'No hole in data..good..No need to worry...'
    else
        if(marine)then
                ih_sx1=1.5+(hole_sx1-ggrid%ax_surf%o)/ggrid%ax_surf%d;	ih_sx2=1.5+(hole_sx2-ggrid%ax_surf%o)/ggrid%ax_surf%d;
                ih_sy1=1.5+(hole_sy1-ggrid%ay_surf%o)/ggrid%ay_surf%d;	ih_sy2=1.5+(hole_sy2-ggrid%ay_surf%o)/ggrid%ay_surf%d;	
                ih_gx1=1.5+(hole_gx1-ggrid%ax_surf%o)/ggrid%ax_surf%d;	ih_gx2=1.5+(hole_gx2-ggrid%ax_surf%o)/ggrid%ax_surf%d;
                ih_gy1=1.5+(hole_gy1-ggrid%ay_surf%o)/ggrid%ay_surf%d;	ih_gy2=1.5+(hole_gy2-ggrid%ay_surf%o)/ggrid%ay_surf%d;
                if(hole_sx1<=hole_sx2.and.ih_sx1>1.and.ih_sx2<dgrid%asx%n) then; if(shole)write(0,*)'hole sx           : ', ih_sx1, ih_sx2;endif
                if(hole_sy1<=hole_sy2.and.ih_sy1>1.and.ih_sx2<dgrid%asx%n) then; if(shole)write(0,*)'hole sy           : ', ih_sy1, ih_sy2;endif
                if(hole_gx1<=hole_gx2                                    ) then; if(ghole)write(0,*)'hole gx           : ', ih_gx1, ih_gx2;endif
                if(hole_gy1<=hole_gy2                                    ) then; if(ghole)write(0,*)'hole gy           : ', ih_gy1, ih_gy2;endif
        else
                ih_sx1=1.5+(hole_sx1-dgrid%asx%o)/dgrid%asx%d;	ih_sx2=1.5+(hole_sx2-dgrid%asx%o)/dgrid%asx%d;
                ih_sy1=1.5+(hole_sy1-dgrid%asy%o)/dgrid%asy%d;	ih_sy2=1.5+(hole_sy2-dgrid%asy%o)/dgrid%asy%d;	
                if(hole_sx1<=hole_sx2.and.ih_sx1>1.and.ih_sx2<dgrid%asx%n) then; if(shole)write(0,*)'hole sx           : ', ih_sx1, ih_sx2;endif
                if(hole_sy1<=hole_sy2.and.ih_sy1>1.and.ih_sx2<dgrid%asx%n) then; if(shole)write(0,*)'hole sy           : ', ih_sy1, ih_sy2;endif
                ih_gx1=1.5+(hole_gx1-dgrid%agx%o)/dgrid%agx%d;	ih_gx2=1.5+(hole_gx2-dgrid%agx%o)/dgrid%agx%d;
                ih_gy1=1.5+(hole_gy1-dgrid%agy%o)/dgrid%agy%d;	ih_gy2=1.5+(hole_gy2-dgrid%agy%o)/dgrid%agy%d;
                if(hole_gx1<=hole_gx2.and.ih_gx1>1.and.ih_gx2<dgrid%agx%n) then; if(ghole)write(0,*)'hole gx           : ', ih_gx1, ih_gx2;endif
                if(hole_gy1<=hole_gy2.and.ih_gy1>1.and.ih_gy2<dgrid%agy%n) then; if(ghole)write(0,*)'hole gy           : ', ih_gy1, ih_gy2;endif
        endif
        write(0,*)"nxhole,dxhole,oxhole:",nxhole,dxhole,oxhole
        write(0,*)"nyhole,dyhole,oyhole:",nyhole,dyhole,oyhole
    endif
    
    allocate(ihh_sx1(nxhole),ihh_sx2(nxhole),ihh_sy1(nyhole),ihh_sy2(nyhole))
    allocate(ihh_gx1(nxhole),ihh_gx2(nxhole),ihh_gy1(nyhole),ihh_gy2(nyhole))
    
    if(hole)then
            do ixhole=1,nxhole
                    if(shole)then; ihh_sx1(ixhole)=ih_sx1+(ixhole-1)*dxhole; ihh_sx2(ixhole)=ih_sx2+(ixhole-1)*dxhole; write(0,*)'ihole, hole sx : ', ixhole,ihh_sx1(ixhole), ihh_sx2(ixhole);endif
                    if(ghole)then; ihh_gx1(ixhole)=ih_gx1+(ixhole-1)*dxhole; ihh_gx2(ixhole)=ih_gx2+(ixhole-1)*dxhole; write(0,*)'ihole, hole gx : ', ixhole,ihh_gx1(ixhole), ihh_gx2(ixhole);endif
            end do
            do iyhole=1,nyhole
                    if(shole)then; ihh_sy1(iyhole)=ih_sy1+(iyhole-1)*dyhole; ihh_sy2(iyhole)=ih_sy2+(iyhole-1)*dyhole; write(0,*)'ihole, hole sy : ', iyhole,ihh_sy1(iyhole), ihh_sy2(iyhole);endif
                    if(ghole)then; ihh_gy1(iyhole)=ih_gy1+(iyhole-1)*dyhole; ihh_gy2(iyhole)=ih_gy2+(iyhole-1)*dyhole; write(0,*)'ihole, hole gy : ', iyhole,ihh_gy1(iyhole), ihh_gy2(iyhole);endif
            end do
    endif
    nlive_gx=dgrid%agx%n; nlive_sx=dgrid%asx%n;
    nlive_gy=dgrid%agy%n; nlive_sy=dgrid%asy%n; 
    write(0,'(A65)')'================================================================'
    write(0,'(A65)')'Summary hole===================================================='
    if(.not. hole .and. .not.(lrand_gx.or.lrand_gy.or.lrand_sx.or.lrand_sy))then 
        write(0,*)'No missing data..good..No need to worry...' 
        allocate(live_gx(nlive_gx)); allocate(live_sx(nlive_sx));allocate(live_gy(nlive_gy)); allocate(live_sy(nlive_sy));
    elseif(hole)then
        if(ih_gx2==ih_gx1)then;nlive_gx=nlive_gx; else; nlive_gx=nlive_gx-(ih_gx2-ih_gx1+1); endif
        if(ih_gy2==ih_gy1)then;nlive_gy=nlive_gy; else; nlive_gy=nlive_gy-(ih_gy2-ih_gy1+1); endif
        if(ih_sx2==ih_sx1)then;nlive_sx=nlive_sx; else; nlive_sx=nlive_sx-(ih_sx2-ih_sx1+1); endif
        if(ih_sy2==ih_sy1)then;nlive_sy=nlive_sy; else; nlive_sy=nlive_sy-(ih_sy2-ih_sy1+1); endif
        if(allocated(live_gx))deallocate(live_gx); allocate(live_gx(nlive_gx));
        if(allocated(live_gy))deallocate(live_gy); allocate(live_gy(nlive_gy));
        if(allocated(live_sx))deallocate(live_sx); allocate(live_sx(nlive_sx));
        if(allocated(live_sy))deallocate(live_sy); allocate(live_sy(nlive_sy));
    else
        if(lrand_gx.or.lrand_gy)then
                write(0,*)'Will not compute missing reciver locations...'
                if(lrand_gx)then
                        if(allocated(rand1))deallocate(rand1); allocate(rand1(dgrid%agx%n)) 
                        open (file=trim(randgx_), unit=10, status='unknown'); 
                        do igx=1,dgrid%agx%n; 
                                read(10,*,err=11,end=11)rand1(igx); 
                        enddo
11                      allocate(rand_gx(igx-1));rand_gx=rand1(1:igx-1);deallocate(rand1); close(10)
                        nlive_gx=dgrid%agx%n-size(rand_gx)
                        if(allocated(live_gx))deallocate(live_gx); allocate(live_gx(nlive_gx)); 
                endif
                if(lrand_gy)then
                        if(allocated(rand1))deallocate(rand1); allocate(rand1(dgrid%agy%n))
                        open (file=trim(randgy_), unit=10, status='unknown'); 
                        do igy=1,dgrid%agy%n; 
                                read(10,*,err=12,end=12)rand1(igy); 
                        enddo
12                      allocate(rand_gy(igy-1));rand_gy=rand1(1:igy-1);deallocate(rand1); close(10)
                        nlive_gy=dgrid%agy%n-size(rand_gy)
                        if(allocated(live_gy))deallocate(live_gy); allocate(live_gy(nlive_gy)); 
                else
                        if(allocated(live_gy))deallocate(live_gy); allocate(live_gy(nlive_gy)); 
                endif
        endif
        if(lrand_sx.or.lrand_sy)then
                write(0,*)'Will not compute missing shot locations...'
                if(lrand_sx)then
                        if(allocated(rand1))deallocate(rand1); allocate(rand1(dgrid%asx%n))
                        open (file=trim(randsx_), unit=10, status='unknown'); 
                        do isx=1,dgrid%asx%n; 
                                read(10,*,err=13,end=13)rand1(isx); 
                        enddo
13                      allocate(rand_sx(isx-1));rand_sx=rand1(1:isx-1);deallocate(rand1); close(10)
                        nlive_sx=dgrid%asx%n-size(rand_sx)
                        if(allocated(live_sx))deallocate(live_sx); allocate(live_sx(nlive_sx)); 
                else
                        if(allocated(live_sx))deallocate(live_sx); allocate(live_sx(nlive_sx)); 
                endif
                if(lrand_sy)then
                        if(allocated(rand1))deallocate(rand1); allocate(rand1(dgrid%asy%n))
                        open (file=trim(randsy_), unit=10, status='unknown'); 
                        do isy=1,dgrid%asy%n; 
                                read(10,*,err=14,end=14)rand1(isy); 
                        enddo
14                      allocate(rand_sy(isy-1));rand_sy=rand1(1:isy-1);deallocate(rand1); close(10)
                        nlive_sy=dgrid%asy%n-size(rand_sy)
                        if(allocated(live_sy))deallocate(live_sy); allocate(live_sy(nlive_sy));
                else
                        if(allocated(live_sy))deallocate(live_sy); allocate(live_sy(nlive_sy));
                endif
        endif
    endif
    write(0,'(A65)')'================================================================'
    !============================================================initialize the live sources and recievers
    if(.not.marine)then
            if(lrand_gx)then; ii=0; do igx=1,dgrid%agx%n; iskip=0; do jj=1,size(rand_gx); if(igx==rand_gx(jj)) then; iskip=iskip+1; cycle; endif; enddo; if(iskip>0)cycle; ii=ii+1; live_gx(ii)=igx; enddo; 
                elseif(ih_gx1<ih_gx2)then; ii=0; do igx=1,dgrid%agx%n; if(igx>ih_gx2 .or. igx<ih_gx1 ) then; ii=ii+1; live_gx(ii)=igx; endif; enddo; else; do igx=1,dgrid%agx%n; live_gx(igx)=igx; enddo; endif
        
            if(lrand_gy)then; ii=0; do igy=1,dgrid%agy%n; iskip=0; do jj=1,size(rand_gy); if(igy==rand_gy(jj)) then; iskip=iskip+1; cycle; endif; enddo; if(iskip>0)cycle; ii=ii+1; live_gy(ii)=igy; enddo; 
                elseif(ih_gy1<ih_gy2)then; ii=0; do igy=1,dgrid%agy%n; if(igy>ih_gy2 .or. igy<ih_gy1 ) then; ii=ii+1; live_gx(ii)=igy; endif; enddo; else; do igy=1,dgrid%agy%n; live_gy(igy)=igy; enddo; endif
    endif    
    if(lrand_sx)then; ii=0; do isx=1,dgrid%asx%n; iskip=0; do jj=1,size(rand_sx); if(isx==rand_sx(jj)) then; iskip=iskip+1; cycle; endif; enddo; if(iskip>0)cycle; ii=ii+1; live_sx(ii)=isx; enddo; 
        elseif(ih_sx1<ih_sx2)then; ii=0; do isx=1,dgrid%asx%n; if(isx>ih_sx2 .or. isx<ih_sx1 ) then; ii=ii+1; live_sx(ii)=isx; endif; enddo; else; do isx=1,dgrid%asx%n; live_sx(isx)=isx; enddo; endif

    if(lrand_sy)then; ii=0; do isy=1,dgrid%asy%n; iskip=0; do jj=1,size(rand_sy); if(isy==rand_sy(jj)) then; iskip=iskip+1; cycle; endif; enddo; if(iskip>0)cycle; ii=ii+1; live_sy(ii)=isy; enddo; 
        elseif(ih_sy1<ih_sy2)then; ii=0; do isy=1,dgrid%asy%n; if(isy>ih_sy2 .or. isy<ih_sy1 ) then; ii=ii+1; live_sy(ii)=isy; endif; enddo; else; do isy=1,dgrid%asy%n; live_sy(isy)=isy; enddo; endif
    allocate(irand_gx(size(rand_gx))); call quick_sort(rand_gx,irand_gx); deallocate(irand_gx);
    allocate(irand_gy(size(rand_gy))); call quick_sort(rand_gy,irand_gy); deallocate(irand_gy);
    allocate(irand_sx(size(rand_sx))); call quick_sort(rand_sx,irand_sx); deallocate(irand_sx);
    allocate(irand_sy(size(rand_sy))); call quick_sort(rand_sy,irand_sy); deallocate(irand_sy);
  end subroutine
!============================================================initialize the live sources and recievers
  subroutine green_param()
    !ggrid modl. params
    call from_param("ngx_modl", ggrid%ax_modl%n,min(hgrid%ax_modl%n+hgrid%ax_offd%n-1,vgrid%ax%n)); call from_param("dgx_modl", ggrid%ax_modl%d, hgrid%ax_modl%d); call from_param("ogx_modl", ggrid%ax_modl%o, max(hgrid%ax_modl%o+hgrid%ax_offd%o,vgrid%ax%o))
    call from_param("ngy_modl", ggrid%ay_modl%n,min(hgrid%ay_modl%n+hgrid%ay_offd%n-1,vgrid%ay%n)); call from_param("dgy_modl", ggrid%ay_modl%d, hgrid%ay_modl%d); call from_param("ogy_modl", ggrid%ay_modl%o, max(hgrid%ay_modl%o+hgrid%ay_offd%o,vgrid%ay%o))
    call from_param("ngz_modl", ggrid%az_modl%n,min(hgrid%az_modl%n+hgrid%az_offd%n-1,vgrid%az%n)); call from_param("dgz_modl", ggrid%az_modl%d, hgrid%az_modl%d); call from_param("ogz_modl", ggrid%az_modl%o, max(hgrid%az_modl%o+hgrid%az_offd%o,vgrid%az%o))
  
    ggrid%index_pro_minz=1.5+(ggrid%az_modl%o                                    -vgrid%az%o)/vgrid%az%d
    ggrid%index_pro_maxz=1.5+(ggrid%az_modl%o+(ggrid%az_modl%n-1)*ggrid%az_modl%d-vgrid%az%o)/vgrid%az%d
    
    ggrid%xmin_modl=max(ggrid%ax_modl%o,vgrid%ax%o)
    ggrid%ymin_modl=max(ggrid%ay_modl%o,vgrid%ay%o)
    ggrid%zmin_modl=max(ggrid%az_modl%o,vgrid%az%o)

    ggrid%xmax_modl=min(ggrid%ax_modl%o+(ggrid%ax_modl%n-1)*ggrid%ax_modl%d,vgrid%ax%o+(vgrid%ax%n-1)*vgrid%ax%d)
    ggrid%ymax_modl=min(ggrid%ay_modl%o+(ggrid%ay_modl%n-1)*ggrid%ay_modl%d,vgrid%ay%o+(vgrid%ay%n-1)*vgrid%ay%d) 
    ggrid%zmax_modl=min(ggrid%az_modl%o+(ggrid%az_modl%n-1)*ggrid%az_modl%d,vgrid%az%o+(vgrid%az%n-1)*vgrid%az%d)

    ggrid%index_mod_minx=1.5+(ggrid%xmin_modl-ggrid%ax_modl%o)/ggrid%ax_modl%d; ggrid%index_mod_maxx=1.5+(ggrid%xmax_modl-ggrid%ax_modl%o)/ggrid%ax_modl%d
    ggrid%index_mod_miny=1.5+(ggrid%ymin_modl-ggrid%ay_modl%o)/ggrid%ay_modl%d; ggrid%index_mod_maxy=1.5+(ggrid%ymax_modl-ggrid%ay_modl%o)/ggrid%ay_modl%d
    ggrid%index_mod_minz=1.5+(ggrid%zmin_modl-ggrid%az_modl%o)/ggrid%az_modl%d; ggrid%index_mod_maxz=1.5+(ggrid%zmax_modl-ggrid%az_modl%o)/ggrid%az_modl%d

    write(0,'(A65)')'========================Summary greens============================'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','ggrid%ax_surf  ','|',ggrid%ax_surf  , '|' 
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','ggrid%ay_surf  ','|',ggrid%ay_surf  , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','ggrid%ax_modl  ','|',ggrid%ax_modl  , '|' 
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','ggrid%ay_modl  ','|',ggrid%ay_modl  , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','ggrid%az_modl  ','|',ggrid%az_modl  , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','ggrid%aw       ','|',ggrid%aw       , '|'
    write(0,'(A2,A15,A2,I10                ,A2)') '|','ggrid%imod_minx','|',ggrid%index_mod_minx, '|'
    write(0,'(A2,A15,A2,I10                ,A2)') '|','ggrid%imod_maxx','|',ggrid%index_mod_maxx, '|'
    write(0,'(A2,A15,A2,I10                ,A2)') '|','ggrid%imod_miny','|',ggrid%index_mod_miny, '|'
    write(0,'(A2,A15,A2,I10                ,A2)') '|','ggrid%imod_maxy','|',ggrid%index_mod_maxy, '|'
    write(0,'(A2,A15,A2,I10                ,A2)') '|','ggrid%imod_minz','|',ggrid%index_mod_minz, '|'
    write(0,'(A2,A15,A2,I10                ,A2)') '|','ggrid%imod_maxz','|',ggrid%index_mod_maxz, '|'
    write(0,'(A65)')'------------------------------------------------------------------'

    if (wfld_d_out)then
        write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','wfld%at       ','|',dgrid%at       , '|'
    endif
    write(0,'(A65)')'------------------------------------------------------------------' 
    write(0,*) '|', 'spike ===>>',spike
    write(0,'(A65)')'====================================================================' 
  end subroutine
!==========================================================================================
  subroutine green_radians_calc()
        if (.not.radian) then; ggrid%aw%d = ggrid%aw%d * 2.0 * PI; ggrid%aw%o = ggrid%aw%o * 2.0 * PI; end if
  end subroutine
!========================================================================================== 
  
  end module
