!hessian compute
module joint_hessian_utils
  use type_mod
  use joint_encode_params
  use ctaper_mod
  use util_
  use sep
  implicit none 
contains
!==========================================================================================
  subroutine hess_output_history()
    !!!!!Outputs the Hessain details into the history file...
    hess_= "hess"; 
    call auxinout(hess_)
    call houaxis2(hess_, hgrid%ahx_offd, 1); call houaxis2(hess_, hgrid%ahy_offd, 2); call houaxis2(hess_, hgrid%ax_offd , 3); call houaxis2(hess_, hgrid%ay_offd , 4); call houaxis2(hess_, hgrid%az_offd , 5); 
    call houaxis2(hess_, hgrid%ahx_modl, 6); call houaxis2(hess_, hgrid%ahy_modl, 7); call houaxis2(hess_, hgrid%ax_modl , 8); call houaxis2(hess_, hgrid%ay_modl , 9); 
    call auxputch("n10", "i", hgrid%az_modl%n, hess_); call auxputch("d10", "r", hgrid%az_modl%d, hess_); call auxputch("o10", "r", hgrid%az_modl%o, hess_)
    !labels ==========================
    call auxputch("label1","s","hx_offd", hess_); call auxputch("label2","s","hy_offd", hess_); call auxputch("label3","s"," x_offd", hess_); call auxputch("label4","s"," y_offd", hess_); call auxputch("label5 ","s"," z_offd", hess_)
    call auxputch("label6","s","hx_modl", hess_); call auxputch("label7","s","hy_modl", hess_); call auxputch("label8","s"," x_modl", hess_); call auxputch("label9","s"," y_modl", hess_); call auxputch("label10","s"," z_modl", hess_)
    call auxputch("d11", "r", ggrid%aw%d, hess_); call auxputch("o11", "r", ggrid%aw%o, hess_); call auxputch("label11","s","w     ", hess_)
    if (nostack)then 
        call auxputch("n11", "i", ggrid%aw%n,hess_);  else; call auxputch("n11", "i", 1         ,hess_)
    endif 
  end subroutine 
!#####################################################
 subroutine                    hess_io_hess1(hessian,index_aw,index_x_modl,index_y_modl,index_z_modl, flag); 
    integer                                     ::  index_aw,index_hx_modl,index_hy_modl,index_x_modl,index_y_modl,index_z_modl 
    integer, dimension(11)                      ::  n_cube, j_wind, n_wind, f_wind
    integer                                     ::  n_dim_cube, err
    real, dimension(:,:,:,:,:),      allocatable::  hessian
    character(len=4)                            ::  flag

    n_dim_cube = 11
    n_cube = (/1 , 1 , hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, 1 , 1 , hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n, ggrid%aw%n/)
    j_wind = (/1 , 1 , 1              , 1              , 1              , 1 , 1 , 1              , 1              , 1              , 1         /)
    n_wind = (/1 , 1 , hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, 1 , 1 , 1              , 1              , 1              , 1         /)
    f_wind = (/0 , 0 , 0              , 0              , 0              , 0 , 0 , index_x_modl-1 , index_y_modl-1 , index_z_modl-1 , index_aw-1/)
    if (flag == "rite") then
                err = srite_window(hess_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian)
    else if (flag == "reed") then
                err = sreed_window(hess_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian)
    else
       call seperr("you have to specify the flag for data_io_data()")
    end if
    if (err /= 0) call seperr("hess_io_hess: error writing hessian")
  end subroutine
!##################################################### 
 subroutine                    hess_io_hess2(hessian,index_z_modl, flag); 
    integer                                     ::  index_z_modl 
    integer, dimension(10)                      ::  n_cube, j_wind, n_wind, f_wind
    integer                                     ::  n_dim_cube, err
    real, dimension(:,:,:,:,:)                  ::  hessian 
    real, dimension(:,:,:,:,:),allocatable      ::  hessian1
    character(len=4)                            ::  flag

    allocate(hessian1(hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, hgrid%ax_modl%n, hgrid%ay_modl%n))
    n_dim_cube = 10
    n_cube = (/1 , 1 , hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, 1 , 1 , hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n/)
    j_wind = (/1 , 1 , 1              , 1              , 1              , 1 , 1 , 1              , 1              , 1              /)
    n_wind = (/1 , 1 , hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, 1 , 1 , hgrid%ax_modl%n, hgrid%ay_modl%n, 1              /)
    f_wind = (/0 , 0 , 0              , 0              , 0              , 0 , 0 , 0              , 0              , index_z_modl-1 /)
    !write(0,'(11I7)') n_cube; write(0,'(11I7)') n_wind; write(0,'(11I7)') f_wind; write(0,'(11I7)') j_wind; write(0,*)'--'
     if (flag == "rite") then
                err = sreed_window(hess_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian1)
                err = srite_window(hess_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian+hessian1)
    else if (flag == "reed") then
                err = sreed_window(hess_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian)
    else
       call seperr("you have to specify the flag for data_io_data()")
    end if
    deallocate(hessian1)

    if (err /= 0) call seperr("hess_io_hess: error writing hessian")
  end subroutine
!##################################################### 
 subroutine                    hess_io_hess_offz(hessian,index_z_offd, flag); 
    integer                                     ::  index_z_offd 
    integer, dimension(10)                      ::  n_cube, j_wind, n_wind, f_wind
    integer                                     ::  n_dim_cube, err
    real, dimension(:,:,:,:,:)                  ::  hessian 
    real, dimension(:,:,:,:,:),allocatable      ::  hessian1
    character(len=4)                            ::  flag

    allocate(hessian1(hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n))
    n_dim_cube = 10
    n_cube = (/1 , 1 , hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, 1 , 1 , hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n/)
    j_wind = (/1 , 1 , 1              , 1              , 1              , 1 , 1 , 1              , 1              , 1              /)
    n_wind = (/1 , 1 , hgrid%ax_offd%n, hgrid%ay_offd%n, 1              , 1 , 1 , hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n/)
    f_wind = (/0 , 0 , 0              , 0              , index_z_offd-1 , 0 , 0 , 0              , 0              , 0              /)
    !write(0,'(11I7)') n_cube; write(0,'(11I7)') n_wind; write(0,'(11I7)') f_wind; write(0,'(11I7)') j_wind; write(0,*)'--'
     if (flag == "rite") then
                err = sreed_window(hess_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian1)
                err = srite_window(hess_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian+hessian1)
    else if (flag == "reed") then
                err = sreed_window(hess_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian)
    else
       call seperr("you have to specify the flag for data_io_data()")
    end if
    deallocate(hessian1)

    if (err /= 0) call seperr("hess_io_hess: error writing hessian")
  end subroutine
!#####################################################  
 subroutine                    hess_io_hess3(hessian, flag); 
    integer                                     ::  index_aw
    integer, dimension(11)                      ::  n_cube, j_wind, n_wind, f_wind
    integer                                     ::  n_dim_cube, err
    real, dimension(:,:,:,:,:,:)                ::  hessian
    character(len=4)                            ::  flag

    n_dim_cube = 11
    n_cube = (/1 , 1 , hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, 1 , 1 , hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n,1/)
    j_wind = (/1 , 1 , 1              , 1              , 1              , 1 , 1 , 1              , 1              , 1              ,1/)
    n_wind = (/1 , 1 , hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, 1 , 1 , hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n,1/)
    f_wind = (/0 , 0 , 0              , 0              , 0              , 0 , 0 , 0              , 0              , 0              ,0/)
    !write(0,'(11I7)') n_cube; write(0,'(11I7)') n_wind; write(0,'(11I7)') f_wind; write(0,'(11I7)') j_wind; write(0,*)'--'
    if (flag == "rite") then
                err = srite_window(hess_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian)
    else if (flag == "reed") then
                err = sreed_window(hess_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian)
    else
       call seperr("you have to specify the flag for data_io_data()")
    end if

    if (err /= 0) call seperr("hess_io_hess: error writing hessian")
  end subroutine
!#####################################################  
!initialize the full hessian to zeros.
 subroutine hess_io_init()
    real, allocatable, dimension(:) :: ctmp
    integer                         :: i, nloop
    allocate(ctmp(hgrid%ahx_modl%n*hgrid%ahy_modl%n*hgrid%ax_modl%n*hgrid%ay_modl%n*hgrid%az_modl%n))
    ctmp = 0.
          nloop = hgrid%ahx_offd%n*hgrid%ahy_offd%n*hgrid%ax_offd%n*hgrid%ay_offd%n*hgrid%az_offd%n
          write(*,*)'Initializing Hessian.....'
        if (nostack)then
                do i=1, nloop*ggrid%aw%n; call sep_write(ctmp, hess_, esize=4); end do
        else
                do i=1, nloop           ; call sep_write(ctmp, hess_, esize=4); end do
        endif
    deallocate(ctmp)
  end subroutine

  
  end module
