module joint_encode_data_history
  use joint_encode_params
  use map_mod, only: data_radians_calc, gre_radians_calc 

  implicit none
contains
!==========================================================================================
  subroutine data_output_history()
        type(axis)   , save :: ww
        ww%d=dgrid%aw%d/(2*PI)
        ww%o=dgrid%aw%o/(2*PI)
        ww%n=dgrid%aw%n

        if (lfreq)then
                write(*,*)'data===========>       freq!' 
                call auxinout(data_)
                if(use_greens)then
                        call houaxis(data_,dgrid%agx,1);call houaxis(data_,dgrid%agy,2); call houaxis(data_,ww,5); call houaxis(data_,wgrid%asx,3); call houaxis(data_,wgrid%asy,4);
                        call auxputch("label1", "s", "geoph_x", data_); call auxputch("label2", "s", "geoph_y", data_); call auxputch("label5", "s", "freq.  ", data_); call auxputch("label3", "s", "shot_x", data_); call auxputch("label4", "s", "shot_y", data_)
                else
                        call houaxis(data_,dgrid%agx,1);call houaxis(data_,dgrid%agy,2); call houaxis(data_,ww,3); call houaxis(data_,wgrid%asx,4); call houaxis(data_,wgrid%asy,5);
                        call auxputch("label1", "s", "geoph_x", data_); call auxputch("label2", "s", "geoph_y", data_); call auxputch("label3", "s", "freq.  ", data_); call auxputch("label4", "s", "shot_x", data_); call auxputch("label5", "s", "shot_y", data_)
                endif
                call to_history('esize', 8, data_)
        else
                call auxinout(data_)
                call houaxis(data_,dgrid%agx,1);call houaxis(data_,dgrid%agy,2); call houaxis(data_,dgrid%at,5); call houaxis(data_,dgrid%asx,3); call houaxis(data_,dgrid%asy,4);
                call auxputch("label1", "s", "geoph_x", data_)
                call auxputch("label2", "s", "geoph_y", data_)
                call auxputch("label5", "s", "time.  ", data_)
                call auxputch("label3", "s", "shot_x ", data_)
                call auxputch("label4", "s", "shot_y ", data_)
                call to_history('esize', 4, data_)
                write(*,*)'data=========>       time'
        endif

  end subroutine
!#####################################
 subroutine green_input_history()
        greens_='greens'
        if(use_greens)then
                if(exist_file(greens_))then
                        call hinaxis(greens_,ggrid%ax_surf,1); call hinaxis(greens_,ggrid%ay_surf,2); call hinaxis(greens_,ggrid%ax_modl,3); call hinaxis(greens_,ggrid%ay_modl,4); call hinaxis(greens_,ggrid%az_modl,5); call hinaxis(greens_,ggrid%aw,6);  
                        call auxpar("esize" , "i",  esize, greens_)
                else
                        call seperr("use_greens=y but file greens not specified: green_input_history")
                endif          
        elseif(use_greens)then
                call hinaxis(greens_,ggrid%ax_surf,1); call hinaxis(greens_,ggrid%ay_surf,2); call hinaxis(greens_,ggrid%ax_modl,3); call hinaxis(greens_,ggrid%ay_modl,4); call hinaxis(greens_,ggrid%az_modl,5); call hinaxis(greens_,ggrid%aw,6);  
                call auxpar("esize" , "i",  esize, greens_)
        endif
  end subroutine
!##################################################
  subroutine wfld_output_history(wfld_)
        character(len=256)        :: wfld_
        call auxinout(wfld_)
        call auxputch("n1","i",vgrid%ax%n,wfld_); call auxputch("n2","i",vgrid%ay%n,wfld_);call auxputch("n3","i",vgrid%az%n,wfld_); call auxputch("n4","i",dgrid%at%n,wfld_); 
        call auxputch("d1","r",vgrid%ax%d,wfld_); call auxputch("d2","r",vgrid%ay%d,wfld_);call auxputch("d3","r",vgrid%az%d,wfld_); call auxputch("d4","r",dgrid%at%d,wfld_);
        call auxputch("o1","r",vgrid%ax%o,wfld_); call auxputch("o2","r",vgrid%ay%o,wfld_);call auxputch("o3","r",vgrid%az%o,wfld_); call auxputch("o4","r",dgrid%at%o,wfld_);
        call auxputch("label1","s","nx",wfld_)
        call auxputch("label2","s","ny",wfld_)
        call auxputch("label3","s","nz",wfld_)
        call auxputch("label4","s","t" ,wfld_)
        call auxputch("esize" ,"i", 4  ,wfld_)
        if(wfld_d_out.and.wfld_u_out)call auxputch("n5","i",2,wfld_); 
  end subroutine
!##################################################
  subroutine data_input_history()
        type(axis)   , save :: ww
        if (lfreq)then
                call auxinout(data_)
                call hinaxis(data_,dgrid%agx,1);call hinaxis(data_,dgrid%agy,2); call hinaxis(data_,dgrid%aw,3); call hinaxis(data_,dgrid%asx,4); call hinaxis(data_,dgrid%asy,5);
        else
                call auxinout(data_)
                call hinaxis(data_,dgrid%agx,1);call hinaxis(data_,dgrid%agy,2); call hinaxis(data_,dgrid%at,5); call hinaxis(data_,dgrid%asx,3); call hinaxis(data_,dgrid%asy,4);
        endif
        if(.not. radian)then
                dgrid%aw%d=2*PI*dgrid%aw%d
                dgrid%aw%o=2*PI*dgrid%aw%o
                dgrid%aw%n=dgrid%aw%n
                wgrid%aw=dgrid%aw
        endif 
        write(0,*)dgrid%aw,'f'
  end subroutine
!##################################################
  subroutine data_header_history()
        type(axis)   , save :: ww
               call auxinout(dhdr_)
  end subroutine

  end module
