 module joint_encode_hlx_blk
! only for three dips!!!!! 0 -45 45
 use  joint_encode_hlx
 use joint_encode_prc
 use createhelix_mod
 use cartesian_mod
 use bound_mod
 use regrid_mod
 use adj_mod
 use lapfac_mod
 use polydiv_mod
 use helicon_mod
 use helix_mod

 implicit none
	integer, private, save:: stat	
        type( filter),   private                        :: aa 
        type( filter),   private                        :: bb 
        type( filter),   private                        :: ff0, ff45, ff_45
        real ,private,  dimension (:), allocatable      :: tt,xx1,xx2,xx3,yy1,yy2,yy3  
        real ,private,  dimension (:), allocatable      :: dipss,dipss1
        integer, private                                :: nd 

 contains 
!#####################################################  
    subroutine filter_init_blk(dips_in)
        integer,dimension(:),allocatable    ::nd,na,center,gap
        real   ,dimension(:),allocatable    ::cube
        real                                :: dips_in(:) 
        integer                             ::stat    , i,j

        allocate(na(2),center(2),nd(2),gap(2)) 
        na(1)=15                 ; na(2)=15; 
        nd(1)=vgrid%ax%n        ; nd(2)=vgrid%az%n; 
        center(1)=na(1)/2       ; center(2)=1; 
        gap=0
        allocate(dipss(nsurv*nmod),dipss1(nmod)) 
        dipss=dips_in
!        dipss1=dipss(1:nmod)

!write(0,*)dipss1

        allocate(xx1(nsurv*nmod),xx2(nsurv*nmod),xx3(nsurv*nmod)) 
        allocate(yy1(nsurv*nmod),yy2(nsurv*nmod),yy3(nsurv*nmod)) 
        

        ff0  =createhelix(nd, center, gap, na)
        ff45 =createhelix(nd, center, gap, na) 
        ff_45=createhelix(nd, center, gap, na)
        i=1;j=1
        ff0%flt   =0.        
        do stat=1, na(1)/2
                i=i+na(1)-1
                j=j+na(1)+1
               ff45%flt(j)=1
               ff_45%flt(i)=1
                write(0,*)i,j
        enddo
!        call transp(1,dipss1) !rearrange angles to z-1 x-2
!        dipss(1:nmod)=dipss1
!        dipss(nmod+1:2*nmod)=dipss1

        ff0%flt=0
        ff0%flt=0
!        call polyxdiv_init(nmod,ff0)
!        call helixcon_init(ff0)	
        deallocate (na,center,nd,gap)
    end subroutine
!#####################################################  conv or deconv
        integer function hlx_it_blks(adj, add, xx, yy) result(stat)
                logical,intent(in)      :: adj,add 
                real, dimension (:)     :: xx, yy 
                call joint_adjnull2 (adj,add, xx,yy)
                xx1=xx; xx2=xx; xx3=xx;
                yy1=yy; yy2=yy; yy3=yy;
hlx_conv=1
!write(0,*)sum(xx),sum(yy),adj,add
                call polyxdiv_init(vgrid%az%n,ff0);

!        ff0%flt   =  (/ 1,0,0/) 
!        ff45%flt  =  (/ 1,0,0/) 
!        ff_45%flt =  (/ 1,0,0/) 

                call polyxdiv_init(nmod,ff0);
                call helixcon_init(ff0  ); 
stat=hlx_it_blk(adj, add, xx1, yy1)
                call helixcon_init(ff45 ); 
                call polyxdiv_init(nmod,ff45);
stat=hlx_it_blk(adj, add, xx2, yy2)
                call helixcon_init(ff_45); 
                call polyxdiv_init(nmod,ff_45);
stat=hlx_it_blk(adj, add, xx3, yy3)
                xx=0.; yy=0.
                where(dipss== 0)xx=xx1; where(dipss== 0)yy=yy1
                where(dipss==-1)xx=xx2; where(dipss==-1)yy=yy2
                where(dipss==+1)xx=xx3; where(dipss==+1)yy=yy3
                !xx=xx1
                !yy=yy1
                stat=0
!write(0,*)sum(xx),sum(yy),adj,add
!write(0,*)sum(xx2),sum(yy2)
!stop        
        end function
!#####################################################  conv or deconv
        integer function hlx_it_blk(adj, add, xx, yy) result(stat)
                logical,intent(in) :: adj,add 
                real, dimension (:)  :: xx, yy 
                call joint_adjnull2 (adj,add, xx,yy)
!write(0,*)sum(xx),sum(yy),adj,add
                !if (nsurv > 5)call transp(1,m6,d6); if (nsurv > 4)call transp(1,m5,d5); if (nsurv > 3)call  transp(1,m4,d4);
                !if (nsurv > 2)call transp(1,m3,d3); if (nsurv > 1)call transp(1,m2,d2); if (nsurv > 0)call  transp(1,m1,d1);
                if (hlx_conv==1)then
                        if (nsurv > 5)call helixcon_lop2(adj,add,m6,d6); if (nsurv > 4)call helixcon_lop2(adj,add,m5,d5); if (nsurv > 3)call helixcon_lop2(adj,add,m4,d4);                                                           
                        if (nsurv > 2)call helixcon_lop2(adj,add,m3,d3); if (nsurv > 1)call helixcon_lop2(adj,add,m2,d2); if (nsurv > 0)call helixcon_lop2(adj,add,m1,d1);
                else
                        if (nsurv > 5)call polyxdiv_lop2(adj,add,m6,d6); if (nsurv > 4)call polyxdiv_lop2(adj,add,m5,d5); if (nsurv > 3)call polyxdiv_lop2(adj,add,m4,d4);                                                           
                        if (nsurv > 2)call polyxdiv_lop2(adj,add,m3,d3); if (nsurv > 1)call polyxdiv_lop2(adj,add,m2,d2); if (nsurv > 0)call polyxdiv_lop2(adj,add,m1,d1);
                endif
                !if (nsurv > 5)call transp(-1,m6,d6); if (nsurv > 4)call transp(-1,m5,d5); if (nsurv > 3)call  transp(-1,m4,d4);
                !if (nsurv > 2)call transp(-1,m3,d3); if (nsurv > 1)call transp(-1,m2,d2); if (nsurv > 0)call  transp(-1,m1,d1);
                stat=0

!write(0,*)sum(xx),sum(yy),adj,add

end function
!#####################################################  conv or deconv
        integer function hlx_it2_blk(adj, add, xx, yy) result(stat)
                logical,intent(in) :: adj,add 
                real, dimension (:)  :: xx, yy 
                call joint_adjnull2 (adj,add, xx,yy)
                if (hlx_conv==1)then
                        if (nsurv > 5)stat= helixcon_lop_2(adj,add,m6,d6); if (nsurv > 4)stat= helixcon_lop_2(adj,add,m5,d5); if (nsurv > 3)stat= helixcon_lop_2(adj,add,m4,d4);                                                           
                        if (nsurv > 2)stat= helixcon_lop_2(adj,add,m3,d3); if (nsurv > 1)stat= helixcon_lop_2(adj,add,m2,d2); if (nsurv > 0)stat= helixcon_lop_2(adj,add,m1,d1);
                else
                        if (nsurv > 5)stat= polyxdiv_lop_2(adj,add,m6,d6); if (nsurv > 4)stat= polyxdiv_lop_2(adj,add,m5,d5); if (nsurv > 3)stat= polyxdiv_lop_2(adj,add,m4,d4);                                                           
                        if (nsurv > 2)stat= polyxdiv_lop_2(adj,add,m3,d3); if (nsurv > 1)stat= polyxdiv_lop_2(adj,add,m2,d2); if (nsurv > 0)stat= polyxdiv_lop_2(adj,add,m1,d1);
                endif
                stat=0
        end function

!#####################################################  transp before filter and back
        subroutine transp(fwd,xx,yy)
                integer,intent(in)      :: fwd 
                real, dimension (:)     :: xx, yy 
                real, dimension(:,:), allocatable       :: temp
                optional                        :: yy

                if (fwd==1)then
                        allocate (temp(vgrid%ax%n,vgrid%az%n))
                        temp=reshape(xx,(/vgrid%ax%n,vgrid%az%n /)); xx=reshape(transpose(temp),(/ nmod /))
                        if(present(yy))then; temp=reshape(yy,(/vgrid%ax%n,vgrid%az%n /)); yy=reshape(transpose(temp),(/ nmod /)); endif
                else
                        allocate (temp(vgrid%az%n,vgrid%ax%n))
                        temp=reshape(xx,(/vgrid%az%n,vgrid%ax%n /)); xx=reshape(transpose(temp),(/ nmod /))
                        if(present(yy))then; temp=reshape(yy,(/vgrid%az%n,vgrid%ax%n /)); yy=reshape(transpose(temp),(/ nmod /));endif
                endif
                stat=0
                deallocate (temp)
        end subroutine

end module 
