!OW mig io
module joint_encode_data_io
  use joint_encode_params
  use joint_encode_data_history, only: wfld_output_history

  implicit none

contains
!#####################################################
  subroutine data_io_init()
        complex, allocatable, dimension(:) :: ctmp
        integer                            :: i, nloop
        if (.not. (adj.or.inv))then        
                write(*,*)"Initializing the born data"
                if(lfreq)then
                        if(encode) then
                                allocate(ctmp(dgrid%agx%n*dgrid%agy%n*dgrid%asx%n*dgrid%asy%n))
                        else
                                allocate(ctmp(dgrid%agx%n*dgrid%agy%n*wgrid%asx%n*wgrid%asy%n))
                        endif        
                        ctmp = (0,0)
                        nloop = dgrid%aw%n
                        do i=1, nloop
                                call sep_write(ctmp, data_, esize=8) 
                        end do
                else
                        allocate(ctmp(dgrid%at%n))
                        ctmp = 0
                        if(encode) then
                                nloop = dgrid%agx%n*dgrid%agy%n*dgrid%asx%n*dgrid%asy%n
                        else
                                nloop = dgrid%agx%n*dgrid%agy%n*wgrid%asx%n*wgrid%asy%n
                        endif        
                        do i=1, nloop
                                call sep_write(ctmp, data_, esize=4)
                        end do
                endif
        deallocate(ctmp)
        endif
  end subroutine
!#####################################################
  subroutine wfld_io_init(wfld_)
        complex, allocatable, dimension(:) :: ctmp
        integer                            :: i, nloop
        character(len=256)                 :: wfld_

        allocate(ctmp(vgrid%ax%n*vgrid%ay%n*dgrid%at%n))
        ctmp = (0,0)
        nloop = vgrid%az%n
        write(*,*)"Initializing the wfld_d"
        do i=1, nloop
!            call sep_write(ctmp, wfld_, esize=4)
        end do
        deallocate(ctmp)
  end subroutine
!#####################################################
  subroutine wfd_io_init(isurv)
        complex, allocatable, dimension(:)      :: ctmp
        integer                                 :: i, nloop
        integer                                 :: isurv
        character (len=256)                     :: wfld_

        if(isurv==1 )wfld_=wfld1_ ;if(isurv==2 )wfld_=wfld2_ ;if(isurv==3 )wfld_=wfld3_ ;if(isurv==4 )wfld_=wfld4_ ;if(isurv==5 )wfld_=wfld5_ ;
        if(isurv==6 )wfld_=wfld6_; if(isurv==7 )wfld_=wfld7_ ;if(isurv==8 )wfld_=wfld8_ ;if(isurv==9 )wfld_=wfld9_ ;if(isurv==10)wfld_=wfld10_;
        if(isurv==11)wfld_=wfld11_;if(isurv==12)wfld_=wfld12_;if(isurv==13)wfld_=wfld13_;if(isurv==14)wfld_=wfld14_;if(isurv==15)wfld_=wfld15_;
        
        call wfld_output_history (wfld_)
        
        allocate(ctmp(vgrid%ax%n*vgrid%ay%n*dgrid%at%n))
        ctmp = (0,0)
        nloop = vgrid%az%n
        write(*,*)"Initializing the wfld_d"
        do i=1, nloop
!            call sep_write(ctmp, wfld_, esize=4)
        end do
        deallocate(ctmp)
  end subroutine
!#####################################################
subroutine data_io_w(flag, data, index_aw )
    complex, dimension(:,:,:,:  ), allocatable :: data
    character(len=4)                    :: flag
    integer                             :: index_aw
    integer, dimension(5)               :: n_cube, j_wind, n_wind, f_wind
    integer                             :: n_dim_cube, err
    character :: y

    n_dim_cube = 5
    n_cube = (/dgrid%agx%n , dgrid%agy%n   , dgrid%asx%n   ,  dgrid%asy%n,dgrid%aw%n /)
    j_wind = (/1           , 1             , 1             ,           1 ,         1 /)
    n_wind = (/dgrid%agx%n , dgrid%agy%n   , dgrid%asx%n   , dgrid%asy%n ,         1 /)
    f_wind = (/0           , 0             , 0             ,           0 , index_aw-1/)
    !write(0,*)n_cube; write(0,*)n_wind; write(0,*)j_wind; write(0,*)f_wind; 
    !write(0,*)index_aw; write(0,*)size(data,1),size(data,2),size(data,3),size(data,4)

    if (flag == "rite") then;!       write(0,*)'writing data frequency: ', index_aw
        err = srite_window(data_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,data)
    else if (flag == "reed") then; !       write(0,*)'reading data frequency: ', index_aw
        data = 0.
        err = sreed_window(data_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,data)
    else
        call seperr("you have to specify the flag for data_io_data()")
    end if
    if (err /= 0) call seperr("data_io_data: error reading data")
  end subroutine
!#####################################################
subroutine data_io_data(flag, data, index_sx, index_sy )
    complex, dimension(:,:,:),  pointer         :: data
    character(len=4)                                     :: flag
    integer                                     :: index_sx, index_sy
    integer, dimension(5)                       :: n_cube, j_wind, n_wind, f_wind
    integer                                     :: n_dim_cube, err
    character :: y

    n_dim_cube = 5
    n_cube = (/dgrid%agx%n , dgrid%agy%n   , dgrid%aw%n    , dgrid%asx%n    ,  dgrid%asy%n/)
    j_wind = (/1           , 1             , 1             , 1              ,  1          /)
    n_wind = (/dgrid%agx%n , dgrid%agy%n   , dgrid%aw%n    , 1              ,  1          /)
    f_wind = (/0           , 0             , 0             , index_sx-1     , index_sy-1  /)
    !write(0,*)n_cube; write(0,*)n_wind; write(0,*)j_wind; write(0,*)f_wind; 
    !write(0,*)index_sx,index_sy; write(0,*)size(data,1),size(data,2),size(data,3),size(data),data_

    if (flag == "rite") then
       err = srite_window(data_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,data)
    else if (flag == "reed") then
       data = 0.
       err = sreed_window(data_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,data)
    else
       call seperr("you have to specify the flag for data_io_data()")
    end if
    if (err /= 0) call seperr("data_io_data: error reading data")
  end subroutine
!#####################################################
subroutine data_read(flag, dat, index_sx, index_sy, isurv )
    complex, dimension(:,:,:)                   :: dat
    character(len=4)                            :: flag 
    integer                                     :: isurv
    integer                                     :: index_sx, index_sy
    integer, dimension(5)                       :: n_cube, j_wind, n_wind, f_wind
    integer                                     :: n_dim_cube, err
    character                                   :: y
    character(len=256)                          :: dat_ 
    
    if(isurv==1)dat_=data1_; if(isurv==2)dat_=data2_ ; if(isurv==3)dat_=data3_  ; if(isurv==4)dat_=data4_  ; if(isurv==5)dat_=data5_  ; if(isurv==6)dat_=data6_  ; if(isurv==7)dat_=data7_; if(isurv==8)dat_=data8_
    if(isurv==9)dat_=data9_; if(isurv==10)dat_=data10_;if(isurv==11)dat_=data11_; if(isurv==12)dat_=data12_; if(isurv==13)dat_=data13_; if(isurv==14)dat_=data14_; if(isurv==15)dat_=data15_
    n_dim_cube = 5
    n_cube = (/dgrid%agx%n , dgrid%agy%n   , dgrid%aw%n    , dgrid%asx%n    ,  dgrid%asy%n/)
    j_wind = (/1           , 1             , 1             , 1              ,  1          /)
    n_wind = (/dgrid%agx%n , dgrid%agy%n   , dgrid%aw%n    , 1              ,  1          /)
    f_wind = (/0           , 0             , 0             , index_sx-1     , index_sy-1  /)
    !write(0,*)n_cube; write(0,*)n_wind; write(0,*)j_wind; write(0,*)f_wind; 
    !write(0,*)index_sx,index_sy; write(0,*)size(data,1),size(data,2),size(data,3),size(data),data_

    if (flag == "rite") then
       err = srite_window(dat_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,dat)
    else if (flag == "reed") then
       data = 0.
       err = sreed_window(dat_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,dat)
    else
       call seperr("you have to specify the flag for data_io_data()")
    end if
    if (err /= 0) call seperr("data_io_data: error reading data")
  end subroutine
!#####################################################
subroutine data_io_s(flag, data, index_sx, index_sy )
    complex, dimension(:,:,:,:  ), allocatable :: data
    character(len=4)                    :: flag
    integer                             :: index_sx, index_sy
    integer, dimension(5)               :: n_cube, j_wind, n_wind, f_wind
    integer                             :: n_dim_cube, err
    character :: y

    n_dim_cube = 5
    n_cube = (/dgrid%agx%n , dgrid%agy%n   , dgrid%aw%n    , dgrid%asx%n    ,  dgrid%asy%n/)
    j_wind = (/1           , 1             , 1             , 1              ,           1/)
    n_wind = (/dgrid%agx%n , dgrid%agy%n   , dgrid%aw%n    , 1              ,           1/)
    f_wind = (/0           , 0             , 0             , index_sx-1     ,  index_sy-1/)
    if (flag == "rite") then
       err = srite_window(data_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,data)
    else if (flag == "reed") then
       data = 0.
       err = sreed_window(data_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,data)
    else
       call seperr("you have to specify the flag for data_io_data()")
    end if
    if (err /= 0) call seperr("data_io_data: error reading data")
  end subroutine
!#####################################################
subroutine data_io_a(flag, fdata)
    complex, dimension(:,:,:,:,:), allocatable         :: fdata
    character(len=4)                            :: flag
    integer, dimension(5)                       :: n_cube, j_wind, n_wind, f_wind
    integer                                     :: n_dim_cube, err
    character :: y

    n_dim_cube = 5
    n_cube = (/dgrid%agx%n , dgrid%agy%n   , dgrid%asx%n   , dgrid%asy%n   ,dgrid%aw%n  /)
    j_wind = (/1           , 1             , 1             , 1             ,           1/)
    n_wind = (/dgrid%agx%n , dgrid%agy%n   , dgrid%asx%n   , dgrid%asy%n   ,dgrid%aw%n  /)
    f_wind = (/0           , 0             , 0             , 0             ,               0/)

    if (flag == "rite") then
       err = srite_window(data_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,fdata)
    else if (flag == "reed") then 
       fdata = 0.
       err = sreed_window(data_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,fdata)
    else
       call seperr("you have to specify the flag for data_io_data()")
    end if
  end subroutine
!#####################################################
subroutine data_io_tdata(flag, fdata)
    use myfft_mod
    complex, dimension(:,:,:,:,:), allocatable         :: fdata
    complex, dimension(size(fdata,5))                :: tmp
    character(len=4)                            :: flag
    integer, dimension(5)                       :: n_cube, j_wind, n_wind, f_wind
    integer                                     :: n_dim_cube, err
    character :: y

    n_dim_cube = 5
    n_cube = (/dgrid%agx%n , dgrid%agy%n   , dgrid%asx%n   , dgrid%asy%n   ,dgrid%at%n  /);
    j_wind = (/1           , 1             , 1             , 1             ,           1/);
    n_wind = (/dgrid%agx%n , dgrid%agy%n   , dgrid%asx%n   , dgrid%asy%n   ,dgrid%at%n  /);
    f_wind = (/0           , 0             , 0             , 0             ,           0/);

        do isy=1, dgrid%asy%n;         
        do isx=1, dgrid%asx%n;         
                do igy=1, dgrid%agy%n; 
                do igx=1, dgrid%agx%n; 
                        call FFT1DT(fdata(dgrid%agx%n, dgrid%agy%n, dgrid%asx%n, dgrid%asy%n, :), 1);
                end do; 
                end do; 
        end do; 
        end do;   

    if (flag == "rite") then
       err = srite_window(data_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,real(fdata))
    else if (flag == "reed") then
       data = 0.2
       err = sreed_window(data_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,real(fdata))
    else
       call seperr("you have to specify the flag for data_io_data()")
    end if
  end subroutine
!#####################################################
  subroutine data_io_greens_blk(greens, index_ws, max_nw)
    integer                                     :: index_ws, max_nw, nbw
    integer, dimension(6)                       :: n_cube, j_wind, n_wind, f_wind
    integer                                     :: n_dim_cube, err
    complex, dimension(:,:,:,:,:,:), allocatable:: greens
    
    nbw=min(nodes,max_nw-index_ws+1)

    n_dim_cube = 6
    n_cube = (/ggrid%ax_surf%n, ggrid%ay_surf%n, ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n, ggrid%aw%n /)
    j_wind = (/1              , 1              , 1              , 1              , 1              , 1          /)
    n_wind = (/ggrid%ax_surf%n, ggrid%ay_surf%n, ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n, nbw        /)
    f_wind = (/0              , 0              , 0              , 0              , 0              , index_ws-1 /)
    !write(*,*) n_cube; write(*,*) n_wind; write(*,*) f_wind; write(*,*) j_wind; write(0,*)'+++'
    greens = 0.

    !write(0,*)'reading greens frequency: ', index_ws, 'of ', int(.5+(ggrid%aw%n*jw))
    err = sreed_window(greens_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,greens)
    if (err /= 0) call seperr("data_io_greens: error readin greens")

  end subroutine!#####################################################
  subroutine data_io_greens(greens, index_ws)
    integer                                   :: index_ws 
    integer, dimension(6)                     :: n_cube, j_wind, n_wind, f_wind
    integer                                   :: n_dim_cube, err
    complex, dimension(:,:,:,:,:), allocatable:: greens

    n_dim_cube = 6
    n_cube = (/ggrid%ax_surf%n, ggrid%ay_surf%n, ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n, ggrid%aw%n /)
    j_wind = (/1              , 1              , 1              , 1              , 1              , 1          /)
    n_wind = (/ggrid%ax_surf%n, ggrid%ay_surf%n, ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n, 1          /)
    f_wind = (/0              , 0              , 0              , 0              , 0              , index_ws-1 /)
    !write(*,*) n_cube; write(*,*) n_wind; write(*,*) f_wind; write(*,*) j_wind; write(0,*)size(greens,1),size(greens,2),size(greens,3),size(greens,4),size(greens,5)
    greens = 0.

    !write(0,*)'reading greens frequency: ', index_ws, 'of ', int(.5+(ggrid%aw%n*jw))
    err = sreed_window(greens_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,greens)
    if (err /= 0) call seperr("data_io_greens: error readin greens")

  end subroutine
!#####################################################
  subroutine data_io_green_s(greens)
    integer                                   :: index_ws
    integer, dimension(6)                     :: n_cube, j_wind, n_wind, f_wind
    integer                                   :: n_dim_cube, err
    complex, dimension(:,:,:,:,:), allocatable:: greens
    greens_scode_="greens_scode"    
    n_dim_cube = 6
    n_cube = (/dgrid%asx%n   , dgrid%asy%n    , ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n, ggrid%aw%n /)
    j_wind = (/1             , 1              , 1              , 1              , 1              , 1          /)
    n_wind = (/dgrid%asx%n   , dgrid%asy%n    , ggrid%ax_modl%n, ggrid%ay_modl%n, ggrid%az_modl%n, ggrid%aw%n /)
    f_wind = (/0             , 0              , 0              , 0              , 0              , 0          /)
    !write(*,*) n_cube; write(*,*) n_wind; write(*,*) f_wind; write(*,*) j_wind
    greens = 0.

    !write(0,*)'reading greens frequency: ', index_ws, 'of ', int(.5+(ggrid%aw%n*jw))
    err = sreed_window(greens_scode_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,greens)
    if (err /= 0) call seperr("data_io_greens: error readin greens")

  end subroutine
!#####################################################
  subroutine data_io_wfld(wfld_, wfld, index_z)
    integer                                :: index_z
    integer, dimension(4)                  :: n_cube, j_wind, n_wind, f_wind
    integer                                :: n_dim_cube, err
    real , dimension(:,:,:,:), allocatable :: wfld
    character(len=256)                     :: wfld_

    n_dim_cube = 4
    n_cube = (/vgrid%az%n, vgrid%ax%n, vgrid%ay%n, dgrid%at%n/wfld_out_jt /)
    j_wind = (/1         , 1         , 1         , 1                      /)
    n_wind = (/vgrid%az%n, vgrid%ax%n, vgrid%ay%n, dgrid%at%n/wfld_out_jt /)
    f_wind = (/0         , 0        ,  0         , 0                      /)

    wfld = 0.
    err = srite_window(wfld_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,wfld)
    if (err /= 0) call seperr("data_io_greens: error reading Green's function")
  end subroutine
!#####################################################
  subroutine mig_io(mig)
    integer                                     :: index_ws
    integer, dimension(5)                       :: n_cube, j_wind, n_wind, f_wind
    integer                                     :: n_dim_cube, err
    real   , dimension(:,:,:,:,:), allocatable  :: mig

    n_dim_cube = 5
    n_cube = (/igrid%ahx%n, igrid%ahy%n , igrid%ax%n              , igrid%ay%n            , igrid%az%n             /)
    n_wind = (/igrid%ahx%n, igrid%ahy%n , igrid%ax%n              , igrid%ay%n            , igrid%az%n             /)
    j_wind = (/1          , 1           , 1                       , 1                     , 1                      /)
    f_wind = (/0          , 0           , 0                       , 0                     , 0                      /)
!    write(0,*)'writing migration freq.: ', index_ws, 'of ', unw, 'at node', omp_get_thread_num();  
    err = srite_window(mig_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,mig)
    if (err /= 0) call seperr("mig_io_mig: error writing mig")

  end subroutine
!#####################################################
  subroutine mig_io2(mig,isurv)
    integer                     :: index_ws
    integer, dimension(3)       :: n_cube, j_wind, n_wind, f_wind
    integer                     :: n_dim_cube, err
    integer                     :: isurv
    real   , dimension(:,:,: )  :: mig
    character(len=256)          :: mig_
    if(isurv==1)mig_=modl1_;if(isurv==2)mig_=modl2_;if(isurv==3)mig_=modl3_;if(isurv==4)mig_=modl4_  ;if(isurv==5)mig_=modl5_  ;if(isurv==6)mig_=modl6_;
    if(isurv==7)mig_=modl7_;if(isurv==8)mig_=modl8_;if(isurv==9)mig_=modl9_;if(isurv==10)mig_=modl10_;if(isurv==11)mig_=modl11_;if(isurv==12)mig_=modl12_;
    if(isurv==13)mig_=modl13_;if(isurv==14)mig_=modl14_;if(isurv==15)mig_=modl15_;
    n_dim_cube = 3
    n_cube = (/igrid%ax%n              , igrid%ay%n            , igrid%az%n             /)
    n_wind = (/igrid%ax%n              , igrid%ay%n            , igrid%az%n             /)
    j_wind = (/1                       , 1                     , 1                      /)
    f_wind = (/0                       , 0                     , 0                      /)
!    write(0,*)'writing migration freq.: ', index_ws, 'of ', unw, 'at node', omp_get_thread_num();  

        err = srite_window(mig_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,mig)
    if (err /= 0) call seperr("mig_io_mig: error writing mig")
  end subroutine
!#####################################################
  subroutine mig_io_hx(mig,isurv)
    integer                     :: index_ws
    integer, dimension(5)       :: n_cube, j_wind, n_wind, f_wind
    integer                     :: n_dim_cube, err
    integer                     :: isurv
    real, dimension(:,:,:,:,:)  :: mig
    character(len=256)          :: mig_
    if(isurv==1)mig_=modl1_;if(isurv==2)mig_=modl2_;if(isurv==3)mig_=modl3_;if(isurv==4)mig_=modl4_  ;if(isurv==5)mig_=modl5_  ;if(isurv==6)mig_=modl6_;
    if(isurv==7)mig_=modl7_;if(isurv==8)mig_=modl8_;if(isurv==9)mig_=modl9_;if(isurv==10)mig_=modl10_;if(isurv==11)mig_=modl11_;if(isurv==12)mig_=modl12_;
    if(isurv==13)mig_=modl13_;if(isurv==14)mig_=modl14_;if(isurv==15)mig_=modl15_;
    n_dim_cube = 5
    n_cube = (/igrid%ahx%n,igrid%ahy%n,igrid%ax%n              , igrid%ay%n            , igrid%az%n             /)
    n_wind = (/igrid%ahx%n,igrid%ahy%n,igrid%ax%n              , igrid%ay%n            , igrid%az%n             /)
    j_wind = (/1          ,1          ,1                       , 1                     , 1                      /)
    f_wind = (/0          ,0          ,0                       , 0                     , 0                      /)
!           write(*,*) n_cube; write(*,*) n_wind; write(*,*) f_wind; write(*,*) j_wind; write(0,*)'+++'
        err = srite_window(mig_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,mig)
    if (err /= 0) call seperr("mig_io_mig: error writing mig")

  end subroutine
!#####################################################
  subroutine mig_io_1d(mig,isurv)
    integer                     :: index_ws
    integer, dimension(1)       :: n_cube, j_wind, n_wind, f_wind
    integer                     :: n_dim_cube, err
    integer                     :: isurv
    real   , dimension(:)          :: mig
    character(len=256)          :: mig_
        
    if(isurv==11)mig_=modl11_;if(isurv==12)mig_=modl12_;if(isurv==13)mig_=modl13_;if(isurv==14)mig_=modl14_;if(isurv==15)mig_=modl15_;
    if(isurv==6 )mig_=modl6_ ;if(isurv==7 )mig_=modl7_ ;if(isurv==8 )mig_=modl8_ ;if(isurv==9 )mig_=modl9_ ;if(isurv==10)mig_=modl10_;
    if(isurv==1 )mig_=modl1_ ;if(isurv==2 )mig_=modl2_ ;if(isurv==3 )mig_=modl3_ ;if(isurv==4 )mig_=modl4_ ;if(isurv==5 )mig_=modl5_ ;

    n_dim_cube = 1
    n_cube = (/igrid%ax%n*igrid%ay%n*igrid%az%n/)
    n_wind = (/igrid%ax%n*igrid%ay%n*igrid%az%n/)
    j_wind = (/1                               /)
    f_wind = (/0                               /)
!    write(0,*)'writing migration freq.: ', index_ws, 'of ', unw, 'at node', omp_get_thread_num();  
    err = srite_window(mig_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,mig)
    if (err /= 0) call seperr("mig_io_mig: error writing mig")

  end subroutine
!#####################################################
 subroutine wfld_out(wfld,wfld_)
        use myfft_mod
        complex    , dimension(:,:,:,:,:), allocatable :: wfld
        complex    , dimension(:        ), allocatable :: tmp_wfld
        real       , dimension(:,:,:,:  ), allocatable :: tmp_wfld2
        real       , dimension(:,:,:,:  ), allocatable :: tmp_wfld3
        character (len=256) :: wfld_

        if (allocated(tmp_wfld )) deallocate (tmp_wfld ); allocate(tmp_wfld(dgrid%at%n))
        if (allocated(tmp_wfld2)) deallocate (tmp_wfld2); allocate(tmp_wfld2(vgrid%ax%n,vgrid%ay%n,vgrid%az%n,dgrid%at%n)) 
        if (allocated(tmp_wfld3)) deallocate (tmp_wfld3); allocate(tmp_wfld3(vgrid%ax%n,vgrid%ay%n,vgrid%az%n,dgrid%at%n))

        nnode =omp_get_num_procs(); thread=omp_get_thread_num(); 
        nodes=floor(nnode*.98)
        call omp_set_num_threads(nodes); write(*,*) 'using', nodes, 'of' , nnode
        !$OMP parallel do private(it,itt,ix,iz,inode,tmp_wfld) schedule(dynamic,1) ordered 
        do iz=1,vgrid%az%n
                if (allocated(tmp_wfld )) deallocate (tmp_wfld ); allocate(tmp_wfld(dgrid%at%n))
                inode=omp_get_thread_num();  
                if(verb>6) write(*,*)'iz.:', iz ,' of ',vgrid%az%n,' @ node ', inode         
                do iy=1,vgrid%ay%n 
                do ix=1,vgrid%ax%n 
                        tmp_wfld=wfld(ix,iy,iz,:,1); call FFT1DT(tmp_wfld, -1); tmp_wfld2(ix,iy,iz,:)=tmp_wfld
                enddo
                enddo
        enddo
        !$OMP end parallel do
        itt=1; 

        call sep_write(tmp_wfld2, wfld_, esize=4)
        write(*,*)'written wavefields for one shot successfully' 
        deallocate(tmp_wfld,tmp_wfld2,tmp_wfld3)
 end subroutine
!#####################################################
 subroutine wfd_d_out(wfld,isurv)
        use myfft_mod
        complex    , dimension(:,:,:,:,:), allocatable  :: wfld
        complex    , dimension(:      ), allocatable    :: tmp_wfld
        real       , dimension(:,:,:,:), allocatable    :: tmp_wfld2
        real       , dimension(:,:,:,:), allocatable    :: tmp_wfld3
        integer                                         :: isurv
        character (len=256) :: wfld_

        if(isurv==1 )wfld_=wfld1_ ;if(isurv==2 )wfld_=wfld2_ ;if(isurv==3 )wfld_=wfld3_ ;if(isurv==4 )wfld_=wfld4_ ;if(isurv==5 )wfld_=wfld5_ ;
        if(isurv==6 )wfld_=wfld6_; if(isurv==7 )wfld_=wfld7_ ;if(isurv==8 )wfld_=wfld8_ ;if(isurv==9 )wfld_=wfld9_ ;if(isurv==10)wfld_=wfld10_;
        if(isurv==11)wfld_=wfld11_;if(isurv==12)wfld_=wfld12_;if(isurv==13)wfld_=wfld13_;if(isurv==14)wfld_=wfld14_;if(isurv==15)wfld_=wfld15_;

        if (allocated(tmp_wfld )) deallocate (tmp_wfld ); allocate(tmp_wfld(dgrid%at%n))
        if (allocated(tmp_wfld2)) deallocate (tmp_wfld2); allocate(tmp_wfld2(vgrid%ax%n,vgrid%ay%n,vgrid%az%n,dgrid%at%n)) 
        if (allocated(tmp_wfld3)) deallocate (tmp_wfld3); allocate(tmp_wfld3(vgrid%ax%n,vgrid%ay%n,vgrid%az%n,dgrid%at%n))

        nnode =omp_get_num_procs(); thread=omp_get_thread_num(); 
        nodes=floor(nnode*.98)
        call omp_set_num_threads(nodes); if(verb>4) write(0,'(A45,I4,A4,I4,A2)',advance='no') 'Writing wavefields for one shot using ', nodes, 'of' , nnode, '.'
        !$OMP parallel do private(it,itt,ix,iz,inode,tmp_wfld) schedule(dynamic,1) ordered 
        do iz=1,vgrid%az%n
                if (allocated(tmp_wfld )) deallocate (tmp_wfld ); allocate(tmp_wfld(dgrid%at%n))
                inode=omp_get_thread_num();  
                if(verb>6) write(*,*)'iz.:', iz ,' of ',vgrid%az%n,' @ node ', inode         
                do iy=1,vgrid%ay%n 
                do ix=1,vgrid%ax%n 
                        tmp_wfld=wfld(ix,iy,iz,:,1); call FFT1DT(tmp_wfld, -1); tmp_wfld2(ix,iy,iz,:)=tmp_wfld
                enddo
                enddo
        enddo
        !$OMP end parallel do
        itt=1; 

        if(verb>4) write(0,'(A34)')' Writing Down-going wavefields....' 
        call sep_write(tmp_wfld2, wfld_, esize=4)
        if(verb>4) write(0,'(A14)')' Successful!' 
        deallocate(tmp_wfld,tmp_wfld2,tmp_wfld3)
 end subroutine
!#####################################################
 subroutine wfd_u_out(wfld,isurv)
        use myfft_mod
        complex    , dimension(:,:,:,:,:), allocatable  :: wfld
        complex    , dimension(:      ), allocatable    :: tmp_wfld
        real       , dimension(:,:,:,:), allocatable    :: tmp_wfld2
        real       , dimension(:,:,:,:), allocatable    :: tmp_wfld3
        integer                                         :: isurv
        character (len=256) :: wfld_

        if(isurv==1 )wfld_=wfld1_ ;if(isurv==2 )wfld_=wfld2_ ;if(isurv==3 )wfld_=wfld3_ ;if(isurv==4 )wfld_=wfld4_ ;if(isurv==5 )wfld_=wfld5_ ;
        if(isurv==6 )wfld_=wfld6_; if(isurv==7 )wfld_=wfld7_ ;if(isurv==8 )wfld_=wfld8_ ;if(isurv==9 )wfld_=wfld9_ ;if(isurv==10)wfld_=wfld10_;
        if(isurv==11)wfld_=wfld11_;if(isurv==12)wfld_=wfld12_;if(isurv==13)wfld_=wfld13_;if(isurv==14)wfld_=wfld14_;if(isurv==15)wfld_=wfld15_;

        if (allocated(tmp_wfld )) deallocate (tmp_wfld ); allocate(tmp_wfld(dgrid%at%n))
        if (allocated(tmp_wfld2)) deallocate (tmp_wfld2); allocate(tmp_wfld2(vgrid%ax%n,vgrid%ay%n,vgrid%az%n,dgrid%at%n)) 
        if (allocated(tmp_wfld3)) deallocate (tmp_wfld3); allocate(tmp_wfld3(vgrid%ax%n,vgrid%ay%n,vgrid%az%n,dgrid%at%n))

        nnode =omp_get_num_procs(); thread=omp_get_thread_num(); 
        nodes=floor(nnode*.98)
        call omp_set_num_threads(nodes); if(verb>4) write(0,'(A45,I4,A4,I4,A2)',advance='no') 'Writing wavefields for one shot using ', nodes, 'of' , nnode, '.'
        !$OMP parallel do private(it,itt,ix,iz,inode,tmp_wfld) schedule(dynamic,1) ordered 
        do iz=1,vgrid%az%n
                if (allocated(tmp_wfld )) deallocate (tmp_wfld ); allocate(tmp_wfld(dgrid%at%n))
                inode=omp_get_thread_num();  
                if(verb>6) write(*,*)'iz.:', iz ,' of ',vgrid%az%n,' @ node ', inode         
                do iy=1,vgrid%ay%n 
                do ix=1,vgrid%ax%n 
                        tmp_wfld=wfld(ix,iy,iz,:,1); call FFT1DT(tmp_wfld, -1); tmp_wfld2(ix,iy,iz,:)=tmp_wfld 
                enddo
                enddo
        enddo
        !$OMP end parallel do
        itt=1; 

        if(verb>4) write(0,'(A34)')' Writing Up-going wavefields....' 
        call sep_write(tmp_wfld2, wfld_, esize=4)
        if(verb>4) write(0,'(A14)')' Successful!' 
        deallocate(tmp_wfld,tmp_wfld2,tmp_wfld3)
 end subroutine
!#####################################################
  subroutine data_velocity()
        use reflect_mod 
        if(lloyd)then
             call sreed(vel_, vel, 4*vgrid%ax%n*vgrid%ay%n*vgrid%az%n)
             if(.not. exist_file(vel_ref_)) call seperr('Provide file for refernce velocities...');
             call from_aux(vel_ref_,"n1",vnum);
             call sreed(vel_ref_, vel_ref, 4*vnum*vgrid%az%n*2)
             nref=0;
             do iz=1,vgrid%az%n
                     do iv=1,vnum; if(vel_ref(iv,iz,1)>1e-05)then; nref(iz)=nref(iz)+1; else; exit; endif; enddo
             enddo
        else
             call sreed(vel_, vel, 4*vgrid%ax%n*vgrid%ay%n*vgrid%az%n)
        endif
        if(exist_file(ref_))then
                call sreed(ref_, ref, 4*rgrid%ax%n*rgrid%ay%n*rgrid%az%n)
        else
                if(.not. (adj .or. inv))call reflec(vel, ref, ref_, vgrid, den)
        endif      
        if(adj .or. inv)then
                img_="img"
                call auxinout(img_)        
                call houaxis(img_,vgrid%ax,1);call houaxis(img_,vgrid%ay,2); call houaxis(img_,vgrid%az,3); 
                call auxputch("label1", "s", "x", img_); call auxputch("label2", "s", "y", img_); call auxputch("label3", "s", "z" , img_); call to_history('esize', 4, img_)
        endif
  end subroutine
!#####################################################
  subroutine data_io_csou(csou)
    integer, dimension(3)                 :: n_cube, j_wind, n_wind, f_wind
    complex, dimension(:,:,:),allocatable :: csou
    integer                               :: n_dim_cube, err

    n_dim_cube = 3
    n_cube = (/wgrid%asx%n, wgrid%asy%n       , wgrid%aw%n      /)
    j_wind = (/1          , 1                 , 1               /)
    n_wind = (/wgrid%asx%n, wgrid%asy%n       , wgrid%aw%n      /)
    f_wind = (/0          , 0                 , 0               /)

    csou = 0.
    err = sreed_window(wavelet_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,csou)
    if (err /= 0) call seperr("data_io_csou: error reading souerce header")
  end subroutine
!#####################################################
  subroutine data_io_csou_code()
        encode_ = "encode"
                if (exist_file(encode_))then
                        do isy=1,dgrid%asy%n
                                do isx=1,dgrid%asx%n
                                        read(50,*,err=14, end=14)code(isy,isx)
                                enddo
                        enddo
                else
                        call seperr('No encode file found!!! check encode')
                endif
14              if (isy*isx-1/=dgrid%asy%n*dgrid%asx%n) call seperr('Number of sources differ from number specified in file')
                close (50)
  end subroutine
!#####################################################
  subroutine data_io_img(img)
    integer, dimension(3)                  :: n_cube, j_wind, n_wind, f_wind
    real   , dimension(:,:,:)              :: img
    integer                                :: n_dim_cube, err

    n_dim_cube = 3
    n_cube = (/vgrid%az%n, vgrid%ax%n        , vgrid%ay%n        /)
    j_wind = (/1         , 1                 , 1                 /)
    n_wind = (/vgrid%az%n, vgrid%ax%n        , vgrid%ay%n        /)
    f_wind = (/0         , 0                 , 0                 /)
    err = srite_window(img_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,img)
    if (err /= 0) call seperr("data_io_img: error writing img... ")
  end subroutine
!#####################################################
  subroutine in_out2d(flag, mm, mm_, isurv)
    integer                     :: index_ws
    integer, dimension(3)       :: n_cube, j_wind, n_wind, f_wind
    integer                     :: n_dim_cube, err
    integer                     :: isurv
    real                        :: mm(igrid%ax%n,igrid%ay%n, igrid%az%n) 
    character(len=256)          :: mm_
    optional                    :: isurv
    character(len=4)            :: flag
    n_dim_cube = 3
    n_cube = (/igrid%ax%n , igrid%ay%n, igrid%az%n  /)
    n_wind = (/igrid%ax%n , igrid%ay%n, igrid%az%n  /)
    j_wind = (/1           , 1         , 1          /)
    f_wind = (/0           , 0         , 0          /)
    if (flag == "rite") then;
        err = srite_window(mm_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,mm)
    elseif (flag == "reed") then;
        err = sreed_window(mm_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,mm)
    else
            call seperr("Wrong flag in in_out2d()")
    endif
    if (err /= 0) call seperr("2dout: error writing 2dout")
  end subroutine
!#####################################################
  subroutine in_map(flag, mm, mm_, isurv)
    integer                     :: index_ws
    integer, dimension(4)       :: n_cube, j_wind, n_wind, f_wind
    integer                     :: n_dim_cube, err
    integer                     :: isurv
    real                        :: mm(dgrid%agx%n,dgrid%agy%n,dgrid%asx%n,dgrid%asy%n) 
    character(len=256)          :: mm_
    optional                    :: isurv
    character(len=4)            :: flag
    n_dim_cube = 3
    n_cube = (/dgrid%agx%n,dgrid%agy%n,dgrid%asx%n,dgrid%asy%n/)
    n_wind = (/dgrid%agx%n,dgrid%agy%n,dgrid%asx%n,dgrid%asy%n/)
    j_wind = (/1          , 1         , 1         ,1          /)
    f_wind = (/0          , 0         , 0         ,1          /)
    if(.not.exist_file(mm_))then
        write(0,*)"File:",trim(mm_),"does not exist!"
        call seperr("Error: in_map() in joint_encode_data_io")
    endif
    if (flag == "rite") then;
        err = srite_window(mm_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,mm)
    elseif (flag == "reed") then;
        err = sreed_window(mm_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,mm)
    else
            call seperr("Wrong flag in in_map()")
    endif
    if (err /= 0) call seperr("in_map: error writing in_map")
  end subroutine
!===============================output shifted models
  subroutine sm_io(flag,sm,isurv)
    character(len=4)            :: flag
    integer                     :: index_ws
    integer, dimension(3)       :: n_cube, j_wind, n_wind, f_wind
    integer                     :: n_dim_cube, err
    integer                     :: isurv
    real                        :: sm(igrid%ax%n,igrid%ay%n,igrid%az%n)
    character(len=256)          :: sm_

    if(isurv==1 )sm_=smodl1_ ;if(isurv==2 )sm_=smodl2_ ;if(isurv==3 )sm_=smodl3_ ;if(isurv==4 )sm_=smodl4_ ;if(isurv==5 )sm_=smodl5_ ;if(isurv==6 )sm_=smodl6_; if(isurv==7 )sm_=smodl7_ ;
    if(isurv==8 )sm_=smodl8_ ;if(isurv==9 )sm_=smodl9_ ;if(isurv==10)sm_=smodl10_;if(isurv==11)sm_=smodl11_;if(isurv==12)sm_=smodl12_;if(isurv==13)sm_=smodl13_;if(isurv==14)sm_=smodl14_;if(isurv==15)sm_=smodl15_;
    
    n_dim_cube = 3
    n_cube = (/igrid%ax%n              , igrid%ay%n            , igrid%az%n/)
    n_wind = (/igrid%ax%n              , igrid%ay%n            , igrid%az%n/)
    j_wind = (/1                       , 1                     , 1         /)
    f_wind = (/0                       , 0                     , 0         /)
   !write(0,*)n_cube; write(0,*)n_wind; write(0,*)j_wind; write(0,*)f_wind;
        if (flag == "rite") then
                if(exist_file(sm_)) then
                               err = srite_window(sm_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,sm   ); if (err /= 0) call seperr("sm_io2: error writing sm")
                else
                               write(0,*)'sm_io2: If you wish to output shifted models....please specify the file name(s)'
                endif
        elseif(flag == "reed") then
                if(exist_file(sm_)) then
                               err = sreed_window(sm_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,sm   ); if (err /= 0) call seperr("sm_io2: error reading sm")
                else
                               write(0,*)'sm_io2: If you wish to read shifted models....please specify the file name(s)'
                endif
        else
                               call seperr("you have to specify the flag for sm_io()")
        endif
  end subroutine
  !===============================
  subroutine rr_io(flag,rr,isurv,ladd)
    character(len=4)            :: flag
    integer                     :: index_ws
    integer, dimension(3)       :: n_cube, j_wind, n_wind, f_wind
    integer                     :: n_dim_cube, err
    integer                     :: isurv
    real                        :: rr(igrid%ax%n,igrid%ay%n,igrid%az%n)
    logical                     :: ladd
    character(len=256)          :: rr_

    if(isurv==1 )rr_=rr1_ ;if(isurv==2 )rr_=rr2_ ;if(isurv==3 )rr_=rr3_ ;if(isurv==4 )rr_=rr4_ ;if(isurv==5 )rr_=rr5_ ;if(isurv==6 )rr_=rr6_; if(isurv==7 )rr_=rr7_ ;
    if(isurv==8 )rr_=rr8_ ;if(isurv==9 )rr_=rr9_ ;if(isurv==10)rr_=rr10_;if(isurv==11)rr_=rr11_;if(isurv==12)rr_=rr12_;if(isurv==13)rr_=rr13_;if(isurv==14)rr_=rr14_;if(isurv==15)rr_=rr15_;
    
    n_dim_cube = 3
    n_cube = (/igrid%ax%n              , igrid%ay%n            , igrid%az%n/)
    n_wind = (/igrid%ax%n              , igrid%ay%n            , igrid%az%n/)
    j_wind = (/1                       , 1                     , 1         /)
    f_wind = (/0                       , 0                     , 0         /)
    !write(0,*)n_cube; write(0,*)n_wind; write(0,*)j_wind; write(0,*)f_wind;
        if (flag == "rite") then
                if((.not. ladd))then
                        call srite(rr_, rr, 4*size(rr))
                elseif((ladd))then
                        if(exist_file(rr_)) then
                                       err = srite_window(rr_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,rr ); if (err /= 0) call seperr("rr_io2: error writing rr")
                        else
                                       write(0,*)'rr_io2: If you wish to output rrr....please specify the file name(s)'
                        endif
                endif        
        elseif(flag == "reed") then
                if(exist_file(rr_)) then
                               err = sreed_window(rr_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,rr ); if (err /= 0) call seperr("rr_io2: error reading rr")
                else
                               write(0,*)'rr_io2: If you wish to read rrr....please specify the file name(s)'
                endif
        else
                               call seperr("you have to specify the flag for rr_io()")
        endif
  end subroutine
  !===============================
  subroutine ts_io(flag,ts,isurv,ladd)
    character(len=4)            :: flag
    integer                     :: index_ws
    integer, dimension(4)       :: n_cube, j_wind, n_wind, f_wind
    integer                     :: n_dim_cube, err
    integer                     :: isurv
    real                        :: ts(igrid%ax%n,igrid%ay%n,igrid%az%n,3)
    real                        :: tt(igrid%ax%n,igrid%ay%n,igrid%az%n,3)
    logical                     :: ladd
    character(len=256)          :: ts_

    if(isurv==1 )ts_=ts1_ ;if(isurv==2 )ts_=ts2_ ;if(isurv==3 )ts_=ts3_ ;if(isurv==4 )ts_=ts4_ ;if(isurv==5 )ts_=ts5_ ;if(isurv==6 )ts_=ts6_; if(isurv==7 )ts_=ts7_ ;
    if(isurv==8 )ts_=ts8_ ;if(isurv==9 )ts_=ts9_ ;if(isurv==10)ts_=ts10_;if(isurv==11)ts_=ts11_;if(isurv==12)ts_=ts12_;if(isurv==13)ts_=ts13_;if(isurv==14)ts_=ts14_;if(isurv==15)ts_=ts15_;
    
    n_dim_cube = 4
    n_cube = (/igrid%ax%n              , igrid%ay%n            , igrid%az%n             ,3 /)
    n_wind = (/igrid%ax%n              , igrid%ay%n            , igrid%az%n             ,3 /)
    j_wind = (/1                       , 1                     , 1                      ,1 /)
    f_wind = (/0                       , 0                     , 0                      ,0 /)
    !write(0,*)n_cube; write(0,*)n_wind; write(0,*)j_wind; write(0,*)f_wind;
        if (flag == "rite") then
                if((.not. ladd))then
                        err = srite_window(ts_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,ts   ); if (err /= 0) call seperr("ts_io: error writing ts")
                elseif(( ladd))then
                        if(ladd.and.exist_file(ts_)) then
                                tt=0.; err = sreed_window(ts_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,   tt); if (err /= 0) call seperr("ts_io: error reading ts")
                                       err = srite_window(ts_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,ts+tt); if (err /= 0) call seperr("ts_io: error writing ts")
                        elseif(exist_file(ts_)) then
                                       err = srite_window(ts_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,ts   ); if (err /= 0) call seperr("ts_io: error writing ts")
                        else
                                       write(0,*)'ts_io2: If you wish to output time-shifts....please specify the file name(s)'
                        endif
                endif          
        elseif(flag == "reed") then
                if(exist_file(ts_)) then
                               err = sreed_window(ts_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,ts   ); if (err /= 0) call seperr("ts_io: error reading ts")
                else
                               write(0,*)'ts_io: If you wish to output time-shifts....please specify the file name(s)'
                endif
        else
                               call seperr("you have to specify the flag for shift_io()")
        endif
  end subroutine
!===============================
  subroutine cc_io(flag,cc,isurv,ladd)
    character(len=4)            :: flag
    integer                     :: index_ws
    integer, dimension(4)       :: n_cube, j_wind, n_wind, f_wind
    integer                     :: n_dim_cube, err
    integer                     :: isurv
    real                        :: cc(igrid%ax%n,igrid%ay%n,igrid%az%n,3)
    real                        :: tt(igrid%ax%n,igrid%ay%n,igrid%az%n,3)
    logical                     :: ladd
    character(len=256)          :: cc_
    
    if(isurv==1 )cc_=cc1_ ;if(isurv==2 )cc_=cc2_ ;if(isurv==3 )cc_=cc3_ ;if(isurv==4 )cc_=cc4_ ;if(isurv==5 )cc_=cc5_ ;if(isurv==6 )cc_=cc6_; if(isurv==7 )cc_=cc7_ ;
    if(isurv==8 )cc_=cc8_ ;if(isurv==9 )cc_=cc9_ ;if(isurv==10)cc_=cc10_;if(isurv==11)cc_=cc11_;if(isurv==12)cc_=cc12_;if(isurv==13)cc_=cc13_;if(isurv==14)cc_=cc14_;if(isurv==15)cc_=cc15_;
    n_dim_cube = 4
    n_cube = (/igrid%ax%n              , igrid%ay%n            , igrid%az%n             ,3 /)
    n_wind = (/igrid%ax%n              , igrid%ay%n            , igrid%az%n             ,3 /)
    j_wind = (/1                       , 1                     , 1                      ,1 /)
    f_wind = (/0                       , 0                     , 0                      ,0 /)
    !write(0,*)'csssssccccccccccccccccccccc'
        if (flag == "rite") then
!               if(lout_scycles.and.(.not. ladd))then
                if((.not. ladd))then
                        call srite(cc_, cc, 4*size(cc))
                elseif(( ladd))then
                if(ladd.and.exist_file(cc_)) then
                        tt=0.;!err = sreed_window(cc_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,   tt); if (err /= 0) call seperr("ts_io2: error reading cc")
                               err = srite_window(cc_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,cc+tt); if (err /= 0) call seperr("ts_io2: error writing cc")
                elseif(exist_file(cc_)) then
                               err = srite_window(cc_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,cc   ); if (err /= 0) call seperr("ts_io2: error writing cc")
                else
                               write(0,*)'ts_io2: If you wish to output x-correlation....please specify the file name(s)'
                endif
                endif
        elseif(flag == "reed") then
                if(exist_file(cc_)) then
                               err = sreed_window(cc_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,cc   ); if (err /= 0) call seperr("ts_io2: error reading cc")
                else
                                write(0,*)'cc_io2: If you wish to output x-corellation....please specify the file name(s)'
                endif
        else
                               call seperr("you have to specify the flag for cc_io2()")
        endif

  end subroutine  
!===============================
  subroutine sv_io(flag,sv,isurv)
    character(len=4)            :: flag
    integer                     :: index_ws
    integer, dimension(3)       :: n_cube, j_wind, n_wind, f_wind
    integer                     :: n_dim_cube, err
    integer                     :: isurv
    real                        :: sv(igrid%ax%n,igrid%ay%n,igrid%az%n)
    logical                     :: ladd
    character(len=256)          :: sv_

    if(isurv==1 )sv_=sv1_ ;if(isurv==2 )sv_=sv2_ ;if(isurv==3 )sv_=sv3_ ;if(isurv==4 )sv_=sv4_ ;if(isurv==5 )sv_=sv5_ ;if(isurv==6 )sv_=sv6_; if(isurv==7 )sv_=sv7_ ;
    if(isurv==8 )sv_=sv8_ ;if(isurv==9 )sv_=sv9_ ;if(isurv==10)sv_=sv10_;if(isurv==11)sv_=sv11_;if(isurv==12)sv_=sv12_;if(isurv==13)sv_=sv13_;if(isurv==14)sv_=sv14_;if(isurv==15)sv_=sv15_;
    n_dim_cube = 3
    n_cube = (/igrid%ax%n              , igrid%ay%n            , igrid%az%n/)
    n_wind = (/igrid%ax%n              , igrid%ay%n            , igrid%az%n/)
    j_wind = (/1                       , 1                     , 1         /)
    f_wind = (/0                       , 0                     , 0         /)

        if (flag == "rite") then
                err = srite_window(sv_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,sv); if (err /= 0) call seperr("sv_io: error writing sv")
        elseif(flag == "reed") then
                err = sreed_window(sv_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,sv); if (err /= 0) call seperr("sv_io: error reading sv")
        else
                call seperr("you have to specify a valid flag for sv_io()")
        endif
  end subroutine  
 !===============================
  subroutine sd_io(flag,sd,isurv)
    character(len=4)            :: flag
    integer, dimension(4)       :: n_cube, j_wind, n_wind, f_wind
    integer                     :: n_dim_cube, err
    integer                     :: isurv
    real                        :: sd(igrid%ax%n,igrid%ay%n,igrid%az%n,3)
    real                        :: tt(igrid%ax%n,igrid%ay%n,igrid%az%n,3)
    logical                     :: ladd
    character(len=256)          :: sd_
    
    if(isurv==1 )sd_=sd1_ ;if(isurv==2 )sd_=sd2_ ;if(isurv==3 )sd_=sd3_ ;if(isurv==4 )sd_=sd4_ ;if(isurv==5 )sd_=sd5_ ;if(isurv==6 )sd_=sd6_; if(isurv==7 )sd_=sd7_ ;
    if(isurv==8 )sd_=sd8_ ;if(isurv==9 )sd_=sd9_ ;if(isurv==10)sd_=sd10_;if(isurv==11)sd_=sd11_;if(isurv==12)sd_=sd12_;if(isurv==13)sd_=sd13_;if(isurv==14)sd_=sd14_;if(isurv==15)sd_=sd15_;
    n_dim_cube = 4
    n_cube = (/igrid%ax%n              , igrid%ay%n            , igrid%az%n             ,3 /)
    n_wind = (/igrid%ax%n              , igrid%ay%n            , igrid%az%n             ,3 /)
    j_wind = (/1                       , 1                     , 1                      ,1 /)
    f_wind = (/0                       , 0                     , 0                      ,0 /)
        if (flag == "rite") then
                if(exist_file(sd_)) then
                               err = srite_window(sd_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,sd  ); if (err /= 0) call seperr("sd_io: error writing cc")
                else
                               write(0,*)'ts_io2: If you wish to output shift-derivatives.....please specify the file name(s): sd*'
                endif
        elseif(flag == "reed") then
                if(exist_file(sd_)) then
                               err = sreed_window(sd_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,sd   ); if (err /= 0) call seperr("ts_io: error reading cc")
                else
                               write(0,*)'sd_io: If you wish to output shift-derivatives.....please specify the file name(s): sd*'
                endif
        else
                               call seperr("you have to specify the flag for sd_io2()")
        endif

  end subroutine   
end module
