module joint_encode_nhlx_blk
 use joint_encode_params
! only works for 4 dips 0 -45 45 90
 use chain0_mod
 use joint_encode_prc
 use createhelix_mod
 use cartesian_mod
 use bound_mod
 use regrid_mod
 use adj_mod
 use lapfac_mod
 use npolydiv_mod
 use nhelicon_mod
 use wilson_mod

 implicit none
        integer,         private                                ,save   :: stat        
        type( filter),   private                                ,save   :: aa
        type( filter),   private                                ,save   :: bb
        real,            private,  dimension (:), allocatable   ,save   :: tt 
        integer,         private                                ,save   :: nd 
        logical,         private                                ,save   :: lscale
        real,                                     allocatable   ,save   :: scale(:)
        integer,         private                                ,save   :: n1 
 contains 
!######################################
        subroutine  ns_init_blk(dips)
                integer                 ::i,n1_in
                real, dimension(2)      ::u,v
                real                    ::eps_in
                real                    :: dips(:)
                if(allocated(ptch)) deallocate(ptch)
                if(allocated(n_nfilt)) deallocate(n_nfilt)
                allocate (ptch(nmod),n_nfilt(nang))
!                n1=vgrid%ax%n
                n1=vgrid%az%n        
                call from_param('scale',lscale,.false.)
                call from_param('destroy',destroy,.false.)
!               allocate(dips(nmod));

                if (lscale)then !scale according to angle
                        call from_param("osc",osc,oang); call from_param("dsc",dsc,dang); call from_param("nsc",nsc,nang)
                        allocate (scale(nsc))
                        do i=1,nsc
                                write(0,*)scale
                                scale(i)=osc+(i-1)*dsc
                                write(0,*)i,scale
                        enddo
                endif
                ptch=0.

                call nhlx_transp(1,dips) !rearrange angles to z-1 x-2
                dips = atan(dips)

                where (dips==0 ) ptch=1
                where (dips==-1) ptch=2
                where (dips==1 ) ptch=3

                n_nfilt=3
                call nallocate(n_filt,n_nfilt,ptch)
                do iang=1,nang
                        do ifilt=1,nfilt
                                n_filt%hlx(iang)%lag(         ifilt) = ifilt                      ! early lags (first row)
                                n_filt%hlx(iang)%lag( nfilt  +ifilt) = n1 + ifilt - nfilt         ! late lags  (second row)
                                n_filt%hlx(iang)%lag( nfilt*2+ifilt) = n1 + ifilt                 ! late late lags (second row)
                        end do
                end do
                call allocatehelix(lapfilt, 4)             ! alloc. filter
                lapfilt0 = 1. + eps_dip                    ! zero lag coeff.
                lapfilt%lag = (/ 1, n1-1, n1, n1+1/)       ! lag(1)= 1; lag(2)=n1  # one side only
                do iang=1,nang
                        dip=oang+(iang-1)*dang
                        if(verb>4)write(0,*)'working on angle',iang,dip,degrad(1,dip),'of', nang
                        !dip=0.!pi/120.
                        u(1)= cos(dip); u(2)=-sin(dip); 
        
                        m=(u(1)-u(2))/2.; 
                        p=(u(1)+u(2))/2.;
                        lapfilt%flt = 0.;
                        lapfilt%flt = (/2*m*p,-p*p,-2*m*p,-m*m/) 
        
                        call wilson_init( 10 * n1 )
                        call wilson_factor( 100, lapfilt0, lapfilt, n_filt0, n_filt%hlx(iang))
                        call wilson_close()
                        n_filt%hlx(iang)%flt=n_filt%hlx(iang)%flt!/n_filt0
                        if(verb>5)write(0,'(50F10.6)')n_filt%hlx(iang)%flt
                end do
                if (lscale.and.nang==nsc)then    !scale according to the angle!!!!!! useful for zeroing specific angles
                        do iang=1,nang
                                n_filt%hlx(iang)%flt=n_filt%hlx(iang)%flt*scale(iang)
                        end do
                endif
                call npolydiv_init(nmod,n_filt)
        end subroutine
!#####################################################  transp before filter and back
        subroutine nhlx_transp(fwd,xx,yy)
                integer,intent(in)      :: fwd 
                real, dimension (:)     :: xx, yy 
                real, dimension(:,:), allocatable       :: temp
                optional                        :: yy
                
                if (fwd==1)then
                        allocate (temp(vgrid%ax%n,vgrid%az%n))
                        temp=reshape(xx,(/vgrid%ax%n,vgrid%az%n /)); xx=reshape(transpose(temp),(/ nmod /))
                        if(present(yy))then; temp=reshape(yy,(/vgrid%ax%n,vgrid%az%n /)); yy=reshape(transpose(temp),(/ nmod /)); endif
                else
                        allocate (temp(vgrid%az%n,vgrid%ax%n))
                        temp=reshape(xx,(/vgrid%az%n,vgrid%ax%n /)); xx=reshape(transpose(temp),(/ nmod /))
                        if(present(yy))then; temp=reshape(yy,(/vgrid%az%n,vgrid%ax%n /)); yy=reshape(transpose(temp),(/ nmod /));endif
                endif
                stat=0
                deallocate (temp)
        end subroutine
!#####################################################  conv or deconv
        integer function nhlx_it(adj, add, xx, yy) result(stat)
                logical,intent(in) :: adj,add 
                real, dimension (:)  :: xx, yy 
                call joint_adjnull2 (adj,add, xx,yy)
                if (nsurv > 5)call nhlx_transp(1,m6,d6); if (nsurv > 4)call nhlx_transp(1,m5,d5); if (nsurv > 3)call nhlx_transp(1,m4,d4);
                if (nsurv > 2)call nhlx_transp(1,m3,d3); if (nsurv > 1)call nhlx_transp(1,m2,d2); if (nsurv > 0)call nhlx_transp(1,m1,d1);
                if (destroy)then
                        if (nsurv > 5)call filt_nhelicon(adj,add,m6,d6); if (nsurv > 4)call filt_nhelicon(adj,add,m5,d5); if (nsurv > 3)call filt_nhelicon(adj,add,m4,d4);
                        if (nsurv > 2)call filt_nhelicon(adj,add,m3,d3); if (nsurv > 1)call filt_nhelicon(adj,add,m2,d2); if (nsurv > 0)call filt_nhelicon(adj,add,m1,d1);
                else
                        if (nsurv > 5)call filt_npolydiv(adj,add,m6,d6); if (nsurv > 4)call filt_npolydiv(adj,add,m5,d5); if (nsurv > 3)call filt_npolydiv(adj,add,m4,d4);
                        if (nsurv > 2)call filt_npolydiv(adj,add,m3,d3); if (nsurv > 1)call filt_npolydiv(adj,add,m2,d2); if (nsurv > 0)call filt_npolydiv(adj,add,m1,d1);
                endif
                if (nsurv > 5)call nhlx_transp(-1,m6,d6); if (nsurv > 4)call nhlx_transp(-1,m5,d5); if (nsurv > 3)call nhlx_transp(-1,m4,d4);
                if (nsurv > 2)call nhlx_transp(-1,m3,d3); if (nsurv > 1)call nhlx_transp(-1,m2,d2); if (nsurv > 0)call nhlx_transp(-1,m1,d1);
                stat=0
        end function
!#####################################spatial int + temp-smooth ...note:int_temp_oper in prc
        integer function nhlx_row1(adj, add, mod, dat) result(stat)
                logical, intent (in)     :: adj, add
                real, dimension (: )     :: mod, dat
                stat=row_1(nhlx_it, int_temp_oper, adj,add,mod,dat) 
        end function
!######################################
        integer function nhlx_row2(adj, add, mod, dat) result(stat)
                logical, intent (in)     :: adj, add
                real, dimension (: )     :: mod, dat
                stat=row_2(nhlx_it, int_temp_oper, adj,add,mod,dat) 
        end function
!######################################
        integer function nhlx_row3(adj, add, mod, dat) result(stat)
                logical, intent (in)     :: adj, add
                real, dimension (: )     :: mod, dat
                stat=row_3(nhlx_it, int_temp_oper, adj,add,mod,dat) 
        end function
!######################################
        integer function nhlx_chain1(adj, add, mod, dat) result(stat)
                logical, intent (in)            :: adj, add
                real, dimension (: )            :: mod, dat
                real, dimension (size(dat))     :: tmp
                stat=1; call chain0(nhlx_it, int_temp_oper,adj,add,mod,dat,tmp); stat=0
        end function
!######################################
        subroutine filt_npolydiv( adj, add, xx, yy) 
                integer                   :: stat,stat1,stat2 
                logical,intent(in)        :: adj,add 
                real,dimension(:)         :: xx,yy 
                real, dimension(size(xx)) :: tmp
                tmp=0.
                if ( adj) then
                        stat= npolydiv_lop(.false.,add, yy,tmp)     ! tmp = grad y
                        stat= npolydiv_lop(.true. ,add, xx,tmp)     ! x = x + grad' tmp
                else
                        stat= npolydiv_lop(.false.,add, xx,tmp)     ! tmp = grad x
                        stat= npolydiv_lop(.true. ,add, yy,tmp)     ! y = y + grad' tmp
                endif
                stat=stat*stat2
        end subroutine 
!######################################
        subroutine filt_nhelicon( adj, add, xx, yy) 
                integer                   :: stat,stat1,stat2 
                logical,intent(in)        :: adj,add 
                real,dimension(:)         :: xx,yy 
                real, dimension(size(xx)) :: tmp
                tmp=0.
                if ( adj) then
                        stat= nhelicon_lop(.false.,.false., yy,tmp)     ! tmp = grad y
                        stat= nhelicon_lop(.true. ,.false., xx,tmp)     ! x = x + grad' tmp
                else
                        stat= nhelicon_lop(.false.,.false., xx,tmp)     ! tmp = grad x
                        stat= nhelicon_lop(.true. ,.false., yy,tmp)     ! y = y + grad' tmp
                endif
                stat=stat*stat2
        end subroutine 

end module
