module joint_encode_data_param
  use joint_encode_params
  use joint_hessian_params
  !use shift_params
  implicit none

contains

!  #============================  
  subroutine data_params() 
        call from_param("lfreq", lfreq      ,  T); 
!! encode stuff
        call from_param("encode"      , encode       ,   F    )
        call from_param("random_constant", random_constant, T ); if (.not. encode)random_constant=F
        call from_param("random_phase", random_phase ,   F    ); if (.not. encode)random_phase=F
        call from_param("linear_phase", linear_phase ,   F    ); if (.not. encode)linear_phase=F; if (linear_phase)then; random_phase=F;random_constant=F; endif
        call from_param("tmin"        , rand_tmin    , -0.5   )
        call from_param("tmax"        , rand_tmax    ,  0.5   ); rand_tlim=rand_tmax-rand_tmin
        call from_param("lsame_time"  , lsame_time   ,   F    );
        
        call from_param("linear_tmin" , linear_tmin  ,  .0    );
        call from_param("linear_tlim" , linear_tlim  ,  1.0   );
        call from_param("sshft_min"   , sshft_min    ,  .0    );
        call from_param("sshft_max"   , sshft_max    ,  .0    ); sshft_lmt=sshft_max-sshft_min; 
        call from_param("sshft_it"    , sshft_it     ,   F    );

        call from_param("code_it"     , code_it      ,   F    );
        call from_param("fine"        , fine         ,   F    );

        call from_param("nxpad_beg", pgrid%nxpad_beg, 0); call from_param("nxpad_end", pgrid%nxpad_end, 0); nxpad=(pgrid%nxpad_beg+pgrid%nxpad_end)/2.
        call from_param("nypad_beg", pgrid%nypad_beg, 0); call from_param("nypad_end", pgrid%nypad_end, 0); nypad=(pgrid%nypad_beg+pgrid%nypad_end)/2.

        call from_param("taper"       , taper        , .true. )
        call from_param("taper_pct"   , taper_pct    , 0.1    )
        call from_param("taper_type"  , taper_type   , 2      )
        call from_param("wfld_d_out"  , wfld_d_out   , .false.)
        call from_param("wfld_u_out"  , wfld_u_out   , .false.)
 
    !! invert stuff
        call from_param("only_ltshift", only_ltshift ,   F    )
        call from_param("ltshift"     , ltshift      ,   F    )
        call from_param("lvshift"     , lvshift      ,   F    )
        call from_param("lonly_dips"  , lonly_dips   ,   F    )
        call from_param("lonly_temp"  , lonly_temp   ,   F    )
        call from_param("dot"         , dot          ,   F    )
        call from_param("inv"         , inv          ,   F    )
        call from_param("adj"         , adj          ,   F    ) 
        call from_param("destroy"     , destroy      ,   F    )
        call from_param("niter"       , niter        ,   5    )
        call from_param("eps_vec"     , eps_vec      ,   T    )

        call from_param("lhybrid"     , lhybrid      ,   T    ); if(lhybrid)eps_vec=F


        call from_param("lshft"       , lsft         ,   F    )
        call from_param("lccor"       , lcc          ,   F    )
        call from_param("lsv"         , lsv          ,   F    )
        call from_param("lshft_diff"  , lsd          ,   F    )
        call from_param("use_shft"    , use_shft     ,   F    )


        
        call from_param("lobc"        , lobc         ,   F    )
        call from_param("lfixed"      , lfixed       ,   F    )

        if(inv.and.adj) call seperr ( 'Please choose between inv or adj...cannot do both')
        
	if(exist_file(report_)) call from_param('report',report_,'report'); 
     	call from_param("sign"        , sign         , +1     )
    	call from_param("marine"      , marine       , .false.)
    	call from_param("offset"      , offset       , .false. )
    	call from_param("radian"      , radian       , .false.)
    	call from_param("spike"       , spike        , .false.)
    	call from_param("spike_data"  , spike_data   , .false.)
    	call from_param("jw"          , jw           , 1      )
    	call from_param("wfld_d_out"  , wfld_d_out   , .false.)
    	call from_param("max_z"       , max_z        , -99999.)
    	call from_param("min_z"       , min_z        , -99999.)
    	call from_param("verb"        , verb         , 1      )

    	call from_param("all_nodes"   , lall_nodes   , F      )

    	call from_param("read_data"   , lread_data   , T      )

    	open(unit=10, file=report_, status='unknown');
   	 write(0,'(A65)')'========================Summary nodes============================='
    	call from_param("nodes"       , nodes        ,  1     );    
    	if(lall_nodes)then
            	nnode =omp_get_num_procs(); nodes=min(nnode,nodes)
            	call omp_set_num_threads(nodes); write(*,*) 'using', nodes, 'or less of' , nnode
        else
            	nnode =omp_get_num_procs(); nodes=min(nnode-1,nodes)
            	call omp_set_num_threads(nodes); write(*,*) 'using', nodes, 'or less of' , nnode
        endif
    	write(0,'(A65)')'End nodes========================================================='       


!!!!!!Hybrid norm
!Type of norms to use
        call from_param("norm_d"      , norm_d       ,   'l2' ) !1:l2, 2:hb
        call from_param("norm_m"      , norm_m       ,   'hybrid' ) !1:l2, 2:hb 
        call from_param("norm_m1"     , norm_m1      ,   'l1' ) !1:l2, 2:hb
        call from_param("norm_m2"     , norm_m2      ,   'l1' ) !1:l2, 2:hb
!quantiles
        call from_param("quant_d"     , quant_d      ,  0.5   ) !0-1
        call from_param("quant_m"     , quant_m      ,  0.5   ) !0-1
!quantile period
        call from_param("quant_period", quant_period ,  1     ) !1-10
!plane search iterations
        call from_param("psiter"      , psiter       ,  1     ) !1-10
!plane search iterations
        call from_param("max_overshot", max_overshot ,  10    ) !1-10

    if(exist_file(report_)) call from_param('report',report_,'report'); 
    hess_="hess"; greens_  = "greens" ; wavelet_="wavelet";  vel_= "vel";  wfld_d_  = "wfld_d" ;  wfld_u_  = "wfld_u" ; report_ = "report" ;  data_  = "data" ;    ref_ = "ref";  mig_='mig'
    call from_param("nxhole"      , nxhole       , 0      )
    call from_param("dxhole"      , dxhole       , 0.     )
    call from_param("oxhole"      , oxhole       , 0.     )
    call from_param("nyhole"      , nyhole       , 0      )
    call from_param("dyhole"      , dyhole       , 0.     )
    call from_param("oyhole"      , oyhole       , 0.     )
    call from_param("hole"        , hole         , F      )
    call from_param("hole_sx1"    , hole_sx1     ,-999999.)
    call from_param("hole_sy1"    , hole_sy1     ,-999999.)
    call from_param("hole_gx1"    , hole_gx1     ,-999999.)
    call from_param("hole_gy1"    , hole_gy1     ,-999999.)
    call from_param("hole_sx2"    , hole_sx2     ,-999999.)
    call from_param("hole_sy2"    , hole_sy2     ,-999999.)
    call from_param("hole_gx2"    , hole_gx2     ,-999999.)
    call from_param("hole_gy2"    , hole_gy2     ,-999999.)

    call from_param("sub_offset"  ,lsub_offset   ,    F   )
    call from_param("vnum"        , vnum         ,    2   )

    !!ffd or phaseshift
    call from_param("ffd"         , ffd          ,  F     ); 
    call from_param("psp"         , psp          ,  T     ); if (ffd) psp=F; 
    call from_param("lloyd"       , lloyd        , .false.); if (lloyd) ffd=F;
    call from_param("interp"      , interp       , .false.);
    write(0,'(A65)')'========================Summary Method============================'
    if(ffd)then
            write(0,*)'Migration method: FFD'
    else
            write(0,*)'Migration method: PSPI with nref=',vnum
    endif
    write(0,'(A65)')'End nodes========================================================='       

    nsurf=dgrid%asx%n*dgrid%asy%n*dgrid%agx%n*dgrid%agy%n

!hessian stuff
        hessian_="hess"
        call from_param("nreal"      , nreal_hess   , 1      )
        call from_param("hessian"    , lhessian     ,  F     ); !compute hessian?
        if(lhessian)lread_data=F



  end subroutine 
!  #============================  
  subroutine obc_params() 
    !! obc stuff
        call from_param("min_sz"      , min_sz       , vgrid%az%o); imin_sz=1.5+(min_sz-vgrid%az%o)/vgrid%az%d	!source depth
        call from_param("max_sz"      , max_sz       , vgrid%az%o); imax_sz=1.5+(max_sz-vgrid%az%o)/vgrid%az%d
        call from_param("min_rz"      , min_rz       , vgrid%az%o); imin_rz=1.5+(min_rz-vgrid%az%o)/vgrid%az%d  !receiver depth
        call from_param("max_rz"      , max_rz       , vgrid%az%o); imax_rz=1.5+(max_rz-vgrid%az%o)/vgrid%az%d
   	 write(0,'(A65)')'========================Summary obc=============================='
        write(0,*)'OBC/OBS Migration....'
        write(0,*)'  Source depth/idepth:',min_sz,imin_sz
        write(0,*)'Receiver depth/idepth:',min_rz,imin_rz
    	write(0,'(A65)')'End nodes========================================================='       
  end subroutine 
!  #============================  
  subroutine green_params()
    !files 
    greens_  = "greens" ; wavelet_="wavelet";  vel_= "vel";  wfld_d_  = "wfld_d" ;  wfld_u_  = "wfld_u" ; report_ = "report" ;  data_  = "data" ;    ref_ = "ref";  mig_='mig'; dhdr_ ="dhdr"
    vel_ref_ = "vel_ref"; 
 
    if(exist_file(report_)) call from_param('report',report_,'report'); 

    !ggrid surf. params  
    call from_param("nx_surf", ggrid%ax_surf%n, ggrid%ax_surf%n); call from_param("dx_surf", ggrid%ax_surf%d, ggrid%ax_surf%d); call from_param("ox_surf", ggrid%ax_surf%o, ggrid%ax_surf%o)
    call from_param("ny_surf", ggrid%ay_surf%n, ggrid%ay_surf%n); call from_param("dy_surf", ggrid%ay_surf%d, ggrid%ay_surf%d); call from_param("oy_surf", ggrid%ay_surf%o, ggrid%ay_surf%o)

    !ggrid modl. params    
    call from_param("nx_modl", ggrid%ax_modl%n,ggrid%ax_modl%n); call from_param("dx_modl", ggrid%ax_modl%d, ggrid%ax_modl%d); call from_param("ox_modl", ggrid%ax_modl%o, ggrid%ax_modl%o)
    call from_param("ny_modl", ggrid%ay_modl%n,ggrid%ay_modl%n); call from_param("dy_modl", ggrid%ay_modl%d, ggrid%ay_modl%d); call from_param("oy_modl", ggrid%ay_modl%o, ggrid%ay_modl%o)
    call from_param("nz_modl", ggrid%az_modl%n,ggrid%az_modl%n); call from_param("dz_modl", ggrid%az_modl%d, ggrid%az_modl%d); call from_param("oz_modl", ggrid%az_modl%o, ggrid%az_modl%o)

    call from_param("sign"        , sign         , +1     )
    call from_param("marine"      , marine       , .false.)
    call from_param("radian"      , radian       , .false.)
    call from_param("spike"       , spike        , .false.)
    call from_param("spike_data"  , spike_data   , .false.)
    call from_param("jw"          , jw           , 1      )
    call from_param("wfld_d_out"  , wfld_d_out   , .false.)
    call from_param("max_z"       , max_z        , -99999.)
    call from_param("min_z"       , min_z        , -99999.)
    call from_param("verb"        , verb         , 1      )

  end subroutine

!  #============================  
  subroutine inv_param()
    call from_param("inv"   ,inv   , F )
    call from_param("niter" ,niter , 1 )

  end subroutine 
  end module

