module joint_encode_params
  use global_params_mod 
  use joint_type 
  use map_mod
  use myfft_mod
  use minresDataModule
  use util_ 
  use adj_mod
  use polydiv_mod
  use helicon_mod
  use nhelicon_mod
  use npolydiv_mod

implicit none
  
!  #============================  
  real, dimension(:,:)       , pointer     ,save :: mm0
  real, dimension(:,:)       , pointer     ,save :: dd0
  real, dimension(:)         , pointer     ,save :: m0, m1 , m2 , m3 , m4 , m5 , m6 , m7, m8, m9, m10, m11, m12, m13, m14, m15                                                  !model
  real, dimension(:)         , pointer     ,save :: d0, d1 , d2 , d3 , d4 , d5 , d6 , d7, d8, d9, d10, d11, d12, d13, d14, d15                                                  !data
  real, dimension(:)         , pointer     ,save :: v0, v1 , v2 , v3 , v4 , v5 , v6 , v7, v8, v9, v10, v11, v12, v13, v14, v15                                                  !velocity
  complex, dimension(:)      , pointer     ,save :: fd0,fd1,fd2 ,fd3 ,fd4 ,fd5 ,fd6 ,fd7,fd8,fd9,fd10,fd11,fd12,fd13,fd14,fd15                                                  !data-freq
  real, dimension(:)         , pointer     ,save :: sm0,sm1,sm2 ,sm3 ,sm4 ,sm5 ,sm6 ,sm7,sm8,sm9,sm10,sm11,sm12,sm13,sm14,sm15                                                  !model-shifted
  real, dimension(:)         , pointer     ,save :: rm0,rm1,rm2 ,rm3 ,rm4 ,rm5 ,rm6 ,rm7,rm8,rm9,rm10,rm11,rm12,rm13,rm14,rm15                                                  !filtered/roughened-model
  real, dimension(:)         , pointer     ,save :: sv0,sv1,sv2 ,sv3 ,sv4 ,sv5 ,sv6 ,sv7,sv8,sv9,sv10,sv11,sv12,sv13,sv14,sv15                                                  !vel-shifted 
  real, dimension(:,:)       , pointer     ,save :: ts0,ts1,ts2 ,ts3 ,ts4 ,ts5 ,ts6 ,ts7,ts8,ts9,ts10,ts11,ts12,ts13,ts14,ts15                                                  !time-shifts x-y-z
  real, dimension(:,:)       , pointer     ,save :: sd0,sd1,sd2 ,sd3 ,sd4 ,sd5 ,sd6 ,sd7,sd8,sd9,sd10,sd11,sd12,sd13,sd14,sd15                                                  !time-shifts derivatives x-y-z
  real, dimension(:,:)       , pointer     ,save :: cc0,cc1,cc2 ,cc3 ,cc4 ,cc5 ,cc6 ,cc7,cc8,cc9,cc10,cc11,cc12,cc13,cc14,cc15                                                  !xcorrelation x-y-z
  real, dimension(:)         , pointer     ,save :: rr0,rr1,rr2 ,rr3 ,rr4 ,rr5 ,rr6 ,rr7,rr8,rr9,rr10,rr11,rr12,rr13,rr14,rr15                                                  !repeatability
  real, dimension(:)         , pointer     ,save :: am0,am1,am2 ,am3 ,am4 ,am5 ,am6 ,am7,am8,am9,am10,am11,am12,am13,am14,am15                                                  !angle gathers model
  real, dimension(:)         , pointer     ,save :: bm0,bm1,bm2 ,bm3 ,bm4 ,bm5 ,bm6 ,bm7,bm8,bm9,bm10,bm11,bm12,bm13,bm14,bm15                                                  !angle gathers shifted model
  real, dimension(:)         , pointer     ,save :: dips1 , dips2 , dips3 , dips4 , dips5 , dips6, dips7,dips8,dips9,dips10,dips11,dips12,dips13,dips14,dips15                  !dips
  real, dimension(:)         , pointer     ,save :: epsi1 , epsi2 , epsi3 , epsi4 , epsi5 , epsi6, epsi7,epsi8,epsi9,epsi10,epsi11,epsi12,epsi13,epsi14,epsi15,epsi4d           !epsilon-spatial-reg-param
  real, dimension(:)         , pointer     ,save :: lmbd1 , lmbd2 , lmbd3 , lmbd4 , lmbd5 , lmbd6, lmbd7,lmbd8,lmbd9,lmbd10,lmbd11,lmbd12,lmbd13,lmbd14,lmbd15,lmbd4d           !lambda-temporal-reg-param
  real, dimension(:)         , pointer     ,save :: gamm1 , gamm2 , gamm3 , gamm4 , gamm5 , gamm6, gamm7,gamm8,gamm9,gamm10,gamm11,gamm12,gamm13,gamm14,gamm15,gamm4d           !gamma-temporal-reg-param
  real, dimension(:)         , pointer     ,save :: mask1 , mask2 , mask3 , mask4 , mask5 , mask6, mask7,mask8,mask9,mask10,mask11,mask12,mask13,mask14,mask15,mask4d           !mask-for reg-etc
  real, dimension(:)         , pointer     ,save :: wght1 , wght2 , wght3 , wght4 , wght5 , wght6, wght7,wght8,wght9,wght10,wght11,wght12,wght13,wght14,wght15,wght4d           !weighting
  real, dimension(:)         , pointer     ,save :: pick1 , pick2 , pick3 , pick4 , pick5 , pick6, pick7,pick8,pick9,pick10,pick11,pick12,pick13,pick14,pick15                  !picks-reservoir tops
  real, dimension(:)         , pointer     ,save :: norm1 , norm2 , norm3 , norm4 , norm5 , norm6, norm7,norm8,norm9,norm10,norm11,norm12,norm13,norm14,norm15                  !norm-file 
  real, dimension(:)         , pointer     ,save :: hesp1 , hesp2 , hesp3 , hesp4 , hesp5 , hesp6, hesp7,hesp8,hesp9,hesp10,hesp11,hesp12,hesp13,hesp14,hesp15                  !diag-hessian
  real, dimension(:,:)       , pointer     ,save :: rmov1 , rmov2 , rmov3 , rmov4 , rmov5 , rmov6, rmov7,rmov8,rmov9,rmov10,rmov11,rmov12,rmov13,rmov14,rmov15                  !movie-data-residual
  real, dimension(:,:)       , pointer     ,save :: mmov1 , mmov2 , mmov3 , mmov4 , mmov5 , mmov6, mmov7,mmov8,mmov9,mmov10,mmov11,mmov12,mmov13,mmov14,mmov15                  !movie-model
  real, dimension(:,:,:)     , pointer     ,save :: hess1 , hess2 , hess3 , hess4 , hess5 , hess6, hess7,hess8,hess9,hess10,hess11,hess12,hess13,hess14,hess15                  !hessian-
  real, dimension(:,:,:,:,:) , pointer     ,save :: hes1  , hes2  , hes3  , hes4  , hes5  , hes6 ,  hes7, hes8, hes9, hes10, hes11, hes12, hes13, hes14, hes15                  !hessian-
  real, dimension(:,:,:,:,:,:), pointer    ,save :: he1   , he2   , he3   , he4   , he5   , he6  ,   he7,  he8,  he9,  he10,  he11,  he12,  he13,  he14,  he15                  !hessian-
  real, dimension(:,:,:,:,:,:), pointer    ,save :: HE_1  , HE_2  , HE_3  , HE_4  , HE_5  , HE_6 ,  HE_7, HE_8, HE_9, HE_10, HE_11, HE_12, HE_13, HE_14, HE_15                  !hessian-for small 2D 
  real, dimension(:,:)        , pointer    ,save :: code1 , code2 , code3 , code4 , code5 , code6, code7,code8,code9,code10,code11,code12,code13,code14,code15                  !codes-
  complex, dimension(:,:,:)   , pointer    ,save :: csou1 , csou2 , csou3 , csou4 , csou5 , csou6, csou7,csou8,csou9,csou10,csou11,csou12,csou13,csou14,csou15                  !source wavelet-
  complex, dimension(:,:,:,:,:) ,pointer  ,save ::  souz1 , souz2 , souz3 , souz4 , souz5 , souz6, souz7,souz8,souz9,souz10,souz11,souz12,souz13,souz14,souz15                  !greens-functions-source at max depth
  complex, dimension(:,:,:,:,:,:),pointer  ,save :: gscd1 , gscd2 , gscd3 , gscd4 , gscd5 , gscd6, gscd7,gscd8,gscd9,gscd10,gscd11,gscd12,gscd13,gscd14,gscd15                  !greens-functions-source
  complex, dimension(:,:,:,:,:,:), pointer ,save :: grcd1 , grcd2 , grcd3 , grcd4 , grcd5 , grcd6, grcd7,grcd8,grcd9,grcd10,grcd11,grcd12,grcd13,grcd14,grcd15                  !greens-functions-recievers
  real, dimension(:)         , allocatable ,target,save :: modl0,smold0,modl00
  complex, dimension(:)      , allocatable ,target,save :: fdata0 
  real, dimension(:)         , allocatable ,target,save :: vel0
  real, dimension(:)         , allocatable ,target,save :: data0
  real, dimension(:)         , allocatable ,target,save :: dips0
  real, dimension(:)         , allocatable ,target,save :: gamm0
  real, dimension(:)         , allocatable ,target,save :: epsi0
  real, dimension(:)         , allocatable ,target,save :: lmbd0
  real, dimension(:)         , allocatable ,target,save :: mask0
  real, dimension(:)         , allocatable ,target,save :: wght0
  real, dimension(:)         , allocatable ,target,save :: pick0
  real, dimension(:)         , allocatable ,target,save :: norm0
  real, dimension(:)         , allocatable ,target,save :: hesp0
  real, dimension(:,:)       , allocatable ,target,save :: rmov0
  real, dimension(:,:)       , allocatable ,target,save :: mmov0
  real, dimension(:,:,:)     , allocatable ,target,save :: hess0
  real, dimension(:,:,:,:,:) , allocatable ,target,save :: hes0 
  real, dimension(:,:,:,:,:,:),allocatable ,target,save :: he0  
  real, dimension(:,:,:,:,:,:),allocatable ,target,save :: HE_0 
  real, dimension(:,:,:)        ,allocatable ,target,save :: code0
  complex, dimension(:,:,:,:)    ,allocatable,target,save :: csou0
  complex, dimension(:,:,:,:,:,:,:),allocatable,target,save:: gscd0
  complex, dimension(:,:,:,:,:,:,:),allocatable,target,save:: grcd0
  complex, dimension(:,:,:,:,:,:,:),allocatable,target,save:: souz0
  real, dimension(:,:,:,:,:)       ,allocatable,target,save:: maps0

  character(len=256)                       ,save ::         modl1_, modl2_, modl3_, modl4_, modl5_, modl6_, modl7_, modl8_ , modl9_, modl10_, modl11_, modl12_, modl13_, modl14_, modl15_  
  character(len=256)                       ,save ::         data1_, data2_, data3_, data4_, data5_, data6_, data7_, data8_ , data9_, data10_, data11_, data12_, data13_, data14_, data15_  
  character(len=256)                       ,save ::         dhdr1_, dhdr2_, dhdr3_, dhdr4_, dhdr5_, dhdr6_, dhdr7_, dhdr8_ , dhdr9_, dhdr10_, dhdr11_, dhdr12_, dhdr13_, dhdr14_, dhdr15_  !hear
  character(len=256)                       ,save ::          vel1_,  vel2_,  vel3_,  vel4_,  vel5_,  vel6_,  vel7_,  vel8_ ,  vel9_,  vel10_,  vel11_,  vel12_,  vel13_,  vel14_ , vel15_  
  character(len=256)                       ,save ::         ts1_, ts2_, ts3_, ts4_, ts5_, ts6_, ts7_, ts8_ , ts9_, ts10_, ts11_, ts12_, ts13_, ts14_, ts15_  
  character(len=256)                       ,save ::         sd1_, sd2_, sd3_, sd4_, sd5_, sd6_, sd7_, sd8_ , sd9_, sd10_, sd11_, sd12_, sd13_, sd14_, sd15_  
  character(len=256)                       ,save ::         cc1_, cc2_, cc3_, cc4_, cc5_, cc6_, cc7_, cc8_ , cc9_, cc10_, cc11_, cc12_, cc13_, cc14_, cc15_  
  character(len=256)                       ,save ::         rr1_, rr2_, rr3_, rr4_, rr5_, rr6_, rr7_, rr8_ , rr9_, rr10_, rr11_, rr12_, rr13_, rr14_, rr15_  
  character(len=256)                       ,save ::         rm1_, rm2_, rm3_, rm4_, rm5_, rm6_, rm7_, rm8_ , rm9_, rm10_, rm11_, rm12_, rm13_, rm14_, rm15_  
  character(len=256)                       ,save ::         am1_, am2_, am3_, am4_, am5_, am6_, am7_, am8_ , am9_, am10_, am11_, am12_, am13_, am14_, am15_  
  character(len=256)                       ,save ::         bm1_, bm2_, bm3_, bm4_, bm5_, bm6_, bm7_, bm8_ , bm9_, bm10_, bm11_, bm12_, bm13_, bm14_, bm15_  
  character(len=256)                       ,save ::        smodl1_,smodl2_,smodl3_,smodl4_,smodl5_,smodl6_,smodl7_,smodl8_ ,smodl9_,smodl10_,smodl11_,smodl12_,smodl13_,smodl14_,smodl15_
  character(len=256)                       ,save ::           sv1_,   sv2_,   sv3_,   sv4_,   sv5_,   sv6_,   sv7_,   sv8_ ,   sv9_,   sv10_,   sv11_,   sv12_,   sv13_,   sv14_,   sv15_ 
  character(len=256)                       ,save :: hess_ , hess1_, hess2_, hess3_, hess4_, hess5_, hess6_, hess7_, hess8_ , hess9_, hess10_, hess11_, hess12_, hess13_, hess14_, hess15_ 
  character(len=256)                       ,save :: hesp_ , hesp1_, hesp2_, hesp3_, hesp4_, hesp5_, hesp6_, hesp7_, hesp8_ , hesp9_, hesp10_, hesp11_, hesp12_, hesp13_, hesp14_, hesp15_  
  character(len=256)                       ,save :: mmov_ , mmov1_, mmov2_, mmov3_, mmov4_, mmov5_, mmov6_, mmov7_, mmov8_ , mmov9_, mmov10_, mmov11_, mmov12_, mmov13_, mmov14_, mmov15_  
  character(len=256)                       ,save :: rmov_ , rmov1_, rmov2_, rmov3_, rmov4_, rmov5_, rmov6_, rmov7_, rmov8_ , rmov9_, rmov10_, rmov11_, rmov12_, rmov13_, rmov14_, rmov15_  
  character(len=256)                       ,save :: norm_ , norm1_, norm2_, norm3_, norm4_, norm5_, norm6_, norm7_, norm8_ , norm9_, norm10_, norm11_, norm12_, norm13_, norm14_, norm15_  
  character(len=256)                       ,save :: epsi_ , epsi1_, epsi2_, epsi3_, epsi4_, epsi5_, epsi6_, epsi7_, epsi8_ , epsi9_, epsi10_, epsi11_, epsi12_, epsi13_, epsi14_, epsi15_  
  character(len=256)                       ,save :: lmbd_ , lmbd1_, lmbd2_, lmbd3_, lmbd4_, lmbd5_, lmbd6_, lmbd7_, lmbd8_ , lmbd9_, lmbd10_, lmbd11_, lmbd12_, lmbd13_, lmbd14_, lmbd15_  
  character(len=256)                       ,save :: mask_ , mask1_, mask2_, mask3_, mask4_, mask5_, mask6_, mask7_, mask8_ , mask9_, mask10_, mask11_, mask12_, mask13_, mask14_, mask15_  
  character(len=256)                       ,save :: wght_ , wght1_, wght2_, wght3_, wght4_, wght5_, wght6_, wght7_, wght8_ , wght9_, wght10_, wght11_, wght12_, wght13_, wght14_, wght15_  
  character(len=256)                       ,save :: pick_ , pick1_, pick2_, pick3_, pick4_, pick5_, pick6_, pick7_, pick8_ , pick9_, pick10_, pick11_, pick12_, pick13_, pick14_, pick15_  
  character(len=256)                       ,save ::         code1_, code2_, code3_, code4_, code5_, code6_, code7_, code8_ , code9_, code10_, code11_, code12_, code13_, code14_, code15_  
  character(len=256)                       ,save ::         souz1_, souz2_, souz3_, souz4_, souz5_, souz6_, souz7_, souz8_ , souz9_, souz10_, souz11_, souz12_, souz13_, souz14_, souz15_   
  character(len=256)                       ,save ::         gscd1_, gscd2_, gscd3_, gscd4_, gscd5_, gscd6_, gscd7_, gscd8_ , gscd9_, gscd10_, gscd11_, gscd12_, gscd13_, gscd14_, gscd15_  
  character(len=256)                       ,save ::         grcd1_, grcd2_, grcd3_, grcd4_, grcd5_, grcd6_, grcd7_, grcd8_ , grcd9_, grcd10_, grcd11_, grcd12_, grcd13_, grcd14_, grcd15_  
  character(len=256)                       ,save ::         wfld1_, wfld2_, wfld3_, wfld4_, wfld5_, wfld6_, wfld7_, wfld8_ , wfld9_, wfld10_, wfld11_, wfld12_, wfld13_, wfld14_, wfld15_
  character(len=256)                       ,save ::         dips1_, dips2_, dips3_, dips4_, dips5_, dips6_, dips7_, dips8_ , dips9_, dips10_, dips11_, dips12_, dips13_, dips14_, dips15_  
  character(len=256)                       ,save ::         maps1_, maps2_, maps3_, maps4_, maps5_, maps6_, maps7_, maps8_ , maps9_, maps10_, maps11_, maps12_, maps13_, maps14_, maps15_  
  real                                     ,save ::      eps1, eps2, eps3, eps4, eps5, eps6, eps7, eps8, eps9, eps10, eps11, eps12, eps13, eps14, eps15 
  real                                     ,save :: lmb, lmb1, lmb2, lmb3, lmb4, lmb5, lmb6, lmb7, lmb8, lmb9, lmb10, lmb11, lmb12, lmb13, lmb14, lmb15 
  real                                     ,save :: gam, gam1, gam2, gam3, gam4, gam5, gam6, gam7, gam8, gam9, gam10, gam11, gam12, gam13, gam14, gam15 
  real                                     ,save :: epi, epi1, epi2, epi3, epi4, epi5, epi6, epi7, epi8, epi9, epi10, epi11, epi12, epi13, epi14, epi15 
  real                                     ,save :: lmd, lmd1, lmd2, lmd3, lmd4, lmd5, lmd6, lmd7, lmd8, lmd9, lmd10, lmd11, lmd12, lmd13, lmd14, lmd15 
  real                                     ,save :: prc, prc1, prc2, prc3, prc4, prc5, prc6, prc7, prc8, prc9, prc10, prc11, prc12, prc13, prc14, prc15 
  logical                                  ,save :: dot, joint, weight, msk, precon, lump, diag, psf, full, small, precond
  logical                                  ,save ::   epsi_1,   epsi_2,   epsi_3,   epsi_4,   epsi_5,   epsi_6,   epsi_7,   epsi_8,   epsi_9,   epsi_10,   epsi_11,   epsi_12,   epsi_13,   epsi_14,   epsi_15
  logical                                  ,save ::   mask_1,   mask_2,   mask_3,   mask_4,   mask_5,   mask_6,   mask_7,   mask_8,   mask_9,   mask_10,   mask_11,   mask_12,   mask_13,   mask_14,   mask_15
  logical                                  ,save ::   pick_1,   pick_2,   pick_3,   pick_4,   pick_5,   pick_6,   pick_7,   pick_8,   pick_9,   pick_10,   pick_11,   pick_12,   pick_13,   pick_14,   pick_15
  logical                                  ,save :: weight_1, weight_2, weight_3, weight_4, weight_5, weight_6, weight_7, weight_8, weight_9, weight_10, weight_11, weight_12, weight_13, weight_14, weight_15
  integer                                  ,save :: jmov, mode, nsurv
  integer                                  ,save :: nmod, noff, ndat, ndat_real
  integer                                  ,save :: iter
  real                                     ,save :: riter
  logical                                  ,save :: all     

!minres      
  real(dp) , dimension(:)     ,allocatable ,save :: data_mres
  real(dp) , dimension(:)     ,allocatable ,save :: modl_mres
  real(dp) , dimension(:)     ,allocatable ,save :: data1_mres, data2_mres, data3_mres, data4_mres, data5_mres, data6_mres  
  real(dp) , dimension(:)     ,allocatable ,save :: modl1_mres, modl2_mres, modl3_mres, modl4_mres, modl5_mres, modl6_mres  
  real(dp)                                 ,save :: Anorm, Acond, Arnorm, rnorm, rtol, r1norm, ynorm
  integer                                  ,save :: n, j, itnlim, istop, itn, nprint
  double precision                         ,save :: tol
  logical                                  ,save :: checkA, noreg 


!####fact_dz 
  real                                     ,save :: dz_fact     
  logical                                  ,save :: ldz_fact     
!####use reservoir picks???
  logical                                  ,save :: lpick
  real                                     ,save :: pclip1
  real                                     ,save :: pclip2
!#####type of 4d reg.
  integer                                  ,save :: reg_4d
!#####type of base/moni reg.
  integer                                  ,save :: reg_base
  integer                                  ,save :: reg_temp

!#####horizontal reflectors (can use simple regs.)
  logical                                  ,save :: flat
!#####axes defaults
  type(axis)                               ,save :: mov, nrm 
  type(axis)                               ,save :: h1,h2,h3,h4,h5,h6,h7,h8,h9,h10
!hess_conv
    integer                                ,save :: ix_modl, iy_modl, iz_modl
    integer                                ,save :: ix_offd, iy_offd, iz_offd
    integer                                ,save :: ix_o, iy_o, iz_o
    integer                                ,save :: ix_m, iy_m, iz_m
    real                                   ,save :: x_offd, y_offd, z_offd
    real                                   ,save :: x_modl, y_modl, z_modl
    real                                   ,save :: maxz,maxx,maxy
    real                                   ,save :: edge
!    real                                   ,save :: start_time, finish_time, start_t, finish_t, start_t0, finish_t0, start_t1, finish_t1, tot_t, int_t
!    integer                                ,save :: time_array_0(8), time_array_1(8), time_array_3(8), time_array_4(8), time_array_5(8), time_array_6(8)
    logical                                ,save :: timing1, timing2, timing3
    
    integer                                ,save :: method
    integer                                ,save :: rtop
!general
    logical                                ,save :: is2d, ismall
    integer                                ,save :: i
    integer                                ,save :: ns
    integer                                ,save :: ng
    logical                                ,save :: spatio
!irls
    real                                   ,save:: tresh
    integer                                ,save:: nfreq, nerr
!prc
    real                                   ,save:: rho, rho_t
!filt
    type(filter)                           ,save:: aa1,aa2
    integer                                ,save:: filt
    integer                                ,save:: hlx_conv
!nhlx
    integer,allocatable                    ,save:: ptch(:), n_nfilt(:)
    real   ,allocatable                    ,save:: dips(:)
    real                                   ,save:: dip
    integer                                ,save:: idip
    real                                   ,save:: pi_1, pi_2, dip0
    type(nfilter)                          ,save:: n_filt 
    type(nfilter)                          ,save:: f_filt 
    type(nfilter)                          ,save:: s_filt 
    type(nfilter)                          ,save:: lapfilt
    type( filter)                          ,save:: hfilt2
    integer                                ,save:: iang,ifilt
    real                                   ,save:: lapfilt0
    real                                   ,save:: n_filt0
    real                                   ,save:: m,p
    logical                                ,save:: destroy
    real                                   ,save:: dang, oang
    integer                                ,save:: nang, nfilt
    integer                                ,save:: verb1,verb2
    real                                   ,save:: dsc, osc
    integer                                ,save:: nsc
    real                                   ,save:: eps_dip
    real                                   ,save:: max_eps_dip, min_eps_dip
    real                                   ,save:: max_dip, min_dip


! scaling
    real, dimension(:)      , allocatable  ,save:: tscale !to scale temp
    real, dimension(:)      , allocatable  ,save:: sscale !to scale spatial 
    real                                   ,save:: dsscale
    real                                   ,save:: dtscale
    logical                                ,save:: lsscale
    logical                                ,save:: ltscale
    real                                   ,save:: max_rho  , min_rho
    real                                   ,save:: max_rho_t, min_rho_t
   
! random source shift
    complex,dimension(:,:,:),allocatable,target ,save:: sshft0 
    logical                                ,save:: lshft0, sshft_it
    complex, dimension(:,:)    , pointer   ,save:: sshft1 ,sshft2 ,sshft3 ,sshft4 ,sshft5 ,sshft6 ,sshft7 ,sshft8 ,sshft9 ,sshft10 ,sshft11 ,sshft12 ,sshft13 ,sshft14 ,sshft15
    logical                                ,save:: lshft1 ,lshft2 ,lshft3 ,lshft4 ,lshft5 ,lshft6 ,lshft7 ,lshft8 ,lshft9 ,lshft10 ,lshft11 ,lshft12 ,lshft13 ,lshft14 ,lshft15
    character(len=256)                     ,save:: sshft1_,sshft2_,sshft3_,sshft4_,sshft5_,sshft6_,sshft7_,sshft8_,sshft9_,sshft10_,sshft11_,sshft12_,sshft13_,sshft14_,sshft15_
    real                                   ,save:: sshft_min, sshft_max, sshft_lmt

! check if base has same encoding.....assume single source base
    logical                                ,save:: sbase1,sbase2,sbase3,sbase4,sbase5,sbase6,sbase7,sbase8,sbase9,sbase10,sbase11,sbase12,sbase13,sbase14,sbase15


!fault, salt files for special filtering..files contain contact edges where the filter range should be different (usu. reduced) compared to the full image space
!instead of above....use variance!!!! take f's as variance...
    real, dimension(:)            , pointer     ,save:: f1 , f2 , f3 , f4 , f5 , f6 , f7, f8, f9, f10, f11, f12, f13, f14, f15 
    real, dimension(:)            , pointer     ,save:: s1 , s2 , s3 , s4 , s5 , s6 , s7, s8, s9, s10, s11, s12, s13, s14, s15  
    real, dimension(:), allocatable,target      ,save:: f0, s0
    real                                        ,save:: f_min, f_max
    real                                        ,save:: s_min, s_max
    character(len=256)                          ,save:: f1_, f2_, f3_, f4_, f5_, f6_,f7_,f8_,f9_,f10_,f11_,f12_,f13_,f14_,f15_
    character(len=256)                          ,save:: s1_, s2_, s3_, s4_, s5_, s6_,s7_,s8_,s9_,s10_,s11_,s12_,s13_,s14_,s15_
    real                                        ,save:: dvar, ovar
    integer                                     ,save:: nvar
    integer,allocatable                         ,save:: varn(:)
    type(vnfilter)                              ,save:: vn_filt 
    
    real                                        ,save:: thres
    real                                        ,save:: quant


 ! compute epsi and lmb as a function of the data...[maxval(data)/denom] or quantile
   real                                         ,save:: eps_denom, lmb_denom, gam_denom 
   real                                         ,save:: eps_quant, lmb_quant, gam_quant
   logical                                      ,save:: lquant, eps_vec
 ! time/depth-shifting
   logical                                      ,save:: ltshift 
   logical                                      ,save:: lvshift
   logical                                      ,save:: lonly_dips
   logical                                      ,save:: lonly_temp
   logical                                      ,save:: lsft !out shift
   logical                                      ,save:: lcc  !out ccor 
   logical                                      ,save:: lsd  !out shift_diff
   logical                                      ,save:: lsv  !out shift_sv

   logical                                      ,save:: use_shft
   logical                                      ,save:: only_ltshift

 
 ! inversion count
    integer                                     ,save:: inv_niter
 
 !!!!!!!!!!!! hybrid
    character(12)                               ,save:: norm_d,norm_m,norm_m1,norm_m2 
    integer                                     ,save:: quant_period
    integer                                     ,save:: psiter,max_overshot
    real                                        ,save:: quant_m,quant_d
    logical                                     ,save:: lhybrid
 
 
 !same random code
    logical                                     ,save:: lsame_time
 
 !use sub-offset module
    logical                                     ,save:: lsub_offset
 
 !compute phase encoded hessian
    logical                                     ,save:: lhessian
 
    logical                                     ,save:: lall_nodes
 !use read full data?
    logical                                     ,save:: lread_data


 !surface array
    integer                                     ,save:: nsurf
    
 
    contains 
!==========================================================================================
  subroutine joint_encode_params_init() 
          modl1_ = "modl1" ;  data1_ = "data1" ; vel1_ ="vel1" ; hess1_ = "hess1" ; hesp1_ = "hesp1" ; mmov1_ = "mmov1" ; rmov1_ = "rmov1" ; norm1_ ="norm1" ; wght1_ = "wg1" ; mask1_ = "mask1" ; epsi1_ ="epsi1" ; lmbd1_ ="lmbd1" ; pick1_ = "pick1" ; code1_ = 'code1' ; grcd1_ = 'grcd1' ; dips1_ = 'dips1'; sshft1_ ='sshft1';  f1_ = 'f1'; s1_ = 's1'; ts1_ ="ts1" ; sd1_  ="sd1"  ; cc1_ ="cc1" ; smodl1_ ="smodl1" ; rr1_ ="rr1" ; sv1_ ="sv1" ; wfld1_ ="wfld1"  ; souz1_="souz1"  ; sv1_="sv1"  ; rm1_="rm1"  ; am1_="am1"   ; bm1_="bm1"      ;dhdr1_="dhdr1"   ;maps1_="maps1"
          modl2_ = "modl2" ;  data2_ = "data2" ; vel2_ ="vel2" ; hess2_ = "hess2" ; hesp2_ = "hesp2" ; mmov2_ = "mmov2" ; rmov2_ = "rmov2" ; norm2_ ="norm2" ; wght2_ = "wg2" ; mask2_ = "mask2" ; epsi2_ ="epsi2" ; lmbd2_ ="lmbd2" ; pick2_ = "pick2" ; code2_ = 'code2' ; grcd2_ = 'grcd2' ; dips2_ = 'dips2'; sshft2_ ='sshft2';  f2_ = 'f2'; s2_ = 's2'; ts2_ ="ts2" ; sd2_  ="sd2"  ; cc2_ ="cc2" ; smodl2_ ="smodl2" ; rr2_ ="rr2" ; sv2_ ="sv2" ; wfld2_ ="wfld2"  ; souz2_="souz2"  ; sv2_="sv2"  ; rm2_="rm2"  ; am2_="am2"   ; bm2_="bm2"      ;dhdr2_="dhdr2"   ;maps2_="maps2"
          modl3_ = "modl3" ;  data3_ = "data3" ; vel3_ ="vel3" ; hess3_ = "hess3" ; hesp3_ = "hesp3" ; mmov3_ = "mmov3" ; rmov3_ = "rmov3" ; norm3_ ="norm3" ; wght3_ = "wg3" ; mask3_ = "mask3" ; epsi3_ ="epsi3" ; lmbd3_ ="lmbd3" ; pick3_ = "pick3" ; code3_ = 'code3' ; grcd3_ = 'grcd3' ; dips3_ = 'dips3'; sshft3_ ='sshft3';  f3_ = 'f3'; s3_ = 's3'; ts3_ ="ts3" ; sd3_  ="sd3"  ; cc3_ ="cc3" ; smodl3_ ="smodl3" ; rr3_ ="rr3" ; sv3_ ="sv3" ; wfld3_ ="wfld3"  ; souz3_="souz3"  ; sv3_="sv3"  ; rm3_="rm3"  ; am3_="am3"   ; bm3_="bm3"      ;dhdr3_="dhdr3"   ;maps3_="maps3"
          modl4_ = "modl4" ;  data4_ = "data4" ; vel4_ ="vel4" ; hess4_ = "hess4" ; hesp4_ = "hesp4" ; mmov4_ = "mmov4" ; rmov4_ = "rmov4" ; norm4_ ="norm4" ; wght4_ = "wg4" ; mask4_ = "mask4" ; epsi4_ ="epsi4" ; lmbd4_ ="lmbd4" ; pick4_ = "pick4" ; code4_ = 'code4' ; grcd4_ = 'grcd4' ; dips4_ = 'dips4'; sshft4_ ='sshft4';  f4_ = 'f4'; s4_ = 's4'; ts4_ ="ts4" ; sd4_  ="sd4"  ; cc4_ ="cc4" ; smodl4_ ="smodl4" ; rr4_ ="rr4" ; sv4_ ="sv4" ; wfld4_ ="wfld4"  ; souz4_="souz4"  ; sv4_="sv4"  ; rm4_="rm4"  ; am4_="am4"   ; bm4_="bm4"      ;dhdr4_="dhdr4"   ;maps4_="maps4"
          modl5_ = "modl5" ;  data5_ = "data5" ; vel5_ ="vel5" ; hess5_ = "hess5" ; hesp5_ = "hesp5" ; mmov5_ = "mmov5" ; rmov5_ = "rmov5" ; norm5_ ="norm5" ; wght5_ = "wg5" ; mask5_ = "mask5" ; epsi5_ ="epsi5" ; lmbd5_ ="lmbd5" ; pick5_ = "pick5" ; code5_ = 'code5' ; grcd5_ = 'grcd5' ; dips5_ = 'dips5'; sshft5_ ='sshft5';  f5_ = 'f5'; s5_ = 's5'; ts5_ ="ts5" ; sd5_  ="sd5"  ; cc5_ ="cc5" ; smodl5_ ="smodl5" ; rr5_ ="rr5" ; sv5_ ="sv5" ; wfld5_ ="wfld5"  ; souz5_="souz5"  ; sv5_="sv5"  ; rm5_="rm5"  ; am5_="am5"   ; bm5_="bm5"      ;dhdr5_="dhdr5"   ;maps5_="maps5"
          modl6_ = "modl6" ;  data6_ = "data6" ; vel6_ ="vel6" ; hess6_ = "hess6" ; hesp6_ = "hesp6" ; mmov6_ = "mmov6" ; rmov6_ = "rmov6" ; norm6_ ="norm6" ; wght6_ = "wg6" ; mask6_ = "mask6" ; epsi6_ ="epsi6" ; lmbd6_ ="lmbd6" ; pick6_ = "pick6" ; code6_ = 'code6' ; grcd6_ = 'grcd6' ; dips6_ = 'dips6'; sshft6_ ='sshft6';  f6_ = 'f6'; s6_ = 's6'; ts6_ ="ts6" ; sd6_  ="sd6"  ; cc6_ ="cc6" ; smodl6_ ="smodl6" ; rr6_ ="rr6" ; sv6_ ="sv6" ; wfld6_ ="wfld6"  ; souz6_="souz6"  ; sv6_="sv6"  ; rm6_="rm6"  ; am6_="am6"   ; bm6_="bm6"      ;dhdr6_="dhdr6"   ;maps6_="maps6"
          modl7_ = "modl7" ;  data7_ = "data7" ; vel7_ ="vel7" ; hess7_ = "hess7" ; hesp7_ = "hesp7" ; mmov7_ = "mmov7" ; rmov7_ = "rmov7" ; norm7_ ="norm7" ; wght7_ = "wg7" ; mask7_ = "mask7" ; epsi7_ ="epsi7" ; lmbd7_ ="lmbd7" ; pick7_ = "pick7" ; code8_ = 'code7' ; grcd7_ = 'grcd7' ; dips7_ = 'dips7'; sshft7_ ='sshft7';  f7_ = 'f7'; s7_ = 's7'; ts7_ ="ts7" ; sd7_  ="sd7"  ; cc7_ ="cc7" ; smodl7_ ="smodl7" ; rr7_ ="rr7" ; sv7_ ="sv7" ; wfld7_ ="wfld7"  ; souz7_="souz7"  ; sv7_="sv7"  ; rm7_="rm7"  ; am7_="am7"   ; bm7_="bm7"      ;dhdr7_="dhdr7"   ;maps7_="maps7"
          modl8_ = "modl8" ;  data8_ = "data8" ; vel8_ ="vel8" ; hess8_ = "hess8" ; hesp8_ = "hesp8" ; mmov8_ = "mmov8" ; rmov8_ = "rmov8" ; norm8_ ="norm8" ; wght8_ = "wg8" ; mask8_ = "mask8" ; epsi8_ ="epsi8" ; lmbd8_ ="lmbd8" ; pick8_ = "pick8" ; code7_ = 'code8' ; grcd8_ = 'grcd8' ; dips8_ = 'dips8'; sshft8_ ='sshft8';  f8_ = 'f8'; s8_ = 's8'; ts8_ ="ts8" ; sd8_  ="sd8"  ; cc8_ ="cc8" ; smodl8_ ="smodl8" ; rr8_ ="rr8" ; sv8_ ="sv8" ; wfld8_ ="wfld8"  ; souz8_="souz8"  ; sv8_="sv8"  ; rm8_="rm8"  ; am8_="am8"   ; bm8_="bm8"      ;dhdr8_="dhdr8"   ;maps8_="maps8"
          modl9_ = "modl9" ;  data9_ = "data9" ; vel9_ ="vel9" ; hess9_ = "hess9" ; hesp9_ = "hesp9" ; mmov9_ = "mmov9" ; rmov9_ = "rmov9" ; norm9_ ="norm9" ; wght9_ = "wg9" ; mask9_ = "mask9" ; epsi9_ ="epsi9" ; lmbd9_ ="lmbd9" ; pick9_ = "pick9" ; code9_ = 'code9' ; grcd9_ = 'grcd9' ; dips9_ = 'dips9'; sshft9_ ='sshft9';  f9_ = 'f9'; s9_ = 's9'; ts9_ ="ts9" ; sd9_  ="sd9"  ; cc9_ ="cc9" ; smodl9_ ="smodl9" ; rr9_ ="rr9" ; sv9_ ="sv9" ; wfld9_ ="wfld9"  ; souz9_="souz9"  ; sv9_="sv9"  ; rm9_="rm9"  ; am9_="am9"   ; bm9_="bm9"      ;dhdr9_="dhdr9"   ;maps9_="maps9"
          modl10_= "modl10"; data10_ = "data10"; vel10_="vel10"; hess10_= "hess10"; hesp10_= "hesp10"; mmov10_= "mmov10"; rmov10_= "rmov10"; norm10_="norm10"; wght10_= "wg10"; mask10_= "mask10"; epsi10_="epsi10"; lmbd10_="lmbd10"; pick10_= "pick10"; code10_= 'code10'; grcd10_= 'grcd10'; dips10_='dips10'; sshft10_='sshft10'; f10_='f10'; s10_='s10'; ts10_="ts10"; sd10_ ="sd10" ; cc10_="cc10"; smodl10_="smodl10"; rr10_="rr10"; sv10_="sv10"; wfld10_="wfld10" ; souz10_="souz10"; sv10_="sv10"; rm10_="rm10"; am10_="am10" ; bm10_="bm10"    ;dhdr10_="dhdr10" ;maps10_="maps10"
          modl11_= "modl11"; data11_ = "data11"; vel11_="vel11"; hess11_= "hess11"; hesp11_= "hesp11"; mmov11_= "mmov11"; rmov11_= "rmov11"; norm11_="norm11"; wght11_= "wg11"; mask11_= "mask11"; epsi11_="epsi11"; lmbd11_="lmbd11"; pick11_= "pick11"; code11_= 'code11'; grcd11_= 'grcd11'; dips11_='dips11'; sshft11_='sshft11'; f11_='f11'; s11_='s11'; ts11_="ts11"; sd11_ ="sd11" ; cc11_="cc11"; smodl11_="smodl11"; rr11_="rr11"; sv11_="sv11"; wfld11_="wfld11" ; souz11_="souz11"; sv11_="sv11"; rm11_="rm11"; am11_="am11" ; bm11_="bm11"    ;dhdr11_="dhdr11" ;maps11_="maps11"
          modl12_= "modl12"; data12_ = "data12"; vel12_="vel12"; hess12_= "hess12"; hesp12_= "hesp12"; mmov12_= "mmov12"; rmov12_= "rmov12"; norm12_="norm12"; wght12_= "wg12"; mask12_= "mask12"; epsi12_="epsi12"; lmbd12_="lmbd12"; pick12_= "pick12"; code12_= 'code12'; grcd12_= 'grcd12'; dips12_='dips12'; sshft12_='sshft12'; f12_='f12'; s12_='s12'; ts12_="ts12"; sd12_ ="sd12" ; cc12_="cc12"; smodl12_="smodl12"; rr12_="rr12"; sv12_="sv12"; wfld12_="wfld12" ; souz12_="souz12"; sv12_="sv12"; rm12_="rm12"; am12_="am12" ; bm12_="bm12"    ;dhdr12_="dhdr12" ;maps12_="maps12"
          modl13_= "modl13"; data13_ = "data13"; vel13_="vel13"; hess13_= "hess13"; hesp13_= "hesp13"; mmov13_= "mmov13"; rmov13_= "rmov13"; norm13_="norm13"; wght13_= "wg13"; mask13_= "mask13"; epsi13_="epsi13"; lmbd13_="lmbd13"; pick13_= "pick13"; code13_= 'code13'; grcd13_= 'grcd13'; dips13_='dips13'; sshft13_='sshft13'; f13_='f13'; s13_='s13'; ts13_="ts13"; sd13_ ="sd13" ; cc13_="cc13"; smodl13_="smodl13"; rr13_="rr13"; sv13_="sv13"; wfld13_="wfld13" ; souz13_="souz13"; sv13_="sv13"; rm13_="rm13"; am13_="am13" ; bm13_="bm13"    ;dhdr13_="dhdr13" ;maps13_="maps13"
          modl14_= "modl14"; data14_ = "data14"; vel14_="vel14"; hess14_= "hess14"; hesp14_= "hesp14"; mmov14_= "mmov14"; rmov14_= "rmov14"; norm14_="norm14"; wght14_= "wg14"; mask14_= "mask14"; epsi14_="epsi14"; lmbd14_="lmbd14"; pick14_= "pick14"; code14_= 'code14'; grcd14_= 'grcd14'; dips14_='dips14'; sshft14_='sshft14'; f14_='f14'; s14_='s14'; ts14_="ts14"; sd14_ ="sd14" ; cc14_="cc14"; smodl14_="smodl14"; rr14_="rr14"; sv14_="sv14"; wfld14_="wfld14" ; souz14_="souz14"; sv14_="sv14"; rm14_="rm14"; am14_="am14" ; bm14_="bm14"    ;dhdr14_="dhdr14" ;maps14_="maps14"
          modl15_= "modl15"; data15_ = "data15"; vel15_="vel15"; hess15_= "hess15"; hesp15_= "hesp15"; mmov15_= "mmov15"; rmov15_= "rmov15"; norm15_="norm15"; wght15_= "wg15"; mask15_= "mask15"; epsi15_="epsi15"; lmbd15_="lmbd15"; pick15_= "pick15"; code15_= 'code15'; grcd15_= 'grcd15'; dips15_='dips15'; sshft15_='sshft15'; f15_='f15'; s15_='s15'; ts15_="ts15"; sd15_ ="sd15" ; cc15_="cc15"; smodl15_="smodl15"; rr15_="rr15"; sv15_="sv15"; wfld15_="wfld15" ; souz15_="souz15"; sv15_="sv15"; rm15_="rm15"; am15_="am15" ; bm15_="bm15"    ;dhdr15_="dhdr15" ;maps15_="maps15"
          rmov_="rmov"
          mmov_="mmov"

          call from_param("spatio"  ,spatio   ,  F     );       
          call from_param("all"     ,all      ,  F     );       
          call from_param("method"  ,method   ,  1     ); 
          call from_param("lump"    ,lump     ,  F     );       
          call from_param("diag"    ,diag     ,  F     ); 
          call from_param("full"    ,full     ,  F     );      
          call from_param("diag"    ,psf      ,  F     );  
          call from_param("dot"     ,dot      ,  F     );         
          call from_param("joint"   ,joint    ,  T     ); 
          call from_param("weight"  ,weight   ,  F     );     
          call from_param("msk"     ,msk      ,  F     );         
          call from_param("precon"  ,precon   ,  F     ); 
          call from_param("timing1" ,timing1  ,  F     ); 
          call from_param("timing2" ,timing2  ,  F     ); 
          call from_param("edge"    ,edge     , 0.3    ); 
          call from_param("mode"    ,mode     , 1      );
          call from_param("nsurv"   ,nsurv    , 2      );
          call from_param("jmov", jmov, max(4,int(niter/50.)))
          call from_param("small"   ,small    ,  T     );
          call from_param("precond" ,precond  ,  F     );
          call from_param("dz_fact" ,dz_fact  ,  1.    );
          call from_param("ldz_fact",ldz_fact ,  F     );
          call from_param("lpick"   ,lpick    ,  T     );
          call from_param("reg_4d"  ,reg_4d   ,  1     ); 
          call from_param("reg_base",reg_base ,  1     );
          call from_param("reg_temp",reg_temp ,  1     );
          call from_param("pclip1"  ,pclip1   ,  0.1   );
          call from_param("pclip2"  ,pclip2   ,  0.2   );
          call from_param("flat"    ,flat     ,  F     );
          call from_param("nodes"   ,nodes    , 1      );
          call from_param("eps"     ,eps      , 0.5    );
          nnode = omp_get_num_procs(); thread=omp_get_thread_num();  nodes=min(nnode-1,nodes); call omp_set_num_threads(nodes); write(*,*) 'using', nodes, 'of' , nnode
!
          call from_param("eps1",eps1,0.6);  call from_param("eps2",eps2,0.8);  call from_param("eps3",eps3,0.6);  call from_param("eps4",eps4,0.6);  call from_param("eps5",eps5,0.6);  call from_param("eps6",eps6,0.8); 
          call from_param("lmb1",lmb1,0.0);  call from_param("lmb2",lmb2,0.0);  call from_param("lmb3",lmb3,0.4);  call from_param("lmb4",lmb4,0.4);  call from_param("lmb5",lmb5,0.4);  call from_param("lmb6",lmb6,0.4);
          call from_param("epi1",epi1,0.6);  call from_param("epi2",epi2,0.8);  call from_param("epi3",epi3,0.6);  call from_param("epi4",epi4,0.6);  call from_param("epi5",epi5,0.6);  call from_param("epi6",epi6,0.8); 
          call from_param("lmd1",lmd1,0.0);  call from_param("lmd2",lmd2,0.0);  call from_param("lmd3",lmd3,0.4);  call from_param("lmd4",lmd4,0.4);  call from_param("lmd5",lmd5,0.4);  call from_param("lmd6",lmd6,0.4);
          call from_param("prc1",prc1,1.0);  call from_param("prc2",prc2,1.0);  call from_param("prc3",prc3,1.0);  call from_param("prc4",prc4,1.0);  call from_param("prc5",prc5,1.0);  call from_param("prc6",prc6,1.0);
!irls
        call from_param ("tresh",tresh,0.082); 
        call from_param ("nfreq",nfreq,5    );
!prc
        call from_param ("rho",rho  ,0.5    ); 
        call from_param ("rho_t",rho_t,0.5    ); 
        call from_param ("reg_temp",reg_temp,1); 
!hlx
        call from_param ("filt",filt,      1); 
        call from_param ("hlx_conv",hlx_conv,  2); 

!nhlx

        pi_1=-pi/2
        pi_2=+pi/2 ! range of angles
    
        call from_param('all  ',all ,     .false.)
        call from_param('nang ',nang,       360  )
        if (nang>1)then; call from_param('dang ',dang, pi/(nang-1)); 
        elseif (nang==1)then; call from_param('dang ',dang,1.); 
        elseif (nang<1)then; call from_param('dang ',dang,0.); endif
        call from_param('oang ',oang,        pi_1)
        call from_param('nfilt',nfilt,         14)
        call from_param('verb' ,verb,           1)
        call from_param('verb1',verb1,          0)
        call from_param('verb2',verb2,          0)
        call from_param('eps_dip',eps_dip, 0.0016)
        call from_param('max_eps_dip',max_eps_dip, 0.5  )
        call from_param('min_eps_dip',min_eps_dip, 0.001)
        call from_param('max_dip',max_dip, -pi/2)
        call from_param('min_dip',min_dip, +pi/2)

!scaling
       call from_param("dsscale",    dsscale,niter*1.);       
       call from_param("dtscale",    dtscale,niter*1.);            
       call from_param("lsscale",    lsscale,  T     );       
       call from_param("ltscale",    ltscale,  F     );       
       call from_param("use_greens",use_greens,F     );       

       call from_param('max_rho'  ,max_rho  , 1. )
       call from_param('min_rho'  ,min_rho  , 0.1)
       call from_param('max_rho_t',max_rho_t, 1. )
       call from_param('min_rho_t',min_rho_t, 0.1)

!scaling for faults and salt edges...factor of the orig eps_dip 
       call from_param('f_max',f_max, 4. )
       call from_param('f_min',f_min, 4. )
       call from_param('s_max',s_max, 4. )
       call from_param('s_min',s_min, 4. )
!....use var....
       call from_param('nvar', nvar, 1 )
       if (nvar>1)then; 
                call from_param('dvar ',dvar,(max_eps_dip-min_eps_dip )/nvar);
       elseif (nvar==1)then; 
                call from_param('dvar ',dvar,1.); 
       elseif (nvar<1 )then;  
                call from_param('dvar ',dvar,0.);
                nvar=1        
       endif
       call from_param('ovar ',ovar, 1.)

!shot shifts
       call from_param("lshft1",  lshft1,  lshft1  ); 
       call from_param("lshft2",  lshft2,  lshft2  );
       call from_param("lshft3",  lshft3,  lshft3  );
       call from_param("lshft4",  lshft4,  lshft4  );
       call from_param("lshft5",  lshft5,  lshft5  );
       call from_param("lshft6",  lshft6,  lshft6  );
       call from_param("lshft7",  lshft7,  lshft7  );
       call from_param("lshft8",  lshft8,  lshft8  );
       call from_param("lshft9",  lshft9,  lshft9  );
       call from_param("lshft10", lshft10, lshft10 );
       call from_param("lshft11", lshft11, lshft11 );
       call from_param("lshft12", lshft12, lshft12 );
       call from_param("lshft13", lshft13, lshft13 );
       call from_param("lshft14", lshft14, lshft14 );
       call from_param("lshft15", lshft15, lshft15 );
       call from_param("lshft0", lshft0, (lshft1 .or.lshft2 .or.lshft3 .or.lshft4 .or.lshft5 .or.lshft6.or.lshft7.or.lshft8.or.lshft9.or.lshft10.or. &
                 lshft11.or.lshft12.or.lshft13.or.lshft14.or.lshft15))

!single base?
       call from_param("sbase1", sbase1, F); call from_param("sbase2", sbase2, F); call from_param("sbase3", sbase3, F);
       call from_param("sbase4", sbase4, F); call from_param("sbase5", sbase5, F); call from_param("sbase6", sbase6, F);
       call from_param("sbase7", sbase7, F); call from_param("sbase8", sbase8, F); call from_param("sbase9", sbase9, F);
       call from_param("sbase10",sbase10,F); call from_param("sbase11",sbase11,F); call from_param("sbase12",sbase12,F); 
       call from_param("sbase13",sbase13,F); call from_param("sbase14",sbase14,F); call from_param("sbase15",sbase15,F); 


!          write(0,*)'*****************************************************'
!          write(0,*)'eps1    eps2    eps3    eps4    eps5    eps6  '
!          write(0,*) eps1,   eps2,   eps3,   eps4,   eps5,   eps6  
!          write(0,*)'lmb1    lmb2    lmb3    lmb4    lmb5    lmb6  '
!          write(0,*) lmb1,   lmb2,   lmb3,   lmb4,   lmb5,   lmb6  
!          write(0,*)'*****************************************************'


    write(0,'(A65)')'========================Summary dip-filter=============================='
    write(0,'(A2,A15,A2,I10,F10.4,F10.4,A2)') '|','Nang, Dang, Oang','|',nang,dang,oang ,'|'
    write(0,'(A65)')'End dip-filter=========================================================='


! IRLS stuff.....quantile...threshold
       call from_param("thres", thres, 1e-10);
       call from_param("quant", quant, 0.5  );

!       memory=0.
!       iter=0.
       call from_param("eps_denom", eps_denom, 25.  );       call from_param("eps_quant", eps_quant, 75.  );
       call from_param("lmb_denom", lmb_denom, 25.  );       call from_param("lmb_quant", lmb_quant, 75.  );
       call from_param("gam_denom", gam_denom, 25.  );       call from_param("gam_quant", gam_quant, 75.  );
       call from_param("lquant"   , lquant   , F    );
       
       
       
!inversion iter       
       inv_niter=0
  end subroutine
!#####################################################  
  end module
