module joint_encode_prc
 use joint_encode_params
 use joint_encode_adjnull
 use joint_encode_add
 use igrad2
 use igrad1
 use laplac2
 use causint_mod
 use leakint
 use chain_mod
 use joint_encode_rows
 !use joint_encode_hlx
 implicit none
        integer, private, save:: stat
 contains 
!#####################################################  
  integer function int_oper(adj, add, modl, data) result(stat)
        logical,intent(in) :: adj, add
        real, dimension(:) :: modl, data
                stat = 1
                call joint_adjnull2         (adj, add,  modl,data)
                call joint_encode_integrate (adj, add            )
                stat = 0
  end function
!#####################################integrate
  subroutine joint_encode_integrate(adj, add )
  logical            :: adj, add  
        if(reg_base==1)then
                if (nsurv > 5)call  int_base(adj,m6,d6);
                if (nsurv > 4)call  int_base(adj,m5,d5);
                if (nsurv > 3)call  int_base(adj,m4,d4);
                if (nsurv > 2)call  int_base(adj,m3,d3);
                if (nsurv > 1)call  int_base(adj,m2,d2);
                if (nsurv > 0)call  int_base(adj,m1,d1);
        elseif(reg_base==2)then
                if (nsurv > 5)call lint_base(adj,m6,d6);
                if (nsurv > 4)call lint_base(adj,m5,d5);
                if (nsurv > 3)call lint_base(adj,m4,d4);
                if (nsurv > 2)call lint_base(adj,m3,d3);
                if (nsurv > 1)call lint_base(adj,m2,d2);
                if (nsurv > 0)call lint_base(adj,m1,d1);
        endif
  end subroutine
!#####################################causal integration
  subroutine int_base(adj, modl, data)
        logical                :: adj
        real, dimension(vgrid%ax%n,vgrid%ay%n,vgrid%az%n) :: modl
        real, dimension(vgrid%ax%n,vgrid%ay%n,vgrid%az%n) :: data
        do iz_modl= 1,vgrid%az%n;stat=causint_lop(adj,T,modl(:,1,iz_modl),data(:,1,iz_modl)); enddo
    return
  end subroutine
!#####################################leaky integration
  subroutine lint_base(adj, modl, data)
        logical                :: adj
        real, dimension(vgrid%ax%n,vgrid%ay%n,vgrid%az%n) :: modl
        real, dimension(vgrid%ax%n,vgrid%ay%n,vgrid%az%n) :: data
        call leakint_init (rho)
        do iz_modl= 1,vgrid%az%n; stat=leakint_lop(adj,T,modl(:,1,iz_modl),data(:,1,iz_modl)); enddo
    return
  end subroutine
!##################################### smooth
  integer function int_temp_oper(adj, add, modl, data) result(stat)
        logical,intent(in) :: adj, add
        real, dimension(:) :: modl, data
        stat = 1
        call joint_adjnull2        (adj, add,  modl,data)
        call joint_encode_int_temp (adj                 )
        stat = 0 
  end function
!####################################temporal smooth 
  subroutine joint_encode_int_temp(adj)
        logical            :: adj
        integer            :: i
        real               :: tt(nmod)
        real,allocatable   :: mm(:,:), dd(:,:) 
        real               :: r1,r2,r3,r4,r5,r6 !leaking rates

		allocate(mm(nmod,nsurv),dd(nmod,nsurv))
                if(nsurv>14)mm(:,15)=m15; if(nsurv>13)mm(:,14)=m14; if(nsurv>12)mm(:,13)=m13; if(nsurv>11)mm(:,12)=m12; if(nsurv>10)mm(:,11)=m11 
                if(nsurv>9 )mm(:,10)=m10; if(nsurv>8 )mm(:,9 )=m9 ; if(nsurv>7 )mm(:,8 )=m8 ; if(nsurv>6 )mm(:,7 )=m7 ; if(nsurv>5 )mm(:,6 )=m6 
                if(nsurv>4 )mm(:,5 )=m5 ; if(nsurv>3 )mm(:,4 )=m4 ; if(nsurv>2 )mm(:,3 )=m3 ; if(nsurv>1 )mm(:,2 )=m2 ; if(nsurv>0 )mm(:,1 )=m1 
!
                if(nsurv>14)dd(:,15)=d15; if(nsurv>13)dd(:,14)=d14; if(nsurv>12)dd(:,13)=d13; if(nsurv>11)dd(:,12)=d12; if(nsurv>10)dd(:,11)=d11
                if(nsurv> 9)dd(:,10)=d10; if(nsurv> 8)dd(:, 9)= d9; if(nsurv> 7)dd(:, 8)= d8; if(nsurv> 6)dd(:, 7)= d7; if(nsurv> 5)dd(:, 6)=d6
                if(nsurv> 4)dd(:, 5)= d5; if(nsurv> 3)dd(:, 4)= d4; if(nsurv> 2)dd(:, 3)= d3; if(nsurv> 1)dd(:, 2)= d2; if(nsurv> 0)dd(:, 1)=d1
                
        if(reg_temp==1)then
                tt = 0.
                if (adj) then
                        do i =nsurv-1,1,-1
                                mm(:,i    ) = mm(:,i    )+ dd(:,i    )+dd(:,i+1)
                        end do
                                mm(:,nsurv) = mm(:,nsurv)+ dd(:,nsurv)
                else
                        do i =2,nsurv
                                dd(:,i) = dd(:,i)+ mm(:,i)+mm(:,i-1)
                        end do
                                dd(:,1) = dd(:,1)+ mm(:,1)
                end if
        elseif(reg_temp==2)then
                tt = 0.
                if ( adj) then
                        do i =nsurv,1,-1
                                        tt= rho_t*tt + dd(:,i)
                                mm(:,i)   = mm(:,i)  + tt
                        end do
                else
                        do i= 1, nsurv  
                                        tt= rho_t*tt + mm(:,i)
                                dd(:,i)   = dd(:,i)  + tt
                        end do
                end if
        elseif(reg_temp==3)then
                !call seperr("Temp-smooth (temp>3): Not working yet....")
!                write(0,*)'b4',sum(mm(:,1)),sum(mm(:,2)),sum(dd(:,1)),sum(dd(:,2)),rho_t
                if (adj) then
                        if (nsurv > 1)then; mm(:,1)=mm(:,1)+(+rho_t*dd(:,2)+dd(:,1)); mm(:,2)=mm(:,2)+(dd(:,2)+rho_t*dd(:,1)) ; endif
                else    
                        if (nsurv > 1)then; dd(:,1)=dd(:,1)+(+rho_t*mm(:,2)+mm(:,1)); dd(:,2)=dd(:,2)+(mm(:,2)+rho_t*mm(:,1)) ; endif
                end if
!               write(0,*)'af',sum(mm(:,1)),sum(mm(:,2)),sum(dd(:,1)),sum(dd(:,2)),rho_t
        elseif(reg_temp==4)then
                if (adj) then
                        if (nsurv > 2)then; m1=m1+(rho_t*d2+d1)/(rho_t+1); m2=m2+(rho_t*d3+d2)/(rho_t+1); m3=m3+d3; 
                    elseif (nsurv > 1)then; m1=m1+(rho_t*d2+d1)/(rho_t+1); m2=m2+(rho_t*d1+d2)/(rho_t+1); 
                     endif
                else    
                        if (nsurv > 2)then; d1=d1+m1                     ; d2=d2+(rho_t*m1+m2)/(rho_t+1); d3=d3+(m3+rho_t*m2)/(rho_t+1); 
                    elseif (nsurv > 1)then; d1=d1+(rho_t*m2+m1)/(rho_t+1); d2=d2+(rho_t*m1+m2)/(rho_t+1);
                     endif
                end if
        elseif(reg_temp>4)then
                !call seperr("Temp-smooth (temp>3): Working yet....")
                if (adj) then
                        if (nsurv > 2)then; m1=m1+(+(rho_t**2)*d3+rho_t*d2+d1); m2=m2+(+rho_t*d3+d2+rho_t*d1) ; m3=m3+(d3+rho_t*d2+(rho_t**2)*d1) ; 
                    elseif (nsurv > 1)then; m1=m1+(              +rho_t*d2+d1); m2=m2+(          d2+rho_t*d1) ; 
                     endif
                else    
                        if (nsurv > 2)then; d1=d1+(+(rho_t**2)*m3+rho_t*m2+m1); d2=d2+(+rho_t*m3+m2+rho_t*m1) ; d3=d3+(m3+rho_t*m2+(rho_t**2)*m1) ; 
                    elseif (nsurv > 1)then; d1=d1+(              +rho_t*m2+m1); d2=d2+(          m2+rho_t*m1) ; 
                     endif
                end if 
        end if
                if(nsurv>14)m15=mm(:,15); if(nsurv>13)m14=mm(:,14); if(nsurv>12)m13=mm(:,13); if(nsurv>11)m12=mm(:,12); if(nsurv>10)m11=mm(:,11); 
                if(nsurv> 9)m10=mm(:,10); if(nsurv>8 )m9 =mm(:,9 ); if(nsurv>7 )m8 =mm(:,8 ); if(nsurv>6 )m7 =mm(:,7 ); if(nsurv>5 )m6 =mm(:,6 ); 
                if(nsurv> 4)m5 =mm(:, 5); if(nsurv>3 )m4 =mm(:,4 ); if(nsurv>2 )m3 =mm(:,3 ); if(nsurv>1 )m2 =mm(:,2 ); if(nsurv>0 )m1 =mm(:,1 ); 
!
                if(nsurv>14)d15=dd(:,15); if(nsurv>13)d14=dd(:,14); if(nsurv>12)d13=dd(:,13); if(nsurv>11)d12=dd(:,12); if(nsurv>10)d11=dd(:,11); 
                if(nsurv>9 )d10=dd(:,10); if(nsurv>8 )d9 =dd(:,9 ); if(nsurv>7 )d8 =dd(:,8 ); if(nsurv>6 )d7 =dd(:,7 ); if(nsurv>5 )d6 =dd(:,6 ); 
                if(nsurv>4 )d5 =dd(:,5 ); if(nsurv>3 )d4 =dd(:,4 ); if(nsurv>2 )d3 =dd(:,3 ); if(nsurv>1 )d2 =dd(:,2 ); if(nsurv>0 )d1 =dd(:,1 ); 

        deallocate(mm,dd)
  end subroutine
!######################################spatial (forward * back)  row ====>>>d = (eA'A)m and m = (eA'A)d -space
  integer function int_fb( adj, add, mod, dat) result(stat) 
	integer                   :: stat1,stat2 
	logical,intent(in)        :: adj,add 
	real,dimension(:)         :: mod,dat 
                stat= row_fb (int_oper, adj, add, mod, dat) 
  end function
!######################################temporal (forward * back) row ====>>>d = (eA'A)m and m = (eA'A)d -time
  integer function int_temp_fb( adj, add, mod, dat) result(stat) 
	integer                   :: stat1,stat2 
	logical,intent(in)        :: adj,add 
	real,dimension(:)         :: mod,dat 
                stat= row_fb (int_temp_oper, adj, add, mod, dat) 
  end function
!#####################################spatial int * temp-smooth row ====>>>d = (eA+lB)m and m = (eA+lB)d 
  integer function row_int(adj, add, mod, dat) result(stat)
        logical, intent (in)     :: adj, add
        real, dimension (: )     :: mod, dat
                stat=row_1(int_oper, int_temp_oper, adj,add,mod,dat) 
  end function
!#####################################spatial int + temp-smooth (forward + back) row ====>>>d = (eA'A+lB'B)m and m = (eA'A+lB'B)d 
  integer function row_int_fb(adj, add, mod, dat) result(stat)
        logical, intent (in)     :: adj, add
        real, dimension (: )     :: mod, dat
                stat=row_fb(row_int, adj,add,mod,dat) 
  end function
!#####################################spatial int * temp-smooth  chain ====>>>d = (AB)m and m = (AB)d 
  integer function chain_int_temp(adj, add, mod, dat) result(stat) 
        logical, intent (in)     :: adj, add
        real, dimension (: )     :: mod, dat
                stat=chain_2(int_oper, int_temp_oper, adj,add,mod,dat) 
  end function
!#####################################temp-smooth * spatial int chain ====>>>d = (AB)m and m = (AB)d 
  integer function chain_temp_int(adj, add, mod, dat) result(stat) 
        logical, intent (in)     :: adj, add
        real, dimension (: )     :: mod, dat
                stat=chain_2(int_temp_oper, int_oper, adj,add,mod,dat) 
  end function
!#####################################spatial int * temp-smooth (forward + back) chain ====>>>d = (A'A.B'B)m and m = (A'A.B'B)d
  integer function chain_int_temp_fb(adj, add, mod, dat) result(stat)
        logical, intent (in)     :: adj, add
        real, dimension (: )     :: mod, dat
                stat=chain_2(int_fb, int_temp_fb, adj,add,mod,dat) 
  end function
!#####################################temp-smooth * spatial int (forward + back) chain ====>>>d = (A'A.B'B)m and m = (A'A.B'B)d
  integer function chain_temp_int_fb(adj, add, mod, dat) result(stat)
        logical, intent (in)     :: adj, add
        real, dimension (: )     :: mod, dat
                if(verb>4) write(0,*)'rho|rho_t', rho, rho_t
                stat=chain_2(int_temp_fb, int_fb, adj,add,mod,dat) 
  end function
!#####################################temp-smooth + spatial int (forward + back) chain ====>>>d = (A'A+B'B)m and m = (A'A+B'B)d
  integer function rows_sum_temp_fb(adj, add, mod, dat) result(stat)
        logical, intent (in)     :: adj, add
        real, dimension (: )     :: mod, dat
                stat=row_sum_fb(int_temp_oper,adj,mod,dat) 
  end function
!#####################################Scaling functions for preconditioner
  integer function int_scale(iter,niter,adj) result(stat)
        integer, intent (in)     :: iter, niter
        logical, intent (in)     :: adj
        stat=1
                riter=iter
                if(lsscale)then; rho  =sscale(iter); else; rho  =rho  ; endif
                if(ltscale)then; rho_t=tscale(iter); else; rho_t=rho_t; endif
        stat=0
  end function
!#####################################diag
  integer function diag_int(adj, add, mod, dat) result(stat) 
        logical, intent (in)     :: adj, add
        real, dimension (: )     :: mod, dat
                if (adj)then
                        mod=mod+dat
                else
                        dat=dat+mod
                endif
                stat=0.
  end function
  end module
