module joint_encode_rcode_init
  use joint_hessian_params

  implicit none
  contains
!===========================================================================================================================================================================
!#######initialize receiver wave-fields 
 subroutine joint_rcode_init(iseed,maps,scd0)  
        integer                  ::   jzd,   jxd,  jyd
        integer                  ::    iw,    n , isrv
        integer                  ::   isx, isy
        integer                  ::   igx, igy 
        integer                  ::   iseed, jseed(1), ir
        real                     :: sxw , syw, gxw, gyw 
        real                     :: sxd , syd, gxd, gyd 
        real                     :: zd, xd, yd   
        real                     :: ran
        real                     :: maps(dgrid%agx%n, dgrid%agy%n)
        real                     :: rand(dgrid%agx%n, dgrid%agy%n, dgrid%aw%n)
        complex                  :: scd0(dgrid%aw%n,nreal_hess)
        integer                  :: icount

        icount=0
        if(allocated(grcd0))deallocate(grcd0); allocate(grcd0(dgrid%agx%n, dgrid%agy%n, dgrid%aw%n, nreal_hess, 1, 1, 1 ))
        write(0,*)'Initializing the encoded receiver waveform...';
        grcd0=1. !init full receiver waveform
        do ir=1,nreal_hess
            icount=icount+1
            jseed=iseed*icount;
            call random_seed(put=jseed); call random_number(rand);
            rand=rand/maxval(rand)*2*PI
            do iw=1,dgrid%aw%n
                    grcd0(:, :, iw, ir, 1, 1, 1 )=(maps*grcd0(:, :, iw, ir, 1, 1, 1 ))*exp(cmplx(0,rand(:,:,iw)));
            enddo        
        enddo
 end subroutine

!#######initialize source and receiver wave-fields 
 subroutine joint_scode_init2(iseed,scd0)  
        integer                  ::   jzd,   jxd,  jyd
        integer                  ::    iw,    n , isrv
        integer                  ::   isx, isy
        integer                  ::   igx, igy 
        integer                  ::   iseed, jseed, ir, nreal
        real                     :: sxw , syw, gxw, gyw 
        real                     :: sxd , syd, gxd, gyd 
        real                     :: zd, xd, yd   
        real                     :: ran
        complex                  :: scd0(:,:,:,:)
        real                     :: rand(size(scd0,1), size(scd0,2), size(scd0,3))

        if(size(scd0,3)/=dgrid%aw%n)then
                write(0,*)"Dim 3 of scd0/=dgrid%aw%n | nscd0:",size(scd0,3),"dgrid%aw%n:",dgrid%aw%n
                call seperr ("Error: =====> joint_rcode_init2")
        endif        
        if(size(scd0,4)/=nreal_hess)then
                write(0,*)"Dim 4 of scd0/=nreal_hess | nscd0:",size(scd0,4),"nreal_hess:",nreal_hess
                call seperr ("Error: =====> joint_rcode_init2")
        endif
        write(0,*)'Initializing the encoded source waveform...';
        grcd0=1. !init full receiver waveform
        do ir=1,nreal_hess
           do iw=1, dgrid%aw%n
              w=dgrid%aw%o+(iw-1)*dgrid%aw%d
              do isy=1, size(scd0,2)
                 do isx=1, size(scd0,1)
                     jseed=iseed*(isx**5)*isy*ir*iw;
                     call random_seed(jseed); call random_number(ran); rand(isx, isy, iw)=ran
                 enddo
              enddo
           enddo
            rand=rand/maxval(rand)*2*PI
            scd0(:,:,:,ir)=scd0(:,:,:,ir)*exp(cmplx(0,rand))
        enddo
 end subroutine


end module