module joint_encode_scode_init
  use joint_encode_params

  implicit none
  contains
!===========================================================================================================================================================================

!#######initialize source wavefields 
 subroutine joint_scode_init()  
        integer                  ::   jzd,   jxd,  jyd
        integer                  ::    iw,  n , isrv
        integer                  ::   isxw, isyw
        integer                  ::   igxw, igyw
        integer                  ::   isxd, isyd
        integer                  ::   igxd, igyd
        real                     :: sxw , syw, gxw, gyw 
        real                     :: sxd , syd, gxd, gyd 
        real                     :: zd, xd, yd   
        write(0,*)'Initializing the encoded source waveform...';
        gscd0=0. !init full source waveform
        if(encode)then
                write(0,'(A65)')'========================= Shot Encoding summary ========================'
                write(0,*)'Original shot x-axis', wgrid%asx
                write(0,*)'Encoded  shot x-axis', dgrid%asx
                write(0,*)'Original shot y-axis', wgrid%asy
                write(0,*)'Encoded  shot y-axis', dgrid%asy
                write(0,'(A65)')'End wavelet============================================================='
        else
                write(0,'(A65)')'========================= Shot Encoding summary ========================'
                write(0,*)'No encoding'
                write(0,'(A65)')'End wavelet============================================================='
        endif
        
        write(0,*)'Start initializing the encoded source waveform...';
        do isrv=1,nsurv
                write(0,*)'Survey', isrv, ' ...'
            do isyw=1, wgrid%asy%n,1; syw = wgrid%asy%o + (isyw-1)*wgrid%asy%d;  isyd = max(1,int(1.5+(syw-dgrid%asy%o)/dgrid%asy%d));
            do isxw=1, wgrid%asx%n,1; sxw = wgrid%asx%o + (isxw-1)*wgrid%asx%d;  isxd = max(1,int(1.5+(sxw-dgrid%asx%o)/dgrid%asx%d));
                jxd=max(1.,1.5+(sxw-vgrid%ax%o)/vgrid%ax%d+ real(sshft0(isxw,isyw,isrv)))
                jyd=max(1.,1.5+(syw-vgrid%ay%o)/vgrid%ay%d+aimag(sshft0(isxw,isyw,isrv)))
                jxd=min(jxd,vgrid%ax%n)
                jyd=min(jyd,vgrid%ax%n)
                jzd=1.
                do iw=1,dgrid%aw%n; 
                    if(cabs(csou_full(isxw,isyw,iw))<=0.) cycle
                     gscd0(jxd,jyd,jzd,iw,isxd,isyd,isrv)=gscd0(jxd,jyd,jzd,iw,isxd,isyd,isrv)+(csou0(isxw,isyw,iw,isrv))
                end do;    
            if(verb>14)then;      write(0,'(A10,I5,A20,6I10,6F10.3)')'Survey ',isrv,' >> isxw|jxd:', isxw,jxd,isyw,jyd,isyd,isrv,sxw,syw,sum(cabs(gscd0(:,:,:,:,isxd,isyd,isrv))),sum(cabs(csou0(isxw,isyw,:,isrv)));
            elseif(verb>13)then;  write(0,'(A10,I5,A20,6I10,4F10.3)')'Survey ',isrv,' >> isxw|jyd:', isxw,jxd,isyw,jyd,isyd,isrv,sxw,syw;endif
            end do;
            end do;
        enddo;
        write(0,*)'Done  initializing the encoded source waveform...';
  end subroutine
end module