module joint_encode_utils
 use joint_encode_fft
 use joint_encode_data_io

  implicit none

contains
!!=======================================================================================
  integer function clean_pointers() result(stat)! 
        stat=1
        nullify( m1, m2, m3, m4, m5, m6, m7, m8, m9, m10, m11, m12, m13, m14, m15, & 
                fd1,fd2,fd3,fd4,fd5,fd6,fd7,fd8,fd9,fd10,fd11,fd12,fd13,fd14,fd15, & 
                 d1, d2, d3, d4, d5, d6, d7, d8, d9, d10, d11, d12, d13, d14, d15)    !clean up pointers
        stat=0
   end function
!!=======================================================================================
  integer function encode_beg() result(stat)! initialize data to real for inversion 
        stat=1
	stat=data_convert(-1)
   end function
!!=======================================================================================
   integer function data_convert(dir) result(stat)
	integer,intent(in) :: dir
	stat=1
        if(use_greens)then
                if(nsurv>0 ) stat=encode_fft_green_fftw(dir,fd1 );if(nsurv>1 ) stat=encode_fft_green_fftw(dir,fd2 ); if(nsurv>2 ) stat=encode_fft_green_fftw(dir,fd3 );
                if(nsurv>3 ) stat=encode_fft_green_fftw(dir,fd4 );if(nsurv>4 ) stat=encode_fft_green_fftw(dir,fd5 ); if(nsurv>5 ) stat=encode_fft_green_fftw(dir,fd6 );
                if(nsurv>6 ) stat=encode_fft_green_fftw(dir,fd7 );if(nsurv>7 ) stat=encode_fft_green_fftw(dir,fd8 ); if(nsurv>8 ) stat=encode_fft_green_fftw(dir,fd9 );
                if(nsurv>9 ) stat=encode_fft_green_fftw(dir,fd10);if(nsurv>10) stat=encode_fft_green_fftw(dir,fd11); if(nsurv>11) stat=encode_fft_green_fftw(dir,fd12);
                if(nsurv>12) stat=encode_fft_green_fftw(dir,fd13);if(nsurv>13) stat=encode_fft_green_fftw(dir,fd14); if(nsurv>14) stat=encode_fft_green_fftw(dir,fd15);
        else
                if(nsurv>0 ) stat=encode_fft_fftw(dir,fd1 );if(nsurv>1 ) stat=encode_fft_fftw(dir,fd2 ); if(nsurv>2 ) stat=encode_fft_fftw(dir,fd3 );
                if(nsurv>3 ) stat=encode_fft_fftw(dir,fd4 );if(nsurv>4 ) stat=encode_fft_fftw(dir,fd5 ); if(nsurv>5 ) stat=encode_fft_fftw(dir,fd6 );
                if(nsurv>6 ) stat=encode_fft_fftw(dir,fd7 );if(nsurv>7 ) stat=encode_fft_fftw(dir,fd8 ); if(nsurv>8 ) stat=encode_fft_fftw(dir,fd9 );
                if(nsurv>9 ) stat=encode_fft_fftw(dir,fd10);if(nsurv>10) stat=encode_fft_fftw(dir,fd11); if(nsurv>11) stat=encode_fft_fftw(dir,fd12);
                if(nsurv>12) stat=encode_fft_fftw(dir,fd13);if(nsurv>13) stat=encode_fft_fftw(dir,fd14); if(nsurv>14) stat=encode_fft_fftw(dir,fd15);
        endif
        stat=0
  end function
!!=======================================================================================
  integer function  encode_end(adj,data,modl) result(stat)
    logical,intent(in) :: adj
    real, dimension(:,:,:,:,:):: data
    real, dimension(:,:,:    ):: modl
        stat=1
        if(adj .and. .not. inv)then
!            call data_io_img(modl)
        elseif (.not. (adj .or. inv))then
!            call data_io_a('rite', fdata);
!            stat=encode_transf(-1,fdata)
!            data=fdata
        elseif(inv)then
!            stat=encode_transf(-1,fdata)
!            data=fdata
        endif 
        stat=0
    end function
!!=======================================================================================
  integer function  encode_init_data(data) result(stat)
    real, dimension(dgrid%agx%n, dgrid%agy%n,dgrid%asx%n,dgrid%asy%n,dgrid%aw%n):: data
        stat=1
        !stat=encode_transf(-1,fdata); data=fdata
        stat=0
  end function
!!=======================================================================================!!=======================================================================================
  integer function  encode_report(adj,modl,data,index_aw,w,inode,isurv) result(stat)
    real, dimension(:,:,:),pointer:: modl
    complex, dimension(:,:,:,:),pointer:: data
    integer                 :: index_aw, inode, isurv
    real                    ::  w
    logical,intent(in)      :: adj

    stat=1
    if(verb>2)then
        if(inv)then
            if(verb>3)then
                if(adj)then
                    write(0,'(A10,I5,A3,F7.3,A5,2F10.4, A6,I5, A15, E20.5, A7, I3)')'done iw: ', index_aw, '|', w,'=> (',sum(csou0(:,:,index_aw,isurv))/size(csou0(:,:,index_aw,isurv)),') of ',ggrid%aw%n, ' |  sum mig:', sum(modl), ' @ node', inode; 
                else
                    write(0,'(A10,I5,A3,F7.3,A5,2F10.4, A6,I5, A15, E20.5, A7, I3)')'done iw: ', index_aw, '|', w,'=> (',sum(csou0(:,:,index_aw,isurv))/size(csou0(:,:,index_aw,isurv)),') of ',ggrid%aw%n, ' |  sum dat:', sum(cabs(data)), ' @ node', inode; 
                endif
            endif
        else
            if(adj)then
                write(0,'(A10,I5,A3,F7.3,A5,2F10.4, A6,I5, A15, E20.5, A7, I3)')'done iw: ', index_aw, '|', w,'=> (',sum(csou0(:,:,index_aw,isurv))/size(csou0(:,:,index_aw,isurv)),') of ',ggrid%aw%n, ' |  sum mig:', sum(modl), ' @ node', inode; 
            else
                write(0,'(A10,I5,A3,F7.3,A5,2F10.4, A6,I5, A15, E20.5, A7, I3)')'done iw: ', index_aw, '|', w,'=> (',sum(csou0(:,:,index_aw,isurv))/size(csou0(:,:,index_aw,isurv)),') of ',ggrid%aw%n, ' |  sum dat:', sum(cabs(data)), ' @ node', inode; 
            endif  												     	
        endif
    endif
    stat=0
  end function
!!=======================================================================================
  integer function encode_io(modl, data) result(stat)
    real, dimension(dgrid%agx%n, dgrid%agy%n,dgrid%asx%n,dgrid%asy%n,dgrid%aw%n):: data
    real, dimension(vgrid%ax%n, vgrid%ay%n, vgrid%az%n):: modl
        stat = 1
        if (adj.or.inv)then
            call data_io_img(modl)  
        else
            call data_io_a('rite', fdata);
        endif
        stat = 0
  end function
!===========================================================================================================================================================================
end module
