!Gboyega 04/1/09
! Variable non-stationary helix filters
module joint_encode_vnhlx
 use joint_encode_params
 use joint_encode_nhlx
 use joint_encode_data_io

 implicit none
        integer,         private                                ,save   :: stat        
        type( filter),   private                                ,save   :: aa
        type( filter),   private                                ,save   :: bb
        real,            private,  dimension (:), allocatable   ,save   :: tt 
        integer,         private                                ,save   :: nd 
        logical,         private                                ,save   :: lscale
        integer,         private                                ,save   :: n1 
        real,            private,                 allocatable   ,save   :: tdip(:)
        real,            private,                 allocatable   ,save   :: tvar(:)
        real   ,         private                                        :: eps_nhlx
        integer,         private                                ,save   :: ncycle
        
 contains 
!######################################
        subroutine  vns_init(var,dips,eps_in)
                integer                 ::i,ivar,n1_in
                real, dimension(2)      ::u,v
                real                    ::eps_in, eps_nhlx
                real                    :: dips(:)
                real                    :: var(:)
                real                    :: vrn
                integer                 :: lap(nang)
                integer                 :: vv(nvar)
                eps_dip=eps_in; n1=vgrid%az%n; 
                if(allocated(ptch)) deallocate(ptch); if(allocated(varn)) deallocate(varn);  if(allocated(n_nfilt)) deallocate(n_nfilt); if(allocated(tdip)) deallocate(tdip);if(allocated(tvar)) deallocate(tvar);
                allocate (ptch(nmod),varn(nmod),n_nfilt(nang),tdip(nmod),tvar(nmod)); 
                         ptch=0.; varn=0.; n_nfilt=0.; tdip=0.;tvar=0.
                tdip=dips ; 
                tvar=var;

                where(tdip> 1.570)tdip= 1.5708    ! minvalmin-angle :-90/90
                where(tdip<-1.570)tdip=-1.5708

                call nhlx_transp(1,tdip) !rearrange angles to z-1 x-2
                call nhlx_transp(1,tvar) !rearrange angles to z-1 x-2

                if(verb>5)write(0,*)'dipinfo:beg',nang,dang,oang
                if(maxval(tdip)==minval(tdip))then;
                        nang=1; dang=1; oang=minval(tdip)
                elseif(minval(tdip)>oang.and.maxval(tdip)<oang+(nang-1)*dang)then
                        oang=minval(tdip)
                        dang=(maxval(tdip)-oang)/(nang-1)
                elseif(minval(tdip)>oang)then
                        oang=minval(tdip)
                        if(maxval(tdip)<oang+(nang-1)*dang)then
                                dang=(maxval(tdip)-oang)/(nang-1)
                        endif
                endif
                if(verb>5)write(0,*)'dipinfo:end',nang,dang,oang
                if(verb>5)write(0,*)'varinfo:beg',nvar,dvar,ovar 
                
                tdip=atan(tdip)
                if(maxval(tvar)==minval(tvar))then;
                        nvar=1; dvar=1.; ovar=minval(tvar)
                elseif(minval(tvar)>ovar.and.maxval(tvar)<ovar+(nvar-1)*dvar)then
                        ovar=minval(tvar); dvar=(maxval(tvar)-ovar)/(nvar-1)
                elseif(minval(tvar)>ovar)then
                        ovar=minval(tvar)
                        if(maxval(tdip)<ovar+(nvar-1)*dvar)then
                                dvar=(maxval(tvar)-ovar)/max(1,nvar-1)
                        endif
                else
                        ovar=minval(tvar)
                        dvar=(maxval(tvar)-ovar)/max(1,nvar-1)
                endif

                do i=1,nmod;
                        dip=tdip(i); idip = 1.5+(dip-oang)/dang; ptch(i)=idip; if((ptch(i)>nang.or.ptch(i)<0.).and.verb>6)write(0,*)'dip',dip,idip,ptch(i)
                        vrn=tvar(i); ivar = 1.5+(vrn-ovar)/dvar; varn(i)=ivar; if((varn(i)>nvar.or.varn(i)<0.).and.verb>6)write(0,*)'var',vrn,ivar,varn(i)
                end do
                

                where (ptch>float(nang))ptch=nang; where (ptch<1. )ptch=1
                where (varn>float(nvar))varn=nvar; where (varn<1. )varn=1
                n_nfilt=nfilt*3
                call vnallocate(vn_filt,n_nfilt,ptch,varn,nvar)
                lap=4
                call nallocate(lapfilt,lap, ptch)      ! alloc. filter
                do iv=1,nvar
                        vrn=1+(ovar+(iv-1)*dvar)
7                        if(verb>4)write(0,'(A25,I4,F5.2,A4,I4)',advance='no')'working on variance',iv,vrn,'of',nvar 
                        do iang=1,nang
                                do ifilt=1,nfilt
                                        vn_filt%nhlx(iv)%hlx(iang)%lag(         ifilt) = ifilt                      ! early lags (first row)
                                        vn_filt%nhlx(iv)%hlx(iang)%lag( nfilt  +ifilt) = n1 + ifilt - nfilt         ! late lags  (second row)
                                        vn_filt%nhlx(iv)%hlx(iang)%lag( nfilt*2+ifilt) = n1 + ifilt                 ! late late lags (second row)
                                end do
                        end do
                        lapfilt0 = 1. + max(1.,vrn)*eps_dip        ! zero lag coeff. multiply by variance
                        call wilson_init( 10 * n1 )
                        do iang=1,nang
                                lapfilt%hlx(iang)%lag = (/ 1, n1-1, n1, n1+1/)    ! lag(1)= 1; lag(2)=n1  # one side only
                                dip=oang+(iang-1)*dang
                                if(verb>5)write(0,*)'working on angle',iang,dip,degrad(1,dip),'of', nang
                                u(1)= cos(dip); u(2)=-sin(dip); 
                                m=(u(1)-u(2))/2.; 
                                p=(u(1)+u(2))/2.;
                                lapfilt%hlx(iang)%flt = 0.;
                                lapfilt%hlx(iang)%flt = (/2*m*p,-p*p,-2*m*p,-m*m/)
                                call wilson_factor( 100, lapfilt0, lapfilt%hlx(iang), n_filt0, vn_filt%nhlx(iv)%hlx(iang))
                                if(verb>5)write(0,'(50F10.6)')vn_filt%nhlx(iv)%hlx(iang)%flt
                        end do
                        call wilson_close()
                        if(verb>4)write(0,*)'finished variance'
                enddo
                if(destroy)then
                        call vnhelicon_init(     vn_filt)
                else
                        call vnpolydiv_init(nmod,vn_filt)
                endif        
        end subroutine
!#####################################################  conv or deconv
        integer function vnhlx_it(adj, add, xx, yy) result(stat)
                logical,intent(in)         :: adj,add 
                real, dimension (:)          :: xx, yy
                integer                        :: isurv
                call joint_adjnull2 (adj,add, xx,yy)
                do isurv=1,nsurv; call nhlx_transp( 1,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));enddo
                if (destroy)then
                        do isurv=1,nsurv; call filt_vnhelicon(adj,add,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));enddo
                else
                        do isurv=1,nsurv; call filt_vnpolydiv(adj,add,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));enddo
                endif
                do isurv=1,nsurv; call nhlx_transp(-1,xx((isurv-1)*nmod+1:isurv*nmod),yy((isurv-1)*nmod+1:isurv*nmod));enddo
                stat=0
        end function
!############################################################################################################# joint preconditioners
!#####################################spatial int + temp-smooth ...note:int_temp_oper in prc
        integer function vnhlx_row1(adj, add, mod, dat) result(stat)
                logical, intent (in)     :: adj, add
                real, dimension (: )     :: mod, dat
                if(destroy)then        
                        stat=1; stat=row_1(vnhlx_it, grad_temp_oper, adj,add,mod,dat); stat=0 
                else
                        stat=1; stat=row_1(vnhlx_it,  int_temp_oper, adj,add,mod,dat); stat=0 
                endif
        end function
!######################################
        integer function vnhlx_row2(adj, add, mod, dat) result(stat)
                logical, intent (in)     :: adj, add
                real, dimension (: )     :: mod, dat
                if(destroy)then        
                        stat=1; stat=row_2(vnhlx_it,grad_temp_oper, adj,add,mod,dat); stat=0 
                else
                        stat=1; stat=row_2(vnhlx_it, int_temp_oper, adj,add,mod,dat); stat=0 
                endif
        end function
!######################################
        integer function vnhlx_row3(adj, add, mod, dat) result(stat)
                logical, intent (in)     :: adj, add
                real, dimension (: )     :: mod, dat
                if(destroy)then        
                        stat=1; stat=row_2(vnhlx_it,grad_temp_oper, adj,add,mod,dat) ; stat=0
                else
                        stat=1; stat=row_2(vnhlx_it, int_temp_oper, adj,add,mod,dat); stat=0 
                endif
        end function
!######################################
        integer function vnhlx_chain1(adj, add, mod, dat) result(stat)
                logical, intent (in)            :: adj, add
                real, dimension (: )            :: mod, dat
                real, dimension (size(dat))     :: tmp
                if(destroy)then        
                        stat=1; call chain0(vnhlx_it,grad_temp_oper,adj,add,mod,dat,tmp); stat=0
                else
                        stat=1; call chain0(vnhlx_it, int_temp_oper,adj,add,mod,dat,tmp); stat=0
                endif
        end function
!######################################
        integer function vnhlx_chain2(adj, add, mod, dat) result(stat)
                logical, intent (in)            :: adj, add
                real, dimension (: )            :: mod, dat
                real, dimension (size(dat))     :: tmp
                if(destroy)then        
                        stat=chain_2(grad_temp_oper, vnhlx_it, adj,add,mod,dat); stat=0
                else
                        stat=chain_2(int_temp_oper , vnhlx_it, adj,add,mod,dat); stat=0
                endif
        end function
!######################################
        integer function vnhlx_chain_2(adj, add, mod, dat) result(stat)
                logical, intent (in)            :: adj, add
                real, dimension (: )            :: mod, dat
                real, dimension (size(dat))     :: tmp
                if(destroy)then        
                        stat=chain_2(vnhlx_it, grad_temp_oper, adj,add,mod,dat); stat=0
                else
                        stat=chain_2(vnhlx_it, int_temp_oper , adj,add,mod,dat); stat=0
                endif
        end function
!######################################
        subroutine filt_vnpolydiv( adj, add, xx, yy) 
                integer                   :: stat,stat1,stat2 
                logical,intent(in)        :: adj,add 
                real,dimension(:)         :: xx,yy 
                real, dimension(size(xx)) :: tmp
                tmp=0.
                if ( adj) then
                        stat= vnpolydiv_lop(.false.,add, yy,tmp)     ! tmp = grad y
                        stat= vnpolydiv_lop(.true. ,add, xx,tmp)     ! x = x + grad' tmp
                else
                        stat= vnpolydiv_lop(.false.,add, xx,tmp)     ! tmp = grad x
                        stat= vnpolydiv_lop(.true. ,add, yy,tmp)     ! y = y + grad' tmp
                endif
                stat=stat*stat2
        end subroutine 
!######################################
        subroutine filt_vnhelicon( adj, add, xx, yy) 
                integer                   :: stat,stat1,stat2 
                logical,intent(in)        :: adj,add 
                real,dimension(:)         :: xx,yy 
                real, dimension(size(xx)) :: tmp
                tmp=0.
                if ( adj) then
                        stat= vnhelicon_lop(.false.,add, yy,tmp)     ! tmp = grad y
                        stat= vnhelicon_lop(.true. ,T  , xx,tmp)     ! x = x + grad' tmp
                else
                        stat= vnhelicon_lop(.false.,add, xx,tmp)     ! tmp = grad x
                        stat= vnhelicon_lop(.true. ,T  , yy,tmp)     ! y = y + grad' tmp
                endif
                stat=stat*stat2
        end subroutine
 ! #####################################Scaling functions for vnhlx
  integer function vnhlx_scale(iter,niter,adj) result(stat)
        integer, intent (in)     :: iter, niter
        logical,intent(in)       :: adj
        stat=1
        if(iter==1.or.(lsscale.and.adj))then; if (modulo(iter,int(dsscale))==1)then; 
            eps_dip=min_eps_dip+(iter-1)*(max_eps_dip-min_eps_dip)/niter; 
            write(0,*)'[Re]Computing spatial-filters with eps_dip:',eps_dip
            call vns_init(f1,dips1,eps_dip); else;            ; endif; 
        endif
        if(iter==1.or.(ltscale.and.adj))then; if (modulo(iter,int(dtscale))==1)then;
            rho_t=max_rho_t-(iter-1)*(max_rho_t-min_rho_t)/niter; 
            write(0,*)'[Re]Computing temporal-filters with rho_t :',rho_t
                                         else; rho_t=rho_t; endif; 
        endif
        stat=0
  end function
  
  
!######################################spatiotemporal
  integer function spatio_lop( adj, add, mod, dat) result(stat) 
        integer                   :: stat1,stat2 
        logical,intent(in)        :: adj,add 
        real,dimension(:)         :: mod,dat
                if(verb>4)write(0,*)'++++++++++++++++++',adj,add
                if(verb>4)write(0,*)sum(mod),sum(dat(1:size(mod))),sum(dat(1+size(mod):)),size(mod),size(dat(1+size(mod):)),'b4'
                        stat=       vnhlx_it(adj, add, mod, dat(1:size(mod) ))
                if(verb>4)write(0,*)sum(mod),sum(dat(1:size(mod))),sum(dat(1+size(mod):)),size(mod),size(dat(1+size(mod):)),'mid'
                        stat= grad_temp_oper(adj, add, mod, dat(1+size(mod):))
                if(verb>4)write(0,*)sum(mod),sum(dat(1:size(mod))),sum(dat(1+size(mod):)),size(mod),size(dat(1+size(mod):)),'af'
                if(verb>4)write(0,*)'++++++++++++++++++',adj,add
  end function
!######################################spatiotemporal+shift
!  integer function spatio_shift_init(ncycle_in) result(stat) 
!        integer         :: ncycle_in
!        stat=1
!                ncycle = ncycle_in        
!        stat=0
!  end function
!######################################
!  integer function spatio_shift_lop( adj, add, mod, dat) result(stat) 
!        integer                         :: stat1,stat2 
!        logical,intent(in)              :: adj,add 
!        real,dimension(:)               :: mod,dat
!        real,dimension(:),allocatable   :: xx
!        integer                         :: ishift,isurv
!        write(0,*)'herere'
!        call adjnull(adj,add,mod,dat)
!                if(verb>1)write(0,*)'++++++++++++++++++++++++++++++++++++++++++++++++++++',adj,add
!                if(verb>1)write(0,'(A10,6(A12,E15.5))')'start-reg:','sum(mod)',sum(mod),'spat(dat)',sum(dat(1:size(mod))),'temp(dat)',sum(dat(1+size(mod):))
!                do isurv=1,nsurv
!                        call ts_io("rite",  ts0(1:nmod,3),   isurv, F); 
!                        call cc_io("rite",  ts0(1:nmod,3),   isurv, F); 
!                enddo
!                ltshift=T;
!                if(verb>1)write(0,'(A10,6(A12,E15.5))')'b4 shifts:','sum(mod)',sum(mod),'spat(dat)',sum(dat(1:size(mod))),'temp(dat)',sum(dat(1+size(mod):))
!                if(ltshift)then;
!                        if(adj)then
!                                allocate(xx(size(dat)));xx=dat
!                                !if(sum(dat(1:size(mod)))/=0.)then
!                                !        do ishift=1,nshift_cycle; stat=shift_init(ishift); stat=shift_it(adj,F,xx(1:size(mod))); enddo
!                                !endif
!                         if(verb>1)write(0,'(A10,6(A12,E15.5))')'af shift2:','sum(mod)',sum(mod),'spat(dat)',sum(xx(1:size(mod))),'temp(dat)',sum(xx(1+size(mod):))
!                                 stat=       vnhlx_it(adj, add, mod, xx(1:size(mod) ))
!                         if(verb>1)write(0,'(A10,6(A12,E15.5))')'af  spat.:','sum(mod)',sum(mod),'spat(dat)',sum(xx(1:size(mod))),'temp(dat)',sum(xx(1+size(mod):))
!                                 stat= grad_temp_oper(adj, add, mod, xx(1+size(mod):))
!                         if(verb>1)write(0,'(A10,6(A12,E15.5))')'end --reg:','sum(mod)',sum(mod),'spat(dat)',sum(xx(1:size(mod))),'temp(dat)',sum(xx(1+size(mod):))
!                                 deallocate(xx)
!                        else
!                                allocate(xx(size(mod)));xx=mod
!                                if(sum(xx)/=0.)then
!                                        do ishift=1,nshift_cycle; stat=shift_init(ishift); stat=shift_oper(adj,F,xx); enddo
!                                endif
!                        if(verb>1)write(0,'(A10,6(A12,E15.5))')'af shifts:','sum(mod)',sum(mod),'sum(xx)',sum(xx),'spat(dat)',sum(dat(1:size(mod))),'temp(dat)',sum(dat(1+size(mod):))
!                                stat=       vnhlx_it(adj, add, xx, dat(1:size(mod) ))
!                        if(verb>1)write(0,'(A10,6(A12,E15.5))')'af  spat.:','sum(mod)',sum(mod),'sum(xx)',sum(xx),'spat(dat)',sum(dat(1:size(mod))),'temp(dat)',sum(dat(1+size(mod):))
!                                stat= grad_temp_oper(adj, add, xx, dat(1+size(mod):))
!                        if(verb>1)write(0,'(A10,6(A12,E15.5))')'end  -reg:','sum(mod)',sum(mod),'sum(xx)',sum(xx),'spat(dat)',sum(dat(1:size(mod))),'temp(dat)',sum(dat(1+size(mod):))
!                                deallocate(xx)
!                        endif
!                else              
!                        if(verb>1)write(0,'(A10,6(A12,E15.5))')'af shifts:','sum(mod)',sum(mod),'spat(dat)',sum(dat(1:size(mod))),'temp(dat)',sum(dat(1+size(mod):))
!                                stat=       vnhlx_it(adj, add, mod, dat(1:size(mod) ))
!                        if(verb>1)write(0,'(A10,6(A12,E15.5))')'af  spat.:','sum(mod)',sum(mod),'spat(dat)',sum(dat(1:size(mod))),'temp(dat)',sum(dat(1+size(mod):))
!                                stat= grad_temp_oper(adj, add, mod, dat(1+size(mod):))
!                        if(verb>1)write(0,'(A10,6(A12,E15.5))')'end  -reg:','sum(mod)',sum(mod),'spat(dat)',sum(dat(1:size(mod))),'temp(dat)',sum(dat(1+size(mod):))
!                        if(verb>1)write(0,*)'++++++++++++++++++++++++++++++++++++++++++++++++end',adj,add
!                endif
!  end function

end module
