module joint_encode_data_wavelet
  use joint_encode_params
  use joint_encode_data_io
  use joint_encode_sx
  use fftw_oneway_mod
  use map_mod
  implicit none 
contains
  !==========================================#
 subroutine data_wavelets()
    integer             :: iw, niw
    real                :: w 
    real                :: max_t
    character(len=1024) :: string
    wavelet_="wavelet"; 
!read the source wavelet from file    
    call auxin(wavelet_) 
        call hinaxis(wavelet_,dgrid%aw,3); 
    allocate(csou(dgrid%aw%n))
    if(exist_file(wavelet_))call sreed(wavelet_, csou, 8*dgrid%aw%n)
!        if (dgrid%aw%n/=ggrid%aw%n) call seperr('Source wavelet must have same num. of freq. as greens.')

!initialize the data time axis.
    max_t=1/dgrid%aw%d
    dgrid%at%n=dgrid%aw%n
    dgrid%at%d=(max_t-dgrid%at%o)/(dgrid%at%n-1)
    call data_radians_calc()
    call gre_radians_calc()

    write(0,'(A65)')'========================Summary wavelet================================='
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','Data  Time  ax','|',dgrid%at, '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','Data  Freq. ax','|',dgrid%aw, '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','Green Freq. ax','|',ggrid%aw, '|'
    write(0,'(A65)')'------------------------------------------------------------------'
    write(*,'(A2,A15,A2,F10.3,A8)')'|','Min. Freq.','|',mcsou,'radians'
    write(*,'(A2,A15,A2,F10.3,A8)')'|','Max. Freq.','|',mcsou+(ggrid%aw%n-1)*ggrid%aw%d,'radians'
    write(0,'(A65)')'End wavelet============================================================='
  end subroutine
!#########################################################################################################
 subroutine data_wavelet_s()
  use init_mod
    integer             :: iw, niw
    real                :: w 
    real                :: max_t
    character(len=1024) :: string
    complex,allocatable :: dcsou(:)

    wavelet_="wavelet"; 
!read the source wavelet from file    
        if(exist_file(wavelet_))then    
                call auxin(wavelet_) 
                call hinaxis(wavelet_,wgrid%asx,1); call hinaxis(wavelet_,wgrid%asy,2); call hinaxis(wavelet_,wgrid%aw ,3); dgrid%aw=wgrid%aw
        
                allocate(csou_full(wgrid%asx%n,wgrid%asy%n,wgrid%aw%n)); csou_full=0.
                
                call data_io_csou(csou_full); mcsou=maxval(abs(csou_full))
            
                allocate(csou(wgrid%aw%n   )); csou(:)=csou_full(1,1,:);
                allocate(dcsou(wgrid%aw%n*2)); dcsou=0.; dcsou(1:wgrid%aw%n)=csou_full(1,1,:);
        
                call fftw_init1d(wgrid%aw%n*2-1);
                call fftw_exec1d(-1,dcsou(:));
                call fftw_exec1d( 1,dcsou(:));
                csou(:)=dcsou(1:wgrid%aw%n);
!initialize the data time axis.
                max_t=1/(dgrid%aw%d*2)
                dgrid%at%n=dgrid%aw%n*2
                dgrid%at%d=(max_t-dgrid%at%o)/(dgrid%at%n-1)
                if (.not. radian) call data_radians_calc()
                if (.not. radian) call gre_radians_calc()
                if (.not. radian) call wav_radians_calc()

                mcsou=0.01*maxval(cabs(csou_full))
        else
                call seperr('Please specify source waveform')
                spike=T
        endif
! apply phase shifts
        call from_param("encode"      , encode       ,   F    )
        call from_param("random_constant", random_constant, T ); if (.not. encode)random_constant=F
        call from_param("random_phase", random_phase ,   F    ); if (.not. encode)random_phase=F
        call from_param("linear_phase", linear_phase ,   F    ); if (.not. encode)linear_phase=F
        call from_param("tmin"        , rand_tmin    , -0.5   )
        call from_param("tmax"        , rand_tmax    ,  0.5   ); rand_tlim=rand_tmax-rand_tmin
        call from_param("code_it"     , code_it      ,   F    )

        !call encode_z1(csou_full)

    ggrid%aw=wgrid%aw
    write(0,'(A65)')'========================Summary wavelet================================='
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','Data  Time  ax','|',dgrid%at, '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','Data  Freq. ax','|',dgrid%aw, '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','Green Freq. ax','|',ggrid%aw, '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','Wave  Freq. ax','|',wgrid%aw, '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','wgrid%asx  ','|',wgrid%asx  , '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','wgrid%asy  ','|',wgrid%asy  , '|'
    write(0,'(A65)')'------------------------------------------------------------------'
    write(*,'(A2,A15,A2,F10.3,A8)')'|','Min. Freq. amp. ','|',mcsou,'radians'
    write(0,'(A65)')'End wavelet============================================================='
  end subroutine
!#########################################################################################################
  subroutine encode_z1(csou_full)
        complex, dimension(:,:,:) :: csou_full
        integer                          :: iw
        real                           :: w, p
    real              :: t(wgrid%asx%n,wgrid%asy%n)                      
        integer                            :: isyy,issy
        integer                            :: isxx,issx
        real                          :: ssx, ssy
    encode_='code'
    allocate(code(wgrid%asx%n, wgrid%asy%n)); memory = memory + 4*size(code);
    if(exist_file(encode_))open (unit=50, file=trim(encode_), status='unknown')

        if(encode)then;
                if (code_it)then
                        if(random_constant)then
                                call random_seed
                                call random_number(t); t=rand_tmin+t*rand_tlim;
                                do iw = 1, wgrid%aw%n
                                        w = wgrid%aw%o + (iw-1)*wgrid%aw%d
                                        csou_full(:,:,iw)=csou_full(:,:,iw)*exp(cmplx(0,-w*t)); 
                                end do
                        endif
                        code=t
                        do isy=1,wgrid%asy%n
                                do isx=1,wgrid%asx%n
                                        write(50,*,err=15)code(isx,isy)
                                enddo
                        enddo
                else
                        if (exist_file(trim(encode_)))then
                                code=-9999
                                do isy=1,wgrid%asy%n
                                        do isx=1,wgrid%asx%n
                                                read(50,*,err=14, end=14)code(isx,isy)
                                        enddo
                                enddo 
14                              if (minval(code)==-9999) call seperr('Number of sources differ from number specified in file')
                                t=code    
                                do iw = 1, wgrid%aw%n
                                        w = wgrid%aw%o + (iw-1)*wgrid%aw%d
!write(0,*)csou_full(:,:,iw),csou_full(:,:,iw)*exp(cmplx(0,-w*t));
                                        csou_full(:,:,iw)=csou_full(:,:,iw)*exp(cmplx(0,-w*t));
                                end do
!stop
                        else
                                call seperr('No encode file found!!! check encode')
                        endif
                endif

        endif
15      close (50)        
  end subroutine

  end module
