module median_mod
  use sep
  use sorting_mod 
  use quantile_mod1
  implicit none
  integer,private :: n1,n2,n3,wind1,wind2,wind3,ierr,panel
  integer,private :: sreed,srite,center,node,inode,i1,i2,i3
  integer, allocatable,private  ::  b1(:), b2(:), b3(:)
  integer, allocatable,private  ::  e1(:), e2(:), e3(:)
  integer, allocatable,private  :: sz1(:),sz2(:),sz3(:)
  real,allocatable,private  :: input(:,:),output(:,:)
contains  
! get parameters
	subroutine median_init (n1_in,n2_in,n3_in,wind1_in,wind2_in,wind3_in,node_in)
                integer         :: n1_in,n2_in,n3_in,wind1_in,wind2_in,wind3_in,node_in
                n1=n1_in; wind1=wind1_in
                n2=n2_in; wind2=wind2_in
                n3=n3_in; wind3=wind3_in
                node=node_in
     	                allocate(b1(node),b2(node),b3(node),e1(node),e2(node),e3(node),sz1(node),sz2(node),sz3(node))
	end subroutine

	function median_lop ( adj, add, xx, yy) result(stat)
		integer            :: stat
		logical,intent(in) :: adj,add
		real,dimension(:)  :: xx,yy
			call median_lop3(adj,add,xx,yy ); stat=0
	end function
	
	subroutine median_lop2(adj,add,in,out)
        	real,dimension(n1,n2)     ::in,out
        	logical                   :: add,adj
                integer, external         :: omp_get_thread_num 

                        call omp_set_num_threads(node)
                        !$OMP parallel private(i1,i2,center,inode)
                       inode=omp_get_thread_num()+1;
                        !$OMP do schedule (static)
                        do i2=1,n2
                                b2(inode)=max(1 ,i2-wind2)
                                e2(inode)=min(n2,i2+wind2)
                                sz2(inode)=e2(inode)-b2(inode)+1
                                do i1=1,n1
                                        b1(inode)=max(1 ,i1-wind1)
                                        e1(inode)=min(n1,i1+wind1)
                                        sz1(inode)=e1(inode)-b1(inode)+1
                                        out(i1,i2)=quantile1(ceiling(.5*sz1(inode)*sz2(inode)), reshape(in(b1(inode):e1(inode),b2(inode):e2(inode)),(/sz1(inode)*sz2(inode)/)))
                                end do
                        end do
                        !$OMP end do
                        !$OMP end parallel
        end subroutine


	subroutine median_lop3(adj,add,in,out)
        	real,dimension(n1,n2,n3)  :: in,out
        	real                      :: temp_v((2*wind1+1)*(2*wind2+1)*(2*wind3+1))
        	logical                   :: add,adj
                integer, external         :: omp_get_thread_num

                        call omp_set_num_threads(node)
                        !$OMP parallel private(i1,i2,i3,center,inode)
                       inode=omp_get_thread_num()+1;
                        !$OMP do schedule (static)
                        do i3=1,n3
                                b3(inode)=max( 1,i3-wind3)
                                e3(inode)=min(n3,i3+wind3)
                                sz3(inode)=e3(inode)-b3(inode)+1
                                do i2=1,n2 
                                        b2(inode)=max(1 ,i2-wind2)
                                        e2(inode)=min(n2,i2+wind2)
                                        sz2(inode)=e2(inode)-b2(inode)+1
                                        do i1=1,n1
                                                b1(inode)=max(1 ,i1-wind1)
                                                e1(inode)=min(n1,i1+wind1)
                                                sz1(inode)=e1(inode)-b1(inode)+1
                                                out(i1,i2,i3)=quantile1(ceiling(.5*sz1(inode)*sz2(inode)*sz3(inode)), reshape(in(b1(inode):e1(inode),b2(inode):e2(inode),b3(inode):e3(inode)),(/sz1(inode)*sz2(inode)*sz3(inode)/)))
                                        !write(0,'(20(I6,2X))')i1,i2,i3,b1,b2,b3,e1,e2,e3,sz1,sz2,sz3,wind1,wind2,wind3,sum(in(b1(inode):e1(inode),b2(inode):e2(inode),b3(inode):e3(inode))),out(i1,i2,i3)
                                        end do
                                end do
                        end do 
                        !$OMP end do
                        !$OMP end parallel
        end subroutine


	subroutine median_clos()
                deallocate(b1,b2,b3,e1,e2,e3,sz1,sz2,sz3)
	end subroutine
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
        
end module
