module nhelicon_mod  
	use adj_mod
	use nhelix_mod
	implicit none
	type( nfilter), private :: aa 
	type(vnfilter), private :: vv
	contains
	subroutine nhelicon_init (aa_in)
		type( nfilter)    :: aa_in 
		aa = aa_in
	end subroutine
	function nhelicon_lop ( adj, add, xx, yy) result(stat)
		integer            :: stat 
		logical,intent(in) :: adj,add 
		real,dimension(:)  :: xx,yy 
			call adjnull (adj,add,xx,yy ); call nhelicon_lop2(adj,add,xx,yy ); stat=0
	end function 
	subroutine nhelicon_lop2(adj,add,xx,yy)
		logical,intent(in) :: adj,add 
		real, dimension (:)  :: xx 
		real, dimension (:)  :: yy 
		integer                         :: iy, ix, ia, ip
		integer, dimension( :), pointer :: lag
		real,    dimension( :), pointer :: flt
			if ( adj) then ! zero lag
				xx =	xx + yy
			else
 				yy =	yy + xx
			end if 
			do iy = 1, size( yy)
				if ( associated( aa%mis)) then; if ( aa%mis( iy)) cycle; endif
  				ip = aa%pch( iy)
				lag => aa%hlx( ip)%lag
				flt => aa%hlx( ip)%flt
				do ia = 1, size( lag)
					ix = iy - lag( ia)
					if ( ix < 1) cycle
					if ( adj) then
						xx(ix) = xx(ix) + yy(iy) * flt( ia)
					else
						yy(iy) = yy(iy) + xx(ix) * flt( ia)
					end if
				end do
			end do
	end subroutine 
	subroutine nhelicon_close()
	end subroutine 

!Variable non-stationary helical convolution
!Gboyega Ayeni
!04/01/2009
	subroutine vnhelicon_init (vv_in)
		type( vnfilter)    :: vv_in 
		vv = vv_in
	end subroutine
	function vnhelicon_lop ( adj, add, xx, yy) result(stat)
		integer            :: stat 
		logical,intent(in) :: adj,add 
		real,dimension(:)  :: xx,yy 
			call adjnull (adj,add,xx,yy ); call vnhelicon_lop2(adj,add,xx,yy ); stat=0
	end function 
	subroutine vnhelicon_lop2(adj,add,xx,yy)
		logical,intent(in) :: adj,add 
		real, dimension (:)  :: xx 
		real, dimension (:)  :: yy 
		integer                         :: iy, ix, ia, ip, iv
		integer, dimension( :), pointer :: lag
		real,    dimension( :), pointer :: flt
			if ( adj) then ! zero lag
				xx =	xx + yy
			else
 				yy =	yy + xx
			end if 
			do iy = 1, size( yy)
  				iv = vv%var(iy)
				if(associated(vv%nhlx(iv)%mis)) then; if ( vv%nhlx(iv)%mis( iy)) cycle; endif
  				ip = vv%nhlx(iv)%pch(iy)
				lag => vv%nhlx(iv)%hlx(ip)%lag
				flt => vv%nhlx(iv)%hlx(ip)%flt
				do ia = 1, size( lag)
					ix = iy - lag( ia)
					if ( ix < 1) cycle
					if ( adj) then
						xx(ix) = xx(ix) + yy(iy) * flt( ia)
					else
						yy(iy) = yy(iy) + xx(ix) * flt( ia)
					end if
				end do
			end do
	end subroutine 
end module 
