module param_mod
  use global_params_mod
  implicit none
contains
!  #============================  
  subroutine data_param()
        data_  = "data" ;    ref_ = "ref"; 

        call from_param("ngx", dgrid%agx%n, vgrid%ax%n-pgrid%nxpad_beg-pgrid%nxpad_end);call from_param("dgx", dgrid%agx%d, vgrid%ax%d);call from_param("ogx", dgrid%agx%o, vgrid%ax%o+(pgrid%nxpad_beg)*vgrid%ax%d)
        call from_param("ngy", dgrid%agy%n, vgrid%ay%n-pgrid%nypad_beg-pgrid%nypad_end);call from_param("dgy", dgrid%agy%d, vgrid%ay%d);call from_param("ogy", dgrid%agy%o, vgrid%ay%o+(pgrid%nypad_beg)*vgrid%ay%d)

        call from_param("nsx", dgrid%asx%n,                                          1);call from_param("dsx", dgrid%asx%d,dgrid%agx%d);call from_param("osx", dgrid%asx%o,  vgrid%ax%o+(vgrid%ax%n-1)/2*vgrid%ax%d)  
        call from_param("nsy", dgrid%asy%n,                                          1);call from_param("dsy", dgrid%asy%d,dgrid%agy%d);call from_param("osy", dgrid%asy%o,  vgrid%ay%o+(vgrid%ay%n-1)/2*vgrid%ay%d)

        call from_param("ldata"       , ldata        , .false.); 
        call from_param("lfreq"       , lfreq        ,  .true.);
        call from_param("no_green"    , no_green     , .true. );if(.not. ldata) no_green=.false.
        call from_param("data_min_z"  , data_min_z   ,  min_z ); 
        call from_param("data_max_z"  , data_max_z   ,  max_z );
  end subroutine 
!  #============================  
  subroutine green_param()
        logical :: center_sou
    !files
    greens_  = "greens" ; wavelet_="wavelet";  vel_= "vel"; wfld_d_  = "wfld_d" ;  report_ = "report" ; 
    vel_ref_ = "vel_ref"; 


    !pgrid paddings
    call from_param("nxpad_beg", pgrid%nxpad_beg, 0); call from_param("nxpad_end", pgrid%nxpad_end, 0); nxpad=(pgrid%nxpad_beg+pgrid%nxpad_end)/2.
    call from_param("nypad_beg", pgrid%nypad_beg, 0); call from_param("nypad_end", pgrid%nypad_end, 0); nypad=(pgrid%nypad_beg+pgrid%nypad_end)/2.


    !ggrid surf. params    
    call from_param("nx_surf", ggrid%ax_surf%n,-99999); call from_param("dx_surf", ggrid%ax_surf%d, -99999.); call from_param("ox_surf", ggrid%ax_surf%o, -99999.)
    call from_param("ny_surf", ggrid%ay_surf%n,-99999); call from_param("dy_surf", ggrid%ay_surf%d, -99999.); call from_param("oy_surf", ggrid%ay_surf%o, -99999.)
    call from_param("center_sou", center_sou,F)
    !ggrid modl. params    
    call from_param("nx_modl", ggrid%ax_modl%n,-99999); call from_param("dx_modl", ggrid%ax_modl%d, 1.); call from_param("ox_modl", ggrid%ax_modl%o, 0.)
    call from_param("ny_modl", ggrid%ay_modl%n,-99999); call from_param("dy_modl", ggrid%ay_modl%d, 1.); call from_param("oy_modl", ggrid%ay_modl%o, 0.)
    call from_param("nz_modl", ggrid%az_modl%n,-99999); call from_param("dz_modl", ggrid%az_modl%d, 1.); call from_param("oz_modl", ggrid%az_modl%o, 0.)

    if(exist_file(wavelet_))then
            dgrid%asx=wgrid%asx
            dgrid%asy=wgrid%asy
    endif

    !!....index of 1st and last point of greens grid in velocity grid
    ggrid%index_mod_minx   = 1.5 + (ggrid%ax_modl%o-vgrid%ax%o)/vgrid%ax%d; ggrid%index_mod_maxx=1.5 + (ggrid%ax_modl%o+(ggrid%ax_modl%n-1)*ggrid%ax_modl%d - vgrid%ax%o)/vgrid%ax%d
    ggrid%index_mod_miny   = 1.5 + (ggrid%ay_modl%o-vgrid%ay%o)/vgrid%ay%d; ggrid%index_mod_maxy=1.5 + (ggrid%ay_modl%o+(ggrid%ay_modl%n-1)*ggrid%ay_modl%d - vgrid%ay%o)/vgrid%ay%d

    call from_param("wfld_out_jt ", wfld_out_jt  , 10     )
    call from_param("wfld_out_pad", wfld_out_pad , 0      )
    call from_param("sign"        , sign         , +1     )
    call from_param("marine"      , marine       , .false.)
    call from_param("radian"      , radian       , .false.)
    call from_param("spike"       , spike        , .false.)
    call from_param("spike_data"  , spike_data   , .false.)
    call from_param("vnum"        , vnum         , 2      )
    call from_param("jw"          , jw           , 2      )
    call from_param("lloyd"       , lloyd        , .false.)
    call from_param("taper"       , taper        , .true. )
    call from_param("taper_pct"   , taper_pct    , 0.1    )
    call from_param("taper_type"  , taper_type   , 2      )
    call from_param("wfld_d_out"  , wfld_d_out   , .false.)
    call from_param("max_ang"     , max_ang      , 89.9   )
    call from_param("max_z"       , max_z        , -99999.)
    call from_param("min_z"       , min_z        , -99999.)
    call from_param("loop"        , loop         , 'w'    )
    call from_param("true"        , true         , .false.)
    call from_param("plane"       , plane        , .false.)
    call from_param("verb"        , verb         , 1      )
    call from_param("allfreq"     , allfreq      , .false.)

    !! up or down propagate
    call from_param("up          ", up           , F     ); 
    call from_param("down        ", down         , T     ); if (up) down=F

    !! encode stuff
    call from_param("code_it"     , code_it      ,   F    )
    call from_param("encode"      , encode       ,   F    )
    call from_param("random_constant", random_constant, F ); if (.not. encode)random_constant=F
    call from_param("random_phase", random_phase ,   F    ); if (.not. encode)random_phase=F
    call from_param("linear_phase", linear_phase ,   F    ); if (.not. encode)linear_phase=F
    call from_param("tmin"        , rand_tmin    , -0.5   )
    call from_param("tmax"        , rand_tmax    ,  0.5   ); rand_tlim=rand_tmax-rand_tmin

    !!ffd or phaseshift
    call from_param("ffd"         , ffd          ,  F     ); 
    call from_param("psp"         , psp          ,  T     ); if (ffd) psp=F
    call from_param("lloyd"       , lloyd        , .false.); if (lloyd) ffd=F
    call from_param("interp"      , interp       , .false.);

    if (exist_file(report_))then;  open(unit=10, file=report_, status='unknown'); endif
    if(lloyd) then;  
            if (exist_file(vel_ref_)) then
                    call from_aux(vel_ref_,"n1",vnum);
            else
                    call seperr('Please provide file for reference velocities or choose lloyd=n')
            endif
    endif
    write(0,'(A65)')'========================Params summary============================'
    write(0,*)'ffd',ffd
    write(0,*)'Lloyd',lloyd
    write(0,*)'interp',interp
    write(0,'(A65)')'========================Summary nodes============================='
    call from_param("nodes"       , nodes        ,  1     );    
    nnode =omp_get_num_procs(); nodes=min(nnode-1,nodes) 
    call omp_set_num_threads(nodes); write(*,*) 'using', nodes, 'or less of' , nnode
    write(0,'(A65)')'End nodes========================================================='

  end subroutine
!==========================================================================================
  subroutine mig_param()
    sou_     = "sou"    ; data_    = "dat"    ;  vel_     = "vel"    ; img_    = "img"     ; mig_    = "mig"    ;  
    wfld_d_  = "wfld_d" ; wfld_u_  = "wfld_u" ;  hessian_ = "hessian"; datumn_  = "datumn" ; report_ = "report" ;
    vel_ref_ = "vel_ref"; 

    call from_param("report"      , report_      , 'report')
    call from_param("wfld_marine" , marine       , .false.)
    call from_param("only_green"  , only_green   , .false.)
    call from_param("marine"      , marine       , .false.)
    call from_param("wfld_out_jt" , wfld_out_jt  , 10     )
    call from_param("sign"        , sign         , +1     )
    call from_param("radian"      , radian       , .false.)
    call from_param("spike"       , spike        , .false.)
    call from_param("vnum"        , vnum         , 2      )
    call from_param("lloyd"       , lloyd        , .false.)
    call from_param("taper"       , taper        , .true. )
    call from_param("taper_pct"   , taper_pct    , 0.1    )
    call from_param("taper_type"  , taper_type   , 2      )
    call from_param("wfld_d_out"  , wfld_d_out   , .false.)
    call from_param("wfld_u_out"  , wfld_u_out   , .false.)
    call from_param("green"       , lgreen       , .false.)
    call from_param("for"         , for          , .true. ) 
    call from_param("ricker"      , lricker      , .false.) 
    call from_param("freq"        , lfreq        , .true. )
    call from_param("nostack_w"   , nostack_w    , .false.)
    call from_param("nostack_s"   , nostack_s    , .false.)
    call from_param("max_ang"     , max_ang      ,   89.9)
    call from_param("max_z"       , max_z        , -99999.)
    call from_param("min_z"       , min_z        , -99999.)
    call from_param("max_x"       , max_x        , -99999.)
    call from_param("min_x"       , min_x        , -99999.)
    call from_param("max_y"       , max_y        , -99999.)
    call from_param("min_y"       , min_y        , -99999.)
    call from_param("max_hx"      , max_hx       , -99999.)
    call from_param("min_hx"      , min_hx       , -99999.)
    call from_param("max_hy"      , max_hy       , -99999.)
    call from_param("min_hy"      , min_hy       , -99999.)
    call from_param("mendx"       , mig_end_x    ,       0)
    call from_param("mendy"       , mig_end_y    ,       0)
    call from_param("mbegx"       , mig_beg_x    ,       0)
    call from_param("mbegy"       , mig_beg_y    ,       0)
    call from_param("wfld_d_sx"   , wfld_d_sx    ,      0.)
    call from_param("wfld_d_sy"   , wfld_d_sy    ,      0.)
    call from_param("wfld_u_sx"   , wfld_u_sx    ,      0.)
    call from_param("wfld_u_sy"   , wfld_u_sy    ,      0.)
    call from_param("loop"        , loop         , 'w'    )
    call from_param("verb"        , verb         , 1      )
    call from_param("phase"       , phase        , .true. )

    !! up or down propagate
    call from_param("up          ", up           , F     ); 
    call from_param("down        ", down         , T     ); if (up) down=F

    !! encode stuff
    call from_param("encode"      , encode       ,   F    )
    call from_param("random_constant", random_constant, F ); if (.not. encode)random_constant=F
    call from_param("random_phase", random_phase ,   F    ); if (.not. encode)random_phase=F
    call from_param("linear_phase", linear_phase ,   F    ); if (.not. encode)linear_phase=F
    call from_param("tmin"        , rand_tmin    , -0.5   )
    call from_param("tmax"        , rand_tmax    ,  0.5   ); rand_tlim=rand_tmax-rand_tmin

    !!ffd or phaseshift
    call from_param("ffd"         , ffd          ,  F     ); 
    call from_param("psp"         , psp          ,  T     ); if (ffd) psp=F

    !pgrid paddings
    call from_param("nxpad_beg", pgrid%nxpad_beg, 0); call from_param("nxpad_end", pgrid%nxpad_end, 0); nxpad=(pgrid%nxpad_beg+pgrid%nxpad_end)/2.
    call from_param("nypad_beg", pgrid%nypad_beg, 0); call from_param("nypad_end", pgrid%nypad_end, 0); nypad=(pgrid%nypad_beg+pgrid%nypad_end)/2.


    if (    exist_file(report_))then;  open(unit=10, file=report_, status='unknown'); endif
    if(lloyd) then; 
            if (exist_file(vel_ref_)) then
                    call from_aux(vel_ref_,"n1",vnum);
            else
                    call seperr('Please provide file for refernce velocities or choose lloyd=n')
            endif
    endif
    call from_param("hole"        , hole         , F      )
    call from_param("hole_sx1"    , hole_sx1     ,-999999.)
    call from_param("hole_sy1"    , hole_sy1     ,-999999.)
    call from_param("hole_gx1"    , hole_gx1     ,-999999.)
    call from_param("hole_gy1"    , hole_gy1     ,-999999.)
    call from_param("hole_sx2"    , hole_sx2     ,-999999.)
    call from_param("hole_sy2"    , hole_sy2     ,-999999.)
    call from_param("hole_gx2"    , hole_gx2     ,-999999.)
    call from_param("hole_gy2"    , hole_gy2     ,-999999.)
    write(0,'(A65)')'========================Summary nodes============================='
    call from_param("nodes"       , nodes        ,  1     );    
    nnode =omp_get_num_procs(); nodes=min(nnode-1,nodes) 
    call omp_set_num_threads(nodes); write(*,*) 'using', nodes, 'or less of' , nnode
    write(0,'(A65)')'End nodes========================================================='
  end subroutine

!  #============================  

  end module

