module reflect_mod
        use type_mod, only: vel_grid
        use sep
        implicit none
        contains
!======================================================================
        subroutine reflec(vel, ref, ref_, vgrid, den)
		optional	:: den
        real, dimension(:,:,:)		    :: ref, vel, den
        type(vel_grid)                  :: vgrid
        integer                         :: iz, ix, iy
		character(len=*)				:: ref_
		
			if (present(den))vel=vel*den
	
			do iz=2,vgrid%az%n
					do ix=2,vgrid%ax%n
							do iy=1,vgrid%ay%n
									ref(iz,ix,iy)=(vel(iz,ix,iy)-vel(iz-1,ix,iy))/(vel(iz,ix,iy)+vel(iz-1,ix,iy));
									if (ref(iz,ix,iy)==0.0 .and. ix/=vgrid%ax%n )then
											ref(iz,ix,iy)=(vel(iz,ix+1,iy)-vel(iz,ix,iy))/(vel(iz,ix+1,iy)+vel(iz,ix,iy));
									end if
							end do
					end do
			end do
			ref(1,:,:)=ref(2,:,:);
			write(*,*)'writing reflectivity model.....'
			call auxinout(ref_)
			call auxputch("n1", "i", vgrid%az%n , ref_); call auxputch("n2", "i", vgrid%ax%n, ref_); call auxputch("n3", "i", vgrid%ay%n , ref_); 
			call auxputch("d1", "r", vgrid%az%d , ref_); call auxputch("d2", "r", vgrid%ax%d, ref_); call auxputch("d3", "r", vgrid%ay%d , ref_); 
			call auxputch("o1", "r", vgrid%az%o , ref_); call auxputch("o2", "r", vgrid%ax%o, ref_); call auxputch("o3", "r", vgrid%ay%o , ref_); 
			call auxputch("label1", "s", "az" , ref_);    call auxputch("label2", "s", "ax" , ref_);   call auxputch("label3", "s", "ay" , ref_)
			call auxputch("esize" , "i",  4  , ref_)
			call srite(ref_, ref,  4*vgrid%az%n*vgrid%ax%n*vgrid%ay%n)

        return 
        end subroutine

end module
