module ricker_mod
        use sep
        use myfft_mod
        use ctaper_mod
        implicit none
        contains
 !===========================================================================
subroutine ricker(sou_,taxis,freq,nsw,flip) 
  integer                               :: nt, nsw, i, j, k
  real                                  :: timesh, pi, pi2, b, freq, const,tim1,tim2,amp,sm,fac, u 
  complex, dimension(:),pointer         :: s, fs,s2,fs2,tmp
  real,    dimension(:),pointer         :: wall     
  logical                               :: flip   
  character(len=256)                    :: sou_, tsou_="twavelet"
  integer                               :: iw,nw
  real                                  :: dw, ow, dt, ot
  type(axis)                            :: taxis

        nt=taxis%n; dt=taxis%d; ot=taxis%o
        pi=  3.14159265359
        timesh=nt*dt/2;
        pi2=(pi**.5)/2;
        b=(6**.5)/(pi*freq);
        const=2*(6**.5)/b;
        allocate(s(nt),s2(nt),tmp(nt));
        do i=1,nt
                tim1=(i-1)*dt;
                tim2=tim1-timesh;
                u=const*tim2;
                amp=(((u**2)/4)-(0.5))*pi2*(exp(-u**2/4));
                s(i)=amp;
        end do
        sm=maxval(abs(s));
        s=s/sm;

        if (nsw>0)then
                do i=1,nsw
                        j=nsw-i;
                        fac=0.5*(cos((pi*j)/nsw) +1);
                        s(i)=s(i)*fac;
                end do
                do i=1,nsw
                        j=i-1;
                        fac=0.5*(cos((pi*j)/nsw) +1);
                        k=nt-nsw+i;
                        s(k)=s(k)*fac;
                end do
         end if
        
        tmp=0
        if(ceiling(nt/2.)-1==nt-ceiling(nt/2.))then;    tmp(1:ceiling(nt/2.)   )=       s(ceiling(nt/2.)-5:nt-5);
        else;                                           tmp(1:ceiling(nt/2.)+1.)=       s(ceiling(nt/2.)-5:nt-5);
        endif
        s2=s;  s=tmp; if(flip)s=-s; if(flip)s2=-s2; 

        write(*,*)'writing source wavelet..............'
        call auxinout(tsou_); 
        call auxputch("n1    ","i", nt,tsou_);call auxputch("d1   ","r",dt,tsou_); call auxputch("o1", "r", ot , tsou_); 
        call auxputch("label1","s","t",tsou_);call auxputch("esize","i", 4,tsou_); call srite(tsou_, real(s2) , 4*nt)

        call FFT1DT(s,   1); nw = floor(nt/2.); dw = 1./(taxis%n*taxis%d);  ow=0.;
        call FFT1DT(s2,  1); nw = floor(nt/2.); dw = 1./(taxis%n*taxis%d);  ow=0.;
        if(associated(fs )) deallocate(fs ); allocate(fs(nw)); fs=s(1:nw);  
        if(associated(fs2)) deallocate(fs2); allocate(fs2(nw)); fs2=s2(1:nw)

        if (associated(wall)) deallocate(wall); allocate(wall(nw)); 
        do iw = 1, nw; wall(iw) = ow  + (iw - 1) * dw; enddo; !compute freq axis
        wall = 2*pi * wall; !freq axis in radians
        fs2(:)=fs2(:)*exp(cmplx(0.,wall(:)*nw*dt));

        call ctaper1d(fs,  fs, dw, nw, 0, 2);
        call ctaper1d(fs2, fs2, dw, nw, 0, 2);

        call auxinout(sou_)
        call auxputch("n1", "i", 1 ,sou_ ); call auxputch("d1", "r", 1   ,sou_ ); call auxputch("o1", "r", 0  , sou_); 
        call auxputch("n2", "i", 1 ,sou_ ); call auxputch("d2", "r", 1   ,sou_ ); call auxputch("o2", "r", 0  , sou_); 
        call auxputch("n3", "i", nw,sou_ ); call auxputch("d3", "r", dw  ,sou_ ); call auxputch("o3", "r", ow , sou_); 
        call auxputch("label1", "s", " " , sou_); call auxputch("label2", "s", " " , sou_); call auxputch("label3", "s", "w" , sou_)
        call auxputch("esize" , "i",  8  , sou_)
        call srite(sou_, fs2, 8*nw)

deallocate(tmp,fs,fs2)
end subroutine
end module
