module taper_mod
use sep, only: seperr
implicit none 
contains
!===========================================

subroutine taper(taped,modl,dx,nx,nxpad,pc,opt)
integer                         ::nx, ntap, nxpad, ix, opt
real                            ::m, dx, pc
real, dimension(:,:),pointer    ::taped, modl
real, dimension(:),allocatable  ::tmp,coeff,cc
real                            :: pi
real                            :: dc, oc
integer                         :: ic,nc
        pi=3.1415937 ;

m=1/(dx*ceiling(nx*pc));
taped=modl;

if (opt==1) then
    do ix=1,ceiling(nx*pc)
        taped(:,nxpad+ix+1)=modl(:,nxpad+ix+1)*m*(ix*dx);
        taped(:,nxpad+nx-ix)=modl(:,nx-ix-nxpad)*m*(ix*dx);
    enddo
    taped(:,1)=0.001*taped(:,2); taped(:,nx)=0.001*taped(:,nx-1);
elseif (opt==2)then
    ntap=ceiling(nx*pc);       
    allocate(coeff(2*ntap)); allocate(cc(ntap))
    dc=pi/(2*ntap);oc=0.;nc=2*ntap
    do ic=1,nc
        coeff(ic)=abs(cos(oc+(ic-2)*dc));
    enddo
    cc=coeff(ntap+1:2*ntap);
    do ix=1,ceiling(nx*pc)
        taped(:,nxpad+ix)=modl(:,nxpad+ix)*cc(ix);
        taped(:,nxpad+nx-ix+1)=modl(:,nxpad+nx-ix+1)*cc(ix);
    enddo
    taped(:,1:nxpad)=0;
    taped(:,nxpad+nx:2*nxpad+nx)=0;
else 
    call seperr('wrong taper param. triang=1 hanning=2.')
endif
end subroutine
end module
