module vel_mod
implicit none

contains
!============================================
subroutine velocity( vref, vmod, ind_vref, nref, vnum)
real    , dimension(:)      , allocatable       :: vref, vvref, tvref
real    , dimension(:,:)    , allocatable       :: vmod
integer , dimension(:,:)    , allocatable       :: ind_vref
integer                                         :: vnum, nref , nnref 
real                                            :: vmax,vmin,dvel
integer                                         :: length_x,length_y
integer                                         :: ix, iy, iv, iiv, iref

vmax=maxval(vmod); vmin=minval(vmod); dvel=(vmax-vmin)/(vnum - 1);
length_x=size(vmod,1);
length_y=size(vmod,2);

if (allocated(vref)) deallocate(vref); allocate(vref(vnum))
if (vmax>=3900) then; nnref=vnum-1;else; nnref=vnum; endif

do ix=1,length_x
        do iy=1,length_y
            ind_vref(ix,iy) = max(1, int(1+ (vmod(ix,iy)-vmin)/dvel));
            ind_vref(ix,iy) = min(ind_vref(ix,iy), vnum);
        enddo
enddo

vref=0.0;
if(vnum==1)then
    vref(1)=sum(vmod)/(length_x+length_y); return
else
    dvel=(vmax-vmin)/(vnum-1);
    do iref=1,vnum
        vref(iref)=vmin+(iref-1)*dvel;
    enddo
endif

allocate(vvref(1)) 
vvref(1)=vref(1); iv=1;

do iiv=2,vnum
        if (vref(iiv)/=vref(iiv-1))then;
             if (allocated(tvref)) deallocate(tvref); allocate(tvref(iv))
                tvref=vvref
                if (allocated(vvref)) deallocate(vvref); allocate(vvref(iv+1))
                vvref(1:iv)=tvref; 
                vvref(iv+1)=vref(iiv); 
                iv=iv+1; 
        else; endif
enddo
nref=iv; 
if (allocated(vref)) deallocate(vref); allocate(vref(nref)) 
vref=vvref;
!write(*,*)'------>>',nref,vref

if (allocated(tvref)) deallocate(tvref) 
if (allocated(vvref)) deallocate(vvref) 
end subroutine
end module
